//
//  Copyright (c) 2003 Launchbird Design Systems, Inc.
//  All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
//  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
//  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  
//  
//  Overview:
//  
//    Performs floating point multiply.
//  
//  Interface:
//  
//  
//  
//    Inputs:
//      a_i : Left operand.
//      b_i : Right operand.
//  
//    Outputs:
//      x_o : Result.
//  
//  Built In Parameters:
//  
//    Exponent Precision = 3
//    Mantissa Precision = 4
//    Total    Precision = 8
//  
//  
//  
//  
//  
//  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
//  
//  Build Date : Fri Aug 22 09:46:58 CDT 2003
//  
//  Interface
//  
//    Build Name    : cf_fp_mul_c_3_4
//    Clock Domains : 
//    Vector Input  : a_i(8)
//    Vector Input  : b_i(8)
//    Vector Output : x_o(8)
//  
//  
//  

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cf_fp_mul_c_3_4.h"

static unsigned char n295[1];
static unsigned char n293[1];
static unsigned char n291[1];
static unsigned char n289[1];
static unsigned char n260[1];
static unsigned char n258[1];
static unsigned char n256[1];
static unsigned char n254[1];
static unsigned char n252[1];
static unsigned char n250[1];
static unsigned char n248[1];
static unsigned char n246[1];
static unsigned char n244[1];
static unsigned char n242[1];
static unsigned char n240[1];
static unsigned char n238[1];
static unsigned char n236[1];
static unsigned char n234[1];
static unsigned char n232[1];
static unsigned char n231[1];
static unsigned char n230[1];
static unsigned char n229[1];
static unsigned char n228[1];
static unsigned char n227[1];
static unsigned char n214[1];
static unsigned char n205[1];
static unsigned char n184[1];
static unsigned char n163[1];
static unsigned char n142[1];
static unsigned char n121[1];
static unsigned char n108[1];
static unsigned char n106[1];
static unsigned char *b_i;
static unsigned char *a_i;
static unsigned char n56[1];
static unsigned char n55[1];
static unsigned char n13[1];
static unsigned char n12[1];
static unsigned char n10[1];
static unsigned char n9[1];
static unsigned char n8[1];
static unsigned char n7[1];
static unsigned char n6[1];
static unsigned char n5[1];
static unsigned char n109[1];
static unsigned char n107[1];
static unsigned char n105[1];
static unsigned char n88[1];
static unsigned char n86[1];
static unsigned char n75[1];
static unsigned char n74[1];
static unsigned char n66[1];
static unsigned char n65[1];
static unsigned char n58[1];
static unsigned char n57[1];
static unsigned char n45[1];
static unsigned char n43[1];
static unsigned char n32[1];
static unsigned char n31[1];
static unsigned char n23[1];
static unsigned char n22[1];
static unsigned char n15[1];
static unsigned char n14[1];
static unsigned char n110[1];
static unsigned char n89[1];
static unsigned char n77[1];
static unsigned char n76[1];
static unsigned char n68[1];
static unsigned char n67[1];
static unsigned char n60[1];
static unsigned char n59[1];
static unsigned char n46[1];
static unsigned char n34[1];
static unsigned char n33[1];
static unsigned char n25[1];
static unsigned char n24[1];
static unsigned char n17[1];
static unsigned char n16[1];
static unsigned char n114[1];
static unsigned char n82[1];
static unsigned char n79[1];
static unsigned char n78[1];
static unsigned char n71[1];
static unsigned char n69[1];
static unsigned char n63[1];
static unsigned char n61[1];
static unsigned char n39[1];
static unsigned char n36[1];
static unsigned char n35[1];
static unsigned char n28[1];
static unsigned char n26[1];
static unsigned char n20[1];
static unsigned char n18[1];
static unsigned char n122[1];
static unsigned char n80[1];
static unsigned char n72[1];
static unsigned char n64[1];
static unsigned char n37[1];
static unsigned char n29[1];
static unsigned char n21[1];
static unsigned char n90[1];
static unsigned char n87[1];
static unsigned char n83[1];
static unsigned char n73[1];
static unsigned char n47[1];
static unsigned char n44[1];
static unsigned char n40[1];
static unsigned char n30[1];
static unsigned char n84[1];
static unsigned char n41[1];
static unsigned char n85[1];
static unsigned char n42[1];
static unsigned char n95[1];
static unsigned char n94[1];
static unsigned char n93[1];
static unsigned char n91[1];
static unsigned char n52[1];
static unsigned char n51[1];
static unsigned char n50[1];
static unsigned char n48[1];
static unsigned char n104[1];
static unsigned char n103[1];
static unsigned char n101[1];
static unsigned char n100[1];
static unsigned char n96[1];
static unsigned char n92[1];
static unsigned char n53[1];
static unsigned char n49[1];
static unsigned char n224[1];
static unsigned char n117[1];
static unsigned char n115[1];
static unsigned char n102[1];
static unsigned char n98[1];
static unsigned char n97[1];
static unsigned char n225[1];
static unsigned char n118[1];
static unsigned char n116[1];
static unsigned char n99[1];
static unsigned char n226[1];
static unsigned char n119[2];
static unsigned char n261[1];
static unsigned char n259[1];
static unsigned char n257[1];
static unsigned char n255[1];
static unsigned char n253[1];
static unsigned char n251[1];
static unsigned char n249[1];
static unsigned char n247[1];
static unsigned char n245[1];
static unsigned char n243[1];
static unsigned char n241[1];
static unsigned char n239[1];
static unsigned char n237[1];
static unsigned char n235[1];
static unsigned char n233[1];
static unsigned char n125[2];
static unsigned char n124[2];
static unsigned char n120[1];
static unsigned char n262[1];
static unsigned char n126[2];
static unsigned char n123[1];
static unsigned char n263[1];
static unsigned char n146[1];
static unsigned char n145[1];
static unsigned char n143[1];
static unsigned char n129[1];
static unsigned char n128[1];
static unsigned char n127[1];
static unsigned char n264[1];
static unsigned char n131[1];
static unsigned char n130[1];
static unsigned char n265[1];
static unsigned char n136[1];
static unsigned char n133[1];
static unsigned char n132[1];
static unsigned char n266[1];
static unsigned char n134[1];
static unsigned char n267[1];
static unsigned char n137[1];
static unsigned char n268[1];
static unsigned char n138[1];
static unsigned char n269[1];
static unsigned char n139[1];
static unsigned char n270[1];
static unsigned char n140[1];
static unsigned char n271[1];
static unsigned char n141[1];
static unsigned char n272[1];
static unsigned char n147[1];
static unsigned char n144[1];
static unsigned char n273[1];
static unsigned char n167[1];
static unsigned char n166[1];
static unsigned char n164[1];
static unsigned char n150[1];
static unsigned char n149[1];
static unsigned char n148[1];
static unsigned char n274[1];
static unsigned char n152[1];
static unsigned char n151[1];
static unsigned char n275[1];
static unsigned char n157[1];
static unsigned char n154[1];
static unsigned char n153[1];
static unsigned char n276[1];
static unsigned char n155[1];
static unsigned char n278[1];
static unsigned char n277[1];
static unsigned char n158[1];
static unsigned char n282[1];
static unsigned char n281[1];
static unsigned char n280[1];
static unsigned char n159[1];
static unsigned char n285[1];
static unsigned char n160[1];
static unsigned char n161[1];
static unsigned char n162[1];
static unsigned char n168[1];
static unsigned char n165[1];
static unsigned char n188[1];
static unsigned char n187[1];
static unsigned char n185[1];
static unsigned char n171[1];
static unsigned char n170[1];
static unsigned char n169[1];
static unsigned char n173[1];
static unsigned char n172[1];
static unsigned char n178[1];
static unsigned char n175[1];
static unsigned char n174[1];
static unsigned char n176[1];
static unsigned char n179[1];
static unsigned char n180[1];
static unsigned char n181[1];
static unsigned char n182[1];
static unsigned char n183[1];
static unsigned char n189[1];
static unsigned char n186[1];
static unsigned char n209[1];
static unsigned char n208[1];
static unsigned char n206[1];
static unsigned char n192[1];
static unsigned char n191[1];
static unsigned char n190[1];
static unsigned char n194[1];
static unsigned char n193[1];
static unsigned char n199[1];
static unsigned char n196[1];
static unsigned char n195[1];
static unsigned char n197[1];
static unsigned char n200[1];
static unsigned char n201[1];
static unsigned char n202[1];
static unsigned char n203[1];
static unsigned char n204[1];
static unsigned char n210[1];
static unsigned char n207[1];
static unsigned char n212[1];
static unsigned char n211[1];
static unsigned char n213[1];
static unsigned char n279[1];
static unsigned char n283[1];
static unsigned char n286[1];
static unsigned char n287[1];
static unsigned char *x_o;

void cf_fp_mul_c_3_4_ports(unsigned char* port_a_i, unsigned char* port_b_i, unsigned char* port_x_o) {
  a_i = port_a_i;
  b_i = port_b_i;
  x_o = port_x_o;
}

void cf_fp_mul_c_3_4_calc() {
  n295[0] = 119;
  n293[0] = 127;
  n291[0] = 112;
  n289[0] = 3;
  n260[0] = 1;
  n258[0] = 3;
  n256[0] = 2;
  n254[0] = 7;
  n252[0] = 6;
  n250[0] = 5;
  n248[0] = 4;
  n246[0] = 15;
  n244[0] = 14;
  n242[0] = 13;
  n240[0] = 12;
  n238[0] = 11;
  n236[0] = 10;
  n234[0] = 9;
  n232[0] = 8;
  n231[0] = 4;
  n230[0] = 3;
  n229[0] = 2;
  n228[0] = 1;
  n227[0] = 0;
  n214[0] = 0;
  n205[0] = 1;
  n184[0] = 1;
  n163[0] = 1;
  n142[0] = 1;
  n121[0] = 1;
  n108[0] = 0;
  n106[0] = 0;
  n56[0] = (1 & (b_i[0])) | (2 & (b_i[0])) | (4 & (b_i[0])) | (8 & (b_i[0]));
  n55[0] = (1 & (b_i[0] >> 4)) | (2 & (b_i[0] >> 4)) | (4 & (b_i[0] >> 4));
  n13[0] = (1 & (a_i[0])) | (2 & (a_i[0])) | (4 & (a_i[0])) | (8 & (a_i[0]));
  n12[0] = (1 & (a_i[0] >> 4)) | (2 & (a_i[0] >> 4)) | (4 & (a_i[0] >> 4));
  n10[0] = (1 & (b_i[0])) | (2 & (b_i[0])) | (4 & (b_i[0])) | (8 & (b_i[0]));
  n9[0] = (1 & (b_i[0] >> 4)) | (2 & (b_i[0] >> 4)) | (4 & (b_i[0] >> 4));
  n8[0] = (1 & (b_i[0] >> 7));
  n7[0] = (1 & (a_i[0])) | (2 & (a_i[0])) | (4 & (a_i[0])) | (8 & (a_i[0]));
  n6[0] = (1 & (a_i[0] >> 4)) | (2 & (a_i[0] >> 4)) | (4 & (a_i[0] >> 4));
  n5[0] = (1 & (a_i[0] >> 7));
  n109[0] = 255 & (n108[0] << 3 | n9[0]);
  n107[0] = 255 & (n106[0] << 3 | n6[0]);
  n105[0] = n5[0] ^ n8[0];
  n88[0] = (1 & (n56[0] >> 3));
  n86[0] = (1 & (n56[0] >> 3));
  n75[0] = (1 & (n56[0])) | (2 & (n56[0])) | (4 & (n56[0]));
  n74[0] = (1 & (n56[0] >> 3));
  n66[0] = (1 & (n55[0])) | (2 & (n55[0]));
  n65[0] = (1 & (n55[0] >> 2));
  n58[0] = (1 & (n55[0])) | (2 & (n55[0]));
  n57[0] = (1 & (n55[0] >> 2));
  n45[0] = (1 & (n13[0] >> 3));
  n43[0] = (1 & (n13[0] >> 3));
  n32[0] = (1 & (n13[0])) | (2 & (n13[0])) | (4 & (n13[0]));
  n31[0] = (1 & (n13[0] >> 3));
  n23[0] = (1 & (n12[0])) | (2 & (n12[0]));
  n22[0] = (1 & (n12[0] >> 2));
  n15[0] = (1 & (n12[0])) | (2 & (n12[0]));
  n14[0] = (1 & (n12[0] >> 2));
  { unsigned int tmp; (tmp = (unsigned int) n107[0] + (unsigned int) n109[0], n110[0] = 15 & (unsigned char) tmp); }
  n89[0] = 1 & ~n88[0];
  n77[0] = (1 & (n75[0])) | (2 & (n75[0]));
  n76[0] = (1 & (n75[0] >> 2));
  n68[0] = (1 & (n66[0]));
  n67[0] = (1 & (n66[0] >> 1));
  n60[0] = (1 & (n58[0]));
  n59[0] = (1 & (n58[0] >> 1));
  n46[0] = 1 & ~n45[0];
  n34[0] = (1 & (n32[0])) | (2 & (n32[0]));
  n33[0] = (1 & (n32[0] >> 2));
  n25[0] = (1 & (n23[0]));
  n24[0] = (1 & (n23[0] >> 1));
  n17[0] = (1 & (n15[0]));
  n16[0] = (1 & (n15[0] >> 1));
  { unsigned int tmp; (tmp = (unsigned int) n110[0] - (unsigned int) n289[0], n114[0] = 15 & (unsigned char) tmp); }
  n82[0] = n74[0] | n76[0];
  n79[0] = (1 & (n77[0]));
  n78[0] = (1 & (n77[0] >> 1));
  n71[0] = n65[0] | n67[0];
  n69[0] = (1 & (n68[0]));
  n63[0] = n57[0] & n59[0];
  n61[0] = (1 & (n60[0]));
  n39[0] = n31[0] | n33[0];
  n36[0] = (1 & (n34[0]));
  n35[0] = (1 & (n34[0] >> 1));
  n28[0] = n22[0] | n24[0];
  n26[0] = (1 & (n25[0]));
  n20[0] = n14[0] & n16[0];
  n18[0] = (1 & (n17[0]));
  { unsigned int tmp; (tmp = (unsigned int) n114[0] + (unsigned int) n121[0], n122[0] = 15 & (unsigned char) tmp); }
  n80[0] = (1 & (n79[0]));
  n72[0] = n71[0] | n69[0];
  n64[0] = n63[0] & n61[0];
  n37[0] = (1 & (n36[0]));
  n29[0] = n28[0] | n26[0];
  n21[0] = n20[0] & n18[0];
  n90[0] = n64[0] & n89[0];
  n87[0] = n64[0] & n86[0];
  n83[0] = n78[0] | n80[0];
  n73[0] = 1 & ~n72[0];
  n47[0] = n21[0] & n46[0];
  n44[0] = n21[0] & n43[0];
  n40[0] = n35[0] | n37[0];
  n30[0] = 1 & ~n29[0];
  n84[0] = n82[0] | n83[0];
  n41[0] = n39[0] | n40[0];
  n85[0] = 1 & ~n84[0];
  n42[0] = 1 & ~n41[0];
  n95[0] = 1 & ~n85[0];
  n94[0] = n73[0] & n85[0];
  n93[0] = n64[0] & n85[0];
  n91[0] = 1 & ~n85[0];
  n52[0] = 1 & ~n42[0];
  n51[0] = n30[0] & n42[0];
  n50[0] = n21[0] & n42[0];
  n48[0] = 1 & ~n42[0];
  n104[0] = n51[0] | n94[0];
  n103[0] = n50[0] | n93[0];
  n101[0] = n51[0] & n93[0];
  n100[0] = n50[0] & n94[0];
  n96[0] = n73[0] & n95[0];
  n92[0] = n90[0] & n91[0];
  n53[0] = n30[0] & n52[0];
  n49[0] = n47[0] & n48[0];
  n224[0] = 255 & (n103[0] << 1 | n104[0]);
  n117[0] = 1 & ~n96[0];
  n115[0] = 1 & ~n53[0];
  n102[0] = n100[0] | n101[0];
  n98[0] = n92[0] | n87[0];
  n97[0] = n49[0] | n44[0];
  n225[0] = 255 & (n102[0] << 2 | n224[0]);
  n118[0] = 255 & (n117[0] << 4 | n10[0]);
  n116[0] = 255 & (n115[0] << 4 | n7[0]);
  n99[0] = n97[0] | n98[0];
  n226[0] = 255 & (n99[0] << 3 | n225[0]);
  {
    unsigned int tmp;
    unsigned char a[2];
    unsigned char b[2];
    a[1] = 0;
    a[0] = n116[0];
    b[1] = 0;
    b[0] = n118[0];
    (tmp = ((unsigned int) a[1] * (unsigned int) b[0]) + ((unsigned int) a[0] * (unsigned int) b[1]) + (tmp = ((unsigned int) a[0] * (unsigned int) b[0]), n119[0] = 255 & (unsigned char) tmp, tmp >> 8), n119[1] = 3 & (unsigned char) tmp);
  }
  n261[0] = n226[0] == n260[0] ? 1 : 0;
  n259[0] = n226[0] == n258[0] ? 1 : 0;
  n257[0] = n226[0] == n256[0] ? 1 : 0;
  n255[0] = n226[0] == n254[0] ? 1 : 0;
  n253[0] = n226[0] == n252[0] ? 1 : 0;
  n251[0] = n226[0] == n250[0] ? 1 : 0;
  n249[0] = n226[0] == n248[0] ? 1 : 0;
  n247[0] = n226[0] == n246[0] ? 1 : 0;
  n245[0] = n226[0] == n244[0] ? 1 : 0;
  n243[0] = n226[0] == n242[0] ? 1 : 0;
  n241[0] = n226[0] == n240[0] ? 1 : 0;
  n239[0] = n226[0] == n238[0] ? 1 : 0;
  n237[0] = n226[0] == n236[0] ? 1 : 0;
  n235[0] = n226[0] == n234[0] ? 1 : 0;
  n233[0] = n226[0] == n232[0] ? 1 : 0;
  n125[0] = (1 & (n119[0])) | (2 & (n119[0])) | (4 & (n119[0])) | (8 & (n119[0])) | (16 & (n119[0])) | (32 & (n119[0])) | (64 & (n119[0])) | (128 & (n119[0]));
  n125[1] = (1 & (n119[1]));
  n124[0] = (1 & (n119[0] >> 1)) | (2 & (n119[0] >> 1)) | (4 & (n119[0] >> 1)) | (8 & (n119[0] >> 1)) | (16 & (n119[0] >> 1)) | (32 & (n119[0] >> 1)) | (64 & (n119[0] >> 1)) | (128 & (n119[1] << 7));
  n124[1] = (1 & (n119[1] >> 1));
  n120[0] = (1 & (n119[1] >> 1));
  if (n261[0]) {
    n262[0] = n228[0];
  }
  else {
    n262[0] = n227[0];
  }
  if (n120[0]) {
    n126[0] = n124[0];
    n126[1] = n124[1];
  }
  else {
    n126[0] = n125[0];
    n126[1] = n125[1];
  }
  if (n120[0]) {
    n123[0] = n122[0];
  }
  else {
    n123[0] = n114[0];
  }
  if (n259[0]) {
    n263[0] = n229[0];
  }
  else {
    n263[0] = n262[0];
  }
  n146[0] = (1 & (n126[0] >> 1)) | (2 & (n126[0] >> 1)) | (4 & (n126[0] >> 1)) | (8 & (n126[0] >> 1)) | (16 & (n126[0] >> 1)) | (32 & (n126[0] >> 1)) | (64 & (n126[0] >> 1)) | (128 & (n126[1] << 7));
  n145[0] = (1 & (n126[0])) | (2 & (n126[0])) | (4 & (n126[0])) | (8 & (n126[0])) | (16 & (n126[0])) | (32 & (n126[0])) | (64 & (n126[0])) | (128 & (n126[0]));
  { unsigned int tmp; (tmp = (unsigned int) n123[0] - (unsigned int) n142[0], n143[0] = 15 & (unsigned char) tmp); }
  n129[0] = (1 & (n123[0])) | (2 & (n123[0])) | (4 & (n123[0]));
  n128[0] = (1 & (n123[0] >> 3));
  n127[0] = (1 & (n126[1]));
  if (n257[0]) {
    n264[0] = n229[0];
  }
  else {
    n264[0] = n263[0];
  }
  n131[0] = (1 & (n129[0])) | (2 & (n129[0]));
  n130[0] = (1 & (n129[0] >> 2));
  if (n255[0]) {
    n265[0] = n230[0];
  }
  else {
    n265[0] = n264[0];
  }
  n136[0] = n128[0] | n130[0];
  n133[0] = (1 & (n131[0]));
  n132[0] = (1 & (n131[0] >> 1));
  if (n253[0]) {
    n266[0] = n230[0];
  }
  else {
    n266[0] = n265[0];
  }
  n134[0] = (1 & (n133[0]));
  if (n251[0]) {
    n267[0] = n230[0];
  }
  else {
    n267[0] = n266[0];
  }
  n137[0] = n132[0] | n134[0];
  if (n249[0]) {
    n268[0] = n230[0];
  }
  else {
    n268[0] = n267[0];
  }
  n138[0] = n136[0] | n137[0];
  if (n247[0]) {
    n269[0] = n231[0];
  }
  else {
    n269[0] = n268[0];
  }
  n139[0] = 1 & ~n138[0];
  if (n245[0]) {
    n270[0] = n231[0];
  }
  else {
    n270[0] = n269[0];
  }
  n140[0] = n127[0] | n139[0];
  if (n243[0]) {
    n271[0] = n231[0];
  }
  else {
    n271[0] = n270[0];
  }
  n141[0] = 1 & ~n140[0];
  if (n241[0]) {
    n272[0] = n231[0];
  }
  else {
    n272[0] = n271[0];
  }
  if (n141[0]) {
    n147[0] = n145[0];
  }
  else {
    n147[0] = n146[0];
  }
  if (n141[0]) {
    n144[0] = n143[0];
  }
  else {
    n144[0] = n123[0];
  }
  if (n239[0]) {
    n273[0] = n231[0];
  }
  else {
    n273[0] = n272[0];
  }
  n167[0] = (1 & (n147[0] >> 1)) | (2 & (n147[0] >> 1)) | (4 & (n147[0] >> 1)) | (8 & (n147[0] >> 1)) | (16 & (n147[0] >> 1)) | (32 & (n147[0] >> 1)) | (64 & (n147[0] >> 1));
  n166[0] = (1 & (n147[0])) | (2 & (n147[0])) | (4 & (n147[0])) | (8 & (n147[0])) | (16 & (n147[0])) | (32 & (n147[0])) | (64 & (n147[0]));
  { unsigned int tmp; (tmp = (unsigned int) n144[0] - (unsigned int) n163[0], n164[0] = 15 & (unsigned char) tmp); }
  n150[0] = (1 & (n144[0])) | (2 & (n144[0])) | (4 & (n144[0]));
  n149[0] = (1 & (n144[0] >> 3));
  n148[0] = (1 & (n147[0] >> 7));
  if (n237[0]) {
    n274[0] = n231[0];
  }
  else {
    n274[0] = n273[0];
  }
  n152[0] = (1 & (n150[0])) | (2 & (n150[0]));
  n151[0] = (1 & (n150[0] >> 2));
  if (n235[0]) {
    n275[0] = n231[0];
  }
  else {
    n275[0] = n274[0];
  }
  n157[0] = n149[0] | n151[0];
  n154[0] = (1 & (n152[0]));
  n153[0] = (1 & (n152[0] >> 1));
  if (n233[0]) {
    n276[0] = n231[0];
  }
  else {
    n276[0] = n275[0];
  }
  n155[0] = (1 & (n154[0]));
  n278[0] = (1 & (n276[0]));
  n277[0] = (1 & (n276[0] >> 1)) | (2 & (n276[0] >> 1));
  n158[0] = n153[0] | n155[0];
  n282[0] = (1 & (n277[0]));
  n281[0] = (1 & (n277[0] >> 1));
  if (n278[0]) {
    n280[0] = n293[0];
  }
  else {
    n280[0] = n291[0];
  }
  n159[0] = n157[0] | n158[0];
  n285[0] = (1 & (n281[0]));
  n160[0] = 1 & ~n159[0];
  n161[0] = n148[0] | n160[0];
  n162[0] = 1 & ~n161[0];
  if (n162[0]) {
    n168[0] = n166[0];
  }
  else {
    n168[0] = n167[0];
  }
  if (n162[0]) {
    n165[0] = n164[0];
  }
  else {
    n165[0] = n144[0];
  }
  n188[0] = (1 & (n168[0] >> 1)) | (2 & (n168[0] >> 1)) | (4 & (n168[0] >> 1)) | (8 & (n168[0] >> 1)) | (16 & (n168[0] >> 1)) | (32 & (n168[0] >> 1));
  n187[0] = (1 & (n168[0])) | (2 & (n168[0])) | (4 & (n168[0])) | (8 & (n168[0])) | (16 & (n168[0])) | (32 & (n168[0]));
  { unsigned int tmp; (tmp = (unsigned int) n165[0] - (unsigned int) n184[0], n185[0] = 15 & (unsigned char) tmp); }
  n171[0] = (1 & (n165[0])) | (2 & (n165[0])) | (4 & (n165[0]));
  n170[0] = (1 & (n165[0] >> 3));
  n169[0] = (1 & (n168[0] >> 6));
  n173[0] = (1 & (n171[0])) | (2 & (n171[0]));
  n172[0] = (1 & (n171[0] >> 2));
  n178[0] = n170[0] | n172[0];
  n175[0] = (1 & (n173[0]));
  n174[0] = (1 & (n173[0] >> 1));
  n176[0] = (1 & (n175[0]));
  n179[0] = n174[0] | n176[0];
  n180[0] = n178[0] | n179[0];
  n181[0] = 1 & ~n180[0];
  n182[0] = n169[0] | n181[0];
  n183[0] = 1 & ~n182[0];
  if (n183[0]) {
    n189[0] = n187[0];
  }
  else {
    n189[0] = n188[0];
  }
  if (n183[0]) {
    n186[0] = n185[0];
  }
  else {
    n186[0] = n165[0];
  }
  n209[0] = (1 & (n189[0] >> 1)) | (2 & (n189[0] >> 1)) | (4 & (n189[0] >> 1)) | (8 & (n189[0] >> 1)) | (16 & (n189[0] >> 1));
  n208[0] = (1 & (n189[0])) | (2 & (n189[0])) | (4 & (n189[0])) | (8 & (n189[0])) | (16 & (n189[0]));
  { unsigned int tmp; (tmp = (unsigned int) n186[0] - (unsigned int) n205[0], n206[0] = 15 & (unsigned char) tmp); }
  n192[0] = (1 & (n186[0])) | (2 & (n186[0])) | (4 & (n186[0]));
  n191[0] = (1 & (n186[0] >> 3));
  n190[0] = (1 & (n189[0] >> 5));
  n194[0] = (1 & (n192[0])) | (2 & (n192[0]));
  n193[0] = (1 & (n192[0] >> 2));
  n199[0] = n191[0] | n193[0];
  n196[0] = (1 & (n194[0]));
  n195[0] = (1 & (n194[0] >> 1));
  n197[0] = (1 & (n196[0]));
  n200[0] = n195[0] | n197[0];
  n201[0] = n199[0] | n200[0];
  n202[0] = 1 & ~n201[0];
  n203[0] = n190[0] | n202[0];
  n204[0] = 1 & ~n203[0];
  if (n204[0]) {
    n210[0] = n208[0];
  }
  else {
    n210[0] = n209[0];
  }
  if (n204[0]) {
    n207[0] = n206[0];
  }
  else {
    n207[0] = n186[0];
  }
  n212[0] = (1 & (n210[0])) | (2 & (n210[0])) | (4 & (n210[0])) | (8 & (n210[0]));
  n211[0] = (1 & (n207[0])) | (2 & (n207[0])) | (4 & (n207[0]));
  n213[0] = 255 & (n211[0] << 4 | n212[0]);
  if (n278[0]) {
    n279[0] = n214[0];
  }
  else {
    n279[0] = n213[0];
  }
  if (n282[0]) {
    n283[0] = n280[0];
  }
  else {
    n283[0] = n279[0];
  }
  if (n285[0]) {
    n286[0] = n295[0];
  }
  else {
    n286[0] = n283[0];
  }
  n287[0] = 255 & (n105[0] << 7 | n286[0]);
  x_o[0] = n287[0];
}

void cf_fp_mul_c_3_4_init() {
  n295[0] = 0;
  n293[0] = 0;
  n291[0] = 0;
  n289[0] = 0;
  n260[0] = 0;
  n258[0] = 0;
  n256[0] = 0;
  n254[0] = 0;
  n252[0] = 0;
  n250[0] = 0;
  n248[0] = 0;
  n246[0] = 0;
  n244[0] = 0;
  n242[0] = 0;
  n240[0] = 0;
  n238[0] = 0;
  n236[0] = 0;
  n234[0] = 0;
  n232[0] = 0;
  n231[0] = 0;
  n230[0] = 0;
  n229[0] = 0;
  n228[0] = 0;
  n227[0] = 0;
  n214[0] = 0;
  n205[0] = 0;
  n184[0] = 0;
  n163[0] = 0;
  n142[0] = 0;
  n121[0] = 0;
  n108[0] = 0;
  n106[0] = 0;
  n56[0] = 0;
  n55[0] = 0;
  n13[0] = 0;
  n12[0] = 0;
  n10[0] = 0;
  n9[0] = 0;
  n8[0] = 0;
  n7[0] = 0;
  n6[0] = 0;
  n5[0] = 0;
  n109[0] = 0;
  n107[0] = 0;
  n105[0] = 0;
  n88[0] = 0;
  n86[0] = 0;
  n75[0] = 0;
  n74[0] = 0;
  n66[0] = 0;
  n65[0] = 0;
  n58[0] = 0;
  n57[0] = 0;
  n45[0] = 0;
  n43[0] = 0;
  n32[0] = 0;
  n31[0] = 0;
  n23[0] = 0;
  n22[0] = 0;
  n15[0] = 0;
  n14[0] = 0;
  n110[0] = 0;
  n89[0] = 0;
  n77[0] = 0;
  n76[0] = 0;
  n68[0] = 0;
  n67[0] = 0;
  n60[0] = 0;
  n59[0] = 0;
  n46[0] = 0;
  n34[0] = 0;
  n33[0] = 0;
  n25[0] = 0;
  n24[0] = 0;
  n17[0] = 0;
  n16[0] = 0;
  n114[0] = 0;
  n82[0] = 0;
  n79[0] = 0;
  n78[0] = 0;
  n71[0] = 0;
  n69[0] = 0;
  n63[0] = 0;
  n61[0] = 0;
  n39[0] = 0;
  n36[0] = 0;
  n35[0] = 0;
  n28[0] = 0;
  n26[0] = 0;
  n20[0] = 0;
  n18[0] = 0;
  n122[0] = 0;
  n80[0] = 0;
  n72[0] = 0;
  n64[0] = 0;
  n37[0] = 0;
  n29[0] = 0;
  n21[0] = 0;
  n90[0] = 0;
  n87[0] = 0;
  n83[0] = 0;
  n73[0] = 0;
  n47[0] = 0;
  n44[0] = 0;
  n40[0] = 0;
  n30[0] = 0;
  n84[0] = 0;
  n41[0] = 0;
  n85[0] = 0;
  n42[0] = 0;
  n95[0] = 0;
  n94[0] = 0;
  n93[0] = 0;
  n91[0] = 0;
  n52[0] = 0;
  n51[0] = 0;
  n50[0] = 0;
  n48[0] = 0;
  n104[0] = 0;
  n103[0] = 0;
  n101[0] = 0;
  n100[0] = 0;
  n96[0] = 0;
  n92[0] = 0;
  n53[0] = 0;
  n49[0] = 0;
  n224[0] = 0;
  n117[0] = 0;
  n115[0] = 0;
  n102[0] = 0;
  n98[0] = 0;
  n97[0] = 0;
  n225[0] = 0;
  n118[0] = 0;
  n116[0] = 0;
  n99[0] = 0;
  n226[0] = 0;
  { int index; for (index = 2; index > 0;) n119[--index] = 0; }
  n261[0] = 0;
  n259[0] = 0;
  n257[0] = 0;
  n255[0] = 0;
  n253[0] = 0;
  n251[0] = 0;
  n249[0] = 0;
  n247[0] = 0;
  n245[0] = 0;
  n243[0] = 0;
  n241[0] = 0;
  n239[0] = 0;
  n237[0] = 0;
  n235[0] = 0;
  n233[0] = 0;
  { int index; for (index = 2; index > 0;) n125[--index] = 0; }
  { int index; for (index = 2; index > 0;) n124[--index] = 0; }
  n120[0] = 0;
  n262[0] = 0;
  { int index; for (index = 2; index > 0;) n126[--index] = 0; }
  n123[0] = 0;
  n263[0] = 0;
  n146[0] = 0;
  n145[0] = 0;
  n143[0] = 0;
  n129[0] = 0;
  n128[0] = 0;
  n127[0] = 0;
  n264[0] = 0;
  n131[0] = 0;
  n130[0] = 0;
  n265[0] = 0;
  n136[0] = 0;
  n133[0] = 0;
  n132[0] = 0;
  n266[0] = 0;
  n134[0] = 0;
  n267[0] = 0;
  n137[0] = 0;
  n268[0] = 0;
  n138[0] = 0;
  n269[0] = 0;
  n139[0] = 0;
  n270[0] = 0;
  n140[0] = 0;
  n271[0] = 0;
  n141[0] = 0;
  n272[0] = 0;
  n147[0] = 0;
  n144[0] = 0;
  n273[0] = 0;
  n167[0] = 0;
  n166[0] = 0;
  n164[0] = 0;
  n150[0] = 0;
  n149[0] = 0;
  n148[0] = 0;
  n274[0] = 0;
  n152[0] = 0;
  n151[0] = 0;
  n275[0] = 0;
  n157[0] = 0;
  n154[0] = 0;
  n153[0] = 0;
  n276[0] = 0;
  n155[0] = 0;
  n278[0] = 0;
  n277[0] = 0;
  n158[0] = 0;
  n282[0] = 0;
  n281[0] = 0;
  n280[0] = 0;
  n159[0] = 0;
  n285[0] = 0;
  n160[0] = 0;
  n161[0] = 0;
  n162[0] = 0;
  n168[0] = 0;
  n165[0] = 0;
  n188[0] = 0;
  n187[0] = 0;
  n185[0] = 0;
  n171[0] = 0;
  n170[0] = 0;
  n169[0] = 0;
  n173[0] = 0;
  n172[0] = 0;
  n178[0] = 0;
  n175[0] = 0;
  n174[0] = 0;
  n176[0] = 0;
  n179[0] = 0;
  n180[0] = 0;
  n181[0] = 0;
  n182[0] = 0;
  n183[0] = 0;
  n189[0] = 0;
  n186[0] = 0;
  n209[0] = 0;
  n208[0] = 0;
  n206[0] = 0;
  n192[0] = 0;
  n191[0] = 0;
  n190[0] = 0;
  n194[0] = 0;
  n193[0] = 0;
  n199[0] = 0;
  n196[0] = 0;
  n195[0] = 0;
  n197[0] = 0;
  n200[0] = 0;
  n201[0] = 0;
  n202[0] = 0;
  n203[0] = 0;
  n204[0] = 0;
  n210[0] = 0;
  n207[0] = 0;
  n212[0] = 0;
  n211[0] = 0;
  n213[0] = 0;
  n279[0] = 0;
  n283[0] = 0;
  n286[0] = 0;
  n287[0] = 0;
  cf_fp_mul_c_3_4_calc();
}

static FILE* sim_file;
static int sim_count;
static unsigned char sim_a_i[1];
static unsigned char sim_b_i[1];
static unsigned char sim_x_o[1];

void cf_fp_mul_c_3_4_sim_init(const char* file) {
  time_t date = time(NULL);
  sim_count = 1;
  cf_fp_mul_c_3_4_init();
  sim_a_i[0] = a_i[0];
  sim_b_i[0] = b_i[0];
  sim_x_o[0] = x_o[0];
  sim_file = fopen(file, "w");
  fprintf(sim_file,
    "$date\n  %s$end\n"
    "$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n"
    "$timescale\n  1 ns\n$end\n"
    "$scope module cf_fp_mul_c_3_4 $end\n"
    "$var wire 8 ! a_i $end\n"
    "$var wire 8 \" b_i $end\n"
    "$var wire 8 # x_o $end\n"
    "$upscope $end\n"
    "$enddefinitions $end\n"
    "#0\n"
    "$dumpvars\n", asctime(localtime(&date)));
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 0; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
        else if (bit & a_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " !\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 0; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
        else if (bit & b_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " \"\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 0; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
        else if (bit & x_o[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " #\n");
  }
  fprintf(sim_file, "$end\n");
}

void cf_fp_mul_c_3_4_sim_end() {
  fprintf(sim_file, "#%d\n", sim_count);
  fclose(sim_file);
}

void cf_fp_mul_c_3_4_sim_sample() {
  int changed = 0;
  if (sim_a_i[0] != a_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 0; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
          else if (bit & a_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " !\n");
    }
    sim_a_i[0] = a_i[0];
  }
  if (sim_b_i[0] != b_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 0; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
          else if (bit & b_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " \"\n");
    }
    sim_b_i[0] = b_i[0];
  }
  if (sim_x_o[0] != x_o[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 0; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
          else if (bit & x_o[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " #\n");
    }
    sim_x_o[0] = x_o[0];
  }
  sim_count++;
}

