#
#  Copyright (c) 2003 Launchbird Design Systems, Inc.
#  All rights reserved.
#  
#  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#  
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#  
#  
#  Overview:
#  
#    Performs floating point multiply.
#  
#  Interface:
#  
#  
#  
#    Inputs:
#      a_i : Left operand.
#      b_i : Right operand.
#  
#    Outputs:
#      x_o : Result.
#  
#  Built In Parameters:
#  
#    Exponent Precision = 3
#    Mantissa Precision = 4
#    Total    Precision = 8
#  
#  
#  
#  
#  
#  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
#  
#  Build Date : Fri Aug 22 09:46:58 CDT 2003
#  
#  Interface
#  
#    Build Name    : cf_fp_mul_c_3_4
#    Clock Domains : 
#    Vector Input  : a_i(8)
#    Vector Input  : b_i(8)
#    Vector Output : x_o(8)
#  
#  
#  

import sys
import time

class cf_fp_mul_c_3_4:

  def init(self):
    self.n295 = 0L
    self.n293 = 0L
    self.n291 = 0L
    self.n289 = 0L
    self.n260 = 0L
    self.n258 = 0L
    self.n256 = 0L
    self.n254 = 0L
    self.n252 = 0L
    self.n250 = 0L
    self.n248 = 0L
    self.n246 = 0L
    self.n244 = 0L
    self.n242 = 0L
    self.n240 = 0L
    self.n238 = 0L
    self.n236 = 0L
    self.n234 = 0L
    self.n232 = 0L
    self.n231 = 0L
    self.n230 = 0L
    self.n229 = 0L
    self.n228 = 0L
    self.n227 = 0L
    self.n214 = 0L
    self.n205 = 0L
    self.n184 = 0L
    self.n163 = 0L
    self.n142 = 0L
    self.n121 = 0L
    self.n108 = 0L
    self.n106 = 0L
    self.n4 = 0L
    self.n3 = 0L
    self.n56 = 0L
    self.n55 = 0L
    self.n13 = 0L
    self.n12 = 0L
    self.n10 = 0L
    self.n9 = 0L
    self.n8 = 0L
    self.n7 = 0L
    self.n6 = 0L
    self.n5 = 0L
    self.n109 = 0L
    self.n107 = 0L
    self.n105 = 0L
    self.n88 = 0L
    self.n86 = 0L
    self.n75 = 0L
    self.n74 = 0L
    self.n66 = 0L
    self.n65 = 0L
    self.n58 = 0L
    self.n57 = 0L
    self.n45 = 0L
    self.n43 = 0L
    self.n32 = 0L
    self.n31 = 0L
    self.n23 = 0L
    self.n22 = 0L
    self.n15 = 0L
    self.n14 = 0L
    self.n110 = 0L
    self.n89 = 0L
    self.n77 = 0L
    self.n76 = 0L
    self.n68 = 0L
    self.n67 = 0L
    self.n60 = 0L
    self.n59 = 0L
    self.n46 = 0L
    self.n34 = 0L
    self.n33 = 0L
    self.n25 = 0L
    self.n24 = 0L
    self.n17 = 0L
    self.n16 = 0L
    self.n114 = 0L
    self.n82 = 0L
    self.n79 = 0L
    self.n78 = 0L
    self.n71 = 0L
    self.n69 = 0L
    self.n63 = 0L
    self.n61 = 0L
    self.n39 = 0L
    self.n36 = 0L
    self.n35 = 0L
    self.n28 = 0L
    self.n26 = 0L
    self.n20 = 0L
    self.n18 = 0L
    self.n122 = 0L
    self.n80 = 0L
    self.n72 = 0L
    self.n64 = 0L
    self.n37 = 0L
    self.n29 = 0L
    self.n21 = 0L
    self.n90 = 0L
    self.n87 = 0L
    self.n83 = 0L
    self.n73 = 0L
    self.n47 = 0L
    self.n44 = 0L
    self.n40 = 0L
    self.n30 = 0L
    self.n84 = 0L
    self.n41 = 0L
    self.n85 = 0L
    self.n42 = 0L
    self.n95 = 0L
    self.n94 = 0L
    self.n93 = 0L
    self.n91 = 0L
    self.n52 = 0L
    self.n51 = 0L
    self.n50 = 0L
    self.n48 = 0L
    self.n104 = 0L
    self.n103 = 0L
    self.n101 = 0L
    self.n100 = 0L
    self.n96 = 0L
    self.n92 = 0L
    self.n53 = 0L
    self.n49 = 0L
    self.n224 = 0L
    self.n117 = 0L
    self.n115 = 0L
    self.n102 = 0L
    self.n98 = 0L
    self.n97 = 0L
    self.n225 = 0L
    self.n118 = 0L
    self.n116 = 0L
    self.n99 = 0L
    self.n226 = 0L
    self.n119 = 0L
    self.n261 = 0L
    self.n259 = 0L
    self.n257 = 0L
    self.n255 = 0L
    self.n253 = 0L
    self.n251 = 0L
    self.n249 = 0L
    self.n247 = 0L
    self.n245 = 0L
    self.n243 = 0L
    self.n241 = 0L
    self.n239 = 0L
    self.n237 = 0L
    self.n235 = 0L
    self.n233 = 0L
    self.n125 = 0L
    self.n124 = 0L
    self.n120 = 0L
    self.n262 = 0L
    self.n126 = 0L
    self.n123 = 0L
    self.n263 = 0L
    self.n146 = 0L
    self.n145 = 0L
    self.n143 = 0L
    self.n129 = 0L
    self.n128 = 0L
    self.n127 = 0L
    self.n264 = 0L
    self.n131 = 0L
    self.n130 = 0L
    self.n265 = 0L
    self.n136 = 0L
    self.n133 = 0L
    self.n132 = 0L
    self.n266 = 0L
    self.n134 = 0L
    self.n267 = 0L
    self.n137 = 0L
    self.n268 = 0L
    self.n138 = 0L
    self.n269 = 0L
    self.n139 = 0L
    self.n270 = 0L
    self.n140 = 0L
    self.n271 = 0L
    self.n141 = 0L
    self.n272 = 0L
    self.n147 = 0L
    self.n144 = 0L
    self.n273 = 0L
    self.n167 = 0L
    self.n166 = 0L
    self.n164 = 0L
    self.n150 = 0L
    self.n149 = 0L
    self.n148 = 0L
    self.n274 = 0L
    self.n152 = 0L
    self.n151 = 0L
    self.n275 = 0L
    self.n157 = 0L
    self.n154 = 0L
    self.n153 = 0L
    self.n276 = 0L
    self.n155 = 0L
    self.n278 = 0L
    self.n277 = 0L
    self.n158 = 0L
    self.n282 = 0L
    self.n281 = 0L
    self.n280 = 0L
    self.n159 = 0L
    self.n285 = 0L
    self.n160 = 0L
    self.n161 = 0L
    self.n162 = 0L
    self.n168 = 0L
    self.n165 = 0L
    self.n188 = 0L
    self.n187 = 0L
    self.n185 = 0L
    self.n171 = 0L
    self.n170 = 0L
    self.n169 = 0L
    self.n173 = 0L
    self.n172 = 0L
    self.n178 = 0L
    self.n175 = 0L
    self.n174 = 0L
    self.n176 = 0L
    self.n179 = 0L
    self.n180 = 0L
    self.n181 = 0L
    self.n182 = 0L
    self.n183 = 0L
    self.n189 = 0L
    self.n186 = 0L
    self.n209 = 0L
    self.n208 = 0L
    self.n206 = 0L
    self.n192 = 0L
    self.n191 = 0L
    self.n190 = 0L
    self.n194 = 0L
    self.n193 = 0L
    self.n199 = 0L
    self.n196 = 0L
    self.n195 = 0L
    self.n197 = 0L
    self.n200 = 0L
    self.n201 = 0L
    self.n202 = 0L
    self.n203 = 0L
    self.n204 = 0L
    self.n210 = 0L
    self.n207 = 0L
    self.n212 = 0L
    self.n211 = 0L
    self.n213 = 0L
    self.n279 = 0L
    self.n283 = 0L
    self.n286 = 0L
    self.n287 = 0L
    self.n288 = 0L
    self.calc(0L, 0L, )

  def calc(self, a_i, b_i, ):
    self.n295 = 0x77L
    self.n293 = 0x7FL
    self.n291 = 0x70L
    self.n289 = 0x3L
    self.n260 = 0x1L
    self.n258 = 0x3L
    self.n256 = 0x2L
    self.n254 = 0x7L
    self.n252 = 0x6L
    self.n250 = 0x5L
    self.n248 = 0x4L
    self.n246 = 0xFL
    self.n244 = 0xEL
    self.n242 = 0xDL
    self.n240 = 0xCL
    self.n238 = 0xBL
    self.n236 = 0xAL
    self.n234 = 0x9L
    self.n232 = 0x8L
    self.n231 = 0x4L
    self.n230 = 0x3L
    self.n229 = 0x2L
    self.n228 = 0x1L
    self.n227 = 0x0L
    self.n214 = 0x00L
    self.n205 = 0x1L
    self.n184 = 0x1L
    self.n163 = 0x1L
    self.n142 = 0x1L
    self.n121 = 0x1L
    self.n108 = 0x0L
    self.n106 = 0x0L
    self.n4 = b_i
    self.n3 = a_i
    self.n56 = (self.n4 & 0x8L) | (self.n4 & 0x4L) | (self.n4 & 0x2L) | (self.n4 & 0x1L)
    self.n55 = ((self.n4 & 0x40L) >> 4) | ((self.n4 & 0x20L) >> 4) | ((self.n4 & 0x10L) >> 4)
    self.n13 = (self.n3 & 0x8L) | (self.n3 & 0x4L) | (self.n3 & 0x2L) | (self.n3 & 0x1L)
    self.n12 = ((self.n3 & 0x40L) >> 4) | ((self.n3 & 0x20L) >> 4) | ((self.n3 & 0x10L) >> 4)
    self.n10 = (self.n4 & 0x8L) | (self.n4 & 0x4L) | (self.n4 & 0x2L) | (self.n4 & 0x1L)
    self.n9 = ((self.n4 & 0x40L) >> 4) | ((self.n4 & 0x20L) >> 4) | ((self.n4 & 0x10L) >> 4)
    self.n8 = ((self.n4 & 0x80L) >> 7)
    self.n7 = (self.n3 & 0x8L) | (self.n3 & 0x4L) | (self.n3 & 0x2L) | (self.n3 & 0x1L)
    self.n6 = ((self.n3 & 0x40L) >> 4) | ((self.n3 & 0x20L) >> 4) | ((self.n3 & 0x10L) >> 4)
    self.n5 = ((self.n3 & 0x80L) >> 7)
    self.n109 = self.n108 << 3 | self.n9
    self.n107 = self.n106 << 3 | self.n6
    self.n105 = self.n5 ^ self.n8
    self.n88 = ((self.n56 & 0x8L) >> 3)
    self.n86 = ((self.n56 & 0x8L) >> 3)
    self.n75 = (self.n56 & 0x4L) | (self.n56 & 0x2L) | (self.n56 & 0x1L)
    self.n74 = ((self.n56 & 0x8L) >> 3)
    self.n66 = (self.n55 & 0x2L) | (self.n55 & 0x1L)
    self.n65 = ((self.n55 & 0x4L) >> 2)
    self.n58 = (self.n55 & 0x2L) | (self.n55 & 0x1L)
    self.n57 = ((self.n55 & 0x4L) >> 2)
    self.n45 = ((self.n13 & 0x8L) >> 3)
    self.n43 = ((self.n13 & 0x8L) >> 3)
    self.n32 = (self.n13 & 0x4L) | (self.n13 & 0x2L) | (self.n13 & 0x1L)
    self.n31 = ((self.n13 & 0x8L) >> 3)
    self.n23 = (self.n12 & 0x2L) | (self.n12 & 0x1L)
    self.n22 = ((self.n12 & 0x4L) >> 2)
    self.n15 = (self.n12 & 0x2L) | (self.n12 & 0x1L)
    self.n14 = ((self.n12 & 0x4L) >> 2)
    self.n110 = (self.n107 + self.n109) & 0xFL
    self.n89 = ~self.n88 & 0x1L
    self.n77 = (self.n75 & 0x2L) | (self.n75 & 0x1L)
    self.n76 = ((self.n75 & 0x4L) >> 2)
    self.n68 = (self.n66 & 0x1L)
    self.n67 = ((self.n66 & 0x2L) >> 1)
    self.n60 = (self.n58 & 0x1L)
    self.n59 = ((self.n58 & 0x2L) >> 1)
    self.n46 = ~self.n45 & 0x1L
    self.n34 = (self.n32 & 0x2L) | (self.n32 & 0x1L)
    self.n33 = ((self.n32 & 0x4L) >> 2)
    self.n25 = (self.n23 & 0x1L)
    self.n24 = ((self.n23 & 0x2L) >> 1)
    self.n17 = (self.n15 & 0x1L)
    self.n16 = ((self.n15 & 0x2L) >> 1)
    self.n114 = (self.n110 - self.n289) & 0xFL
    self.n82 = self.n74 | self.n76
    self.n79 = (self.n77 & 0x1L)
    self.n78 = ((self.n77 & 0x2L) >> 1)
    self.n71 = self.n65 | self.n67
    self.n69 = (self.n68 & 0x1L)
    self.n63 = self.n57 & self.n59
    self.n61 = (self.n60 & 0x1L)
    self.n39 = self.n31 | self.n33
    self.n36 = (self.n34 & 0x1L)
    self.n35 = ((self.n34 & 0x2L) >> 1)
    self.n28 = self.n22 | self.n24
    self.n26 = (self.n25 & 0x1L)
    self.n20 = self.n14 & self.n16
    self.n18 = (self.n17 & 0x1L)
    self.n122 = (self.n114 + self.n121) & 0xFL
    self.n80 = (self.n79 & 0x1L)
    self.n72 = self.n71 | self.n69
    self.n64 = self.n63 & self.n61
    self.n37 = (self.n36 & 0x1L)
    self.n29 = self.n28 | self.n26
    self.n21 = self.n20 & self.n18
    self.n90 = self.n64 & self.n89
    self.n87 = self.n64 & self.n86
    self.n83 = self.n78 | self.n80
    self.n73 = ~self.n72 & 0x1L
    self.n47 = self.n21 & self.n46
    self.n44 = self.n21 & self.n43
    self.n40 = self.n35 | self.n37
    self.n30 = ~self.n29 & 0x1L
    self.n84 = self.n82 | self.n83
    self.n41 = self.n39 | self.n40
    self.n85 = ~self.n84 & 0x1L
    self.n42 = ~self.n41 & 0x1L
    self.n95 = ~self.n85 & 0x1L
    self.n94 = self.n73 & self.n85
    self.n93 = self.n64 & self.n85
    self.n91 = ~self.n85 & 0x1L
    self.n52 = ~self.n42 & 0x1L
    self.n51 = self.n30 & self.n42
    self.n50 = self.n21 & self.n42
    self.n48 = ~self.n42 & 0x1L
    self.n104 = self.n51 | self.n94
    self.n103 = self.n50 | self.n93
    self.n101 = self.n51 & self.n93
    self.n100 = self.n50 & self.n94
    self.n96 = self.n73 & self.n95
    self.n92 = self.n90 & self.n91
    self.n53 = self.n30 & self.n52
    self.n49 = self.n47 & self.n48
    self.n224 = self.n103 << 1 | self.n104
    self.n117 = ~self.n96 & 0x1L
    self.n115 = ~self.n53 & 0x1L
    self.n102 = self.n100 | self.n101
    self.n98 = self.n92 | self.n87
    self.n97 = self.n49 | self.n44
    self.n225 = self.n102 << 2 | self.n224
    self.n118 = self.n117 << 4 | self.n10
    self.n116 = self.n115 << 4 | self.n7
    self.n99 = self.n97 | self.n98
    self.n226 = self.n99 << 3 | self.n225
    self.n119 = (self.n116 * self.n118) & 0x3FFL
    if self.n226 == self.n260:
      self.n261 = 1L
    else:
      self.n261 = 0L
    if self.n226 == self.n258:
      self.n259 = 1L
    else:
      self.n259 = 0L
    if self.n226 == self.n256:
      self.n257 = 1L
    else:
      self.n257 = 0L
    if self.n226 == self.n254:
      self.n255 = 1L
    else:
      self.n255 = 0L
    if self.n226 == self.n252:
      self.n253 = 1L
    else:
      self.n253 = 0L
    if self.n226 == self.n250:
      self.n251 = 1L
    else:
      self.n251 = 0L
    if self.n226 == self.n248:
      self.n249 = 1L
    else:
      self.n249 = 0L
    if self.n226 == self.n246:
      self.n247 = 1L
    else:
      self.n247 = 0L
    if self.n226 == self.n244:
      self.n245 = 1L
    else:
      self.n245 = 0L
    if self.n226 == self.n242:
      self.n243 = 1L
    else:
      self.n243 = 0L
    if self.n226 == self.n240:
      self.n241 = 1L
    else:
      self.n241 = 0L
    if self.n226 == self.n238:
      self.n239 = 1L
    else:
      self.n239 = 0L
    if self.n226 == self.n236:
      self.n237 = 1L
    else:
      self.n237 = 0L
    if self.n226 == self.n234:
      self.n235 = 1L
    else:
      self.n235 = 0L
    if self.n226 == self.n232:
      self.n233 = 1L
    else:
      self.n233 = 0L
    self.n125 = (self.n119 & 0x100L) | (self.n119 & 0x80L) | (self.n119 & 0x40L) | (self.n119 & 0x20L) | (self.n119 & 0x10L) | (self.n119 & 0x8L) | (self.n119 & 0x4L) | (self.n119 & 0x2L) | (self.n119 & 0x1L)
    self.n124 = ((self.n119 & 0x200L) >> 1) | ((self.n119 & 0x100L) >> 1) | ((self.n119 & 0x80L) >> 1) | ((self.n119 & 0x40L) >> 1) | ((self.n119 & 0x20L) >> 1) | ((self.n119 & 0x10L) >> 1) | ((self.n119 & 0x8L) >> 1) | ((self.n119 & 0x4L) >> 1) | ((self.n119 & 0x2L) >> 1)
    self.n120 = ((self.n119 & 0x200L) >> 9)
    if self.n261:
      self.n262 = self.n228
    else:
      self.n262 = self.n227
    if self.n120:
      self.n126 = self.n124
    else:
      self.n126 = self.n125
    if self.n120:
      self.n123 = self.n122
    else:
      self.n123 = self.n114
    if self.n259:
      self.n263 = self.n229
    else:
      self.n263 = self.n262
    self.n146 = ((self.n126 & 0x100L) >> 1) | ((self.n126 & 0x80L) >> 1) | ((self.n126 & 0x40L) >> 1) | ((self.n126 & 0x20L) >> 1) | ((self.n126 & 0x10L) >> 1) | ((self.n126 & 0x8L) >> 1) | ((self.n126 & 0x4L) >> 1) | ((self.n126 & 0x2L) >> 1)
    self.n145 = (self.n126 & 0x80L) | (self.n126 & 0x40L) | (self.n126 & 0x20L) | (self.n126 & 0x10L) | (self.n126 & 0x8L) | (self.n126 & 0x4L) | (self.n126 & 0x2L) | (self.n126 & 0x1L)
    self.n143 = (self.n123 - self.n142) & 0xFL
    self.n129 = (self.n123 & 0x4L) | (self.n123 & 0x2L) | (self.n123 & 0x1L)
    self.n128 = ((self.n123 & 0x8L) >> 3)
    self.n127 = ((self.n126 & 0x100L) >> 8)
    if self.n257:
      self.n264 = self.n229
    else:
      self.n264 = self.n263
    self.n131 = (self.n129 & 0x2L) | (self.n129 & 0x1L)
    self.n130 = ((self.n129 & 0x4L) >> 2)
    if self.n255:
      self.n265 = self.n230
    else:
      self.n265 = self.n264
    self.n136 = self.n128 | self.n130
    self.n133 = (self.n131 & 0x1L)
    self.n132 = ((self.n131 & 0x2L) >> 1)
    if self.n253:
      self.n266 = self.n230
    else:
      self.n266 = self.n265
    self.n134 = (self.n133 & 0x1L)
    if self.n251:
      self.n267 = self.n230
    else:
      self.n267 = self.n266
    self.n137 = self.n132 | self.n134
    if self.n249:
      self.n268 = self.n230
    else:
      self.n268 = self.n267
    self.n138 = self.n136 | self.n137
    if self.n247:
      self.n269 = self.n231
    else:
      self.n269 = self.n268
    self.n139 = ~self.n138 & 0x1L
    if self.n245:
      self.n270 = self.n231
    else:
      self.n270 = self.n269
    self.n140 = self.n127 | self.n139
    if self.n243:
      self.n271 = self.n231
    else:
      self.n271 = self.n270
    self.n141 = ~self.n140 & 0x1L
    if self.n241:
      self.n272 = self.n231
    else:
      self.n272 = self.n271
    if self.n141:
      self.n147 = self.n145
    else:
      self.n147 = self.n146
    if self.n141:
      self.n144 = self.n143
    else:
      self.n144 = self.n123
    if self.n239:
      self.n273 = self.n231
    else:
      self.n273 = self.n272
    self.n167 = ((self.n147 & 0x80L) >> 1) | ((self.n147 & 0x40L) >> 1) | ((self.n147 & 0x20L) >> 1) | ((self.n147 & 0x10L) >> 1) | ((self.n147 & 0x8L) >> 1) | ((self.n147 & 0x4L) >> 1) | ((self.n147 & 0x2L) >> 1)
    self.n166 = (self.n147 & 0x40L) | (self.n147 & 0x20L) | (self.n147 & 0x10L) | (self.n147 & 0x8L) | (self.n147 & 0x4L) | (self.n147 & 0x2L) | (self.n147 & 0x1L)
    self.n164 = (self.n144 - self.n163) & 0xFL
    self.n150 = (self.n144 & 0x4L) | (self.n144 & 0x2L) | (self.n144 & 0x1L)
    self.n149 = ((self.n144 & 0x8L) >> 3)
    self.n148 = ((self.n147 & 0x80L) >> 7)
    if self.n237:
      self.n274 = self.n231
    else:
      self.n274 = self.n273
    self.n152 = (self.n150 & 0x2L) | (self.n150 & 0x1L)
    self.n151 = ((self.n150 & 0x4L) >> 2)
    if self.n235:
      self.n275 = self.n231
    else:
      self.n275 = self.n274
    self.n157 = self.n149 | self.n151
    self.n154 = (self.n152 & 0x1L)
    self.n153 = ((self.n152 & 0x2L) >> 1)
    if self.n233:
      self.n276 = self.n231
    else:
      self.n276 = self.n275
    self.n155 = (self.n154 & 0x1L)
    self.n278 = (self.n276 & 0x1L)
    self.n277 = ((self.n276 & 0x4L) >> 1) | ((self.n276 & 0x2L) >> 1)
    self.n158 = self.n153 | self.n155
    self.n282 = (self.n277 & 0x1L)
    self.n281 = ((self.n277 & 0x2L) >> 1)
    if self.n278:
      self.n280 = self.n293
    else:
      self.n280 = self.n291
    self.n159 = self.n157 | self.n158
    self.n285 = (self.n281 & 0x1L)
    self.n160 = ~self.n159 & 0x1L
    self.n161 = self.n148 | self.n160
    self.n162 = ~self.n161 & 0x1L
    if self.n162:
      self.n168 = self.n166
    else:
      self.n168 = self.n167
    if self.n162:
      self.n165 = self.n164
    else:
      self.n165 = self.n144
    self.n188 = ((self.n168 & 0x40L) >> 1) | ((self.n168 & 0x20L) >> 1) | ((self.n168 & 0x10L) >> 1) | ((self.n168 & 0x8L) >> 1) | ((self.n168 & 0x4L) >> 1) | ((self.n168 & 0x2L) >> 1)
    self.n187 = (self.n168 & 0x20L) | (self.n168 & 0x10L) | (self.n168 & 0x8L) | (self.n168 & 0x4L) | (self.n168 & 0x2L) | (self.n168 & 0x1L)
    self.n185 = (self.n165 - self.n184) & 0xFL
    self.n171 = (self.n165 & 0x4L) | (self.n165 & 0x2L) | (self.n165 & 0x1L)
    self.n170 = ((self.n165 & 0x8L) >> 3)
    self.n169 = ((self.n168 & 0x40L) >> 6)
    self.n173 = (self.n171 & 0x2L) | (self.n171 & 0x1L)
    self.n172 = ((self.n171 & 0x4L) >> 2)
    self.n178 = self.n170 | self.n172
    self.n175 = (self.n173 & 0x1L)
    self.n174 = ((self.n173 & 0x2L) >> 1)
    self.n176 = (self.n175 & 0x1L)
    self.n179 = self.n174 | self.n176
    self.n180 = self.n178 | self.n179
    self.n181 = ~self.n180 & 0x1L
    self.n182 = self.n169 | self.n181
    self.n183 = ~self.n182 & 0x1L
    if self.n183:
      self.n189 = self.n187
    else:
      self.n189 = self.n188
    if self.n183:
      self.n186 = self.n185
    else:
      self.n186 = self.n165
    self.n209 = ((self.n189 & 0x20L) >> 1) | ((self.n189 & 0x10L) >> 1) | ((self.n189 & 0x8L) >> 1) | ((self.n189 & 0x4L) >> 1) | ((self.n189 & 0x2L) >> 1)
    self.n208 = (self.n189 & 0x10L) | (self.n189 & 0x8L) | (self.n189 & 0x4L) | (self.n189 & 0x2L) | (self.n189 & 0x1L)
    self.n206 = (self.n186 - self.n205) & 0xFL
    self.n192 = (self.n186 & 0x4L) | (self.n186 & 0x2L) | (self.n186 & 0x1L)
    self.n191 = ((self.n186 & 0x8L) >> 3)
    self.n190 = ((self.n189 & 0x20L) >> 5)
    self.n194 = (self.n192 & 0x2L) | (self.n192 & 0x1L)
    self.n193 = ((self.n192 & 0x4L) >> 2)
    self.n199 = self.n191 | self.n193
    self.n196 = (self.n194 & 0x1L)
    self.n195 = ((self.n194 & 0x2L) >> 1)
    self.n197 = (self.n196 & 0x1L)
    self.n200 = self.n195 | self.n197
    self.n201 = self.n199 | self.n200
    self.n202 = ~self.n201 & 0x1L
    self.n203 = self.n190 | self.n202
    self.n204 = ~self.n203 & 0x1L
    if self.n204:
      self.n210 = self.n208
    else:
      self.n210 = self.n209
    if self.n204:
      self.n207 = self.n206
    else:
      self.n207 = self.n186
    self.n212 = (self.n210 & 0x8L) | (self.n210 & 0x4L) | (self.n210 & 0x2L) | (self.n210 & 0x1L)
    self.n211 = (self.n207 & 0x4L) | (self.n207 & 0x2L) | (self.n207 & 0x1L)
    self.n213 = self.n211 << 4 | self.n212
    if self.n278:
      self.n279 = self.n214
    else:
      self.n279 = self.n213
    if self.n282:
      self.n283 = self.n280
    else:
      self.n283 = self.n279
    if self.n285:
      self.n286 = self.n295
    else:
      self.n286 = self.n283
    self.n287 = self.n105 << 7 | self.n286
    x_o = self.n287
    self.n288 = self.n287
    return (x_o, )

  def sim_init(self, vcdFile):
    self.sim_file = open(vcdFile, 'w')
    self.sim_count = 1
    self.init()
    self.sim_n3 = self.n3
    self.sim_n4 = self.n4
    self.sim_n288 = self.n288
    self.sim_file.write("$date\n")
    self.sim_file.write("  " + time.strftime("%a %b %d %H:%M:%S %Y", time.localtime()) + "\n")
    self.sim_file.write("$end\n")
    self.sim_file.write("$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n")
    self.sim_file.write("$timescale\n  1 ns\n$end\n")
    self.sim_file.write("$scope module cf_fp_mul_c_3_4 $end\n")
    self.sim_file.write("$var wire 8 ! a_i $end\n")
    self.sim_file.write("$var wire 8 \" b_i $end\n")
    self.sim_file.write("$var wire 8 # x_o $end\n")
    self.sim_file.write("$upscope $end\n")
    self.sim_file.write("$enddefinitions $end\n")
    self.sim_file.write("#0\n")
    self.sim_file.write("$dumpvars\n")
    found = 0
    for bit in range(7, -1, -1):
      if found:
        if self.n3 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n3 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" !\n")
    found = 0
    for bit in range(7, -1, -1):
      if found:
        if self.n4 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n4 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" \"\n")
    found = 0
    for bit in range(7, -1, -1):
      if found:
        if self.n288 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n288 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" #\n")
    self.sim_file.write("$end\n")

  def sim_end(self):
    self.sim_file.write("#%d\n" % self.sim_count)
    self.sim_file.close()

  def sim_sample(self):
    changed = 0
    if self.sim_n3 != self.n3:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(7, -1, -1):
        if found:
          if self.n3 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n3 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" !\n")
      self.sim_n3 = self.n3
    if self.sim_n4 != self.n4:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(7, -1, -1):
        if found:
          if self.n4 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n4 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" \"\n")
      self.sim_n4 = self.n4
    if self.sim_n288 != self.n288:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(7, -1, -1):
        if found:
          if self.n288 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n288 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" #\n")
      self.sim_n288 = self.n288
    self.sim_count = self.sim_count + 1

