--
--  Copyright (c) 2003 Launchbird Design Systems, Inc.
--  All rights reserved.
--  
--  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
--    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
--    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
--  
--  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
--  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
--  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
--  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
--  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
--  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--  
--  
--  Overview:
--  
--    Performs floating point multiply.
--  
--  Interface:
--  
--  
--  
--    Inputs:
--      a_i : Left operand.
--      b_i : Right operand.
--  
--    Outputs:
--      x_o : Result.
--  
--  Built In Parameters:
--  
--    Exponent Precision = 3
--    Mantissa Precision = 4
--    Total    Precision = 8
--  
--  
--  
--  
--  
--  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
--  
--  Build Date : Fri Aug 22 09:46:58 CDT 2003
--  
--  Interface
--  
--    Build Name    : cf_fp_mul_c_3_4
--    Clock Domains : 
--    Vector Input  : a_i(8)
--    Vector Input  : b_i(8)
--    Vector Output : x_o(8)
--  
--  
--  

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_16 is
port (
i1 : in  unsigned(3 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_3_4_16;
architecture rtl of cf_fp_mul_c_3_4_16 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(2 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(1 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
begin
n1 <= i1(3 downto 3);
n2 <= i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(2 downto 2);
n4 <= n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(1 downto 1);
n6 <= n4(0 downto 0);
n7 <= n6(0 downto 0);
n8 <= n1 or n3;
n9 <= n5 or n7;
n10 <= n8 or n9;
n11 <= not n10;
o1 <= n11;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_15 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(5 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(4 downto 0));
end entity cf_fp_mul_c_3_4_15;
architecture rtl of cf_fp_mul_c_3_4_15 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(3 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(3 downto 0);
signal n7 : unsigned(4 downto 0);
signal n8 : unsigned(4 downto 0);
signal n9 : unsigned(4 downto 0);
signal s10_1 : unsigned(0 downto 0);
component cf_fp_mul_c_3_4_16 is
port (
i1 : in  unsigned(3 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_16;
begin
n1 <= i2(5 downto 5);
n2 <= n1 or s10_1;
n3 <= not n2;
n4 <= "0001";
n5 <= i1 - n4;
n6 <= n5 when n3 = "1" else i1;
n7 <= i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n8 <= i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n9 <= n7 when n3 = "1" else n8;
s10 : cf_fp_mul_c_3_4_16 port map (i1, s10_1);
o2 <= n9;
o1 <= n6;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_14 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(6 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(5 downto 0));
end entity cf_fp_mul_c_3_4_14;
architecture rtl of cf_fp_mul_c_3_4_14 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(3 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(3 downto 0);
signal n7 : unsigned(5 downto 0);
signal n8 : unsigned(5 downto 0);
signal n9 : unsigned(5 downto 0);
signal s10_1 : unsigned(0 downto 0);
component cf_fp_mul_c_3_4_16 is
port (
i1 : in  unsigned(3 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_16;
begin
n1 <= i2(6 downto 6);
n2 <= n1 or s10_1;
n3 <= not n2;
n4 <= "0001";
n5 <= i1 - n4;
n6 <= n5 when n3 = "1" else i1;
n7 <= i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n8 <= i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n9 <= n7 when n3 = "1" else n8;
s10 : cf_fp_mul_c_3_4_16 port map (i1, s10_1);
o2 <= n9;
o1 <= n6;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_13 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(7 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(6 downto 0));
end entity cf_fp_mul_c_3_4_13;
architecture rtl of cf_fp_mul_c_3_4_13 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(3 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(3 downto 0);
signal n7 : unsigned(6 downto 0);
signal n8 : unsigned(6 downto 0);
signal n9 : unsigned(6 downto 0);
signal s10_1 : unsigned(0 downto 0);
component cf_fp_mul_c_3_4_16 is
port (
i1 : in  unsigned(3 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_16;
begin
n1 <= i2(7 downto 7);
n2 <= n1 or s10_1;
n3 <= not n2;
n4 <= "0001";
n5 <= i1 - n4;
n6 <= n5 when n3 = "1" else i1;
n7 <= i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n8 <= i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n9 <= n7 when n3 = "1" else n8;
s10 : cf_fp_mul_c_3_4_16 port map (i1, s10_1);
o2 <= n9;
o1 <= n6;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_12 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(8 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(7 downto 0));
end entity cf_fp_mul_c_3_4_12;
architecture rtl of cf_fp_mul_c_3_4_12 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(3 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(3 downto 0);
signal n7 : unsigned(7 downto 0);
signal n8 : unsigned(7 downto 0);
signal n9 : unsigned(7 downto 0);
signal s10_1 : unsigned(0 downto 0);
component cf_fp_mul_c_3_4_16 is
port (
i1 : in  unsigned(3 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_16;
begin
n1 <= i2(8 downto 8);
n2 <= n1 or s10_1;
n3 <= not n2;
n4 <= "0001";
n5 <= i1 - n4;
n6 <= n5 when n3 = "1" else i1;
n7 <= i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n8 <= i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n9 <= n7 when n3 = "1" else n8;
s10 : cf_fp_mul_c_3_4_16 port map (i1, s10_1);
o2 <= n9;
o1 <= n6;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_11 is
port (
i1 : in  unsigned(2 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_3_4_11;
architecture rtl of cf_fp_mul_c_3_4_11 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(1 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
begin
n1 <= i1(2 downto 2);
n2 <= i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(1 downto 1);
n4 <= n2(0 downto 0);
n5 <= n4(0 downto 0);
n6 <= n1 or n3;
n7 <= n6 or n5;
n8 <= not n7;
o1 <= n8;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_10 is
port (
i1 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_3_4_10;
architecture rtl of cf_fp_mul_c_3_4_10 is
signal n1 : unsigned(2 downto 0);
signal n2 : unsigned(3 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(1 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
signal n12 : unsigned(0 downto 0);
signal n13 : unsigned(0 downto 0);
signal n14 : unsigned(0 downto 0);
signal n15 : unsigned(0 downto 0);
signal n16 : unsigned(0 downto 0);
signal n17 : unsigned(0 downto 0);
signal n18 : unsigned(0 downto 0);
signal n19 : unsigned(0 downto 0);
signal n20 : unsigned(0 downto 0);
signal s21_1 : unsigned(0 downto 0);
signal s22_1 : unsigned(0 downto 0);
component cf_fp_mul_c_3_4_16 is
port (
i1 : in  unsigned(3 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_16;
component cf_fp_mul_c_3_4_11 is
port (
i1 : in  unsigned(2 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_11;
begin
n1 <= i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4);
n2 <= i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n1(2 downto 2);
n4 <= n1(1 downto 1) &
  n1(0 downto 0);
n5 <= n4(1 downto 1);
n6 <= n4(0 downto 0);
n7 <= n6(0 downto 0);
n8 <= n3 and n5;
n9 <= n8 and n7;
n10 <= n2(3 downto 3);
n11 <= n9 and n10;
n12 <= n2(3 downto 3);
n13 <= not n12;
n14 <= n9 and n13;
n15 <= not s21_1;
n16 <= n14 and n15;
n17 <= n9 and s21_1;
n18 <= s22_1 and s21_1;
n19 <= not s21_1;
n20 <= s22_1 and n19;
s21 : cf_fp_mul_c_3_4_16 port map (n2, s21_1);
s22 : cf_fp_mul_c_3_4_11 port map (n1, s22_1);
o5 <= n20;
o4 <= n18;
o3 <= n17;
o2 <= n16;
o1 <= n11;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_9 is
port (
i1 : in  unsigned(7 downto 0);
i2 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(3 downto 0);
o7 : out unsigned(9 downto 0));
end entity cf_fp_mul_c_3_4_9;
architecture rtl of cf_fp_mul_c_3_4_9 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(2 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(2 downto 0);
signal n6 : unsigned(3 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
signal n12 : unsigned(0 downto 0);
signal n13 : unsigned(0 downto 0);
signal n14 : unsigned(0 downto 0);
signal n15 : unsigned(0 downto 0);
signal n16 : unsigned(0 downto 0);
signal n17 : unsigned(3 downto 0);
signal n18 : unsigned(0 downto 0);
signal n19 : unsigned(3 downto 0);
signal n20 : unsigned(3 downto 0);
signal n21 : unsigned(3 downto 0);
signal n22 : unsigned(0 downto 0);
signal n23 : unsigned(4 downto 0);
signal n24 : unsigned(0 downto 0);
signal n25 : unsigned(4 downto 0);
signal n26 : unsigned(9 downto 0);
signal n27 : unsigned(3 downto 0);
signal s28_1 : unsigned(0 downto 0);
signal s28_2 : unsigned(0 downto 0);
signal s28_3 : unsigned(0 downto 0);
signal s28_4 : unsigned(0 downto 0);
signal s28_5 : unsigned(0 downto 0);
signal s29_1 : unsigned(0 downto 0);
signal s29_2 : unsigned(0 downto 0);
signal s29_3 : unsigned(0 downto 0);
signal s29_4 : unsigned(0 downto 0);
signal s29_5 : unsigned(0 downto 0);
component cf_fp_mul_c_3_4_10 is
port (
i1 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end component cf_fp_mul_c_3_4_10;
begin
n1 <= i1(7 downto 7);
n2 <= i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4);
n3 <= i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n4 <= i2(7 downto 7);
n5 <= i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4);
n6 <= i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n7 <= s29_2 or s29_1;
n8 <= s28_2 or s28_1;
n9 <= n7 or n8;
n10 <= s29_3 and s28_4;
n11 <= s29_4 and s28_3;
n12 <= n10 or n11;
n13 <= s29_3 or s28_3;
n14 <= s29_4 or s28_4;
n15 <= n1 xor n4;
n16 <= "0";
n17 <= n16 & n2;
n18 <= "0";
n19 <= n18 & n5;
n20 <= n17 + n19;
n21 <= n20 - n27;
n22 <= not s29_5;
n23 <= n22 & n3;
n24 <= not s28_5;
n25 <= n24 & n6;
n26 <= n23 * n25;
n27 <= "0011";
s28 : cf_fp_mul_c_3_4_10 port map (i2, s28_1, s28_2, s28_3, s28_4, s28_5);
s29 : cf_fp_mul_c_3_4_10 port map (i1, s29_1, s29_2, s29_3, s29_4, s29_5);
o7 <= n26;
o6 <= n21;
o5 <= n15;
o4 <= n14;
o3 <= n13;
o2 <= n12;
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_8 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_3_4_8;
architecture rtl of cf_fp_mul_c_3_4_8 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
begin
n1 <= "0010";
n2 <= "1" when i1 = n1 else "0";
n3 <= "0011";
n4 <= "1" when i1 = n3 else "0";
n5 <= "0001";
n6 <= "1" when i1 = n5 else "0";
n7 <= i3 when n6 = "1" else i2;
n8 <= i4 when n4 = "1" else n7;
n9 <= i4 when n2 = "1" else n8;
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_7 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_3_4_7;
architecture rtl of cf_fp_mul_c_3_4_7 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_3_4_8 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_3_4_8;
begin
n1 <= "0101";
n2 <= "1" when i1 = n1 else "0";
n3 <= "0110";
n4 <= "1" when i1 = n3 else "0";
n5 <= "0111";
n6 <= "1" when i1 = n5 else "0";
n7 <= i5 when n6 = "1" else s10_1;
n8 <= i5 when n4 = "1" else n7;
n9 <= i5 when n2 = "1" else n8;
s10 : cf_fp_mul_c_3_4_8 port map (i1, i2, i3, i4, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_6 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_3_4_6;
architecture rtl of cf_fp_mul_c_3_4_6 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_3_4_7 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_3_4_7;
begin
n1 <= "1110";
n2 <= "1" when i1 = n1 else "0";
n3 <= "1111";
n4 <= "1" when i1 = n3 else "0";
n5 <= "0100";
n6 <= "1" when i1 = n5 else "0";
n7 <= i5 when n6 = "1" else s10_1;
n8 <= i6 when n4 = "1" else n7;
n9 <= i6 when n2 = "1" else n8;
s10 : cf_fp_mul_c_3_4_7 port map (i1, i2, i3, i4, i5, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_5 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_3_4_5;
architecture rtl of cf_fp_mul_c_3_4_5 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_3_4_6 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_3_4_6;
begin
n1 <= "1011";
n2 <= "1" when i1 = n1 else "0";
n3 <= "1100";
n4 <= "1" when i1 = n3 else "0";
n5 <= "1101";
n6 <= "1" when i1 = n5 else "0";
n7 <= i6 when n6 = "1" else s10_1;
n8 <= i6 when n4 = "1" else n7;
n9 <= i6 when n2 = "1" else n8;
s10 : cf_fp_mul_c_3_4_6 port map (i1, i2, i3, i4, i5, i6, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_4 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_3_4_4;
architecture rtl of cf_fp_mul_c_3_4_4 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_3_4_5 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_3_4_5;
begin
n1 <= "1000";
n2 <= "1" when i1 = n1 else "0";
n3 <= "1001";
n4 <= "1" when i1 = n3 else "0";
n5 <= "1010";
n6 <= "1" when i1 = n5 else "0";
n7 <= i6 when n6 = "1" else s10_1;
n8 <= i6 when n4 = "1" else n7;
n9 <= i6 when n2 = "1" else n8;
s10 : cf_fp_mul_c_3_4_5 port map (i1, i2, i3, i4, i5, i6, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_3 is
port (
i1 : in  unsigned(6 downto 0);
i2 : in  unsigned(6 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(6 downto 0);
i5 : in  unsigned(6 downto 0);
i6 : in  unsigned(6 downto 0);
o1 : out unsigned(6 downto 0));
end entity cf_fp_mul_c_3_4_3;
architecture rtl of cf_fp_mul_c_3_4_3 is
signal n1 : unsigned(1 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(6 downto 0);
signal n4 : unsigned(6 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(6 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(6 downto 0);
begin
n1 <= i3(2 downto 2) &
  i3(1 downto 1);
n2 <= i3(0 downto 0);
n3 <= i2 when n2 = "1" else i1;
n4 <= i5 when n2 = "1" else i4;
n5 <= n1(1 downto 1);
n6 <= n1(0 downto 0);
n7 <= n4 when n6 = "1" else n3;
n8 <= n5(0 downto 0);
n9 <= i6 when n8 = "1" else n7;
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_2 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(3 downto 0);
i7 : in  unsigned(4 downto 0);
o1 : out unsigned(7 downto 0));
end entity cf_fp_mul_c_3_4_2;
architecture rtl of cf_fp_mul_c_3_4_2 is
signal n1 : unsigned(2 downto 0);
signal n2 : unsigned(3 downto 0);
signal n3 : unsigned(6 downto 0);
signal n4 : unsigned(6 downto 0);
signal n5 : unsigned(1 downto 0);
signal n6 : unsigned(2 downto 0);
signal n7 : unsigned(3 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal n10 : unsigned(2 downto 0);
signal n11 : unsigned(2 downto 0);
signal n12 : unsigned(2 downto 0);
signal n13 : unsigned(7 downto 0);
signal n14 : unsigned(6 downto 0);
signal n15 : unsigned(6 downto 0);
signal n16 : unsigned(6 downto 0);
signal s17_1 : unsigned(2 downto 0);
signal s18_1 : unsigned(6 downto 0);
component cf_fp_mul_c_3_4_4 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_3_4_4;
component cf_fp_mul_c_3_4_3 is
port (
i1 : in  unsigned(6 downto 0);
i2 : in  unsigned(6 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(6 downto 0);
i5 : in  unsigned(6 downto 0);
i6 : in  unsigned(6 downto 0);
o1 : out unsigned(6 downto 0));
end component cf_fp_mul_c_3_4_3;
begin
n1 <= i6(2 downto 2) &
  i6(1 downto 1) &
  i6(0 downto 0);
n2 <= i7(3 downto 3) &
  i7(2 downto 2) &
  i7(1 downto 1) &
  i7(0 downto 0);
n3 <= n1 & n2;
n4 <= "0000000";
n5 <= i3 & i4;
n6 <= i2 & n5;
n7 <= i1 & n6;
n8 <= "000";
n9 <= "001";
n10 <= "010";
n11 <= "011";
n12 <= "100";
n13 <= i5 & s18_1;
n14 <= "1110000";
n15 <= "1111111";
n16 <= "1110111";
s17 : cf_fp_mul_c_3_4_4 port map (n7, n8, n9, n10, n11, n12, s17_1);
s18 : cf_fp_mul_c_3_4_3 port map (n3, n4, s17_1, n14, n15, n16, s18_1);
o1 <= n13;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4_1 is
port (
i1 : in  unsigned(7 downto 0);
i2 : in  unsigned(7 downto 0);
o1 : out unsigned(7 downto 0));
end entity cf_fp_mul_c_3_4_1;
architecture rtl of cf_fp_mul_c_3_4_1 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(3 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(3 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal s8_1 : unsigned(3 downto 0);
signal s8_2 : unsigned(4 downto 0);
signal s9_1 : unsigned(3 downto 0);
signal s9_2 : unsigned(5 downto 0);
signal s10_1 : unsigned(3 downto 0);
signal s10_2 : unsigned(6 downto 0);
signal s11_1 : unsigned(3 downto 0);
signal s11_2 : unsigned(7 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(3 downto 0);
signal s12_7 : unsigned(9 downto 0);
signal s13_1 : unsigned(7 downto 0);
component cf_fp_mul_c_3_4_15 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(5 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(4 downto 0));
end component cf_fp_mul_c_3_4_15;
component cf_fp_mul_c_3_4_14 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(6 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(5 downto 0));
end component cf_fp_mul_c_3_4_14;
component cf_fp_mul_c_3_4_13 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(7 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(6 downto 0));
end component cf_fp_mul_c_3_4_13;
component cf_fp_mul_c_3_4_12 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(8 downto 0);
o1 : out unsigned(3 downto 0);
o2 : out unsigned(7 downto 0));
end component cf_fp_mul_c_3_4_12;
component cf_fp_mul_c_3_4_9 is
port (
i1 : in  unsigned(7 downto 0);
i2 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(3 downto 0);
o7 : out unsigned(9 downto 0));
end component cf_fp_mul_c_3_4_9;
component cf_fp_mul_c_3_4_2 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(3 downto 0);
i7 : in  unsigned(4 downto 0);
o1 : out unsigned(7 downto 0));
end component cf_fp_mul_c_3_4_2;
begin
n1 <= s12_7(9 downto 9);
n2 <= "0001";
n3 <= s12_6 + n2;
n4 <= n3 when n1 = "1" else s12_6;
n5 <= s12_7(9 downto 9) &
  s12_7(8 downto 8) &
  s12_7(7 downto 7) &
  s12_7(6 downto 6) &
  s12_7(5 downto 5) &
  s12_7(4 downto 4) &
  s12_7(3 downto 3) &
  s12_7(2 downto 2) &
  s12_7(1 downto 1);
n6 <= s12_7(8 downto 8) &
  s12_7(7 downto 7) &
  s12_7(6 downto 6) &
  s12_7(5 downto 5) &
  s12_7(4 downto 4) &
  s12_7(3 downto 3) &
  s12_7(2 downto 2) &
  s12_7(1 downto 1) &
  s12_7(0 downto 0);
n7 <= n5 when n1 = "1" else n6;
s8 : cf_fp_mul_c_3_4_15 port map (s9_1, s9_2, s8_1, s8_2);
s9 : cf_fp_mul_c_3_4_14 port map (s10_1, s10_2, s9_1, s9_2);
s10 : cf_fp_mul_c_3_4_13 port map (s11_1, s11_2, s10_1, s10_2);
s11 : cf_fp_mul_c_3_4_12 port map (n4, n7, s11_1, s11_2);
s12 : cf_fp_mul_c_3_4_9 port map (i1, i2, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7);
s13 : cf_fp_mul_c_3_4_2 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s8_1, s8_2, s13_1);
o1 <= s13_1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_3_4 is
port(
signal a_i : in unsigned(7 downto 0);
signal b_i : in unsigned(7 downto 0);
signal x_o : out unsigned(7 downto 0));
end entity cf_fp_mul_c_3_4;
architecture rtl of cf_fp_mul_c_3_4 is
component cf_fp_mul_c_3_4_1 is
port (
i1 : in  unsigned(7 downto 0);
i2 : in  unsigned(7 downto 0);
o1 : out unsigned(7 downto 0));
end component cf_fp_mul_c_3_4_1;
signal n1 : unsigned(7 downto 0);
begin
s1 : cf_fp_mul_c_3_4_1 port map (a_i, b_i, n1);
x_o <= n1;
end architecture rtl;


