//
//  Copyright (c) 2003 Launchbird Design Systems, Inc.
//  All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
//  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
//  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  
//  
//  Overview:
//  
//    Performs floating point multiply.
//  
//  Interface:
//  
//  
//  
//    Inputs:
//      a_i : Left operand.
//      b_i : Right operand.
//  
//    Outputs:
//      x_o : Result.
//  
//  Built In Parameters:
//  
//    Exponent Precision = 5
//    Mantissa Precision = 10
//    Total    Precision = 16
//  
//  
//  
//  
//  
//  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
//  
//  Build Date : Fri Aug 22 09:47:02 CDT 2003
//  
//  Interface
//  
//    Build Name    : cf_fp_mul_c_5_10
//    Clock Domains : 
//    Vector Input  : a_i(16)
//    Vector Input  : b_i(16)
//    Vector Output : x_o(16)
//  
//  
//  

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cf_fp_mul_c_5_10.h"

static unsigned char n541[2];
static unsigned char n539[2];
static unsigned char n537[2];
static unsigned char n535[1];
static unsigned char n506[1];
static unsigned char n504[1];
static unsigned char n502[1];
static unsigned char n500[1];
static unsigned char n498[1];
static unsigned char n496[1];
static unsigned char n494[1];
static unsigned char n492[1];
static unsigned char n490[1];
static unsigned char n488[1];
static unsigned char n486[1];
static unsigned char n484[1];
static unsigned char n482[1];
static unsigned char n480[1];
static unsigned char n478[1];
static unsigned char n477[1];
static unsigned char n476[1];
static unsigned char n475[1];
static unsigned char n474[1];
static unsigned char n473[1];
static unsigned char n460[2];
static unsigned char n451[1];
static unsigned char n424[1];
static unsigned char n397[1];
static unsigned char n370[1];
static unsigned char n343[1];
static unsigned char n316[1];
static unsigned char n289[1];
static unsigned char n262[1];
static unsigned char n235[1];
static unsigned char n208[1];
static unsigned char n181[1];
static unsigned char n168[1];
static unsigned char n166[1];
static unsigned char *b_i;
static unsigned char *a_i;
static unsigned char n86[2];
static unsigned char n85[1];
static unsigned char n13[2];
static unsigned char n12[1];
static unsigned char n10[2];
static unsigned char n9[1];
static unsigned char n8[1];
static unsigned char n7[2];
static unsigned char n6[1];
static unsigned char n5[1];
static unsigned char n169[1];
static unsigned char n167[1];
static unsigned char n165[1];
static unsigned char n148[1];
static unsigned char n146[1];
static unsigned char n117[2];
static unsigned char n116[1];
static unsigned char n102[1];
static unsigned char n101[1];
static unsigned char n88[1];
static unsigned char n87[1];
static unsigned char n75[1];
static unsigned char n73[1];
static unsigned char n44[2];
static unsigned char n43[1];
static unsigned char n29[1];
static unsigned char n28[1];
static unsigned char n15[1];
static unsigned char n14[1];
static unsigned char n170[1];
static unsigned char n149[1];
static unsigned char n119[1];
static unsigned char n118[1];
static unsigned char n104[1];
static unsigned char n103[1];
static unsigned char n90[1];
static unsigned char n89[1];
static unsigned char n76[1];
static unsigned char n46[1];
static unsigned char n45[1];
static unsigned char n31[1];
static unsigned char n30[1];
static unsigned char n17[1];
static unsigned char n16[1];
static unsigned char n174[1];
static unsigned char n136[1];
static unsigned char n121[1];
static unsigned char n120[1];
static unsigned char n111[1];
static unsigned char n106[1];
static unsigned char n105[1];
static unsigned char n97[1];
static unsigned char n92[1];
static unsigned char n91[1];
static unsigned char n63[1];
static unsigned char n48[1];
static unsigned char n47[1];
static unsigned char n38[1];
static unsigned char n33[1];
static unsigned char n32[1];
static unsigned char n24[1];
static unsigned char n19[1];
static unsigned char n18[1];
static unsigned char n182[1];
static unsigned char n123[1];
static unsigned char n122[1];
static unsigned char n108[1];
static unsigned char n107[1];
static unsigned char n94[1];
static unsigned char n93[1];
static unsigned char n50[1];
static unsigned char n49[1];
static unsigned char n35[1];
static unsigned char n34[1];
static unsigned char n21[1];
static unsigned char n20[1];
static unsigned char n137[1];
static unsigned char n125[1];
static unsigned char n124[1];
static unsigned char n112[1];
static unsigned char n109[1];
static unsigned char n98[1];
static unsigned char n95[1];
static unsigned char n64[1];
static unsigned char n52[1];
static unsigned char n51[1];
static unsigned char n39[1];
static unsigned char n36[1];
static unsigned char n25[1];
static unsigned char n22[1];
static unsigned char n141[1];
static unsigned char n127[1];
static unsigned char n126[1];
static unsigned char n113[1];
static unsigned char n99[1];
static unsigned char n68[1];
static unsigned char n54[1];
static unsigned char n53[1];
static unsigned char n40[1];
static unsigned char n26[1];
static unsigned char n138[1];
static unsigned char n129[1];
static unsigned char n128[1];
static unsigned char n114[1];
static unsigned char n100[1];
static unsigned char n65[1];
static unsigned char n56[1];
static unsigned char n55[1];
static unsigned char n41[1];
static unsigned char n27[1];
static unsigned char n150[1];
static unsigned char n147[1];
static unsigned char n131[1];
static unsigned char n130[1];
static unsigned char n115[1];
static unsigned char n77[1];
static unsigned char n74[1];
static unsigned char n58[1];
static unsigned char n57[1];
static unsigned char n42[1];
static unsigned char n139[1];
static unsigned char n133[1];
static unsigned char n132[1];
static unsigned char n66[1];
static unsigned char n60[1];
static unsigned char n59[1];
static unsigned char n142[1];
static unsigned char n134[1];
static unsigned char n69[1];
static unsigned char n61[1];
static unsigned char n143[1];
static unsigned char n140[1];
static unsigned char n70[1];
static unsigned char n67[1];
static unsigned char n144[1];
static unsigned char n71[1];
static unsigned char n145[1];
static unsigned char n72[1];
static unsigned char n155[1];
static unsigned char n154[1];
static unsigned char n153[1];
static unsigned char n151[1];
static unsigned char n82[1];
static unsigned char n81[1];
static unsigned char n80[1];
static unsigned char n78[1];
static unsigned char n164[1];
static unsigned char n163[1];
static unsigned char n161[1];
static unsigned char n160[1];
static unsigned char n156[1];
static unsigned char n152[1];
static unsigned char n83[1];
static unsigned char n79[1];
static unsigned char n470[1];
static unsigned char n177[1];
static unsigned char n175[1];
static unsigned char n162[1];
static unsigned char n158[1];
static unsigned char n157[1];
static unsigned char n471[1];
static unsigned char n178[2];
static unsigned char n176[2];
static unsigned char n159[1];
static unsigned char n472[1];
static unsigned char n179[3];
static unsigned char n507[1];
static unsigned char n505[1];
static unsigned char n503[1];
static unsigned char n501[1];
static unsigned char n499[1];
static unsigned char n497[1];
static unsigned char n495[1];
static unsigned char n493[1];
static unsigned char n491[1];
static unsigned char n489[1];
static unsigned char n487[1];
static unsigned char n485[1];
static unsigned char n483[1];
static unsigned char n481[1];
static unsigned char n479[1];
static unsigned char n185[3];
static unsigned char n184[3];
static unsigned char n180[1];
static unsigned char n508[1];
static unsigned char n186[3];
static unsigned char n183[1];
static unsigned char n509[1];
static unsigned char n212[3];
static unsigned char n211[3];
static unsigned char n209[1];
static unsigned char n189[1];
static unsigned char n188[1];
static unsigned char n187[1];
static unsigned char n510[1];
static unsigned char n191[1];
static unsigned char n190[1];
static unsigned char n511[1];
static unsigned char n200[1];
static unsigned char n193[1];
static unsigned char n192[1];
static unsigned char n512[1];
static unsigned char n195[1];
static unsigned char n194[1];
static unsigned char n513[1];
static unsigned char n201[1];
static unsigned char n197[1];
static unsigned char n196[1];
static unsigned char n514[1];
static unsigned char n203[1];
static unsigned char n198[1];
static unsigned char n515[1];
static unsigned char n202[1];
static unsigned char n516[1];
static unsigned char n204[1];
static unsigned char n517[1];
static unsigned char n205[1];
static unsigned char n518[1];
static unsigned char n206[1];
static unsigned char n519[1];
static unsigned char n207[1];
static unsigned char n520[1];
static unsigned char n213[3];
static unsigned char n210[1];
static unsigned char n521[1];
static unsigned char n239[3];
static unsigned char n238[3];
static unsigned char n236[1];
static unsigned char n216[1];
static unsigned char n215[1];
static unsigned char n214[1];
static unsigned char n522[1];
static unsigned char n218[1];
static unsigned char n217[1];
static unsigned char n524[1];
static unsigned char n523[1];
static unsigned char n227[1];
static unsigned char n220[1];
static unsigned char n219[1];
static unsigned char n528[1];
static unsigned char n527[1];
static unsigned char n526[2];
static unsigned char n222[1];
static unsigned char n221[1];
static unsigned char n531[1];
static unsigned char n228[1];
static unsigned char n224[1];
static unsigned char n223[1];
static unsigned char n230[1];
static unsigned char n225[1];
static unsigned char n229[1];
static unsigned char n231[1];
static unsigned char n232[1];
static unsigned char n233[1];
static unsigned char n234[1];
static unsigned char n240[3];
static unsigned char n237[1];
static unsigned char n266[3];
static unsigned char n265[3];
static unsigned char n263[1];
static unsigned char n243[1];
static unsigned char n242[1];
static unsigned char n241[1];
static unsigned char n245[1];
static unsigned char n244[1];
static unsigned char n254[1];
static unsigned char n247[1];
static unsigned char n246[1];
static unsigned char n249[1];
static unsigned char n248[1];
static unsigned char n255[1];
static unsigned char n251[1];
static unsigned char n250[1];
static unsigned char n257[1];
static unsigned char n252[1];
static unsigned char n256[1];
static unsigned char n258[1];
static unsigned char n259[1];
static unsigned char n260[1];
static unsigned char n261[1];
static unsigned char n267[3];
static unsigned char n264[1];
static unsigned char n293[3];
static unsigned char n292[3];
static unsigned char n290[1];
static unsigned char n270[1];
static unsigned char n269[1];
static unsigned char n268[1];
static unsigned char n272[1];
static unsigned char n271[1];
static unsigned char n281[1];
static unsigned char n274[1];
static unsigned char n273[1];
static unsigned char n276[1];
static unsigned char n275[1];
static unsigned char n282[1];
static unsigned char n278[1];
static unsigned char n277[1];
static unsigned char n284[1];
static unsigned char n279[1];
static unsigned char n283[1];
static unsigned char n285[1];
static unsigned char n286[1];
static unsigned char n287[1];
static unsigned char n288[1];
static unsigned char n294[3];
static unsigned char n291[1];
static unsigned char n320[2];
static unsigned char n319[2];
static unsigned char n317[1];
static unsigned char n297[1];
static unsigned char n296[1];
static unsigned char n295[1];
static unsigned char n299[1];
static unsigned char n298[1];
static unsigned char n308[1];
static unsigned char n301[1];
static unsigned char n300[1];
static unsigned char n303[1];
static unsigned char n302[1];
static unsigned char n309[1];
static unsigned char n305[1];
static unsigned char n304[1];
static unsigned char n311[1];
static unsigned char n306[1];
static unsigned char n310[1];
static unsigned char n312[1];
static unsigned char n313[1];
static unsigned char n314[1];
static unsigned char n315[1];
static unsigned char n321[2];
static unsigned char n318[1];
static unsigned char n347[2];
static unsigned char n346[2];
static unsigned char n344[1];
static unsigned char n324[1];
static unsigned char n323[1];
static unsigned char n322[1];
static unsigned char n326[1];
static unsigned char n325[1];
static unsigned char n335[1];
static unsigned char n328[1];
static unsigned char n327[1];
static unsigned char n330[1];
static unsigned char n329[1];
static unsigned char n336[1];
static unsigned char n332[1];
static unsigned char n331[1];
static unsigned char n338[1];
static unsigned char n333[1];
static unsigned char n337[1];
static unsigned char n339[1];
static unsigned char n340[1];
static unsigned char n341[1];
static unsigned char n342[1];
static unsigned char n348[2];
static unsigned char n345[1];
static unsigned char n374[2];
static unsigned char n373[2];
static unsigned char n371[1];
static unsigned char n351[1];
static unsigned char n350[1];
static unsigned char n349[1];
static unsigned char n353[1];
static unsigned char n352[1];
static unsigned char n362[1];
static unsigned char n355[1];
static unsigned char n354[1];
static unsigned char n357[1];
static unsigned char n356[1];
static unsigned char n363[1];
static unsigned char n359[1];
static unsigned char n358[1];
static unsigned char n365[1];
static unsigned char n360[1];
static unsigned char n364[1];
static unsigned char n366[1];
static unsigned char n367[1];
static unsigned char n368[1];
static unsigned char n369[1];
static unsigned char n375[2];
static unsigned char n372[1];
static unsigned char n401[2];
static unsigned char n400[2];
static unsigned char n398[1];
static unsigned char n378[1];
static unsigned char n377[1];
static unsigned char n376[1];
static unsigned char n380[1];
static unsigned char n379[1];
static unsigned char n389[1];
static unsigned char n382[1];
static unsigned char n381[1];
static unsigned char n384[1];
static unsigned char n383[1];
static unsigned char n390[1];
static unsigned char n386[1];
static unsigned char n385[1];
static unsigned char n392[1];
static unsigned char n387[1];
static unsigned char n391[1];
static unsigned char n393[1];
static unsigned char n394[1];
static unsigned char n395[1];
static unsigned char n396[1];
static unsigned char n402[2];
static unsigned char n399[1];
static unsigned char n428[2];
static unsigned char n427[2];
static unsigned char n425[1];
static unsigned char n405[1];
static unsigned char n404[1];
static unsigned char n403[1];
static unsigned char n407[1];
static unsigned char n406[1];
static unsigned char n416[1];
static unsigned char n409[1];
static unsigned char n408[1];
static unsigned char n411[1];
static unsigned char n410[1];
static unsigned char n417[1];
static unsigned char n413[1];
static unsigned char n412[1];
static unsigned char n419[1];
static unsigned char n414[1];
static unsigned char n418[1];
static unsigned char n420[1];
static unsigned char n421[1];
static unsigned char n422[1];
static unsigned char n423[1];
static unsigned char n429[2];
static unsigned char n426[1];
static unsigned char n455[2];
static unsigned char n454[2];
static unsigned char n452[1];
static unsigned char n432[1];
static unsigned char n431[1];
static unsigned char n430[1];
static unsigned char n434[1];
static unsigned char n433[1];
static unsigned char n443[1];
static unsigned char n436[1];
static unsigned char n435[1];
static unsigned char n438[1];
static unsigned char n437[1];
static unsigned char n444[1];
static unsigned char n440[1];
static unsigned char n439[1];
static unsigned char n446[1];
static unsigned char n441[1];
static unsigned char n445[1];
static unsigned char n447[1];
static unsigned char n448[1];
static unsigned char n449[1];
static unsigned char n450[1];
static unsigned char n456[2];
static unsigned char n453[1];
static unsigned char n458[2];
static unsigned char n457[1];
static unsigned char n459[2];
static unsigned char n525[2];
static unsigned char n529[2];
static unsigned char n532[2];
static unsigned char n533[2];
static unsigned char *x_o;

void cf_fp_mul_c_5_10_ports(unsigned char* port_a_i, unsigned char* port_b_i, unsigned char* port_x_o) {
  a_i = port_a_i;
  b_i = port_b_i;
  x_o = port_x_o;
}

void cf_fp_mul_c_5_10_calc() {
  n541[0] = 255;
  n541[1] = 125;
  n539[0] = 255;
  n539[1] = 127;
  n537[0] = 0;
  n537[1] = 124;
  n535[0] = 15;
  n506[0] = 1;
  n504[0] = 3;
  n502[0] = 2;
  n500[0] = 7;
  n498[0] = 6;
  n496[0] = 5;
  n494[0] = 4;
  n492[0] = 15;
  n490[0] = 14;
  n488[0] = 13;
  n486[0] = 12;
  n484[0] = 11;
  n482[0] = 10;
  n480[0] = 9;
  n478[0] = 8;
  n477[0] = 4;
  n476[0] = 3;
  n475[0] = 2;
  n474[0] = 1;
  n473[0] = 0;
  n460[0] = 0;
  n460[1] = 0;
  n451[0] = 1;
  n424[0] = 1;
  n397[0] = 1;
  n370[0] = 1;
  n343[0] = 1;
  n316[0] = 1;
  n289[0] = 1;
  n262[0] = 1;
  n235[0] = 1;
  n208[0] = 1;
  n181[0] = 1;
  n168[0] = 0;
  n166[0] = 0;
  n86[0] = (1 & (b_i[0])) | (2 & (b_i[0])) | (4 & (b_i[0])) | (8 & (b_i[0])) | (16 & (b_i[0])) | (32 & (b_i[0])) | (64 & (b_i[0])) | (128 & (b_i[0]));
  n86[1] = (1 & (b_i[1])) | (2 & (b_i[1]));
  n85[0] = (1 & (b_i[1] >> 2)) | (2 & (b_i[1] >> 2)) | (4 & (b_i[1] >> 2)) | (8 & (b_i[1] >> 2)) | (16 & (b_i[1] >> 2));
  n13[0] = (1 & (a_i[0])) | (2 & (a_i[0])) | (4 & (a_i[0])) | (8 & (a_i[0])) | (16 & (a_i[0])) | (32 & (a_i[0])) | (64 & (a_i[0])) | (128 & (a_i[0]));
  n13[1] = (1 & (a_i[1])) | (2 & (a_i[1]));
  n12[0] = (1 & (a_i[1] >> 2)) | (2 & (a_i[1] >> 2)) | (4 & (a_i[1] >> 2)) | (8 & (a_i[1] >> 2)) | (16 & (a_i[1] >> 2));
  n10[0] = (1 & (b_i[0])) | (2 & (b_i[0])) | (4 & (b_i[0])) | (8 & (b_i[0])) | (16 & (b_i[0])) | (32 & (b_i[0])) | (64 & (b_i[0])) | (128 & (b_i[0]));
  n10[1] = (1 & (b_i[1])) | (2 & (b_i[1]));
  n9[0] = (1 & (b_i[1] >> 2)) | (2 & (b_i[1] >> 2)) | (4 & (b_i[1] >> 2)) | (8 & (b_i[1] >> 2)) | (16 & (b_i[1] >> 2));
  n8[0] = (1 & (b_i[1] >> 7));
  n7[0] = (1 & (a_i[0])) | (2 & (a_i[0])) | (4 & (a_i[0])) | (8 & (a_i[0])) | (16 & (a_i[0])) | (32 & (a_i[0])) | (64 & (a_i[0])) | (128 & (a_i[0]));
  n7[1] = (1 & (a_i[1])) | (2 & (a_i[1]));
  n6[0] = (1 & (a_i[1] >> 2)) | (2 & (a_i[1] >> 2)) | (4 & (a_i[1] >> 2)) | (8 & (a_i[1] >> 2)) | (16 & (a_i[1] >> 2));
  n5[0] = (1 & (a_i[1] >> 7));
  n169[0] = 255 & (n168[0] << 5 | n9[0]);
  n167[0] = 255 & (n166[0] << 5 | n6[0]);
  n165[0] = n5[0] ^ n8[0];
  n148[0] = (1 & (n86[1] >> 1));
  n146[0] = (1 & (n86[1] >> 1));
  n117[0] = (1 & (n86[0])) | (2 & (n86[0])) | (4 & (n86[0])) | (8 & (n86[0])) | (16 & (n86[0])) | (32 & (n86[0])) | (64 & (n86[0])) | (128 & (n86[0]));
  n117[1] = (1 & (n86[1]));
  n116[0] = (1 & (n86[1] >> 1));
  n102[0] = (1 & (n85[0])) | (2 & (n85[0])) | (4 & (n85[0])) | (8 & (n85[0]));
  n101[0] = (1 & (n85[0] >> 4));
  n88[0] = (1 & (n85[0])) | (2 & (n85[0])) | (4 & (n85[0])) | (8 & (n85[0]));
  n87[0] = (1 & (n85[0] >> 4));
  n75[0] = (1 & (n13[1] >> 1));
  n73[0] = (1 & (n13[1] >> 1));
  n44[0] = (1 & (n13[0])) | (2 & (n13[0])) | (4 & (n13[0])) | (8 & (n13[0])) | (16 & (n13[0])) | (32 & (n13[0])) | (64 & (n13[0])) | (128 & (n13[0]));
  n44[1] = (1 & (n13[1]));
  n43[0] = (1 & (n13[1] >> 1));
  n29[0] = (1 & (n12[0])) | (2 & (n12[0])) | (4 & (n12[0])) | (8 & (n12[0]));
  n28[0] = (1 & (n12[0] >> 4));
  n15[0] = (1 & (n12[0])) | (2 & (n12[0])) | (4 & (n12[0])) | (8 & (n12[0]));
  n14[0] = (1 & (n12[0] >> 4));
  { unsigned int tmp; (tmp = (unsigned int) n167[0] + (unsigned int) n169[0], n170[0] = 63 & (unsigned char) tmp); }
  n149[0] = 1 & ~n148[0];
  n119[0] = (1 & (n117[0])) | (2 & (n117[0])) | (4 & (n117[0])) | (8 & (n117[0])) | (16 & (n117[0])) | (32 & (n117[0])) | (64 & (n117[0])) | (128 & (n117[0]));
  n118[0] = (1 & (n117[1]));
  n104[0] = (1 & (n102[0])) | (2 & (n102[0])) | (4 & (n102[0]));
  n103[0] = (1 & (n102[0] >> 3));
  n90[0] = (1 & (n88[0])) | (2 & (n88[0])) | (4 & (n88[0]));
  n89[0] = (1 & (n88[0] >> 3));
  n76[0] = 1 & ~n75[0];
  n46[0] = (1 & (n44[0])) | (2 & (n44[0])) | (4 & (n44[0])) | (8 & (n44[0])) | (16 & (n44[0])) | (32 & (n44[0])) | (64 & (n44[0])) | (128 & (n44[0]));
  n45[0] = (1 & (n44[1]));
  n31[0] = (1 & (n29[0])) | (2 & (n29[0])) | (4 & (n29[0]));
  n30[0] = (1 & (n29[0] >> 3));
  n17[0] = (1 & (n15[0])) | (2 & (n15[0])) | (4 & (n15[0]));
  n16[0] = (1 & (n15[0] >> 3));
  { unsigned int tmp; (tmp = (unsigned int) n170[0] - (unsigned int) n535[0], n174[0] = 63 & (unsigned char) tmp); }
  n136[0] = n116[0] | n118[0];
  n121[0] = (1 & (n119[0])) | (2 & (n119[0])) | (4 & (n119[0])) | (8 & (n119[0])) | (16 & (n119[0])) | (32 & (n119[0])) | (64 & (n119[0]));
  n120[0] = (1 & (n119[0] >> 7));
  n111[0] = n101[0] | n103[0];
  n106[0] = (1 & (n104[0])) | (2 & (n104[0]));
  n105[0] = (1 & (n104[0] >> 2));
  n97[0] = n87[0] & n89[0];
  n92[0] = (1 & (n90[0])) | (2 & (n90[0]));
  n91[0] = (1 & (n90[0] >> 2));
  n63[0] = n43[0] | n45[0];
  n48[0] = (1 & (n46[0])) | (2 & (n46[0])) | (4 & (n46[0])) | (8 & (n46[0])) | (16 & (n46[0])) | (32 & (n46[0])) | (64 & (n46[0]));
  n47[0] = (1 & (n46[0] >> 7));
  n38[0] = n28[0] | n30[0];
  n33[0] = (1 & (n31[0])) | (2 & (n31[0]));
  n32[0] = (1 & (n31[0] >> 2));
  n24[0] = n14[0] & n16[0];
  n19[0] = (1 & (n17[0])) | (2 & (n17[0]));
  n18[0] = (1 & (n17[0] >> 2));
  { unsigned int tmp; (tmp = (unsigned int) n174[0] + (unsigned int) n181[0], n182[0] = 63 & (unsigned char) tmp); }
  n123[0] = (1 & (n121[0])) | (2 & (n121[0])) | (4 & (n121[0])) | (8 & (n121[0])) | (16 & (n121[0])) | (32 & (n121[0]));
  n122[0] = (1 & (n121[0] >> 6));
  n108[0] = (1 & (n106[0]));
  n107[0] = (1 & (n106[0] >> 1));
  n94[0] = (1 & (n92[0]));
  n93[0] = (1 & (n92[0] >> 1));
  n50[0] = (1 & (n48[0])) | (2 & (n48[0])) | (4 & (n48[0])) | (8 & (n48[0])) | (16 & (n48[0])) | (32 & (n48[0]));
  n49[0] = (1 & (n48[0] >> 6));
  n35[0] = (1 & (n33[0]));
  n34[0] = (1 & (n33[0] >> 1));
  n21[0] = (1 & (n19[0]));
  n20[0] = (1 & (n19[0] >> 1));
  n137[0] = n120[0] | n122[0];
  n125[0] = (1 & (n123[0])) | (2 & (n123[0])) | (4 & (n123[0])) | (8 & (n123[0])) | (16 & (n123[0]));
  n124[0] = (1 & (n123[0] >> 5));
  n112[0] = n105[0] | n107[0];
  n109[0] = (1 & (n108[0]));
  n98[0] = n91[0] & n93[0];
  n95[0] = (1 & (n94[0]));
  n64[0] = n47[0] | n49[0];
  n52[0] = (1 & (n50[0])) | (2 & (n50[0])) | (4 & (n50[0])) | (8 & (n50[0])) | (16 & (n50[0]));
  n51[0] = (1 & (n50[0] >> 5));
  n39[0] = n32[0] | n34[0];
  n36[0] = (1 & (n35[0]));
  n25[0] = n18[0] & n20[0];
  n22[0] = (1 & (n21[0]));
  n141[0] = n136[0] | n137[0];
  n127[0] = (1 & (n125[0])) | (2 & (n125[0])) | (4 & (n125[0])) | (8 & (n125[0]));
  n126[0] = (1 & (n125[0] >> 4));
  n113[0] = n111[0] | n112[0];
  n99[0] = n97[0] & n98[0];
  n68[0] = n63[0] | n64[0];
  n54[0] = (1 & (n52[0])) | (2 & (n52[0])) | (4 & (n52[0])) | (8 & (n52[0]));
  n53[0] = (1 & (n52[0] >> 4));
  n40[0] = n38[0] | n39[0];
  n26[0] = n24[0] & n25[0];
  n138[0] = n124[0] | n126[0];
  n129[0] = (1 & (n127[0])) | (2 & (n127[0])) | (4 & (n127[0]));
  n128[0] = (1 & (n127[0] >> 3));
  n114[0] = n113[0] | n109[0];
  n100[0] = n99[0] & n95[0];
  n65[0] = n51[0] | n53[0];
  n56[0] = (1 & (n54[0])) | (2 & (n54[0])) | (4 & (n54[0]));
  n55[0] = (1 & (n54[0] >> 3));
  n41[0] = n40[0] | n36[0];
  n27[0] = n26[0] & n22[0];
  n150[0] = n100[0] & n149[0];
  n147[0] = n100[0] & n146[0];
  n131[0] = (1 & (n129[0])) | (2 & (n129[0]));
  n130[0] = (1 & (n129[0] >> 2));
  n115[0] = 1 & ~n114[0];
  n77[0] = n27[0] & n76[0];
  n74[0] = n27[0] & n73[0];
  n58[0] = (1 & (n56[0])) | (2 & (n56[0]));
  n57[0] = (1 & (n56[0] >> 2));
  n42[0] = 1 & ~n41[0];
  n139[0] = n128[0] | n130[0];
  n133[0] = (1 & (n131[0]));
  n132[0] = (1 & (n131[0] >> 1));
  n66[0] = n55[0] | n57[0];
  n60[0] = (1 & (n58[0]));
  n59[0] = (1 & (n58[0] >> 1));
  n142[0] = n138[0] | n139[0];
  n134[0] = (1 & (n133[0]));
  n69[0] = n65[0] | n66[0];
  n61[0] = (1 & (n60[0]));
  n143[0] = n141[0] | n142[0];
  n140[0] = n132[0] | n134[0];
  n70[0] = n68[0] | n69[0];
  n67[0] = n59[0] | n61[0];
  n144[0] = n143[0] | n140[0];
  n71[0] = n70[0] | n67[0];
  n145[0] = 1 & ~n144[0];
  n72[0] = 1 & ~n71[0];
  n155[0] = 1 & ~n145[0];
  n154[0] = n115[0] & n145[0];
  n153[0] = n100[0] & n145[0];
  n151[0] = 1 & ~n145[0];
  n82[0] = 1 & ~n72[0];
  n81[0] = n42[0] & n72[0];
  n80[0] = n27[0] & n72[0];
  n78[0] = 1 & ~n72[0];
  n164[0] = n81[0] | n154[0];
  n163[0] = n80[0] | n153[0];
  n161[0] = n81[0] & n153[0];
  n160[0] = n80[0] & n154[0];
  n156[0] = n115[0] & n155[0];
  n152[0] = n150[0] & n151[0];
  n83[0] = n42[0] & n82[0];
  n79[0] = n77[0] & n78[0];
  n470[0] = 255 & (n163[0] << 1 | n164[0]);
  n177[0] = 1 & ~n156[0];
  n175[0] = 1 & ~n83[0];
  n162[0] = n160[0] | n161[0];
  n158[0] = n152[0] | n147[0];
  n157[0] = n79[0] | n74[0];
  n471[0] = 255 & (n162[0] << 2 | n470[0]);
  n178[0] = n10[0];
  n178[1] = 255 & (n177[0] << 2 | n10[1]);
  n176[0] = n7[0];
  n176[1] = 255 & (n175[0] << 2 | n7[1]);
  n159[0] = n157[0] | n158[0];
  n472[0] = 255 & (n159[0] << 3 | n471[0]);
  {
    unsigned int tmp;
    unsigned char a[3];
    unsigned char b[3];
    a[2] = 0;
    a[1] = n176[1];
    a[0] = n176[0];
    b[2] = 0;
    b[1] = n178[1];
    b[0] = n178[0];
    (tmp = ((unsigned int) a[2] * (unsigned int) b[0]) + ((unsigned int) a[1] * (unsigned int) b[1]) + ((unsigned int) a[0] * (unsigned int) b[2]) + (tmp = ((unsigned int) a[1] * (unsigned int) b[0]) + ((unsigned int) a[0] * (unsigned int) b[1]) + (tmp = ((unsigned int) a[0] * (unsigned int) b[0]), n179[0] = 255 & (unsigned char) tmp, tmp >> 8), n179[1] = 255 & (unsigned char) tmp, tmp >> 8), n179[2] = 63 & (unsigned char) tmp);
  }
  n507[0] = n472[0] == n506[0] ? 1 : 0;
  n505[0] = n472[0] == n504[0] ? 1 : 0;
  n503[0] = n472[0] == n502[0] ? 1 : 0;
  n501[0] = n472[0] == n500[0] ? 1 : 0;
  n499[0] = n472[0] == n498[0] ? 1 : 0;
  n497[0] = n472[0] == n496[0] ? 1 : 0;
  n495[0] = n472[0] == n494[0] ? 1 : 0;
  n493[0] = n472[0] == n492[0] ? 1 : 0;
  n491[0] = n472[0] == n490[0] ? 1 : 0;
  n489[0] = n472[0] == n488[0] ? 1 : 0;
  n487[0] = n472[0] == n486[0] ? 1 : 0;
  n485[0] = n472[0] == n484[0] ? 1 : 0;
  n483[0] = n472[0] == n482[0] ? 1 : 0;
  n481[0] = n472[0] == n480[0] ? 1 : 0;
  n479[0] = n472[0] == n478[0] ? 1 : 0;
  n185[0] = (1 & (n179[0])) | (2 & (n179[0])) | (4 & (n179[0])) | (8 & (n179[0])) | (16 & (n179[0])) | (32 & (n179[0])) | (64 & (n179[0])) | (128 & (n179[0]));
  n185[1] = (1 & (n179[1])) | (2 & (n179[1])) | (4 & (n179[1])) | (8 & (n179[1])) | (16 & (n179[1])) | (32 & (n179[1])) | (64 & (n179[1])) | (128 & (n179[1]));
  n185[2] = (1 & (n179[2])) | (2 & (n179[2])) | (4 & (n179[2])) | (8 & (n179[2])) | (16 & (n179[2]));
  n184[0] = (1 & (n179[0] >> 1)) | (2 & (n179[0] >> 1)) | (4 & (n179[0] >> 1)) | (8 & (n179[0] >> 1)) | (16 & (n179[0] >> 1)) | (32 & (n179[0] >> 1)) | (64 & (n179[0] >> 1)) | (128 & (n179[1] << 7));
  n184[1] = (1 & (n179[1] >> 1)) | (2 & (n179[1] >> 1)) | (4 & (n179[1] >> 1)) | (8 & (n179[1] >> 1)) | (16 & (n179[1] >> 1)) | (32 & (n179[1] >> 1)) | (64 & (n179[1] >> 1)) | (128 & (n179[2] << 7));
  n184[2] = (1 & (n179[2] >> 1)) | (2 & (n179[2] >> 1)) | (4 & (n179[2] >> 1)) | (8 & (n179[2] >> 1)) | (16 & (n179[2] >> 1));
  n180[0] = (1 & (n179[2] >> 5));
  if (n507[0]) {
    n508[0] = n474[0];
  }
  else {
    n508[0] = n473[0];
  }
  if (n180[0]) {
    n186[0] = n184[0];
    n186[1] = n184[1];
    n186[2] = n184[2];
  }
  else {
    n186[0] = n185[0];
    n186[1] = n185[1];
    n186[2] = n185[2];
  }
  if (n180[0]) {
    n183[0] = n182[0];
  }
  else {
    n183[0] = n174[0];
  }
  if (n505[0]) {
    n509[0] = n475[0];
  }
  else {
    n509[0] = n508[0];
  }
  n212[0] = (1 & (n186[0] >> 1)) | (2 & (n186[0] >> 1)) | (4 & (n186[0] >> 1)) | (8 & (n186[0] >> 1)) | (16 & (n186[0] >> 1)) | (32 & (n186[0] >> 1)) | (64 & (n186[0] >> 1)) | (128 & (n186[1] << 7));
  n212[1] = (1 & (n186[1] >> 1)) | (2 & (n186[1] >> 1)) | (4 & (n186[1] >> 1)) | (8 & (n186[1] >> 1)) | (16 & (n186[1] >> 1)) | (32 & (n186[1] >> 1)) | (64 & (n186[1] >> 1)) | (128 & (n186[2] << 7));
  n212[2] = (1 & (n186[2] >> 1)) | (2 & (n186[2] >> 1)) | (4 & (n186[2] >> 1)) | (8 & (n186[2] >> 1));
  n211[0] = (1 & (n186[0])) | (2 & (n186[0])) | (4 & (n186[0])) | (8 & (n186[0])) | (16 & (n186[0])) | (32 & (n186[0])) | (64 & (n186[0])) | (128 & (n186[0]));
  n211[1] = (1 & (n186[1])) | (2 & (n186[1])) | (4 & (n186[1])) | (8 & (n186[1])) | (16 & (n186[1])) | (32 & (n186[1])) | (64 & (n186[1])) | (128 & (n186[1]));
  n211[2] = (1 & (n186[2])) | (2 & (n186[2])) | (4 & (n186[2])) | (8 & (n186[2]));
  { unsigned int tmp; (tmp = (unsigned int) n183[0] - (unsigned int) n208[0], n209[0] = 63 & (unsigned char) tmp); }
  n189[0] = (1 & (n183[0])) | (2 & (n183[0])) | (4 & (n183[0])) | (8 & (n183[0])) | (16 & (n183[0]));
  n188[0] = (1 & (n183[0] >> 5));
  n187[0] = (1 & (n186[2] >> 4));
  if (n503[0]) {
    n510[0] = n475[0];
  }
  else {
    n510[0] = n509[0];
  }
  n191[0] = (1 & (n189[0])) | (2 & (n189[0])) | (4 & (n189[0])) | (8 & (n189[0]));
  n190[0] = (1 & (n189[0] >> 4));
  if (n501[0]) {
    n511[0] = n476[0];
  }
  else {
    n511[0] = n510[0];
  }
  n200[0] = n188[0] | n190[0];
  n193[0] = (1 & (n191[0])) | (2 & (n191[0])) | (4 & (n191[0]));
  n192[0] = (1 & (n191[0] >> 3));
  if (n499[0]) {
    n512[0] = n476[0];
  }
  else {
    n512[0] = n511[0];
  }
  n195[0] = (1 & (n193[0])) | (2 & (n193[0]));
  n194[0] = (1 & (n193[0] >> 2));
  if (n497[0]) {
    n513[0] = n476[0];
  }
  else {
    n513[0] = n512[0];
  }
  n201[0] = n192[0] | n194[0];
  n197[0] = (1 & (n195[0]));
  n196[0] = (1 & (n195[0] >> 1));
  if (n495[0]) {
    n514[0] = n476[0];
  }
  else {
    n514[0] = n513[0];
  }
  n203[0] = n200[0] | n201[0];
  n198[0] = (1 & (n197[0]));
  if (n493[0]) {
    n515[0] = n477[0];
  }
  else {
    n515[0] = n514[0];
  }
  n202[0] = n196[0] | n198[0];
  if (n491[0]) {
    n516[0] = n477[0];
  }
  else {
    n516[0] = n515[0];
  }
  n204[0] = n203[0] | n202[0];
  if (n489[0]) {
    n517[0] = n477[0];
  }
  else {
    n517[0] = n516[0];
  }
  n205[0] = 1 & ~n204[0];
  if (n487[0]) {
    n518[0] = n477[0];
  }
  else {
    n518[0] = n517[0];
  }
  n206[0] = n187[0] | n205[0];
  if (n485[0]) {
    n519[0] = n477[0];
  }
  else {
    n519[0] = n518[0];
  }
  n207[0] = 1 & ~n206[0];
  if (n483[0]) {
    n520[0] = n477[0];
  }
  else {
    n520[0] = n519[0];
  }
  if (n207[0]) {
    n213[0] = n211[0];
    n213[1] = n211[1];
    n213[2] = n211[2];
  }
  else {
    n213[0] = n212[0];
    n213[1] = n212[1];
    n213[2] = n212[2];
  }
  if (n207[0]) {
    n210[0] = n209[0];
  }
  else {
    n210[0] = n183[0];
  }
  if (n481[0]) {
    n521[0] = n477[0];
  }
  else {
    n521[0] = n520[0];
  }
  n239[0] = (1 & (n213[0] >> 1)) | (2 & (n213[0] >> 1)) | (4 & (n213[0] >> 1)) | (8 & (n213[0] >> 1)) | (16 & (n213[0] >> 1)) | (32 & (n213[0] >> 1)) | (64 & (n213[0] >> 1)) | (128 & (n213[1] << 7));
  n239[1] = (1 & (n213[1] >> 1)) | (2 & (n213[1] >> 1)) | (4 & (n213[1] >> 1)) | (8 & (n213[1] >> 1)) | (16 & (n213[1] >> 1)) | (32 & (n213[1] >> 1)) | (64 & (n213[1] >> 1)) | (128 & (n213[2] << 7));
  n239[2] = (1 & (n213[2] >> 1)) | (2 & (n213[2] >> 1)) | (4 & (n213[2] >> 1));
  n238[0] = (1 & (n213[0])) | (2 & (n213[0])) | (4 & (n213[0])) | (8 & (n213[0])) | (16 & (n213[0])) | (32 & (n213[0])) | (64 & (n213[0])) | (128 & (n213[0]));
  n238[1] = (1 & (n213[1])) | (2 & (n213[1])) | (4 & (n213[1])) | (8 & (n213[1])) | (16 & (n213[1])) | (32 & (n213[1])) | (64 & (n213[1])) | (128 & (n213[1]));
  n238[2] = (1 & (n213[2])) | (2 & (n213[2])) | (4 & (n213[2]));
  { unsigned int tmp; (tmp = (unsigned int) n210[0] - (unsigned int) n235[0], n236[0] = 63 & (unsigned char) tmp); }
  n216[0] = (1 & (n210[0])) | (2 & (n210[0])) | (4 & (n210[0])) | (8 & (n210[0])) | (16 & (n210[0]));
  n215[0] = (1 & (n210[0] >> 5));
  n214[0] = (1 & (n213[2] >> 3));
  if (n479[0]) {
    n522[0] = n477[0];
  }
  else {
    n522[0] = n521[0];
  }
  n218[0] = (1 & (n216[0])) | (2 & (n216[0])) | (4 & (n216[0])) | (8 & (n216[0]));
  n217[0] = (1 & (n216[0] >> 4));
  n524[0] = (1 & (n522[0]));
  n523[0] = (1 & (n522[0] >> 1)) | (2 & (n522[0] >> 1));
  n227[0] = n215[0] | n217[0];
  n220[0] = (1 & (n218[0])) | (2 & (n218[0])) | (4 & (n218[0]));
  n219[0] = (1 & (n218[0] >> 3));
  n528[0] = (1 & (n523[0]));
  n527[0] = (1 & (n523[0] >> 1));
  if (n524[0]) {
    n526[0] = n539[0];
    n526[1] = n539[1];
  }
  else {
    n526[0] = n537[0];
    n526[1] = n537[1];
  }
  n222[0] = (1 & (n220[0])) | (2 & (n220[0]));
  n221[0] = (1 & (n220[0] >> 2));
  n531[0] = (1 & (n527[0]));
  n228[0] = n219[0] | n221[0];
  n224[0] = (1 & (n222[0]));
  n223[0] = (1 & (n222[0] >> 1));
  n230[0] = n227[0] | n228[0];
  n225[0] = (1 & (n224[0]));
  n229[0] = n223[0] | n225[0];
  n231[0] = n230[0] | n229[0];
  n232[0] = 1 & ~n231[0];
  n233[0] = n214[0] | n232[0];
  n234[0] = 1 & ~n233[0];
  if (n234[0]) {
    n240[0] = n238[0];
    n240[1] = n238[1];
    n240[2] = n238[2];
  }
  else {
    n240[0] = n239[0];
    n240[1] = n239[1];
    n240[2] = n239[2];
  }
  if (n234[0]) {
    n237[0] = n236[0];
  }
  else {
    n237[0] = n210[0];
  }
  n266[0] = (1 & (n240[0] >> 1)) | (2 & (n240[0] >> 1)) | (4 & (n240[0] >> 1)) | (8 & (n240[0] >> 1)) | (16 & (n240[0] >> 1)) | (32 & (n240[0] >> 1)) | (64 & (n240[0] >> 1)) | (128 & (n240[1] << 7));
  n266[1] = (1 & (n240[1] >> 1)) | (2 & (n240[1] >> 1)) | (4 & (n240[1] >> 1)) | (8 & (n240[1] >> 1)) | (16 & (n240[1] >> 1)) | (32 & (n240[1] >> 1)) | (64 & (n240[1] >> 1)) | (128 & (n240[2] << 7));
  n266[2] = (1 & (n240[2] >> 1)) | (2 & (n240[2] >> 1));
  n265[0] = (1 & (n240[0])) | (2 & (n240[0])) | (4 & (n240[0])) | (8 & (n240[0])) | (16 & (n240[0])) | (32 & (n240[0])) | (64 & (n240[0])) | (128 & (n240[0]));
  n265[1] = (1 & (n240[1])) | (2 & (n240[1])) | (4 & (n240[1])) | (8 & (n240[1])) | (16 & (n240[1])) | (32 & (n240[1])) | (64 & (n240[1])) | (128 & (n240[1]));
  n265[2] = (1 & (n240[2])) | (2 & (n240[2]));
  { unsigned int tmp; (tmp = (unsigned int) n237[0] - (unsigned int) n262[0], n263[0] = 63 & (unsigned char) tmp); }
  n243[0] = (1 & (n237[0])) | (2 & (n237[0])) | (4 & (n237[0])) | (8 & (n237[0])) | (16 & (n237[0]));
  n242[0] = (1 & (n237[0] >> 5));
  n241[0] = (1 & (n240[2] >> 2));
  n245[0] = (1 & (n243[0])) | (2 & (n243[0])) | (4 & (n243[0])) | (8 & (n243[0]));
  n244[0] = (1 & (n243[0] >> 4));
  n254[0] = n242[0] | n244[0];
  n247[0] = (1 & (n245[0])) | (2 & (n245[0])) | (4 & (n245[0]));
  n246[0] = (1 & (n245[0] >> 3));
  n249[0] = (1 & (n247[0])) | (2 & (n247[0]));
  n248[0] = (1 & (n247[0] >> 2));
  n255[0] = n246[0] | n248[0];
  n251[0] = (1 & (n249[0]));
  n250[0] = (1 & (n249[0] >> 1));
  n257[0] = n254[0] | n255[0];
  n252[0] = (1 & (n251[0]));
  n256[0] = n250[0] | n252[0];
  n258[0] = n257[0] | n256[0];
  n259[0] = 1 & ~n258[0];
  n260[0] = n241[0] | n259[0];
  n261[0] = 1 & ~n260[0];
  if (n261[0]) {
    n267[0] = n265[0];
    n267[1] = n265[1];
    n267[2] = n265[2];
  }
  else {
    n267[0] = n266[0];
    n267[1] = n266[1];
    n267[2] = n266[2];
  }
  if (n261[0]) {
    n264[0] = n263[0];
  }
  else {
    n264[0] = n237[0];
  }
  n293[0] = (1 & (n267[0] >> 1)) | (2 & (n267[0] >> 1)) | (4 & (n267[0] >> 1)) | (8 & (n267[0] >> 1)) | (16 & (n267[0] >> 1)) | (32 & (n267[0] >> 1)) | (64 & (n267[0] >> 1)) | (128 & (n267[1] << 7));
  n293[1] = (1 & (n267[1] >> 1)) | (2 & (n267[1] >> 1)) | (4 & (n267[1] >> 1)) | (8 & (n267[1] >> 1)) | (16 & (n267[1] >> 1)) | (32 & (n267[1] >> 1)) | (64 & (n267[1] >> 1)) | (128 & (n267[2] << 7));
  n293[2] = (1 & (n267[2] >> 1));
  n292[0] = (1 & (n267[0])) | (2 & (n267[0])) | (4 & (n267[0])) | (8 & (n267[0])) | (16 & (n267[0])) | (32 & (n267[0])) | (64 & (n267[0])) | (128 & (n267[0]));
  n292[1] = (1 & (n267[1])) | (2 & (n267[1])) | (4 & (n267[1])) | (8 & (n267[1])) | (16 & (n267[1])) | (32 & (n267[1])) | (64 & (n267[1])) | (128 & (n267[1]));
  n292[2] = (1 & (n267[2]));
  { unsigned int tmp; (tmp = (unsigned int) n264[0] - (unsigned int) n289[0], n290[0] = 63 & (unsigned char) tmp); }
  n270[0] = (1 & (n264[0])) | (2 & (n264[0])) | (4 & (n264[0])) | (8 & (n264[0])) | (16 & (n264[0]));
  n269[0] = (1 & (n264[0] >> 5));
  n268[0] = (1 & (n267[2] >> 1));
  n272[0] = (1 & (n270[0])) | (2 & (n270[0])) | (4 & (n270[0])) | (8 & (n270[0]));
  n271[0] = (1 & (n270[0] >> 4));
  n281[0] = n269[0] | n271[0];
  n274[0] = (1 & (n272[0])) | (2 & (n272[0])) | (4 & (n272[0]));
  n273[0] = (1 & (n272[0] >> 3));
  n276[0] = (1 & (n274[0])) | (2 & (n274[0]));
  n275[0] = (1 & (n274[0] >> 2));
  n282[0] = n273[0] | n275[0];
  n278[0] = (1 & (n276[0]));
  n277[0] = (1 & (n276[0] >> 1));
  n284[0] = n281[0] | n282[0];
  n279[0] = (1 & (n278[0]));
  n283[0] = n277[0] | n279[0];
  n285[0] = n284[0] | n283[0];
  n286[0] = 1 & ~n285[0];
  n287[0] = n268[0] | n286[0];
  n288[0] = 1 & ~n287[0];
  if (n288[0]) {
    n294[0] = n292[0];
    n294[1] = n292[1];
    n294[2] = n292[2];
  }
  else {
    n294[0] = n293[0];
    n294[1] = n293[1];
    n294[2] = n293[2];
  }
  if (n288[0]) {
    n291[0] = n290[0];
  }
  else {
    n291[0] = n264[0];
  }
  n320[0] = (1 & (n294[0] >> 1)) | (2 & (n294[0] >> 1)) | (4 & (n294[0] >> 1)) | (8 & (n294[0] >> 1)) | (16 & (n294[0] >> 1)) | (32 & (n294[0] >> 1)) | (64 & (n294[0] >> 1)) | (128 & (n294[1] << 7));
  n320[1] = (1 & (n294[1] >> 1)) | (2 & (n294[1] >> 1)) | (4 & (n294[1] >> 1)) | (8 & (n294[1] >> 1)) | (16 & (n294[1] >> 1)) | (32 & (n294[1] >> 1)) | (64 & (n294[1] >> 1)) | (128 & (n294[2] << 7));
  n319[0] = (1 & (n294[0])) | (2 & (n294[0])) | (4 & (n294[0])) | (8 & (n294[0])) | (16 & (n294[0])) | (32 & (n294[0])) | (64 & (n294[0])) | (128 & (n294[0]));
  n319[1] = (1 & (n294[1])) | (2 & (n294[1])) | (4 & (n294[1])) | (8 & (n294[1])) | (16 & (n294[1])) | (32 & (n294[1])) | (64 & (n294[1])) | (128 & (n294[1]));
  { unsigned int tmp; (tmp = (unsigned int) n291[0] - (unsigned int) n316[0], n317[0] = 63 & (unsigned char) tmp); }
  n297[0] = (1 & (n291[0])) | (2 & (n291[0])) | (4 & (n291[0])) | (8 & (n291[0])) | (16 & (n291[0]));
  n296[0] = (1 & (n291[0] >> 5));
  n295[0] = (1 & (n294[2]));
  n299[0] = (1 & (n297[0])) | (2 & (n297[0])) | (4 & (n297[0])) | (8 & (n297[0]));
  n298[0] = (1 & (n297[0] >> 4));
  n308[0] = n296[0] | n298[0];
  n301[0] = (1 & (n299[0])) | (2 & (n299[0])) | (4 & (n299[0]));
  n300[0] = (1 & (n299[0] >> 3));
  n303[0] = (1 & (n301[0])) | (2 & (n301[0]));
  n302[0] = (1 & (n301[0] >> 2));
  n309[0] = n300[0] | n302[0];
  n305[0] = (1 & (n303[0]));
  n304[0] = (1 & (n303[0] >> 1));
  n311[0] = n308[0] | n309[0];
  n306[0] = (1 & (n305[0]));
  n310[0] = n304[0] | n306[0];
  n312[0] = n311[0] | n310[0];
  n313[0] = 1 & ~n312[0];
  n314[0] = n295[0] | n313[0];
  n315[0] = 1 & ~n314[0];
  if (n315[0]) {
    n321[0] = n319[0];
    n321[1] = n319[1];
  }
  else {
    n321[0] = n320[0];
    n321[1] = n320[1];
  }
  if (n315[0]) {
    n318[0] = n317[0];
  }
  else {
    n318[0] = n291[0];
  }
  n347[0] = (1 & (n321[0] >> 1)) | (2 & (n321[0] >> 1)) | (4 & (n321[0] >> 1)) | (8 & (n321[0] >> 1)) | (16 & (n321[0] >> 1)) | (32 & (n321[0] >> 1)) | (64 & (n321[0] >> 1)) | (128 & (n321[1] << 7));
  n347[1] = (1 & (n321[1] >> 1)) | (2 & (n321[1] >> 1)) | (4 & (n321[1] >> 1)) | (8 & (n321[1] >> 1)) | (16 & (n321[1] >> 1)) | (32 & (n321[1] >> 1)) | (64 & (n321[1] >> 1));
  n346[0] = (1 & (n321[0])) | (2 & (n321[0])) | (4 & (n321[0])) | (8 & (n321[0])) | (16 & (n321[0])) | (32 & (n321[0])) | (64 & (n321[0])) | (128 & (n321[0]));
  n346[1] = (1 & (n321[1])) | (2 & (n321[1])) | (4 & (n321[1])) | (8 & (n321[1])) | (16 & (n321[1])) | (32 & (n321[1])) | (64 & (n321[1]));
  { unsigned int tmp; (tmp = (unsigned int) n318[0] - (unsigned int) n343[0], n344[0] = 63 & (unsigned char) tmp); }
  n324[0] = (1 & (n318[0])) | (2 & (n318[0])) | (4 & (n318[0])) | (8 & (n318[0])) | (16 & (n318[0]));
  n323[0] = (1 & (n318[0] >> 5));
  n322[0] = (1 & (n321[1] >> 7));
  n326[0] = (1 & (n324[0])) | (2 & (n324[0])) | (4 & (n324[0])) | (8 & (n324[0]));
  n325[0] = (1 & (n324[0] >> 4));
  n335[0] = n323[0] | n325[0];
  n328[0] = (1 & (n326[0])) | (2 & (n326[0])) | (4 & (n326[0]));
  n327[0] = (1 & (n326[0] >> 3));
  n330[0] = (1 & (n328[0])) | (2 & (n328[0]));
  n329[0] = (1 & (n328[0] >> 2));
  n336[0] = n327[0] | n329[0];
  n332[0] = (1 & (n330[0]));
  n331[0] = (1 & (n330[0] >> 1));
  n338[0] = n335[0] | n336[0];
  n333[0] = (1 & (n332[0]));
  n337[0] = n331[0] | n333[0];
  n339[0] = n338[0] | n337[0];
  n340[0] = 1 & ~n339[0];
  n341[0] = n322[0] | n340[0];
  n342[0] = 1 & ~n341[0];
  if (n342[0]) {
    n348[0] = n346[0];
    n348[1] = n346[1];
  }
  else {
    n348[0] = n347[0];
    n348[1] = n347[1];
  }
  if (n342[0]) {
    n345[0] = n344[0];
  }
  else {
    n345[0] = n318[0];
  }
  n374[0] = (1 & (n348[0] >> 1)) | (2 & (n348[0] >> 1)) | (4 & (n348[0] >> 1)) | (8 & (n348[0] >> 1)) | (16 & (n348[0] >> 1)) | (32 & (n348[0] >> 1)) | (64 & (n348[0] >> 1)) | (128 & (n348[1] << 7));
  n374[1] = (1 & (n348[1] >> 1)) | (2 & (n348[1] >> 1)) | (4 & (n348[1] >> 1)) | (8 & (n348[1] >> 1)) | (16 & (n348[1] >> 1)) | (32 & (n348[1] >> 1));
  n373[0] = (1 & (n348[0])) | (2 & (n348[0])) | (4 & (n348[0])) | (8 & (n348[0])) | (16 & (n348[0])) | (32 & (n348[0])) | (64 & (n348[0])) | (128 & (n348[0]));
  n373[1] = (1 & (n348[1])) | (2 & (n348[1])) | (4 & (n348[1])) | (8 & (n348[1])) | (16 & (n348[1])) | (32 & (n348[1]));
  { unsigned int tmp; (tmp = (unsigned int) n345[0] - (unsigned int) n370[0], n371[0] = 63 & (unsigned char) tmp); }
  n351[0] = (1 & (n345[0])) | (2 & (n345[0])) | (4 & (n345[0])) | (8 & (n345[0])) | (16 & (n345[0]));
  n350[0] = (1 & (n345[0] >> 5));
  n349[0] = (1 & (n348[1] >> 6));
  n353[0] = (1 & (n351[0])) | (2 & (n351[0])) | (4 & (n351[0])) | (8 & (n351[0]));
  n352[0] = (1 & (n351[0] >> 4));
  n362[0] = n350[0] | n352[0];
  n355[0] = (1 & (n353[0])) | (2 & (n353[0])) | (4 & (n353[0]));
  n354[0] = (1 & (n353[0] >> 3));
  n357[0] = (1 & (n355[0])) | (2 & (n355[0]));
  n356[0] = (1 & (n355[0] >> 2));
  n363[0] = n354[0] | n356[0];
  n359[0] = (1 & (n357[0]));
  n358[0] = (1 & (n357[0] >> 1));
  n365[0] = n362[0] | n363[0];
  n360[0] = (1 & (n359[0]));
  n364[0] = n358[0] | n360[0];
  n366[0] = n365[0] | n364[0];
  n367[0] = 1 & ~n366[0];
  n368[0] = n349[0] | n367[0];
  n369[0] = 1 & ~n368[0];
  if (n369[0]) {
    n375[0] = n373[0];
    n375[1] = n373[1];
  }
  else {
    n375[0] = n374[0];
    n375[1] = n374[1];
  }
  if (n369[0]) {
    n372[0] = n371[0];
  }
  else {
    n372[0] = n345[0];
  }
  n401[0] = (1 & (n375[0] >> 1)) | (2 & (n375[0] >> 1)) | (4 & (n375[0] >> 1)) | (8 & (n375[0] >> 1)) | (16 & (n375[0] >> 1)) | (32 & (n375[0] >> 1)) | (64 & (n375[0] >> 1)) | (128 & (n375[1] << 7));
  n401[1] = (1 & (n375[1] >> 1)) | (2 & (n375[1] >> 1)) | (4 & (n375[1] >> 1)) | (8 & (n375[1] >> 1)) | (16 & (n375[1] >> 1));
  n400[0] = (1 & (n375[0])) | (2 & (n375[0])) | (4 & (n375[0])) | (8 & (n375[0])) | (16 & (n375[0])) | (32 & (n375[0])) | (64 & (n375[0])) | (128 & (n375[0]));
  n400[1] = (1 & (n375[1])) | (2 & (n375[1])) | (4 & (n375[1])) | (8 & (n375[1])) | (16 & (n375[1]));
  { unsigned int tmp; (tmp = (unsigned int) n372[0] - (unsigned int) n397[0], n398[0] = 63 & (unsigned char) tmp); }
  n378[0] = (1 & (n372[0])) | (2 & (n372[0])) | (4 & (n372[0])) | (8 & (n372[0])) | (16 & (n372[0]));
  n377[0] = (1 & (n372[0] >> 5));
  n376[0] = (1 & (n375[1] >> 5));
  n380[0] = (1 & (n378[0])) | (2 & (n378[0])) | (4 & (n378[0])) | (8 & (n378[0]));
  n379[0] = (1 & (n378[0] >> 4));
  n389[0] = n377[0] | n379[0];
  n382[0] = (1 & (n380[0])) | (2 & (n380[0])) | (4 & (n380[0]));
  n381[0] = (1 & (n380[0] >> 3));
  n384[0] = (1 & (n382[0])) | (2 & (n382[0]));
  n383[0] = (1 & (n382[0] >> 2));
  n390[0] = n381[0] | n383[0];
  n386[0] = (1 & (n384[0]));
  n385[0] = (1 & (n384[0] >> 1));
  n392[0] = n389[0] | n390[0];
  n387[0] = (1 & (n386[0]));
  n391[0] = n385[0] | n387[0];
  n393[0] = n392[0] | n391[0];
  n394[0] = 1 & ~n393[0];
  n395[0] = n376[0] | n394[0];
  n396[0] = 1 & ~n395[0];
  if (n396[0]) {
    n402[0] = n400[0];
    n402[1] = n400[1];
  }
  else {
    n402[0] = n401[0];
    n402[1] = n401[1];
  }
  if (n396[0]) {
    n399[0] = n398[0];
  }
  else {
    n399[0] = n372[0];
  }
  n428[0] = (1 & (n402[0] >> 1)) | (2 & (n402[0] >> 1)) | (4 & (n402[0] >> 1)) | (8 & (n402[0] >> 1)) | (16 & (n402[0] >> 1)) | (32 & (n402[0] >> 1)) | (64 & (n402[0] >> 1)) | (128 & (n402[1] << 7));
  n428[1] = (1 & (n402[1] >> 1)) | (2 & (n402[1] >> 1)) | (4 & (n402[1] >> 1)) | (8 & (n402[1] >> 1));
  n427[0] = (1 & (n402[0])) | (2 & (n402[0])) | (4 & (n402[0])) | (8 & (n402[0])) | (16 & (n402[0])) | (32 & (n402[0])) | (64 & (n402[0])) | (128 & (n402[0]));
  n427[1] = (1 & (n402[1])) | (2 & (n402[1])) | (4 & (n402[1])) | (8 & (n402[1]));
  { unsigned int tmp; (tmp = (unsigned int) n399[0] - (unsigned int) n424[0], n425[0] = 63 & (unsigned char) tmp); }
  n405[0] = (1 & (n399[0])) | (2 & (n399[0])) | (4 & (n399[0])) | (8 & (n399[0])) | (16 & (n399[0]));
  n404[0] = (1 & (n399[0] >> 5));
  n403[0] = (1 & (n402[1] >> 4));
  n407[0] = (1 & (n405[0])) | (2 & (n405[0])) | (4 & (n405[0])) | (8 & (n405[0]));
  n406[0] = (1 & (n405[0] >> 4));
  n416[0] = n404[0] | n406[0];
  n409[0] = (1 & (n407[0])) | (2 & (n407[0])) | (4 & (n407[0]));
  n408[0] = (1 & (n407[0] >> 3));
  n411[0] = (1 & (n409[0])) | (2 & (n409[0]));
  n410[0] = (1 & (n409[0] >> 2));
  n417[0] = n408[0] | n410[0];
  n413[0] = (1 & (n411[0]));
  n412[0] = (1 & (n411[0] >> 1));
  n419[0] = n416[0] | n417[0];
  n414[0] = (1 & (n413[0]));
  n418[0] = n412[0] | n414[0];
  n420[0] = n419[0] | n418[0];
  n421[0] = 1 & ~n420[0];
  n422[0] = n403[0] | n421[0];
  n423[0] = 1 & ~n422[0];
  if (n423[0]) {
    n429[0] = n427[0];
    n429[1] = n427[1];
  }
  else {
    n429[0] = n428[0];
    n429[1] = n428[1];
  }
  if (n423[0]) {
    n426[0] = n425[0];
  }
  else {
    n426[0] = n399[0];
  }
  n455[0] = (1 & (n429[0] >> 1)) | (2 & (n429[0] >> 1)) | (4 & (n429[0] >> 1)) | (8 & (n429[0] >> 1)) | (16 & (n429[0] >> 1)) | (32 & (n429[0] >> 1)) | (64 & (n429[0] >> 1)) | (128 & (n429[1] << 7));
  n455[1] = (1 & (n429[1] >> 1)) | (2 & (n429[1] >> 1)) | (4 & (n429[1] >> 1));
  n454[0] = (1 & (n429[0])) | (2 & (n429[0])) | (4 & (n429[0])) | (8 & (n429[0])) | (16 & (n429[0])) | (32 & (n429[0])) | (64 & (n429[0])) | (128 & (n429[0]));
  n454[1] = (1 & (n429[1])) | (2 & (n429[1])) | (4 & (n429[1]));
  { unsigned int tmp; (tmp = (unsigned int) n426[0] - (unsigned int) n451[0], n452[0] = 63 & (unsigned char) tmp); }
  n432[0] = (1 & (n426[0])) | (2 & (n426[0])) | (4 & (n426[0])) | (8 & (n426[0])) | (16 & (n426[0]));
  n431[0] = (1 & (n426[0] >> 5));
  n430[0] = (1 & (n429[1] >> 3));
  n434[0] = (1 & (n432[0])) | (2 & (n432[0])) | (4 & (n432[0])) | (8 & (n432[0]));
  n433[0] = (1 & (n432[0] >> 4));
  n443[0] = n431[0] | n433[0];
  n436[0] = (1 & (n434[0])) | (2 & (n434[0])) | (4 & (n434[0]));
  n435[0] = (1 & (n434[0] >> 3));
  n438[0] = (1 & (n436[0])) | (2 & (n436[0]));
  n437[0] = (1 & (n436[0] >> 2));
  n444[0] = n435[0] | n437[0];
  n440[0] = (1 & (n438[0]));
  n439[0] = (1 & (n438[0] >> 1));
  n446[0] = n443[0] | n444[0];
  n441[0] = (1 & (n440[0]));
  n445[0] = n439[0] | n441[0];
  n447[0] = n446[0] | n445[0];
  n448[0] = 1 & ~n447[0];
  n449[0] = n430[0] | n448[0];
  n450[0] = 1 & ~n449[0];
  if (n450[0]) {
    n456[0] = n454[0];
    n456[1] = n454[1];
  }
  else {
    n456[0] = n455[0];
    n456[1] = n455[1];
  }
  if (n450[0]) {
    n453[0] = n452[0];
  }
  else {
    n453[0] = n426[0];
  }
  n458[0] = (1 & (n456[0])) | (2 & (n456[0])) | (4 & (n456[0])) | (8 & (n456[0])) | (16 & (n456[0])) | (32 & (n456[0])) | (64 & (n456[0])) | (128 & (n456[0]));
  n458[1] = (1 & (n456[1])) | (2 & (n456[1]));
  n457[0] = (1 & (n453[0])) | (2 & (n453[0])) | (4 & (n453[0])) | (8 & (n453[0])) | (16 & (n453[0]));
  n459[0] = n458[0];
  n459[1] = 255 & (n457[0] << 2 | n458[1]);
  if (n524[0]) {
    n525[0] = n460[0];
    n525[1] = n460[1];
  }
  else {
    n525[0] = n459[0];
    n525[1] = n459[1];
  }
  if (n528[0]) {
    n529[0] = n526[0];
    n529[1] = n526[1];
  }
  else {
    n529[0] = n525[0];
    n529[1] = n525[1];
  }
  if (n531[0]) {
    n532[0] = n541[0];
    n532[1] = n541[1];
  }
  else {
    n532[0] = n529[0];
    n532[1] = n529[1];
  }
  n533[0] = n532[0];
  n533[1] = 255 & (n165[0] << 7 | n532[1]);
  x_o[0] = n533[0];
  x_o[1] = n533[1];
}

void cf_fp_mul_c_5_10_init() {
  { int index; for (index = 2; index > 0;) n541[--index] = 0; }
  { int index; for (index = 2; index > 0;) n539[--index] = 0; }
  { int index; for (index = 2; index > 0;) n537[--index] = 0; }
  n535[0] = 0;
  n506[0] = 0;
  n504[0] = 0;
  n502[0] = 0;
  n500[0] = 0;
  n498[0] = 0;
  n496[0] = 0;
  n494[0] = 0;
  n492[0] = 0;
  n490[0] = 0;
  n488[0] = 0;
  n486[0] = 0;
  n484[0] = 0;
  n482[0] = 0;
  n480[0] = 0;
  n478[0] = 0;
  n477[0] = 0;
  n476[0] = 0;
  n475[0] = 0;
  n474[0] = 0;
  n473[0] = 0;
  { int index; for (index = 2; index > 0;) n460[--index] = 0; }
  n451[0] = 0;
  n424[0] = 0;
  n397[0] = 0;
  n370[0] = 0;
  n343[0] = 0;
  n316[0] = 0;
  n289[0] = 0;
  n262[0] = 0;
  n235[0] = 0;
  n208[0] = 0;
  n181[0] = 0;
  n168[0] = 0;
  n166[0] = 0;
  { int index; for (index = 2; index > 0;) n86[--index] = 0; }
  n85[0] = 0;
  { int index; for (index = 2; index > 0;) n13[--index] = 0; }
  n12[0] = 0;
  { int index; for (index = 2; index > 0;) n10[--index] = 0; }
  n9[0] = 0;
  n8[0] = 0;
  { int index; for (index = 2; index > 0;) n7[--index] = 0; }
  n6[0] = 0;
  n5[0] = 0;
  n169[0] = 0;
  n167[0] = 0;
  n165[0] = 0;
  n148[0] = 0;
  n146[0] = 0;
  { int index; for (index = 2; index > 0;) n117[--index] = 0; }
  n116[0] = 0;
  n102[0] = 0;
  n101[0] = 0;
  n88[0] = 0;
  n87[0] = 0;
  n75[0] = 0;
  n73[0] = 0;
  { int index; for (index = 2; index > 0;) n44[--index] = 0; }
  n43[0] = 0;
  n29[0] = 0;
  n28[0] = 0;
  n15[0] = 0;
  n14[0] = 0;
  n170[0] = 0;
  n149[0] = 0;
  n119[0] = 0;
  n118[0] = 0;
  n104[0] = 0;
  n103[0] = 0;
  n90[0] = 0;
  n89[0] = 0;
  n76[0] = 0;
  n46[0] = 0;
  n45[0] = 0;
  n31[0] = 0;
  n30[0] = 0;
  n17[0] = 0;
  n16[0] = 0;
  n174[0] = 0;
  n136[0] = 0;
  n121[0] = 0;
  n120[0] = 0;
  n111[0] = 0;
  n106[0] = 0;
  n105[0] = 0;
  n97[0] = 0;
  n92[0] = 0;
  n91[0] = 0;
  n63[0] = 0;
  n48[0] = 0;
  n47[0] = 0;
  n38[0] = 0;
  n33[0] = 0;
  n32[0] = 0;
  n24[0] = 0;
  n19[0] = 0;
  n18[0] = 0;
  n182[0] = 0;
  n123[0] = 0;
  n122[0] = 0;
  n108[0] = 0;
  n107[0] = 0;
  n94[0] = 0;
  n93[0] = 0;
  n50[0] = 0;
  n49[0] = 0;
  n35[0] = 0;
  n34[0] = 0;
  n21[0] = 0;
  n20[0] = 0;
  n137[0] = 0;
  n125[0] = 0;
  n124[0] = 0;
  n112[0] = 0;
  n109[0] = 0;
  n98[0] = 0;
  n95[0] = 0;
  n64[0] = 0;
  n52[0] = 0;
  n51[0] = 0;
  n39[0] = 0;
  n36[0] = 0;
  n25[0] = 0;
  n22[0] = 0;
  n141[0] = 0;
  n127[0] = 0;
  n126[0] = 0;
  n113[0] = 0;
  n99[0] = 0;
  n68[0] = 0;
  n54[0] = 0;
  n53[0] = 0;
  n40[0] = 0;
  n26[0] = 0;
  n138[0] = 0;
  n129[0] = 0;
  n128[0] = 0;
  n114[0] = 0;
  n100[0] = 0;
  n65[0] = 0;
  n56[0] = 0;
  n55[0] = 0;
  n41[0] = 0;
  n27[0] = 0;
  n150[0] = 0;
  n147[0] = 0;
  n131[0] = 0;
  n130[0] = 0;
  n115[0] = 0;
  n77[0] = 0;
  n74[0] = 0;
  n58[0] = 0;
  n57[0] = 0;
  n42[0] = 0;
  n139[0] = 0;
  n133[0] = 0;
  n132[0] = 0;
  n66[0] = 0;
  n60[0] = 0;
  n59[0] = 0;
  n142[0] = 0;
  n134[0] = 0;
  n69[0] = 0;
  n61[0] = 0;
  n143[0] = 0;
  n140[0] = 0;
  n70[0] = 0;
  n67[0] = 0;
  n144[0] = 0;
  n71[0] = 0;
  n145[0] = 0;
  n72[0] = 0;
  n155[0] = 0;
  n154[0] = 0;
  n153[0] = 0;
  n151[0] = 0;
  n82[0] = 0;
  n81[0] = 0;
  n80[0] = 0;
  n78[0] = 0;
  n164[0] = 0;
  n163[0] = 0;
  n161[0] = 0;
  n160[0] = 0;
  n156[0] = 0;
  n152[0] = 0;
  n83[0] = 0;
  n79[0] = 0;
  n470[0] = 0;
  n177[0] = 0;
  n175[0] = 0;
  n162[0] = 0;
  n158[0] = 0;
  n157[0] = 0;
  n471[0] = 0;
  { int index; for (index = 2; index > 0;) n178[--index] = 0; }
  { int index; for (index = 2; index > 0;) n176[--index] = 0; }
  n159[0] = 0;
  n472[0] = 0;
  { int index; for (index = 3; index > 0;) n179[--index] = 0; }
  n507[0] = 0;
  n505[0] = 0;
  n503[0] = 0;
  n501[0] = 0;
  n499[0] = 0;
  n497[0] = 0;
  n495[0] = 0;
  n493[0] = 0;
  n491[0] = 0;
  n489[0] = 0;
  n487[0] = 0;
  n485[0] = 0;
  n483[0] = 0;
  n481[0] = 0;
  n479[0] = 0;
  { int index; for (index = 3; index > 0;) n185[--index] = 0; }
  { int index; for (index = 3; index > 0;) n184[--index] = 0; }
  n180[0] = 0;
  n508[0] = 0;
  { int index; for (index = 3; index > 0;) n186[--index] = 0; }
  n183[0] = 0;
  n509[0] = 0;
  { int index; for (index = 3; index > 0;) n212[--index] = 0; }
  { int index; for (index = 3; index > 0;) n211[--index] = 0; }
  n209[0] = 0;
  n189[0] = 0;
  n188[0] = 0;
  n187[0] = 0;
  n510[0] = 0;
  n191[0] = 0;
  n190[0] = 0;
  n511[0] = 0;
  n200[0] = 0;
  n193[0] = 0;
  n192[0] = 0;
  n512[0] = 0;
  n195[0] = 0;
  n194[0] = 0;
  n513[0] = 0;
  n201[0] = 0;
  n197[0] = 0;
  n196[0] = 0;
  n514[0] = 0;
  n203[0] = 0;
  n198[0] = 0;
  n515[0] = 0;
  n202[0] = 0;
  n516[0] = 0;
  n204[0] = 0;
  n517[0] = 0;
  n205[0] = 0;
  n518[0] = 0;
  n206[0] = 0;
  n519[0] = 0;
  n207[0] = 0;
  n520[0] = 0;
  { int index; for (index = 3; index > 0;) n213[--index] = 0; }
  n210[0] = 0;
  n521[0] = 0;
  { int index; for (index = 3; index > 0;) n239[--index] = 0; }
  { int index; for (index = 3; index > 0;) n238[--index] = 0; }
  n236[0] = 0;
  n216[0] = 0;
  n215[0] = 0;
  n214[0] = 0;
  n522[0] = 0;
  n218[0] = 0;
  n217[0] = 0;
  n524[0] = 0;
  n523[0] = 0;
  n227[0] = 0;
  n220[0] = 0;
  n219[0] = 0;
  n528[0] = 0;
  n527[0] = 0;
  { int index; for (index = 2; index > 0;) n526[--index] = 0; }
  n222[0] = 0;
  n221[0] = 0;
  n531[0] = 0;
  n228[0] = 0;
  n224[0] = 0;
  n223[0] = 0;
  n230[0] = 0;
  n225[0] = 0;
  n229[0] = 0;
  n231[0] = 0;
  n232[0] = 0;
  n233[0] = 0;
  n234[0] = 0;
  { int index; for (index = 3; index > 0;) n240[--index] = 0; }
  n237[0] = 0;
  { int index; for (index = 3; index > 0;) n266[--index] = 0; }
  { int index; for (index = 3; index > 0;) n265[--index] = 0; }
  n263[0] = 0;
  n243[0] = 0;
  n242[0] = 0;
  n241[0] = 0;
  n245[0] = 0;
  n244[0] = 0;
  n254[0] = 0;
  n247[0] = 0;
  n246[0] = 0;
  n249[0] = 0;
  n248[0] = 0;
  n255[0] = 0;
  n251[0] = 0;
  n250[0] = 0;
  n257[0] = 0;
  n252[0] = 0;
  n256[0] = 0;
  n258[0] = 0;
  n259[0] = 0;
  n260[0] = 0;
  n261[0] = 0;
  { int index; for (index = 3; index > 0;) n267[--index] = 0; }
  n264[0] = 0;
  { int index; for (index = 3; index > 0;) n293[--index] = 0; }
  { int index; for (index = 3; index > 0;) n292[--index] = 0; }
  n290[0] = 0;
  n270[0] = 0;
  n269[0] = 0;
  n268[0] = 0;
  n272[0] = 0;
  n271[0] = 0;
  n281[0] = 0;
  n274[0] = 0;
  n273[0] = 0;
  n276[0] = 0;
  n275[0] = 0;
  n282[0] = 0;
  n278[0] = 0;
  n277[0] = 0;
  n284[0] = 0;
  n279[0] = 0;
  n283[0] = 0;
  n285[0] = 0;
  n286[0] = 0;
  n287[0] = 0;
  n288[0] = 0;
  { int index; for (index = 3; index > 0;) n294[--index] = 0; }
  n291[0] = 0;
  { int index; for (index = 2; index > 0;) n320[--index] = 0; }
  { int index; for (index = 2; index > 0;) n319[--index] = 0; }
  n317[0] = 0;
  n297[0] = 0;
  n296[0] = 0;
  n295[0] = 0;
  n299[0] = 0;
  n298[0] = 0;
  n308[0] = 0;
  n301[0] = 0;
  n300[0] = 0;
  n303[0] = 0;
  n302[0] = 0;
  n309[0] = 0;
  n305[0] = 0;
  n304[0] = 0;
  n311[0] = 0;
  n306[0] = 0;
  n310[0] = 0;
  n312[0] = 0;
  n313[0] = 0;
  n314[0] = 0;
  n315[0] = 0;
  { int index; for (index = 2; index > 0;) n321[--index] = 0; }
  n318[0] = 0;
  { int index; for (index = 2; index > 0;) n347[--index] = 0; }
  { int index; for (index = 2; index > 0;) n346[--index] = 0; }
  n344[0] = 0;
  n324[0] = 0;
  n323[0] = 0;
  n322[0] = 0;
  n326[0] = 0;
  n325[0] = 0;
  n335[0] = 0;
  n328[0] = 0;
  n327[0] = 0;
  n330[0] = 0;
  n329[0] = 0;
  n336[0] = 0;
  n332[0] = 0;
  n331[0] = 0;
  n338[0] = 0;
  n333[0] = 0;
  n337[0] = 0;
  n339[0] = 0;
  n340[0] = 0;
  n341[0] = 0;
  n342[0] = 0;
  { int index; for (index = 2; index > 0;) n348[--index] = 0; }
  n345[0] = 0;
  { int index; for (index = 2; index > 0;) n374[--index] = 0; }
  { int index; for (index = 2; index > 0;) n373[--index] = 0; }
  n371[0] = 0;
  n351[0] = 0;
  n350[0] = 0;
  n349[0] = 0;
  n353[0] = 0;
  n352[0] = 0;
  n362[0] = 0;
  n355[0] = 0;
  n354[0] = 0;
  n357[0] = 0;
  n356[0] = 0;
  n363[0] = 0;
  n359[0] = 0;
  n358[0] = 0;
  n365[0] = 0;
  n360[0] = 0;
  n364[0] = 0;
  n366[0] = 0;
  n367[0] = 0;
  n368[0] = 0;
  n369[0] = 0;
  { int index; for (index = 2; index > 0;) n375[--index] = 0; }
  n372[0] = 0;
  { int index; for (index = 2; index > 0;) n401[--index] = 0; }
  { int index; for (index = 2; index > 0;) n400[--index] = 0; }
  n398[0] = 0;
  n378[0] = 0;
  n377[0] = 0;
  n376[0] = 0;
  n380[0] = 0;
  n379[0] = 0;
  n389[0] = 0;
  n382[0] = 0;
  n381[0] = 0;
  n384[0] = 0;
  n383[0] = 0;
  n390[0] = 0;
  n386[0] = 0;
  n385[0] = 0;
  n392[0] = 0;
  n387[0] = 0;
  n391[0] = 0;
  n393[0] = 0;
  n394[0] = 0;
  n395[0] = 0;
  n396[0] = 0;
  { int index; for (index = 2; index > 0;) n402[--index] = 0; }
  n399[0] = 0;
  { int index; for (index = 2; index > 0;) n428[--index] = 0; }
  { int index; for (index = 2; index > 0;) n427[--index] = 0; }
  n425[0] = 0;
  n405[0] = 0;
  n404[0] = 0;
  n403[0] = 0;
  n407[0] = 0;
  n406[0] = 0;
  n416[0] = 0;
  n409[0] = 0;
  n408[0] = 0;
  n411[0] = 0;
  n410[0] = 0;
  n417[0] = 0;
  n413[0] = 0;
  n412[0] = 0;
  n419[0] = 0;
  n414[0] = 0;
  n418[0] = 0;
  n420[0] = 0;
  n421[0] = 0;
  n422[0] = 0;
  n423[0] = 0;
  { int index; for (index = 2; index > 0;) n429[--index] = 0; }
  n426[0] = 0;
  { int index; for (index = 2; index > 0;) n455[--index] = 0; }
  { int index; for (index = 2; index > 0;) n454[--index] = 0; }
  n452[0] = 0;
  n432[0] = 0;
  n431[0] = 0;
  n430[0] = 0;
  n434[0] = 0;
  n433[0] = 0;
  n443[0] = 0;
  n436[0] = 0;
  n435[0] = 0;
  n438[0] = 0;
  n437[0] = 0;
  n444[0] = 0;
  n440[0] = 0;
  n439[0] = 0;
  n446[0] = 0;
  n441[0] = 0;
  n445[0] = 0;
  n447[0] = 0;
  n448[0] = 0;
  n449[0] = 0;
  n450[0] = 0;
  { int index; for (index = 2; index > 0;) n456[--index] = 0; }
  n453[0] = 0;
  { int index; for (index = 2; index > 0;) n458[--index] = 0; }
  n457[0] = 0;
  { int index; for (index = 2; index > 0;) n459[--index] = 0; }
  { int index; for (index = 2; index > 0;) n525[--index] = 0; }
  { int index; for (index = 2; index > 0;) n529[--index] = 0; }
  { int index; for (index = 2; index > 0;) n532[--index] = 0; }
  { int index; for (index = 2; index > 0;) n533[--index] = 0; }
  cf_fp_mul_c_5_10_calc();
}

static FILE* sim_file;
static int sim_count;
static unsigned char sim_a_i[2];
static unsigned char sim_b_i[2];
static unsigned char sim_x_o[2];

void cf_fp_mul_c_5_10_sim_init(const char* file) {
  time_t date = time(NULL);
  sim_count = 1;
  cf_fp_mul_c_5_10_init();
  sim_a_i[0] = a_i[0];
  sim_a_i[1] = a_i[1];
  sim_b_i[0] = b_i[0];
  sim_b_i[1] = b_i[1];
  sim_x_o[0] = x_o[0];
  sim_x_o[1] = x_o[1];
  sim_file = fopen(file, "w");
  fprintf(sim_file,
    "$date\n  %s$end\n"
    "$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n"
    "$timescale\n  1 ns\n$end\n"
    "$scope module cf_fp_mul_c_5_10 $end\n"
    "$var wire 16 ! a_i $end\n"
    "$var wire 16 \" b_i $end\n"
    "$var wire 16 # x_o $end\n"
    "$upscope $end\n"
    "$enddefinitions $end\n"
    "#0\n"
    "$dumpvars\n", asctime(localtime(&date)));
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 1; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
        else if (bit & a_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " !\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 1; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
        else if (bit & b_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " \"\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 1; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
        else if (bit & x_o[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " #\n");
  }
  fprintf(sim_file, "$end\n");
}

void cf_fp_mul_c_5_10_sim_end() {
  fprintf(sim_file, "#%d\n", sim_count);
  fclose(sim_file);
}

void cf_fp_mul_c_5_10_sim_sample() {
  int changed = 0;
  if (sim_a_i[1] != a_i[1] || sim_a_i[0] != a_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 1; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
          else if (bit & a_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " !\n");
    }
    sim_a_i[0] = a_i[0];
    sim_a_i[1] = a_i[1];
  }
  if (sim_b_i[1] != b_i[1] || sim_b_i[0] != b_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 1; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
          else if (bit & b_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " \"\n");
    }
    sim_b_i[0] = b_i[0];
    sim_b_i[1] = b_i[1];
  }
  if (sim_x_o[1] != x_o[1] || sim_x_o[0] != x_o[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 1; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
          else if (bit & x_o[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " #\n");
    }
    sim_x_o[0] = x_o[0];
    sim_x_o[1] = x_o[1];
  }
  sim_count++;
}

