#
#  Copyright (c) 2003 Launchbird Design Systems, Inc.
#  All rights reserved.
#  
#  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#  
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#  
#  
#  Overview:
#  
#    Performs floating point multiply.
#  
#  Interface:
#  
#  
#  
#    Inputs:
#      a_i : Left operand.
#      b_i : Right operand.
#  
#    Outputs:
#      x_o : Result.
#  
#  Built In Parameters:
#  
#    Exponent Precision = 5
#    Mantissa Precision = 10
#    Total    Precision = 16
#  
#  
#  
#  
#  
#  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
#  
#  Build Date : Fri Aug 22 09:47:02 CDT 2003
#  
#  Interface
#  
#    Build Name    : cf_fp_mul_c_5_10
#    Clock Domains : 
#    Vector Input  : a_i(16)
#    Vector Input  : b_i(16)
#    Vector Output : x_o(16)
#  
#  
#  

import sys
import time

class cf_fp_mul_c_5_10:

  def init(self):
    self.n541 = 0L
    self.n539 = 0L
    self.n537 = 0L
    self.n535 = 0L
    self.n506 = 0L
    self.n504 = 0L
    self.n502 = 0L
    self.n500 = 0L
    self.n498 = 0L
    self.n496 = 0L
    self.n494 = 0L
    self.n492 = 0L
    self.n490 = 0L
    self.n488 = 0L
    self.n486 = 0L
    self.n484 = 0L
    self.n482 = 0L
    self.n480 = 0L
    self.n478 = 0L
    self.n477 = 0L
    self.n476 = 0L
    self.n475 = 0L
    self.n474 = 0L
    self.n473 = 0L
    self.n460 = 0L
    self.n451 = 0L
    self.n424 = 0L
    self.n397 = 0L
    self.n370 = 0L
    self.n343 = 0L
    self.n316 = 0L
    self.n289 = 0L
    self.n262 = 0L
    self.n235 = 0L
    self.n208 = 0L
    self.n181 = 0L
    self.n168 = 0L
    self.n166 = 0L
    self.n4 = 0L
    self.n3 = 0L
    self.n86 = 0L
    self.n85 = 0L
    self.n13 = 0L
    self.n12 = 0L
    self.n10 = 0L
    self.n9 = 0L
    self.n8 = 0L
    self.n7 = 0L
    self.n6 = 0L
    self.n5 = 0L
    self.n169 = 0L
    self.n167 = 0L
    self.n165 = 0L
    self.n148 = 0L
    self.n146 = 0L
    self.n117 = 0L
    self.n116 = 0L
    self.n102 = 0L
    self.n101 = 0L
    self.n88 = 0L
    self.n87 = 0L
    self.n75 = 0L
    self.n73 = 0L
    self.n44 = 0L
    self.n43 = 0L
    self.n29 = 0L
    self.n28 = 0L
    self.n15 = 0L
    self.n14 = 0L
    self.n170 = 0L
    self.n149 = 0L
    self.n119 = 0L
    self.n118 = 0L
    self.n104 = 0L
    self.n103 = 0L
    self.n90 = 0L
    self.n89 = 0L
    self.n76 = 0L
    self.n46 = 0L
    self.n45 = 0L
    self.n31 = 0L
    self.n30 = 0L
    self.n17 = 0L
    self.n16 = 0L
    self.n174 = 0L
    self.n136 = 0L
    self.n121 = 0L
    self.n120 = 0L
    self.n111 = 0L
    self.n106 = 0L
    self.n105 = 0L
    self.n97 = 0L
    self.n92 = 0L
    self.n91 = 0L
    self.n63 = 0L
    self.n48 = 0L
    self.n47 = 0L
    self.n38 = 0L
    self.n33 = 0L
    self.n32 = 0L
    self.n24 = 0L
    self.n19 = 0L
    self.n18 = 0L
    self.n182 = 0L
    self.n123 = 0L
    self.n122 = 0L
    self.n108 = 0L
    self.n107 = 0L
    self.n94 = 0L
    self.n93 = 0L
    self.n50 = 0L
    self.n49 = 0L
    self.n35 = 0L
    self.n34 = 0L
    self.n21 = 0L
    self.n20 = 0L
    self.n137 = 0L
    self.n125 = 0L
    self.n124 = 0L
    self.n112 = 0L
    self.n109 = 0L
    self.n98 = 0L
    self.n95 = 0L
    self.n64 = 0L
    self.n52 = 0L
    self.n51 = 0L
    self.n39 = 0L
    self.n36 = 0L
    self.n25 = 0L
    self.n22 = 0L
    self.n141 = 0L
    self.n127 = 0L
    self.n126 = 0L
    self.n113 = 0L
    self.n99 = 0L
    self.n68 = 0L
    self.n54 = 0L
    self.n53 = 0L
    self.n40 = 0L
    self.n26 = 0L
    self.n138 = 0L
    self.n129 = 0L
    self.n128 = 0L
    self.n114 = 0L
    self.n100 = 0L
    self.n65 = 0L
    self.n56 = 0L
    self.n55 = 0L
    self.n41 = 0L
    self.n27 = 0L
    self.n150 = 0L
    self.n147 = 0L
    self.n131 = 0L
    self.n130 = 0L
    self.n115 = 0L
    self.n77 = 0L
    self.n74 = 0L
    self.n58 = 0L
    self.n57 = 0L
    self.n42 = 0L
    self.n139 = 0L
    self.n133 = 0L
    self.n132 = 0L
    self.n66 = 0L
    self.n60 = 0L
    self.n59 = 0L
    self.n142 = 0L
    self.n134 = 0L
    self.n69 = 0L
    self.n61 = 0L
    self.n143 = 0L
    self.n140 = 0L
    self.n70 = 0L
    self.n67 = 0L
    self.n144 = 0L
    self.n71 = 0L
    self.n145 = 0L
    self.n72 = 0L
    self.n155 = 0L
    self.n154 = 0L
    self.n153 = 0L
    self.n151 = 0L
    self.n82 = 0L
    self.n81 = 0L
    self.n80 = 0L
    self.n78 = 0L
    self.n164 = 0L
    self.n163 = 0L
    self.n161 = 0L
    self.n160 = 0L
    self.n156 = 0L
    self.n152 = 0L
    self.n83 = 0L
    self.n79 = 0L
    self.n470 = 0L
    self.n177 = 0L
    self.n175 = 0L
    self.n162 = 0L
    self.n158 = 0L
    self.n157 = 0L
    self.n471 = 0L
    self.n178 = 0L
    self.n176 = 0L
    self.n159 = 0L
    self.n472 = 0L
    self.n179 = 0L
    self.n507 = 0L
    self.n505 = 0L
    self.n503 = 0L
    self.n501 = 0L
    self.n499 = 0L
    self.n497 = 0L
    self.n495 = 0L
    self.n493 = 0L
    self.n491 = 0L
    self.n489 = 0L
    self.n487 = 0L
    self.n485 = 0L
    self.n483 = 0L
    self.n481 = 0L
    self.n479 = 0L
    self.n185 = 0L
    self.n184 = 0L
    self.n180 = 0L
    self.n508 = 0L
    self.n186 = 0L
    self.n183 = 0L
    self.n509 = 0L
    self.n212 = 0L
    self.n211 = 0L
    self.n209 = 0L
    self.n189 = 0L
    self.n188 = 0L
    self.n187 = 0L
    self.n510 = 0L
    self.n191 = 0L
    self.n190 = 0L
    self.n511 = 0L
    self.n200 = 0L
    self.n193 = 0L
    self.n192 = 0L
    self.n512 = 0L
    self.n195 = 0L
    self.n194 = 0L
    self.n513 = 0L
    self.n201 = 0L
    self.n197 = 0L
    self.n196 = 0L
    self.n514 = 0L
    self.n203 = 0L
    self.n198 = 0L
    self.n515 = 0L
    self.n202 = 0L
    self.n516 = 0L
    self.n204 = 0L
    self.n517 = 0L
    self.n205 = 0L
    self.n518 = 0L
    self.n206 = 0L
    self.n519 = 0L
    self.n207 = 0L
    self.n520 = 0L
    self.n213 = 0L
    self.n210 = 0L
    self.n521 = 0L
    self.n239 = 0L
    self.n238 = 0L
    self.n236 = 0L
    self.n216 = 0L
    self.n215 = 0L
    self.n214 = 0L
    self.n522 = 0L
    self.n218 = 0L
    self.n217 = 0L
    self.n524 = 0L
    self.n523 = 0L
    self.n227 = 0L
    self.n220 = 0L
    self.n219 = 0L
    self.n528 = 0L
    self.n527 = 0L
    self.n526 = 0L
    self.n222 = 0L
    self.n221 = 0L
    self.n531 = 0L
    self.n228 = 0L
    self.n224 = 0L
    self.n223 = 0L
    self.n230 = 0L
    self.n225 = 0L
    self.n229 = 0L
    self.n231 = 0L
    self.n232 = 0L
    self.n233 = 0L
    self.n234 = 0L
    self.n240 = 0L
    self.n237 = 0L
    self.n266 = 0L
    self.n265 = 0L
    self.n263 = 0L
    self.n243 = 0L
    self.n242 = 0L
    self.n241 = 0L
    self.n245 = 0L
    self.n244 = 0L
    self.n254 = 0L
    self.n247 = 0L
    self.n246 = 0L
    self.n249 = 0L
    self.n248 = 0L
    self.n255 = 0L
    self.n251 = 0L
    self.n250 = 0L
    self.n257 = 0L
    self.n252 = 0L
    self.n256 = 0L
    self.n258 = 0L
    self.n259 = 0L
    self.n260 = 0L
    self.n261 = 0L
    self.n267 = 0L
    self.n264 = 0L
    self.n293 = 0L
    self.n292 = 0L
    self.n290 = 0L
    self.n270 = 0L
    self.n269 = 0L
    self.n268 = 0L
    self.n272 = 0L
    self.n271 = 0L
    self.n281 = 0L
    self.n274 = 0L
    self.n273 = 0L
    self.n276 = 0L
    self.n275 = 0L
    self.n282 = 0L
    self.n278 = 0L
    self.n277 = 0L
    self.n284 = 0L
    self.n279 = 0L
    self.n283 = 0L
    self.n285 = 0L
    self.n286 = 0L
    self.n287 = 0L
    self.n288 = 0L
    self.n294 = 0L
    self.n291 = 0L
    self.n320 = 0L
    self.n319 = 0L
    self.n317 = 0L
    self.n297 = 0L
    self.n296 = 0L
    self.n295 = 0L
    self.n299 = 0L
    self.n298 = 0L
    self.n308 = 0L
    self.n301 = 0L
    self.n300 = 0L
    self.n303 = 0L
    self.n302 = 0L
    self.n309 = 0L
    self.n305 = 0L
    self.n304 = 0L
    self.n311 = 0L
    self.n306 = 0L
    self.n310 = 0L
    self.n312 = 0L
    self.n313 = 0L
    self.n314 = 0L
    self.n315 = 0L
    self.n321 = 0L
    self.n318 = 0L
    self.n347 = 0L
    self.n346 = 0L
    self.n344 = 0L
    self.n324 = 0L
    self.n323 = 0L
    self.n322 = 0L
    self.n326 = 0L
    self.n325 = 0L
    self.n335 = 0L
    self.n328 = 0L
    self.n327 = 0L
    self.n330 = 0L
    self.n329 = 0L
    self.n336 = 0L
    self.n332 = 0L
    self.n331 = 0L
    self.n338 = 0L
    self.n333 = 0L
    self.n337 = 0L
    self.n339 = 0L
    self.n340 = 0L
    self.n341 = 0L
    self.n342 = 0L
    self.n348 = 0L
    self.n345 = 0L
    self.n374 = 0L
    self.n373 = 0L
    self.n371 = 0L
    self.n351 = 0L
    self.n350 = 0L
    self.n349 = 0L
    self.n353 = 0L
    self.n352 = 0L
    self.n362 = 0L
    self.n355 = 0L
    self.n354 = 0L
    self.n357 = 0L
    self.n356 = 0L
    self.n363 = 0L
    self.n359 = 0L
    self.n358 = 0L
    self.n365 = 0L
    self.n360 = 0L
    self.n364 = 0L
    self.n366 = 0L
    self.n367 = 0L
    self.n368 = 0L
    self.n369 = 0L
    self.n375 = 0L
    self.n372 = 0L
    self.n401 = 0L
    self.n400 = 0L
    self.n398 = 0L
    self.n378 = 0L
    self.n377 = 0L
    self.n376 = 0L
    self.n380 = 0L
    self.n379 = 0L
    self.n389 = 0L
    self.n382 = 0L
    self.n381 = 0L
    self.n384 = 0L
    self.n383 = 0L
    self.n390 = 0L
    self.n386 = 0L
    self.n385 = 0L
    self.n392 = 0L
    self.n387 = 0L
    self.n391 = 0L
    self.n393 = 0L
    self.n394 = 0L
    self.n395 = 0L
    self.n396 = 0L
    self.n402 = 0L
    self.n399 = 0L
    self.n428 = 0L
    self.n427 = 0L
    self.n425 = 0L
    self.n405 = 0L
    self.n404 = 0L
    self.n403 = 0L
    self.n407 = 0L
    self.n406 = 0L
    self.n416 = 0L
    self.n409 = 0L
    self.n408 = 0L
    self.n411 = 0L
    self.n410 = 0L
    self.n417 = 0L
    self.n413 = 0L
    self.n412 = 0L
    self.n419 = 0L
    self.n414 = 0L
    self.n418 = 0L
    self.n420 = 0L
    self.n421 = 0L
    self.n422 = 0L
    self.n423 = 0L
    self.n429 = 0L
    self.n426 = 0L
    self.n455 = 0L
    self.n454 = 0L
    self.n452 = 0L
    self.n432 = 0L
    self.n431 = 0L
    self.n430 = 0L
    self.n434 = 0L
    self.n433 = 0L
    self.n443 = 0L
    self.n436 = 0L
    self.n435 = 0L
    self.n438 = 0L
    self.n437 = 0L
    self.n444 = 0L
    self.n440 = 0L
    self.n439 = 0L
    self.n446 = 0L
    self.n441 = 0L
    self.n445 = 0L
    self.n447 = 0L
    self.n448 = 0L
    self.n449 = 0L
    self.n450 = 0L
    self.n456 = 0L
    self.n453 = 0L
    self.n458 = 0L
    self.n457 = 0L
    self.n459 = 0L
    self.n525 = 0L
    self.n529 = 0L
    self.n532 = 0L
    self.n533 = 0L
    self.n534 = 0L
    self.calc(0L, 0L, )

  def calc(self, a_i, b_i, ):
    self.n541 = 0x7DFFL
    self.n539 = 0x7FFFL
    self.n537 = 0x7C00L
    self.n535 = 0x0FL
    self.n506 = 0x1L
    self.n504 = 0x3L
    self.n502 = 0x2L
    self.n500 = 0x7L
    self.n498 = 0x6L
    self.n496 = 0x5L
    self.n494 = 0x4L
    self.n492 = 0xFL
    self.n490 = 0xEL
    self.n488 = 0xDL
    self.n486 = 0xCL
    self.n484 = 0xBL
    self.n482 = 0xAL
    self.n480 = 0x9L
    self.n478 = 0x8L
    self.n477 = 0x4L
    self.n476 = 0x3L
    self.n475 = 0x2L
    self.n474 = 0x1L
    self.n473 = 0x0L
    self.n460 = 0x0000L
    self.n451 = 0x01L
    self.n424 = 0x01L
    self.n397 = 0x01L
    self.n370 = 0x01L
    self.n343 = 0x01L
    self.n316 = 0x01L
    self.n289 = 0x01L
    self.n262 = 0x01L
    self.n235 = 0x01L
    self.n208 = 0x01L
    self.n181 = 0x01L
    self.n168 = 0x0L
    self.n166 = 0x0L
    self.n4 = b_i
    self.n3 = a_i
    self.n86 = (self.n4 & 0x200L) | (self.n4 & 0x100L) | (self.n4 & 0x80L) | (self.n4 & 0x40L) | (self.n4 & 0x20L) | (self.n4 & 0x10L) | (self.n4 & 0x8L) | (self.n4 & 0x4L) | (self.n4 & 0x2L) | (self.n4 & 0x1L)
    self.n85 = ((self.n4 & 0x4000L) >> 10) | ((self.n4 & 0x2000L) >> 10) | ((self.n4 & 0x1000L) >> 10) | ((self.n4 & 0x800L) >> 10) | ((self.n4 & 0x400L) >> 10)
    self.n13 = (self.n3 & 0x200L) | (self.n3 & 0x100L) | (self.n3 & 0x80L) | (self.n3 & 0x40L) | (self.n3 & 0x20L) | (self.n3 & 0x10L) | (self.n3 & 0x8L) | (self.n3 & 0x4L) | (self.n3 & 0x2L) | (self.n3 & 0x1L)
    self.n12 = ((self.n3 & 0x4000L) >> 10) | ((self.n3 & 0x2000L) >> 10) | ((self.n3 & 0x1000L) >> 10) | ((self.n3 & 0x800L) >> 10) | ((self.n3 & 0x400L) >> 10)
    self.n10 = (self.n4 & 0x200L) | (self.n4 & 0x100L) | (self.n4 & 0x80L) | (self.n4 & 0x40L) | (self.n4 & 0x20L) | (self.n4 & 0x10L) | (self.n4 & 0x8L) | (self.n4 & 0x4L) | (self.n4 & 0x2L) | (self.n4 & 0x1L)
    self.n9 = ((self.n4 & 0x4000L) >> 10) | ((self.n4 & 0x2000L) >> 10) | ((self.n4 & 0x1000L) >> 10) | ((self.n4 & 0x800L) >> 10) | ((self.n4 & 0x400L) >> 10)
    self.n8 = ((self.n4 & 0x8000L) >> 15)
    self.n7 = (self.n3 & 0x200L) | (self.n3 & 0x100L) | (self.n3 & 0x80L) | (self.n3 & 0x40L) | (self.n3 & 0x20L) | (self.n3 & 0x10L) | (self.n3 & 0x8L) | (self.n3 & 0x4L) | (self.n3 & 0x2L) | (self.n3 & 0x1L)
    self.n6 = ((self.n3 & 0x4000L) >> 10) | ((self.n3 & 0x2000L) >> 10) | ((self.n3 & 0x1000L) >> 10) | ((self.n3 & 0x800L) >> 10) | ((self.n3 & 0x400L) >> 10)
    self.n5 = ((self.n3 & 0x8000L) >> 15)
    self.n169 = self.n168 << 5 | self.n9
    self.n167 = self.n166 << 5 | self.n6
    self.n165 = self.n5 ^ self.n8
    self.n148 = ((self.n86 & 0x200L) >> 9)
    self.n146 = ((self.n86 & 0x200L) >> 9)
    self.n117 = (self.n86 & 0x100L) | (self.n86 & 0x80L) | (self.n86 & 0x40L) | (self.n86 & 0x20L) | (self.n86 & 0x10L) | (self.n86 & 0x8L) | (self.n86 & 0x4L) | (self.n86 & 0x2L) | (self.n86 & 0x1L)
    self.n116 = ((self.n86 & 0x200L) >> 9)
    self.n102 = (self.n85 & 0x8L) | (self.n85 & 0x4L) | (self.n85 & 0x2L) | (self.n85 & 0x1L)
    self.n101 = ((self.n85 & 0x10L) >> 4)
    self.n88 = (self.n85 & 0x8L) | (self.n85 & 0x4L) | (self.n85 & 0x2L) | (self.n85 & 0x1L)
    self.n87 = ((self.n85 & 0x10L) >> 4)
    self.n75 = ((self.n13 & 0x200L) >> 9)
    self.n73 = ((self.n13 & 0x200L) >> 9)
    self.n44 = (self.n13 & 0x100L) | (self.n13 & 0x80L) | (self.n13 & 0x40L) | (self.n13 & 0x20L) | (self.n13 & 0x10L) | (self.n13 & 0x8L) | (self.n13 & 0x4L) | (self.n13 & 0x2L) | (self.n13 & 0x1L)
    self.n43 = ((self.n13 & 0x200L) >> 9)
    self.n29 = (self.n12 & 0x8L) | (self.n12 & 0x4L) | (self.n12 & 0x2L) | (self.n12 & 0x1L)
    self.n28 = ((self.n12 & 0x10L) >> 4)
    self.n15 = (self.n12 & 0x8L) | (self.n12 & 0x4L) | (self.n12 & 0x2L) | (self.n12 & 0x1L)
    self.n14 = ((self.n12 & 0x10L) >> 4)
    self.n170 = (self.n167 + self.n169) & 0x3FL
    self.n149 = ~self.n148 & 0x1L
    self.n119 = (self.n117 & 0x80L) | (self.n117 & 0x40L) | (self.n117 & 0x20L) | (self.n117 & 0x10L) | (self.n117 & 0x8L) | (self.n117 & 0x4L) | (self.n117 & 0x2L) | (self.n117 & 0x1L)
    self.n118 = ((self.n117 & 0x100L) >> 8)
    self.n104 = (self.n102 & 0x4L) | (self.n102 & 0x2L) | (self.n102 & 0x1L)
    self.n103 = ((self.n102 & 0x8L) >> 3)
    self.n90 = (self.n88 & 0x4L) | (self.n88 & 0x2L) | (self.n88 & 0x1L)
    self.n89 = ((self.n88 & 0x8L) >> 3)
    self.n76 = ~self.n75 & 0x1L
    self.n46 = (self.n44 & 0x80L) | (self.n44 & 0x40L) | (self.n44 & 0x20L) | (self.n44 & 0x10L) | (self.n44 & 0x8L) | (self.n44 & 0x4L) | (self.n44 & 0x2L) | (self.n44 & 0x1L)
    self.n45 = ((self.n44 & 0x100L) >> 8)
    self.n31 = (self.n29 & 0x4L) | (self.n29 & 0x2L) | (self.n29 & 0x1L)
    self.n30 = ((self.n29 & 0x8L) >> 3)
    self.n17 = (self.n15 & 0x4L) | (self.n15 & 0x2L) | (self.n15 & 0x1L)
    self.n16 = ((self.n15 & 0x8L) >> 3)
    self.n174 = (self.n170 - self.n535) & 0x3FL
    self.n136 = self.n116 | self.n118
    self.n121 = (self.n119 & 0x40L) | (self.n119 & 0x20L) | (self.n119 & 0x10L) | (self.n119 & 0x8L) | (self.n119 & 0x4L) | (self.n119 & 0x2L) | (self.n119 & 0x1L)
    self.n120 = ((self.n119 & 0x80L) >> 7)
    self.n111 = self.n101 | self.n103
    self.n106 = (self.n104 & 0x2L) | (self.n104 & 0x1L)
    self.n105 = ((self.n104 & 0x4L) >> 2)
    self.n97 = self.n87 & self.n89
    self.n92 = (self.n90 & 0x2L) | (self.n90 & 0x1L)
    self.n91 = ((self.n90 & 0x4L) >> 2)
    self.n63 = self.n43 | self.n45
    self.n48 = (self.n46 & 0x40L) | (self.n46 & 0x20L) | (self.n46 & 0x10L) | (self.n46 & 0x8L) | (self.n46 & 0x4L) | (self.n46 & 0x2L) | (self.n46 & 0x1L)
    self.n47 = ((self.n46 & 0x80L) >> 7)
    self.n38 = self.n28 | self.n30
    self.n33 = (self.n31 & 0x2L) | (self.n31 & 0x1L)
    self.n32 = ((self.n31 & 0x4L) >> 2)
    self.n24 = self.n14 & self.n16
    self.n19 = (self.n17 & 0x2L) | (self.n17 & 0x1L)
    self.n18 = ((self.n17 & 0x4L) >> 2)
    self.n182 = (self.n174 + self.n181) & 0x3FL
    self.n123 = (self.n121 & 0x20L) | (self.n121 & 0x10L) | (self.n121 & 0x8L) | (self.n121 & 0x4L) | (self.n121 & 0x2L) | (self.n121 & 0x1L)
    self.n122 = ((self.n121 & 0x40L) >> 6)
    self.n108 = (self.n106 & 0x1L)
    self.n107 = ((self.n106 & 0x2L) >> 1)
    self.n94 = (self.n92 & 0x1L)
    self.n93 = ((self.n92 & 0x2L) >> 1)
    self.n50 = (self.n48 & 0x20L) | (self.n48 & 0x10L) | (self.n48 & 0x8L) | (self.n48 & 0x4L) | (self.n48 & 0x2L) | (self.n48 & 0x1L)
    self.n49 = ((self.n48 & 0x40L) >> 6)
    self.n35 = (self.n33 & 0x1L)
    self.n34 = ((self.n33 & 0x2L) >> 1)
    self.n21 = (self.n19 & 0x1L)
    self.n20 = ((self.n19 & 0x2L) >> 1)
    self.n137 = self.n120 | self.n122
    self.n125 = (self.n123 & 0x10L) | (self.n123 & 0x8L) | (self.n123 & 0x4L) | (self.n123 & 0x2L) | (self.n123 & 0x1L)
    self.n124 = ((self.n123 & 0x20L) >> 5)
    self.n112 = self.n105 | self.n107
    self.n109 = (self.n108 & 0x1L)
    self.n98 = self.n91 & self.n93
    self.n95 = (self.n94 & 0x1L)
    self.n64 = self.n47 | self.n49
    self.n52 = (self.n50 & 0x10L) | (self.n50 & 0x8L) | (self.n50 & 0x4L) | (self.n50 & 0x2L) | (self.n50 & 0x1L)
    self.n51 = ((self.n50 & 0x20L) >> 5)
    self.n39 = self.n32 | self.n34
    self.n36 = (self.n35 & 0x1L)
    self.n25 = self.n18 & self.n20
    self.n22 = (self.n21 & 0x1L)
    self.n141 = self.n136 | self.n137
    self.n127 = (self.n125 & 0x8L) | (self.n125 & 0x4L) | (self.n125 & 0x2L) | (self.n125 & 0x1L)
    self.n126 = ((self.n125 & 0x10L) >> 4)
    self.n113 = self.n111 | self.n112
    self.n99 = self.n97 & self.n98
    self.n68 = self.n63 | self.n64
    self.n54 = (self.n52 & 0x8L) | (self.n52 & 0x4L) | (self.n52 & 0x2L) | (self.n52 & 0x1L)
    self.n53 = ((self.n52 & 0x10L) >> 4)
    self.n40 = self.n38 | self.n39
    self.n26 = self.n24 & self.n25
    self.n138 = self.n124 | self.n126
    self.n129 = (self.n127 & 0x4L) | (self.n127 & 0x2L) | (self.n127 & 0x1L)
    self.n128 = ((self.n127 & 0x8L) >> 3)
    self.n114 = self.n113 | self.n109
    self.n100 = self.n99 & self.n95
    self.n65 = self.n51 | self.n53
    self.n56 = (self.n54 & 0x4L) | (self.n54 & 0x2L) | (self.n54 & 0x1L)
    self.n55 = ((self.n54 & 0x8L) >> 3)
    self.n41 = self.n40 | self.n36
    self.n27 = self.n26 & self.n22
    self.n150 = self.n100 & self.n149
    self.n147 = self.n100 & self.n146
    self.n131 = (self.n129 & 0x2L) | (self.n129 & 0x1L)
    self.n130 = ((self.n129 & 0x4L) >> 2)
    self.n115 = ~self.n114 & 0x1L
    self.n77 = self.n27 & self.n76
    self.n74 = self.n27 & self.n73
    self.n58 = (self.n56 & 0x2L) | (self.n56 & 0x1L)
    self.n57 = ((self.n56 & 0x4L) >> 2)
    self.n42 = ~self.n41 & 0x1L
    self.n139 = self.n128 | self.n130
    self.n133 = (self.n131 & 0x1L)
    self.n132 = ((self.n131 & 0x2L) >> 1)
    self.n66 = self.n55 | self.n57
    self.n60 = (self.n58 & 0x1L)
    self.n59 = ((self.n58 & 0x2L) >> 1)
    self.n142 = self.n138 | self.n139
    self.n134 = (self.n133 & 0x1L)
    self.n69 = self.n65 | self.n66
    self.n61 = (self.n60 & 0x1L)
    self.n143 = self.n141 | self.n142
    self.n140 = self.n132 | self.n134
    self.n70 = self.n68 | self.n69
    self.n67 = self.n59 | self.n61
    self.n144 = self.n143 | self.n140
    self.n71 = self.n70 | self.n67
    self.n145 = ~self.n144 & 0x1L
    self.n72 = ~self.n71 & 0x1L
    self.n155 = ~self.n145 & 0x1L
    self.n154 = self.n115 & self.n145
    self.n153 = self.n100 & self.n145
    self.n151 = ~self.n145 & 0x1L
    self.n82 = ~self.n72 & 0x1L
    self.n81 = self.n42 & self.n72
    self.n80 = self.n27 & self.n72
    self.n78 = ~self.n72 & 0x1L
    self.n164 = self.n81 | self.n154
    self.n163 = self.n80 | self.n153
    self.n161 = self.n81 & self.n153
    self.n160 = self.n80 & self.n154
    self.n156 = self.n115 & self.n155
    self.n152 = self.n150 & self.n151
    self.n83 = self.n42 & self.n82
    self.n79 = self.n77 & self.n78
    self.n470 = self.n163 << 1 | self.n164
    self.n177 = ~self.n156 & 0x1L
    self.n175 = ~self.n83 & 0x1L
    self.n162 = self.n160 | self.n161
    self.n158 = self.n152 | self.n147
    self.n157 = self.n79 | self.n74
    self.n471 = self.n162 << 2 | self.n470
    self.n178 = self.n177 << 10 | self.n10
    self.n176 = self.n175 << 10 | self.n7
    self.n159 = self.n157 | self.n158
    self.n472 = self.n159 << 3 | self.n471
    self.n179 = (self.n176 * self.n178) & 0x3FFFFFL
    if self.n472 == self.n506:
      self.n507 = 1L
    else:
      self.n507 = 0L
    if self.n472 == self.n504:
      self.n505 = 1L
    else:
      self.n505 = 0L
    if self.n472 == self.n502:
      self.n503 = 1L
    else:
      self.n503 = 0L
    if self.n472 == self.n500:
      self.n501 = 1L
    else:
      self.n501 = 0L
    if self.n472 == self.n498:
      self.n499 = 1L
    else:
      self.n499 = 0L
    if self.n472 == self.n496:
      self.n497 = 1L
    else:
      self.n497 = 0L
    if self.n472 == self.n494:
      self.n495 = 1L
    else:
      self.n495 = 0L
    if self.n472 == self.n492:
      self.n493 = 1L
    else:
      self.n493 = 0L
    if self.n472 == self.n490:
      self.n491 = 1L
    else:
      self.n491 = 0L
    if self.n472 == self.n488:
      self.n489 = 1L
    else:
      self.n489 = 0L
    if self.n472 == self.n486:
      self.n487 = 1L
    else:
      self.n487 = 0L
    if self.n472 == self.n484:
      self.n485 = 1L
    else:
      self.n485 = 0L
    if self.n472 == self.n482:
      self.n483 = 1L
    else:
      self.n483 = 0L
    if self.n472 == self.n480:
      self.n481 = 1L
    else:
      self.n481 = 0L
    if self.n472 == self.n478:
      self.n479 = 1L
    else:
      self.n479 = 0L
    self.n185 = (self.n179 & 0x100000L) | (self.n179 & 0x80000L) | (self.n179 & 0x40000L) | (self.n179 & 0x20000L) | (self.n179 & 0x10000L) | (self.n179 & 0x8000L) | (self.n179 & 0x4000L) | (self.n179 & 0x2000L) | (self.n179 & 0x1000L) | (self.n179 & 0x800L) | (self.n179 & 0x400L) | (self.n179 & 0x200L) | (self.n179 & 0x100L) | (self.n179 & 0x80L) | (self.n179 & 0x40L) | (self.n179 & 0x20L) | (self.n179 & 0x10L) | (self.n179 & 0x8L) | (self.n179 & 0x4L) | (self.n179 & 0x2L) | (self.n179 & 0x1L)
    self.n184 = ((self.n179 & 0x200000L) >> 1) | ((self.n179 & 0x100000L) >> 1) | ((self.n179 & 0x80000L) >> 1) | ((self.n179 & 0x40000L) >> 1) | ((self.n179 & 0x20000L) >> 1) | ((self.n179 & 0x10000L) >> 1) | ((self.n179 & 0x8000L) >> 1) | ((self.n179 & 0x4000L) >> 1) | ((self.n179 & 0x2000L) >> 1) | ((self.n179 & 0x1000L) >> 1) | ((self.n179 & 0x800L) >> 1) | ((self.n179 & 0x400L) >> 1) | ((self.n179 & 0x200L) >> 1) | ((self.n179 & 0x100L) >> 1) | ((self.n179 & 0x80L) >> 1) | ((self.n179 & 0x40L) >> 1) | ((self.n179 & 0x20L) >> 1) | ((self.n179 & 0x10L) >> 1) | ((self.n179 & 0x8L) >> 1) | ((self.n179 & 0x4L) >> 1) | ((self.n179 & 0x2L) >> 1)
    self.n180 = ((self.n179 & 0x200000L) >> 21)
    if self.n507:
      self.n508 = self.n474
    else:
      self.n508 = self.n473
    if self.n180:
      self.n186 = self.n184
    else:
      self.n186 = self.n185
    if self.n180:
      self.n183 = self.n182
    else:
      self.n183 = self.n174
    if self.n505:
      self.n509 = self.n475
    else:
      self.n509 = self.n508
    self.n212 = ((self.n186 & 0x100000L) >> 1) | ((self.n186 & 0x80000L) >> 1) | ((self.n186 & 0x40000L) >> 1) | ((self.n186 & 0x20000L) >> 1) | ((self.n186 & 0x10000L) >> 1) | ((self.n186 & 0x8000L) >> 1) | ((self.n186 & 0x4000L) >> 1) | ((self.n186 & 0x2000L) >> 1) | ((self.n186 & 0x1000L) >> 1) | ((self.n186 & 0x800L) >> 1) | ((self.n186 & 0x400L) >> 1) | ((self.n186 & 0x200L) >> 1) | ((self.n186 & 0x100L) >> 1) | ((self.n186 & 0x80L) >> 1) | ((self.n186 & 0x40L) >> 1) | ((self.n186 & 0x20L) >> 1) | ((self.n186 & 0x10L) >> 1) | ((self.n186 & 0x8L) >> 1) | ((self.n186 & 0x4L) >> 1) | ((self.n186 & 0x2L) >> 1)
    self.n211 = (self.n186 & 0x80000L) | (self.n186 & 0x40000L) | (self.n186 & 0x20000L) | (self.n186 & 0x10000L) | (self.n186 & 0x8000L) | (self.n186 & 0x4000L) | (self.n186 & 0x2000L) | (self.n186 & 0x1000L) | (self.n186 & 0x800L) | (self.n186 & 0x400L) | (self.n186 & 0x200L) | (self.n186 & 0x100L) | (self.n186 & 0x80L) | (self.n186 & 0x40L) | (self.n186 & 0x20L) | (self.n186 & 0x10L) | (self.n186 & 0x8L) | (self.n186 & 0x4L) | (self.n186 & 0x2L) | (self.n186 & 0x1L)
    self.n209 = (self.n183 - self.n208) & 0x3FL
    self.n189 = (self.n183 & 0x10L) | (self.n183 & 0x8L) | (self.n183 & 0x4L) | (self.n183 & 0x2L) | (self.n183 & 0x1L)
    self.n188 = ((self.n183 & 0x20L) >> 5)
    self.n187 = ((self.n186 & 0x100000L) >> 20)
    if self.n503:
      self.n510 = self.n475
    else:
      self.n510 = self.n509
    self.n191 = (self.n189 & 0x8L) | (self.n189 & 0x4L) | (self.n189 & 0x2L) | (self.n189 & 0x1L)
    self.n190 = ((self.n189 & 0x10L) >> 4)
    if self.n501:
      self.n511 = self.n476
    else:
      self.n511 = self.n510
    self.n200 = self.n188 | self.n190
    self.n193 = (self.n191 & 0x4L) | (self.n191 & 0x2L) | (self.n191 & 0x1L)
    self.n192 = ((self.n191 & 0x8L) >> 3)
    if self.n499:
      self.n512 = self.n476
    else:
      self.n512 = self.n511
    self.n195 = (self.n193 & 0x2L) | (self.n193 & 0x1L)
    self.n194 = ((self.n193 & 0x4L) >> 2)
    if self.n497:
      self.n513 = self.n476
    else:
      self.n513 = self.n512
    self.n201 = self.n192 | self.n194
    self.n197 = (self.n195 & 0x1L)
    self.n196 = ((self.n195 & 0x2L) >> 1)
    if self.n495:
      self.n514 = self.n476
    else:
      self.n514 = self.n513
    self.n203 = self.n200 | self.n201
    self.n198 = (self.n197 & 0x1L)
    if self.n493:
      self.n515 = self.n477
    else:
      self.n515 = self.n514
    self.n202 = self.n196 | self.n198
    if self.n491:
      self.n516 = self.n477
    else:
      self.n516 = self.n515
    self.n204 = self.n203 | self.n202
    if self.n489:
      self.n517 = self.n477
    else:
      self.n517 = self.n516
    self.n205 = ~self.n204 & 0x1L
    if self.n487:
      self.n518 = self.n477
    else:
      self.n518 = self.n517
    self.n206 = self.n187 | self.n205
    if self.n485:
      self.n519 = self.n477
    else:
      self.n519 = self.n518
    self.n207 = ~self.n206 & 0x1L
    if self.n483:
      self.n520 = self.n477
    else:
      self.n520 = self.n519
    if self.n207:
      self.n213 = self.n211
    else:
      self.n213 = self.n212
    if self.n207:
      self.n210 = self.n209
    else:
      self.n210 = self.n183
    if self.n481:
      self.n521 = self.n477
    else:
      self.n521 = self.n520
    self.n239 = ((self.n213 & 0x80000L) >> 1) | ((self.n213 & 0x40000L) >> 1) | ((self.n213 & 0x20000L) >> 1) | ((self.n213 & 0x10000L) >> 1) | ((self.n213 & 0x8000L) >> 1) | ((self.n213 & 0x4000L) >> 1) | ((self.n213 & 0x2000L) >> 1) | ((self.n213 & 0x1000L) >> 1) | ((self.n213 & 0x800L) >> 1) | ((self.n213 & 0x400L) >> 1) | ((self.n213 & 0x200L) >> 1) | ((self.n213 & 0x100L) >> 1) | ((self.n213 & 0x80L) >> 1) | ((self.n213 & 0x40L) >> 1) | ((self.n213 & 0x20L) >> 1) | ((self.n213 & 0x10L) >> 1) | ((self.n213 & 0x8L) >> 1) | ((self.n213 & 0x4L) >> 1) | ((self.n213 & 0x2L) >> 1)
    self.n238 = (self.n213 & 0x40000L) | (self.n213 & 0x20000L) | (self.n213 & 0x10000L) | (self.n213 & 0x8000L) | (self.n213 & 0x4000L) | (self.n213 & 0x2000L) | (self.n213 & 0x1000L) | (self.n213 & 0x800L) | (self.n213 & 0x400L) | (self.n213 & 0x200L) | (self.n213 & 0x100L) | (self.n213 & 0x80L) | (self.n213 & 0x40L) | (self.n213 & 0x20L) | (self.n213 & 0x10L) | (self.n213 & 0x8L) | (self.n213 & 0x4L) | (self.n213 & 0x2L) | (self.n213 & 0x1L)
    self.n236 = (self.n210 - self.n235) & 0x3FL
    self.n216 = (self.n210 & 0x10L) | (self.n210 & 0x8L) | (self.n210 & 0x4L) | (self.n210 & 0x2L) | (self.n210 & 0x1L)
    self.n215 = ((self.n210 & 0x20L) >> 5)
    self.n214 = ((self.n213 & 0x80000L) >> 19)
    if self.n479:
      self.n522 = self.n477
    else:
      self.n522 = self.n521
    self.n218 = (self.n216 & 0x8L) | (self.n216 & 0x4L) | (self.n216 & 0x2L) | (self.n216 & 0x1L)
    self.n217 = ((self.n216 & 0x10L) >> 4)
    self.n524 = (self.n522 & 0x1L)
    self.n523 = ((self.n522 & 0x4L) >> 1) | ((self.n522 & 0x2L) >> 1)
    self.n227 = self.n215 | self.n217
    self.n220 = (self.n218 & 0x4L) | (self.n218 & 0x2L) | (self.n218 & 0x1L)
    self.n219 = ((self.n218 & 0x8L) >> 3)
    self.n528 = (self.n523 & 0x1L)
    self.n527 = ((self.n523 & 0x2L) >> 1)
    if self.n524:
      self.n526 = self.n539
    else:
      self.n526 = self.n537
    self.n222 = (self.n220 & 0x2L) | (self.n220 & 0x1L)
    self.n221 = ((self.n220 & 0x4L) >> 2)
    self.n531 = (self.n527 & 0x1L)
    self.n228 = self.n219 | self.n221
    self.n224 = (self.n222 & 0x1L)
    self.n223 = ((self.n222 & 0x2L) >> 1)
    self.n230 = self.n227 | self.n228
    self.n225 = (self.n224 & 0x1L)
    self.n229 = self.n223 | self.n225
    self.n231 = self.n230 | self.n229
    self.n232 = ~self.n231 & 0x1L
    self.n233 = self.n214 | self.n232
    self.n234 = ~self.n233 & 0x1L
    if self.n234:
      self.n240 = self.n238
    else:
      self.n240 = self.n239
    if self.n234:
      self.n237 = self.n236
    else:
      self.n237 = self.n210
    self.n266 = ((self.n240 & 0x40000L) >> 1) | ((self.n240 & 0x20000L) >> 1) | ((self.n240 & 0x10000L) >> 1) | ((self.n240 & 0x8000L) >> 1) | ((self.n240 & 0x4000L) >> 1) | ((self.n240 & 0x2000L) >> 1) | ((self.n240 & 0x1000L) >> 1) | ((self.n240 & 0x800L) >> 1) | ((self.n240 & 0x400L) >> 1) | ((self.n240 & 0x200L) >> 1) | ((self.n240 & 0x100L) >> 1) | ((self.n240 & 0x80L) >> 1) | ((self.n240 & 0x40L) >> 1) | ((self.n240 & 0x20L) >> 1) | ((self.n240 & 0x10L) >> 1) | ((self.n240 & 0x8L) >> 1) | ((self.n240 & 0x4L) >> 1) | ((self.n240 & 0x2L) >> 1)
    self.n265 = (self.n240 & 0x20000L) | (self.n240 & 0x10000L) | (self.n240 & 0x8000L) | (self.n240 & 0x4000L) | (self.n240 & 0x2000L) | (self.n240 & 0x1000L) | (self.n240 & 0x800L) | (self.n240 & 0x400L) | (self.n240 & 0x200L) | (self.n240 & 0x100L) | (self.n240 & 0x80L) | (self.n240 & 0x40L) | (self.n240 & 0x20L) | (self.n240 & 0x10L) | (self.n240 & 0x8L) | (self.n240 & 0x4L) | (self.n240 & 0x2L) | (self.n240 & 0x1L)
    self.n263 = (self.n237 - self.n262) & 0x3FL
    self.n243 = (self.n237 & 0x10L) | (self.n237 & 0x8L) | (self.n237 & 0x4L) | (self.n237 & 0x2L) | (self.n237 & 0x1L)
    self.n242 = ((self.n237 & 0x20L) >> 5)
    self.n241 = ((self.n240 & 0x40000L) >> 18)
    self.n245 = (self.n243 & 0x8L) | (self.n243 & 0x4L) | (self.n243 & 0x2L) | (self.n243 & 0x1L)
    self.n244 = ((self.n243 & 0x10L) >> 4)
    self.n254 = self.n242 | self.n244
    self.n247 = (self.n245 & 0x4L) | (self.n245 & 0x2L) | (self.n245 & 0x1L)
    self.n246 = ((self.n245 & 0x8L) >> 3)
    self.n249 = (self.n247 & 0x2L) | (self.n247 & 0x1L)
    self.n248 = ((self.n247 & 0x4L) >> 2)
    self.n255 = self.n246 | self.n248
    self.n251 = (self.n249 & 0x1L)
    self.n250 = ((self.n249 & 0x2L) >> 1)
    self.n257 = self.n254 | self.n255
    self.n252 = (self.n251 & 0x1L)
    self.n256 = self.n250 | self.n252
    self.n258 = self.n257 | self.n256
    self.n259 = ~self.n258 & 0x1L
    self.n260 = self.n241 | self.n259
    self.n261 = ~self.n260 & 0x1L
    if self.n261:
      self.n267 = self.n265
    else:
      self.n267 = self.n266
    if self.n261:
      self.n264 = self.n263
    else:
      self.n264 = self.n237
    self.n293 = ((self.n267 & 0x20000L) >> 1) | ((self.n267 & 0x10000L) >> 1) | ((self.n267 & 0x8000L) >> 1) | ((self.n267 & 0x4000L) >> 1) | ((self.n267 & 0x2000L) >> 1) | ((self.n267 & 0x1000L) >> 1) | ((self.n267 & 0x800L) >> 1) | ((self.n267 & 0x400L) >> 1) | ((self.n267 & 0x200L) >> 1) | ((self.n267 & 0x100L) >> 1) | ((self.n267 & 0x80L) >> 1) | ((self.n267 & 0x40L) >> 1) | ((self.n267 & 0x20L) >> 1) | ((self.n267 & 0x10L) >> 1) | ((self.n267 & 0x8L) >> 1) | ((self.n267 & 0x4L) >> 1) | ((self.n267 & 0x2L) >> 1)
    self.n292 = (self.n267 & 0x10000L) | (self.n267 & 0x8000L) | (self.n267 & 0x4000L) | (self.n267 & 0x2000L) | (self.n267 & 0x1000L) | (self.n267 & 0x800L) | (self.n267 & 0x400L) | (self.n267 & 0x200L) | (self.n267 & 0x100L) | (self.n267 & 0x80L) | (self.n267 & 0x40L) | (self.n267 & 0x20L) | (self.n267 & 0x10L) | (self.n267 & 0x8L) | (self.n267 & 0x4L) | (self.n267 & 0x2L) | (self.n267 & 0x1L)
    self.n290 = (self.n264 - self.n289) & 0x3FL
    self.n270 = (self.n264 & 0x10L) | (self.n264 & 0x8L) | (self.n264 & 0x4L) | (self.n264 & 0x2L) | (self.n264 & 0x1L)
    self.n269 = ((self.n264 & 0x20L) >> 5)
    self.n268 = ((self.n267 & 0x20000L) >> 17)
    self.n272 = (self.n270 & 0x8L) | (self.n270 & 0x4L) | (self.n270 & 0x2L) | (self.n270 & 0x1L)
    self.n271 = ((self.n270 & 0x10L) >> 4)
    self.n281 = self.n269 | self.n271
    self.n274 = (self.n272 & 0x4L) | (self.n272 & 0x2L) | (self.n272 & 0x1L)
    self.n273 = ((self.n272 & 0x8L) >> 3)
    self.n276 = (self.n274 & 0x2L) | (self.n274 & 0x1L)
    self.n275 = ((self.n274 & 0x4L) >> 2)
    self.n282 = self.n273 | self.n275
    self.n278 = (self.n276 & 0x1L)
    self.n277 = ((self.n276 & 0x2L) >> 1)
    self.n284 = self.n281 | self.n282
    self.n279 = (self.n278 & 0x1L)
    self.n283 = self.n277 | self.n279
    self.n285 = self.n284 | self.n283
    self.n286 = ~self.n285 & 0x1L
    self.n287 = self.n268 | self.n286
    self.n288 = ~self.n287 & 0x1L
    if self.n288:
      self.n294 = self.n292
    else:
      self.n294 = self.n293
    if self.n288:
      self.n291 = self.n290
    else:
      self.n291 = self.n264
    self.n320 = ((self.n294 & 0x10000L) >> 1) | ((self.n294 & 0x8000L) >> 1) | ((self.n294 & 0x4000L) >> 1) | ((self.n294 & 0x2000L) >> 1) | ((self.n294 & 0x1000L) >> 1) | ((self.n294 & 0x800L) >> 1) | ((self.n294 & 0x400L) >> 1) | ((self.n294 & 0x200L) >> 1) | ((self.n294 & 0x100L) >> 1) | ((self.n294 & 0x80L) >> 1) | ((self.n294 & 0x40L) >> 1) | ((self.n294 & 0x20L) >> 1) | ((self.n294 & 0x10L) >> 1) | ((self.n294 & 0x8L) >> 1) | ((self.n294 & 0x4L) >> 1) | ((self.n294 & 0x2L) >> 1)
    self.n319 = (self.n294 & 0x8000L) | (self.n294 & 0x4000L) | (self.n294 & 0x2000L) | (self.n294 & 0x1000L) | (self.n294 & 0x800L) | (self.n294 & 0x400L) | (self.n294 & 0x200L) | (self.n294 & 0x100L) | (self.n294 & 0x80L) | (self.n294 & 0x40L) | (self.n294 & 0x20L) | (self.n294 & 0x10L) | (self.n294 & 0x8L) | (self.n294 & 0x4L) | (self.n294 & 0x2L) | (self.n294 & 0x1L)
    self.n317 = (self.n291 - self.n316) & 0x3FL
    self.n297 = (self.n291 & 0x10L) | (self.n291 & 0x8L) | (self.n291 & 0x4L) | (self.n291 & 0x2L) | (self.n291 & 0x1L)
    self.n296 = ((self.n291 & 0x20L) >> 5)
    self.n295 = ((self.n294 & 0x10000L) >> 16)
    self.n299 = (self.n297 & 0x8L) | (self.n297 & 0x4L) | (self.n297 & 0x2L) | (self.n297 & 0x1L)
    self.n298 = ((self.n297 & 0x10L) >> 4)
    self.n308 = self.n296 | self.n298
    self.n301 = (self.n299 & 0x4L) | (self.n299 & 0x2L) | (self.n299 & 0x1L)
    self.n300 = ((self.n299 & 0x8L) >> 3)
    self.n303 = (self.n301 & 0x2L) | (self.n301 & 0x1L)
    self.n302 = ((self.n301 & 0x4L) >> 2)
    self.n309 = self.n300 | self.n302
    self.n305 = (self.n303 & 0x1L)
    self.n304 = ((self.n303 & 0x2L) >> 1)
    self.n311 = self.n308 | self.n309
    self.n306 = (self.n305 & 0x1L)
    self.n310 = self.n304 | self.n306
    self.n312 = self.n311 | self.n310
    self.n313 = ~self.n312 & 0x1L
    self.n314 = self.n295 | self.n313
    self.n315 = ~self.n314 & 0x1L
    if self.n315:
      self.n321 = self.n319
    else:
      self.n321 = self.n320
    if self.n315:
      self.n318 = self.n317
    else:
      self.n318 = self.n291
    self.n347 = ((self.n321 & 0x8000L) >> 1) | ((self.n321 & 0x4000L) >> 1) | ((self.n321 & 0x2000L) >> 1) | ((self.n321 & 0x1000L) >> 1) | ((self.n321 & 0x800L) >> 1) | ((self.n321 & 0x400L) >> 1) | ((self.n321 & 0x200L) >> 1) | ((self.n321 & 0x100L) >> 1) | ((self.n321 & 0x80L) >> 1) | ((self.n321 & 0x40L) >> 1) | ((self.n321 & 0x20L) >> 1) | ((self.n321 & 0x10L) >> 1) | ((self.n321 & 0x8L) >> 1) | ((self.n321 & 0x4L) >> 1) | ((self.n321 & 0x2L) >> 1)
    self.n346 = (self.n321 & 0x4000L) | (self.n321 & 0x2000L) | (self.n321 & 0x1000L) | (self.n321 & 0x800L) | (self.n321 & 0x400L) | (self.n321 & 0x200L) | (self.n321 & 0x100L) | (self.n321 & 0x80L) | (self.n321 & 0x40L) | (self.n321 & 0x20L) | (self.n321 & 0x10L) | (self.n321 & 0x8L) | (self.n321 & 0x4L) | (self.n321 & 0x2L) | (self.n321 & 0x1L)
    self.n344 = (self.n318 - self.n343) & 0x3FL
    self.n324 = (self.n318 & 0x10L) | (self.n318 & 0x8L) | (self.n318 & 0x4L) | (self.n318 & 0x2L) | (self.n318 & 0x1L)
    self.n323 = ((self.n318 & 0x20L) >> 5)
    self.n322 = ((self.n321 & 0x8000L) >> 15)
    self.n326 = (self.n324 & 0x8L) | (self.n324 & 0x4L) | (self.n324 & 0x2L) | (self.n324 & 0x1L)
    self.n325 = ((self.n324 & 0x10L) >> 4)
    self.n335 = self.n323 | self.n325
    self.n328 = (self.n326 & 0x4L) | (self.n326 & 0x2L) | (self.n326 & 0x1L)
    self.n327 = ((self.n326 & 0x8L) >> 3)
    self.n330 = (self.n328 & 0x2L) | (self.n328 & 0x1L)
    self.n329 = ((self.n328 & 0x4L) >> 2)
    self.n336 = self.n327 | self.n329
    self.n332 = (self.n330 & 0x1L)
    self.n331 = ((self.n330 & 0x2L) >> 1)
    self.n338 = self.n335 | self.n336
    self.n333 = (self.n332 & 0x1L)
    self.n337 = self.n331 | self.n333
    self.n339 = self.n338 | self.n337
    self.n340 = ~self.n339 & 0x1L
    self.n341 = self.n322 | self.n340
    self.n342 = ~self.n341 & 0x1L
    if self.n342:
      self.n348 = self.n346
    else:
      self.n348 = self.n347
    if self.n342:
      self.n345 = self.n344
    else:
      self.n345 = self.n318
    self.n374 = ((self.n348 & 0x4000L) >> 1) | ((self.n348 & 0x2000L) >> 1) | ((self.n348 & 0x1000L) >> 1) | ((self.n348 & 0x800L) >> 1) | ((self.n348 & 0x400L) >> 1) | ((self.n348 & 0x200L) >> 1) | ((self.n348 & 0x100L) >> 1) | ((self.n348 & 0x80L) >> 1) | ((self.n348 & 0x40L) >> 1) | ((self.n348 & 0x20L) >> 1) | ((self.n348 & 0x10L) >> 1) | ((self.n348 & 0x8L) >> 1) | ((self.n348 & 0x4L) >> 1) | ((self.n348 & 0x2L) >> 1)
    self.n373 = (self.n348 & 0x2000L) | (self.n348 & 0x1000L) | (self.n348 & 0x800L) | (self.n348 & 0x400L) | (self.n348 & 0x200L) | (self.n348 & 0x100L) | (self.n348 & 0x80L) | (self.n348 & 0x40L) | (self.n348 & 0x20L) | (self.n348 & 0x10L) | (self.n348 & 0x8L) | (self.n348 & 0x4L) | (self.n348 & 0x2L) | (self.n348 & 0x1L)
    self.n371 = (self.n345 - self.n370) & 0x3FL
    self.n351 = (self.n345 & 0x10L) | (self.n345 & 0x8L) | (self.n345 & 0x4L) | (self.n345 & 0x2L) | (self.n345 & 0x1L)
    self.n350 = ((self.n345 & 0x20L) >> 5)
    self.n349 = ((self.n348 & 0x4000L) >> 14)
    self.n353 = (self.n351 & 0x8L) | (self.n351 & 0x4L) | (self.n351 & 0x2L) | (self.n351 & 0x1L)
    self.n352 = ((self.n351 & 0x10L) >> 4)
    self.n362 = self.n350 | self.n352
    self.n355 = (self.n353 & 0x4L) | (self.n353 & 0x2L) | (self.n353 & 0x1L)
    self.n354 = ((self.n353 & 0x8L) >> 3)
    self.n357 = (self.n355 & 0x2L) | (self.n355 & 0x1L)
    self.n356 = ((self.n355 & 0x4L) >> 2)
    self.n363 = self.n354 | self.n356
    self.n359 = (self.n357 & 0x1L)
    self.n358 = ((self.n357 & 0x2L) >> 1)
    self.n365 = self.n362 | self.n363
    self.n360 = (self.n359 & 0x1L)
    self.n364 = self.n358 | self.n360
    self.n366 = self.n365 | self.n364
    self.n367 = ~self.n366 & 0x1L
    self.n368 = self.n349 | self.n367
    self.n369 = ~self.n368 & 0x1L
    if self.n369:
      self.n375 = self.n373
    else:
      self.n375 = self.n374
    if self.n369:
      self.n372 = self.n371
    else:
      self.n372 = self.n345
    self.n401 = ((self.n375 & 0x2000L) >> 1) | ((self.n375 & 0x1000L) >> 1) | ((self.n375 & 0x800L) >> 1) | ((self.n375 & 0x400L) >> 1) | ((self.n375 & 0x200L) >> 1) | ((self.n375 & 0x100L) >> 1) | ((self.n375 & 0x80L) >> 1) | ((self.n375 & 0x40L) >> 1) | ((self.n375 & 0x20L) >> 1) | ((self.n375 & 0x10L) >> 1) | ((self.n375 & 0x8L) >> 1) | ((self.n375 & 0x4L) >> 1) | ((self.n375 & 0x2L) >> 1)
    self.n400 = (self.n375 & 0x1000L) | (self.n375 & 0x800L) | (self.n375 & 0x400L) | (self.n375 & 0x200L) | (self.n375 & 0x100L) | (self.n375 & 0x80L) | (self.n375 & 0x40L) | (self.n375 & 0x20L) | (self.n375 & 0x10L) | (self.n375 & 0x8L) | (self.n375 & 0x4L) | (self.n375 & 0x2L) | (self.n375 & 0x1L)
    self.n398 = (self.n372 - self.n397) & 0x3FL
    self.n378 = (self.n372 & 0x10L) | (self.n372 & 0x8L) | (self.n372 & 0x4L) | (self.n372 & 0x2L) | (self.n372 & 0x1L)
    self.n377 = ((self.n372 & 0x20L) >> 5)
    self.n376 = ((self.n375 & 0x2000L) >> 13)
    self.n380 = (self.n378 & 0x8L) | (self.n378 & 0x4L) | (self.n378 & 0x2L) | (self.n378 & 0x1L)
    self.n379 = ((self.n378 & 0x10L) >> 4)
    self.n389 = self.n377 | self.n379
    self.n382 = (self.n380 & 0x4L) | (self.n380 & 0x2L) | (self.n380 & 0x1L)
    self.n381 = ((self.n380 & 0x8L) >> 3)
    self.n384 = (self.n382 & 0x2L) | (self.n382 & 0x1L)
    self.n383 = ((self.n382 & 0x4L) >> 2)
    self.n390 = self.n381 | self.n383
    self.n386 = (self.n384 & 0x1L)
    self.n385 = ((self.n384 & 0x2L) >> 1)
    self.n392 = self.n389 | self.n390
    self.n387 = (self.n386 & 0x1L)
    self.n391 = self.n385 | self.n387
    self.n393 = self.n392 | self.n391
    self.n394 = ~self.n393 & 0x1L
    self.n395 = self.n376 | self.n394
    self.n396 = ~self.n395 & 0x1L
    if self.n396:
      self.n402 = self.n400
    else:
      self.n402 = self.n401
    if self.n396:
      self.n399 = self.n398
    else:
      self.n399 = self.n372
    self.n428 = ((self.n402 & 0x1000L) >> 1) | ((self.n402 & 0x800L) >> 1) | ((self.n402 & 0x400L) >> 1) | ((self.n402 & 0x200L) >> 1) | ((self.n402 & 0x100L) >> 1) | ((self.n402 & 0x80L) >> 1) | ((self.n402 & 0x40L) >> 1) | ((self.n402 & 0x20L) >> 1) | ((self.n402 & 0x10L) >> 1) | ((self.n402 & 0x8L) >> 1) | ((self.n402 & 0x4L) >> 1) | ((self.n402 & 0x2L) >> 1)
    self.n427 = (self.n402 & 0x800L) | (self.n402 & 0x400L) | (self.n402 & 0x200L) | (self.n402 & 0x100L) | (self.n402 & 0x80L) | (self.n402 & 0x40L) | (self.n402 & 0x20L) | (self.n402 & 0x10L) | (self.n402 & 0x8L) | (self.n402 & 0x4L) | (self.n402 & 0x2L) | (self.n402 & 0x1L)
    self.n425 = (self.n399 - self.n424) & 0x3FL
    self.n405 = (self.n399 & 0x10L) | (self.n399 & 0x8L) | (self.n399 & 0x4L) | (self.n399 & 0x2L) | (self.n399 & 0x1L)
    self.n404 = ((self.n399 & 0x20L) >> 5)
    self.n403 = ((self.n402 & 0x1000L) >> 12)
    self.n407 = (self.n405 & 0x8L) | (self.n405 & 0x4L) | (self.n405 & 0x2L) | (self.n405 & 0x1L)
    self.n406 = ((self.n405 & 0x10L) >> 4)
    self.n416 = self.n404 | self.n406
    self.n409 = (self.n407 & 0x4L) | (self.n407 & 0x2L) | (self.n407 & 0x1L)
    self.n408 = ((self.n407 & 0x8L) >> 3)
    self.n411 = (self.n409 & 0x2L) | (self.n409 & 0x1L)
    self.n410 = ((self.n409 & 0x4L) >> 2)
    self.n417 = self.n408 | self.n410
    self.n413 = (self.n411 & 0x1L)
    self.n412 = ((self.n411 & 0x2L) >> 1)
    self.n419 = self.n416 | self.n417
    self.n414 = (self.n413 & 0x1L)
    self.n418 = self.n412 | self.n414
    self.n420 = self.n419 | self.n418
    self.n421 = ~self.n420 & 0x1L
    self.n422 = self.n403 | self.n421
    self.n423 = ~self.n422 & 0x1L
    if self.n423:
      self.n429 = self.n427
    else:
      self.n429 = self.n428
    if self.n423:
      self.n426 = self.n425
    else:
      self.n426 = self.n399
    self.n455 = ((self.n429 & 0x800L) >> 1) | ((self.n429 & 0x400L) >> 1) | ((self.n429 & 0x200L) >> 1) | ((self.n429 & 0x100L) >> 1) | ((self.n429 & 0x80L) >> 1) | ((self.n429 & 0x40L) >> 1) | ((self.n429 & 0x20L) >> 1) | ((self.n429 & 0x10L) >> 1) | ((self.n429 & 0x8L) >> 1) | ((self.n429 & 0x4L) >> 1) | ((self.n429 & 0x2L) >> 1)
    self.n454 = (self.n429 & 0x400L) | (self.n429 & 0x200L) | (self.n429 & 0x100L) | (self.n429 & 0x80L) | (self.n429 & 0x40L) | (self.n429 & 0x20L) | (self.n429 & 0x10L) | (self.n429 & 0x8L) | (self.n429 & 0x4L) | (self.n429 & 0x2L) | (self.n429 & 0x1L)
    self.n452 = (self.n426 - self.n451) & 0x3FL
    self.n432 = (self.n426 & 0x10L) | (self.n426 & 0x8L) | (self.n426 & 0x4L) | (self.n426 & 0x2L) | (self.n426 & 0x1L)
    self.n431 = ((self.n426 & 0x20L) >> 5)
    self.n430 = ((self.n429 & 0x800L) >> 11)
    self.n434 = (self.n432 & 0x8L) | (self.n432 & 0x4L) | (self.n432 & 0x2L) | (self.n432 & 0x1L)
    self.n433 = ((self.n432 & 0x10L) >> 4)
    self.n443 = self.n431 | self.n433
    self.n436 = (self.n434 & 0x4L) | (self.n434 & 0x2L) | (self.n434 & 0x1L)
    self.n435 = ((self.n434 & 0x8L) >> 3)
    self.n438 = (self.n436 & 0x2L) | (self.n436 & 0x1L)
    self.n437 = ((self.n436 & 0x4L) >> 2)
    self.n444 = self.n435 | self.n437
    self.n440 = (self.n438 & 0x1L)
    self.n439 = ((self.n438 & 0x2L) >> 1)
    self.n446 = self.n443 | self.n444
    self.n441 = (self.n440 & 0x1L)
    self.n445 = self.n439 | self.n441
    self.n447 = self.n446 | self.n445
    self.n448 = ~self.n447 & 0x1L
    self.n449 = self.n430 | self.n448
    self.n450 = ~self.n449 & 0x1L
    if self.n450:
      self.n456 = self.n454
    else:
      self.n456 = self.n455
    if self.n450:
      self.n453 = self.n452
    else:
      self.n453 = self.n426
    self.n458 = (self.n456 & 0x200L) | (self.n456 & 0x100L) | (self.n456 & 0x80L) | (self.n456 & 0x40L) | (self.n456 & 0x20L) | (self.n456 & 0x10L) | (self.n456 & 0x8L) | (self.n456 & 0x4L) | (self.n456 & 0x2L) | (self.n456 & 0x1L)
    self.n457 = (self.n453 & 0x10L) | (self.n453 & 0x8L) | (self.n453 & 0x4L) | (self.n453 & 0x2L) | (self.n453 & 0x1L)
    self.n459 = self.n457 << 10 | self.n458
    if self.n524:
      self.n525 = self.n460
    else:
      self.n525 = self.n459
    if self.n528:
      self.n529 = self.n526
    else:
      self.n529 = self.n525
    if self.n531:
      self.n532 = self.n541
    else:
      self.n532 = self.n529
    self.n533 = self.n165 << 15 | self.n532
    x_o = self.n533
    self.n534 = self.n533
    return (x_o, )

  def sim_init(self, vcdFile):
    self.sim_file = open(vcdFile, 'w')
    self.sim_count = 1
    self.init()
    self.sim_n3 = self.n3
    self.sim_n4 = self.n4
    self.sim_n534 = self.n534
    self.sim_file.write("$date\n")
    self.sim_file.write("  " + time.strftime("%a %b %d %H:%M:%S %Y", time.localtime()) + "\n")
    self.sim_file.write("$end\n")
    self.sim_file.write("$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n")
    self.sim_file.write("$timescale\n  1 ns\n$end\n")
    self.sim_file.write("$scope module cf_fp_mul_c_5_10 $end\n")
    self.sim_file.write("$var wire 16 ! a_i $end\n")
    self.sim_file.write("$var wire 16 \" b_i $end\n")
    self.sim_file.write("$var wire 16 # x_o $end\n")
    self.sim_file.write("$upscope $end\n")
    self.sim_file.write("$enddefinitions $end\n")
    self.sim_file.write("#0\n")
    self.sim_file.write("$dumpvars\n")
    found = 0
    for bit in range(15, -1, -1):
      if found:
        if self.n3 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n3 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" !\n")
    found = 0
    for bit in range(15, -1, -1):
      if found:
        if self.n4 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n4 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" \"\n")
    found = 0
    for bit in range(15, -1, -1):
      if found:
        if self.n534 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n534 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" #\n")
    self.sim_file.write("$end\n")

  def sim_end(self):
    self.sim_file.write("#%d\n" % self.sim_count)
    self.sim_file.close()

  def sim_sample(self):
    changed = 0
    if self.sim_n3 != self.n3:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(15, -1, -1):
        if found:
          if self.n3 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n3 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" !\n")
      self.sim_n3 = self.n3
    if self.sim_n4 != self.n4:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(15, -1, -1):
        if found:
          if self.n4 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n4 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" \"\n")
      self.sim_n4 = self.n4
    if self.sim_n534 != self.n534:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(15, -1, -1):
        if found:
          if self.n534 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n534 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" #\n")
      self.sim_n534 = self.n534
    self.sim_count = self.sim_count + 1

