//
//  Copyright (c) 2003 Launchbird Design Systems, Inc.
//  All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
//  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
//  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  
//  
//  Overview:
//  
//    Performs floating point multiply.
//  
//  Interface:
//  
//    Synchronization:
//      clock_c  : Clock input.
//  
//    Inputs:
//      a_i : Left operand.
//      b_i : Right operand.
//  
//    Outputs:
//      x_o : Result.
//  
//  Built In Parameters:
//  
//    Exponent Precision = 3
//    Mantissa Precision = 4
//    Total    Precision = 8
//    Pipeline Latency   = 8 clock cycles
//  
//  
//  
//  
//  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
//  
//  Build Date : Fri Aug 22 09:47:00 CDT 2003
//  
//  Interface
//  
//    Build Name    : cf_fp_mul_p_3_4
//    Clock Domains : clock_c  
//    Vector Input  : a_i(8)
//    Vector Input  : b_i(8)
//    Vector Output : x_o(8)
//  
//  
//  

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cf_fp_mul_p_3_4.h"

static unsigned char n610[1];
static unsigned char n608[1];
static unsigned char n606[1];
static unsigned char n604[1];
static unsigned char *x_o;
static unsigned char n568[1];
static unsigned char n566[1];
static unsigned char n564[1];
static unsigned char n562[1];
static unsigned char n560[1];
static unsigned char n558[1];
static unsigned char n556[1];
static unsigned char n554[1];
static unsigned char n552[1];
static unsigned char n550[1];
static unsigned char n548[1];
static unsigned char n546[1];
static unsigned char n544[1];
static unsigned char n542[1];
static unsigned char n540[1];
static unsigned char n539[1];
static unsigned char n538[1];
static unsigned char n537[1];
static unsigned char n536[1];
static unsigned char n535[1];
static unsigned char n532[1];
static unsigned char n522[1];
static unsigned char n520[1];
static unsigned char n519[1];
static unsigned char n468[1];
static unsigned char n467[1];
static unsigned char n464[1];
static unsigned char n451[1];
static unsigned char n450[1];
static unsigned char n449[1];
static unsigned char n398[1];
static unsigned char n397[1];
static unsigned char n394[1];
static unsigned char n381[1];
static unsigned char n380[1];
static unsigned char n379[1];
static unsigned char n328[1];
static unsigned char n327[1];
static unsigned char n324[1];
static unsigned char n311[1];
static unsigned char n310[1];
static unsigned char n309[1];
static unsigned char n258[1];
static unsigned char n257[1];
static unsigned char n254[1];
static unsigned char n241[1];
static unsigned char n240[1];
static unsigned char n239[1];
static unsigned char n188[2];
static unsigned char n187[2];
static unsigned char n184[1];
static unsigned char n183[1];
static unsigned char n122[1];
static unsigned char n120[1];
static unsigned char n70[1];
static unsigned char n69[1];
static unsigned char n27[1];
static unsigned char n26[1];
static unsigned char n24[1];
static unsigned char n23[1];
static unsigned char n22[1];
static unsigned char n21[1];
static unsigned char n20[1];
static unsigned char n19[1];
static unsigned char *b_i;
static unsigned char *a_i;
static unsigned char n2[1];
static unsigned char n1[1];
static unsigned char n533[1];
static unsigned char n521[1];
static unsigned char n504[1];
static unsigned char n504r[1];
static unsigned char n504e[1];
static unsigned char n504d[1];
static unsigned char n497[1];
static unsigned char n497r[1];
static unsigned char n497e[1];
static unsigned char n497d[1];
static unsigned char n490[1];
static unsigned char n490r[1];
static unsigned char n490e[1];
static unsigned char n490d[1];
static unsigned char n483[1];
static unsigned char n483r[1];
static unsigned char n483e[1];
static unsigned char n483d[1];
static unsigned char n476[1];
static unsigned char n476r[1];
static unsigned char n476e[1];
static unsigned char n476d[1];
static unsigned char n465[1];
static unsigned char n453[1];
static unsigned char n452[1];
static unsigned char n434[1];
static unsigned char n434r[1];
static unsigned char n434e[1];
static unsigned char n434d[1];
static unsigned char n427[1];
static unsigned char n427r[1];
static unsigned char n427e[1];
static unsigned char n427d[1];
static unsigned char n420[1];
static unsigned char n420r[1];
static unsigned char n420e[1];
static unsigned char n420d[1];
static unsigned char n413[1];
static unsigned char n413r[1];
static unsigned char n413e[1];
static unsigned char n413d[1];
static unsigned char n406[1];
static unsigned char n406r[1];
static unsigned char n406e[1];
static unsigned char n406d[1];
static unsigned char n395[1];
static unsigned char n383[1];
static unsigned char n382[1];
static unsigned char n364[1];
static unsigned char n364r[1];
static unsigned char n364e[1];
static unsigned char n364d[1];
static unsigned char n357[1];
static unsigned char n357r[1];
static unsigned char n357e[1];
static unsigned char n357d[1];
static unsigned char n350[1];
static unsigned char n350r[1];
static unsigned char n350e[1];
static unsigned char n350d[1];
static unsigned char n343[1];
static unsigned char n343r[1];
static unsigned char n343e[1];
static unsigned char n343d[1];
static unsigned char n336[1];
static unsigned char n336r[1];
static unsigned char n336e[1];
static unsigned char n336d[1];
static unsigned char n325[1];
static unsigned char n313[1];
static unsigned char n312[1];
static unsigned char n294[1];
static unsigned char n294r[1];
static unsigned char n294e[1];
static unsigned char n294d[1];
static unsigned char n287[1];
static unsigned char n287r[1];
static unsigned char n287e[1];
static unsigned char n287d[1];
static unsigned char n280[1];
static unsigned char n280r[1];
static unsigned char n280e[1];
static unsigned char n280d[1];
static unsigned char n273[1];
static unsigned char n273r[1];
static unsigned char n273e[1];
static unsigned char n273d[1];
static unsigned char n266[1];
static unsigned char n266r[1];
static unsigned char n266e[1];
static unsigned char n266d[1];
static unsigned char n255[1];
static unsigned char n243[1];
static unsigned char n242[1];
static unsigned char n224[1];
static unsigned char n224r[1];
static unsigned char n224e[1];
static unsigned char n224d[1];
static unsigned char n217[1];
static unsigned char n217r[1];
static unsigned char n217e[1];
static unsigned char n217d[1];
static unsigned char n210[1];
static unsigned char n210r[1];
static unsigned char n210e[1];
static unsigned char n210d[1];
static unsigned char n203[1];
static unsigned char n203r[1];
static unsigned char n203e[1];
static unsigned char n203d[1];
static unsigned char n196[1];
static unsigned char n196r[1];
static unsigned char n196e[1];
static unsigned char n196d[1];
static unsigned char n189[2];
static unsigned char n185[1];
static unsigned char n123[1];
static unsigned char n121[1];
static unsigned char n119[1];
static unsigned char n102[1];
static unsigned char n100[1];
static unsigned char n89[1];
static unsigned char n88[1];
static unsigned char n80[1];
static unsigned char n79[1];
static unsigned char n72[1];
static unsigned char n71[1];
static unsigned char n59[1];
static unsigned char n57[1];
static unsigned char n46[1];
static unsigned char n45[1];
static unsigned char n37[1];
static unsigned char n36[1];
static unsigned char n29[1];
static unsigned char n28[1];
static unsigned char n18[1];
static unsigned char n18r[1];
static unsigned char n18e[1];
static unsigned char n18d[1];
static unsigned char n11[1];
static unsigned char n11r[1];
static unsigned char n11e[1];
static unsigned char n11d[1];
static unsigned char n534[1];
static unsigned char n458[1];
static unsigned char n455[1];
static unsigned char n454[1];
static unsigned char n388[1];
static unsigned char n385[1];
static unsigned char n384[1];
static unsigned char n318[1];
static unsigned char n315[1];
static unsigned char n314[1];
static unsigned char n248[1];
static unsigned char n245[1];
static unsigned char n244[1];
static unsigned char n238[2];
static unsigned char n238r[1];
static unsigned char n238e[1];
static unsigned char n238d[2];
static unsigned char n186[1];
static unsigned char n168[1];
static unsigned char n168r[1];
static unsigned char n168e[1];
static unsigned char n168d[1];
static unsigned char n124[1];
static unsigned char n103[1];
static unsigned char n91[1];
static unsigned char n90[1];
static unsigned char n82[1];
static unsigned char n81[1];
static unsigned char n74[1];
static unsigned char n73[1];
static unsigned char n60[1];
static unsigned char n48[1];
static unsigned char n47[1];
static unsigned char n39[1];
static unsigned char n38[1];
static unsigned char n31[1];
static unsigned char n30[1];
static unsigned char n569[1];
static unsigned char n567[1];
static unsigned char n565[1];
static unsigned char n563[1];
static unsigned char n561[1];
static unsigned char n559[1];
static unsigned char n557[1];
static unsigned char n555[1];
static unsigned char n553[1];
static unsigned char n551[1];
static unsigned char n549[1];
static unsigned char n547[1];
static unsigned char n545[1];
static unsigned char n543[1];
static unsigned char n541[1];
static unsigned char n456[1];
static unsigned char n386[1];
static unsigned char n316[1];
static unsigned char n246[1];
static unsigned char n231[1];
static unsigned char n231r[1];
static unsigned char n231e[1];
static unsigned char n231d[1];
static unsigned char n128[1];
static unsigned char n96[1];
static unsigned char n93[1];
static unsigned char n92[1];
static unsigned char n85[1];
static unsigned char n83[1];
static unsigned char n77[1];
static unsigned char n75[1];
static unsigned char n53[1];
static unsigned char n50[1];
static unsigned char n49[1];
static unsigned char n42[1];
static unsigned char n40[1];
static unsigned char n34[1];
static unsigned char n32[1];
static unsigned char n570[1];
static unsigned char n459[1];
static unsigned char n389[1];
static unsigned char n319[1];
static unsigned char n249[1];
static unsigned char n175[1];
static unsigned char n175r[1];
static unsigned char n175e[1];
static unsigned char n175d[1];
static unsigned char n94[1];
static unsigned char n86[1];
static unsigned char n78[1];
static unsigned char n51[1];
static unsigned char n43[1];
static unsigned char n35[1];
static unsigned char n571[1];
static unsigned char n460[1];
static unsigned char n390[1];
static unsigned char n320[1];
static unsigned char n250[1];
static unsigned char n104[1];
static unsigned char n101[1];
static unsigned char n97[1];
static unsigned char n87[1];
static unsigned char n61[1];
static unsigned char n58[1];
static unsigned char n54[1];
static unsigned char n44[1];
static unsigned char n572[1];
static unsigned char n461[1];
static unsigned char n391[1];
static unsigned char n321[1];
static unsigned char n251[1];
static unsigned char n98[1];
static unsigned char n55[1];
static unsigned char n573[1];
static unsigned char n462[1];
static unsigned char n392[1];
static unsigned char n322[1];
static unsigned char n252[1];
static unsigned char n99[1];
static unsigned char n56[1];
static unsigned char n574[1];
static unsigned char n463[1];
static unsigned char n393[1];
static unsigned char n323[1];
static unsigned char n253[1];
static unsigned char n109[1];
static unsigned char n108[1];
static unsigned char n107[1];
static unsigned char n105[1];
static unsigned char n66[1];
static unsigned char n65[1];
static unsigned char n64[1];
static unsigned char n62[1];
static unsigned char n575[1];
static unsigned char n469[1];
static unsigned char n466[1];
static unsigned char n399[1];
static unsigned char n396[1];
static unsigned char n329[1];
static unsigned char n326[1];
static unsigned char n259[1];
static unsigned char n256[1];
static unsigned char n118[1];
static unsigned char n117[1];
static unsigned char n115[1];
static unsigned char n114[1];
static unsigned char n110[1];
static unsigned char n106[1];
static unsigned char n67[1];
static unsigned char n63[1];
static unsigned char n576[1];
static unsigned char n518[1];
static unsigned char n518r[1];
static unsigned char n518e[1];
static unsigned char n518d[1];
static unsigned char n511[1];
static unsigned char n511r[1];
static unsigned char n511e[1];
static unsigned char n511d[1];
static unsigned char n448[1];
static unsigned char n448r[1];
static unsigned char n448e[1];
static unsigned char n448d[1];
static unsigned char n441[1];
static unsigned char n441r[1];
static unsigned char n441e[1];
static unsigned char n441d[1];
static unsigned char n378[1];
static unsigned char n378r[1];
static unsigned char n378e[1];
static unsigned char n378d[1];
static unsigned char n371[1];
static unsigned char n371r[1];
static unsigned char n371e[1];
static unsigned char n371d[1];
static unsigned char n308[1];
static unsigned char n308r[1];
static unsigned char n308e[1];
static unsigned char n308d[1];
static unsigned char n301[1];
static unsigned char n301r[1];
static unsigned char n301e[1];
static unsigned char n301d[1];
static unsigned char n161[1];
static unsigned char n161r[1];
static unsigned char n161e[1];
static unsigned char n161d[1];
static unsigned char n154[1];
static unsigned char n154r[1];
static unsigned char n154e[1];
static unsigned char n154d[1];
static unsigned char n131[1];
static unsigned char n129[1];
static unsigned char n116[1];
static unsigned char n112[1];
static unsigned char n111[1];
static unsigned char n577[1];
static unsigned char n147[1];
static unsigned char n147r[1];
static unsigned char n147e[1];
static unsigned char n147d[1];
static unsigned char n132[1];
static unsigned char n130[1];
static unsigned char n113[1];
static unsigned char n578[1];
static unsigned char n140[1];
static unsigned char n140r[1];
static unsigned char n140e[1];
static unsigned char n140d[1];
static unsigned char n133[2];
static unsigned char n579[1];
static unsigned char n182[2];
static unsigned char n182r[1];
static unsigned char n182e[1];
static unsigned char n182d[2];
static unsigned char n580[1];
static unsigned char n581[1];
static unsigned char n582[1];
static unsigned char n583[1];
static unsigned char n584[1];
static unsigned char n586[1];
static unsigned char n585[1];
static unsigned char n590[1];
static unsigned char n589[1];
static unsigned char n588[1];
static unsigned char n587[1];
static unsigned char n593[1];
static unsigned char n591[1];
static unsigned char n594[1];
static unsigned char n595[1];
static unsigned char n602[1];
static unsigned char n602r[1];
static unsigned char n602e[1];
static unsigned char n602d[1];

void cf_fp_mul_p_3_4_ports(unsigned char* port_a_i, unsigned char* port_b_i, unsigned char* port_x_o) {
  a_i = port_a_i;
  b_i = port_b_i;
  x_o = port_x_o;
}

void cf_fp_mul_p_3_4_calc() {
  n610[0] = 119;
  n608[0] = 127;
  n606[0] = 112;
  n604[0] = 3;
  x_o[0] = n602[0];
  n568[0] = 1;
  n566[0] = 3;
  n564[0] = 2;
  n562[0] = 7;
  n560[0] = 6;
  n558[0] = 5;
  n556[0] = 4;
  n554[0] = 15;
  n552[0] = 14;
  n550[0] = 13;
  n548[0] = 12;
  n546[0] = 11;
  n544[0] = 10;
  n542[0] = 9;
  n540[0] = 8;
  n539[0] = 4;
  n538[0] = 3;
  n537[0] = 2;
  n536[0] = 1;
  n535[0] = 0;
  n532[0] = 255 & (n490[0] << 1 | n497[0]);
  n522[0] = 0;
  n520[0] = (1 & (n518[0])) | (2 & (n518[0])) | (4 & (n518[0])) | (8 & (n518[0]));
  n519[0] = (1 & (n511[0])) | (2 & (n511[0])) | (4 & (n511[0]));
  n468[0] = (1 & (n448[0] >> 1)) | (2 & (n448[0] >> 1)) | (4 & (n448[0] >> 1)) | (8 & (n448[0] >> 1)) | (16 & (n448[0] >> 1));
  n467[0] = (1 & (n448[0])) | (2 & (n448[0])) | (4 & (n448[0])) | (8 & (n448[0])) | (16 & (n448[0]));
  n464[0] = 1;
  n451[0] = (1 & (n441[0])) | (2 & (n441[0])) | (4 & (n441[0]));
  n450[0] = (1 & (n441[0] >> 3));
  n449[0] = (1 & (n448[0] >> 5));
  n398[0] = (1 & (n378[0] >> 1)) | (2 & (n378[0] >> 1)) | (4 & (n378[0] >> 1)) | (8 & (n378[0] >> 1)) | (16 & (n378[0] >> 1)) | (32 & (n378[0] >> 1));
  n397[0] = (1 & (n378[0])) | (2 & (n378[0])) | (4 & (n378[0])) | (8 & (n378[0])) | (16 & (n378[0])) | (32 & (n378[0]));
  n394[0] = 1;
  n381[0] = (1 & (n371[0])) | (2 & (n371[0])) | (4 & (n371[0]));
  n380[0] = (1 & (n371[0] >> 3));
  n379[0] = (1 & (n378[0] >> 6));
  n328[0] = (1 & (n308[0] >> 1)) | (2 & (n308[0] >> 1)) | (4 & (n308[0] >> 1)) | (8 & (n308[0] >> 1)) | (16 & (n308[0] >> 1)) | (32 & (n308[0] >> 1)) | (64 & (n308[0] >> 1));
  n327[0] = (1 & (n308[0])) | (2 & (n308[0])) | (4 & (n308[0])) | (8 & (n308[0])) | (16 & (n308[0])) | (32 & (n308[0])) | (64 & (n308[0]));
  n324[0] = 1;
  n311[0] = (1 & (n301[0])) | (2 & (n301[0])) | (4 & (n301[0]));
  n310[0] = (1 & (n301[0] >> 3));
  n309[0] = (1 & (n308[0] >> 7));
  n258[0] = (1 & (n238[0] >> 1)) | (2 & (n238[0] >> 1)) | (4 & (n238[0] >> 1)) | (8 & (n238[0] >> 1)) | (16 & (n238[0] >> 1)) | (32 & (n238[0] >> 1)) | (64 & (n238[0] >> 1)) | (128 & (n238[1] << 7));
  n257[0] = (1 & (n238[0])) | (2 & (n238[0])) | (4 & (n238[0])) | (8 & (n238[0])) | (16 & (n238[0])) | (32 & (n238[0])) | (64 & (n238[0])) | (128 & (n238[0]));
  n254[0] = 1;
  n241[0] = (1 & (n231[0])) | (2 & (n231[0])) | (4 & (n231[0]));
  n240[0] = (1 & (n231[0] >> 3));
  n239[0] = (1 & (n238[1]));
  n188[0] = (1 & (n182[0])) | (2 & (n182[0])) | (4 & (n182[0])) | (8 & (n182[0])) | (16 & (n182[0])) | (32 & (n182[0])) | (64 & (n182[0])) | (128 & (n182[0]));
  n188[1] = (1 & (n182[1]));
  n187[0] = (1 & (n182[0] >> 1)) | (2 & (n182[0] >> 1)) | (4 & (n182[0] >> 1)) | (8 & (n182[0] >> 1)) | (16 & (n182[0] >> 1)) | (32 & (n182[0] >> 1)) | (64 & (n182[0] >> 1)) | (128 & (n182[1] << 7));
  n187[1] = (1 & (n182[1] >> 1));
  n184[0] = 1;
  n183[0] = (1 & (n182[1] >> 1));
  n122[0] = 0;
  n120[0] = 0;
  n70[0] = (1 & (n18[0])) | (2 & (n18[0])) | (4 & (n18[0])) | (8 & (n18[0]));
  n69[0] = (1 & (n18[0] >> 4)) | (2 & (n18[0] >> 4)) | (4 & (n18[0] >> 4));
  n27[0] = (1 & (n11[0])) | (2 & (n11[0])) | (4 & (n11[0])) | (8 & (n11[0]));
  n26[0] = (1 & (n11[0] >> 4)) | (2 & (n11[0] >> 4)) | (4 & (n11[0] >> 4));
  n24[0] = (1 & (n18[0])) | (2 & (n18[0])) | (4 & (n18[0])) | (8 & (n18[0]));
  n23[0] = (1 & (n18[0] >> 4)) | (2 & (n18[0] >> 4)) | (4 & (n18[0] >> 4));
  n22[0] = (1 & (n18[0] >> 7));
  n21[0] = (1 & (n11[0])) | (2 & (n11[0])) | (4 & (n11[0])) | (8 & (n11[0]));
  n20[0] = (1 & (n11[0] >> 4)) | (2 & (n11[0] >> 4)) | (4 & (n11[0] >> 4));
  n19[0] = (1 & (n11[0] >> 7));
  n2[0] = 0;
  n1[0] = 1;
  n533[0] = 255 & (n483[0] << 2 | n532[0]);
  n521[0] = 255 & (n519[0] << 4 | n520[0]);
  n504r[0] = n2[0];
  n504e[0] = n1[0];
  n504d[0] = n434[0];
  n497r[0] = n2[0];
  n497e[0] = n1[0];
  n497d[0] = n427[0];
  n490r[0] = n2[0];
  n490e[0] = n1[0];
  n490d[0] = n420[0];
  n483r[0] = n2[0];
  n483e[0] = n1[0];
  n483d[0] = n413[0];
  n476r[0] = n2[0];
  n476e[0] = n1[0];
  n476d[0] = n406[0];
  { unsigned int tmp; (tmp = (unsigned int) n441[0] - (unsigned int) n464[0], n465[0] = 15 & (unsigned char) tmp); }
  n453[0] = (1 & (n451[0])) | (2 & (n451[0]));
  n452[0] = (1 & (n451[0] >> 2));
  n434r[0] = n2[0];
  n434e[0] = n1[0];
  n434d[0] = n364[0];
  n427r[0] = n2[0];
  n427e[0] = n1[0];
  n427d[0] = n357[0];
  n420r[0] = n2[0];
  n420e[0] = n1[0];
  n420d[0] = n350[0];
  n413r[0] = n2[0];
  n413e[0] = n1[0];
  n413d[0] = n343[0];
  n406r[0] = n2[0];
  n406e[0] = n1[0];
  n406d[0] = n336[0];
  { unsigned int tmp; (tmp = (unsigned int) n371[0] - (unsigned int) n394[0], n395[0] = 15 & (unsigned char) tmp); }
  n383[0] = (1 & (n381[0])) | (2 & (n381[0]));
  n382[0] = (1 & (n381[0] >> 2));
  n364r[0] = n2[0];
  n364e[0] = n1[0];
  n364d[0] = n294[0];
  n357r[0] = n2[0];
  n357e[0] = n1[0];
  n357d[0] = n287[0];
  n350r[0] = n2[0];
  n350e[0] = n1[0];
  n350d[0] = n280[0];
  n343r[0] = n2[0];
  n343e[0] = n1[0];
  n343d[0] = n273[0];
  n336r[0] = n2[0];
  n336e[0] = n1[0];
  n336d[0] = n266[0];
  { unsigned int tmp; (tmp = (unsigned int) n301[0] - (unsigned int) n324[0], n325[0] = 15 & (unsigned char) tmp); }
  n313[0] = (1 & (n311[0])) | (2 & (n311[0]));
  n312[0] = (1 & (n311[0] >> 2));
  n294r[0] = n2[0];
  n294e[0] = n1[0];
  n294d[0] = n224[0];
  n287r[0] = n2[0];
  n287e[0] = n1[0];
  n287d[0] = n217[0];
  n280r[0] = n2[0];
  n280e[0] = n1[0];
  n280d[0] = n210[0];
  n273r[0] = n2[0];
  n273e[0] = n1[0];
  n273d[0] = n203[0];
  n266r[0] = n2[0];
  n266e[0] = n1[0];
  n266d[0] = n196[0];
  { unsigned int tmp; (tmp = (unsigned int) n231[0] - (unsigned int) n254[0], n255[0] = 15 & (unsigned char) tmp); }
  n243[0] = (1 & (n241[0])) | (2 & (n241[0]));
  n242[0] = (1 & (n241[0] >> 2));
  n224r[0] = n2[0];
  n224e[0] = n1[0];
  n224d[0] = n168[0];
  n217r[0] = n2[0];
  n217e[0] = n1[0];
  n217d[0] = n161[0];
  n210r[0] = n2[0];
  n210e[0] = n1[0];
  n210d[0] = n154[0];
  n203r[0] = n2[0];
  n203e[0] = n1[0];
  n203d[0] = n147[0];
  n196r[0] = n2[0];
  n196e[0] = n1[0];
  n196d[0] = n140[0];
  if (n183[0]) {
    n189[0] = n187[0];
    n189[1] = n187[1];
  }
  else {
    n189[0] = n188[0];
    n189[1] = n188[1];
  }
  { unsigned int tmp; (tmp = (unsigned int) n175[0] + (unsigned int) n184[0], n185[0] = 15 & (unsigned char) tmp); }
  n123[0] = 255 & (n122[0] << 3 | n23[0]);
  n121[0] = 255 & (n120[0] << 3 | n20[0]);
  n119[0] = n19[0] ^ n22[0];
  n102[0] = (1 & (n70[0] >> 3));
  n100[0] = (1 & (n70[0] >> 3));
  n89[0] = (1 & (n70[0])) | (2 & (n70[0])) | (4 & (n70[0]));
  n88[0] = (1 & (n70[0] >> 3));
  n80[0] = (1 & (n69[0])) | (2 & (n69[0]));
  n79[0] = (1 & (n69[0] >> 2));
  n72[0] = (1 & (n69[0])) | (2 & (n69[0]));
  n71[0] = (1 & (n69[0] >> 2));
  n59[0] = (1 & (n27[0] >> 3));
  n57[0] = (1 & (n27[0] >> 3));
  n46[0] = (1 & (n27[0])) | (2 & (n27[0])) | (4 & (n27[0]));
  n45[0] = (1 & (n27[0] >> 3));
  n37[0] = (1 & (n26[0])) | (2 & (n26[0]));
  n36[0] = (1 & (n26[0] >> 2));
  n29[0] = (1 & (n26[0])) | (2 & (n26[0]));
  n28[0] = (1 & (n26[0] >> 2));
  n18r[0] = n2[0];
  n18e[0] = n1[0];
  n18d[0] = b_i[0];
  n11r[0] = n2[0];
  n11e[0] = n1[0];
  n11d[0] = a_i[0];
  n534[0] = 255 & (n476[0] << 3 | n533[0]);
  n458[0] = n450[0] | n452[0];
  n455[0] = (1 & (n453[0]));
  n454[0] = (1 & (n453[0] >> 1));
  n388[0] = n380[0] | n382[0];
  n385[0] = (1 & (n383[0]));
  n384[0] = (1 & (n383[0] >> 1));
  n318[0] = n310[0] | n312[0];
  n315[0] = (1 & (n313[0]));
  n314[0] = (1 & (n313[0] >> 1));
  n248[0] = n240[0] | n242[0];
  n245[0] = (1 & (n243[0]));
  n244[0] = (1 & (n243[0] >> 1));
  n238r[0] = n2[0];
  n238e[0] = n1[0];
  n238d[0] = n189[0];
  n238d[1] = n189[1];
  if (n183[0]) {
    n186[0] = n185[0];
  }
  else {
    n186[0] = n175[0];
  }
  n168r[0] = n2[0];
  n168e[0] = n1[0];
  n168d[0] = n119[0];
  { unsigned int tmp; (tmp = (unsigned int) n121[0] + (unsigned int) n123[0], n124[0] = 15 & (unsigned char) tmp); }
  n103[0] = 1 & ~n102[0];
  n91[0] = (1 & (n89[0])) | (2 & (n89[0]));
  n90[0] = (1 & (n89[0] >> 2));
  n82[0] = (1 & (n80[0]));
  n81[0] = (1 & (n80[0] >> 1));
  n74[0] = (1 & (n72[0]));
  n73[0] = (1 & (n72[0] >> 1));
  n60[0] = 1 & ~n59[0];
  n48[0] = (1 & (n46[0])) | (2 & (n46[0]));
  n47[0] = (1 & (n46[0] >> 2));
  n39[0] = (1 & (n37[0]));
  n38[0] = (1 & (n37[0] >> 1));
  n31[0] = (1 & (n29[0]));
  n30[0] = (1 & (n29[0] >> 1));
  n569[0] = n534[0] == n568[0] ? 1 : 0;
  n567[0] = n534[0] == n566[0] ? 1 : 0;
  n565[0] = n534[0] == n564[0] ? 1 : 0;
  n563[0] = n534[0] == n562[0] ? 1 : 0;
  n561[0] = n534[0] == n560[0] ? 1 : 0;
  n559[0] = n534[0] == n558[0] ? 1 : 0;
  n557[0] = n534[0] == n556[0] ? 1 : 0;
  n555[0] = n534[0] == n554[0] ? 1 : 0;
  n553[0] = n534[0] == n552[0] ? 1 : 0;
  n551[0] = n534[0] == n550[0] ? 1 : 0;
  n549[0] = n534[0] == n548[0] ? 1 : 0;
  n547[0] = n534[0] == n546[0] ? 1 : 0;
  n545[0] = n534[0] == n544[0] ? 1 : 0;
  n543[0] = n534[0] == n542[0] ? 1 : 0;
  n541[0] = n534[0] == n540[0] ? 1 : 0;
  n456[0] = (1 & (n455[0]));
  n386[0] = (1 & (n385[0]));
  n316[0] = (1 & (n315[0]));
  n246[0] = (1 & (n245[0]));
  n231r[0] = n2[0];
  n231e[0] = n1[0];
  n231d[0] = n186[0];
  { unsigned int tmp; (tmp = (unsigned int) n124[0] - (unsigned int) n604[0], n128[0] = 15 & (unsigned char) tmp); }
  n96[0] = n88[0] | n90[0];
  n93[0] = (1 & (n91[0]));
  n92[0] = (1 & (n91[0] >> 1));
  n85[0] = n79[0] | n81[0];
  n83[0] = (1 & (n82[0]));
  n77[0] = n71[0] & n73[0];
  n75[0] = (1 & (n74[0]));
  n53[0] = n45[0] | n47[0];
  n50[0] = (1 & (n48[0]));
  n49[0] = (1 & (n48[0] >> 1));
  n42[0] = n36[0] | n38[0];
  n40[0] = (1 & (n39[0]));
  n34[0] = n28[0] & n30[0];
  n32[0] = (1 & (n31[0]));
  if (n569[0]) {
    n570[0] = n536[0];
  }
  else {
    n570[0] = n535[0];
  }
  n459[0] = n454[0] | n456[0];
  n389[0] = n384[0] | n386[0];
  n319[0] = n314[0] | n316[0];
  n249[0] = n244[0] | n246[0];
  n175r[0] = n2[0];
  n175e[0] = n1[0];
  n175d[0] = n128[0];
  n94[0] = (1 & (n93[0]));
  n86[0] = n85[0] | n83[0];
  n78[0] = n77[0] & n75[0];
  n51[0] = (1 & (n50[0]));
  n43[0] = n42[0] | n40[0];
  n35[0] = n34[0] & n32[0];
  if (n567[0]) {
    n571[0] = n537[0];
  }
  else {
    n571[0] = n570[0];
  }
  n460[0] = n458[0] | n459[0];
  n390[0] = n388[0] | n389[0];
  n320[0] = n318[0] | n319[0];
  n250[0] = n248[0] | n249[0];
  n104[0] = n78[0] & n103[0];
  n101[0] = n78[0] & n100[0];
  n97[0] = n92[0] | n94[0];
  n87[0] = 1 & ~n86[0];
  n61[0] = n35[0] & n60[0];
  n58[0] = n35[0] & n57[0];
  n54[0] = n49[0] | n51[0];
  n44[0] = 1 & ~n43[0];
  if (n565[0]) {
    n572[0] = n537[0];
  }
  else {
    n572[0] = n571[0];
  }
  n461[0] = 1 & ~n460[0];
  n391[0] = 1 & ~n390[0];
  n321[0] = 1 & ~n320[0];
  n251[0] = 1 & ~n250[0];
  n98[0] = n96[0] | n97[0];
  n55[0] = n53[0] | n54[0];
  if (n563[0]) {
    n573[0] = n538[0];
  }
  else {
    n573[0] = n572[0];
  }
  n462[0] = n449[0] | n461[0];
  n392[0] = n379[0] | n391[0];
  n322[0] = n309[0] | n321[0];
  n252[0] = n239[0] | n251[0];
  n99[0] = 1 & ~n98[0];
  n56[0] = 1 & ~n55[0];
  if (n561[0]) {
    n574[0] = n538[0];
  }
  else {
    n574[0] = n573[0];
  }
  n463[0] = 1 & ~n462[0];
  n393[0] = 1 & ~n392[0];
  n323[0] = 1 & ~n322[0];
  n253[0] = 1 & ~n252[0];
  n109[0] = 1 & ~n99[0];
  n108[0] = n87[0] & n99[0];
  n107[0] = n78[0] & n99[0];
  n105[0] = 1 & ~n99[0];
  n66[0] = 1 & ~n56[0];
  n65[0] = n44[0] & n56[0];
  n64[0] = n35[0] & n56[0];
  n62[0] = 1 & ~n56[0];
  if (n559[0]) {
    n575[0] = n538[0];
  }
  else {
    n575[0] = n574[0];
  }
  if (n463[0]) {
    n469[0] = n467[0];
  }
  else {
    n469[0] = n468[0];
  }
  if (n463[0]) {
    n466[0] = n465[0];
  }
  else {
    n466[0] = n441[0];
  }
  if (n393[0]) {
    n399[0] = n397[0];
  }
  else {
    n399[0] = n398[0];
  }
  if (n393[0]) {
    n396[0] = n395[0];
  }
  else {
    n396[0] = n371[0];
  }
  if (n323[0]) {
    n329[0] = n327[0];
  }
  else {
    n329[0] = n328[0];
  }
  if (n323[0]) {
    n326[0] = n325[0];
  }
  else {
    n326[0] = n301[0];
  }
  if (n253[0]) {
    n259[0] = n257[0];
  }
  else {
    n259[0] = n258[0];
  }
  if (n253[0]) {
    n256[0] = n255[0];
  }
  else {
    n256[0] = n231[0];
  }
  n118[0] = n65[0] | n108[0];
  n117[0] = n64[0] | n107[0];
  n115[0] = n65[0] & n107[0];
  n114[0] = n64[0] & n108[0];
  n110[0] = n87[0] & n109[0];
  n106[0] = n104[0] & n105[0];
  n67[0] = n44[0] & n66[0];
  n63[0] = n61[0] & n62[0];
  if (n557[0]) {
    n576[0] = n538[0];
  }
  else {
    n576[0] = n575[0];
  }
  n518r[0] = n2[0];
  n518e[0] = n1[0];
  n518d[0] = n469[0];
  n511r[0] = n2[0];
  n511e[0] = n1[0];
  n511d[0] = n466[0];
  n448r[0] = n2[0];
  n448e[0] = n1[0];
  n448d[0] = n399[0];
  n441r[0] = n2[0];
  n441e[0] = n1[0];
  n441d[0] = n396[0];
  n378r[0] = n2[0];
  n378e[0] = n1[0];
  n378d[0] = n329[0];
  n371r[0] = n2[0];
  n371e[0] = n1[0];
  n371d[0] = n326[0];
  n308r[0] = n2[0];
  n308e[0] = n1[0];
  n308d[0] = n259[0];
  n301r[0] = n2[0];
  n301e[0] = n1[0];
  n301d[0] = n256[0];
  n161r[0] = n2[0];
  n161e[0] = n1[0];
  n161d[0] = n118[0];
  n154r[0] = n2[0];
  n154e[0] = n1[0];
  n154d[0] = n117[0];
  n131[0] = 1 & ~n110[0];
  n129[0] = 1 & ~n67[0];
  n116[0] = n114[0] | n115[0];
  n112[0] = n106[0] | n101[0];
  n111[0] = n63[0] | n58[0];
  if (n555[0]) {
    n577[0] = n539[0];
  }
  else {
    n577[0] = n576[0];
  }
  n147r[0] = n2[0];
  n147e[0] = n1[0];
  n147d[0] = n116[0];
  n132[0] = 255 & (n131[0] << 4 | n24[0]);
  n130[0] = 255 & (n129[0] << 4 | n21[0]);
  n113[0] = n111[0] | n112[0];
  if (n553[0]) {
    n578[0] = n539[0];
  }
  else {
    n578[0] = n577[0];
  }
  n140r[0] = n2[0];
  n140e[0] = n1[0];
  n140d[0] = n113[0];
  {
    unsigned int tmp;
    unsigned char a[2];
    unsigned char b[2];
    a[1] = 0;
    a[0] = n130[0];
    b[1] = 0;
    b[0] = n132[0];
    (tmp = ((unsigned int) a[1] * (unsigned int) b[0]) + ((unsigned int) a[0] * (unsigned int) b[1]) + (tmp = ((unsigned int) a[0] * (unsigned int) b[0]), n133[0] = 255 & (unsigned char) tmp, tmp >> 8), n133[1] = 3 & (unsigned char) tmp);
  }
  if (n551[0]) {
    n579[0] = n539[0];
  }
  else {
    n579[0] = n578[0];
  }
  n182r[0] = n2[0];
  n182e[0] = n1[0];
  n182d[0] = n133[0];
  n182d[1] = n133[1];
  if (n549[0]) {
    n580[0] = n539[0];
  }
  else {
    n580[0] = n579[0];
  }
  if (n547[0]) {
    n581[0] = n539[0];
  }
  else {
    n581[0] = n580[0];
  }
  if (n545[0]) {
    n582[0] = n539[0];
  }
  else {
    n582[0] = n581[0];
  }
  if (n543[0]) {
    n583[0] = n539[0];
  }
  else {
    n583[0] = n582[0];
  }
  if (n541[0]) {
    n584[0] = n539[0];
  }
  else {
    n584[0] = n583[0];
  }
  n586[0] = (1 & (n584[0]));
  n585[0] = (1 & (n584[0] >> 1)) | (2 & (n584[0] >> 1));
  n590[0] = (1 & (n585[0]));
  n589[0] = (1 & (n585[0] >> 1));
  if (n586[0]) {
    n588[0] = n608[0];
  }
  else {
    n588[0] = n606[0];
  }
  if (n586[0]) {
    n587[0] = n522[0];
  }
  else {
    n587[0] = n521[0];
  }
  n593[0] = (1 & (n589[0]));
  if (n590[0]) {
    n591[0] = n588[0];
  }
  else {
    n591[0] = n587[0];
  }
  if (n593[0]) {
    n594[0] = n610[0];
  }
  else {
    n594[0] = n591[0];
  }
  n595[0] = 255 & (n504[0] << 7 | n594[0]);
  n602r[0] = n2[0];
  n602e[0] = n1[0];
  n602d[0] = n595[0];
}

void cf_fp_mul_p_3_4_init() {
  n610[0] = 0;
  n608[0] = 0;
  n606[0] = 0;
  n604[0] = 0;
  n568[0] = 0;
  n566[0] = 0;
  n564[0] = 0;
  n562[0] = 0;
  n560[0] = 0;
  n558[0] = 0;
  n556[0] = 0;
  n554[0] = 0;
  n552[0] = 0;
  n550[0] = 0;
  n548[0] = 0;
  n546[0] = 0;
  n544[0] = 0;
  n542[0] = 0;
  n540[0] = 0;
  n539[0] = 0;
  n538[0] = 0;
  n537[0] = 0;
  n536[0] = 0;
  n535[0] = 0;
  n532[0] = 0;
  n522[0] = 0;
  n520[0] = 0;
  n519[0] = 0;
  n468[0] = 0;
  n467[0] = 0;
  n464[0] = 0;
  n451[0] = 0;
  n450[0] = 0;
  n449[0] = 0;
  n398[0] = 0;
  n397[0] = 0;
  n394[0] = 0;
  n381[0] = 0;
  n380[0] = 0;
  n379[0] = 0;
  n328[0] = 0;
  n327[0] = 0;
  n324[0] = 0;
  n311[0] = 0;
  n310[0] = 0;
  n309[0] = 0;
  n258[0] = 0;
  n257[0] = 0;
  n254[0] = 0;
  n241[0] = 0;
  n240[0] = 0;
  n239[0] = 0;
  { int index; for (index = 2; index > 0;) n188[--index] = 0; }
  { int index; for (index = 2; index > 0;) n187[--index] = 0; }
  n184[0] = 0;
  n183[0] = 0;
  n122[0] = 0;
  n120[0] = 0;
  n70[0] = 0;
  n69[0] = 0;
  n27[0] = 0;
  n26[0] = 0;
  n24[0] = 0;
  n23[0] = 0;
  n22[0] = 0;
  n21[0] = 0;
  n20[0] = 0;
  n19[0] = 0;
  n2[0] = 0;
  n1[0] = 0;
  n533[0] = 0;
  n521[0] = 0;
  n504[0] = 0;
  n504r[0] = 0;
  n504e[0] = 0;
  n504d[0] = 0;
  n497[0] = 0;
  n497r[0] = 0;
  n497e[0] = 0;
  n497d[0] = 0;
  n490[0] = 0;
  n490r[0] = 0;
  n490e[0] = 0;
  n490d[0] = 0;
  n483[0] = 0;
  n483r[0] = 0;
  n483e[0] = 0;
  n483d[0] = 0;
  n476[0] = 0;
  n476r[0] = 0;
  n476e[0] = 0;
  n476d[0] = 0;
  n465[0] = 0;
  n453[0] = 0;
  n452[0] = 0;
  n434[0] = 0;
  n434r[0] = 0;
  n434e[0] = 0;
  n434d[0] = 0;
  n427[0] = 0;
  n427r[0] = 0;
  n427e[0] = 0;
  n427d[0] = 0;
  n420[0] = 0;
  n420r[0] = 0;
  n420e[0] = 0;
  n420d[0] = 0;
  n413[0] = 0;
  n413r[0] = 0;
  n413e[0] = 0;
  n413d[0] = 0;
  n406[0] = 0;
  n406r[0] = 0;
  n406e[0] = 0;
  n406d[0] = 0;
  n395[0] = 0;
  n383[0] = 0;
  n382[0] = 0;
  n364[0] = 0;
  n364r[0] = 0;
  n364e[0] = 0;
  n364d[0] = 0;
  n357[0] = 0;
  n357r[0] = 0;
  n357e[0] = 0;
  n357d[0] = 0;
  n350[0] = 0;
  n350r[0] = 0;
  n350e[0] = 0;
  n350d[0] = 0;
  n343[0] = 0;
  n343r[0] = 0;
  n343e[0] = 0;
  n343d[0] = 0;
  n336[0] = 0;
  n336r[0] = 0;
  n336e[0] = 0;
  n336d[0] = 0;
  n325[0] = 0;
  n313[0] = 0;
  n312[0] = 0;
  n294[0] = 0;
  n294r[0] = 0;
  n294e[0] = 0;
  n294d[0] = 0;
  n287[0] = 0;
  n287r[0] = 0;
  n287e[0] = 0;
  n287d[0] = 0;
  n280[0] = 0;
  n280r[0] = 0;
  n280e[0] = 0;
  n280d[0] = 0;
  n273[0] = 0;
  n273r[0] = 0;
  n273e[0] = 0;
  n273d[0] = 0;
  n266[0] = 0;
  n266r[0] = 0;
  n266e[0] = 0;
  n266d[0] = 0;
  n255[0] = 0;
  n243[0] = 0;
  n242[0] = 0;
  n224[0] = 0;
  n224r[0] = 0;
  n224e[0] = 0;
  n224d[0] = 0;
  n217[0] = 0;
  n217r[0] = 0;
  n217e[0] = 0;
  n217d[0] = 0;
  n210[0] = 0;
  n210r[0] = 0;
  n210e[0] = 0;
  n210d[0] = 0;
  n203[0] = 0;
  n203r[0] = 0;
  n203e[0] = 0;
  n203d[0] = 0;
  n196[0] = 0;
  n196r[0] = 0;
  n196e[0] = 0;
  n196d[0] = 0;
  { int index; for (index = 2; index > 0;) n189[--index] = 0; }
  n185[0] = 0;
  n123[0] = 0;
  n121[0] = 0;
  n119[0] = 0;
  n102[0] = 0;
  n100[0] = 0;
  n89[0] = 0;
  n88[0] = 0;
  n80[0] = 0;
  n79[0] = 0;
  n72[0] = 0;
  n71[0] = 0;
  n59[0] = 0;
  n57[0] = 0;
  n46[0] = 0;
  n45[0] = 0;
  n37[0] = 0;
  n36[0] = 0;
  n29[0] = 0;
  n28[0] = 0;
  n18[0] = 0;
  n18r[0] = 0;
  n18e[0] = 0;
  n18d[0] = 0;
  n11[0] = 0;
  n11r[0] = 0;
  n11e[0] = 0;
  n11d[0] = 0;
  n534[0] = 0;
  n458[0] = 0;
  n455[0] = 0;
  n454[0] = 0;
  n388[0] = 0;
  n385[0] = 0;
  n384[0] = 0;
  n318[0] = 0;
  n315[0] = 0;
  n314[0] = 0;
  n248[0] = 0;
  n245[0] = 0;
  n244[0] = 0;
  { int index; for (index = 2; index > 0;) n238[--index] = 0; }
  n238r[0] = 0;
  n238e[0] = 0;
  { int index; for (index = 2; index > 0;) n238d[--index] = 0; }
  n186[0] = 0;
  n168[0] = 0;
  n168r[0] = 0;
  n168e[0] = 0;
  n168d[0] = 0;
  n124[0] = 0;
  n103[0] = 0;
  n91[0] = 0;
  n90[0] = 0;
  n82[0] = 0;
  n81[0] = 0;
  n74[0] = 0;
  n73[0] = 0;
  n60[0] = 0;
  n48[0] = 0;
  n47[0] = 0;
  n39[0] = 0;
  n38[0] = 0;
  n31[0] = 0;
  n30[0] = 0;
  n569[0] = 0;
  n567[0] = 0;
  n565[0] = 0;
  n563[0] = 0;
  n561[0] = 0;
  n559[0] = 0;
  n557[0] = 0;
  n555[0] = 0;
  n553[0] = 0;
  n551[0] = 0;
  n549[0] = 0;
  n547[0] = 0;
  n545[0] = 0;
  n543[0] = 0;
  n541[0] = 0;
  n456[0] = 0;
  n386[0] = 0;
  n316[0] = 0;
  n246[0] = 0;
  n231[0] = 0;
  n231r[0] = 0;
  n231e[0] = 0;
  n231d[0] = 0;
  n128[0] = 0;
  n96[0] = 0;
  n93[0] = 0;
  n92[0] = 0;
  n85[0] = 0;
  n83[0] = 0;
  n77[0] = 0;
  n75[0] = 0;
  n53[0] = 0;
  n50[0] = 0;
  n49[0] = 0;
  n42[0] = 0;
  n40[0] = 0;
  n34[0] = 0;
  n32[0] = 0;
  n570[0] = 0;
  n459[0] = 0;
  n389[0] = 0;
  n319[0] = 0;
  n249[0] = 0;
  n175[0] = 0;
  n175r[0] = 0;
  n175e[0] = 0;
  n175d[0] = 0;
  n94[0] = 0;
  n86[0] = 0;
  n78[0] = 0;
  n51[0] = 0;
  n43[0] = 0;
  n35[0] = 0;
  n571[0] = 0;
  n460[0] = 0;
  n390[0] = 0;
  n320[0] = 0;
  n250[0] = 0;
  n104[0] = 0;
  n101[0] = 0;
  n97[0] = 0;
  n87[0] = 0;
  n61[0] = 0;
  n58[0] = 0;
  n54[0] = 0;
  n44[0] = 0;
  n572[0] = 0;
  n461[0] = 0;
  n391[0] = 0;
  n321[0] = 0;
  n251[0] = 0;
  n98[0] = 0;
  n55[0] = 0;
  n573[0] = 0;
  n462[0] = 0;
  n392[0] = 0;
  n322[0] = 0;
  n252[0] = 0;
  n99[0] = 0;
  n56[0] = 0;
  n574[0] = 0;
  n463[0] = 0;
  n393[0] = 0;
  n323[0] = 0;
  n253[0] = 0;
  n109[0] = 0;
  n108[0] = 0;
  n107[0] = 0;
  n105[0] = 0;
  n66[0] = 0;
  n65[0] = 0;
  n64[0] = 0;
  n62[0] = 0;
  n575[0] = 0;
  n469[0] = 0;
  n466[0] = 0;
  n399[0] = 0;
  n396[0] = 0;
  n329[0] = 0;
  n326[0] = 0;
  n259[0] = 0;
  n256[0] = 0;
  n118[0] = 0;
  n117[0] = 0;
  n115[0] = 0;
  n114[0] = 0;
  n110[0] = 0;
  n106[0] = 0;
  n67[0] = 0;
  n63[0] = 0;
  n576[0] = 0;
  n518[0] = 0;
  n518r[0] = 0;
  n518e[0] = 0;
  n518d[0] = 0;
  n511[0] = 0;
  n511r[0] = 0;
  n511e[0] = 0;
  n511d[0] = 0;
  n448[0] = 0;
  n448r[0] = 0;
  n448e[0] = 0;
  n448d[0] = 0;
  n441[0] = 0;
  n441r[0] = 0;
  n441e[0] = 0;
  n441d[0] = 0;
  n378[0] = 0;
  n378r[0] = 0;
  n378e[0] = 0;
  n378d[0] = 0;
  n371[0] = 0;
  n371r[0] = 0;
  n371e[0] = 0;
  n371d[0] = 0;
  n308[0] = 0;
  n308r[0] = 0;
  n308e[0] = 0;
  n308d[0] = 0;
  n301[0] = 0;
  n301r[0] = 0;
  n301e[0] = 0;
  n301d[0] = 0;
  n161[0] = 0;
  n161r[0] = 0;
  n161e[0] = 0;
  n161d[0] = 0;
  n154[0] = 0;
  n154r[0] = 0;
  n154e[0] = 0;
  n154d[0] = 0;
  n131[0] = 0;
  n129[0] = 0;
  n116[0] = 0;
  n112[0] = 0;
  n111[0] = 0;
  n577[0] = 0;
  n147[0] = 0;
  n147r[0] = 0;
  n147e[0] = 0;
  n147d[0] = 0;
  n132[0] = 0;
  n130[0] = 0;
  n113[0] = 0;
  n578[0] = 0;
  n140[0] = 0;
  n140r[0] = 0;
  n140e[0] = 0;
  n140d[0] = 0;
  { int index; for (index = 2; index > 0;) n133[--index] = 0; }
  n579[0] = 0;
  { int index; for (index = 2; index > 0;) n182[--index] = 0; }
  n182r[0] = 0;
  n182e[0] = 0;
  { int index; for (index = 2; index > 0;) n182d[--index] = 0; }
  n580[0] = 0;
  n581[0] = 0;
  n582[0] = 0;
  n583[0] = 0;
  n584[0] = 0;
  n586[0] = 0;
  n585[0] = 0;
  n590[0] = 0;
  n589[0] = 0;
  n588[0] = 0;
  n587[0] = 0;
  n593[0] = 0;
  n591[0] = 0;
  n594[0] = 0;
  n595[0] = 0;
  n602[0] = 0;
  n602r[0] = 0;
  n602e[0] = 0;
  n602d[0] = 0;
  cf_fp_mul_p_3_4_calc();
}

void cf_fp_mul_p_3_4_cycle_clock()
{
  if (n11r[0]) {
    n11[0] = 0;
  }
  else if (n11e[0]) {
    n11[0] = n11d[0];
  }
  if (n18r[0]) {
    n18[0] = 0;
  }
  else if (n18e[0]) {
    n18[0] = n18d[0];
  }
  if (n140r[0]) {
    n140[0] = 0;
  }
  else if (n140e[0]) {
    n140[0] = n140d[0];
  }
  if (n147r[0]) {
    n147[0] = 0;
  }
  else if (n147e[0]) {
    n147[0] = n147d[0];
  }
  if (n154r[0]) {
    n154[0] = 0;
  }
  else if (n154e[0]) {
    n154[0] = n154d[0];
  }
  if (n161r[0]) {
    n161[0] = 0;
  }
  else if (n161e[0]) {
    n161[0] = n161d[0];
  }
  if (n168r[0]) {
    n168[0] = 0;
  }
  else if (n168e[0]) {
    n168[0] = n168d[0];
  }
  if (n175r[0]) {
    n175[0] = 0;
  }
  else if (n175e[0]) {
    n175[0] = n175d[0];
  }
  if (n182r[0]) {
    n182[0] = 0;
    n182[1] = 0;
  }
  else if (n182e[0]) {
    n182[0] = n182d[0];
    n182[1] = n182d[1];
  }
  if (n196r[0]) {
    n196[0] = 0;
  }
  else if (n196e[0]) {
    n196[0] = n196d[0];
  }
  if (n203r[0]) {
    n203[0] = 0;
  }
  else if (n203e[0]) {
    n203[0] = n203d[0];
  }
  if (n210r[0]) {
    n210[0] = 0;
  }
  else if (n210e[0]) {
    n210[0] = n210d[0];
  }
  if (n217r[0]) {
    n217[0] = 0;
  }
  else if (n217e[0]) {
    n217[0] = n217d[0];
  }
  if (n224r[0]) {
    n224[0] = 0;
  }
  else if (n224e[0]) {
    n224[0] = n224d[0];
  }
  if (n231r[0]) {
    n231[0] = 0;
  }
  else if (n231e[0]) {
    n231[0] = n231d[0];
  }
  if (n238r[0]) {
    n238[0] = 0;
    n238[1] = 0;
  }
  else if (n238e[0]) {
    n238[0] = n238d[0];
    n238[1] = n238d[1];
  }
  if (n266r[0]) {
    n266[0] = 0;
  }
  else if (n266e[0]) {
    n266[0] = n266d[0];
  }
  if (n273r[0]) {
    n273[0] = 0;
  }
  else if (n273e[0]) {
    n273[0] = n273d[0];
  }
  if (n280r[0]) {
    n280[0] = 0;
  }
  else if (n280e[0]) {
    n280[0] = n280d[0];
  }
  if (n287r[0]) {
    n287[0] = 0;
  }
  else if (n287e[0]) {
    n287[0] = n287d[0];
  }
  if (n294r[0]) {
    n294[0] = 0;
  }
  else if (n294e[0]) {
    n294[0] = n294d[0];
  }
  if (n301r[0]) {
    n301[0] = 0;
  }
  else if (n301e[0]) {
    n301[0] = n301d[0];
  }
  if (n308r[0]) {
    n308[0] = 0;
  }
  else if (n308e[0]) {
    n308[0] = n308d[0];
  }
  if (n336r[0]) {
    n336[0] = 0;
  }
  else if (n336e[0]) {
    n336[0] = n336d[0];
  }
  if (n343r[0]) {
    n343[0] = 0;
  }
  else if (n343e[0]) {
    n343[0] = n343d[0];
  }
  if (n350r[0]) {
    n350[0] = 0;
  }
  else if (n350e[0]) {
    n350[0] = n350d[0];
  }
  if (n357r[0]) {
    n357[0] = 0;
  }
  else if (n357e[0]) {
    n357[0] = n357d[0];
  }
  if (n364r[0]) {
    n364[0] = 0;
  }
  else if (n364e[0]) {
    n364[0] = n364d[0];
  }
  if (n371r[0]) {
    n371[0] = 0;
  }
  else if (n371e[0]) {
    n371[0] = n371d[0];
  }
  if (n378r[0]) {
    n378[0] = 0;
  }
  else if (n378e[0]) {
    n378[0] = n378d[0];
  }
  if (n406r[0]) {
    n406[0] = 0;
  }
  else if (n406e[0]) {
    n406[0] = n406d[0];
  }
  if (n413r[0]) {
    n413[0] = 0;
  }
  else if (n413e[0]) {
    n413[0] = n413d[0];
  }
  if (n420r[0]) {
    n420[0] = 0;
  }
  else if (n420e[0]) {
    n420[0] = n420d[0];
  }
  if (n427r[0]) {
    n427[0] = 0;
  }
  else if (n427e[0]) {
    n427[0] = n427d[0];
  }
  if (n434r[0]) {
    n434[0] = 0;
  }
  else if (n434e[0]) {
    n434[0] = n434d[0];
  }
  if (n441r[0]) {
    n441[0] = 0;
  }
  else if (n441e[0]) {
    n441[0] = n441d[0];
  }
  if (n448r[0]) {
    n448[0] = 0;
  }
  else if (n448e[0]) {
    n448[0] = n448d[0];
  }
  if (n476r[0]) {
    n476[0] = 0;
  }
  else if (n476e[0]) {
    n476[0] = n476d[0];
  }
  if (n483r[0]) {
    n483[0] = 0;
  }
  else if (n483e[0]) {
    n483[0] = n483d[0];
  }
  if (n490r[0]) {
    n490[0] = 0;
  }
  else if (n490e[0]) {
    n490[0] = n490d[0];
  }
  if (n497r[0]) {
    n497[0] = 0;
  }
  else if (n497e[0]) {
    n497[0] = n497d[0];
  }
  if (n504r[0]) {
    n504[0] = 0;
  }
  else if (n504e[0]) {
    n504[0] = n504d[0];
  }
  if (n511r[0]) {
    n511[0] = 0;
  }
  else if (n511e[0]) {
    n511[0] = n511d[0];
  }
  if (n518r[0]) {
    n518[0] = 0;
  }
  else if (n518e[0]) {
    n518[0] = n518d[0];
  }
  if (n602r[0]) {
    n602[0] = 0;
  }
  else if (n602e[0]) {
    n602[0] = n602d[0];
  }
}

static FILE* sim_file;
static int sim_count;
static unsigned char sim_a_i[1];
static unsigned char sim_b_i[1];
static unsigned char sim_x_o[1];

void cf_fp_mul_p_3_4_sim_init(const char* file) {
  time_t date = time(NULL);
  sim_count = 1;
  cf_fp_mul_p_3_4_init();
  sim_a_i[0] = a_i[0];
  sim_b_i[0] = b_i[0];
  sim_x_o[0] = x_o[0];
  sim_file = fopen(file, "w");
  fprintf(sim_file,
    "$date\n  %s$end\n"
    "$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n"
    "$timescale\n  1 ns\n$end\n"
    "$scope module cf_fp_mul_p_3_4 $end\n"
    "$var wire 8 ! a_i $end\n"
    "$var wire 8 \" b_i $end\n"
    "$var wire 8 # x_o $end\n"
    "$upscope $end\n"
    "$enddefinitions $end\n"
    "#0\n"
    "$dumpvars\n", asctime(localtime(&date)));
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 0; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
        else if (bit & a_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " !\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 0; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
        else if (bit & b_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " \"\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 0; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
        else if (bit & x_o[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " #\n");
  }
  fprintf(sim_file, "$end\n");
}

void cf_fp_mul_p_3_4_sim_end() {
  fprintf(sim_file, "#%d\n", sim_count);
  fclose(sim_file);
}

void cf_fp_mul_p_3_4_sim_sample() {
  int changed = 0;
  if (sim_a_i[0] != a_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 0; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
          else if (bit & a_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " !\n");
    }
    sim_a_i[0] = a_i[0];
  }
  if (sim_b_i[0] != b_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 0; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
          else if (bit & b_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " \"\n");
    }
    sim_b_i[0] = b_i[0];
  }
  if (sim_x_o[0] != x_o[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 0; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
          else if (bit & x_o[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " #\n");
    }
    sim_x_o[0] = x_o[0];
  }
  sim_count++;
}

