#
#  Copyright (c) 2003 Launchbird Design Systems, Inc.
#  All rights reserved.
#  
#  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#  
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#  
#  
#  Overview:
#  
#    Performs floating point multiply.
#  
#  Interface:
#  
#    Synchronization:
#      clock_c  : Clock input.
#  
#    Inputs:
#      a_i : Left operand.
#      b_i : Right operand.
#  
#    Outputs:
#      x_o : Result.
#  
#  Built In Parameters:
#  
#    Exponent Precision = 3
#    Mantissa Precision = 4
#    Total    Precision = 8
#    Pipeline Latency   = 8 clock cycles
#  
#  
#  
#  
#  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
#  
#  Build Date : Fri Aug 22 09:47:00 CDT 2003
#  
#  Interface
#  
#    Build Name    : cf_fp_mul_p_3_4
#    Clock Domains : clock_c  
#    Vector Input  : a_i(8)
#    Vector Input  : b_i(8)
#    Vector Output : x_o(8)
#  
#  
#  

import sys
import time

class cf_fp_mul_p_3_4:

  def init(self):
    self.n610 = 0L
    self.n608 = 0L
    self.n606 = 0L
    self.n604 = 0L
    self.n603 = 0L
    self.n568 = 0L
    self.n566 = 0L
    self.n564 = 0L
    self.n562 = 0L
    self.n560 = 0L
    self.n558 = 0L
    self.n556 = 0L
    self.n554 = 0L
    self.n552 = 0L
    self.n550 = 0L
    self.n548 = 0L
    self.n546 = 0L
    self.n544 = 0L
    self.n542 = 0L
    self.n540 = 0L
    self.n539 = 0L
    self.n538 = 0L
    self.n537 = 0L
    self.n536 = 0L
    self.n535 = 0L
    self.n532 = 0L
    self.n522 = 0L
    self.n520 = 0L
    self.n519 = 0L
    self.n468 = 0L
    self.n467 = 0L
    self.n464 = 0L
    self.n451 = 0L
    self.n450 = 0L
    self.n449 = 0L
    self.n398 = 0L
    self.n397 = 0L
    self.n394 = 0L
    self.n381 = 0L
    self.n380 = 0L
    self.n379 = 0L
    self.n328 = 0L
    self.n327 = 0L
    self.n324 = 0L
    self.n311 = 0L
    self.n310 = 0L
    self.n309 = 0L
    self.n258 = 0L
    self.n257 = 0L
    self.n254 = 0L
    self.n241 = 0L
    self.n240 = 0L
    self.n239 = 0L
    self.n188 = 0L
    self.n187 = 0L
    self.n184 = 0L
    self.n183 = 0L
    self.n122 = 0L
    self.n120 = 0L
    self.n70 = 0L
    self.n69 = 0L
    self.n27 = 0L
    self.n26 = 0L
    self.n24 = 0L
    self.n23 = 0L
    self.n22 = 0L
    self.n21 = 0L
    self.n20 = 0L
    self.n19 = 0L
    self.n4 = 0L
    self.n3 = 0L
    self.n2 = 0L
    self.n1 = 0L
    self.n533 = 0L
    self.n521 = 0L
    self.n504 = 0L
    self.n504r = 0L
    self.n504e = 0L
    self.n504d = 0L
    self.n497 = 0L
    self.n497r = 0L
    self.n497e = 0L
    self.n497d = 0L
    self.n490 = 0L
    self.n490r = 0L
    self.n490e = 0L
    self.n490d = 0L
    self.n483 = 0L
    self.n483r = 0L
    self.n483e = 0L
    self.n483d = 0L
    self.n476 = 0L
    self.n476r = 0L
    self.n476e = 0L
    self.n476d = 0L
    self.n465 = 0L
    self.n453 = 0L
    self.n452 = 0L
    self.n434 = 0L
    self.n434r = 0L
    self.n434e = 0L
    self.n434d = 0L
    self.n427 = 0L
    self.n427r = 0L
    self.n427e = 0L
    self.n427d = 0L
    self.n420 = 0L
    self.n420r = 0L
    self.n420e = 0L
    self.n420d = 0L
    self.n413 = 0L
    self.n413r = 0L
    self.n413e = 0L
    self.n413d = 0L
    self.n406 = 0L
    self.n406r = 0L
    self.n406e = 0L
    self.n406d = 0L
    self.n395 = 0L
    self.n383 = 0L
    self.n382 = 0L
    self.n364 = 0L
    self.n364r = 0L
    self.n364e = 0L
    self.n364d = 0L
    self.n357 = 0L
    self.n357r = 0L
    self.n357e = 0L
    self.n357d = 0L
    self.n350 = 0L
    self.n350r = 0L
    self.n350e = 0L
    self.n350d = 0L
    self.n343 = 0L
    self.n343r = 0L
    self.n343e = 0L
    self.n343d = 0L
    self.n336 = 0L
    self.n336r = 0L
    self.n336e = 0L
    self.n336d = 0L
    self.n325 = 0L
    self.n313 = 0L
    self.n312 = 0L
    self.n294 = 0L
    self.n294r = 0L
    self.n294e = 0L
    self.n294d = 0L
    self.n287 = 0L
    self.n287r = 0L
    self.n287e = 0L
    self.n287d = 0L
    self.n280 = 0L
    self.n280r = 0L
    self.n280e = 0L
    self.n280d = 0L
    self.n273 = 0L
    self.n273r = 0L
    self.n273e = 0L
    self.n273d = 0L
    self.n266 = 0L
    self.n266r = 0L
    self.n266e = 0L
    self.n266d = 0L
    self.n255 = 0L
    self.n243 = 0L
    self.n242 = 0L
    self.n224 = 0L
    self.n224r = 0L
    self.n224e = 0L
    self.n224d = 0L
    self.n217 = 0L
    self.n217r = 0L
    self.n217e = 0L
    self.n217d = 0L
    self.n210 = 0L
    self.n210r = 0L
    self.n210e = 0L
    self.n210d = 0L
    self.n203 = 0L
    self.n203r = 0L
    self.n203e = 0L
    self.n203d = 0L
    self.n196 = 0L
    self.n196r = 0L
    self.n196e = 0L
    self.n196d = 0L
    self.n189 = 0L
    self.n185 = 0L
    self.n123 = 0L
    self.n121 = 0L
    self.n119 = 0L
    self.n102 = 0L
    self.n100 = 0L
    self.n89 = 0L
    self.n88 = 0L
    self.n80 = 0L
    self.n79 = 0L
    self.n72 = 0L
    self.n71 = 0L
    self.n59 = 0L
    self.n57 = 0L
    self.n46 = 0L
    self.n45 = 0L
    self.n37 = 0L
    self.n36 = 0L
    self.n29 = 0L
    self.n28 = 0L
    self.n18 = 0L
    self.n18r = 0L
    self.n18e = 0L
    self.n18d = 0L
    self.n11 = 0L
    self.n11r = 0L
    self.n11e = 0L
    self.n11d = 0L
    self.n534 = 0L
    self.n458 = 0L
    self.n455 = 0L
    self.n454 = 0L
    self.n388 = 0L
    self.n385 = 0L
    self.n384 = 0L
    self.n318 = 0L
    self.n315 = 0L
    self.n314 = 0L
    self.n248 = 0L
    self.n245 = 0L
    self.n244 = 0L
    self.n238 = 0L
    self.n238r = 0L
    self.n238e = 0L
    self.n238d = 0L
    self.n186 = 0L
    self.n168 = 0L
    self.n168r = 0L
    self.n168e = 0L
    self.n168d = 0L
    self.n124 = 0L
    self.n103 = 0L
    self.n91 = 0L
    self.n90 = 0L
    self.n82 = 0L
    self.n81 = 0L
    self.n74 = 0L
    self.n73 = 0L
    self.n60 = 0L
    self.n48 = 0L
    self.n47 = 0L
    self.n39 = 0L
    self.n38 = 0L
    self.n31 = 0L
    self.n30 = 0L
    self.n569 = 0L
    self.n567 = 0L
    self.n565 = 0L
    self.n563 = 0L
    self.n561 = 0L
    self.n559 = 0L
    self.n557 = 0L
    self.n555 = 0L
    self.n553 = 0L
    self.n551 = 0L
    self.n549 = 0L
    self.n547 = 0L
    self.n545 = 0L
    self.n543 = 0L
    self.n541 = 0L
    self.n456 = 0L
    self.n386 = 0L
    self.n316 = 0L
    self.n246 = 0L
    self.n231 = 0L
    self.n231r = 0L
    self.n231e = 0L
    self.n231d = 0L
    self.n128 = 0L
    self.n96 = 0L
    self.n93 = 0L
    self.n92 = 0L
    self.n85 = 0L
    self.n83 = 0L
    self.n77 = 0L
    self.n75 = 0L
    self.n53 = 0L
    self.n50 = 0L
    self.n49 = 0L
    self.n42 = 0L
    self.n40 = 0L
    self.n34 = 0L
    self.n32 = 0L
    self.n570 = 0L
    self.n459 = 0L
    self.n389 = 0L
    self.n319 = 0L
    self.n249 = 0L
    self.n175 = 0L
    self.n175r = 0L
    self.n175e = 0L
    self.n175d = 0L
    self.n94 = 0L
    self.n86 = 0L
    self.n78 = 0L
    self.n51 = 0L
    self.n43 = 0L
    self.n35 = 0L
    self.n571 = 0L
    self.n460 = 0L
    self.n390 = 0L
    self.n320 = 0L
    self.n250 = 0L
    self.n104 = 0L
    self.n101 = 0L
    self.n97 = 0L
    self.n87 = 0L
    self.n61 = 0L
    self.n58 = 0L
    self.n54 = 0L
    self.n44 = 0L
    self.n572 = 0L
    self.n461 = 0L
    self.n391 = 0L
    self.n321 = 0L
    self.n251 = 0L
    self.n98 = 0L
    self.n55 = 0L
    self.n573 = 0L
    self.n462 = 0L
    self.n392 = 0L
    self.n322 = 0L
    self.n252 = 0L
    self.n99 = 0L
    self.n56 = 0L
    self.n574 = 0L
    self.n463 = 0L
    self.n393 = 0L
    self.n323 = 0L
    self.n253 = 0L
    self.n109 = 0L
    self.n108 = 0L
    self.n107 = 0L
    self.n105 = 0L
    self.n66 = 0L
    self.n65 = 0L
    self.n64 = 0L
    self.n62 = 0L
    self.n575 = 0L
    self.n469 = 0L
    self.n466 = 0L
    self.n399 = 0L
    self.n396 = 0L
    self.n329 = 0L
    self.n326 = 0L
    self.n259 = 0L
    self.n256 = 0L
    self.n118 = 0L
    self.n117 = 0L
    self.n115 = 0L
    self.n114 = 0L
    self.n110 = 0L
    self.n106 = 0L
    self.n67 = 0L
    self.n63 = 0L
    self.n576 = 0L
    self.n518 = 0L
    self.n518r = 0L
    self.n518e = 0L
    self.n518d = 0L
    self.n511 = 0L
    self.n511r = 0L
    self.n511e = 0L
    self.n511d = 0L
    self.n448 = 0L
    self.n448r = 0L
    self.n448e = 0L
    self.n448d = 0L
    self.n441 = 0L
    self.n441r = 0L
    self.n441e = 0L
    self.n441d = 0L
    self.n378 = 0L
    self.n378r = 0L
    self.n378e = 0L
    self.n378d = 0L
    self.n371 = 0L
    self.n371r = 0L
    self.n371e = 0L
    self.n371d = 0L
    self.n308 = 0L
    self.n308r = 0L
    self.n308e = 0L
    self.n308d = 0L
    self.n301 = 0L
    self.n301r = 0L
    self.n301e = 0L
    self.n301d = 0L
    self.n161 = 0L
    self.n161r = 0L
    self.n161e = 0L
    self.n161d = 0L
    self.n154 = 0L
    self.n154r = 0L
    self.n154e = 0L
    self.n154d = 0L
    self.n131 = 0L
    self.n129 = 0L
    self.n116 = 0L
    self.n112 = 0L
    self.n111 = 0L
    self.n577 = 0L
    self.n147 = 0L
    self.n147r = 0L
    self.n147e = 0L
    self.n147d = 0L
    self.n132 = 0L
    self.n130 = 0L
    self.n113 = 0L
    self.n578 = 0L
    self.n140 = 0L
    self.n140r = 0L
    self.n140e = 0L
    self.n140d = 0L
    self.n133 = 0L
    self.n579 = 0L
    self.n182 = 0L
    self.n182r = 0L
    self.n182e = 0L
    self.n182d = 0L
    self.n580 = 0L
    self.n581 = 0L
    self.n582 = 0L
    self.n583 = 0L
    self.n584 = 0L
    self.n586 = 0L
    self.n585 = 0L
    self.n590 = 0L
    self.n589 = 0L
    self.n588 = 0L
    self.n587 = 0L
    self.n593 = 0L
    self.n591 = 0L
    self.n594 = 0L
    self.n595 = 0L
    self.n602 = 0L
    self.n602r = 0L
    self.n602e = 0L
    self.n602d = 0L
    self.calc(0L, 0L, )

  def calc(self, a_i, b_i, ):
    self.n610 = 0x77L
    self.n608 = 0x7FL
    self.n606 = 0x70L
    self.n604 = 0x3L
    x_o = self.n602
    self.n603 = self.n602
    self.n568 = 0x1L
    self.n566 = 0x3L
    self.n564 = 0x2L
    self.n562 = 0x7L
    self.n560 = 0x6L
    self.n558 = 0x5L
    self.n556 = 0x4L
    self.n554 = 0xFL
    self.n552 = 0xEL
    self.n550 = 0xDL
    self.n548 = 0xCL
    self.n546 = 0xBL
    self.n544 = 0xAL
    self.n542 = 0x9L
    self.n540 = 0x8L
    self.n539 = 0x4L
    self.n538 = 0x3L
    self.n537 = 0x2L
    self.n536 = 0x1L
    self.n535 = 0x0L
    self.n532 = self.n490 << 1 | self.n497
    self.n522 = 0x00L
    self.n520 = (self.n518 & 0x8L) | (self.n518 & 0x4L) | (self.n518 & 0x2L) | (self.n518 & 0x1L)
    self.n519 = (self.n511 & 0x4L) | (self.n511 & 0x2L) | (self.n511 & 0x1L)
    self.n468 = ((self.n448 & 0x20L) >> 1) | ((self.n448 & 0x10L) >> 1) | ((self.n448 & 0x8L) >> 1) | ((self.n448 & 0x4L) >> 1) | ((self.n448 & 0x2L) >> 1)
    self.n467 = (self.n448 & 0x10L) | (self.n448 & 0x8L) | (self.n448 & 0x4L) | (self.n448 & 0x2L) | (self.n448 & 0x1L)
    self.n464 = 0x1L
    self.n451 = (self.n441 & 0x4L) | (self.n441 & 0x2L) | (self.n441 & 0x1L)
    self.n450 = ((self.n441 & 0x8L) >> 3)
    self.n449 = ((self.n448 & 0x20L) >> 5)
    self.n398 = ((self.n378 & 0x40L) >> 1) | ((self.n378 & 0x20L) >> 1) | ((self.n378 & 0x10L) >> 1) | ((self.n378 & 0x8L) >> 1) | ((self.n378 & 0x4L) >> 1) | ((self.n378 & 0x2L) >> 1)
    self.n397 = (self.n378 & 0x20L) | (self.n378 & 0x10L) | (self.n378 & 0x8L) | (self.n378 & 0x4L) | (self.n378 & 0x2L) | (self.n378 & 0x1L)
    self.n394 = 0x1L
    self.n381 = (self.n371 & 0x4L) | (self.n371 & 0x2L) | (self.n371 & 0x1L)
    self.n380 = ((self.n371 & 0x8L) >> 3)
    self.n379 = ((self.n378 & 0x40L) >> 6)
    self.n328 = ((self.n308 & 0x80L) >> 1) | ((self.n308 & 0x40L) >> 1) | ((self.n308 & 0x20L) >> 1) | ((self.n308 & 0x10L) >> 1) | ((self.n308 & 0x8L) >> 1) | ((self.n308 & 0x4L) >> 1) | ((self.n308 & 0x2L) >> 1)
    self.n327 = (self.n308 & 0x40L) | (self.n308 & 0x20L) | (self.n308 & 0x10L) | (self.n308 & 0x8L) | (self.n308 & 0x4L) | (self.n308 & 0x2L) | (self.n308 & 0x1L)
    self.n324 = 0x1L
    self.n311 = (self.n301 & 0x4L) | (self.n301 & 0x2L) | (self.n301 & 0x1L)
    self.n310 = ((self.n301 & 0x8L) >> 3)
    self.n309 = ((self.n308 & 0x80L) >> 7)
    self.n258 = ((self.n238 & 0x100L) >> 1) | ((self.n238 & 0x80L) >> 1) | ((self.n238 & 0x40L) >> 1) | ((self.n238 & 0x20L) >> 1) | ((self.n238 & 0x10L) >> 1) | ((self.n238 & 0x8L) >> 1) | ((self.n238 & 0x4L) >> 1) | ((self.n238 & 0x2L) >> 1)
    self.n257 = (self.n238 & 0x80L) | (self.n238 & 0x40L) | (self.n238 & 0x20L) | (self.n238 & 0x10L) | (self.n238 & 0x8L) | (self.n238 & 0x4L) | (self.n238 & 0x2L) | (self.n238 & 0x1L)
    self.n254 = 0x1L
    self.n241 = (self.n231 & 0x4L) | (self.n231 & 0x2L) | (self.n231 & 0x1L)
    self.n240 = ((self.n231 & 0x8L) >> 3)
    self.n239 = ((self.n238 & 0x100L) >> 8)
    self.n188 = (self.n182 & 0x100L) | (self.n182 & 0x80L) | (self.n182 & 0x40L) | (self.n182 & 0x20L) | (self.n182 & 0x10L) | (self.n182 & 0x8L) | (self.n182 & 0x4L) | (self.n182 & 0x2L) | (self.n182 & 0x1L)
    self.n187 = ((self.n182 & 0x200L) >> 1) | ((self.n182 & 0x100L) >> 1) | ((self.n182 & 0x80L) >> 1) | ((self.n182 & 0x40L) >> 1) | ((self.n182 & 0x20L) >> 1) | ((self.n182 & 0x10L) >> 1) | ((self.n182 & 0x8L) >> 1) | ((self.n182 & 0x4L) >> 1) | ((self.n182 & 0x2L) >> 1)
    self.n184 = 0x1L
    self.n183 = ((self.n182 & 0x200L) >> 9)
    self.n122 = 0x0L
    self.n120 = 0x0L
    self.n70 = (self.n18 & 0x8L) | (self.n18 & 0x4L) | (self.n18 & 0x2L) | (self.n18 & 0x1L)
    self.n69 = ((self.n18 & 0x40L) >> 4) | ((self.n18 & 0x20L) >> 4) | ((self.n18 & 0x10L) >> 4)
    self.n27 = (self.n11 & 0x8L) | (self.n11 & 0x4L) | (self.n11 & 0x2L) | (self.n11 & 0x1L)
    self.n26 = ((self.n11 & 0x40L) >> 4) | ((self.n11 & 0x20L) >> 4) | ((self.n11 & 0x10L) >> 4)
    self.n24 = (self.n18 & 0x8L) | (self.n18 & 0x4L) | (self.n18 & 0x2L) | (self.n18 & 0x1L)
    self.n23 = ((self.n18 & 0x40L) >> 4) | ((self.n18 & 0x20L) >> 4) | ((self.n18 & 0x10L) >> 4)
    self.n22 = ((self.n18 & 0x80L) >> 7)
    self.n21 = (self.n11 & 0x8L) | (self.n11 & 0x4L) | (self.n11 & 0x2L) | (self.n11 & 0x1L)
    self.n20 = ((self.n11 & 0x40L) >> 4) | ((self.n11 & 0x20L) >> 4) | ((self.n11 & 0x10L) >> 4)
    self.n19 = ((self.n11 & 0x80L) >> 7)
    self.n4 = b_i
    self.n3 = a_i
    self.n2 = 0x0L
    self.n1 = 0x1L
    self.n533 = self.n483 << 2 | self.n532
    self.n521 = self.n519 << 4 | self.n520
    self.n504r = self.n2
    self.n504e = self.n1
    self.n504d = self.n434
    self.n497r = self.n2
    self.n497e = self.n1
    self.n497d = self.n427
    self.n490r = self.n2
    self.n490e = self.n1
    self.n490d = self.n420
    self.n483r = self.n2
    self.n483e = self.n1
    self.n483d = self.n413
    self.n476r = self.n2
    self.n476e = self.n1
    self.n476d = self.n406
    self.n465 = (self.n441 - self.n464) & 0xFL
    self.n453 = (self.n451 & 0x2L) | (self.n451 & 0x1L)
    self.n452 = ((self.n451 & 0x4L) >> 2)
    self.n434r = self.n2
    self.n434e = self.n1
    self.n434d = self.n364
    self.n427r = self.n2
    self.n427e = self.n1
    self.n427d = self.n357
    self.n420r = self.n2
    self.n420e = self.n1
    self.n420d = self.n350
    self.n413r = self.n2
    self.n413e = self.n1
    self.n413d = self.n343
    self.n406r = self.n2
    self.n406e = self.n1
    self.n406d = self.n336
    self.n395 = (self.n371 - self.n394) & 0xFL
    self.n383 = (self.n381 & 0x2L) | (self.n381 & 0x1L)
    self.n382 = ((self.n381 & 0x4L) >> 2)
    self.n364r = self.n2
    self.n364e = self.n1
    self.n364d = self.n294
    self.n357r = self.n2
    self.n357e = self.n1
    self.n357d = self.n287
    self.n350r = self.n2
    self.n350e = self.n1
    self.n350d = self.n280
    self.n343r = self.n2
    self.n343e = self.n1
    self.n343d = self.n273
    self.n336r = self.n2
    self.n336e = self.n1
    self.n336d = self.n266
    self.n325 = (self.n301 - self.n324) & 0xFL
    self.n313 = (self.n311 & 0x2L) | (self.n311 & 0x1L)
    self.n312 = ((self.n311 & 0x4L) >> 2)
    self.n294r = self.n2
    self.n294e = self.n1
    self.n294d = self.n224
    self.n287r = self.n2
    self.n287e = self.n1
    self.n287d = self.n217
    self.n280r = self.n2
    self.n280e = self.n1
    self.n280d = self.n210
    self.n273r = self.n2
    self.n273e = self.n1
    self.n273d = self.n203
    self.n266r = self.n2
    self.n266e = self.n1
    self.n266d = self.n196
    self.n255 = (self.n231 - self.n254) & 0xFL
    self.n243 = (self.n241 & 0x2L) | (self.n241 & 0x1L)
    self.n242 = ((self.n241 & 0x4L) >> 2)
    self.n224r = self.n2
    self.n224e = self.n1
    self.n224d = self.n168
    self.n217r = self.n2
    self.n217e = self.n1
    self.n217d = self.n161
    self.n210r = self.n2
    self.n210e = self.n1
    self.n210d = self.n154
    self.n203r = self.n2
    self.n203e = self.n1
    self.n203d = self.n147
    self.n196r = self.n2
    self.n196e = self.n1
    self.n196d = self.n140
    if self.n183:
      self.n189 = self.n187
    else:
      self.n189 = self.n188
    self.n185 = (self.n175 + self.n184) & 0xFL
    self.n123 = self.n122 << 3 | self.n23
    self.n121 = self.n120 << 3 | self.n20
    self.n119 = self.n19 ^ self.n22
    self.n102 = ((self.n70 & 0x8L) >> 3)
    self.n100 = ((self.n70 & 0x8L) >> 3)
    self.n89 = (self.n70 & 0x4L) | (self.n70 & 0x2L) | (self.n70 & 0x1L)
    self.n88 = ((self.n70 & 0x8L) >> 3)
    self.n80 = (self.n69 & 0x2L) | (self.n69 & 0x1L)
    self.n79 = ((self.n69 & 0x4L) >> 2)
    self.n72 = (self.n69 & 0x2L) | (self.n69 & 0x1L)
    self.n71 = ((self.n69 & 0x4L) >> 2)
    self.n59 = ((self.n27 & 0x8L) >> 3)
    self.n57 = ((self.n27 & 0x8L) >> 3)
    self.n46 = (self.n27 & 0x4L) | (self.n27 & 0x2L) | (self.n27 & 0x1L)
    self.n45 = ((self.n27 & 0x8L) >> 3)
    self.n37 = (self.n26 & 0x2L) | (self.n26 & 0x1L)
    self.n36 = ((self.n26 & 0x4L) >> 2)
    self.n29 = (self.n26 & 0x2L) | (self.n26 & 0x1L)
    self.n28 = ((self.n26 & 0x4L) >> 2)
    self.n18r = self.n2
    self.n18e = self.n1
    self.n18d = self.n4
    self.n11r = self.n2
    self.n11e = self.n1
    self.n11d = self.n3
    self.n534 = self.n476 << 3 | self.n533
    self.n458 = self.n450 | self.n452
    self.n455 = (self.n453 & 0x1L)
    self.n454 = ((self.n453 & 0x2L) >> 1)
    self.n388 = self.n380 | self.n382
    self.n385 = (self.n383 & 0x1L)
    self.n384 = ((self.n383 & 0x2L) >> 1)
    self.n318 = self.n310 | self.n312
    self.n315 = (self.n313 & 0x1L)
    self.n314 = ((self.n313 & 0x2L) >> 1)
    self.n248 = self.n240 | self.n242
    self.n245 = (self.n243 & 0x1L)
    self.n244 = ((self.n243 & 0x2L) >> 1)
    self.n238r = self.n2
    self.n238e = self.n1
    self.n238d = self.n189
    if self.n183:
      self.n186 = self.n185
    else:
      self.n186 = self.n175
    self.n168r = self.n2
    self.n168e = self.n1
    self.n168d = self.n119
    self.n124 = (self.n121 + self.n123) & 0xFL
    self.n103 = ~self.n102 & 0x1L
    self.n91 = (self.n89 & 0x2L) | (self.n89 & 0x1L)
    self.n90 = ((self.n89 & 0x4L) >> 2)
    self.n82 = (self.n80 & 0x1L)
    self.n81 = ((self.n80 & 0x2L) >> 1)
    self.n74 = (self.n72 & 0x1L)
    self.n73 = ((self.n72 & 0x2L) >> 1)
    self.n60 = ~self.n59 & 0x1L
    self.n48 = (self.n46 & 0x2L) | (self.n46 & 0x1L)
    self.n47 = ((self.n46 & 0x4L) >> 2)
    self.n39 = (self.n37 & 0x1L)
    self.n38 = ((self.n37 & 0x2L) >> 1)
    self.n31 = (self.n29 & 0x1L)
    self.n30 = ((self.n29 & 0x2L) >> 1)
    if self.n534 == self.n568:
      self.n569 = 1L
    else:
      self.n569 = 0L
    if self.n534 == self.n566:
      self.n567 = 1L
    else:
      self.n567 = 0L
    if self.n534 == self.n564:
      self.n565 = 1L
    else:
      self.n565 = 0L
    if self.n534 == self.n562:
      self.n563 = 1L
    else:
      self.n563 = 0L
    if self.n534 == self.n560:
      self.n561 = 1L
    else:
      self.n561 = 0L
    if self.n534 == self.n558:
      self.n559 = 1L
    else:
      self.n559 = 0L
    if self.n534 == self.n556:
      self.n557 = 1L
    else:
      self.n557 = 0L
    if self.n534 == self.n554:
      self.n555 = 1L
    else:
      self.n555 = 0L
    if self.n534 == self.n552:
      self.n553 = 1L
    else:
      self.n553 = 0L
    if self.n534 == self.n550:
      self.n551 = 1L
    else:
      self.n551 = 0L
    if self.n534 == self.n548:
      self.n549 = 1L
    else:
      self.n549 = 0L
    if self.n534 == self.n546:
      self.n547 = 1L
    else:
      self.n547 = 0L
    if self.n534 == self.n544:
      self.n545 = 1L
    else:
      self.n545 = 0L
    if self.n534 == self.n542:
      self.n543 = 1L
    else:
      self.n543 = 0L
    if self.n534 == self.n540:
      self.n541 = 1L
    else:
      self.n541 = 0L
    self.n456 = (self.n455 & 0x1L)
    self.n386 = (self.n385 & 0x1L)
    self.n316 = (self.n315 & 0x1L)
    self.n246 = (self.n245 & 0x1L)
    self.n231r = self.n2
    self.n231e = self.n1
    self.n231d = self.n186
    self.n128 = (self.n124 - self.n604) & 0xFL
    self.n96 = self.n88 | self.n90
    self.n93 = (self.n91 & 0x1L)
    self.n92 = ((self.n91 & 0x2L) >> 1)
    self.n85 = self.n79 | self.n81
    self.n83 = (self.n82 & 0x1L)
    self.n77 = self.n71 & self.n73
    self.n75 = (self.n74 & 0x1L)
    self.n53 = self.n45 | self.n47
    self.n50 = (self.n48 & 0x1L)
    self.n49 = ((self.n48 & 0x2L) >> 1)
    self.n42 = self.n36 | self.n38
    self.n40 = (self.n39 & 0x1L)
    self.n34 = self.n28 & self.n30
    self.n32 = (self.n31 & 0x1L)
    if self.n569:
      self.n570 = self.n536
    else:
      self.n570 = self.n535
    self.n459 = self.n454 | self.n456
    self.n389 = self.n384 | self.n386
    self.n319 = self.n314 | self.n316
    self.n249 = self.n244 | self.n246
    self.n175r = self.n2
    self.n175e = self.n1
    self.n175d = self.n128
    self.n94 = (self.n93 & 0x1L)
    self.n86 = self.n85 | self.n83
    self.n78 = self.n77 & self.n75
    self.n51 = (self.n50 & 0x1L)
    self.n43 = self.n42 | self.n40
    self.n35 = self.n34 & self.n32
    if self.n567:
      self.n571 = self.n537
    else:
      self.n571 = self.n570
    self.n460 = self.n458 | self.n459
    self.n390 = self.n388 | self.n389
    self.n320 = self.n318 | self.n319
    self.n250 = self.n248 | self.n249
    self.n104 = self.n78 & self.n103
    self.n101 = self.n78 & self.n100
    self.n97 = self.n92 | self.n94
    self.n87 = ~self.n86 & 0x1L
    self.n61 = self.n35 & self.n60
    self.n58 = self.n35 & self.n57
    self.n54 = self.n49 | self.n51
    self.n44 = ~self.n43 & 0x1L
    if self.n565:
      self.n572 = self.n537
    else:
      self.n572 = self.n571
    self.n461 = ~self.n460 & 0x1L
    self.n391 = ~self.n390 & 0x1L
    self.n321 = ~self.n320 & 0x1L
    self.n251 = ~self.n250 & 0x1L
    self.n98 = self.n96 | self.n97
    self.n55 = self.n53 | self.n54
    if self.n563:
      self.n573 = self.n538
    else:
      self.n573 = self.n572
    self.n462 = self.n449 | self.n461
    self.n392 = self.n379 | self.n391
    self.n322 = self.n309 | self.n321
    self.n252 = self.n239 | self.n251
    self.n99 = ~self.n98 & 0x1L
    self.n56 = ~self.n55 & 0x1L
    if self.n561:
      self.n574 = self.n538
    else:
      self.n574 = self.n573
    self.n463 = ~self.n462 & 0x1L
    self.n393 = ~self.n392 & 0x1L
    self.n323 = ~self.n322 & 0x1L
    self.n253 = ~self.n252 & 0x1L
    self.n109 = ~self.n99 & 0x1L
    self.n108 = self.n87 & self.n99
    self.n107 = self.n78 & self.n99
    self.n105 = ~self.n99 & 0x1L
    self.n66 = ~self.n56 & 0x1L
    self.n65 = self.n44 & self.n56
    self.n64 = self.n35 & self.n56
    self.n62 = ~self.n56 & 0x1L
    if self.n559:
      self.n575 = self.n538
    else:
      self.n575 = self.n574
    if self.n463:
      self.n469 = self.n467
    else:
      self.n469 = self.n468
    if self.n463:
      self.n466 = self.n465
    else:
      self.n466 = self.n441
    if self.n393:
      self.n399 = self.n397
    else:
      self.n399 = self.n398
    if self.n393:
      self.n396 = self.n395
    else:
      self.n396 = self.n371
    if self.n323:
      self.n329 = self.n327
    else:
      self.n329 = self.n328
    if self.n323:
      self.n326 = self.n325
    else:
      self.n326 = self.n301
    if self.n253:
      self.n259 = self.n257
    else:
      self.n259 = self.n258
    if self.n253:
      self.n256 = self.n255
    else:
      self.n256 = self.n231
    self.n118 = self.n65 | self.n108
    self.n117 = self.n64 | self.n107
    self.n115 = self.n65 & self.n107
    self.n114 = self.n64 & self.n108
    self.n110 = self.n87 & self.n109
    self.n106 = self.n104 & self.n105
    self.n67 = self.n44 & self.n66
    self.n63 = self.n61 & self.n62
    if self.n557:
      self.n576 = self.n538
    else:
      self.n576 = self.n575
    self.n518r = self.n2
    self.n518e = self.n1
    self.n518d = self.n469
    self.n511r = self.n2
    self.n511e = self.n1
    self.n511d = self.n466
    self.n448r = self.n2
    self.n448e = self.n1
    self.n448d = self.n399
    self.n441r = self.n2
    self.n441e = self.n1
    self.n441d = self.n396
    self.n378r = self.n2
    self.n378e = self.n1
    self.n378d = self.n329
    self.n371r = self.n2
    self.n371e = self.n1
    self.n371d = self.n326
    self.n308r = self.n2
    self.n308e = self.n1
    self.n308d = self.n259
    self.n301r = self.n2
    self.n301e = self.n1
    self.n301d = self.n256
    self.n161r = self.n2
    self.n161e = self.n1
    self.n161d = self.n118
    self.n154r = self.n2
    self.n154e = self.n1
    self.n154d = self.n117
    self.n131 = ~self.n110 & 0x1L
    self.n129 = ~self.n67 & 0x1L
    self.n116 = self.n114 | self.n115
    self.n112 = self.n106 | self.n101
    self.n111 = self.n63 | self.n58
    if self.n555:
      self.n577 = self.n539
    else:
      self.n577 = self.n576
    self.n147r = self.n2
    self.n147e = self.n1
    self.n147d = self.n116
    self.n132 = self.n131 << 4 | self.n24
    self.n130 = self.n129 << 4 | self.n21
    self.n113 = self.n111 | self.n112
    if self.n553:
      self.n578 = self.n539
    else:
      self.n578 = self.n577
    self.n140r = self.n2
    self.n140e = self.n1
    self.n140d = self.n113
    self.n133 = (self.n130 * self.n132) & 0x3FFL
    if self.n551:
      self.n579 = self.n539
    else:
      self.n579 = self.n578
    self.n182r = self.n2
    self.n182e = self.n1
    self.n182d = self.n133
    if self.n549:
      self.n580 = self.n539
    else:
      self.n580 = self.n579
    if self.n547:
      self.n581 = self.n539
    else:
      self.n581 = self.n580
    if self.n545:
      self.n582 = self.n539
    else:
      self.n582 = self.n581
    if self.n543:
      self.n583 = self.n539
    else:
      self.n583 = self.n582
    if self.n541:
      self.n584 = self.n539
    else:
      self.n584 = self.n583
    self.n586 = (self.n584 & 0x1L)
    self.n585 = ((self.n584 & 0x4L) >> 1) | ((self.n584 & 0x2L) >> 1)
    self.n590 = (self.n585 & 0x1L)
    self.n589 = ((self.n585 & 0x2L) >> 1)
    if self.n586:
      self.n588 = self.n608
    else:
      self.n588 = self.n606
    if self.n586:
      self.n587 = self.n522
    else:
      self.n587 = self.n521
    self.n593 = (self.n589 & 0x1L)
    if self.n590:
      self.n591 = self.n588
    else:
      self.n591 = self.n587
    if self.n593:
      self.n594 = self.n610
    else:
      self.n594 = self.n591
    self.n595 = self.n504 << 7 | self.n594
    self.n602r = self.n2
    self.n602e = self.n1
    self.n602d = self.n595
    return (x_o, )

  def cycle_clock(self):
    if self.n11r:
      self.n11 = 0L
    elif self.n11e:
        self.n11 = self.n11d
    if self.n18r:
      self.n18 = 0L
    elif self.n18e:
        self.n18 = self.n18d
    if self.n140r:
      self.n140 = 0L
    elif self.n140e:
        self.n140 = self.n140d
    if self.n147r:
      self.n147 = 0L
    elif self.n147e:
        self.n147 = self.n147d
    if self.n154r:
      self.n154 = 0L
    elif self.n154e:
        self.n154 = self.n154d
    if self.n161r:
      self.n161 = 0L
    elif self.n161e:
        self.n161 = self.n161d
    if self.n168r:
      self.n168 = 0L
    elif self.n168e:
        self.n168 = self.n168d
    if self.n175r:
      self.n175 = 0L
    elif self.n175e:
        self.n175 = self.n175d
    if self.n182r:
      self.n182 = 0L
    elif self.n182e:
        self.n182 = self.n182d
    if self.n196r:
      self.n196 = 0L
    elif self.n196e:
        self.n196 = self.n196d
    if self.n203r:
      self.n203 = 0L
    elif self.n203e:
        self.n203 = self.n203d
    if self.n210r:
      self.n210 = 0L
    elif self.n210e:
        self.n210 = self.n210d
    if self.n217r:
      self.n217 = 0L
    elif self.n217e:
        self.n217 = self.n217d
    if self.n224r:
      self.n224 = 0L
    elif self.n224e:
        self.n224 = self.n224d
    if self.n231r:
      self.n231 = 0L
    elif self.n231e:
        self.n231 = self.n231d
    if self.n238r:
      self.n238 = 0L
    elif self.n238e:
        self.n238 = self.n238d
    if self.n266r:
      self.n266 = 0L
    elif self.n266e:
        self.n266 = self.n266d
    if self.n273r:
      self.n273 = 0L
    elif self.n273e:
        self.n273 = self.n273d
    if self.n280r:
      self.n280 = 0L
    elif self.n280e:
        self.n280 = self.n280d
    if self.n287r:
      self.n287 = 0L
    elif self.n287e:
        self.n287 = self.n287d
    if self.n294r:
      self.n294 = 0L
    elif self.n294e:
        self.n294 = self.n294d
    if self.n301r:
      self.n301 = 0L
    elif self.n301e:
        self.n301 = self.n301d
    if self.n308r:
      self.n308 = 0L
    elif self.n308e:
        self.n308 = self.n308d
    if self.n336r:
      self.n336 = 0L
    elif self.n336e:
        self.n336 = self.n336d
    if self.n343r:
      self.n343 = 0L
    elif self.n343e:
        self.n343 = self.n343d
    if self.n350r:
      self.n350 = 0L
    elif self.n350e:
        self.n350 = self.n350d
    if self.n357r:
      self.n357 = 0L
    elif self.n357e:
        self.n357 = self.n357d
    if self.n364r:
      self.n364 = 0L
    elif self.n364e:
        self.n364 = self.n364d
    if self.n371r:
      self.n371 = 0L
    elif self.n371e:
        self.n371 = self.n371d
    if self.n378r:
      self.n378 = 0L
    elif self.n378e:
        self.n378 = self.n378d
    if self.n406r:
      self.n406 = 0L
    elif self.n406e:
        self.n406 = self.n406d
    if self.n413r:
      self.n413 = 0L
    elif self.n413e:
        self.n413 = self.n413d
    if self.n420r:
      self.n420 = 0L
    elif self.n420e:
        self.n420 = self.n420d
    if self.n427r:
      self.n427 = 0L
    elif self.n427e:
        self.n427 = self.n427d
    if self.n434r:
      self.n434 = 0L
    elif self.n434e:
        self.n434 = self.n434d
    if self.n441r:
      self.n441 = 0L
    elif self.n441e:
        self.n441 = self.n441d
    if self.n448r:
      self.n448 = 0L
    elif self.n448e:
        self.n448 = self.n448d
    if self.n476r:
      self.n476 = 0L
    elif self.n476e:
        self.n476 = self.n476d
    if self.n483r:
      self.n483 = 0L
    elif self.n483e:
        self.n483 = self.n483d
    if self.n490r:
      self.n490 = 0L
    elif self.n490e:
        self.n490 = self.n490d
    if self.n497r:
      self.n497 = 0L
    elif self.n497e:
        self.n497 = self.n497d
    if self.n504r:
      self.n504 = 0L
    elif self.n504e:
        self.n504 = self.n504d
    if self.n511r:
      self.n511 = 0L
    elif self.n511e:
        self.n511 = self.n511d
    if self.n518r:
      self.n518 = 0L
    elif self.n518e:
        self.n518 = self.n518d
    if self.n602r:
      self.n602 = 0L
    elif self.n602e:
        self.n602 = self.n602d

  def sim_init(self, vcdFile):
    self.sim_file = open(vcdFile, 'w')
    self.sim_count = 1
    self.init()
    self.sim_n3 = self.n3
    self.sim_n4 = self.n4
    self.sim_n603 = self.n603
    self.sim_file.write("$date\n")
    self.sim_file.write("  " + time.strftime("%a %b %d %H:%M:%S %Y", time.localtime()) + "\n")
    self.sim_file.write("$end\n")
    self.sim_file.write("$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n")
    self.sim_file.write("$timescale\n  1 ns\n$end\n")
    self.sim_file.write("$scope module cf_fp_mul_p_3_4 $end\n")
    self.sim_file.write("$var wire 8 ! a_i $end\n")
    self.sim_file.write("$var wire 8 \" b_i $end\n")
    self.sim_file.write("$var wire 8 # x_o $end\n")
    self.sim_file.write("$upscope $end\n")
    self.sim_file.write("$enddefinitions $end\n")
    self.sim_file.write("#0\n")
    self.sim_file.write("$dumpvars\n")
    found = 0
    for bit in range(7, -1, -1):
      if found:
        if self.n3 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n3 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" !\n")
    found = 0
    for bit in range(7, -1, -1):
      if found:
        if self.n4 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n4 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" \"\n")
    found = 0
    for bit in range(7, -1, -1):
      if found:
        if self.n603 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n603 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" #\n")
    self.sim_file.write("$end\n")

  def sim_end(self):
    self.sim_file.write("#%d\n" % self.sim_count)
    self.sim_file.close()

  def sim_sample(self):
    changed = 0
    if self.sim_n3 != self.n3:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(7, -1, -1):
        if found:
          if self.n3 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n3 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" !\n")
      self.sim_n3 = self.n3
    if self.sim_n4 != self.n4:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(7, -1, -1):
        if found:
          if self.n4 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n4 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" \"\n")
      self.sim_n4 = self.n4
    if self.sim_n603 != self.n603:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(7, -1, -1):
        if found:
          if self.n603 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n603 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" #\n")
      self.sim_n603 = self.n603
    self.sim_count = self.sim_count + 1

