//
//  Copyright (c) 2003 Launchbird Design Systems, Inc.
//  All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
//  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
//  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  
//  
//  Overview:
//  
//    Performs floating point multiply.
//  
//  Interface:
//  
//    Synchronization:
//      clock_c  : Clock input.
//  
//    Inputs:
//      a_i : Left operand.
//      b_i : Right operand.
//  
//    Outputs:
//      x_o : Result.
//  
//  Built In Parameters:
//  
//    Exponent Precision = 5
//    Mantissa Precision = 10
//    Total    Precision = 16
//    Pipeline Latency   = 14 clock cycles
//  
//  
//  
//  
//  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
//  
//  Build Date : Fri Aug 22 09:47:04 CDT 2003
//  
//  Interface
//  
//    Build Name    : cf_fp_mul_p_5_10
//    Clock Domains : clock_c  
//    Vector Input  : a_i(16)
//    Vector Input  : b_i(16)
//    Vector Output : x_o(16)
//  
//  
//  

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cf_fp_mul_p_5_10.h"

static unsigned char n1150[2];
static unsigned char n1148[2];
static unsigned char n1146[2];
static unsigned char n1144[1];
static unsigned char *x_o;
static unsigned char n1108[1];
static unsigned char n1106[1];
static unsigned char n1104[1];
static unsigned char n1102[1];
static unsigned char n1100[1];
static unsigned char n1098[1];
static unsigned char n1096[1];
static unsigned char n1094[1];
static unsigned char n1092[1];
static unsigned char n1090[1];
static unsigned char n1088[1];
static unsigned char n1086[1];
static unsigned char n1084[1];
static unsigned char n1082[1];
static unsigned char n1080[1];
static unsigned char n1079[1];
static unsigned char n1078[1];
static unsigned char n1077[1];
static unsigned char n1076[1];
static unsigned char n1075[1];
static unsigned char n1072[1];
static unsigned char n1062[2];
static unsigned char n1060[2];
static unsigned char n1059[1];
static unsigned char n1008[2];
static unsigned char n1007[2];
static unsigned char n1004[1];
static unsigned char n985[1];
static unsigned char n984[1];
static unsigned char n983[1];
static unsigned char n932[2];
static unsigned char n931[2];
static unsigned char n928[1];
static unsigned char n909[1];
static unsigned char n908[1];
static unsigned char n907[1];
static unsigned char n856[2];
static unsigned char n855[2];
static unsigned char n852[1];
static unsigned char n833[1];
static unsigned char n832[1];
static unsigned char n831[1];
static unsigned char n780[2];
static unsigned char n779[2];
static unsigned char n776[1];
static unsigned char n757[1];
static unsigned char n756[1];
static unsigned char n755[1];
static unsigned char n704[2];
static unsigned char n703[2];
static unsigned char n700[1];
static unsigned char n681[1];
static unsigned char n680[1];
static unsigned char n679[1];
static unsigned char n628[2];
static unsigned char n627[2];
static unsigned char n624[1];
static unsigned char n605[1];
static unsigned char n604[1];
static unsigned char n603[1];
static unsigned char n552[3];
static unsigned char n551[3];
static unsigned char n548[1];
static unsigned char n529[1];
static unsigned char n528[1];
static unsigned char n527[1];
static unsigned char n476[3];
static unsigned char n475[3];
static unsigned char n472[1];
static unsigned char n453[1];
static unsigned char n452[1];
static unsigned char n451[1];
static unsigned char n400[3];
static unsigned char n399[3];
static unsigned char n396[1];
static unsigned char n377[1];
static unsigned char n376[1];
static unsigned char n375[1];
static unsigned char n324[3];
static unsigned char n323[3];
static unsigned char n320[1];
static unsigned char n301[1];
static unsigned char n300[1];
static unsigned char n299[1];
static unsigned char n248[3];
static unsigned char n247[3];
static unsigned char n244[1];
static unsigned char n243[1];
static unsigned char n182[1];
static unsigned char n180[1];
static unsigned char n100[2];
static unsigned char n99[1];
static unsigned char n27[2];
static unsigned char n26[1];
static unsigned char n24[2];
static unsigned char n23[1];
static unsigned char n22[1];
static unsigned char n21[2];
static unsigned char n20[1];
static unsigned char n19[1];
static unsigned char *b_i;
static unsigned char *a_i;
static unsigned char n2[1];
static unsigned char n1[1];
static unsigned char n1073[1];
static unsigned char n1061[2];
static unsigned char n1044[1];
static unsigned char n1044r[1];
static unsigned char n1044e[1];
static unsigned char n1044d[1];
static unsigned char n1037[1];
static unsigned char n1037r[1];
static unsigned char n1037e[1];
static unsigned char n1037d[1];
static unsigned char n1030[1];
static unsigned char n1030r[1];
static unsigned char n1030e[1];
static unsigned char n1030d[1];
static unsigned char n1023[1];
static unsigned char n1023r[1];
static unsigned char n1023e[1];
static unsigned char n1023d[1];
static unsigned char n1016[1];
static unsigned char n1016r[1];
static unsigned char n1016e[1];
static unsigned char n1016d[1];
static unsigned char n1005[1];
static unsigned char n987[1];
static unsigned char n986[1];
static unsigned char n968[1];
static unsigned char n968r[1];
static unsigned char n968e[1];
static unsigned char n968d[1];
static unsigned char n961[1];
static unsigned char n961r[1];
static unsigned char n961e[1];
static unsigned char n961d[1];
static unsigned char n954[1];
static unsigned char n954r[1];
static unsigned char n954e[1];
static unsigned char n954d[1];
static unsigned char n947[1];
static unsigned char n947r[1];
static unsigned char n947e[1];
static unsigned char n947d[1];
static unsigned char n940[1];
static unsigned char n940r[1];
static unsigned char n940e[1];
static unsigned char n940d[1];
static unsigned char n929[1];
static unsigned char n911[1];
static unsigned char n910[1];
static unsigned char n892[1];
static unsigned char n892r[1];
static unsigned char n892e[1];
static unsigned char n892d[1];
static unsigned char n885[1];
static unsigned char n885r[1];
static unsigned char n885e[1];
static unsigned char n885d[1];
static unsigned char n878[1];
static unsigned char n878r[1];
static unsigned char n878e[1];
static unsigned char n878d[1];
static unsigned char n871[1];
static unsigned char n871r[1];
static unsigned char n871e[1];
static unsigned char n871d[1];
static unsigned char n864[1];
static unsigned char n864r[1];
static unsigned char n864e[1];
static unsigned char n864d[1];
static unsigned char n853[1];
static unsigned char n835[1];
static unsigned char n834[1];
static unsigned char n816[1];
static unsigned char n816r[1];
static unsigned char n816e[1];
static unsigned char n816d[1];
static unsigned char n809[1];
static unsigned char n809r[1];
static unsigned char n809e[1];
static unsigned char n809d[1];
static unsigned char n802[1];
static unsigned char n802r[1];
static unsigned char n802e[1];
static unsigned char n802d[1];
static unsigned char n795[1];
static unsigned char n795r[1];
static unsigned char n795e[1];
static unsigned char n795d[1];
static unsigned char n788[1];
static unsigned char n788r[1];
static unsigned char n788e[1];
static unsigned char n788d[1];
static unsigned char n777[1];
static unsigned char n759[1];
static unsigned char n758[1];
static unsigned char n740[1];
static unsigned char n740r[1];
static unsigned char n740e[1];
static unsigned char n740d[1];
static unsigned char n733[1];
static unsigned char n733r[1];
static unsigned char n733e[1];
static unsigned char n733d[1];
static unsigned char n726[1];
static unsigned char n726r[1];
static unsigned char n726e[1];
static unsigned char n726d[1];
static unsigned char n719[1];
static unsigned char n719r[1];
static unsigned char n719e[1];
static unsigned char n719d[1];
static unsigned char n712[1];
static unsigned char n712r[1];
static unsigned char n712e[1];
static unsigned char n712d[1];
static unsigned char n701[1];
static unsigned char n683[1];
static unsigned char n682[1];
static unsigned char n664[1];
static unsigned char n664r[1];
static unsigned char n664e[1];
static unsigned char n664d[1];
static unsigned char n657[1];
static unsigned char n657r[1];
static unsigned char n657e[1];
static unsigned char n657d[1];
static unsigned char n650[1];
static unsigned char n650r[1];
static unsigned char n650e[1];
static unsigned char n650d[1];
static unsigned char n643[1];
static unsigned char n643r[1];
static unsigned char n643e[1];
static unsigned char n643d[1];
static unsigned char n636[1];
static unsigned char n636r[1];
static unsigned char n636e[1];
static unsigned char n636d[1];
static unsigned char n625[1];
static unsigned char n607[1];
static unsigned char n606[1];
static unsigned char n588[1];
static unsigned char n588r[1];
static unsigned char n588e[1];
static unsigned char n588d[1];
static unsigned char n581[1];
static unsigned char n581r[1];
static unsigned char n581e[1];
static unsigned char n581d[1];
static unsigned char n574[1];
static unsigned char n574r[1];
static unsigned char n574e[1];
static unsigned char n574d[1];
static unsigned char n567[1];
static unsigned char n567r[1];
static unsigned char n567e[1];
static unsigned char n567d[1];
static unsigned char n560[1];
static unsigned char n560r[1];
static unsigned char n560e[1];
static unsigned char n560d[1];
static unsigned char n549[1];
static unsigned char n531[1];
static unsigned char n530[1];
static unsigned char n512[1];
static unsigned char n512r[1];
static unsigned char n512e[1];
static unsigned char n512d[1];
static unsigned char n505[1];
static unsigned char n505r[1];
static unsigned char n505e[1];
static unsigned char n505d[1];
static unsigned char n498[1];
static unsigned char n498r[1];
static unsigned char n498e[1];
static unsigned char n498d[1];
static unsigned char n491[1];
static unsigned char n491r[1];
static unsigned char n491e[1];
static unsigned char n491d[1];
static unsigned char n484[1];
static unsigned char n484r[1];
static unsigned char n484e[1];
static unsigned char n484d[1];
static unsigned char n473[1];
static unsigned char n455[1];
static unsigned char n454[1];
static unsigned char n436[1];
static unsigned char n436r[1];
static unsigned char n436e[1];
static unsigned char n436d[1];
static unsigned char n429[1];
static unsigned char n429r[1];
static unsigned char n429e[1];
static unsigned char n429d[1];
static unsigned char n422[1];
static unsigned char n422r[1];
static unsigned char n422e[1];
static unsigned char n422d[1];
static unsigned char n415[1];
static unsigned char n415r[1];
static unsigned char n415e[1];
static unsigned char n415d[1];
static unsigned char n408[1];
static unsigned char n408r[1];
static unsigned char n408e[1];
static unsigned char n408d[1];
static unsigned char n397[1];
static unsigned char n379[1];
static unsigned char n378[1];
static unsigned char n360[1];
static unsigned char n360r[1];
static unsigned char n360e[1];
static unsigned char n360d[1];
static unsigned char n353[1];
static unsigned char n353r[1];
static unsigned char n353e[1];
static unsigned char n353d[1];
static unsigned char n346[1];
static unsigned char n346r[1];
static unsigned char n346e[1];
static unsigned char n346d[1];
static unsigned char n339[1];
static unsigned char n339r[1];
static unsigned char n339e[1];
static unsigned char n339d[1];
static unsigned char n332[1];
static unsigned char n332r[1];
static unsigned char n332e[1];
static unsigned char n332d[1];
static unsigned char n321[1];
static unsigned char n303[1];
static unsigned char n302[1];
static unsigned char n284[1];
static unsigned char n284r[1];
static unsigned char n284e[1];
static unsigned char n284d[1];
static unsigned char n277[1];
static unsigned char n277r[1];
static unsigned char n277e[1];
static unsigned char n277d[1];
static unsigned char n270[1];
static unsigned char n270r[1];
static unsigned char n270e[1];
static unsigned char n270d[1];
static unsigned char n263[1];
static unsigned char n263r[1];
static unsigned char n263e[1];
static unsigned char n263d[1];
static unsigned char n256[1];
static unsigned char n256r[1];
static unsigned char n256e[1];
static unsigned char n256d[1];
static unsigned char n249[3];
static unsigned char n245[1];
static unsigned char n183[1];
static unsigned char n181[1];
static unsigned char n179[1];
static unsigned char n162[1];
static unsigned char n160[1];
static unsigned char n131[2];
static unsigned char n130[1];
static unsigned char n116[1];
static unsigned char n115[1];
static unsigned char n102[1];
static unsigned char n101[1];
static unsigned char n89[1];
static unsigned char n87[1];
static unsigned char n58[2];
static unsigned char n57[1];
static unsigned char n43[1];
static unsigned char n42[1];
static unsigned char n29[1];
static unsigned char n28[1];
static unsigned char n18[2];
static unsigned char n18r[1];
static unsigned char n18e[1];
static unsigned char n18d[2];
static unsigned char n11[2];
static unsigned char n11r[1];
static unsigned char n11e[1];
static unsigned char n11d[2];
static unsigned char n1074[1];
static unsigned char n996[1];
static unsigned char n989[1];
static unsigned char n988[1];
static unsigned char n920[1];
static unsigned char n913[1];
static unsigned char n912[1];
static unsigned char n844[1];
static unsigned char n837[1];
static unsigned char n836[1];
static unsigned char n768[1];
static unsigned char n761[1];
static unsigned char n760[1];
static unsigned char n692[1];
static unsigned char n685[1];
static unsigned char n684[1];
static unsigned char n616[1];
static unsigned char n609[1];
static unsigned char n608[1];
static unsigned char n540[1];
static unsigned char n533[1];
static unsigned char n532[1];
static unsigned char n464[1];
static unsigned char n457[1];
static unsigned char n456[1];
static unsigned char n388[1];
static unsigned char n381[1];
static unsigned char n380[1];
static unsigned char n312[1];
static unsigned char n305[1];
static unsigned char n304[1];
static unsigned char n298[3];
static unsigned char n298r[1];
static unsigned char n298e[1];
static unsigned char n298d[3];
static unsigned char n246[1];
static unsigned char n228[1];
static unsigned char n228r[1];
static unsigned char n228e[1];
static unsigned char n228d[1];
static unsigned char n184[1];
static unsigned char n163[1];
static unsigned char n133[1];
static unsigned char n132[1];
static unsigned char n118[1];
static unsigned char n117[1];
static unsigned char n104[1];
static unsigned char n103[1];
static unsigned char n90[1];
static unsigned char n60[1];
static unsigned char n59[1];
static unsigned char n45[1];
static unsigned char n44[1];
static unsigned char n31[1];
static unsigned char n30[1];
static unsigned char n1109[1];
static unsigned char n1107[1];
static unsigned char n1105[1];
static unsigned char n1103[1];
static unsigned char n1101[1];
static unsigned char n1099[1];
static unsigned char n1097[1];
static unsigned char n1095[1];
static unsigned char n1093[1];
static unsigned char n1091[1];
static unsigned char n1089[1];
static unsigned char n1087[1];
static unsigned char n1085[1];
static unsigned char n1083[1];
static unsigned char n1081[1];
static unsigned char n991[1];
static unsigned char n990[1];
static unsigned char n915[1];
static unsigned char n914[1];
static unsigned char n839[1];
static unsigned char n838[1];
static unsigned char n763[1];
static unsigned char n762[1];
static unsigned char n687[1];
static unsigned char n686[1];
static unsigned char n611[1];
static unsigned char n610[1];
static unsigned char n535[1];
static unsigned char n534[1];
static unsigned char n459[1];
static unsigned char n458[1];
static unsigned char n383[1];
static unsigned char n382[1];
static unsigned char n307[1];
static unsigned char n306[1];
static unsigned char n291[1];
static unsigned char n291r[1];
static unsigned char n291e[1];
static unsigned char n291d[1];
static unsigned char n188[1];
static unsigned char n150[1];
static unsigned char n135[1];
static unsigned char n134[1];
static unsigned char n125[1];
static unsigned char n120[1];
static unsigned char n119[1];
static unsigned char n111[1];
static unsigned char n106[1];
static unsigned char n105[1];
static unsigned char n77[1];
static unsigned char n62[1];
static unsigned char n61[1];
static unsigned char n52[1];
static unsigned char n47[1];
static unsigned char n46[1];
static unsigned char n38[1];
static unsigned char n33[1];
static unsigned char n32[1];
static unsigned char n1110[1];
static unsigned char n997[1];
static unsigned char n993[1];
static unsigned char n992[1];
static unsigned char n921[1];
static unsigned char n917[1];
static unsigned char n916[1];
static unsigned char n845[1];
static unsigned char n841[1];
static unsigned char n840[1];
static unsigned char n769[1];
static unsigned char n765[1];
static unsigned char n764[1];
static unsigned char n693[1];
static unsigned char n689[1];
static unsigned char n688[1];
static unsigned char n617[1];
static unsigned char n613[1];
static unsigned char n612[1];
static unsigned char n541[1];
static unsigned char n537[1];
static unsigned char n536[1];
static unsigned char n465[1];
static unsigned char n461[1];
static unsigned char n460[1];
static unsigned char n389[1];
static unsigned char n385[1];
static unsigned char n384[1];
static unsigned char n313[1];
static unsigned char n309[1];
static unsigned char n308[1];
static unsigned char n235[1];
static unsigned char n235r[1];
static unsigned char n235e[1];
static unsigned char n235d[1];
static unsigned char n137[1];
static unsigned char n136[1];
static unsigned char n122[1];
static unsigned char n121[1];
static unsigned char n108[1];
static unsigned char n107[1];
static unsigned char n64[1];
static unsigned char n63[1];
static unsigned char n49[1];
static unsigned char n48[1];
static unsigned char n35[1];
static unsigned char n34[1];
static unsigned char n1111[1];
static unsigned char n999[1];
static unsigned char n994[1];
static unsigned char n923[1];
static unsigned char n918[1];
static unsigned char n847[1];
static unsigned char n842[1];
static unsigned char n771[1];
static unsigned char n766[1];
static unsigned char n695[1];
static unsigned char n690[1];
static unsigned char n619[1];
static unsigned char n614[1];
static unsigned char n543[1];
static unsigned char n538[1];
static unsigned char n467[1];
static unsigned char n462[1];
static unsigned char n391[1];
static unsigned char n386[1];
static unsigned char n315[1];
static unsigned char n310[1];
static unsigned char n151[1];
static unsigned char n139[1];
static unsigned char n138[1];
static unsigned char n126[1];
static unsigned char n123[1];
static unsigned char n112[1];
static unsigned char n109[1];
static unsigned char n78[1];
static unsigned char n66[1];
static unsigned char n65[1];
static unsigned char n53[1];
static unsigned char n50[1];
static unsigned char n39[1];
static unsigned char n36[1];
static unsigned char n1112[1];
static unsigned char n998[1];
static unsigned char n922[1];
static unsigned char n846[1];
static unsigned char n770[1];
static unsigned char n694[1];
static unsigned char n618[1];
static unsigned char n542[1];
static unsigned char n466[1];
static unsigned char n390[1];
static unsigned char n314[1];
static unsigned char n155[1];
static unsigned char n141[1];
static unsigned char n140[1];
static unsigned char n127[1];
static unsigned char n113[1];
static unsigned char n82[1];
static unsigned char n68[1];
static unsigned char n67[1];
static unsigned char n54[1];
static unsigned char n40[1];
static unsigned char n1113[1];
static unsigned char n1000[1];
static unsigned char n924[1];
static unsigned char n848[1];
static unsigned char n772[1];
static unsigned char n696[1];
static unsigned char n620[1];
static unsigned char n544[1];
static unsigned char n468[1];
static unsigned char n392[1];
static unsigned char n316[1];
static unsigned char n152[1];
static unsigned char n143[1];
static unsigned char n142[1];
static unsigned char n128[1];
static unsigned char n114[1];
static unsigned char n79[1];
static unsigned char n70[1];
static unsigned char n69[1];
static unsigned char n55[1];
static unsigned char n41[1];
static unsigned char n1114[1];
static unsigned char n1001[1];
static unsigned char n925[1];
static unsigned char n849[1];
static unsigned char n773[1];
static unsigned char n697[1];
static unsigned char n621[1];
static unsigned char n545[1];
static unsigned char n469[1];
static unsigned char n393[1];
static unsigned char n317[1];
static unsigned char n164[1];
static unsigned char n161[1];
static unsigned char n145[1];
static unsigned char n144[1];
static unsigned char n129[1];
static unsigned char n91[1];
static unsigned char n88[1];
static unsigned char n72[1];
static unsigned char n71[1];
static unsigned char n56[1];
static unsigned char n1115[1];
static unsigned char n1002[1];
static unsigned char n926[1];
static unsigned char n850[1];
static unsigned char n774[1];
static unsigned char n698[1];
static unsigned char n622[1];
static unsigned char n546[1];
static unsigned char n470[1];
static unsigned char n394[1];
static unsigned char n318[1];
static unsigned char n153[1];
static unsigned char n147[1];
static unsigned char n146[1];
static unsigned char n80[1];
static unsigned char n74[1];
static unsigned char n73[1];
static unsigned char n1116[1];
static unsigned char n1003[1];
static unsigned char n927[1];
static unsigned char n851[1];
static unsigned char n775[1];
static unsigned char n699[1];
static unsigned char n623[1];
static unsigned char n547[1];
static unsigned char n471[1];
static unsigned char n395[1];
static unsigned char n319[1];
static unsigned char n156[1];
static unsigned char n148[1];
static unsigned char n83[1];
static unsigned char n75[1];
static unsigned char n1117[1];
static unsigned char n1009[2];
static unsigned char n1006[1];
static unsigned char n933[2];
static unsigned char n930[1];
static unsigned char n857[2];
static unsigned char n854[1];
static unsigned char n781[2];
static unsigned char n778[1];
static unsigned char n705[2];
static unsigned char n702[1];
static unsigned char n629[2];
static unsigned char n626[1];
static unsigned char n553[3];
static unsigned char n550[1];
static unsigned char n477[3];
static unsigned char n474[1];
static unsigned char n401[3];
static unsigned char n398[1];
static unsigned char n325[3];
static unsigned char n322[1];
static unsigned char n157[1];
static unsigned char n154[1];
static unsigned char n84[1];
static unsigned char n81[1];
static unsigned char n1118[1];
static unsigned char n1058[2];
static unsigned char n1058r[1];
static unsigned char n1058e[1];
static unsigned char n1058d[2];
static unsigned char n1051[1];
static unsigned char n1051r[1];
static unsigned char n1051e[1];
static unsigned char n1051d[1];
static unsigned char n982[2];
static unsigned char n982r[1];
static unsigned char n982e[1];
static unsigned char n982d[2];
static unsigned char n975[1];
static unsigned char n975r[1];
static unsigned char n975e[1];
static unsigned char n975d[1];
static unsigned char n906[2];
static unsigned char n906r[1];
static unsigned char n906e[1];
static unsigned char n906d[2];
static unsigned char n899[1];
static unsigned char n899r[1];
static unsigned char n899e[1];
static unsigned char n899d[1];
static unsigned char n830[2];
static unsigned char n830r[1];
static unsigned char n830e[1];
static unsigned char n830d[2];
static unsigned char n823[1];
static unsigned char n823r[1];
static unsigned char n823e[1];
static unsigned char n823d[1];
static unsigned char n754[2];
static unsigned char n754r[1];
static unsigned char n754e[1];
static unsigned char n754d[2];
static unsigned char n747[1];
static unsigned char n747r[1];
static unsigned char n747e[1];
static unsigned char n747d[1];
static unsigned char n678[2];
static unsigned char n678r[1];
static unsigned char n678e[1];
static unsigned char n678d[2];
static unsigned char n671[1];
static unsigned char n671r[1];
static unsigned char n671e[1];
static unsigned char n671d[1];
static unsigned char n602[3];
static unsigned char n602r[1];
static unsigned char n602e[1];
static unsigned char n602d[3];
static unsigned char n595[1];
static unsigned char n595r[1];
static unsigned char n595e[1];
static unsigned char n595d[1];
static unsigned char n526[3];
static unsigned char n526r[1];
static unsigned char n526e[1];
static unsigned char n526d[3];
static unsigned char n519[1];
static unsigned char n519r[1];
static unsigned char n519e[1];
static unsigned char n519d[1];
static unsigned char n450[3];
static unsigned char n450r[1];
static unsigned char n450e[1];
static unsigned char n450d[3];
static unsigned char n443[1];
static unsigned char n443r[1];
static unsigned char n443e[1];
static unsigned char n443d[1];
static unsigned char n374[3];
static unsigned char n374r[1];
static unsigned char n374e[1];
static unsigned char n374d[3];
static unsigned char n367[1];
static unsigned char n367r[1];
static unsigned char n367e[1];
static unsigned char n367d[1];
static unsigned char n158[1];
static unsigned char n85[1];
static unsigned char n1119[1];
static unsigned char n159[1];
static unsigned char n86[1];
static unsigned char n1120[1];
static unsigned char n169[1];
static unsigned char n168[1];
static unsigned char n167[1];
static unsigned char n165[1];
static unsigned char n96[1];
static unsigned char n95[1];
static unsigned char n94[1];
static unsigned char n92[1];
static unsigned char n1121[1];
static unsigned char n178[1];
static unsigned char n177[1];
static unsigned char n175[1];
static unsigned char n174[1];
static unsigned char n170[1];
static unsigned char n166[1];
static unsigned char n97[1];
static unsigned char n93[1];
static unsigned char n1122[1];
static unsigned char n221[1];
static unsigned char n221r[1];
static unsigned char n221e[1];
static unsigned char n221d[1];
static unsigned char n214[1];
static unsigned char n214r[1];
static unsigned char n214e[1];
static unsigned char n214d[1];
static unsigned char n191[1];
static unsigned char n189[1];
static unsigned char n176[1];
static unsigned char n172[1];
static unsigned char n171[1];
static unsigned char n1123[1];
static unsigned char n207[1];
static unsigned char n207r[1];
static unsigned char n207e[1];
static unsigned char n207d[1];
static unsigned char n192[2];
static unsigned char n190[2];
static unsigned char n173[1];
static unsigned char n1124[1];
static unsigned char n200[1];
static unsigned char n200r[1];
static unsigned char n200e[1];
static unsigned char n200d[1];
static unsigned char n193[3];
static unsigned char n1126[1];
static unsigned char n1125[1];
static unsigned char n242[3];
static unsigned char n242r[1];
static unsigned char n242e[1];
static unsigned char n242d[3];
static unsigned char n1130[1];
static unsigned char n1129[1];
static unsigned char n1128[2];
static unsigned char n1127[2];
static unsigned char n1133[1];
static unsigned char n1131[2];
static unsigned char n1134[2];
static unsigned char n1135[2];
static unsigned char n1142[2];
static unsigned char n1142r[1];
static unsigned char n1142e[1];
static unsigned char n1142d[2];

void cf_fp_mul_p_5_10_ports(unsigned char* port_a_i, unsigned char* port_b_i, unsigned char* port_x_o) {
  a_i = port_a_i;
  b_i = port_b_i;
  x_o = port_x_o;
}

void cf_fp_mul_p_5_10_calc() {
  n1150[0] = 255;
  n1150[1] = 125;
  n1148[0] = 255;
  n1148[1] = 127;
  n1146[0] = 0;
  n1146[1] = 124;
  n1144[0] = 15;
  x_o[0] = n1142[0];
  x_o[1] = n1142[1];
  n1108[0] = 1;
  n1106[0] = 3;
  n1104[0] = 2;
  n1102[0] = 7;
  n1100[0] = 6;
  n1098[0] = 5;
  n1096[0] = 4;
  n1094[0] = 15;
  n1092[0] = 14;
  n1090[0] = 13;
  n1088[0] = 12;
  n1086[0] = 11;
  n1084[0] = 10;
  n1082[0] = 9;
  n1080[0] = 8;
  n1079[0] = 4;
  n1078[0] = 3;
  n1077[0] = 2;
  n1076[0] = 1;
  n1075[0] = 0;
  n1072[0] = 255 & (n1030[0] << 1 | n1037[0]);
  n1062[0] = 0;
  n1062[1] = 0;
  n1060[0] = (1 & (n1058[0])) | (2 & (n1058[0])) | (4 & (n1058[0])) | (8 & (n1058[0])) | (16 & (n1058[0])) | (32 & (n1058[0])) | (64 & (n1058[0])) | (128 & (n1058[0]));
  n1060[1] = (1 & (n1058[1])) | (2 & (n1058[1]));
  n1059[0] = (1 & (n1051[0])) | (2 & (n1051[0])) | (4 & (n1051[0])) | (8 & (n1051[0])) | (16 & (n1051[0]));
  n1008[0] = (1 & (n982[0] >> 1)) | (2 & (n982[0] >> 1)) | (4 & (n982[0] >> 1)) | (8 & (n982[0] >> 1)) | (16 & (n982[0] >> 1)) | (32 & (n982[0] >> 1)) | (64 & (n982[0] >> 1)) | (128 & (n982[1] << 7));
  n1008[1] = (1 & (n982[1] >> 1)) | (2 & (n982[1] >> 1)) | (4 & (n982[1] >> 1));
  n1007[0] = (1 & (n982[0])) | (2 & (n982[0])) | (4 & (n982[0])) | (8 & (n982[0])) | (16 & (n982[0])) | (32 & (n982[0])) | (64 & (n982[0])) | (128 & (n982[0]));
  n1007[1] = (1 & (n982[1])) | (2 & (n982[1])) | (4 & (n982[1]));
  n1004[0] = 1;
  n985[0] = (1 & (n975[0])) | (2 & (n975[0])) | (4 & (n975[0])) | (8 & (n975[0])) | (16 & (n975[0]));
  n984[0] = (1 & (n975[0] >> 5));
  n983[0] = (1 & (n982[1] >> 3));
  n932[0] = (1 & (n906[0] >> 1)) | (2 & (n906[0] >> 1)) | (4 & (n906[0] >> 1)) | (8 & (n906[0] >> 1)) | (16 & (n906[0] >> 1)) | (32 & (n906[0] >> 1)) | (64 & (n906[0] >> 1)) | (128 & (n906[1] << 7));
  n932[1] = (1 & (n906[1] >> 1)) | (2 & (n906[1] >> 1)) | (4 & (n906[1] >> 1)) | (8 & (n906[1] >> 1));
  n931[0] = (1 & (n906[0])) | (2 & (n906[0])) | (4 & (n906[0])) | (8 & (n906[0])) | (16 & (n906[0])) | (32 & (n906[0])) | (64 & (n906[0])) | (128 & (n906[0]));
  n931[1] = (1 & (n906[1])) | (2 & (n906[1])) | (4 & (n906[1])) | (8 & (n906[1]));
  n928[0] = 1;
  n909[0] = (1 & (n899[0])) | (2 & (n899[0])) | (4 & (n899[0])) | (8 & (n899[0])) | (16 & (n899[0]));
  n908[0] = (1 & (n899[0] >> 5));
  n907[0] = (1 & (n906[1] >> 4));
  n856[0] = (1 & (n830[0] >> 1)) | (2 & (n830[0] >> 1)) | (4 & (n830[0] >> 1)) | (8 & (n830[0] >> 1)) | (16 & (n830[0] >> 1)) | (32 & (n830[0] >> 1)) | (64 & (n830[0] >> 1)) | (128 & (n830[1] << 7));
  n856[1] = (1 & (n830[1] >> 1)) | (2 & (n830[1] >> 1)) | (4 & (n830[1] >> 1)) | (8 & (n830[1] >> 1)) | (16 & (n830[1] >> 1));
  n855[0] = (1 & (n830[0])) | (2 & (n830[0])) | (4 & (n830[0])) | (8 & (n830[0])) | (16 & (n830[0])) | (32 & (n830[0])) | (64 & (n830[0])) | (128 & (n830[0]));
  n855[1] = (1 & (n830[1])) | (2 & (n830[1])) | (4 & (n830[1])) | (8 & (n830[1])) | (16 & (n830[1]));
  n852[0] = 1;
  n833[0] = (1 & (n823[0])) | (2 & (n823[0])) | (4 & (n823[0])) | (8 & (n823[0])) | (16 & (n823[0]));
  n832[0] = (1 & (n823[0] >> 5));
  n831[0] = (1 & (n830[1] >> 5));
  n780[0] = (1 & (n754[0] >> 1)) | (2 & (n754[0] >> 1)) | (4 & (n754[0] >> 1)) | (8 & (n754[0] >> 1)) | (16 & (n754[0] >> 1)) | (32 & (n754[0] >> 1)) | (64 & (n754[0] >> 1)) | (128 & (n754[1] << 7));
  n780[1] = (1 & (n754[1] >> 1)) | (2 & (n754[1] >> 1)) | (4 & (n754[1] >> 1)) | (8 & (n754[1] >> 1)) | (16 & (n754[1] >> 1)) | (32 & (n754[1] >> 1));
  n779[0] = (1 & (n754[0])) | (2 & (n754[0])) | (4 & (n754[0])) | (8 & (n754[0])) | (16 & (n754[0])) | (32 & (n754[0])) | (64 & (n754[0])) | (128 & (n754[0]));
  n779[1] = (1 & (n754[1])) | (2 & (n754[1])) | (4 & (n754[1])) | (8 & (n754[1])) | (16 & (n754[1])) | (32 & (n754[1]));
  n776[0] = 1;
  n757[0] = (1 & (n747[0])) | (2 & (n747[0])) | (4 & (n747[0])) | (8 & (n747[0])) | (16 & (n747[0]));
  n756[0] = (1 & (n747[0] >> 5));
  n755[0] = (1 & (n754[1] >> 6));
  n704[0] = (1 & (n678[0] >> 1)) | (2 & (n678[0] >> 1)) | (4 & (n678[0] >> 1)) | (8 & (n678[0] >> 1)) | (16 & (n678[0] >> 1)) | (32 & (n678[0] >> 1)) | (64 & (n678[0] >> 1)) | (128 & (n678[1] << 7));
  n704[1] = (1 & (n678[1] >> 1)) | (2 & (n678[1] >> 1)) | (4 & (n678[1] >> 1)) | (8 & (n678[1] >> 1)) | (16 & (n678[1] >> 1)) | (32 & (n678[1] >> 1)) | (64 & (n678[1] >> 1));
  n703[0] = (1 & (n678[0])) | (2 & (n678[0])) | (4 & (n678[0])) | (8 & (n678[0])) | (16 & (n678[0])) | (32 & (n678[0])) | (64 & (n678[0])) | (128 & (n678[0]));
  n703[1] = (1 & (n678[1])) | (2 & (n678[1])) | (4 & (n678[1])) | (8 & (n678[1])) | (16 & (n678[1])) | (32 & (n678[1])) | (64 & (n678[1]));
  n700[0] = 1;
  n681[0] = (1 & (n671[0])) | (2 & (n671[0])) | (4 & (n671[0])) | (8 & (n671[0])) | (16 & (n671[0]));
  n680[0] = (1 & (n671[0] >> 5));
  n679[0] = (1 & (n678[1] >> 7));
  n628[0] = (1 & (n602[0] >> 1)) | (2 & (n602[0] >> 1)) | (4 & (n602[0] >> 1)) | (8 & (n602[0] >> 1)) | (16 & (n602[0] >> 1)) | (32 & (n602[0] >> 1)) | (64 & (n602[0] >> 1)) | (128 & (n602[1] << 7));
  n628[1] = (1 & (n602[1] >> 1)) | (2 & (n602[1] >> 1)) | (4 & (n602[1] >> 1)) | (8 & (n602[1] >> 1)) | (16 & (n602[1] >> 1)) | (32 & (n602[1] >> 1)) | (64 & (n602[1] >> 1)) | (128 & (n602[2] << 7));
  n627[0] = (1 & (n602[0])) | (2 & (n602[0])) | (4 & (n602[0])) | (8 & (n602[0])) | (16 & (n602[0])) | (32 & (n602[0])) | (64 & (n602[0])) | (128 & (n602[0]));
  n627[1] = (1 & (n602[1])) | (2 & (n602[1])) | (4 & (n602[1])) | (8 & (n602[1])) | (16 & (n602[1])) | (32 & (n602[1])) | (64 & (n602[1])) | (128 & (n602[1]));
  n624[0] = 1;
  n605[0] = (1 & (n595[0])) | (2 & (n595[0])) | (4 & (n595[0])) | (8 & (n595[0])) | (16 & (n595[0]));
  n604[0] = (1 & (n595[0] >> 5));
  n603[0] = (1 & (n602[2]));
  n552[0] = (1 & (n526[0] >> 1)) | (2 & (n526[0] >> 1)) | (4 & (n526[0] >> 1)) | (8 & (n526[0] >> 1)) | (16 & (n526[0] >> 1)) | (32 & (n526[0] >> 1)) | (64 & (n526[0] >> 1)) | (128 & (n526[1] << 7));
  n552[1] = (1 & (n526[1] >> 1)) | (2 & (n526[1] >> 1)) | (4 & (n526[1] >> 1)) | (8 & (n526[1] >> 1)) | (16 & (n526[1] >> 1)) | (32 & (n526[1] >> 1)) | (64 & (n526[1] >> 1)) | (128 & (n526[2] << 7));
  n552[2] = (1 & (n526[2] >> 1));
  n551[0] = (1 & (n526[0])) | (2 & (n526[0])) | (4 & (n526[0])) | (8 & (n526[0])) | (16 & (n526[0])) | (32 & (n526[0])) | (64 & (n526[0])) | (128 & (n526[0]));
  n551[1] = (1 & (n526[1])) | (2 & (n526[1])) | (4 & (n526[1])) | (8 & (n526[1])) | (16 & (n526[1])) | (32 & (n526[1])) | (64 & (n526[1])) | (128 & (n526[1]));
  n551[2] = (1 & (n526[2]));
  n548[0] = 1;
  n529[0] = (1 & (n519[0])) | (2 & (n519[0])) | (4 & (n519[0])) | (8 & (n519[0])) | (16 & (n519[0]));
  n528[0] = (1 & (n519[0] >> 5));
  n527[0] = (1 & (n526[2] >> 1));
  n476[0] = (1 & (n450[0] >> 1)) | (2 & (n450[0] >> 1)) | (4 & (n450[0] >> 1)) | (8 & (n450[0] >> 1)) | (16 & (n450[0] >> 1)) | (32 & (n450[0] >> 1)) | (64 & (n450[0] >> 1)) | (128 & (n450[1] << 7));
  n476[1] = (1 & (n450[1] >> 1)) | (2 & (n450[1] >> 1)) | (4 & (n450[1] >> 1)) | (8 & (n450[1] >> 1)) | (16 & (n450[1] >> 1)) | (32 & (n450[1] >> 1)) | (64 & (n450[1] >> 1)) | (128 & (n450[2] << 7));
  n476[2] = (1 & (n450[2] >> 1)) | (2 & (n450[2] >> 1));
  n475[0] = (1 & (n450[0])) | (2 & (n450[0])) | (4 & (n450[0])) | (8 & (n450[0])) | (16 & (n450[0])) | (32 & (n450[0])) | (64 & (n450[0])) | (128 & (n450[0]));
  n475[1] = (1 & (n450[1])) | (2 & (n450[1])) | (4 & (n450[1])) | (8 & (n450[1])) | (16 & (n450[1])) | (32 & (n450[1])) | (64 & (n450[1])) | (128 & (n450[1]));
  n475[2] = (1 & (n450[2])) | (2 & (n450[2]));
  n472[0] = 1;
  n453[0] = (1 & (n443[0])) | (2 & (n443[0])) | (4 & (n443[0])) | (8 & (n443[0])) | (16 & (n443[0]));
  n452[0] = (1 & (n443[0] >> 5));
  n451[0] = (1 & (n450[2] >> 2));
  n400[0] = (1 & (n374[0] >> 1)) | (2 & (n374[0] >> 1)) | (4 & (n374[0] >> 1)) | (8 & (n374[0] >> 1)) | (16 & (n374[0] >> 1)) | (32 & (n374[0] >> 1)) | (64 & (n374[0] >> 1)) | (128 & (n374[1] << 7));
  n400[1] = (1 & (n374[1] >> 1)) | (2 & (n374[1] >> 1)) | (4 & (n374[1] >> 1)) | (8 & (n374[1] >> 1)) | (16 & (n374[1] >> 1)) | (32 & (n374[1] >> 1)) | (64 & (n374[1] >> 1)) | (128 & (n374[2] << 7));
  n400[2] = (1 & (n374[2] >> 1)) | (2 & (n374[2] >> 1)) | (4 & (n374[2] >> 1));
  n399[0] = (1 & (n374[0])) | (2 & (n374[0])) | (4 & (n374[0])) | (8 & (n374[0])) | (16 & (n374[0])) | (32 & (n374[0])) | (64 & (n374[0])) | (128 & (n374[0]));
  n399[1] = (1 & (n374[1])) | (2 & (n374[1])) | (4 & (n374[1])) | (8 & (n374[1])) | (16 & (n374[1])) | (32 & (n374[1])) | (64 & (n374[1])) | (128 & (n374[1]));
  n399[2] = (1 & (n374[2])) | (2 & (n374[2])) | (4 & (n374[2]));
  n396[0] = 1;
  n377[0] = (1 & (n367[0])) | (2 & (n367[0])) | (4 & (n367[0])) | (8 & (n367[0])) | (16 & (n367[0]));
  n376[0] = (1 & (n367[0] >> 5));
  n375[0] = (1 & (n374[2] >> 3));
  n324[0] = (1 & (n298[0] >> 1)) | (2 & (n298[0] >> 1)) | (4 & (n298[0] >> 1)) | (8 & (n298[0] >> 1)) | (16 & (n298[0] >> 1)) | (32 & (n298[0] >> 1)) | (64 & (n298[0] >> 1)) | (128 & (n298[1] << 7));
  n324[1] = (1 & (n298[1] >> 1)) | (2 & (n298[1] >> 1)) | (4 & (n298[1] >> 1)) | (8 & (n298[1] >> 1)) | (16 & (n298[1] >> 1)) | (32 & (n298[1] >> 1)) | (64 & (n298[1] >> 1)) | (128 & (n298[2] << 7));
  n324[2] = (1 & (n298[2] >> 1)) | (2 & (n298[2] >> 1)) | (4 & (n298[2] >> 1)) | (8 & (n298[2] >> 1));
  n323[0] = (1 & (n298[0])) | (2 & (n298[0])) | (4 & (n298[0])) | (8 & (n298[0])) | (16 & (n298[0])) | (32 & (n298[0])) | (64 & (n298[0])) | (128 & (n298[0]));
  n323[1] = (1 & (n298[1])) | (2 & (n298[1])) | (4 & (n298[1])) | (8 & (n298[1])) | (16 & (n298[1])) | (32 & (n298[1])) | (64 & (n298[1])) | (128 & (n298[1]));
  n323[2] = (1 & (n298[2])) | (2 & (n298[2])) | (4 & (n298[2])) | (8 & (n298[2]));
  n320[0] = 1;
  n301[0] = (1 & (n291[0])) | (2 & (n291[0])) | (4 & (n291[0])) | (8 & (n291[0])) | (16 & (n291[0]));
  n300[0] = (1 & (n291[0] >> 5));
  n299[0] = (1 & (n298[2] >> 4));
  n248[0] = (1 & (n242[0])) | (2 & (n242[0])) | (4 & (n242[0])) | (8 & (n242[0])) | (16 & (n242[0])) | (32 & (n242[0])) | (64 & (n242[0])) | (128 & (n242[0]));
  n248[1] = (1 & (n242[1])) | (2 & (n242[1])) | (4 & (n242[1])) | (8 & (n242[1])) | (16 & (n242[1])) | (32 & (n242[1])) | (64 & (n242[1])) | (128 & (n242[1]));
  n248[2] = (1 & (n242[2])) | (2 & (n242[2])) | (4 & (n242[2])) | (8 & (n242[2])) | (16 & (n242[2]));
  n247[0] = (1 & (n242[0] >> 1)) | (2 & (n242[0] >> 1)) | (4 & (n242[0] >> 1)) | (8 & (n242[0] >> 1)) | (16 & (n242[0] >> 1)) | (32 & (n242[0] >> 1)) | (64 & (n242[0] >> 1)) | (128 & (n242[1] << 7));
  n247[1] = (1 & (n242[1] >> 1)) | (2 & (n242[1] >> 1)) | (4 & (n242[1] >> 1)) | (8 & (n242[1] >> 1)) | (16 & (n242[1] >> 1)) | (32 & (n242[1] >> 1)) | (64 & (n242[1] >> 1)) | (128 & (n242[2] << 7));
  n247[2] = (1 & (n242[2] >> 1)) | (2 & (n242[2] >> 1)) | (4 & (n242[2] >> 1)) | (8 & (n242[2] >> 1)) | (16 & (n242[2] >> 1));
  n244[0] = 1;
  n243[0] = (1 & (n242[2] >> 5));
  n182[0] = 0;
  n180[0] = 0;
  n100[0] = (1 & (n18[0])) | (2 & (n18[0])) | (4 & (n18[0])) | (8 & (n18[0])) | (16 & (n18[0])) | (32 & (n18[0])) | (64 & (n18[0])) | (128 & (n18[0]));
  n100[1] = (1 & (n18[1])) | (2 & (n18[1]));
  n99[0] = (1 & (n18[1] >> 2)) | (2 & (n18[1] >> 2)) | (4 & (n18[1] >> 2)) | (8 & (n18[1] >> 2)) | (16 & (n18[1] >> 2));
  n27[0] = (1 & (n11[0])) | (2 & (n11[0])) | (4 & (n11[0])) | (8 & (n11[0])) | (16 & (n11[0])) | (32 & (n11[0])) | (64 & (n11[0])) | (128 & (n11[0]));
  n27[1] = (1 & (n11[1])) | (2 & (n11[1]));
  n26[0] = (1 & (n11[1] >> 2)) | (2 & (n11[1] >> 2)) | (4 & (n11[1] >> 2)) | (8 & (n11[1] >> 2)) | (16 & (n11[1] >> 2));
  n24[0] = (1 & (n18[0])) | (2 & (n18[0])) | (4 & (n18[0])) | (8 & (n18[0])) | (16 & (n18[0])) | (32 & (n18[0])) | (64 & (n18[0])) | (128 & (n18[0]));
  n24[1] = (1 & (n18[1])) | (2 & (n18[1]));
  n23[0] = (1 & (n18[1] >> 2)) | (2 & (n18[1] >> 2)) | (4 & (n18[1] >> 2)) | (8 & (n18[1] >> 2)) | (16 & (n18[1] >> 2));
  n22[0] = (1 & (n18[1] >> 7));
  n21[0] = (1 & (n11[0])) | (2 & (n11[0])) | (4 & (n11[0])) | (8 & (n11[0])) | (16 & (n11[0])) | (32 & (n11[0])) | (64 & (n11[0])) | (128 & (n11[0]));
  n21[1] = (1 & (n11[1])) | (2 & (n11[1]));
  n20[0] = (1 & (n11[1] >> 2)) | (2 & (n11[1] >> 2)) | (4 & (n11[1] >> 2)) | (8 & (n11[1] >> 2)) | (16 & (n11[1] >> 2));
  n19[0] = (1 & (n11[1] >> 7));
  n2[0] = 0;
  n1[0] = 1;
  n1073[0] = 255 & (n1023[0] << 2 | n1072[0]);
  n1061[0] = n1060[0];
  n1061[1] = 255 & (n1059[0] << 2 | n1060[1]);
  n1044r[0] = n2[0];
  n1044e[0] = n1[0];
  n1044d[0] = n968[0];
  n1037r[0] = n2[0];
  n1037e[0] = n1[0];
  n1037d[0] = n961[0];
  n1030r[0] = n2[0];
  n1030e[0] = n1[0];
  n1030d[0] = n954[0];
  n1023r[0] = n2[0];
  n1023e[0] = n1[0];
  n1023d[0] = n947[0];
  n1016r[0] = n2[0];
  n1016e[0] = n1[0];
  n1016d[0] = n940[0];
  { unsigned int tmp; (tmp = (unsigned int) n975[0] - (unsigned int) n1004[0], n1005[0] = 63 & (unsigned char) tmp); }
  n987[0] = (1 & (n985[0])) | (2 & (n985[0])) | (4 & (n985[0])) | (8 & (n985[0]));
  n986[0] = (1 & (n985[0] >> 4));
  n968r[0] = n2[0];
  n968e[0] = n1[0];
  n968d[0] = n892[0];
  n961r[0] = n2[0];
  n961e[0] = n1[0];
  n961d[0] = n885[0];
  n954r[0] = n2[0];
  n954e[0] = n1[0];
  n954d[0] = n878[0];
  n947r[0] = n2[0];
  n947e[0] = n1[0];
  n947d[0] = n871[0];
  n940r[0] = n2[0];
  n940e[0] = n1[0];
  n940d[0] = n864[0];
  { unsigned int tmp; (tmp = (unsigned int) n899[0] - (unsigned int) n928[0], n929[0] = 63 & (unsigned char) tmp); }
  n911[0] = (1 & (n909[0])) | (2 & (n909[0])) | (4 & (n909[0])) | (8 & (n909[0]));
  n910[0] = (1 & (n909[0] >> 4));
  n892r[0] = n2[0];
  n892e[0] = n1[0];
  n892d[0] = n816[0];
  n885r[0] = n2[0];
  n885e[0] = n1[0];
  n885d[0] = n809[0];
  n878r[0] = n2[0];
  n878e[0] = n1[0];
  n878d[0] = n802[0];
  n871r[0] = n2[0];
  n871e[0] = n1[0];
  n871d[0] = n795[0];
  n864r[0] = n2[0];
  n864e[0] = n1[0];
  n864d[0] = n788[0];
  { unsigned int tmp; (tmp = (unsigned int) n823[0] - (unsigned int) n852[0], n853[0] = 63 & (unsigned char) tmp); }
  n835[0] = (1 & (n833[0])) | (2 & (n833[0])) | (4 & (n833[0])) | (8 & (n833[0]));
  n834[0] = (1 & (n833[0] >> 4));
  n816r[0] = n2[0];
  n816e[0] = n1[0];
  n816d[0] = n740[0];
  n809r[0] = n2[0];
  n809e[0] = n1[0];
  n809d[0] = n733[0];
  n802r[0] = n2[0];
  n802e[0] = n1[0];
  n802d[0] = n726[0];
  n795r[0] = n2[0];
  n795e[0] = n1[0];
  n795d[0] = n719[0];
  n788r[0] = n2[0];
  n788e[0] = n1[0];
  n788d[0] = n712[0];
  { unsigned int tmp; (tmp = (unsigned int) n747[0] - (unsigned int) n776[0], n777[0] = 63 & (unsigned char) tmp); }
  n759[0] = (1 & (n757[0])) | (2 & (n757[0])) | (4 & (n757[0])) | (8 & (n757[0]));
  n758[0] = (1 & (n757[0] >> 4));
  n740r[0] = n2[0];
  n740e[0] = n1[0];
  n740d[0] = n664[0];
  n733r[0] = n2[0];
  n733e[0] = n1[0];
  n733d[0] = n657[0];
  n726r[0] = n2[0];
  n726e[0] = n1[0];
  n726d[0] = n650[0];
  n719r[0] = n2[0];
  n719e[0] = n1[0];
  n719d[0] = n643[0];
  n712r[0] = n2[0];
  n712e[0] = n1[0];
  n712d[0] = n636[0];
  { unsigned int tmp; (tmp = (unsigned int) n671[0] - (unsigned int) n700[0], n701[0] = 63 & (unsigned char) tmp); }
  n683[0] = (1 & (n681[0])) | (2 & (n681[0])) | (4 & (n681[0])) | (8 & (n681[0]));
  n682[0] = (1 & (n681[0] >> 4));
  n664r[0] = n2[0];
  n664e[0] = n1[0];
  n664d[0] = n588[0];
  n657r[0] = n2[0];
  n657e[0] = n1[0];
  n657d[0] = n581[0];
  n650r[0] = n2[0];
  n650e[0] = n1[0];
  n650d[0] = n574[0];
  n643r[0] = n2[0];
  n643e[0] = n1[0];
  n643d[0] = n567[0];
  n636r[0] = n2[0];
  n636e[0] = n1[0];
  n636d[0] = n560[0];
  { unsigned int tmp; (tmp = (unsigned int) n595[0] - (unsigned int) n624[0], n625[0] = 63 & (unsigned char) tmp); }
  n607[0] = (1 & (n605[0])) | (2 & (n605[0])) | (4 & (n605[0])) | (8 & (n605[0]));
  n606[0] = (1 & (n605[0] >> 4));
  n588r[0] = n2[0];
  n588e[0] = n1[0];
  n588d[0] = n512[0];
  n581r[0] = n2[0];
  n581e[0] = n1[0];
  n581d[0] = n505[0];
  n574r[0] = n2[0];
  n574e[0] = n1[0];
  n574d[0] = n498[0];
  n567r[0] = n2[0];
  n567e[0] = n1[0];
  n567d[0] = n491[0];
  n560r[0] = n2[0];
  n560e[0] = n1[0];
  n560d[0] = n484[0];
  { unsigned int tmp; (tmp = (unsigned int) n519[0] - (unsigned int) n548[0], n549[0] = 63 & (unsigned char) tmp); }
  n531[0] = (1 & (n529[0])) | (2 & (n529[0])) | (4 & (n529[0])) | (8 & (n529[0]));
  n530[0] = (1 & (n529[0] >> 4));
  n512r[0] = n2[0];
  n512e[0] = n1[0];
  n512d[0] = n436[0];
  n505r[0] = n2[0];
  n505e[0] = n1[0];
  n505d[0] = n429[0];
  n498r[0] = n2[0];
  n498e[0] = n1[0];
  n498d[0] = n422[0];
  n491r[0] = n2[0];
  n491e[0] = n1[0];
  n491d[0] = n415[0];
  n484r[0] = n2[0];
  n484e[0] = n1[0];
  n484d[0] = n408[0];
  { unsigned int tmp; (tmp = (unsigned int) n443[0] - (unsigned int) n472[0], n473[0] = 63 & (unsigned char) tmp); }
  n455[0] = (1 & (n453[0])) | (2 & (n453[0])) | (4 & (n453[0])) | (8 & (n453[0]));
  n454[0] = (1 & (n453[0] >> 4));
  n436r[0] = n2[0];
  n436e[0] = n1[0];
  n436d[0] = n360[0];
  n429r[0] = n2[0];
  n429e[0] = n1[0];
  n429d[0] = n353[0];
  n422r[0] = n2[0];
  n422e[0] = n1[0];
  n422d[0] = n346[0];
  n415r[0] = n2[0];
  n415e[0] = n1[0];
  n415d[0] = n339[0];
  n408r[0] = n2[0];
  n408e[0] = n1[0];
  n408d[0] = n332[0];
  { unsigned int tmp; (tmp = (unsigned int) n367[0] - (unsigned int) n396[0], n397[0] = 63 & (unsigned char) tmp); }
  n379[0] = (1 & (n377[0])) | (2 & (n377[0])) | (4 & (n377[0])) | (8 & (n377[0]));
  n378[0] = (1 & (n377[0] >> 4));
  n360r[0] = n2[0];
  n360e[0] = n1[0];
  n360d[0] = n284[0];
  n353r[0] = n2[0];
  n353e[0] = n1[0];
  n353d[0] = n277[0];
  n346r[0] = n2[0];
  n346e[0] = n1[0];
  n346d[0] = n270[0];
  n339r[0] = n2[0];
  n339e[0] = n1[0];
  n339d[0] = n263[0];
  n332r[0] = n2[0];
  n332e[0] = n1[0];
  n332d[0] = n256[0];
  { unsigned int tmp; (tmp = (unsigned int) n291[0] - (unsigned int) n320[0], n321[0] = 63 & (unsigned char) tmp); }
  n303[0] = (1 & (n301[0])) | (2 & (n301[0])) | (4 & (n301[0])) | (8 & (n301[0]));
  n302[0] = (1 & (n301[0] >> 4));
  n284r[0] = n2[0];
  n284e[0] = n1[0];
  n284d[0] = n228[0];
  n277r[0] = n2[0];
  n277e[0] = n1[0];
  n277d[0] = n221[0];
  n270r[0] = n2[0];
  n270e[0] = n1[0];
  n270d[0] = n214[0];
  n263r[0] = n2[0];
  n263e[0] = n1[0];
  n263d[0] = n207[0];
  n256r[0] = n2[0];
  n256e[0] = n1[0];
  n256d[0] = n200[0];
  if (n243[0]) {
    n249[0] = n247[0];
    n249[1] = n247[1];
    n249[2] = n247[2];
  }
  else {
    n249[0] = n248[0];
    n249[1] = n248[1];
    n249[2] = n248[2];
  }
  { unsigned int tmp; (tmp = (unsigned int) n235[0] + (unsigned int) n244[0], n245[0] = 63 & (unsigned char) tmp); }
  n183[0] = 255 & (n182[0] << 5 | n23[0]);
  n181[0] = 255 & (n180[0] << 5 | n20[0]);
  n179[0] = n19[0] ^ n22[0];
  n162[0] = (1 & (n100[1] >> 1));
  n160[0] = (1 & (n100[1] >> 1));
  n131[0] = (1 & (n100[0])) | (2 & (n100[0])) | (4 & (n100[0])) | (8 & (n100[0])) | (16 & (n100[0])) | (32 & (n100[0])) | (64 & (n100[0])) | (128 & (n100[0]));
  n131[1] = (1 & (n100[1]));
  n130[0] = (1 & (n100[1] >> 1));
  n116[0] = (1 & (n99[0])) | (2 & (n99[0])) | (4 & (n99[0])) | (8 & (n99[0]));
  n115[0] = (1 & (n99[0] >> 4));
  n102[0] = (1 & (n99[0])) | (2 & (n99[0])) | (4 & (n99[0])) | (8 & (n99[0]));
  n101[0] = (1 & (n99[0] >> 4));
  n89[0] = (1 & (n27[1] >> 1));
  n87[0] = (1 & (n27[1] >> 1));
  n58[0] = (1 & (n27[0])) | (2 & (n27[0])) | (4 & (n27[0])) | (8 & (n27[0])) | (16 & (n27[0])) | (32 & (n27[0])) | (64 & (n27[0])) | (128 & (n27[0]));
  n58[1] = (1 & (n27[1]));
  n57[0] = (1 & (n27[1] >> 1));
  n43[0] = (1 & (n26[0])) | (2 & (n26[0])) | (4 & (n26[0])) | (8 & (n26[0]));
  n42[0] = (1 & (n26[0] >> 4));
  n29[0] = (1 & (n26[0])) | (2 & (n26[0])) | (4 & (n26[0])) | (8 & (n26[0]));
  n28[0] = (1 & (n26[0] >> 4));
  n18r[0] = n2[0];
  n18e[0] = n1[0];
  n18d[0] = b_i[0];
  n18d[1] = b_i[1];
  n11r[0] = n2[0];
  n11e[0] = n1[0];
  n11d[0] = a_i[0];
  n11d[1] = a_i[1];
  n1074[0] = 255 & (n1016[0] << 3 | n1073[0]);
  n996[0] = n984[0] | n986[0];
  n989[0] = (1 & (n987[0])) | (2 & (n987[0])) | (4 & (n987[0]));
  n988[0] = (1 & (n987[0] >> 3));
  n920[0] = n908[0] | n910[0];
  n913[0] = (1 & (n911[0])) | (2 & (n911[0])) | (4 & (n911[0]));
  n912[0] = (1 & (n911[0] >> 3));
  n844[0] = n832[0] | n834[0];
  n837[0] = (1 & (n835[0])) | (2 & (n835[0])) | (4 & (n835[0]));
  n836[0] = (1 & (n835[0] >> 3));
  n768[0] = n756[0] | n758[0];
  n761[0] = (1 & (n759[0])) | (2 & (n759[0])) | (4 & (n759[0]));
  n760[0] = (1 & (n759[0] >> 3));
  n692[0] = n680[0] | n682[0];
  n685[0] = (1 & (n683[0])) | (2 & (n683[0])) | (4 & (n683[0]));
  n684[0] = (1 & (n683[0] >> 3));
  n616[0] = n604[0] | n606[0];
  n609[0] = (1 & (n607[0])) | (2 & (n607[0])) | (4 & (n607[0]));
  n608[0] = (1 & (n607[0] >> 3));
  n540[0] = n528[0] | n530[0];
  n533[0] = (1 & (n531[0])) | (2 & (n531[0])) | (4 & (n531[0]));
  n532[0] = (1 & (n531[0] >> 3));
  n464[0] = n452[0] | n454[0];
  n457[0] = (1 & (n455[0])) | (2 & (n455[0])) | (4 & (n455[0]));
  n456[0] = (1 & (n455[0] >> 3));
  n388[0] = n376[0] | n378[0];
  n381[0] = (1 & (n379[0])) | (2 & (n379[0])) | (4 & (n379[0]));
  n380[0] = (1 & (n379[0] >> 3));
  n312[0] = n300[0] | n302[0];
  n305[0] = (1 & (n303[0])) | (2 & (n303[0])) | (4 & (n303[0]));
  n304[0] = (1 & (n303[0] >> 3));
  n298r[0] = n2[0];
  n298e[0] = n1[0];
  n298d[0] = n249[0];
  n298d[1] = n249[1];
  n298d[2] = n249[2];
  if (n243[0]) {
    n246[0] = n245[0];
  }
  else {
    n246[0] = n235[0];
  }
  n228r[0] = n2[0];
  n228e[0] = n1[0];
  n228d[0] = n179[0];
  { unsigned int tmp; (tmp = (unsigned int) n181[0] + (unsigned int) n183[0], n184[0] = 63 & (unsigned char) tmp); }
  n163[0] = 1 & ~n162[0];
  n133[0] = (1 & (n131[0])) | (2 & (n131[0])) | (4 & (n131[0])) | (8 & (n131[0])) | (16 & (n131[0])) | (32 & (n131[0])) | (64 & (n131[0])) | (128 & (n131[0]));
  n132[0] = (1 & (n131[1]));
  n118[0] = (1 & (n116[0])) | (2 & (n116[0])) | (4 & (n116[0]));
  n117[0] = (1 & (n116[0] >> 3));
  n104[0] = (1 & (n102[0])) | (2 & (n102[0])) | (4 & (n102[0]));
  n103[0] = (1 & (n102[0] >> 3));
  n90[0] = 1 & ~n89[0];
  n60[0] = (1 & (n58[0])) | (2 & (n58[0])) | (4 & (n58[0])) | (8 & (n58[0])) | (16 & (n58[0])) | (32 & (n58[0])) | (64 & (n58[0])) | (128 & (n58[0]));
  n59[0] = (1 & (n58[1]));
  n45[0] = (1 & (n43[0])) | (2 & (n43[0])) | (4 & (n43[0]));
  n44[0] = (1 & (n43[0] >> 3));
  n31[0] = (1 & (n29[0])) | (2 & (n29[0])) | (4 & (n29[0]));
  n30[0] = (1 & (n29[0] >> 3));
  n1109[0] = n1074[0] == n1108[0] ? 1 : 0;
  n1107[0] = n1074[0] == n1106[0] ? 1 : 0;
  n1105[0] = n1074[0] == n1104[0] ? 1 : 0;
  n1103[0] = n1074[0] == n1102[0] ? 1 : 0;
  n1101[0] = n1074[0] == n1100[0] ? 1 : 0;
  n1099[0] = n1074[0] == n1098[0] ? 1 : 0;
  n1097[0] = n1074[0] == n1096[0] ? 1 : 0;
  n1095[0] = n1074[0] == n1094[0] ? 1 : 0;
  n1093[0] = n1074[0] == n1092[0] ? 1 : 0;
  n1091[0] = n1074[0] == n1090[0] ? 1 : 0;
  n1089[0] = n1074[0] == n1088[0] ? 1 : 0;
  n1087[0] = n1074[0] == n1086[0] ? 1 : 0;
  n1085[0] = n1074[0] == n1084[0] ? 1 : 0;
  n1083[0] = n1074[0] == n1082[0] ? 1 : 0;
  n1081[0] = n1074[0] == n1080[0] ? 1 : 0;
  n991[0] = (1 & (n989[0])) | (2 & (n989[0]));
  n990[0] = (1 & (n989[0] >> 2));
  n915[0] = (1 & (n913[0])) | (2 & (n913[0]));
  n914[0] = (1 & (n913[0] >> 2));
  n839[0] = (1 & (n837[0])) | (2 & (n837[0]));
  n838[0] = (1 & (n837[0] >> 2));
  n763[0] = (1 & (n761[0])) | (2 & (n761[0]));
  n762[0] = (1 & (n761[0] >> 2));
  n687[0] = (1 & (n685[0])) | (2 & (n685[0]));
  n686[0] = (1 & (n685[0] >> 2));
  n611[0] = (1 & (n609[0])) | (2 & (n609[0]));
  n610[0] = (1 & (n609[0] >> 2));
  n535[0] = (1 & (n533[0])) | (2 & (n533[0]));
  n534[0] = (1 & (n533[0] >> 2));
  n459[0] = (1 & (n457[0])) | (2 & (n457[0]));
  n458[0] = (1 & (n457[0] >> 2));
  n383[0] = (1 & (n381[0])) | (2 & (n381[0]));
  n382[0] = (1 & (n381[0] >> 2));
  n307[0] = (1 & (n305[0])) | (2 & (n305[0]));
  n306[0] = (1 & (n305[0] >> 2));
  n291r[0] = n2[0];
  n291e[0] = n1[0];
  n291d[0] = n246[0];
  { unsigned int tmp; (tmp = (unsigned int) n184[0] - (unsigned int) n1144[0], n188[0] = 63 & (unsigned char) tmp); }
  n150[0] = n130[0] | n132[0];
  n135[0] = (1 & (n133[0])) | (2 & (n133[0])) | (4 & (n133[0])) | (8 & (n133[0])) | (16 & (n133[0])) | (32 & (n133[0])) | (64 & (n133[0]));
  n134[0] = (1 & (n133[0] >> 7));
  n125[0] = n115[0] | n117[0];
  n120[0] = (1 & (n118[0])) | (2 & (n118[0]));
  n119[0] = (1 & (n118[0] >> 2));
  n111[0] = n101[0] & n103[0];
  n106[0] = (1 & (n104[0])) | (2 & (n104[0]));
  n105[0] = (1 & (n104[0] >> 2));
  n77[0] = n57[0] | n59[0];
  n62[0] = (1 & (n60[0])) | (2 & (n60[0])) | (4 & (n60[0])) | (8 & (n60[0])) | (16 & (n60[0])) | (32 & (n60[0])) | (64 & (n60[0]));
  n61[0] = (1 & (n60[0] >> 7));
  n52[0] = n42[0] | n44[0];
  n47[0] = (1 & (n45[0])) | (2 & (n45[0]));
  n46[0] = (1 & (n45[0] >> 2));
  n38[0] = n28[0] & n30[0];
  n33[0] = (1 & (n31[0])) | (2 & (n31[0]));
  n32[0] = (1 & (n31[0] >> 2));
  if (n1109[0]) {
    n1110[0] = n1076[0];
  }
  else {
    n1110[0] = n1075[0];
  }
  n997[0] = n988[0] | n990[0];
  n993[0] = (1 & (n991[0]));
  n992[0] = (1 & (n991[0] >> 1));
  n921[0] = n912[0] | n914[0];
  n917[0] = (1 & (n915[0]));
  n916[0] = (1 & (n915[0] >> 1));
  n845[0] = n836[0] | n838[0];
  n841[0] = (1 & (n839[0]));
  n840[0] = (1 & (n839[0] >> 1));
  n769[0] = n760[0] | n762[0];
  n765[0] = (1 & (n763[0]));
  n764[0] = (1 & (n763[0] >> 1));
  n693[0] = n684[0] | n686[0];
  n689[0] = (1 & (n687[0]));
  n688[0] = (1 & (n687[0] >> 1));
  n617[0] = n608[0] | n610[0];
  n613[0] = (1 & (n611[0]));
  n612[0] = (1 & (n611[0] >> 1));
  n541[0] = n532[0] | n534[0];
  n537[0] = (1 & (n535[0]));
  n536[0] = (1 & (n535[0] >> 1));
  n465[0] = n456[0] | n458[0];
  n461[0] = (1 & (n459[0]));
  n460[0] = (1 & (n459[0] >> 1));
  n389[0] = n380[0] | n382[0];
  n385[0] = (1 & (n383[0]));
  n384[0] = (1 & (n383[0] >> 1));
  n313[0] = n304[0] | n306[0];
  n309[0] = (1 & (n307[0]));
  n308[0] = (1 & (n307[0] >> 1));
  n235r[0] = n2[0];
  n235e[0] = n1[0];
  n235d[0] = n188[0];
  n137[0] = (1 & (n135[0])) | (2 & (n135[0])) | (4 & (n135[0])) | (8 & (n135[0])) | (16 & (n135[0])) | (32 & (n135[0]));
  n136[0] = (1 & (n135[0] >> 6));
  n122[0] = (1 & (n120[0]));
  n121[0] = (1 & (n120[0] >> 1));
  n108[0] = (1 & (n106[0]));
  n107[0] = (1 & (n106[0] >> 1));
  n64[0] = (1 & (n62[0])) | (2 & (n62[0])) | (4 & (n62[0])) | (8 & (n62[0])) | (16 & (n62[0])) | (32 & (n62[0]));
  n63[0] = (1 & (n62[0] >> 6));
  n49[0] = (1 & (n47[0]));
  n48[0] = (1 & (n47[0] >> 1));
  n35[0] = (1 & (n33[0]));
  n34[0] = (1 & (n33[0] >> 1));
  if (n1107[0]) {
    n1111[0] = n1077[0];
  }
  else {
    n1111[0] = n1110[0];
  }
  n999[0] = n996[0] | n997[0];
  n994[0] = (1 & (n993[0]));
  n923[0] = n920[0] | n921[0];
  n918[0] = (1 & (n917[0]));
  n847[0] = n844[0] | n845[0];
  n842[0] = (1 & (n841[0]));
  n771[0] = n768[0] | n769[0];
  n766[0] = (1 & (n765[0]));
  n695[0] = n692[0] | n693[0];
  n690[0] = (1 & (n689[0]));
  n619[0] = n616[0] | n617[0];
  n614[0] = (1 & (n613[0]));
  n543[0] = n540[0] | n541[0];
  n538[0] = (1 & (n537[0]));
  n467[0] = n464[0] | n465[0];
  n462[0] = (1 & (n461[0]));
  n391[0] = n388[0] | n389[0];
  n386[0] = (1 & (n385[0]));
  n315[0] = n312[0] | n313[0];
  n310[0] = (1 & (n309[0]));
  n151[0] = n134[0] | n136[0];
  n139[0] = (1 & (n137[0])) | (2 & (n137[0])) | (4 & (n137[0])) | (8 & (n137[0])) | (16 & (n137[0]));
  n138[0] = (1 & (n137[0] >> 5));
  n126[0] = n119[0] | n121[0];
  n123[0] = (1 & (n122[0]));
  n112[0] = n105[0] & n107[0];
  n109[0] = (1 & (n108[0]));
  n78[0] = n61[0] | n63[0];
  n66[0] = (1 & (n64[0])) | (2 & (n64[0])) | (4 & (n64[0])) | (8 & (n64[0])) | (16 & (n64[0]));
  n65[0] = (1 & (n64[0] >> 5));
  n53[0] = n46[0] | n48[0];
  n50[0] = (1 & (n49[0]));
  n39[0] = n32[0] & n34[0];
  n36[0] = (1 & (n35[0]));
  if (n1105[0]) {
    n1112[0] = n1077[0];
  }
  else {
    n1112[0] = n1111[0];
  }
  n998[0] = n992[0] | n994[0];
  n922[0] = n916[0] | n918[0];
  n846[0] = n840[0] | n842[0];
  n770[0] = n764[0] | n766[0];
  n694[0] = n688[0] | n690[0];
  n618[0] = n612[0] | n614[0];
  n542[0] = n536[0] | n538[0];
  n466[0] = n460[0] | n462[0];
  n390[0] = n384[0] | n386[0];
  n314[0] = n308[0] | n310[0];
  n155[0] = n150[0] | n151[0];
  n141[0] = (1 & (n139[0])) | (2 & (n139[0])) | (4 & (n139[0])) | (8 & (n139[0]));
  n140[0] = (1 & (n139[0] >> 4));
  n127[0] = n125[0] | n126[0];
  n113[0] = n111[0] & n112[0];
  n82[0] = n77[0] | n78[0];
  n68[0] = (1 & (n66[0])) | (2 & (n66[0])) | (4 & (n66[0])) | (8 & (n66[0]));
  n67[0] = (1 & (n66[0] >> 4));
  n54[0] = n52[0] | n53[0];
  n40[0] = n38[0] & n39[0];
  if (n1103[0]) {
    n1113[0] = n1078[0];
  }
  else {
    n1113[0] = n1112[0];
  }
  n1000[0] = n999[0] | n998[0];
  n924[0] = n923[0] | n922[0];
  n848[0] = n847[0] | n846[0];
  n772[0] = n771[0] | n770[0];
  n696[0] = n695[0] | n694[0];
  n620[0] = n619[0] | n618[0];
  n544[0] = n543[0] | n542[0];
  n468[0] = n467[0] | n466[0];
  n392[0] = n391[0] | n390[0];
  n316[0] = n315[0] | n314[0];
  n152[0] = n138[0] | n140[0];
  n143[0] = (1 & (n141[0])) | (2 & (n141[0])) | (4 & (n141[0]));
  n142[0] = (1 & (n141[0] >> 3));
  n128[0] = n127[0] | n123[0];
  n114[0] = n113[0] & n109[0];
  n79[0] = n65[0] | n67[0];
  n70[0] = (1 & (n68[0])) | (2 & (n68[0])) | (4 & (n68[0]));
  n69[0] = (1 & (n68[0] >> 3));
  n55[0] = n54[0] | n50[0];
  n41[0] = n40[0] & n36[0];
  if (n1101[0]) {
    n1114[0] = n1078[0];
  }
  else {
    n1114[0] = n1113[0];
  }
  n1001[0] = 1 & ~n1000[0];
  n925[0] = 1 & ~n924[0];
  n849[0] = 1 & ~n848[0];
  n773[0] = 1 & ~n772[0];
  n697[0] = 1 & ~n696[0];
  n621[0] = 1 & ~n620[0];
  n545[0] = 1 & ~n544[0];
  n469[0] = 1 & ~n468[0];
  n393[0] = 1 & ~n392[0];
  n317[0] = 1 & ~n316[0];
  n164[0] = n114[0] & n163[0];
  n161[0] = n114[0] & n160[0];
  n145[0] = (1 & (n143[0])) | (2 & (n143[0]));
  n144[0] = (1 & (n143[0] >> 2));
  n129[0] = 1 & ~n128[0];
  n91[0] = n41[0] & n90[0];
  n88[0] = n41[0] & n87[0];
  n72[0] = (1 & (n70[0])) | (2 & (n70[0]));
  n71[0] = (1 & (n70[0] >> 2));
  n56[0] = 1 & ~n55[0];
  if (n1099[0]) {
    n1115[0] = n1078[0];
  }
  else {
    n1115[0] = n1114[0];
  }
  n1002[0] = n983[0] | n1001[0];
  n926[0] = n907[0] | n925[0];
  n850[0] = n831[0] | n849[0];
  n774[0] = n755[0] | n773[0];
  n698[0] = n679[0] | n697[0];
  n622[0] = n603[0] | n621[0];
  n546[0] = n527[0] | n545[0];
  n470[0] = n451[0] | n469[0];
  n394[0] = n375[0] | n393[0];
  n318[0] = n299[0] | n317[0];
  n153[0] = n142[0] | n144[0];
  n147[0] = (1 & (n145[0]));
  n146[0] = (1 & (n145[0] >> 1));
  n80[0] = n69[0] | n71[0];
  n74[0] = (1 & (n72[0]));
  n73[0] = (1 & (n72[0] >> 1));
  if (n1097[0]) {
    n1116[0] = n1078[0];
  }
  else {
    n1116[0] = n1115[0];
  }
  n1003[0] = 1 & ~n1002[0];
  n927[0] = 1 & ~n926[0];
  n851[0] = 1 & ~n850[0];
  n775[0] = 1 & ~n774[0];
  n699[0] = 1 & ~n698[0];
  n623[0] = 1 & ~n622[0];
  n547[0] = 1 & ~n546[0];
  n471[0] = 1 & ~n470[0];
  n395[0] = 1 & ~n394[0];
  n319[0] = 1 & ~n318[0];
  n156[0] = n152[0] | n153[0];
  n148[0] = (1 & (n147[0]));
  n83[0] = n79[0] | n80[0];
  n75[0] = (1 & (n74[0]));
  if (n1095[0]) {
    n1117[0] = n1079[0];
  }
  else {
    n1117[0] = n1116[0];
  }
  if (n1003[0]) {
    n1009[0] = n1007[0];
    n1009[1] = n1007[1];
  }
  else {
    n1009[0] = n1008[0];
    n1009[1] = n1008[1];
  }
  if (n1003[0]) {
    n1006[0] = n1005[0];
  }
  else {
    n1006[0] = n975[0];
  }
  if (n927[0]) {
    n933[0] = n931[0];
    n933[1] = n931[1];
  }
  else {
    n933[0] = n932[0];
    n933[1] = n932[1];
  }
  if (n927[0]) {
    n930[0] = n929[0];
  }
  else {
    n930[0] = n899[0];
  }
  if (n851[0]) {
    n857[0] = n855[0];
    n857[1] = n855[1];
  }
  else {
    n857[0] = n856[0];
    n857[1] = n856[1];
  }
  if (n851[0]) {
    n854[0] = n853[0];
  }
  else {
    n854[0] = n823[0];
  }
  if (n775[0]) {
    n781[0] = n779[0];
    n781[1] = n779[1];
  }
  else {
    n781[0] = n780[0];
    n781[1] = n780[1];
  }
  if (n775[0]) {
    n778[0] = n777[0];
  }
  else {
    n778[0] = n747[0];
  }
  if (n699[0]) {
    n705[0] = n703[0];
    n705[1] = n703[1];
  }
  else {
    n705[0] = n704[0];
    n705[1] = n704[1];
  }
  if (n699[0]) {
    n702[0] = n701[0];
  }
  else {
    n702[0] = n671[0];
  }
  if (n623[0]) {
    n629[0] = n627[0];
    n629[1] = n627[1];
  }
  else {
    n629[0] = n628[0];
    n629[1] = n628[1];
  }
  if (n623[0]) {
    n626[0] = n625[0];
  }
  else {
    n626[0] = n595[0];
  }
  if (n547[0]) {
    n553[0] = n551[0];
    n553[1] = n551[1];
    n553[2] = n551[2];
  }
  else {
    n553[0] = n552[0];
    n553[1] = n552[1];
    n553[2] = n552[2];
  }
  if (n547[0]) {
    n550[0] = n549[0];
  }
  else {
    n550[0] = n519[0];
  }
  if (n471[0]) {
    n477[0] = n475[0];
    n477[1] = n475[1];
    n477[2] = n475[2];
  }
  else {
    n477[0] = n476[0];
    n477[1] = n476[1];
    n477[2] = n476[2];
  }
  if (n471[0]) {
    n474[0] = n473[0];
  }
  else {
    n474[0] = n443[0];
  }
  if (n395[0]) {
    n401[0] = n399[0];
    n401[1] = n399[1];
    n401[2] = n399[2];
  }
  else {
    n401[0] = n400[0];
    n401[1] = n400[1];
    n401[2] = n400[2];
  }
  if (n395[0]) {
    n398[0] = n397[0];
  }
  else {
    n398[0] = n367[0];
  }
  if (n319[0]) {
    n325[0] = n323[0];
    n325[1] = n323[1];
    n325[2] = n323[2];
  }
  else {
    n325[0] = n324[0];
    n325[1] = n324[1];
    n325[2] = n324[2];
  }
  if (n319[0]) {
    n322[0] = n321[0];
  }
  else {
    n322[0] = n291[0];
  }
  n157[0] = n155[0] | n156[0];
  n154[0] = n146[0] | n148[0];
  n84[0] = n82[0] | n83[0];
  n81[0] = n73[0] | n75[0];
  if (n1093[0]) {
    n1118[0] = n1079[0];
  }
  else {
    n1118[0] = n1117[0];
  }
  n1058r[0] = n2[0];
  n1058e[0] = n1[0];
  n1058d[0] = n1009[0];
  n1058d[1] = n1009[1];
  n1051r[0] = n2[0];
  n1051e[0] = n1[0];
  n1051d[0] = n1006[0];
  n982r[0] = n2[0];
  n982e[0] = n1[0];
  n982d[0] = n933[0];
  n982d[1] = n933[1];
  n975r[0] = n2[0];
  n975e[0] = n1[0];
  n975d[0] = n930[0];
  n906r[0] = n2[0];
  n906e[0] = n1[0];
  n906d[0] = n857[0];
  n906d[1] = n857[1];
  n899r[0] = n2[0];
  n899e[0] = n1[0];
  n899d[0] = n854[0];
  n830r[0] = n2[0];
  n830e[0] = n1[0];
  n830d[0] = n781[0];
  n830d[1] = n781[1];
  n823r[0] = n2[0];
  n823e[0] = n1[0];
  n823d[0] = n778[0];
  n754r[0] = n2[0];
  n754e[0] = n1[0];
  n754d[0] = n705[0];
  n754d[1] = n705[1];
  n747r[0] = n2[0];
  n747e[0] = n1[0];
  n747d[0] = n702[0];
  n678r[0] = n2[0];
  n678e[0] = n1[0];
  n678d[0] = n629[0];
  n678d[1] = n629[1];
  n671r[0] = n2[0];
  n671e[0] = n1[0];
  n671d[0] = n626[0];
  n602r[0] = n2[0];
  n602e[0] = n1[0];
  n602d[0] = n553[0];
  n602d[1] = n553[1];
  n602d[2] = n553[2];
  n595r[0] = n2[0];
  n595e[0] = n1[0];
  n595d[0] = n550[0];
  n526r[0] = n2[0];
  n526e[0] = n1[0];
  n526d[0] = n477[0];
  n526d[1] = n477[1];
  n526d[2] = n477[2];
  n519r[0] = n2[0];
  n519e[0] = n1[0];
  n519d[0] = n474[0];
  n450r[0] = n2[0];
  n450e[0] = n1[0];
  n450d[0] = n401[0];
  n450d[1] = n401[1];
  n450d[2] = n401[2];
  n443r[0] = n2[0];
  n443e[0] = n1[0];
  n443d[0] = n398[0];
  n374r[0] = n2[0];
  n374e[0] = n1[0];
  n374d[0] = n325[0];
  n374d[1] = n325[1];
  n374d[2] = n325[2];
  n367r[0] = n2[0];
  n367e[0] = n1[0];
  n367d[0] = n322[0];
  n158[0] = n157[0] | n154[0];
  n85[0] = n84[0] | n81[0];
  if (n1091[0]) {
    n1119[0] = n1079[0];
  }
  else {
    n1119[0] = n1118[0];
  }
  n159[0] = 1 & ~n158[0];
  n86[0] = 1 & ~n85[0];
  if (n1089[0]) {
    n1120[0] = n1079[0];
  }
  else {
    n1120[0] = n1119[0];
  }
  n169[0] = 1 & ~n159[0];
  n168[0] = n129[0] & n159[0];
  n167[0] = n114[0] & n159[0];
  n165[0] = 1 & ~n159[0];
  n96[0] = 1 & ~n86[0];
  n95[0] = n56[0] & n86[0];
  n94[0] = n41[0] & n86[0];
  n92[0] = 1 & ~n86[0];
  if (n1087[0]) {
    n1121[0] = n1079[0];
  }
  else {
    n1121[0] = n1120[0];
  }
  n178[0] = n95[0] | n168[0];
  n177[0] = n94[0] | n167[0];
  n175[0] = n95[0] & n167[0];
  n174[0] = n94[0] & n168[0];
  n170[0] = n129[0] & n169[0];
  n166[0] = n164[0] & n165[0];
  n97[0] = n56[0] & n96[0];
  n93[0] = n91[0] & n92[0];
  if (n1085[0]) {
    n1122[0] = n1079[0];
  }
  else {
    n1122[0] = n1121[0];
  }
  n221r[0] = n2[0];
  n221e[0] = n1[0];
  n221d[0] = n178[0];
  n214r[0] = n2[0];
  n214e[0] = n1[0];
  n214d[0] = n177[0];
  n191[0] = 1 & ~n170[0];
  n189[0] = 1 & ~n97[0];
  n176[0] = n174[0] | n175[0];
  n172[0] = n166[0] | n161[0];
  n171[0] = n93[0] | n88[0];
  if (n1083[0]) {
    n1123[0] = n1079[0];
  }
  else {
    n1123[0] = n1122[0];
  }
  n207r[0] = n2[0];
  n207e[0] = n1[0];
  n207d[0] = n176[0];
  n192[0] = n24[0];
  n192[1] = 255 & (n191[0] << 2 | n24[1]);
  n190[0] = n21[0];
  n190[1] = 255 & (n189[0] << 2 | n21[1]);
  n173[0] = n171[0] | n172[0];
  if (n1081[0]) {
    n1124[0] = n1079[0];
  }
  else {
    n1124[0] = n1123[0];
  }
  n200r[0] = n2[0];
  n200e[0] = n1[0];
  n200d[0] = n173[0];
  {
    unsigned int tmp;
    unsigned char a[3];
    unsigned char b[3];
    a[2] = 0;
    a[1] = n190[1];
    a[0] = n190[0];
    b[2] = 0;
    b[1] = n192[1];
    b[0] = n192[0];
    (tmp = ((unsigned int) a[2] * (unsigned int) b[0]) + ((unsigned int) a[1] * (unsigned int) b[1]) + ((unsigned int) a[0] * (unsigned int) b[2]) + (tmp = ((unsigned int) a[1] * (unsigned int) b[0]) + ((unsigned int) a[0] * (unsigned int) b[1]) + (tmp = ((unsigned int) a[0] * (unsigned int) b[0]), n193[0] = 255 & (unsigned char) tmp, tmp >> 8), n193[1] = 255 & (unsigned char) tmp, tmp >> 8), n193[2] = 63 & (unsigned char) tmp);
  }
  n1126[0] = (1 & (n1124[0]));
  n1125[0] = (1 & (n1124[0] >> 1)) | (2 & (n1124[0] >> 1));
  n242r[0] = n2[0];
  n242e[0] = n1[0];
  n242d[0] = n193[0];
  n242d[1] = n193[1];
  n242d[2] = n193[2];
  n1130[0] = (1 & (n1125[0]));
  n1129[0] = (1 & (n1125[0] >> 1));
  if (n1126[0]) {
    n1128[0] = n1148[0];
    n1128[1] = n1148[1];
  }
  else {
    n1128[0] = n1146[0];
    n1128[1] = n1146[1];
  }
  if (n1126[0]) {
    n1127[0] = n1062[0];
    n1127[1] = n1062[1];
  }
  else {
    n1127[0] = n1061[0];
    n1127[1] = n1061[1];
  }
  n1133[0] = (1 & (n1129[0]));
  if (n1130[0]) {
    n1131[0] = n1128[0];
    n1131[1] = n1128[1];
  }
  else {
    n1131[0] = n1127[0];
    n1131[1] = n1127[1];
  }
  if (n1133[0]) {
    n1134[0] = n1150[0];
    n1134[1] = n1150[1];
  }
  else {
    n1134[0] = n1131[0];
    n1134[1] = n1131[1];
  }
  n1135[0] = n1134[0];
  n1135[1] = 255 & (n1044[0] << 7 | n1134[1]);
  n1142r[0] = n2[0];
  n1142e[0] = n1[0];
  n1142d[0] = n1135[0];
  n1142d[1] = n1135[1];
}

void cf_fp_mul_p_5_10_init() {
  { int index; for (index = 2; index > 0;) n1150[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1148[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1146[--index] = 0; }
  n1144[0] = 0;
  n1108[0] = 0;
  n1106[0] = 0;
  n1104[0] = 0;
  n1102[0] = 0;
  n1100[0] = 0;
  n1098[0] = 0;
  n1096[0] = 0;
  n1094[0] = 0;
  n1092[0] = 0;
  n1090[0] = 0;
  n1088[0] = 0;
  n1086[0] = 0;
  n1084[0] = 0;
  n1082[0] = 0;
  n1080[0] = 0;
  n1079[0] = 0;
  n1078[0] = 0;
  n1077[0] = 0;
  n1076[0] = 0;
  n1075[0] = 0;
  n1072[0] = 0;
  { int index; for (index = 2; index > 0;) n1062[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1060[--index] = 0; }
  n1059[0] = 0;
  { int index; for (index = 2; index > 0;) n1008[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1007[--index] = 0; }
  n1004[0] = 0;
  n985[0] = 0;
  n984[0] = 0;
  n983[0] = 0;
  { int index; for (index = 2; index > 0;) n932[--index] = 0; }
  { int index; for (index = 2; index > 0;) n931[--index] = 0; }
  n928[0] = 0;
  n909[0] = 0;
  n908[0] = 0;
  n907[0] = 0;
  { int index; for (index = 2; index > 0;) n856[--index] = 0; }
  { int index; for (index = 2; index > 0;) n855[--index] = 0; }
  n852[0] = 0;
  n833[0] = 0;
  n832[0] = 0;
  n831[0] = 0;
  { int index; for (index = 2; index > 0;) n780[--index] = 0; }
  { int index; for (index = 2; index > 0;) n779[--index] = 0; }
  n776[0] = 0;
  n757[0] = 0;
  n756[0] = 0;
  n755[0] = 0;
  { int index; for (index = 2; index > 0;) n704[--index] = 0; }
  { int index; for (index = 2; index > 0;) n703[--index] = 0; }
  n700[0] = 0;
  n681[0] = 0;
  n680[0] = 0;
  n679[0] = 0;
  { int index; for (index = 2; index > 0;) n628[--index] = 0; }
  { int index; for (index = 2; index > 0;) n627[--index] = 0; }
  n624[0] = 0;
  n605[0] = 0;
  n604[0] = 0;
  n603[0] = 0;
  { int index; for (index = 3; index > 0;) n552[--index] = 0; }
  { int index; for (index = 3; index > 0;) n551[--index] = 0; }
  n548[0] = 0;
  n529[0] = 0;
  n528[0] = 0;
  n527[0] = 0;
  { int index; for (index = 3; index > 0;) n476[--index] = 0; }
  { int index; for (index = 3; index > 0;) n475[--index] = 0; }
  n472[0] = 0;
  n453[0] = 0;
  n452[0] = 0;
  n451[0] = 0;
  { int index; for (index = 3; index > 0;) n400[--index] = 0; }
  { int index; for (index = 3; index > 0;) n399[--index] = 0; }
  n396[0] = 0;
  n377[0] = 0;
  n376[0] = 0;
  n375[0] = 0;
  { int index; for (index = 3; index > 0;) n324[--index] = 0; }
  { int index; for (index = 3; index > 0;) n323[--index] = 0; }
  n320[0] = 0;
  n301[0] = 0;
  n300[0] = 0;
  n299[0] = 0;
  { int index; for (index = 3; index > 0;) n248[--index] = 0; }
  { int index; for (index = 3; index > 0;) n247[--index] = 0; }
  n244[0] = 0;
  n243[0] = 0;
  n182[0] = 0;
  n180[0] = 0;
  { int index; for (index = 2; index > 0;) n100[--index] = 0; }
  n99[0] = 0;
  { int index; for (index = 2; index > 0;) n27[--index] = 0; }
  n26[0] = 0;
  { int index; for (index = 2; index > 0;) n24[--index] = 0; }
  n23[0] = 0;
  n22[0] = 0;
  { int index; for (index = 2; index > 0;) n21[--index] = 0; }
  n20[0] = 0;
  n19[0] = 0;
  n2[0] = 0;
  n1[0] = 0;
  n1073[0] = 0;
  { int index; for (index = 2; index > 0;) n1061[--index] = 0; }
  n1044[0] = 0;
  n1044r[0] = 0;
  n1044e[0] = 0;
  n1044d[0] = 0;
  n1037[0] = 0;
  n1037r[0] = 0;
  n1037e[0] = 0;
  n1037d[0] = 0;
  n1030[0] = 0;
  n1030r[0] = 0;
  n1030e[0] = 0;
  n1030d[0] = 0;
  n1023[0] = 0;
  n1023r[0] = 0;
  n1023e[0] = 0;
  n1023d[0] = 0;
  n1016[0] = 0;
  n1016r[0] = 0;
  n1016e[0] = 0;
  n1016d[0] = 0;
  n1005[0] = 0;
  n987[0] = 0;
  n986[0] = 0;
  n968[0] = 0;
  n968r[0] = 0;
  n968e[0] = 0;
  n968d[0] = 0;
  n961[0] = 0;
  n961r[0] = 0;
  n961e[0] = 0;
  n961d[0] = 0;
  n954[0] = 0;
  n954r[0] = 0;
  n954e[0] = 0;
  n954d[0] = 0;
  n947[0] = 0;
  n947r[0] = 0;
  n947e[0] = 0;
  n947d[0] = 0;
  n940[0] = 0;
  n940r[0] = 0;
  n940e[0] = 0;
  n940d[0] = 0;
  n929[0] = 0;
  n911[0] = 0;
  n910[0] = 0;
  n892[0] = 0;
  n892r[0] = 0;
  n892e[0] = 0;
  n892d[0] = 0;
  n885[0] = 0;
  n885r[0] = 0;
  n885e[0] = 0;
  n885d[0] = 0;
  n878[0] = 0;
  n878r[0] = 0;
  n878e[0] = 0;
  n878d[0] = 0;
  n871[0] = 0;
  n871r[0] = 0;
  n871e[0] = 0;
  n871d[0] = 0;
  n864[0] = 0;
  n864r[0] = 0;
  n864e[0] = 0;
  n864d[0] = 0;
  n853[0] = 0;
  n835[0] = 0;
  n834[0] = 0;
  n816[0] = 0;
  n816r[0] = 0;
  n816e[0] = 0;
  n816d[0] = 0;
  n809[0] = 0;
  n809r[0] = 0;
  n809e[0] = 0;
  n809d[0] = 0;
  n802[0] = 0;
  n802r[0] = 0;
  n802e[0] = 0;
  n802d[0] = 0;
  n795[0] = 0;
  n795r[0] = 0;
  n795e[0] = 0;
  n795d[0] = 0;
  n788[0] = 0;
  n788r[0] = 0;
  n788e[0] = 0;
  n788d[0] = 0;
  n777[0] = 0;
  n759[0] = 0;
  n758[0] = 0;
  n740[0] = 0;
  n740r[0] = 0;
  n740e[0] = 0;
  n740d[0] = 0;
  n733[0] = 0;
  n733r[0] = 0;
  n733e[0] = 0;
  n733d[0] = 0;
  n726[0] = 0;
  n726r[0] = 0;
  n726e[0] = 0;
  n726d[0] = 0;
  n719[0] = 0;
  n719r[0] = 0;
  n719e[0] = 0;
  n719d[0] = 0;
  n712[0] = 0;
  n712r[0] = 0;
  n712e[0] = 0;
  n712d[0] = 0;
  n701[0] = 0;
  n683[0] = 0;
  n682[0] = 0;
  n664[0] = 0;
  n664r[0] = 0;
  n664e[0] = 0;
  n664d[0] = 0;
  n657[0] = 0;
  n657r[0] = 0;
  n657e[0] = 0;
  n657d[0] = 0;
  n650[0] = 0;
  n650r[0] = 0;
  n650e[0] = 0;
  n650d[0] = 0;
  n643[0] = 0;
  n643r[0] = 0;
  n643e[0] = 0;
  n643d[0] = 0;
  n636[0] = 0;
  n636r[0] = 0;
  n636e[0] = 0;
  n636d[0] = 0;
  n625[0] = 0;
  n607[0] = 0;
  n606[0] = 0;
  n588[0] = 0;
  n588r[0] = 0;
  n588e[0] = 0;
  n588d[0] = 0;
  n581[0] = 0;
  n581r[0] = 0;
  n581e[0] = 0;
  n581d[0] = 0;
  n574[0] = 0;
  n574r[0] = 0;
  n574e[0] = 0;
  n574d[0] = 0;
  n567[0] = 0;
  n567r[0] = 0;
  n567e[0] = 0;
  n567d[0] = 0;
  n560[0] = 0;
  n560r[0] = 0;
  n560e[0] = 0;
  n560d[0] = 0;
  n549[0] = 0;
  n531[0] = 0;
  n530[0] = 0;
  n512[0] = 0;
  n512r[0] = 0;
  n512e[0] = 0;
  n512d[0] = 0;
  n505[0] = 0;
  n505r[0] = 0;
  n505e[0] = 0;
  n505d[0] = 0;
  n498[0] = 0;
  n498r[0] = 0;
  n498e[0] = 0;
  n498d[0] = 0;
  n491[0] = 0;
  n491r[0] = 0;
  n491e[0] = 0;
  n491d[0] = 0;
  n484[0] = 0;
  n484r[0] = 0;
  n484e[0] = 0;
  n484d[0] = 0;
  n473[0] = 0;
  n455[0] = 0;
  n454[0] = 0;
  n436[0] = 0;
  n436r[0] = 0;
  n436e[0] = 0;
  n436d[0] = 0;
  n429[0] = 0;
  n429r[0] = 0;
  n429e[0] = 0;
  n429d[0] = 0;
  n422[0] = 0;
  n422r[0] = 0;
  n422e[0] = 0;
  n422d[0] = 0;
  n415[0] = 0;
  n415r[0] = 0;
  n415e[0] = 0;
  n415d[0] = 0;
  n408[0] = 0;
  n408r[0] = 0;
  n408e[0] = 0;
  n408d[0] = 0;
  n397[0] = 0;
  n379[0] = 0;
  n378[0] = 0;
  n360[0] = 0;
  n360r[0] = 0;
  n360e[0] = 0;
  n360d[0] = 0;
  n353[0] = 0;
  n353r[0] = 0;
  n353e[0] = 0;
  n353d[0] = 0;
  n346[0] = 0;
  n346r[0] = 0;
  n346e[0] = 0;
  n346d[0] = 0;
  n339[0] = 0;
  n339r[0] = 0;
  n339e[0] = 0;
  n339d[0] = 0;
  n332[0] = 0;
  n332r[0] = 0;
  n332e[0] = 0;
  n332d[0] = 0;
  n321[0] = 0;
  n303[0] = 0;
  n302[0] = 0;
  n284[0] = 0;
  n284r[0] = 0;
  n284e[0] = 0;
  n284d[0] = 0;
  n277[0] = 0;
  n277r[0] = 0;
  n277e[0] = 0;
  n277d[0] = 0;
  n270[0] = 0;
  n270r[0] = 0;
  n270e[0] = 0;
  n270d[0] = 0;
  n263[0] = 0;
  n263r[0] = 0;
  n263e[0] = 0;
  n263d[0] = 0;
  n256[0] = 0;
  n256r[0] = 0;
  n256e[0] = 0;
  n256d[0] = 0;
  { int index; for (index = 3; index > 0;) n249[--index] = 0; }
  n245[0] = 0;
  n183[0] = 0;
  n181[0] = 0;
  n179[0] = 0;
  n162[0] = 0;
  n160[0] = 0;
  { int index; for (index = 2; index > 0;) n131[--index] = 0; }
  n130[0] = 0;
  n116[0] = 0;
  n115[0] = 0;
  n102[0] = 0;
  n101[0] = 0;
  n89[0] = 0;
  n87[0] = 0;
  { int index; for (index = 2; index > 0;) n58[--index] = 0; }
  n57[0] = 0;
  n43[0] = 0;
  n42[0] = 0;
  n29[0] = 0;
  n28[0] = 0;
  { int index; for (index = 2; index > 0;) n18[--index] = 0; }
  n18r[0] = 0;
  n18e[0] = 0;
  { int index; for (index = 2; index > 0;) n18d[--index] = 0; }
  { int index; for (index = 2; index > 0;) n11[--index] = 0; }
  n11r[0] = 0;
  n11e[0] = 0;
  { int index; for (index = 2; index > 0;) n11d[--index] = 0; }
  n1074[0] = 0;
  n996[0] = 0;
  n989[0] = 0;
  n988[0] = 0;
  n920[0] = 0;
  n913[0] = 0;
  n912[0] = 0;
  n844[0] = 0;
  n837[0] = 0;
  n836[0] = 0;
  n768[0] = 0;
  n761[0] = 0;
  n760[0] = 0;
  n692[0] = 0;
  n685[0] = 0;
  n684[0] = 0;
  n616[0] = 0;
  n609[0] = 0;
  n608[0] = 0;
  n540[0] = 0;
  n533[0] = 0;
  n532[0] = 0;
  n464[0] = 0;
  n457[0] = 0;
  n456[0] = 0;
  n388[0] = 0;
  n381[0] = 0;
  n380[0] = 0;
  n312[0] = 0;
  n305[0] = 0;
  n304[0] = 0;
  { int index; for (index = 3; index > 0;) n298[--index] = 0; }
  n298r[0] = 0;
  n298e[0] = 0;
  { int index; for (index = 3; index > 0;) n298d[--index] = 0; }
  n246[0] = 0;
  n228[0] = 0;
  n228r[0] = 0;
  n228e[0] = 0;
  n228d[0] = 0;
  n184[0] = 0;
  n163[0] = 0;
  n133[0] = 0;
  n132[0] = 0;
  n118[0] = 0;
  n117[0] = 0;
  n104[0] = 0;
  n103[0] = 0;
  n90[0] = 0;
  n60[0] = 0;
  n59[0] = 0;
  n45[0] = 0;
  n44[0] = 0;
  n31[0] = 0;
  n30[0] = 0;
  n1109[0] = 0;
  n1107[0] = 0;
  n1105[0] = 0;
  n1103[0] = 0;
  n1101[0] = 0;
  n1099[0] = 0;
  n1097[0] = 0;
  n1095[0] = 0;
  n1093[0] = 0;
  n1091[0] = 0;
  n1089[0] = 0;
  n1087[0] = 0;
  n1085[0] = 0;
  n1083[0] = 0;
  n1081[0] = 0;
  n991[0] = 0;
  n990[0] = 0;
  n915[0] = 0;
  n914[0] = 0;
  n839[0] = 0;
  n838[0] = 0;
  n763[0] = 0;
  n762[0] = 0;
  n687[0] = 0;
  n686[0] = 0;
  n611[0] = 0;
  n610[0] = 0;
  n535[0] = 0;
  n534[0] = 0;
  n459[0] = 0;
  n458[0] = 0;
  n383[0] = 0;
  n382[0] = 0;
  n307[0] = 0;
  n306[0] = 0;
  n291[0] = 0;
  n291r[0] = 0;
  n291e[0] = 0;
  n291d[0] = 0;
  n188[0] = 0;
  n150[0] = 0;
  n135[0] = 0;
  n134[0] = 0;
  n125[0] = 0;
  n120[0] = 0;
  n119[0] = 0;
  n111[0] = 0;
  n106[0] = 0;
  n105[0] = 0;
  n77[0] = 0;
  n62[0] = 0;
  n61[0] = 0;
  n52[0] = 0;
  n47[0] = 0;
  n46[0] = 0;
  n38[0] = 0;
  n33[0] = 0;
  n32[0] = 0;
  n1110[0] = 0;
  n997[0] = 0;
  n993[0] = 0;
  n992[0] = 0;
  n921[0] = 0;
  n917[0] = 0;
  n916[0] = 0;
  n845[0] = 0;
  n841[0] = 0;
  n840[0] = 0;
  n769[0] = 0;
  n765[0] = 0;
  n764[0] = 0;
  n693[0] = 0;
  n689[0] = 0;
  n688[0] = 0;
  n617[0] = 0;
  n613[0] = 0;
  n612[0] = 0;
  n541[0] = 0;
  n537[0] = 0;
  n536[0] = 0;
  n465[0] = 0;
  n461[0] = 0;
  n460[0] = 0;
  n389[0] = 0;
  n385[0] = 0;
  n384[0] = 0;
  n313[0] = 0;
  n309[0] = 0;
  n308[0] = 0;
  n235[0] = 0;
  n235r[0] = 0;
  n235e[0] = 0;
  n235d[0] = 0;
  n137[0] = 0;
  n136[0] = 0;
  n122[0] = 0;
  n121[0] = 0;
  n108[0] = 0;
  n107[0] = 0;
  n64[0] = 0;
  n63[0] = 0;
  n49[0] = 0;
  n48[0] = 0;
  n35[0] = 0;
  n34[0] = 0;
  n1111[0] = 0;
  n999[0] = 0;
  n994[0] = 0;
  n923[0] = 0;
  n918[0] = 0;
  n847[0] = 0;
  n842[0] = 0;
  n771[0] = 0;
  n766[0] = 0;
  n695[0] = 0;
  n690[0] = 0;
  n619[0] = 0;
  n614[0] = 0;
  n543[0] = 0;
  n538[0] = 0;
  n467[0] = 0;
  n462[0] = 0;
  n391[0] = 0;
  n386[0] = 0;
  n315[0] = 0;
  n310[0] = 0;
  n151[0] = 0;
  n139[0] = 0;
  n138[0] = 0;
  n126[0] = 0;
  n123[0] = 0;
  n112[0] = 0;
  n109[0] = 0;
  n78[0] = 0;
  n66[0] = 0;
  n65[0] = 0;
  n53[0] = 0;
  n50[0] = 0;
  n39[0] = 0;
  n36[0] = 0;
  n1112[0] = 0;
  n998[0] = 0;
  n922[0] = 0;
  n846[0] = 0;
  n770[0] = 0;
  n694[0] = 0;
  n618[0] = 0;
  n542[0] = 0;
  n466[0] = 0;
  n390[0] = 0;
  n314[0] = 0;
  n155[0] = 0;
  n141[0] = 0;
  n140[0] = 0;
  n127[0] = 0;
  n113[0] = 0;
  n82[0] = 0;
  n68[0] = 0;
  n67[0] = 0;
  n54[0] = 0;
  n40[0] = 0;
  n1113[0] = 0;
  n1000[0] = 0;
  n924[0] = 0;
  n848[0] = 0;
  n772[0] = 0;
  n696[0] = 0;
  n620[0] = 0;
  n544[0] = 0;
  n468[0] = 0;
  n392[0] = 0;
  n316[0] = 0;
  n152[0] = 0;
  n143[0] = 0;
  n142[0] = 0;
  n128[0] = 0;
  n114[0] = 0;
  n79[0] = 0;
  n70[0] = 0;
  n69[0] = 0;
  n55[0] = 0;
  n41[0] = 0;
  n1114[0] = 0;
  n1001[0] = 0;
  n925[0] = 0;
  n849[0] = 0;
  n773[0] = 0;
  n697[0] = 0;
  n621[0] = 0;
  n545[0] = 0;
  n469[0] = 0;
  n393[0] = 0;
  n317[0] = 0;
  n164[0] = 0;
  n161[0] = 0;
  n145[0] = 0;
  n144[0] = 0;
  n129[0] = 0;
  n91[0] = 0;
  n88[0] = 0;
  n72[0] = 0;
  n71[0] = 0;
  n56[0] = 0;
  n1115[0] = 0;
  n1002[0] = 0;
  n926[0] = 0;
  n850[0] = 0;
  n774[0] = 0;
  n698[0] = 0;
  n622[0] = 0;
  n546[0] = 0;
  n470[0] = 0;
  n394[0] = 0;
  n318[0] = 0;
  n153[0] = 0;
  n147[0] = 0;
  n146[0] = 0;
  n80[0] = 0;
  n74[0] = 0;
  n73[0] = 0;
  n1116[0] = 0;
  n1003[0] = 0;
  n927[0] = 0;
  n851[0] = 0;
  n775[0] = 0;
  n699[0] = 0;
  n623[0] = 0;
  n547[0] = 0;
  n471[0] = 0;
  n395[0] = 0;
  n319[0] = 0;
  n156[0] = 0;
  n148[0] = 0;
  n83[0] = 0;
  n75[0] = 0;
  n1117[0] = 0;
  { int index; for (index = 2; index > 0;) n1009[--index] = 0; }
  n1006[0] = 0;
  { int index; for (index = 2; index > 0;) n933[--index] = 0; }
  n930[0] = 0;
  { int index; for (index = 2; index > 0;) n857[--index] = 0; }
  n854[0] = 0;
  { int index; for (index = 2; index > 0;) n781[--index] = 0; }
  n778[0] = 0;
  { int index; for (index = 2; index > 0;) n705[--index] = 0; }
  n702[0] = 0;
  { int index; for (index = 2; index > 0;) n629[--index] = 0; }
  n626[0] = 0;
  { int index; for (index = 3; index > 0;) n553[--index] = 0; }
  n550[0] = 0;
  { int index; for (index = 3; index > 0;) n477[--index] = 0; }
  n474[0] = 0;
  { int index; for (index = 3; index > 0;) n401[--index] = 0; }
  n398[0] = 0;
  { int index; for (index = 3; index > 0;) n325[--index] = 0; }
  n322[0] = 0;
  n157[0] = 0;
  n154[0] = 0;
  n84[0] = 0;
  n81[0] = 0;
  n1118[0] = 0;
  { int index; for (index = 2; index > 0;) n1058[--index] = 0; }
  n1058r[0] = 0;
  n1058e[0] = 0;
  { int index; for (index = 2; index > 0;) n1058d[--index] = 0; }
  n1051[0] = 0;
  n1051r[0] = 0;
  n1051e[0] = 0;
  n1051d[0] = 0;
  { int index; for (index = 2; index > 0;) n982[--index] = 0; }
  n982r[0] = 0;
  n982e[0] = 0;
  { int index; for (index = 2; index > 0;) n982d[--index] = 0; }
  n975[0] = 0;
  n975r[0] = 0;
  n975e[0] = 0;
  n975d[0] = 0;
  { int index; for (index = 2; index > 0;) n906[--index] = 0; }
  n906r[0] = 0;
  n906e[0] = 0;
  { int index; for (index = 2; index > 0;) n906d[--index] = 0; }
  n899[0] = 0;
  n899r[0] = 0;
  n899e[0] = 0;
  n899d[0] = 0;
  { int index; for (index = 2; index > 0;) n830[--index] = 0; }
  n830r[0] = 0;
  n830e[0] = 0;
  { int index; for (index = 2; index > 0;) n830d[--index] = 0; }
  n823[0] = 0;
  n823r[0] = 0;
  n823e[0] = 0;
  n823d[0] = 0;
  { int index; for (index = 2; index > 0;) n754[--index] = 0; }
  n754r[0] = 0;
  n754e[0] = 0;
  { int index; for (index = 2; index > 0;) n754d[--index] = 0; }
  n747[0] = 0;
  n747r[0] = 0;
  n747e[0] = 0;
  n747d[0] = 0;
  { int index; for (index = 2; index > 0;) n678[--index] = 0; }
  n678r[0] = 0;
  n678e[0] = 0;
  { int index; for (index = 2; index > 0;) n678d[--index] = 0; }
  n671[0] = 0;
  n671r[0] = 0;
  n671e[0] = 0;
  n671d[0] = 0;
  { int index; for (index = 3; index > 0;) n602[--index] = 0; }
  n602r[0] = 0;
  n602e[0] = 0;
  { int index; for (index = 3; index > 0;) n602d[--index] = 0; }
  n595[0] = 0;
  n595r[0] = 0;
  n595e[0] = 0;
  n595d[0] = 0;
  { int index; for (index = 3; index > 0;) n526[--index] = 0; }
  n526r[0] = 0;
  n526e[0] = 0;
  { int index; for (index = 3; index > 0;) n526d[--index] = 0; }
  n519[0] = 0;
  n519r[0] = 0;
  n519e[0] = 0;
  n519d[0] = 0;
  { int index; for (index = 3; index > 0;) n450[--index] = 0; }
  n450r[0] = 0;
  n450e[0] = 0;
  { int index; for (index = 3; index > 0;) n450d[--index] = 0; }
  n443[0] = 0;
  n443r[0] = 0;
  n443e[0] = 0;
  n443d[0] = 0;
  { int index; for (index = 3; index > 0;) n374[--index] = 0; }
  n374r[0] = 0;
  n374e[0] = 0;
  { int index; for (index = 3; index > 0;) n374d[--index] = 0; }
  n367[0] = 0;
  n367r[0] = 0;
  n367e[0] = 0;
  n367d[0] = 0;
  n158[0] = 0;
  n85[0] = 0;
  n1119[0] = 0;
  n159[0] = 0;
  n86[0] = 0;
  n1120[0] = 0;
  n169[0] = 0;
  n168[0] = 0;
  n167[0] = 0;
  n165[0] = 0;
  n96[0] = 0;
  n95[0] = 0;
  n94[0] = 0;
  n92[0] = 0;
  n1121[0] = 0;
  n178[0] = 0;
  n177[0] = 0;
  n175[0] = 0;
  n174[0] = 0;
  n170[0] = 0;
  n166[0] = 0;
  n97[0] = 0;
  n93[0] = 0;
  n1122[0] = 0;
  n221[0] = 0;
  n221r[0] = 0;
  n221e[0] = 0;
  n221d[0] = 0;
  n214[0] = 0;
  n214r[0] = 0;
  n214e[0] = 0;
  n214d[0] = 0;
  n191[0] = 0;
  n189[0] = 0;
  n176[0] = 0;
  n172[0] = 0;
  n171[0] = 0;
  n1123[0] = 0;
  n207[0] = 0;
  n207r[0] = 0;
  n207e[0] = 0;
  n207d[0] = 0;
  { int index; for (index = 2; index > 0;) n192[--index] = 0; }
  { int index; for (index = 2; index > 0;) n190[--index] = 0; }
  n173[0] = 0;
  n1124[0] = 0;
  n200[0] = 0;
  n200r[0] = 0;
  n200e[0] = 0;
  n200d[0] = 0;
  { int index; for (index = 3; index > 0;) n193[--index] = 0; }
  n1126[0] = 0;
  n1125[0] = 0;
  { int index; for (index = 3; index > 0;) n242[--index] = 0; }
  n242r[0] = 0;
  n242e[0] = 0;
  { int index; for (index = 3; index > 0;) n242d[--index] = 0; }
  n1130[0] = 0;
  n1129[0] = 0;
  { int index; for (index = 2; index > 0;) n1128[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1127[--index] = 0; }
  n1133[0] = 0;
  { int index; for (index = 2; index > 0;) n1131[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1134[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1135[--index] = 0; }
  { int index; for (index = 2; index > 0;) n1142[--index] = 0; }
  n1142r[0] = 0;
  n1142e[0] = 0;
  { int index; for (index = 2; index > 0;) n1142d[--index] = 0; }
  cf_fp_mul_p_5_10_calc();
}

void cf_fp_mul_p_5_10_cycle_clock()
{
  if (n11r[0]) {
    n11[0] = 0;
    n11[1] = 0;
  }
  else if (n11e[0]) {
    n11[0] = n11d[0];
    n11[1] = n11d[1];
  }
  if (n18r[0]) {
    n18[0] = 0;
    n18[1] = 0;
  }
  else if (n18e[0]) {
    n18[0] = n18d[0];
    n18[1] = n18d[1];
  }
  if (n200r[0]) {
    n200[0] = 0;
  }
  else if (n200e[0]) {
    n200[0] = n200d[0];
  }
  if (n207r[0]) {
    n207[0] = 0;
  }
  else if (n207e[0]) {
    n207[0] = n207d[0];
  }
  if (n214r[0]) {
    n214[0] = 0;
  }
  else if (n214e[0]) {
    n214[0] = n214d[0];
  }
  if (n221r[0]) {
    n221[0] = 0;
  }
  else if (n221e[0]) {
    n221[0] = n221d[0];
  }
  if (n228r[0]) {
    n228[0] = 0;
  }
  else if (n228e[0]) {
    n228[0] = n228d[0];
  }
  if (n235r[0]) {
    n235[0] = 0;
  }
  else if (n235e[0]) {
    n235[0] = n235d[0];
  }
  if (n242r[0]) {
    n242[0] = 0;
    n242[1] = 0;
    n242[2] = 0;
  }
  else if (n242e[0]) {
    n242[0] = n242d[0];
    n242[1] = n242d[1];
    n242[2] = n242d[2];
  }
  if (n256r[0]) {
    n256[0] = 0;
  }
  else if (n256e[0]) {
    n256[0] = n256d[0];
  }
  if (n263r[0]) {
    n263[0] = 0;
  }
  else if (n263e[0]) {
    n263[0] = n263d[0];
  }
  if (n270r[0]) {
    n270[0] = 0;
  }
  else if (n270e[0]) {
    n270[0] = n270d[0];
  }
  if (n277r[0]) {
    n277[0] = 0;
  }
  else if (n277e[0]) {
    n277[0] = n277d[0];
  }
  if (n284r[0]) {
    n284[0] = 0;
  }
  else if (n284e[0]) {
    n284[0] = n284d[0];
  }
  if (n291r[0]) {
    n291[0] = 0;
  }
  else if (n291e[0]) {
    n291[0] = n291d[0];
  }
  if (n298r[0]) {
    n298[0] = 0;
    n298[1] = 0;
    n298[2] = 0;
  }
  else if (n298e[0]) {
    n298[0] = n298d[0];
    n298[1] = n298d[1];
    n298[2] = n298d[2];
  }
  if (n332r[0]) {
    n332[0] = 0;
  }
  else if (n332e[0]) {
    n332[0] = n332d[0];
  }
  if (n339r[0]) {
    n339[0] = 0;
  }
  else if (n339e[0]) {
    n339[0] = n339d[0];
  }
  if (n346r[0]) {
    n346[0] = 0;
  }
  else if (n346e[0]) {
    n346[0] = n346d[0];
  }
  if (n353r[0]) {
    n353[0] = 0;
  }
  else if (n353e[0]) {
    n353[0] = n353d[0];
  }
  if (n360r[0]) {
    n360[0] = 0;
  }
  else if (n360e[0]) {
    n360[0] = n360d[0];
  }
  if (n367r[0]) {
    n367[0] = 0;
  }
  else if (n367e[0]) {
    n367[0] = n367d[0];
  }
  if (n374r[0]) {
    n374[0] = 0;
    n374[1] = 0;
    n374[2] = 0;
  }
  else if (n374e[0]) {
    n374[0] = n374d[0];
    n374[1] = n374d[1];
    n374[2] = n374d[2];
  }
  if (n408r[0]) {
    n408[0] = 0;
  }
  else if (n408e[0]) {
    n408[0] = n408d[0];
  }
  if (n415r[0]) {
    n415[0] = 0;
  }
  else if (n415e[0]) {
    n415[0] = n415d[0];
  }
  if (n422r[0]) {
    n422[0] = 0;
  }
  else if (n422e[0]) {
    n422[0] = n422d[0];
  }
  if (n429r[0]) {
    n429[0] = 0;
  }
  else if (n429e[0]) {
    n429[0] = n429d[0];
  }
  if (n436r[0]) {
    n436[0] = 0;
  }
  else if (n436e[0]) {
    n436[0] = n436d[0];
  }
  if (n443r[0]) {
    n443[0] = 0;
  }
  else if (n443e[0]) {
    n443[0] = n443d[0];
  }
  if (n450r[0]) {
    n450[0] = 0;
    n450[1] = 0;
    n450[2] = 0;
  }
  else if (n450e[0]) {
    n450[0] = n450d[0];
    n450[1] = n450d[1];
    n450[2] = n450d[2];
  }
  if (n484r[0]) {
    n484[0] = 0;
  }
  else if (n484e[0]) {
    n484[0] = n484d[0];
  }
  if (n491r[0]) {
    n491[0] = 0;
  }
  else if (n491e[0]) {
    n491[0] = n491d[0];
  }
  if (n498r[0]) {
    n498[0] = 0;
  }
  else if (n498e[0]) {
    n498[0] = n498d[0];
  }
  if (n505r[0]) {
    n505[0] = 0;
  }
  else if (n505e[0]) {
    n505[0] = n505d[0];
  }
  if (n512r[0]) {
    n512[0] = 0;
  }
  else if (n512e[0]) {
    n512[0] = n512d[0];
  }
  if (n519r[0]) {
    n519[0] = 0;
  }
  else if (n519e[0]) {
    n519[0] = n519d[0];
  }
  if (n526r[0]) {
    n526[0] = 0;
    n526[1] = 0;
    n526[2] = 0;
  }
  else if (n526e[0]) {
    n526[0] = n526d[0];
    n526[1] = n526d[1];
    n526[2] = n526d[2];
  }
  if (n560r[0]) {
    n560[0] = 0;
  }
  else if (n560e[0]) {
    n560[0] = n560d[0];
  }
  if (n567r[0]) {
    n567[0] = 0;
  }
  else if (n567e[0]) {
    n567[0] = n567d[0];
  }
  if (n574r[0]) {
    n574[0] = 0;
  }
  else if (n574e[0]) {
    n574[0] = n574d[0];
  }
  if (n581r[0]) {
    n581[0] = 0;
  }
  else if (n581e[0]) {
    n581[0] = n581d[0];
  }
  if (n588r[0]) {
    n588[0] = 0;
  }
  else if (n588e[0]) {
    n588[0] = n588d[0];
  }
  if (n595r[0]) {
    n595[0] = 0;
  }
  else if (n595e[0]) {
    n595[0] = n595d[0];
  }
  if (n602r[0]) {
    n602[0] = 0;
    n602[1] = 0;
    n602[2] = 0;
  }
  else if (n602e[0]) {
    n602[0] = n602d[0];
    n602[1] = n602d[1];
    n602[2] = n602d[2];
  }
  if (n636r[0]) {
    n636[0] = 0;
  }
  else if (n636e[0]) {
    n636[0] = n636d[0];
  }
  if (n643r[0]) {
    n643[0] = 0;
  }
  else if (n643e[0]) {
    n643[0] = n643d[0];
  }
  if (n650r[0]) {
    n650[0] = 0;
  }
  else if (n650e[0]) {
    n650[0] = n650d[0];
  }
  if (n657r[0]) {
    n657[0] = 0;
  }
  else if (n657e[0]) {
    n657[0] = n657d[0];
  }
  if (n664r[0]) {
    n664[0] = 0;
  }
  else if (n664e[0]) {
    n664[0] = n664d[0];
  }
  if (n671r[0]) {
    n671[0] = 0;
  }
  else if (n671e[0]) {
    n671[0] = n671d[0];
  }
  if (n678r[0]) {
    n678[0] = 0;
    n678[1] = 0;
  }
  else if (n678e[0]) {
    n678[0] = n678d[0];
    n678[1] = n678d[1];
  }
  if (n712r[0]) {
    n712[0] = 0;
  }
  else if (n712e[0]) {
    n712[0] = n712d[0];
  }
  if (n719r[0]) {
    n719[0] = 0;
  }
  else if (n719e[0]) {
    n719[0] = n719d[0];
  }
  if (n726r[0]) {
    n726[0] = 0;
  }
  else if (n726e[0]) {
    n726[0] = n726d[0];
  }
  if (n733r[0]) {
    n733[0] = 0;
  }
  else if (n733e[0]) {
    n733[0] = n733d[0];
  }
  if (n740r[0]) {
    n740[0] = 0;
  }
  else if (n740e[0]) {
    n740[0] = n740d[0];
  }
  if (n747r[0]) {
    n747[0] = 0;
  }
  else if (n747e[0]) {
    n747[0] = n747d[0];
  }
  if (n754r[0]) {
    n754[0] = 0;
    n754[1] = 0;
  }
  else if (n754e[0]) {
    n754[0] = n754d[0];
    n754[1] = n754d[1];
  }
  if (n788r[0]) {
    n788[0] = 0;
  }
  else if (n788e[0]) {
    n788[0] = n788d[0];
  }
  if (n795r[0]) {
    n795[0] = 0;
  }
  else if (n795e[0]) {
    n795[0] = n795d[0];
  }
  if (n802r[0]) {
    n802[0] = 0;
  }
  else if (n802e[0]) {
    n802[0] = n802d[0];
  }
  if (n809r[0]) {
    n809[0] = 0;
  }
  else if (n809e[0]) {
    n809[0] = n809d[0];
  }
  if (n816r[0]) {
    n816[0] = 0;
  }
  else if (n816e[0]) {
    n816[0] = n816d[0];
  }
  if (n823r[0]) {
    n823[0] = 0;
  }
  else if (n823e[0]) {
    n823[0] = n823d[0];
  }
  if (n830r[0]) {
    n830[0] = 0;
    n830[1] = 0;
  }
  else if (n830e[0]) {
    n830[0] = n830d[0];
    n830[1] = n830d[1];
  }
  if (n864r[0]) {
    n864[0] = 0;
  }
  else if (n864e[0]) {
    n864[0] = n864d[0];
  }
  if (n871r[0]) {
    n871[0] = 0;
  }
  else if (n871e[0]) {
    n871[0] = n871d[0];
  }
  if (n878r[0]) {
    n878[0] = 0;
  }
  else if (n878e[0]) {
    n878[0] = n878d[0];
  }
  if (n885r[0]) {
    n885[0] = 0;
  }
  else if (n885e[0]) {
    n885[0] = n885d[0];
  }
  if (n892r[0]) {
    n892[0] = 0;
  }
  else if (n892e[0]) {
    n892[0] = n892d[0];
  }
  if (n899r[0]) {
    n899[0] = 0;
  }
  else if (n899e[0]) {
    n899[0] = n899d[0];
  }
  if (n906r[0]) {
    n906[0] = 0;
    n906[1] = 0;
  }
  else if (n906e[0]) {
    n906[0] = n906d[0];
    n906[1] = n906d[1];
  }
  if (n940r[0]) {
    n940[0] = 0;
  }
  else if (n940e[0]) {
    n940[0] = n940d[0];
  }
  if (n947r[0]) {
    n947[0] = 0;
  }
  else if (n947e[0]) {
    n947[0] = n947d[0];
  }
  if (n954r[0]) {
    n954[0] = 0;
  }
  else if (n954e[0]) {
    n954[0] = n954d[0];
  }
  if (n961r[0]) {
    n961[0] = 0;
  }
  else if (n961e[0]) {
    n961[0] = n961d[0];
  }
  if (n968r[0]) {
    n968[0] = 0;
  }
  else if (n968e[0]) {
    n968[0] = n968d[0];
  }
  if (n975r[0]) {
    n975[0] = 0;
  }
  else if (n975e[0]) {
    n975[0] = n975d[0];
  }
  if (n982r[0]) {
    n982[0] = 0;
    n982[1] = 0;
  }
  else if (n982e[0]) {
    n982[0] = n982d[0];
    n982[1] = n982d[1];
  }
  if (n1016r[0]) {
    n1016[0] = 0;
  }
  else if (n1016e[0]) {
    n1016[0] = n1016d[0];
  }
  if (n1023r[0]) {
    n1023[0] = 0;
  }
  else if (n1023e[0]) {
    n1023[0] = n1023d[0];
  }
  if (n1030r[0]) {
    n1030[0] = 0;
  }
  else if (n1030e[0]) {
    n1030[0] = n1030d[0];
  }
  if (n1037r[0]) {
    n1037[0] = 0;
  }
  else if (n1037e[0]) {
    n1037[0] = n1037d[0];
  }
  if (n1044r[0]) {
    n1044[0] = 0;
  }
  else if (n1044e[0]) {
    n1044[0] = n1044d[0];
  }
  if (n1051r[0]) {
    n1051[0] = 0;
  }
  else if (n1051e[0]) {
    n1051[0] = n1051d[0];
  }
  if (n1058r[0]) {
    n1058[0] = 0;
    n1058[1] = 0;
  }
  else if (n1058e[0]) {
    n1058[0] = n1058d[0];
    n1058[1] = n1058d[1];
  }
  if (n1142r[0]) {
    n1142[0] = 0;
    n1142[1] = 0;
  }
  else if (n1142e[0]) {
    n1142[0] = n1142d[0];
    n1142[1] = n1142d[1];
  }
}

static FILE* sim_file;
static int sim_count;
static unsigned char sim_a_i[2];
static unsigned char sim_b_i[2];
static unsigned char sim_x_o[2];

void cf_fp_mul_p_5_10_sim_init(const char* file) {
  time_t date = time(NULL);
  sim_count = 1;
  cf_fp_mul_p_5_10_init();
  sim_a_i[0] = a_i[0];
  sim_a_i[1] = a_i[1];
  sim_b_i[0] = b_i[0];
  sim_b_i[1] = b_i[1];
  sim_x_o[0] = x_o[0];
  sim_x_o[1] = x_o[1];
  sim_file = fopen(file, "w");
  fprintf(sim_file,
    "$date\n  %s$end\n"
    "$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n"
    "$timescale\n  1 ns\n$end\n"
    "$scope module cf_fp_mul_p_5_10 $end\n"
    "$var wire 16 ! a_i $end\n"
    "$var wire 16 \" b_i $end\n"
    "$var wire 16 # x_o $end\n"
    "$upscope $end\n"
    "$enddefinitions $end\n"
    "#0\n"
    "$dumpvars\n", asctime(localtime(&date)));
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 1; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
        else if (bit & a_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " !\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 1; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
        else if (bit & b_i[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " \"\n");
  }
  {
    int bit;
    int byte;
    int found = 0;
    for (byte = 1; byte >= 0; byte--) {
      for (bit = 128; bit >= 1; bit /= 2) {
        if (found)
          fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
        else if (bit & x_o[byte]) {
          found = 1;
          fprintf(sim_file, "b1");
        }
      }
    }
    if (!found)
      fprintf(sim_file, "b0");
    fprintf(sim_file, " #\n");
  }
  fprintf(sim_file, "$end\n");
}

void cf_fp_mul_p_5_10_sim_end() {
  fprintf(sim_file, "#%d\n", sim_count);
  fclose(sim_file);
}

void cf_fp_mul_p_5_10_sim_sample() {
  int changed = 0;
  if (sim_a_i[1] != a_i[1] || sim_a_i[0] != a_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 1; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & a_i[byte]) ? "1" : "0");
          else if (bit & a_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " !\n");
    }
    sim_a_i[0] = a_i[0];
    sim_a_i[1] = a_i[1];
  }
  if (sim_b_i[1] != b_i[1] || sim_b_i[0] != b_i[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 1; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & b_i[byte]) ? "1" : "0");
          else if (bit & b_i[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " \"\n");
    }
    sim_b_i[0] = b_i[0];
    sim_b_i[1] = b_i[1];
  }
  if (sim_x_o[1] != x_o[1] || sim_x_o[0] != x_o[0]) {
    if (!changed) { changed = 1; fprintf(sim_file, "#%d\n", sim_count); }
    {
      int bit;
      int byte;
      int found = 0;
      for (byte = 1; byte >= 0; byte--) {
        for (bit = 128; bit >= 1; bit /= 2) {
          if (found)
            fprintf(sim_file, (bit & x_o[byte]) ? "1" : "0");
          else if (bit & x_o[byte]) {
            found = 1;
            fprintf(sim_file, "b1");
          }
        }
      }
      if (!found)
        fprintf(sim_file, "b0");
      fprintf(sim_file, " #\n");
    }
    sim_x_o[0] = x_o[0];
    sim_x_o[1] = x_o[1];
  }
  sim_count++;
}

