#
#  Copyright (c) 2003 Launchbird Design Systems, Inc.
#  All rights reserved.
#  
#  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#  
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#  
#  
#  Overview:
#  
#    Performs floating point multiply.
#  
#  Interface:
#  
#    Synchronization:
#      clock_c  : Clock input.
#  
#    Inputs:
#      a_i : Left operand.
#      b_i : Right operand.
#  
#    Outputs:
#      x_o : Result.
#  
#  Built In Parameters:
#  
#    Exponent Precision = 5
#    Mantissa Precision = 10
#    Total    Precision = 16
#    Pipeline Latency   = 14 clock cycles
#  
#  
#  
#  
#  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
#  
#  Build Date : Fri Aug 22 09:47:04 CDT 2003
#  
#  Interface
#  
#    Build Name    : cf_fp_mul_p_5_10
#    Clock Domains : clock_c  
#    Vector Input  : a_i(16)
#    Vector Input  : b_i(16)
#    Vector Output : x_o(16)
#  
#  
#  

import sys
import time

class cf_fp_mul_p_5_10:

  def init(self):
    self.n1150 = 0L
    self.n1148 = 0L
    self.n1146 = 0L
    self.n1144 = 0L
    self.n1143 = 0L
    self.n1108 = 0L
    self.n1106 = 0L
    self.n1104 = 0L
    self.n1102 = 0L
    self.n1100 = 0L
    self.n1098 = 0L
    self.n1096 = 0L
    self.n1094 = 0L
    self.n1092 = 0L
    self.n1090 = 0L
    self.n1088 = 0L
    self.n1086 = 0L
    self.n1084 = 0L
    self.n1082 = 0L
    self.n1080 = 0L
    self.n1079 = 0L
    self.n1078 = 0L
    self.n1077 = 0L
    self.n1076 = 0L
    self.n1075 = 0L
    self.n1072 = 0L
    self.n1062 = 0L
    self.n1060 = 0L
    self.n1059 = 0L
    self.n1008 = 0L
    self.n1007 = 0L
    self.n1004 = 0L
    self.n985 = 0L
    self.n984 = 0L
    self.n983 = 0L
    self.n932 = 0L
    self.n931 = 0L
    self.n928 = 0L
    self.n909 = 0L
    self.n908 = 0L
    self.n907 = 0L
    self.n856 = 0L
    self.n855 = 0L
    self.n852 = 0L
    self.n833 = 0L
    self.n832 = 0L
    self.n831 = 0L
    self.n780 = 0L
    self.n779 = 0L
    self.n776 = 0L
    self.n757 = 0L
    self.n756 = 0L
    self.n755 = 0L
    self.n704 = 0L
    self.n703 = 0L
    self.n700 = 0L
    self.n681 = 0L
    self.n680 = 0L
    self.n679 = 0L
    self.n628 = 0L
    self.n627 = 0L
    self.n624 = 0L
    self.n605 = 0L
    self.n604 = 0L
    self.n603 = 0L
    self.n552 = 0L
    self.n551 = 0L
    self.n548 = 0L
    self.n529 = 0L
    self.n528 = 0L
    self.n527 = 0L
    self.n476 = 0L
    self.n475 = 0L
    self.n472 = 0L
    self.n453 = 0L
    self.n452 = 0L
    self.n451 = 0L
    self.n400 = 0L
    self.n399 = 0L
    self.n396 = 0L
    self.n377 = 0L
    self.n376 = 0L
    self.n375 = 0L
    self.n324 = 0L
    self.n323 = 0L
    self.n320 = 0L
    self.n301 = 0L
    self.n300 = 0L
    self.n299 = 0L
    self.n248 = 0L
    self.n247 = 0L
    self.n244 = 0L
    self.n243 = 0L
    self.n182 = 0L
    self.n180 = 0L
    self.n100 = 0L
    self.n99 = 0L
    self.n27 = 0L
    self.n26 = 0L
    self.n24 = 0L
    self.n23 = 0L
    self.n22 = 0L
    self.n21 = 0L
    self.n20 = 0L
    self.n19 = 0L
    self.n4 = 0L
    self.n3 = 0L
    self.n2 = 0L
    self.n1 = 0L
    self.n1073 = 0L
    self.n1061 = 0L
    self.n1044 = 0L
    self.n1044r = 0L
    self.n1044e = 0L
    self.n1044d = 0L
    self.n1037 = 0L
    self.n1037r = 0L
    self.n1037e = 0L
    self.n1037d = 0L
    self.n1030 = 0L
    self.n1030r = 0L
    self.n1030e = 0L
    self.n1030d = 0L
    self.n1023 = 0L
    self.n1023r = 0L
    self.n1023e = 0L
    self.n1023d = 0L
    self.n1016 = 0L
    self.n1016r = 0L
    self.n1016e = 0L
    self.n1016d = 0L
    self.n1005 = 0L
    self.n987 = 0L
    self.n986 = 0L
    self.n968 = 0L
    self.n968r = 0L
    self.n968e = 0L
    self.n968d = 0L
    self.n961 = 0L
    self.n961r = 0L
    self.n961e = 0L
    self.n961d = 0L
    self.n954 = 0L
    self.n954r = 0L
    self.n954e = 0L
    self.n954d = 0L
    self.n947 = 0L
    self.n947r = 0L
    self.n947e = 0L
    self.n947d = 0L
    self.n940 = 0L
    self.n940r = 0L
    self.n940e = 0L
    self.n940d = 0L
    self.n929 = 0L
    self.n911 = 0L
    self.n910 = 0L
    self.n892 = 0L
    self.n892r = 0L
    self.n892e = 0L
    self.n892d = 0L
    self.n885 = 0L
    self.n885r = 0L
    self.n885e = 0L
    self.n885d = 0L
    self.n878 = 0L
    self.n878r = 0L
    self.n878e = 0L
    self.n878d = 0L
    self.n871 = 0L
    self.n871r = 0L
    self.n871e = 0L
    self.n871d = 0L
    self.n864 = 0L
    self.n864r = 0L
    self.n864e = 0L
    self.n864d = 0L
    self.n853 = 0L
    self.n835 = 0L
    self.n834 = 0L
    self.n816 = 0L
    self.n816r = 0L
    self.n816e = 0L
    self.n816d = 0L
    self.n809 = 0L
    self.n809r = 0L
    self.n809e = 0L
    self.n809d = 0L
    self.n802 = 0L
    self.n802r = 0L
    self.n802e = 0L
    self.n802d = 0L
    self.n795 = 0L
    self.n795r = 0L
    self.n795e = 0L
    self.n795d = 0L
    self.n788 = 0L
    self.n788r = 0L
    self.n788e = 0L
    self.n788d = 0L
    self.n777 = 0L
    self.n759 = 0L
    self.n758 = 0L
    self.n740 = 0L
    self.n740r = 0L
    self.n740e = 0L
    self.n740d = 0L
    self.n733 = 0L
    self.n733r = 0L
    self.n733e = 0L
    self.n733d = 0L
    self.n726 = 0L
    self.n726r = 0L
    self.n726e = 0L
    self.n726d = 0L
    self.n719 = 0L
    self.n719r = 0L
    self.n719e = 0L
    self.n719d = 0L
    self.n712 = 0L
    self.n712r = 0L
    self.n712e = 0L
    self.n712d = 0L
    self.n701 = 0L
    self.n683 = 0L
    self.n682 = 0L
    self.n664 = 0L
    self.n664r = 0L
    self.n664e = 0L
    self.n664d = 0L
    self.n657 = 0L
    self.n657r = 0L
    self.n657e = 0L
    self.n657d = 0L
    self.n650 = 0L
    self.n650r = 0L
    self.n650e = 0L
    self.n650d = 0L
    self.n643 = 0L
    self.n643r = 0L
    self.n643e = 0L
    self.n643d = 0L
    self.n636 = 0L
    self.n636r = 0L
    self.n636e = 0L
    self.n636d = 0L
    self.n625 = 0L
    self.n607 = 0L
    self.n606 = 0L
    self.n588 = 0L
    self.n588r = 0L
    self.n588e = 0L
    self.n588d = 0L
    self.n581 = 0L
    self.n581r = 0L
    self.n581e = 0L
    self.n581d = 0L
    self.n574 = 0L
    self.n574r = 0L
    self.n574e = 0L
    self.n574d = 0L
    self.n567 = 0L
    self.n567r = 0L
    self.n567e = 0L
    self.n567d = 0L
    self.n560 = 0L
    self.n560r = 0L
    self.n560e = 0L
    self.n560d = 0L
    self.n549 = 0L
    self.n531 = 0L
    self.n530 = 0L
    self.n512 = 0L
    self.n512r = 0L
    self.n512e = 0L
    self.n512d = 0L
    self.n505 = 0L
    self.n505r = 0L
    self.n505e = 0L
    self.n505d = 0L
    self.n498 = 0L
    self.n498r = 0L
    self.n498e = 0L
    self.n498d = 0L
    self.n491 = 0L
    self.n491r = 0L
    self.n491e = 0L
    self.n491d = 0L
    self.n484 = 0L
    self.n484r = 0L
    self.n484e = 0L
    self.n484d = 0L
    self.n473 = 0L
    self.n455 = 0L
    self.n454 = 0L
    self.n436 = 0L
    self.n436r = 0L
    self.n436e = 0L
    self.n436d = 0L
    self.n429 = 0L
    self.n429r = 0L
    self.n429e = 0L
    self.n429d = 0L
    self.n422 = 0L
    self.n422r = 0L
    self.n422e = 0L
    self.n422d = 0L
    self.n415 = 0L
    self.n415r = 0L
    self.n415e = 0L
    self.n415d = 0L
    self.n408 = 0L
    self.n408r = 0L
    self.n408e = 0L
    self.n408d = 0L
    self.n397 = 0L
    self.n379 = 0L
    self.n378 = 0L
    self.n360 = 0L
    self.n360r = 0L
    self.n360e = 0L
    self.n360d = 0L
    self.n353 = 0L
    self.n353r = 0L
    self.n353e = 0L
    self.n353d = 0L
    self.n346 = 0L
    self.n346r = 0L
    self.n346e = 0L
    self.n346d = 0L
    self.n339 = 0L
    self.n339r = 0L
    self.n339e = 0L
    self.n339d = 0L
    self.n332 = 0L
    self.n332r = 0L
    self.n332e = 0L
    self.n332d = 0L
    self.n321 = 0L
    self.n303 = 0L
    self.n302 = 0L
    self.n284 = 0L
    self.n284r = 0L
    self.n284e = 0L
    self.n284d = 0L
    self.n277 = 0L
    self.n277r = 0L
    self.n277e = 0L
    self.n277d = 0L
    self.n270 = 0L
    self.n270r = 0L
    self.n270e = 0L
    self.n270d = 0L
    self.n263 = 0L
    self.n263r = 0L
    self.n263e = 0L
    self.n263d = 0L
    self.n256 = 0L
    self.n256r = 0L
    self.n256e = 0L
    self.n256d = 0L
    self.n249 = 0L
    self.n245 = 0L
    self.n183 = 0L
    self.n181 = 0L
    self.n179 = 0L
    self.n162 = 0L
    self.n160 = 0L
    self.n131 = 0L
    self.n130 = 0L
    self.n116 = 0L
    self.n115 = 0L
    self.n102 = 0L
    self.n101 = 0L
    self.n89 = 0L
    self.n87 = 0L
    self.n58 = 0L
    self.n57 = 0L
    self.n43 = 0L
    self.n42 = 0L
    self.n29 = 0L
    self.n28 = 0L
    self.n18 = 0L
    self.n18r = 0L
    self.n18e = 0L
    self.n18d = 0L
    self.n11 = 0L
    self.n11r = 0L
    self.n11e = 0L
    self.n11d = 0L
    self.n1074 = 0L
    self.n996 = 0L
    self.n989 = 0L
    self.n988 = 0L
    self.n920 = 0L
    self.n913 = 0L
    self.n912 = 0L
    self.n844 = 0L
    self.n837 = 0L
    self.n836 = 0L
    self.n768 = 0L
    self.n761 = 0L
    self.n760 = 0L
    self.n692 = 0L
    self.n685 = 0L
    self.n684 = 0L
    self.n616 = 0L
    self.n609 = 0L
    self.n608 = 0L
    self.n540 = 0L
    self.n533 = 0L
    self.n532 = 0L
    self.n464 = 0L
    self.n457 = 0L
    self.n456 = 0L
    self.n388 = 0L
    self.n381 = 0L
    self.n380 = 0L
    self.n312 = 0L
    self.n305 = 0L
    self.n304 = 0L
    self.n298 = 0L
    self.n298r = 0L
    self.n298e = 0L
    self.n298d = 0L
    self.n246 = 0L
    self.n228 = 0L
    self.n228r = 0L
    self.n228e = 0L
    self.n228d = 0L
    self.n184 = 0L
    self.n163 = 0L
    self.n133 = 0L
    self.n132 = 0L
    self.n118 = 0L
    self.n117 = 0L
    self.n104 = 0L
    self.n103 = 0L
    self.n90 = 0L
    self.n60 = 0L
    self.n59 = 0L
    self.n45 = 0L
    self.n44 = 0L
    self.n31 = 0L
    self.n30 = 0L
    self.n1109 = 0L
    self.n1107 = 0L
    self.n1105 = 0L
    self.n1103 = 0L
    self.n1101 = 0L
    self.n1099 = 0L
    self.n1097 = 0L
    self.n1095 = 0L
    self.n1093 = 0L
    self.n1091 = 0L
    self.n1089 = 0L
    self.n1087 = 0L
    self.n1085 = 0L
    self.n1083 = 0L
    self.n1081 = 0L
    self.n991 = 0L
    self.n990 = 0L
    self.n915 = 0L
    self.n914 = 0L
    self.n839 = 0L
    self.n838 = 0L
    self.n763 = 0L
    self.n762 = 0L
    self.n687 = 0L
    self.n686 = 0L
    self.n611 = 0L
    self.n610 = 0L
    self.n535 = 0L
    self.n534 = 0L
    self.n459 = 0L
    self.n458 = 0L
    self.n383 = 0L
    self.n382 = 0L
    self.n307 = 0L
    self.n306 = 0L
    self.n291 = 0L
    self.n291r = 0L
    self.n291e = 0L
    self.n291d = 0L
    self.n188 = 0L
    self.n150 = 0L
    self.n135 = 0L
    self.n134 = 0L
    self.n125 = 0L
    self.n120 = 0L
    self.n119 = 0L
    self.n111 = 0L
    self.n106 = 0L
    self.n105 = 0L
    self.n77 = 0L
    self.n62 = 0L
    self.n61 = 0L
    self.n52 = 0L
    self.n47 = 0L
    self.n46 = 0L
    self.n38 = 0L
    self.n33 = 0L
    self.n32 = 0L
    self.n1110 = 0L
    self.n997 = 0L
    self.n993 = 0L
    self.n992 = 0L
    self.n921 = 0L
    self.n917 = 0L
    self.n916 = 0L
    self.n845 = 0L
    self.n841 = 0L
    self.n840 = 0L
    self.n769 = 0L
    self.n765 = 0L
    self.n764 = 0L
    self.n693 = 0L
    self.n689 = 0L
    self.n688 = 0L
    self.n617 = 0L
    self.n613 = 0L
    self.n612 = 0L
    self.n541 = 0L
    self.n537 = 0L
    self.n536 = 0L
    self.n465 = 0L
    self.n461 = 0L
    self.n460 = 0L
    self.n389 = 0L
    self.n385 = 0L
    self.n384 = 0L
    self.n313 = 0L
    self.n309 = 0L
    self.n308 = 0L
    self.n235 = 0L
    self.n235r = 0L
    self.n235e = 0L
    self.n235d = 0L
    self.n137 = 0L
    self.n136 = 0L
    self.n122 = 0L
    self.n121 = 0L
    self.n108 = 0L
    self.n107 = 0L
    self.n64 = 0L
    self.n63 = 0L
    self.n49 = 0L
    self.n48 = 0L
    self.n35 = 0L
    self.n34 = 0L
    self.n1111 = 0L
    self.n999 = 0L
    self.n994 = 0L
    self.n923 = 0L
    self.n918 = 0L
    self.n847 = 0L
    self.n842 = 0L
    self.n771 = 0L
    self.n766 = 0L
    self.n695 = 0L
    self.n690 = 0L
    self.n619 = 0L
    self.n614 = 0L
    self.n543 = 0L
    self.n538 = 0L
    self.n467 = 0L
    self.n462 = 0L
    self.n391 = 0L
    self.n386 = 0L
    self.n315 = 0L
    self.n310 = 0L
    self.n151 = 0L
    self.n139 = 0L
    self.n138 = 0L
    self.n126 = 0L
    self.n123 = 0L
    self.n112 = 0L
    self.n109 = 0L
    self.n78 = 0L
    self.n66 = 0L
    self.n65 = 0L
    self.n53 = 0L
    self.n50 = 0L
    self.n39 = 0L
    self.n36 = 0L
    self.n1112 = 0L
    self.n998 = 0L
    self.n922 = 0L
    self.n846 = 0L
    self.n770 = 0L
    self.n694 = 0L
    self.n618 = 0L
    self.n542 = 0L
    self.n466 = 0L
    self.n390 = 0L
    self.n314 = 0L
    self.n155 = 0L
    self.n141 = 0L
    self.n140 = 0L
    self.n127 = 0L
    self.n113 = 0L
    self.n82 = 0L
    self.n68 = 0L
    self.n67 = 0L
    self.n54 = 0L
    self.n40 = 0L
    self.n1113 = 0L
    self.n1000 = 0L
    self.n924 = 0L
    self.n848 = 0L
    self.n772 = 0L
    self.n696 = 0L
    self.n620 = 0L
    self.n544 = 0L
    self.n468 = 0L
    self.n392 = 0L
    self.n316 = 0L
    self.n152 = 0L
    self.n143 = 0L
    self.n142 = 0L
    self.n128 = 0L
    self.n114 = 0L
    self.n79 = 0L
    self.n70 = 0L
    self.n69 = 0L
    self.n55 = 0L
    self.n41 = 0L
    self.n1114 = 0L
    self.n1001 = 0L
    self.n925 = 0L
    self.n849 = 0L
    self.n773 = 0L
    self.n697 = 0L
    self.n621 = 0L
    self.n545 = 0L
    self.n469 = 0L
    self.n393 = 0L
    self.n317 = 0L
    self.n164 = 0L
    self.n161 = 0L
    self.n145 = 0L
    self.n144 = 0L
    self.n129 = 0L
    self.n91 = 0L
    self.n88 = 0L
    self.n72 = 0L
    self.n71 = 0L
    self.n56 = 0L
    self.n1115 = 0L
    self.n1002 = 0L
    self.n926 = 0L
    self.n850 = 0L
    self.n774 = 0L
    self.n698 = 0L
    self.n622 = 0L
    self.n546 = 0L
    self.n470 = 0L
    self.n394 = 0L
    self.n318 = 0L
    self.n153 = 0L
    self.n147 = 0L
    self.n146 = 0L
    self.n80 = 0L
    self.n74 = 0L
    self.n73 = 0L
    self.n1116 = 0L
    self.n1003 = 0L
    self.n927 = 0L
    self.n851 = 0L
    self.n775 = 0L
    self.n699 = 0L
    self.n623 = 0L
    self.n547 = 0L
    self.n471 = 0L
    self.n395 = 0L
    self.n319 = 0L
    self.n156 = 0L
    self.n148 = 0L
    self.n83 = 0L
    self.n75 = 0L
    self.n1117 = 0L
    self.n1009 = 0L
    self.n1006 = 0L
    self.n933 = 0L
    self.n930 = 0L
    self.n857 = 0L
    self.n854 = 0L
    self.n781 = 0L
    self.n778 = 0L
    self.n705 = 0L
    self.n702 = 0L
    self.n629 = 0L
    self.n626 = 0L
    self.n553 = 0L
    self.n550 = 0L
    self.n477 = 0L
    self.n474 = 0L
    self.n401 = 0L
    self.n398 = 0L
    self.n325 = 0L
    self.n322 = 0L
    self.n157 = 0L
    self.n154 = 0L
    self.n84 = 0L
    self.n81 = 0L
    self.n1118 = 0L
    self.n1058 = 0L
    self.n1058r = 0L
    self.n1058e = 0L
    self.n1058d = 0L
    self.n1051 = 0L
    self.n1051r = 0L
    self.n1051e = 0L
    self.n1051d = 0L
    self.n982 = 0L
    self.n982r = 0L
    self.n982e = 0L
    self.n982d = 0L
    self.n975 = 0L
    self.n975r = 0L
    self.n975e = 0L
    self.n975d = 0L
    self.n906 = 0L
    self.n906r = 0L
    self.n906e = 0L
    self.n906d = 0L
    self.n899 = 0L
    self.n899r = 0L
    self.n899e = 0L
    self.n899d = 0L
    self.n830 = 0L
    self.n830r = 0L
    self.n830e = 0L
    self.n830d = 0L
    self.n823 = 0L
    self.n823r = 0L
    self.n823e = 0L
    self.n823d = 0L
    self.n754 = 0L
    self.n754r = 0L
    self.n754e = 0L
    self.n754d = 0L
    self.n747 = 0L
    self.n747r = 0L
    self.n747e = 0L
    self.n747d = 0L
    self.n678 = 0L
    self.n678r = 0L
    self.n678e = 0L
    self.n678d = 0L
    self.n671 = 0L
    self.n671r = 0L
    self.n671e = 0L
    self.n671d = 0L
    self.n602 = 0L
    self.n602r = 0L
    self.n602e = 0L
    self.n602d = 0L
    self.n595 = 0L
    self.n595r = 0L
    self.n595e = 0L
    self.n595d = 0L
    self.n526 = 0L
    self.n526r = 0L
    self.n526e = 0L
    self.n526d = 0L
    self.n519 = 0L
    self.n519r = 0L
    self.n519e = 0L
    self.n519d = 0L
    self.n450 = 0L
    self.n450r = 0L
    self.n450e = 0L
    self.n450d = 0L
    self.n443 = 0L
    self.n443r = 0L
    self.n443e = 0L
    self.n443d = 0L
    self.n374 = 0L
    self.n374r = 0L
    self.n374e = 0L
    self.n374d = 0L
    self.n367 = 0L
    self.n367r = 0L
    self.n367e = 0L
    self.n367d = 0L
    self.n158 = 0L
    self.n85 = 0L
    self.n1119 = 0L
    self.n159 = 0L
    self.n86 = 0L
    self.n1120 = 0L
    self.n169 = 0L
    self.n168 = 0L
    self.n167 = 0L
    self.n165 = 0L
    self.n96 = 0L
    self.n95 = 0L
    self.n94 = 0L
    self.n92 = 0L
    self.n1121 = 0L
    self.n178 = 0L
    self.n177 = 0L
    self.n175 = 0L
    self.n174 = 0L
    self.n170 = 0L
    self.n166 = 0L
    self.n97 = 0L
    self.n93 = 0L
    self.n1122 = 0L
    self.n221 = 0L
    self.n221r = 0L
    self.n221e = 0L
    self.n221d = 0L
    self.n214 = 0L
    self.n214r = 0L
    self.n214e = 0L
    self.n214d = 0L
    self.n191 = 0L
    self.n189 = 0L
    self.n176 = 0L
    self.n172 = 0L
    self.n171 = 0L
    self.n1123 = 0L
    self.n207 = 0L
    self.n207r = 0L
    self.n207e = 0L
    self.n207d = 0L
    self.n192 = 0L
    self.n190 = 0L
    self.n173 = 0L
    self.n1124 = 0L
    self.n200 = 0L
    self.n200r = 0L
    self.n200e = 0L
    self.n200d = 0L
    self.n193 = 0L
    self.n1126 = 0L
    self.n1125 = 0L
    self.n242 = 0L
    self.n242r = 0L
    self.n242e = 0L
    self.n242d = 0L
    self.n1130 = 0L
    self.n1129 = 0L
    self.n1128 = 0L
    self.n1127 = 0L
    self.n1133 = 0L
    self.n1131 = 0L
    self.n1134 = 0L
    self.n1135 = 0L
    self.n1142 = 0L
    self.n1142r = 0L
    self.n1142e = 0L
    self.n1142d = 0L
    self.calc(0L, 0L, )

  def calc(self, a_i, b_i, ):
    self.n1150 = 0x7DFFL
    self.n1148 = 0x7FFFL
    self.n1146 = 0x7C00L
    self.n1144 = 0x0FL
    x_o = self.n1142
    self.n1143 = self.n1142
    self.n1108 = 0x1L
    self.n1106 = 0x3L
    self.n1104 = 0x2L
    self.n1102 = 0x7L
    self.n1100 = 0x6L
    self.n1098 = 0x5L
    self.n1096 = 0x4L
    self.n1094 = 0xFL
    self.n1092 = 0xEL
    self.n1090 = 0xDL
    self.n1088 = 0xCL
    self.n1086 = 0xBL
    self.n1084 = 0xAL
    self.n1082 = 0x9L
    self.n1080 = 0x8L
    self.n1079 = 0x4L
    self.n1078 = 0x3L
    self.n1077 = 0x2L
    self.n1076 = 0x1L
    self.n1075 = 0x0L
    self.n1072 = self.n1030 << 1 | self.n1037
    self.n1062 = 0x0000L
    self.n1060 = (self.n1058 & 0x200L) | (self.n1058 & 0x100L) | (self.n1058 & 0x80L) | (self.n1058 & 0x40L) | (self.n1058 & 0x20L) | (self.n1058 & 0x10L) | (self.n1058 & 0x8L) | (self.n1058 & 0x4L) | (self.n1058 & 0x2L) | (self.n1058 & 0x1L)
    self.n1059 = (self.n1051 & 0x10L) | (self.n1051 & 0x8L) | (self.n1051 & 0x4L) | (self.n1051 & 0x2L) | (self.n1051 & 0x1L)
    self.n1008 = ((self.n982 & 0x800L) >> 1) | ((self.n982 & 0x400L) >> 1) | ((self.n982 & 0x200L) >> 1) | ((self.n982 & 0x100L) >> 1) | ((self.n982 & 0x80L) >> 1) | ((self.n982 & 0x40L) >> 1) | ((self.n982 & 0x20L) >> 1) | ((self.n982 & 0x10L) >> 1) | ((self.n982 & 0x8L) >> 1) | ((self.n982 & 0x4L) >> 1) | ((self.n982 & 0x2L) >> 1)
    self.n1007 = (self.n982 & 0x400L) | (self.n982 & 0x200L) | (self.n982 & 0x100L) | (self.n982 & 0x80L) | (self.n982 & 0x40L) | (self.n982 & 0x20L) | (self.n982 & 0x10L) | (self.n982 & 0x8L) | (self.n982 & 0x4L) | (self.n982 & 0x2L) | (self.n982 & 0x1L)
    self.n1004 = 0x01L
    self.n985 = (self.n975 & 0x10L) | (self.n975 & 0x8L) | (self.n975 & 0x4L) | (self.n975 & 0x2L) | (self.n975 & 0x1L)
    self.n984 = ((self.n975 & 0x20L) >> 5)
    self.n983 = ((self.n982 & 0x800L) >> 11)
    self.n932 = ((self.n906 & 0x1000L) >> 1) | ((self.n906 & 0x800L) >> 1) | ((self.n906 & 0x400L) >> 1) | ((self.n906 & 0x200L) >> 1) | ((self.n906 & 0x100L) >> 1) | ((self.n906 & 0x80L) >> 1) | ((self.n906 & 0x40L) >> 1) | ((self.n906 & 0x20L) >> 1) | ((self.n906 & 0x10L) >> 1) | ((self.n906 & 0x8L) >> 1) | ((self.n906 & 0x4L) >> 1) | ((self.n906 & 0x2L) >> 1)
    self.n931 = (self.n906 & 0x800L) | (self.n906 & 0x400L) | (self.n906 & 0x200L) | (self.n906 & 0x100L) | (self.n906 & 0x80L) | (self.n906 & 0x40L) | (self.n906 & 0x20L) | (self.n906 & 0x10L) | (self.n906 & 0x8L) | (self.n906 & 0x4L) | (self.n906 & 0x2L) | (self.n906 & 0x1L)
    self.n928 = 0x01L
    self.n909 = (self.n899 & 0x10L) | (self.n899 & 0x8L) | (self.n899 & 0x4L) | (self.n899 & 0x2L) | (self.n899 & 0x1L)
    self.n908 = ((self.n899 & 0x20L) >> 5)
    self.n907 = ((self.n906 & 0x1000L) >> 12)
    self.n856 = ((self.n830 & 0x2000L) >> 1) | ((self.n830 & 0x1000L) >> 1) | ((self.n830 & 0x800L) >> 1) | ((self.n830 & 0x400L) >> 1) | ((self.n830 & 0x200L) >> 1) | ((self.n830 & 0x100L) >> 1) | ((self.n830 & 0x80L) >> 1) | ((self.n830 & 0x40L) >> 1) | ((self.n830 & 0x20L) >> 1) | ((self.n830 & 0x10L) >> 1) | ((self.n830 & 0x8L) >> 1) | ((self.n830 & 0x4L) >> 1) | ((self.n830 & 0x2L) >> 1)
    self.n855 = (self.n830 & 0x1000L) | (self.n830 & 0x800L) | (self.n830 & 0x400L) | (self.n830 & 0x200L) | (self.n830 & 0x100L) | (self.n830 & 0x80L) | (self.n830 & 0x40L) | (self.n830 & 0x20L) | (self.n830 & 0x10L) | (self.n830 & 0x8L) | (self.n830 & 0x4L) | (self.n830 & 0x2L) | (self.n830 & 0x1L)
    self.n852 = 0x01L
    self.n833 = (self.n823 & 0x10L) | (self.n823 & 0x8L) | (self.n823 & 0x4L) | (self.n823 & 0x2L) | (self.n823 & 0x1L)
    self.n832 = ((self.n823 & 0x20L) >> 5)
    self.n831 = ((self.n830 & 0x2000L) >> 13)
    self.n780 = ((self.n754 & 0x4000L) >> 1) | ((self.n754 & 0x2000L) >> 1) | ((self.n754 & 0x1000L) >> 1) | ((self.n754 & 0x800L) >> 1) | ((self.n754 & 0x400L) >> 1) | ((self.n754 & 0x200L) >> 1) | ((self.n754 & 0x100L) >> 1) | ((self.n754 & 0x80L) >> 1) | ((self.n754 & 0x40L) >> 1) | ((self.n754 & 0x20L) >> 1) | ((self.n754 & 0x10L) >> 1) | ((self.n754 & 0x8L) >> 1) | ((self.n754 & 0x4L) >> 1) | ((self.n754 & 0x2L) >> 1)
    self.n779 = (self.n754 & 0x2000L) | (self.n754 & 0x1000L) | (self.n754 & 0x800L) | (self.n754 & 0x400L) | (self.n754 & 0x200L) | (self.n754 & 0x100L) | (self.n754 & 0x80L) | (self.n754 & 0x40L) | (self.n754 & 0x20L) | (self.n754 & 0x10L) | (self.n754 & 0x8L) | (self.n754 & 0x4L) | (self.n754 & 0x2L) | (self.n754 & 0x1L)
    self.n776 = 0x01L
    self.n757 = (self.n747 & 0x10L) | (self.n747 & 0x8L) | (self.n747 & 0x4L) | (self.n747 & 0x2L) | (self.n747 & 0x1L)
    self.n756 = ((self.n747 & 0x20L) >> 5)
    self.n755 = ((self.n754 & 0x4000L) >> 14)
    self.n704 = ((self.n678 & 0x8000L) >> 1) | ((self.n678 & 0x4000L) >> 1) | ((self.n678 & 0x2000L) >> 1) | ((self.n678 & 0x1000L) >> 1) | ((self.n678 & 0x800L) >> 1) | ((self.n678 & 0x400L) >> 1) | ((self.n678 & 0x200L) >> 1) | ((self.n678 & 0x100L) >> 1) | ((self.n678 & 0x80L) >> 1) | ((self.n678 & 0x40L) >> 1) | ((self.n678 & 0x20L) >> 1) | ((self.n678 & 0x10L) >> 1) | ((self.n678 & 0x8L) >> 1) | ((self.n678 & 0x4L) >> 1) | ((self.n678 & 0x2L) >> 1)
    self.n703 = (self.n678 & 0x4000L) | (self.n678 & 0x2000L) | (self.n678 & 0x1000L) | (self.n678 & 0x800L) | (self.n678 & 0x400L) | (self.n678 & 0x200L) | (self.n678 & 0x100L) | (self.n678 & 0x80L) | (self.n678 & 0x40L) | (self.n678 & 0x20L) | (self.n678 & 0x10L) | (self.n678 & 0x8L) | (self.n678 & 0x4L) | (self.n678 & 0x2L) | (self.n678 & 0x1L)
    self.n700 = 0x01L
    self.n681 = (self.n671 & 0x10L) | (self.n671 & 0x8L) | (self.n671 & 0x4L) | (self.n671 & 0x2L) | (self.n671 & 0x1L)
    self.n680 = ((self.n671 & 0x20L) >> 5)
    self.n679 = ((self.n678 & 0x8000L) >> 15)
    self.n628 = ((self.n602 & 0x10000L) >> 1) | ((self.n602 & 0x8000L) >> 1) | ((self.n602 & 0x4000L) >> 1) | ((self.n602 & 0x2000L) >> 1) | ((self.n602 & 0x1000L) >> 1) | ((self.n602 & 0x800L) >> 1) | ((self.n602 & 0x400L) >> 1) | ((self.n602 & 0x200L) >> 1) | ((self.n602 & 0x100L) >> 1) | ((self.n602 & 0x80L) >> 1) | ((self.n602 & 0x40L) >> 1) | ((self.n602 & 0x20L) >> 1) | ((self.n602 & 0x10L) >> 1) | ((self.n602 & 0x8L) >> 1) | ((self.n602 & 0x4L) >> 1) | ((self.n602 & 0x2L) >> 1)
    self.n627 = (self.n602 & 0x8000L) | (self.n602 & 0x4000L) | (self.n602 & 0x2000L) | (self.n602 & 0x1000L) | (self.n602 & 0x800L) | (self.n602 & 0x400L) | (self.n602 & 0x200L) | (self.n602 & 0x100L) | (self.n602 & 0x80L) | (self.n602 & 0x40L) | (self.n602 & 0x20L) | (self.n602 & 0x10L) | (self.n602 & 0x8L) | (self.n602 & 0x4L) | (self.n602 & 0x2L) | (self.n602 & 0x1L)
    self.n624 = 0x01L
    self.n605 = (self.n595 & 0x10L) | (self.n595 & 0x8L) | (self.n595 & 0x4L) | (self.n595 & 0x2L) | (self.n595 & 0x1L)
    self.n604 = ((self.n595 & 0x20L) >> 5)
    self.n603 = ((self.n602 & 0x10000L) >> 16)
    self.n552 = ((self.n526 & 0x20000L) >> 1) | ((self.n526 & 0x10000L) >> 1) | ((self.n526 & 0x8000L) >> 1) | ((self.n526 & 0x4000L) >> 1) | ((self.n526 & 0x2000L) >> 1) | ((self.n526 & 0x1000L) >> 1) | ((self.n526 & 0x800L) >> 1) | ((self.n526 & 0x400L) >> 1) | ((self.n526 & 0x200L) >> 1) | ((self.n526 & 0x100L) >> 1) | ((self.n526 & 0x80L) >> 1) | ((self.n526 & 0x40L) >> 1) | ((self.n526 & 0x20L) >> 1) | ((self.n526 & 0x10L) >> 1) | ((self.n526 & 0x8L) >> 1) | ((self.n526 & 0x4L) >> 1) | ((self.n526 & 0x2L) >> 1)
    self.n551 = (self.n526 & 0x10000L) | (self.n526 & 0x8000L) | (self.n526 & 0x4000L) | (self.n526 & 0x2000L) | (self.n526 & 0x1000L) | (self.n526 & 0x800L) | (self.n526 & 0x400L) | (self.n526 & 0x200L) | (self.n526 & 0x100L) | (self.n526 & 0x80L) | (self.n526 & 0x40L) | (self.n526 & 0x20L) | (self.n526 & 0x10L) | (self.n526 & 0x8L) | (self.n526 & 0x4L) | (self.n526 & 0x2L) | (self.n526 & 0x1L)
    self.n548 = 0x01L
    self.n529 = (self.n519 & 0x10L) | (self.n519 & 0x8L) | (self.n519 & 0x4L) | (self.n519 & 0x2L) | (self.n519 & 0x1L)
    self.n528 = ((self.n519 & 0x20L) >> 5)
    self.n527 = ((self.n526 & 0x20000L) >> 17)
    self.n476 = ((self.n450 & 0x40000L) >> 1) | ((self.n450 & 0x20000L) >> 1) | ((self.n450 & 0x10000L) >> 1) | ((self.n450 & 0x8000L) >> 1) | ((self.n450 & 0x4000L) >> 1) | ((self.n450 & 0x2000L) >> 1) | ((self.n450 & 0x1000L) >> 1) | ((self.n450 & 0x800L) >> 1) | ((self.n450 & 0x400L) >> 1) | ((self.n450 & 0x200L) >> 1) | ((self.n450 & 0x100L) >> 1) | ((self.n450 & 0x80L) >> 1) | ((self.n450 & 0x40L) >> 1) | ((self.n450 & 0x20L) >> 1) | ((self.n450 & 0x10L) >> 1) | ((self.n450 & 0x8L) >> 1) | ((self.n450 & 0x4L) >> 1) | ((self.n450 & 0x2L) >> 1)
    self.n475 = (self.n450 & 0x20000L) | (self.n450 & 0x10000L) | (self.n450 & 0x8000L) | (self.n450 & 0x4000L) | (self.n450 & 0x2000L) | (self.n450 & 0x1000L) | (self.n450 & 0x800L) | (self.n450 & 0x400L) | (self.n450 & 0x200L) | (self.n450 & 0x100L) | (self.n450 & 0x80L) | (self.n450 & 0x40L) | (self.n450 & 0x20L) | (self.n450 & 0x10L) | (self.n450 & 0x8L) | (self.n450 & 0x4L) | (self.n450 & 0x2L) | (self.n450 & 0x1L)
    self.n472 = 0x01L
    self.n453 = (self.n443 & 0x10L) | (self.n443 & 0x8L) | (self.n443 & 0x4L) | (self.n443 & 0x2L) | (self.n443 & 0x1L)
    self.n452 = ((self.n443 & 0x20L) >> 5)
    self.n451 = ((self.n450 & 0x40000L) >> 18)
    self.n400 = ((self.n374 & 0x80000L) >> 1) | ((self.n374 & 0x40000L) >> 1) | ((self.n374 & 0x20000L) >> 1) | ((self.n374 & 0x10000L) >> 1) | ((self.n374 & 0x8000L) >> 1) | ((self.n374 & 0x4000L) >> 1) | ((self.n374 & 0x2000L) >> 1) | ((self.n374 & 0x1000L) >> 1) | ((self.n374 & 0x800L) >> 1) | ((self.n374 & 0x400L) >> 1) | ((self.n374 & 0x200L) >> 1) | ((self.n374 & 0x100L) >> 1) | ((self.n374 & 0x80L) >> 1) | ((self.n374 & 0x40L) >> 1) | ((self.n374 & 0x20L) >> 1) | ((self.n374 & 0x10L) >> 1) | ((self.n374 & 0x8L) >> 1) | ((self.n374 & 0x4L) >> 1) | ((self.n374 & 0x2L) >> 1)
    self.n399 = (self.n374 & 0x40000L) | (self.n374 & 0x20000L) | (self.n374 & 0x10000L) | (self.n374 & 0x8000L) | (self.n374 & 0x4000L) | (self.n374 & 0x2000L) | (self.n374 & 0x1000L) | (self.n374 & 0x800L) | (self.n374 & 0x400L) | (self.n374 & 0x200L) | (self.n374 & 0x100L) | (self.n374 & 0x80L) | (self.n374 & 0x40L) | (self.n374 & 0x20L) | (self.n374 & 0x10L) | (self.n374 & 0x8L) | (self.n374 & 0x4L) | (self.n374 & 0x2L) | (self.n374 & 0x1L)
    self.n396 = 0x01L
    self.n377 = (self.n367 & 0x10L) | (self.n367 & 0x8L) | (self.n367 & 0x4L) | (self.n367 & 0x2L) | (self.n367 & 0x1L)
    self.n376 = ((self.n367 & 0x20L) >> 5)
    self.n375 = ((self.n374 & 0x80000L) >> 19)
    self.n324 = ((self.n298 & 0x100000L) >> 1) | ((self.n298 & 0x80000L) >> 1) | ((self.n298 & 0x40000L) >> 1) | ((self.n298 & 0x20000L) >> 1) | ((self.n298 & 0x10000L) >> 1) | ((self.n298 & 0x8000L) >> 1) | ((self.n298 & 0x4000L) >> 1) | ((self.n298 & 0x2000L) >> 1) | ((self.n298 & 0x1000L) >> 1) | ((self.n298 & 0x800L) >> 1) | ((self.n298 & 0x400L) >> 1) | ((self.n298 & 0x200L) >> 1) | ((self.n298 & 0x100L) >> 1) | ((self.n298 & 0x80L) >> 1) | ((self.n298 & 0x40L) >> 1) | ((self.n298 & 0x20L) >> 1) | ((self.n298 & 0x10L) >> 1) | ((self.n298 & 0x8L) >> 1) | ((self.n298 & 0x4L) >> 1) | ((self.n298 & 0x2L) >> 1)
    self.n323 = (self.n298 & 0x80000L) | (self.n298 & 0x40000L) | (self.n298 & 0x20000L) | (self.n298 & 0x10000L) | (self.n298 & 0x8000L) | (self.n298 & 0x4000L) | (self.n298 & 0x2000L) | (self.n298 & 0x1000L) | (self.n298 & 0x800L) | (self.n298 & 0x400L) | (self.n298 & 0x200L) | (self.n298 & 0x100L) | (self.n298 & 0x80L) | (self.n298 & 0x40L) | (self.n298 & 0x20L) | (self.n298 & 0x10L) | (self.n298 & 0x8L) | (self.n298 & 0x4L) | (self.n298 & 0x2L) | (self.n298 & 0x1L)
    self.n320 = 0x01L
    self.n301 = (self.n291 & 0x10L) | (self.n291 & 0x8L) | (self.n291 & 0x4L) | (self.n291 & 0x2L) | (self.n291 & 0x1L)
    self.n300 = ((self.n291 & 0x20L) >> 5)
    self.n299 = ((self.n298 & 0x100000L) >> 20)
    self.n248 = (self.n242 & 0x100000L) | (self.n242 & 0x80000L) | (self.n242 & 0x40000L) | (self.n242 & 0x20000L) | (self.n242 & 0x10000L) | (self.n242 & 0x8000L) | (self.n242 & 0x4000L) | (self.n242 & 0x2000L) | (self.n242 & 0x1000L) | (self.n242 & 0x800L) | (self.n242 & 0x400L) | (self.n242 & 0x200L) | (self.n242 & 0x100L) | (self.n242 & 0x80L) | (self.n242 & 0x40L) | (self.n242 & 0x20L) | (self.n242 & 0x10L) | (self.n242 & 0x8L) | (self.n242 & 0x4L) | (self.n242 & 0x2L) | (self.n242 & 0x1L)
    self.n247 = ((self.n242 & 0x200000L) >> 1) | ((self.n242 & 0x100000L) >> 1) | ((self.n242 & 0x80000L) >> 1) | ((self.n242 & 0x40000L) >> 1) | ((self.n242 & 0x20000L) >> 1) | ((self.n242 & 0x10000L) >> 1) | ((self.n242 & 0x8000L) >> 1) | ((self.n242 & 0x4000L) >> 1) | ((self.n242 & 0x2000L) >> 1) | ((self.n242 & 0x1000L) >> 1) | ((self.n242 & 0x800L) >> 1) | ((self.n242 & 0x400L) >> 1) | ((self.n242 & 0x200L) >> 1) | ((self.n242 & 0x100L) >> 1) | ((self.n242 & 0x80L) >> 1) | ((self.n242 & 0x40L) >> 1) | ((self.n242 & 0x20L) >> 1) | ((self.n242 & 0x10L) >> 1) | ((self.n242 & 0x8L) >> 1) | ((self.n242 & 0x4L) >> 1) | ((self.n242 & 0x2L) >> 1)
    self.n244 = 0x01L
    self.n243 = ((self.n242 & 0x200000L) >> 21)
    self.n182 = 0x0L
    self.n180 = 0x0L
    self.n100 = (self.n18 & 0x200L) | (self.n18 & 0x100L) | (self.n18 & 0x80L) | (self.n18 & 0x40L) | (self.n18 & 0x20L) | (self.n18 & 0x10L) | (self.n18 & 0x8L) | (self.n18 & 0x4L) | (self.n18 & 0x2L) | (self.n18 & 0x1L)
    self.n99 = ((self.n18 & 0x4000L) >> 10) | ((self.n18 & 0x2000L) >> 10) | ((self.n18 & 0x1000L) >> 10) | ((self.n18 & 0x800L) >> 10) | ((self.n18 & 0x400L) >> 10)
    self.n27 = (self.n11 & 0x200L) | (self.n11 & 0x100L) | (self.n11 & 0x80L) | (self.n11 & 0x40L) | (self.n11 & 0x20L) | (self.n11 & 0x10L) | (self.n11 & 0x8L) | (self.n11 & 0x4L) | (self.n11 & 0x2L) | (self.n11 & 0x1L)
    self.n26 = ((self.n11 & 0x4000L) >> 10) | ((self.n11 & 0x2000L) >> 10) | ((self.n11 & 0x1000L) >> 10) | ((self.n11 & 0x800L) >> 10) | ((self.n11 & 0x400L) >> 10)
    self.n24 = (self.n18 & 0x200L) | (self.n18 & 0x100L) | (self.n18 & 0x80L) | (self.n18 & 0x40L) | (self.n18 & 0x20L) | (self.n18 & 0x10L) | (self.n18 & 0x8L) | (self.n18 & 0x4L) | (self.n18 & 0x2L) | (self.n18 & 0x1L)
    self.n23 = ((self.n18 & 0x4000L) >> 10) | ((self.n18 & 0x2000L) >> 10) | ((self.n18 & 0x1000L) >> 10) | ((self.n18 & 0x800L) >> 10) | ((self.n18 & 0x400L) >> 10)
    self.n22 = ((self.n18 & 0x8000L) >> 15)
    self.n21 = (self.n11 & 0x200L) | (self.n11 & 0x100L) | (self.n11 & 0x80L) | (self.n11 & 0x40L) | (self.n11 & 0x20L) | (self.n11 & 0x10L) | (self.n11 & 0x8L) | (self.n11 & 0x4L) | (self.n11 & 0x2L) | (self.n11 & 0x1L)
    self.n20 = ((self.n11 & 0x4000L) >> 10) | ((self.n11 & 0x2000L) >> 10) | ((self.n11 & 0x1000L) >> 10) | ((self.n11 & 0x800L) >> 10) | ((self.n11 & 0x400L) >> 10)
    self.n19 = ((self.n11 & 0x8000L) >> 15)
    self.n4 = b_i
    self.n3 = a_i
    self.n2 = 0x0L
    self.n1 = 0x1L
    self.n1073 = self.n1023 << 2 | self.n1072
    self.n1061 = self.n1059 << 10 | self.n1060
    self.n1044r = self.n2
    self.n1044e = self.n1
    self.n1044d = self.n968
    self.n1037r = self.n2
    self.n1037e = self.n1
    self.n1037d = self.n961
    self.n1030r = self.n2
    self.n1030e = self.n1
    self.n1030d = self.n954
    self.n1023r = self.n2
    self.n1023e = self.n1
    self.n1023d = self.n947
    self.n1016r = self.n2
    self.n1016e = self.n1
    self.n1016d = self.n940
    self.n1005 = (self.n975 - self.n1004) & 0x3FL
    self.n987 = (self.n985 & 0x8L) | (self.n985 & 0x4L) | (self.n985 & 0x2L) | (self.n985 & 0x1L)
    self.n986 = ((self.n985 & 0x10L) >> 4)
    self.n968r = self.n2
    self.n968e = self.n1
    self.n968d = self.n892
    self.n961r = self.n2
    self.n961e = self.n1
    self.n961d = self.n885
    self.n954r = self.n2
    self.n954e = self.n1
    self.n954d = self.n878
    self.n947r = self.n2
    self.n947e = self.n1
    self.n947d = self.n871
    self.n940r = self.n2
    self.n940e = self.n1
    self.n940d = self.n864
    self.n929 = (self.n899 - self.n928) & 0x3FL
    self.n911 = (self.n909 & 0x8L) | (self.n909 & 0x4L) | (self.n909 & 0x2L) | (self.n909 & 0x1L)
    self.n910 = ((self.n909 & 0x10L) >> 4)
    self.n892r = self.n2
    self.n892e = self.n1
    self.n892d = self.n816
    self.n885r = self.n2
    self.n885e = self.n1
    self.n885d = self.n809
    self.n878r = self.n2
    self.n878e = self.n1
    self.n878d = self.n802
    self.n871r = self.n2
    self.n871e = self.n1
    self.n871d = self.n795
    self.n864r = self.n2
    self.n864e = self.n1
    self.n864d = self.n788
    self.n853 = (self.n823 - self.n852) & 0x3FL
    self.n835 = (self.n833 & 0x8L) | (self.n833 & 0x4L) | (self.n833 & 0x2L) | (self.n833 & 0x1L)
    self.n834 = ((self.n833 & 0x10L) >> 4)
    self.n816r = self.n2
    self.n816e = self.n1
    self.n816d = self.n740
    self.n809r = self.n2
    self.n809e = self.n1
    self.n809d = self.n733
    self.n802r = self.n2
    self.n802e = self.n1
    self.n802d = self.n726
    self.n795r = self.n2
    self.n795e = self.n1
    self.n795d = self.n719
    self.n788r = self.n2
    self.n788e = self.n1
    self.n788d = self.n712
    self.n777 = (self.n747 - self.n776) & 0x3FL
    self.n759 = (self.n757 & 0x8L) | (self.n757 & 0x4L) | (self.n757 & 0x2L) | (self.n757 & 0x1L)
    self.n758 = ((self.n757 & 0x10L) >> 4)
    self.n740r = self.n2
    self.n740e = self.n1
    self.n740d = self.n664
    self.n733r = self.n2
    self.n733e = self.n1
    self.n733d = self.n657
    self.n726r = self.n2
    self.n726e = self.n1
    self.n726d = self.n650
    self.n719r = self.n2
    self.n719e = self.n1
    self.n719d = self.n643
    self.n712r = self.n2
    self.n712e = self.n1
    self.n712d = self.n636
    self.n701 = (self.n671 - self.n700) & 0x3FL
    self.n683 = (self.n681 & 0x8L) | (self.n681 & 0x4L) | (self.n681 & 0x2L) | (self.n681 & 0x1L)
    self.n682 = ((self.n681 & 0x10L) >> 4)
    self.n664r = self.n2
    self.n664e = self.n1
    self.n664d = self.n588
    self.n657r = self.n2
    self.n657e = self.n1
    self.n657d = self.n581
    self.n650r = self.n2
    self.n650e = self.n1
    self.n650d = self.n574
    self.n643r = self.n2
    self.n643e = self.n1
    self.n643d = self.n567
    self.n636r = self.n2
    self.n636e = self.n1
    self.n636d = self.n560
    self.n625 = (self.n595 - self.n624) & 0x3FL
    self.n607 = (self.n605 & 0x8L) | (self.n605 & 0x4L) | (self.n605 & 0x2L) | (self.n605 & 0x1L)
    self.n606 = ((self.n605 & 0x10L) >> 4)
    self.n588r = self.n2
    self.n588e = self.n1
    self.n588d = self.n512
    self.n581r = self.n2
    self.n581e = self.n1
    self.n581d = self.n505
    self.n574r = self.n2
    self.n574e = self.n1
    self.n574d = self.n498
    self.n567r = self.n2
    self.n567e = self.n1
    self.n567d = self.n491
    self.n560r = self.n2
    self.n560e = self.n1
    self.n560d = self.n484
    self.n549 = (self.n519 - self.n548) & 0x3FL
    self.n531 = (self.n529 & 0x8L) | (self.n529 & 0x4L) | (self.n529 & 0x2L) | (self.n529 & 0x1L)
    self.n530 = ((self.n529 & 0x10L) >> 4)
    self.n512r = self.n2
    self.n512e = self.n1
    self.n512d = self.n436
    self.n505r = self.n2
    self.n505e = self.n1
    self.n505d = self.n429
    self.n498r = self.n2
    self.n498e = self.n1
    self.n498d = self.n422
    self.n491r = self.n2
    self.n491e = self.n1
    self.n491d = self.n415
    self.n484r = self.n2
    self.n484e = self.n1
    self.n484d = self.n408
    self.n473 = (self.n443 - self.n472) & 0x3FL
    self.n455 = (self.n453 & 0x8L) | (self.n453 & 0x4L) | (self.n453 & 0x2L) | (self.n453 & 0x1L)
    self.n454 = ((self.n453 & 0x10L) >> 4)
    self.n436r = self.n2
    self.n436e = self.n1
    self.n436d = self.n360
    self.n429r = self.n2
    self.n429e = self.n1
    self.n429d = self.n353
    self.n422r = self.n2
    self.n422e = self.n1
    self.n422d = self.n346
    self.n415r = self.n2
    self.n415e = self.n1
    self.n415d = self.n339
    self.n408r = self.n2
    self.n408e = self.n1
    self.n408d = self.n332
    self.n397 = (self.n367 - self.n396) & 0x3FL
    self.n379 = (self.n377 & 0x8L) | (self.n377 & 0x4L) | (self.n377 & 0x2L) | (self.n377 & 0x1L)
    self.n378 = ((self.n377 & 0x10L) >> 4)
    self.n360r = self.n2
    self.n360e = self.n1
    self.n360d = self.n284
    self.n353r = self.n2
    self.n353e = self.n1
    self.n353d = self.n277
    self.n346r = self.n2
    self.n346e = self.n1
    self.n346d = self.n270
    self.n339r = self.n2
    self.n339e = self.n1
    self.n339d = self.n263
    self.n332r = self.n2
    self.n332e = self.n1
    self.n332d = self.n256
    self.n321 = (self.n291 - self.n320) & 0x3FL
    self.n303 = (self.n301 & 0x8L) | (self.n301 & 0x4L) | (self.n301 & 0x2L) | (self.n301 & 0x1L)
    self.n302 = ((self.n301 & 0x10L) >> 4)
    self.n284r = self.n2
    self.n284e = self.n1
    self.n284d = self.n228
    self.n277r = self.n2
    self.n277e = self.n1
    self.n277d = self.n221
    self.n270r = self.n2
    self.n270e = self.n1
    self.n270d = self.n214
    self.n263r = self.n2
    self.n263e = self.n1
    self.n263d = self.n207
    self.n256r = self.n2
    self.n256e = self.n1
    self.n256d = self.n200
    if self.n243:
      self.n249 = self.n247
    else:
      self.n249 = self.n248
    self.n245 = (self.n235 + self.n244) & 0x3FL
    self.n183 = self.n182 << 5 | self.n23
    self.n181 = self.n180 << 5 | self.n20
    self.n179 = self.n19 ^ self.n22
    self.n162 = ((self.n100 & 0x200L) >> 9)
    self.n160 = ((self.n100 & 0x200L) >> 9)
    self.n131 = (self.n100 & 0x100L) | (self.n100 & 0x80L) | (self.n100 & 0x40L) | (self.n100 & 0x20L) | (self.n100 & 0x10L) | (self.n100 & 0x8L) | (self.n100 & 0x4L) | (self.n100 & 0x2L) | (self.n100 & 0x1L)
    self.n130 = ((self.n100 & 0x200L) >> 9)
    self.n116 = (self.n99 & 0x8L) | (self.n99 & 0x4L) | (self.n99 & 0x2L) | (self.n99 & 0x1L)
    self.n115 = ((self.n99 & 0x10L) >> 4)
    self.n102 = (self.n99 & 0x8L) | (self.n99 & 0x4L) | (self.n99 & 0x2L) | (self.n99 & 0x1L)
    self.n101 = ((self.n99 & 0x10L) >> 4)
    self.n89 = ((self.n27 & 0x200L) >> 9)
    self.n87 = ((self.n27 & 0x200L) >> 9)
    self.n58 = (self.n27 & 0x100L) | (self.n27 & 0x80L) | (self.n27 & 0x40L) | (self.n27 & 0x20L) | (self.n27 & 0x10L) | (self.n27 & 0x8L) | (self.n27 & 0x4L) | (self.n27 & 0x2L) | (self.n27 & 0x1L)
    self.n57 = ((self.n27 & 0x200L) >> 9)
    self.n43 = (self.n26 & 0x8L) | (self.n26 & 0x4L) | (self.n26 & 0x2L) | (self.n26 & 0x1L)
    self.n42 = ((self.n26 & 0x10L) >> 4)
    self.n29 = (self.n26 & 0x8L) | (self.n26 & 0x4L) | (self.n26 & 0x2L) | (self.n26 & 0x1L)
    self.n28 = ((self.n26 & 0x10L) >> 4)
    self.n18r = self.n2
    self.n18e = self.n1
    self.n18d = self.n4
    self.n11r = self.n2
    self.n11e = self.n1
    self.n11d = self.n3
    self.n1074 = self.n1016 << 3 | self.n1073
    self.n996 = self.n984 | self.n986
    self.n989 = (self.n987 & 0x4L) | (self.n987 & 0x2L) | (self.n987 & 0x1L)
    self.n988 = ((self.n987 & 0x8L) >> 3)
    self.n920 = self.n908 | self.n910
    self.n913 = (self.n911 & 0x4L) | (self.n911 & 0x2L) | (self.n911 & 0x1L)
    self.n912 = ((self.n911 & 0x8L) >> 3)
    self.n844 = self.n832 | self.n834
    self.n837 = (self.n835 & 0x4L) | (self.n835 & 0x2L) | (self.n835 & 0x1L)
    self.n836 = ((self.n835 & 0x8L) >> 3)
    self.n768 = self.n756 | self.n758
    self.n761 = (self.n759 & 0x4L) | (self.n759 & 0x2L) | (self.n759 & 0x1L)
    self.n760 = ((self.n759 & 0x8L) >> 3)
    self.n692 = self.n680 | self.n682
    self.n685 = (self.n683 & 0x4L) | (self.n683 & 0x2L) | (self.n683 & 0x1L)
    self.n684 = ((self.n683 & 0x8L) >> 3)
    self.n616 = self.n604 | self.n606
    self.n609 = (self.n607 & 0x4L) | (self.n607 & 0x2L) | (self.n607 & 0x1L)
    self.n608 = ((self.n607 & 0x8L) >> 3)
    self.n540 = self.n528 | self.n530
    self.n533 = (self.n531 & 0x4L) | (self.n531 & 0x2L) | (self.n531 & 0x1L)
    self.n532 = ((self.n531 & 0x8L) >> 3)
    self.n464 = self.n452 | self.n454
    self.n457 = (self.n455 & 0x4L) | (self.n455 & 0x2L) | (self.n455 & 0x1L)
    self.n456 = ((self.n455 & 0x8L) >> 3)
    self.n388 = self.n376 | self.n378
    self.n381 = (self.n379 & 0x4L) | (self.n379 & 0x2L) | (self.n379 & 0x1L)
    self.n380 = ((self.n379 & 0x8L) >> 3)
    self.n312 = self.n300 | self.n302
    self.n305 = (self.n303 & 0x4L) | (self.n303 & 0x2L) | (self.n303 & 0x1L)
    self.n304 = ((self.n303 & 0x8L) >> 3)
    self.n298r = self.n2
    self.n298e = self.n1
    self.n298d = self.n249
    if self.n243:
      self.n246 = self.n245
    else:
      self.n246 = self.n235
    self.n228r = self.n2
    self.n228e = self.n1
    self.n228d = self.n179
    self.n184 = (self.n181 + self.n183) & 0x3FL
    self.n163 = ~self.n162 & 0x1L
    self.n133 = (self.n131 & 0x80L) | (self.n131 & 0x40L) | (self.n131 & 0x20L) | (self.n131 & 0x10L) | (self.n131 & 0x8L) | (self.n131 & 0x4L) | (self.n131 & 0x2L) | (self.n131 & 0x1L)
    self.n132 = ((self.n131 & 0x100L) >> 8)
    self.n118 = (self.n116 & 0x4L) | (self.n116 & 0x2L) | (self.n116 & 0x1L)
    self.n117 = ((self.n116 & 0x8L) >> 3)
    self.n104 = (self.n102 & 0x4L) | (self.n102 & 0x2L) | (self.n102 & 0x1L)
    self.n103 = ((self.n102 & 0x8L) >> 3)
    self.n90 = ~self.n89 & 0x1L
    self.n60 = (self.n58 & 0x80L) | (self.n58 & 0x40L) | (self.n58 & 0x20L) | (self.n58 & 0x10L) | (self.n58 & 0x8L) | (self.n58 & 0x4L) | (self.n58 & 0x2L) | (self.n58 & 0x1L)
    self.n59 = ((self.n58 & 0x100L) >> 8)
    self.n45 = (self.n43 & 0x4L) | (self.n43 & 0x2L) | (self.n43 & 0x1L)
    self.n44 = ((self.n43 & 0x8L) >> 3)
    self.n31 = (self.n29 & 0x4L) | (self.n29 & 0x2L) | (self.n29 & 0x1L)
    self.n30 = ((self.n29 & 0x8L) >> 3)
    if self.n1074 == self.n1108:
      self.n1109 = 1L
    else:
      self.n1109 = 0L
    if self.n1074 == self.n1106:
      self.n1107 = 1L
    else:
      self.n1107 = 0L
    if self.n1074 == self.n1104:
      self.n1105 = 1L
    else:
      self.n1105 = 0L
    if self.n1074 == self.n1102:
      self.n1103 = 1L
    else:
      self.n1103 = 0L
    if self.n1074 == self.n1100:
      self.n1101 = 1L
    else:
      self.n1101 = 0L
    if self.n1074 == self.n1098:
      self.n1099 = 1L
    else:
      self.n1099 = 0L
    if self.n1074 == self.n1096:
      self.n1097 = 1L
    else:
      self.n1097 = 0L
    if self.n1074 == self.n1094:
      self.n1095 = 1L
    else:
      self.n1095 = 0L
    if self.n1074 == self.n1092:
      self.n1093 = 1L
    else:
      self.n1093 = 0L
    if self.n1074 == self.n1090:
      self.n1091 = 1L
    else:
      self.n1091 = 0L
    if self.n1074 == self.n1088:
      self.n1089 = 1L
    else:
      self.n1089 = 0L
    if self.n1074 == self.n1086:
      self.n1087 = 1L
    else:
      self.n1087 = 0L
    if self.n1074 == self.n1084:
      self.n1085 = 1L
    else:
      self.n1085 = 0L
    if self.n1074 == self.n1082:
      self.n1083 = 1L
    else:
      self.n1083 = 0L
    if self.n1074 == self.n1080:
      self.n1081 = 1L
    else:
      self.n1081 = 0L
    self.n991 = (self.n989 & 0x2L) | (self.n989 & 0x1L)
    self.n990 = ((self.n989 & 0x4L) >> 2)
    self.n915 = (self.n913 & 0x2L) | (self.n913 & 0x1L)
    self.n914 = ((self.n913 & 0x4L) >> 2)
    self.n839 = (self.n837 & 0x2L) | (self.n837 & 0x1L)
    self.n838 = ((self.n837 & 0x4L) >> 2)
    self.n763 = (self.n761 & 0x2L) | (self.n761 & 0x1L)
    self.n762 = ((self.n761 & 0x4L) >> 2)
    self.n687 = (self.n685 & 0x2L) | (self.n685 & 0x1L)
    self.n686 = ((self.n685 & 0x4L) >> 2)
    self.n611 = (self.n609 & 0x2L) | (self.n609 & 0x1L)
    self.n610 = ((self.n609 & 0x4L) >> 2)
    self.n535 = (self.n533 & 0x2L) | (self.n533 & 0x1L)
    self.n534 = ((self.n533 & 0x4L) >> 2)
    self.n459 = (self.n457 & 0x2L) | (self.n457 & 0x1L)
    self.n458 = ((self.n457 & 0x4L) >> 2)
    self.n383 = (self.n381 & 0x2L) | (self.n381 & 0x1L)
    self.n382 = ((self.n381 & 0x4L) >> 2)
    self.n307 = (self.n305 & 0x2L) | (self.n305 & 0x1L)
    self.n306 = ((self.n305 & 0x4L) >> 2)
    self.n291r = self.n2
    self.n291e = self.n1
    self.n291d = self.n246
    self.n188 = (self.n184 - self.n1144) & 0x3FL
    self.n150 = self.n130 | self.n132
    self.n135 = (self.n133 & 0x40L) | (self.n133 & 0x20L) | (self.n133 & 0x10L) | (self.n133 & 0x8L) | (self.n133 & 0x4L) | (self.n133 & 0x2L) | (self.n133 & 0x1L)
    self.n134 = ((self.n133 & 0x80L) >> 7)
    self.n125 = self.n115 | self.n117
    self.n120 = (self.n118 & 0x2L) | (self.n118 & 0x1L)
    self.n119 = ((self.n118 & 0x4L) >> 2)
    self.n111 = self.n101 & self.n103
    self.n106 = (self.n104 & 0x2L) | (self.n104 & 0x1L)
    self.n105 = ((self.n104 & 0x4L) >> 2)
    self.n77 = self.n57 | self.n59
    self.n62 = (self.n60 & 0x40L) | (self.n60 & 0x20L) | (self.n60 & 0x10L) | (self.n60 & 0x8L) | (self.n60 & 0x4L) | (self.n60 & 0x2L) | (self.n60 & 0x1L)
    self.n61 = ((self.n60 & 0x80L) >> 7)
    self.n52 = self.n42 | self.n44
    self.n47 = (self.n45 & 0x2L) | (self.n45 & 0x1L)
    self.n46 = ((self.n45 & 0x4L) >> 2)
    self.n38 = self.n28 & self.n30
    self.n33 = (self.n31 & 0x2L) | (self.n31 & 0x1L)
    self.n32 = ((self.n31 & 0x4L) >> 2)
    if self.n1109:
      self.n1110 = self.n1076
    else:
      self.n1110 = self.n1075
    self.n997 = self.n988 | self.n990
    self.n993 = (self.n991 & 0x1L)
    self.n992 = ((self.n991 & 0x2L) >> 1)
    self.n921 = self.n912 | self.n914
    self.n917 = (self.n915 & 0x1L)
    self.n916 = ((self.n915 & 0x2L) >> 1)
    self.n845 = self.n836 | self.n838
    self.n841 = (self.n839 & 0x1L)
    self.n840 = ((self.n839 & 0x2L) >> 1)
    self.n769 = self.n760 | self.n762
    self.n765 = (self.n763 & 0x1L)
    self.n764 = ((self.n763 & 0x2L) >> 1)
    self.n693 = self.n684 | self.n686
    self.n689 = (self.n687 & 0x1L)
    self.n688 = ((self.n687 & 0x2L) >> 1)
    self.n617 = self.n608 | self.n610
    self.n613 = (self.n611 & 0x1L)
    self.n612 = ((self.n611 & 0x2L) >> 1)
    self.n541 = self.n532 | self.n534
    self.n537 = (self.n535 & 0x1L)
    self.n536 = ((self.n535 & 0x2L) >> 1)
    self.n465 = self.n456 | self.n458
    self.n461 = (self.n459 & 0x1L)
    self.n460 = ((self.n459 & 0x2L) >> 1)
    self.n389 = self.n380 | self.n382
    self.n385 = (self.n383 & 0x1L)
    self.n384 = ((self.n383 & 0x2L) >> 1)
    self.n313 = self.n304 | self.n306
    self.n309 = (self.n307 & 0x1L)
    self.n308 = ((self.n307 & 0x2L) >> 1)
    self.n235r = self.n2
    self.n235e = self.n1
    self.n235d = self.n188
    self.n137 = (self.n135 & 0x20L) | (self.n135 & 0x10L) | (self.n135 & 0x8L) | (self.n135 & 0x4L) | (self.n135 & 0x2L) | (self.n135 & 0x1L)
    self.n136 = ((self.n135 & 0x40L) >> 6)
    self.n122 = (self.n120 & 0x1L)
    self.n121 = ((self.n120 & 0x2L) >> 1)
    self.n108 = (self.n106 & 0x1L)
    self.n107 = ((self.n106 & 0x2L) >> 1)
    self.n64 = (self.n62 & 0x20L) | (self.n62 & 0x10L) | (self.n62 & 0x8L) | (self.n62 & 0x4L) | (self.n62 & 0x2L) | (self.n62 & 0x1L)
    self.n63 = ((self.n62 & 0x40L) >> 6)
    self.n49 = (self.n47 & 0x1L)
    self.n48 = ((self.n47 & 0x2L) >> 1)
    self.n35 = (self.n33 & 0x1L)
    self.n34 = ((self.n33 & 0x2L) >> 1)
    if self.n1107:
      self.n1111 = self.n1077
    else:
      self.n1111 = self.n1110
    self.n999 = self.n996 | self.n997
    self.n994 = (self.n993 & 0x1L)
    self.n923 = self.n920 | self.n921
    self.n918 = (self.n917 & 0x1L)
    self.n847 = self.n844 | self.n845
    self.n842 = (self.n841 & 0x1L)
    self.n771 = self.n768 | self.n769
    self.n766 = (self.n765 & 0x1L)
    self.n695 = self.n692 | self.n693
    self.n690 = (self.n689 & 0x1L)
    self.n619 = self.n616 | self.n617
    self.n614 = (self.n613 & 0x1L)
    self.n543 = self.n540 | self.n541
    self.n538 = (self.n537 & 0x1L)
    self.n467 = self.n464 | self.n465
    self.n462 = (self.n461 & 0x1L)
    self.n391 = self.n388 | self.n389
    self.n386 = (self.n385 & 0x1L)
    self.n315 = self.n312 | self.n313
    self.n310 = (self.n309 & 0x1L)
    self.n151 = self.n134 | self.n136
    self.n139 = (self.n137 & 0x10L) | (self.n137 & 0x8L) | (self.n137 & 0x4L) | (self.n137 & 0x2L) | (self.n137 & 0x1L)
    self.n138 = ((self.n137 & 0x20L) >> 5)
    self.n126 = self.n119 | self.n121
    self.n123 = (self.n122 & 0x1L)
    self.n112 = self.n105 & self.n107
    self.n109 = (self.n108 & 0x1L)
    self.n78 = self.n61 | self.n63
    self.n66 = (self.n64 & 0x10L) | (self.n64 & 0x8L) | (self.n64 & 0x4L) | (self.n64 & 0x2L) | (self.n64 & 0x1L)
    self.n65 = ((self.n64 & 0x20L) >> 5)
    self.n53 = self.n46 | self.n48
    self.n50 = (self.n49 & 0x1L)
    self.n39 = self.n32 & self.n34
    self.n36 = (self.n35 & 0x1L)
    if self.n1105:
      self.n1112 = self.n1077
    else:
      self.n1112 = self.n1111
    self.n998 = self.n992 | self.n994
    self.n922 = self.n916 | self.n918
    self.n846 = self.n840 | self.n842
    self.n770 = self.n764 | self.n766
    self.n694 = self.n688 | self.n690
    self.n618 = self.n612 | self.n614
    self.n542 = self.n536 | self.n538
    self.n466 = self.n460 | self.n462
    self.n390 = self.n384 | self.n386
    self.n314 = self.n308 | self.n310
    self.n155 = self.n150 | self.n151
    self.n141 = (self.n139 & 0x8L) | (self.n139 & 0x4L) | (self.n139 & 0x2L) | (self.n139 & 0x1L)
    self.n140 = ((self.n139 & 0x10L) >> 4)
    self.n127 = self.n125 | self.n126
    self.n113 = self.n111 & self.n112
    self.n82 = self.n77 | self.n78
    self.n68 = (self.n66 & 0x8L) | (self.n66 & 0x4L) | (self.n66 & 0x2L) | (self.n66 & 0x1L)
    self.n67 = ((self.n66 & 0x10L) >> 4)
    self.n54 = self.n52 | self.n53
    self.n40 = self.n38 & self.n39
    if self.n1103:
      self.n1113 = self.n1078
    else:
      self.n1113 = self.n1112
    self.n1000 = self.n999 | self.n998
    self.n924 = self.n923 | self.n922
    self.n848 = self.n847 | self.n846
    self.n772 = self.n771 | self.n770
    self.n696 = self.n695 | self.n694
    self.n620 = self.n619 | self.n618
    self.n544 = self.n543 | self.n542
    self.n468 = self.n467 | self.n466
    self.n392 = self.n391 | self.n390
    self.n316 = self.n315 | self.n314
    self.n152 = self.n138 | self.n140
    self.n143 = (self.n141 & 0x4L) | (self.n141 & 0x2L) | (self.n141 & 0x1L)
    self.n142 = ((self.n141 & 0x8L) >> 3)
    self.n128 = self.n127 | self.n123
    self.n114 = self.n113 & self.n109
    self.n79 = self.n65 | self.n67
    self.n70 = (self.n68 & 0x4L) | (self.n68 & 0x2L) | (self.n68 & 0x1L)
    self.n69 = ((self.n68 & 0x8L) >> 3)
    self.n55 = self.n54 | self.n50
    self.n41 = self.n40 & self.n36
    if self.n1101:
      self.n1114 = self.n1078
    else:
      self.n1114 = self.n1113
    self.n1001 = ~self.n1000 & 0x1L
    self.n925 = ~self.n924 & 0x1L
    self.n849 = ~self.n848 & 0x1L
    self.n773 = ~self.n772 & 0x1L
    self.n697 = ~self.n696 & 0x1L
    self.n621 = ~self.n620 & 0x1L
    self.n545 = ~self.n544 & 0x1L
    self.n469 = ~self.n468 & 0x1L
    self.n393 = ~self.n392 & 0x1L
    self.n317 = ~self.n316 & 0x1L
    self.n164 = self.n114 & self.n163
    self.n161 = self.n114 & self.n160
    self.n145 = (self.n143 & 0x2L) | (self.n143 & 0x1L)
    self.n144 = ((self.n143 & 0x4L) >> 2)
    self.n129 = ~self.n128 & 0x1L
    self.n91 = self.n41 & self.n90
    self.n88 = self.n41 & self.n87
    self.n72 = (self.n70 & 0x2L) | (self.n70 & 0x1L)
    self.n71 = ((self.n70 & 0x4L) >> 2)
    self.n56 = ~self.n55 & 0x1L
    if self.n1099:
      self.n1115 = self.n1078
    else:
      self.n1115 = self.n1114
    self.n1002 = self.n983 | self.n1001
    self.n926 = self.n907 | self.n925
    self.n850 = self.n831 | self.n849
    self.n774 = self.n755 | self.n773
    self.n698 = self.n679 | self.n697
    self.n622 = self.n603 | self.n621
    self.n546 = self.n527 | self.n545
    self.n470 = self.n451 | self.n469
    self.n394 = self.n375 | self.n393
    self.n318 = self.n299 | self.n317
    self.n153 = self.n142 | self.n144
    self.n147 = (self.n145 & 0x1L)
    self.n146 = ((self.n145 & 0x2L) >> 1)
    self.n80 = self.n69 | self.n71
    self.n74 = (self.n72 & 0x1L)
    self.n73 = ((self.n72 & 0x2L) >> 1)
    if self.n1097:
      self.n1116 = self.n1078
    else:
      self.n1116 = self.n1115
    self.n1003 = ~self.n1002 & 0x1L
    self.n927 = ~self.n926 & 0x1L
    self.n851 = ~self.n850 & 0x1L
    self.n775 = ~self.n774 & 0x1L
    self.n699 = ~self.n698 & 0x1L
    self.n623 = ~self.n622 & 0x1L
    self.n547 = ~self.n546 & 0x1L
    self.n471 = ~self.n470 & 0x1L
    self.n395 = ~self.n394 & 0x1L
    self.n319 = ~self.n318 & 0x1L
    self.n156 = self.n152 | self.n153
    self.n148 = (self.n147 & 0x1L)
    self.n83 = self.n79 | self.n80
    self.n75 = (self.n74 & 0x1L)
    if self.n1095:
      self.n1117 = self.n1079
    else:
      self.n1117 = self.n1116
    if self.n1003:
      self.n1009 = self.n1007
    else:
      self.n1009 = self.n1008
    if self.n1003:
      self.n1006 = self.n1005
    else:
      self.n1006 = self.n975
    if self.n927:
      self.n933 = self.n931
    else:
      self.n933 = self.n932
    if self.n927:
      self.n930 = self.n929
    else:
      self.n930 = self.n899
    if self.n851:
      self.n857 = self.n855
    else:
      self.n857 = self.n856
    if self.n851:
      self.n854 = self.n853
    else:
      self.n854 = self.n823
    if self.n775:
      self.n781 = self.n779
    else:
      self.n781 = self.n780
    if self.n775:
      self.n778 = self.n777
    else:
      self.n778 = self.n747
    if self.n699:
      self.n705 = self.n703
    else:
      self.n705 = self.n704
    if self.n699:
      self.n702 = self.n701
    else:
      self.n702 = self.n671
    if self.n623:
      self.n629 = self.n627
    else:
      self.n629 = self.n628
    if self.n623:
      self.n626 = self.n625
    else:
      self.n626 = self.n595
    if self.n547:
      self.n553 = self.n551
    else:
      self.n553 = self.n552
    if self.n547:
      self.n550 = self.n549
    else:
      self.n550 = self.n519
    if self.n471:
      self.n477 = self.n475
    else:
      self.n477 = self.n476
    if self.n471:
      self.n474 = self.n473
    else:
      self.n474 = self.n443
    if self.n395:
      self.n401 = self.n399
    else:
      self.n401 = self.n400
    if self.n395:
      self.n398 = self.n397
    else:
      self.n398 = self.n367
    if self.n319:
      self.n325 = self.n323
    else:
      self.n325 = self.n324
    if self.n319:
      self.n322 = self.n321
    else:
      self.n322 = self.n291
    self.n157 = self.n155 | self.n156
    self.n154 = self.n146 | self.n148
    self.n84 = self.n82 | self.n83
    self.n81 = self.n73 | self.n75
    if self.n1093:
      self.n1118 = self.n1079
    else:
      self.n1118 = self.n1117
    self.n1058r = self.n2
    self.n1058e = self.n1
    self.n1058d = self.n1009
    self.n1051r = self.n2
    self.n1051e = self.n1
    self.n1051d = self.n1006
    self.n982r = self.n2
    self.n982e = self.n1
    self.n982d = self.n933
    self.n975r = self.n2
    self.n975e = self.n1
    self.n975d = self.n930
    self.n906r = self.n2
    self.n906e = self.n1
    self.n906d = self.n857
    self.n899r = self.n2
    self.n899e = self.n1
    self.n899d = self.n854
    self.n830r = self.n2
    self.n830e = self.n1
    self.n830d = self.n781
    self.n823r = self.n2
    self.n823e = self.n1
    self.n823d = self.n778
    self.n754r = self.n2
    self.n754e = self.n1
    self.n754d = self.n705
    self.n747r = self.n2
    self.n747e = self.n1
    self.n747d = self.n702
    self.n678r = self.n2
    self.n678e = self.n1
    self.n678d = self.n629
    self.n671r = self.n2
    self.n671e = self.n1
    self.n671d = self.n626
    self.n602r = self.n2
    self.n602e = self.n1
    self.n602d = self.n553
    self.n595r = self.n2
    self.n595e = self.n1
    self.n595d = self.n550
    self.n526r = self.n2
    self.n526e = self.n1
    self.n526d = self.n477
    self.n519r = self.n2
    self.n519e = self.n1
    self.n519d = self.n474
    self.n450r = self.n2
    self.n450e = self.n1
    self.n450d = self.n401
    self.n443r = self.n2
    self.n443e = self.n1
    self.n443d = self.n398
    self.n374r = self.n2
    self.n374e = self.n1
    self.n374d = self.n325
    self.n367r = self.n2
    self.n367e = self.n1
    self.n367d = self.n322
    self.n158 = self.n157 | self.n154
    self.n85 = self.n84 | self.n81
    if self.n1091:
      self.n1119 = self.n1079
    else:
      self.n1119 = self.n1118
    self.n159 = ~self.n158 & 0x1L
    self.n86 = ~self.n85 & 0x1L
    if self.n1089:
      self.n1120 = self.n1079
    else:
      self.n1120 = self.n1119
    self.n169 = ~self.n159 & 0x1L
    self.n168 = self.n129 & self.n159
    self.n167 = self.n114 & self.n159
    self.n165 = ~self.n159 & 0x1L
    self.n96 = ~self.n86 & 0x1L
    self.n95 = self.n56 & self.n86
    self.n94 = self.n41 & self.n86
    self.n92 = ~self.n86 & 0x1L
    if self.n1087:
      self.n1121 = self.n1079
    else:
      self.n1121 = self.n1120
    self.n178 = self.n95 | self.n168
    self.n177 = self.n94 | self.n167
    self.n175 = self.n95 & self.n167
    self.n174 = self.n94 & self.n168
    self.n170 = self.n129 & self.n169
    self.n166 = self.n164 & self.n165
    self.n97 = self.n56 & self.n96
    self.n93 = self.n91 & self.n92
    if self.n1085:
      self.n1122 = self.n1079
    else:
      self.n1122 = self.n1121
    self.n221r = self.n2
    self.n221e = self.n1
    self.n221d = self.n178
    self.n214r = self.n2
    self.n214e = self.n1
    self.n214d = self.n177
    self.n191 = ~self.n170 & 0x1L
    self.n189 = ~self.n97 & 0x1L
    self.n176 = self.n174 | self.n175
    self.n172 = self.n166 | self.n161
    self.n171 = self.n93 | self.n88
    if self.n1083:
      self.n1123 = self.n1079
    else:
      self.n1123 = self.n1122
    self.n207r = self.n2
    self.n207e = self.n1
    self.n207d = self.n176
    self.n192 = self.n191 << 10 | self.n24
    self.n190 = self.n189 << 10 | self.n21
    self.n173 = self.n171 | self.n172
    if self.n1081:
      self.n1124 = self.n1079
    else:
      self.n1124 = self.n1123
    self.n200r = self.n2
    self.n200e = self.n1
    self.n200d = self.n173
    self.n193 = (self.n190 * self.n192) & 0x3FFFFFL
    self.n1126 = (self.n1124 & 0x1L)
    self.n1125 = ((self.n1124 & 0x4L) >> 1) | ((self.n1124 & 0x2L) >> 1)
    self.n242r = self.n2
    self.n242e = self.n1
    self.n242d = self.n193
    self.n1130 = (self.n1125 & 0x1L)
    self.n1129 = ((self.n1125 & 0x2L) >> 1)
    if self.n1126:
      self.n1128 = self.n1148
    else:
      self.n1128 = self.n1146
    if self.n1126:
      self.n1127 = self.n1062
    else:
      self.n1127 = self.n1061
    self.n1133 = (self.n1129 & 0x1L)
    if self.n1130:
      self.n1131 = self.n1128
    else:
      self.n1131 = self.n1127
    if self.n1133:
      self.n1134 = self.n1150
    else:
      self.n1134 = self.n1131
    self.n1135 = self.n1044 << 15 | self.n1134
    self.n1142r = self.n2
    self.n1142e = self.n1
    self.n1142d = self.n1135
    return (x_o, )

  def cycle_clock(self):
    if self.n11r:
      self.n11 = 0L
    elif self.n11e:
        self.n11 = self.n11d
    if self.n18r:
      self.n18 = 0L
    elif self.n18e:
        self.n18 = self.n18d
    if self.n200r:
      self.n200 = 0L
    elif self.n200e:
        self.n200 = self.n200d
    if self.n207r:
      self.n207 = 0L
    elif self.n207e:
        self.n207 = self.n207d
    if self.n214r:
      self.n214 = 0L
    elif self.n214e:
        self.n214 = self.n214d
    if self.n221r:
      self.n221 = 0L
    elif self.n221e:
        self.n221 = self.n221d
    if self.n228r:
      self.n228 = 0L
    elif self.n228e:
        self.n228 = self.n228d
    if self.n235r:
      self.n235 = 0L
    elif self.n235e:
        self.n235 = self.n235d
    if self.n242r:
      self.n242 = 0L
    elif self.n242e:
        self.n242 = self.n242d
    if self.n256r:
      self.n256 = 0L
    elif self.n256e:
        self.n256 = self.n256d
    if self.n263r:
      self.n263 = 0L
    elif self.n263e:
        self.n263 = self.n263d
    if self.n270r:
      self.n270 = 0L
    elif self.n270e:
        self.n270 = self.n270d
    if self.n277r:
      self.n277 = 0L
    elif self.n277e:
        self.n277 = self.n277d
    if self.n284r:
      self.n284 = 0L
    elif self.n284e:
        self.n284 = self.n284d
    if self.n291r:
      self.n291 = 0L
    elif self.n291e:
        self.n291 = self.n291d
    if self.n298r:
      self.n298 = 0L
    elif self.n298e:
        self.n298 = self.n298d
    if self.n332r:
      self.n332 = 0L
    elif self.n332e:
        self.n332 = self.n332d
    if self.n339r:
      self.n339 = 0L
    elif self.n339e:
        self.n339 = self.n339d
    if self.n346r:
      self.n346 = 0L
    elif self.n346e:
        self.n346 = self.n346d
    if self.n353r:
      self.n353 = 0L
    elif self.n353e:
        self.n353 = self.n353d
    if self.n360r:
      self.n360 = 0L
    elif self.n360e:
        self.n360 = self.n360d
    if self.n367r:
      self.n367 = 0L
    elif self.n367e:
        self.n367 = self.n367d
    if self.n374r:
      self.n374 = 0L
    elif self.n374e:
        self.n374 = self.n374d
    if self.n408r:
      self.n408 = 0L
    elif self.n408e:
        self.n408 = self.n408d
    if self.n415r:
      self.n415 = 0L
    elif self.n415e:
        self.n415 = self.n415d
    if self.n422r:
      self.n422 = 0L
    elif self.n422e:
        self.n422 = self.n422d
    if self.n429r:
      self.n429 = 0L
    elif self.n429e:
        self.n429 = self.n429d
    if self.n436r:
      self.n436 = 0L
    elif self.n436e:
        self.n436 = self.n436d
    if self.n443r:
      self.n443 = 0L
    elif self.n443e:
        self.n443 = self.n443d
    if self.n450r:
      self.n450 = 0L
    elif self.n450e:
        self.n450 = self.n450d
    if self.n484r:
      self.n484 = 0L
    elif self.n484e:
        self.n484 = self.n484d
    if self.n491r:
      self.n491 = 0L
    elif self.n491e:
        self.n491 = self.n491d
    if self.n498r:
      self.n498 = 0L
    elif self.n498e:
        self.n498 = self.n498d
    if self.n505r:
      self.n505 = 0L
    elif self.n505e:
        self.n505 = self.n505d
    if self.n512r:
      self.n512 = 0L
    elif self.n512e:
        self.n512 = self.n512d
    if self.n519r:
      self.n519 = 0L
    elif self.n519e:
        self.n519 = self.n519d
    if self.n526r:
      self.n526 = 0L
    elif self.n526e:
        self.n526 = self.n526d
    if self.n560r:
      self.n560 = 0L
    elif self.n560e:
        self.n560 = self.n560d
    if self.n567r:
      self.n567 = 0L
    elif self.n567e:
        self.n567 = self.n567d
    if self.n574r:
      self.n574 = 0L
    elif self.n574e:
        self.n574 = self.n574d
    if self.n581r:
      self.n581 = 0L
    elif self.n581e:
        self.n581 = self.n581d
    if self.n588r:
      self.n588 = 0L
    elif self.n588e:
        self.n588 = self.n588d
    if self.n595r:
      self.n595 = 0L
    elif self.n595e:
        self.n595 = self.n595d
    if self.n602r:
      self.n602 = 0L
    elif self.n602e:
        self.n602 = self.n602d
    if self.n636r:
      self.n636 = 0L
    elif self.n636e:
        self.n636 = self.n636d
    if self.n643r:
      self.n643 = 0L
    elif self.n643e:
        self.n643 = self.n643d
    if self.n650r:
      self.n650 = 0L
    elif self.n650e:
        self.n650 = self.n650d
    if self.n657r:
      self.n657 = 0L
    elif self.n657e:
        self.n657 = self.n657d
    if self.n664r:
      self.n664 = 0L
    elif self.n664e:
        self.n664 = self.n664d
    if self.n671r:
      self.n671 = 0L
    elif self.n671e:
        self.n671 = self.n671d
    if self.n678r:
      self.n678 = 0L
    elif self.n678e:
        self.n678 = self.n678d
    if self.n712r:
      self.n712 = 0L
    elif self.n712e:
        self.n712 = self.n712d
    if self.n719r:
      self.n719 = 0L
    elif self.n719e:
        self.n719 = self.n719d
    if self.n726r:
      self.n726 = 0L
    elif self.n726e:
        self.n726 = self.n726d
    if self.n733r:
      self.n733 = 0L
    elif self.n733e:
        self.n733 = self.n733d
    if self.n740r:
      self.n740 = 0L
    elif self.n740e:
        self.n740 = self.n740d
    if self.n747r:
      self.n747 = 0L
    elif self.n747e:
        self.n747 = self.n747d
    if self.n754r:
      self.n754 = 0L
    elif self.n754e:
        self.n754 = self.n754d
    if self.n788r:
      self.n788 = 0L
    elif self.n788e:
        self.n788 = self.n788d
    if self.n795r:
      self.n795 = 0L
    elif self.n795e:
        self.n795 = self.n795d
    if self.n802r:
      self.n802 = 0L
    elif self.n802e:
        self.n802 = self.n802d
    if self.n809r:
      self.n809 = 0L
    elif self.n809e:
        self.n809 = self.n809d
    if self.n816r:
      self.n816 = 0L
    elif self.n816e:
        self.n816 = self.n816d
    if self.n823r:
      self.n823 = 0L
    elif self.n823e:
        self.n823 = self.n823d
    if self.n830r:
      self.n830 = 0L
    elif self.n830e:
        self.n830 = self.n830d
    if self.n864r:
      self.n864 = 0L
    elif self.n864e:
        self.n864 = self.n864d
    if self.n871r:
      self.n871 = 0L
    elif self.n871e:
        self.n871 = self.n871d
    if self.n878r:
      self.n878 = 0L
    elif self.n878e:
        self.n878 = self.n878d
    if self.n885r:
      self.n885 = 0L
    elif self.n885e:
        self.n885 = self.n885d
    if self.n892r:
      self.n892 = 0L
    elif self.n892e:
        self.n892 = self.n892d
    if self.n899r:
      self.n899 = 0L
    elif self.n899e:
        self.n899 = self.n899d
    if self.n906r:
      self.n906 = 0L
    elif self.n906e:
        self.n906 = self.n906d
    if self.n940r:
      self.n940 = 0L
    elif self.n940e:
        self.n940 = self.n940d
    if self.n947r:
      self.n947 = 0L
    elif self.n947e:
        self.n947 = self.n947d
    if self.n954r:
      self.n954 = 0L
    elif self.n954e:
        self.n954 = self.n954d
    if self.n961r:
      self.n961 = 0L
    elif self.n961e:
        self.n961 = self.n961d
    if self.n968r:
      self.n968 = 0L
    elif self.n968e:
        self.n968 = self.n968d
    if self.n975r:
      self.n975 = 0L
    elif self.n975e:
        self.n975 = self.n975d
    if self.n982r:
      self.n982 = 0L
    elif self.n982e:
        self.n982 = self.n982d
    if self.n1016r:
      self.n1016 = 0L
    elif self.n1016e:
        self.n1016 = self.n1016d
    if self.n1023r:
      self.n1023 = 0L
    elif self.n1023e:
        self.n1023 = self.n1023d
    if self.n1030r:
      self.n1030 = 0L
    elif self.n1030e:
        self.n1030 = self.n1030d
    if self.n1037r:
      self.n1037 = 0L
    elif self.n1037e:
        self.n1037 = self.n1037d
    if self.n1044r:
      self.n1044 = 0L
    elif self.n1044e:
        self.n1044 = self.n1044d
    if self.n1051r:
      self.n1051 = 0L
    elif self.n1051e:
        self.n1051 = self.n1051d
    if self.n1058r:
      self.n1058 = 0L
    elif self.n1058e:
        self.n1058 = self.n1058d
    if self.n1142r:
      self.n1142 = 0L
    elif self.n1142e:
        self.n1142 = self.n1142d

  def sim_init(self, vcdFile):
    self.sim_file = open(vcdFile, 'w')
    self.sim_count = 1
    self.init()
    self.sim_n3 = self.n3
    self.sim_n4 = self.n4
    self.sim_n1143 = self.n1143
    self.sim_file.write("$date\n")
    self.sim_file.write("  " + time.strftime("%a %b %d %H:%M:%S %Y", time.localtime()) + "\n")
    self.sim_file.write("$end\n")
    self.sim_file.write("$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n")
    self.sim_file.write("$timescale\n  1 ns\n$end\n")
    self.sim_file.write("$scope module cf_fp_mul_p_5_10 $end\n")
    self.sim_file.write("$var wire 16 ! a_i $end\n")
    self.sim_file.write("$var wire 16 \" b_i $end\n")
    self.sim_file.write("$var wire 16 # x_o $end\n")
    self.sim_file.write("$upscope $end\n")
    self.sim_file.write("$enddefinitions $end\n")
    self.sim_file.write("#0\n")
    self.sim_file.write("$dumpvars\n")
    found = 0
    for bit in range(15, -1, -1):
      if found:
        if self.n3 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n3 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" !\n")
    found = 0
    for bit in range(15, -1, -1):
      if found:
        if self.n4 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n4 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" \"\n")
    found = 0
    for bit in range(15, -1, -1):
      if found:
        if self.n1143 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n1143 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" #\n")
    self.sim_file.write("$end\n")

  def sim_end(self):
    self.sim_file.write("#%d\n" % self.sim_count)
    self.sim_file.close()

  def sim_sample(self):
    changed = 0
    if self.sim_n3 != self.n3:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(15, -1, -1):
        if found:
          if self.n3 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n3 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" !\n")
      self.sim_n3 = self.n3
    if self.sim_n4 != self.n4:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(15, -1, -1):
        if found:
          if self.n4 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n4 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" \"\n")
      self.sim_n4 = self.n4
    if self.sim_n1143 != self.n1143:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(15, -1, -1):
        if found:
          if self.n1143 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n1143 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" #\n")
      self.sim_n1143 = self.n1143
    self.sim_count = self.sim_count + 1

