#
#  Copyright (c) 2003 Launchbird Design Systems, Inc.
#  All rights reserved.
#  
#  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#  
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#  
#  
#  Overview:
#  
#    Performs floating point multiply.
#  
#  Interface:
#  
#  
#  
#    Inputs:
#      a_i : Left operand.
#      b_i : Right operand.
#  
#    Outputs:
#      x_o : Result.
#  
#  Built In Parameters:
#  
#    Exponent Precision = 8
#    Mantissa Precision = 23
#    Total    Precision = 32
#  
#  
#  
#  
#  
#  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
#  
#  Build Date : Fri Aug 22 09:47:09 CDT 2003
#  
#  Interface
#  
#    Build Name    : cf_fp_mul_c_8_23
#    Clock Domains : 
#    Vector Input  : a_i(32)
#    Vector Input  : b_i(32)
#    Vector Output : x_o(32)
#  
#  
#  

import sys
import time

class cf_fp_mul_c_8_23:

  def init(self):
    self.n1213 = 0L
    self.n1211 = 0L
    self.n1209 = 0L
    self.n1207 = 0L
    self.n1178 = 0L
    self.n1176 = 0L
    self.n1174 = 0L
    self.n1172 = 0L
    self.n1170 = 0L
    self.n1168 = 0L
    self.n1166 = 0L
    self.n1164 = 0L
    self.n1162 = 0L
    self.n1160 = 0L
    self.n1158 = 0L
    self.n1156 = 0L
    self.n1154 = 0L
    self.n1152 = 0L
    self.n1150 = 0L
    self.n1149 = 0L
    self.n1148 = 0L
    self.n1147 = 0L
    self.n1146 = 0L
    self.n1145 = 0L
    self.n1132 = 0L
    self.n1123 = 0L
    self.n1087 = 0L
    self.n1051 = 0L
    self.n1015 = 0L
    self.n979 = 0L
    self.n943 = 0L
    self.n907 = 0L
    self.n871 = 0L
    self.n835 = 0L
    self.n799 = 0L
    self.n763 = 0L
    self.n727 = 0L
    self.n691 = 0L
    self.n655 = 0L
    self.n619 = 0L
    self.n583 = 0L
    self.n547 = 0L
    self.n511 = 0L
    self.n475 = 0L
    self.n439 = 0L
    self.n403 = 0L
    self.n367 = 0L
    self.n331 = 0L
    self.n295 = 0L
    self.n282 = 0L
    self.n280 = 0L
    self.n4 = 0L
    self.n3 = 0L
    self.n143 = 0L
    self.n142 = 0L
    self.n13 = 0L
    self.n12 = 0L
    self.n10 = 0L
    self.n9 = 0L
    self.n8 = 0L
    self.n7 = 0L
    self.n6 = 0L
    self.n5 = 0L
    self.n283 = 0L
    self.n281 = 0L
    self.n279 = 0L
    self.n262 = 0L
    self.n260 = 0L
    self.n192 = 0L
    self.n191 = 0L
    self.n168 = 0L
    self.n167 = 0L
    self.n145 = 0L
    self.n144 = 0L
    self.n132 = 0L
    self.n130 = 0L
    self.n62 = 0L
    self.n61 = 0L
    self.n38 = 0L
    self.n37 = 0L
    self.n15 = 0L
    self.n14 = 0L
    self.n284 = 0L
    self.n263 = 0L
    self.n194 = 0L
    self.n193 = 0L
    self.n170 = 0L
    self.n169 = 0L
    self.n147 = 0L
    self.n146 = 0L
    self.n133 = 0L
    self.n64 = 0L
    self.n63 = 0L
    self.n40 = 0L
    self.n39 = 0L
    self.n17 = 0L
    self.n16 = 0L
    self.n288 = 0L
    self.n237 = 0L
    self.n196 = 0L
    self.n195 = 0L
    self.n183 = 0L
    self.n172 = 0L
    self.n171 = 0L
    self.n160 = 0L
    self.n149 = 0L
    self.n148 = 0L
    self.n107 = 0L
    self.n66 = 0L
    self.n65 = 0L
    self.n53 = 0L
    self.n42 = 0L
    self.n41 = 0L
    self.n30 = 0L
    self.n19 = 0L
    self.n18 = 0L
    self.n296 = 0L
    self.n198 = 0L
    self.n197 = 0L
    self.n174 = 0L
    self.n173 = 0L
    self.n151 = 0L
    self.n150 = 0L
    self.n68 = 0L
    self.n67 = 0L
    self.n44 = 0L
    self.n43 = 0L
    self.n21 = 0L
    self.n20 = 0L
    self.n238 = 0L
    self.n200 = 0L
    self.n199 = 0L
    self.n184 = 0L
    self.n176 = 0L
    self.n175 = 0L
    self.n161 = 0L
    self.n153 = 0L
    self.n152 = 0L
    self.n108 = 0L
    self.n70 = 0L
    self.n69 = 0L
    self.n54 = 0L
    self.n46 = 0L
    self.n45 = 0L
    self.n31 = 0L
    self.n23 = 0L
    self.n22 = 0L
    self.n248 = 0L
    self.n202 = 0L
    self.n201 = 0L
    self.n187 = 0L
    self.n178 = 0L
    self.n177 = 0L
    self.n164 = 0L
    self.n155 = 0L
    self.n154 = 0L
    self.n118 = 0L
    self.n72 = 0L
    self.n71 = 0L
    self.n57 = 0L
    self.n48 = 0L
    self.n47 = 0L
    self.n34 = 0L
    self.n25 = 0L
    self.n24 = 0L
    self.n239 = 0L
    self.n204 = 0L
    self.n203 = 0L
    self.n185 = 0L
    self.n180 = 0L
    self.n179 = 0L
    self.n162 = 0L
    self.n157 = 0L
    self.n156 = 0L
    self.n109 = 0L
    self.n74 = 0L
    self.n73 = 0L
    self.n55 = 0L
    self.n50 = 0L
    self.n49 = 0L
    self.n32 = 0L
    self.n27 = 0L
    self.n26 = 0L
    self.n206 = 0L
    self.n205 = 0L
    self.n181 = 0L
    self.n158 = 0L
    self.n76 = 0L
    self.n75 = 0L
    self.n51 = 0L
    self.n28 = 0L
    self.n240 = 0L
    self.n208 = 0L
    self.n207 = 0L
    self.n186 = 0L
    self.n163 = 0L
    self.n110 = 0L
    self.n78 = 0L
    self.n77 = 0L
    self.n56 = 0L
    self.n33 = 0L
    self.n249 = 0L
    self.n210 = 0L
    self.n209 = 0L
    self.n188 = 0L
    self.n165 = 0L
    self.n119 = 0L
    self.n80 = 0L
    self.n79 = 0L
    self.n58 = 0L
    self.n35 = 0L
    self.n254 = 0L
    self.n241 = 0L
    self.n212 = 0L
    self.n211 = 0L
    self.n189 = 0L
    self.n166 = 0L
    self.n124 = 0L
    self.n111 = 0L
    self.n82 = 0L
    self.n81 = 0L
    self.n59 = 0L
    self.n36 = 0L
    self.n264 = 0L
    self.n261 = 0L
    self.n214 = 0L
    self.n213 = 0L
    self.n190 = 0L
    self.n134 = 0L
    self.n131 = 0L
    self.n84 = 0L
    self.n83 = 0L
    self.n60 = 0L
    self.n242 = 0L
    self.n216 = 0L
    self.n215 = 0L
    self.n112 = 0L
    self.n86 = 0L
    self.n85 = 0L
    self.n250 = 0L
    self.n218 = 0L
    self.n217 = 0L
    self.n120 = 0L
    self.n88 = 0L
    self.n87 = 0L
    self.n243 = 0L
    self.n220 = 0L
    self.n219 = 0L
    self.n113 = 0L
    self.n90 = 0L
    self.n89 = 0L
    self.n222 = 0L
    self.n221 = 0L
    self.n92 = 0L
    self.n91 = 0L
    self.n244 = 0L
    self.n224 = 0L
    self.n223 = 0L
    self.n114 = 0L
    self.n94 = 0L
    self.n93 = 0L
    self.n251 = 0L
    self.n226 = 0L
    self.n225 = 0L
    self.n121 = 0L
    self.n96 = 0L
    self.n95 = 0L
    self.n255 = 0L
    self.n245 = 0L
    self.n228 = 0L
    self.n227 = 0L
    self.n125 = 0L
    self.n115 = 0L
    self.n98 = 0L
    self.n97 = 0L
    self.n257 = 0L
    self.n230 = 0L
    self.n229 = 0L
    self.n127 = 0L
    self.n100 = 0L
    self.n99 = 0L
    self.n246 = 0L
    self.n232 = 0L
    self.n231 = 0L
    self.n116 = 0L
    self.n102 = 0L
    self.n101 = 0L
    self.n252 = 0L
    self.n234 = 0L
    self.n233 = 0L
    self.n122 = 0L
    self.n104 = 0L
    self.n103 = 0L
    self.n247 = 0L
    self.n235 = 0L
    self.n117 = 0L
    self.n105 = 0L
    self.n253 = 0L
    self.n123 = 0L
    self.n256 = 0L
    self.n126 = 0L
    self.n258 = 0L
    self.n128 = 0L
    self.n259 = 0L
    self.n129 = 0L
    self.n269 = 0L
    self.n268 = 0L
    self.n267 = 0L
    self.n265 = 0L
    self.n139 = 0L
    self.n138 = 0L
    self.n137 = 0L
    self.n135 = 0L
    self.n278 = 0L
    self.n277 = 0L
    self.n275 = 0L
    self.n274 = 0L
    self.n270 = 0L
    self.n266 = 0L
    self.n140 = 0L
    self.n136 = 0L
    self.n1142 = 0L
    self.n291 = 0L
    self.n289 = 0L
    self.n276 = 0L
    self.n272 = 0L
    self.n271 = 0L
    self.n1143 = 0L
    self.n292 = 0L
    self.n290 = 0L
    self.n273 = 0L
    self.n1144 = 0L
    self.n293 = 0L
    self.n1179 = 0L
    self.n1177 = 0L
    self.n1175 = 0L
    self.n1173 = 0L
    self.n1171 = 0L
    self.n1169 = 0L
    self.n1167 = 0L
    self.n1165 = 0L
    self.n1163 = 0L
    self.n1161 = 0L
    self.n1159 = 0L
    self.n1157 = 0L
    self.n1155 = 0L
    self.n1153 = 0L
    self.n1151 = 0L
    self.n299 = 0L
    self.n298 = 0L
    self.n294 = 0L
    self.n1180 = 0L
    self.n300 = 0L
    self.n297 = 0L
    self.n1181 = 0L
    self.n335 = 0L
    self.n334 = 0L
    self.n332 = 0L
    self.n303 = 0L
    self.n302 = 0L
    self.n301 = 0L
    self.n1182 = 0L
    self.n305 = 0L
    self.n304 = 0L
    self.n1183 = 0L
    self.n320 = 0L
    self.n307 = 0L
    self.n306 = 0L
    self.n1184 = 0L
    self.n309 = 0L
    self.n308 = 0L
    self.n1185 = 0L
    self.n321 = 0L
    self.n311 = 0L
    self.n310 = 0L
    self.n1186 = 0L
    self.n324 = 0L
    self.n313 = 0L
    self.n312 = 0L
    self.n1187 = 0L
    self.n322 = 0L
    self.n315 = 0L
    self.n314 = 0L
    self.n1188 = 0L
    self.n317 = 0L
    self.n316 = 0L
    self.n1189 = 0L
    self.n323 = 0L
    self.n318 = 0L
    self.n1190 = 0L
    self.n325 = 0L
    self.n1191 = 0L
    self.n326 = 0L
    self.n1192 = 0L
    self.n327 = 0L
    self.n1193 = 0L
    self.n328 = 0L
    self.n1194 = 0L
    self.n329 = 0L
    self.n1196 = 0L
    self.n1195 = 0L
    self.n330 = 0L
    self.n1200 = 0L
    self.n1199 = 0L
    self.n1198 = 0L
    self.n336 = 0L
    self.n333 = 0L
    self.n1203 = 0L
    self.n371 = 0L
    self.n370 = 0L
    self.n368 = 0L
    self.n339 = 0L
    self.n338 = 0L
    self.n337 = 0L
    self.n341 = 0L
    self.n340 = 0L
    self.n356 = 0L
    self.n343 = 0L
    self.n342 = 0L
    self.n345 = 0L
    self.n344 = 0L
    self.n357 = 0L
    self.n347 = 0L
    self.n346 = 0L
    self.n360 = 0L
    self.n349 = 0L
    self.n348 = 0L
    self.n358 = 0L
    self.n351 = 0L
    self.n350 = 0L
    self.n353 = 0L
    self.n352 = 0L
    self.n359 = 0L
    self.n354 = 0L
    self.n361 = 0L
    self.n362 = 0L
    self.n363 = 0L
    self.n364 = 0L
    self.n365 = 0L
    self.n366 = 0L
    self.n372 = 0L
    self.n369 = 0L
    self.n407 = 0L
    self.n406 = 0L
    self.n404 = 0L
    self.n375 = 0L
    self.n374 = 0L
    self.n373 = 0L
    self.n377 = 0L
    self.n376 = 0L
    self.n392 = 0L
    self.n379 = 0L
    self.n378 = 0L
    self.n381 = 0L
    self.n380 = 0L
    self.n393 = 0L
    self.n383 = 0L
    self.n382 = 0L
    self.n396 = 0L
    self.n385 = 0L
    self.n384 = 0L
    self.n394 = 0L
    self.n387 = 0L
    self.n386 = 0L
    self.n389 = 0L
    self.n388 = 0L
    self.n395 = 0L
    self.n390 = 0L
    self.n397 = 0L
    self.n398 = 0L
    self.n399 = 0L
    self.n400 = 0L
    self.n401 = 0L
    self.n402 = 0L
    self.n408 = 0L
    self.n405 = 0L
    self.n443 = 0L
    self.n442 = 0L
    self.n440 = 0L
    self.n411 = 0L
    self.n410 = 0L
    self.n409 = 0L
    self.n413 = 0L
    self.n412 = 0L
    self.n428 = 0L
    self.n415 = 0L
    self.n414 = 0L
    self.n417 = 0L
    self.n416 = 0L
    self.n429 = 0L
    self.n419 = 0L
    self.n418 = 0L
    self.n432 = 0L
    self.n421 = 0L
    self.n420 = 0L
    self.n430 = 0L
    self.n423 = 0L
    self.n422 = 0L
    self.n425 = 0L
    self.n424 = 0L
    self.n431 = 0L
    self.n426 = 0L
    self.n433 = 0L
    self.n434 = 0L
    self.n435 = 0L
    self.n436 = 0L
    self.n437 = 0L
    self.n438 = 0L
    self.n444 = 0L
    self.n441 = 0L
    self.n479 = 0L
    self.n478 = 0L
    self.n476 = 0L
    self.n447 = 0L
    self.n446 = 0L
    self.n445 = 0L
    self.n449 = 0L
    self.n448 = 0L
    self.n464 = 0L
    self.n451 = 0L
    self.n450 = 0L
    self.n453 = 0L
    self.n452 = 0L
    self.n465 = 0L
    self.n455 = 0L
    self.n454 = 0L
    self.n468 = 0L
    self.n457 = 0L
    self.n456 = 0L
    self.n466 = 0L
    self.n459 = 0L
    self.n458 = 0L
    self.n461 = 0L
    self.n460 = 0L
    self.n467 = 0L
    self.n462 = 0L
    self.n469 = 0L
    self.n470 = 0L
    self.n471 = 0L
    self.n472 = 0L
    self.n473 = 0L
    self.n474 = 0L
    self.n480 = 0L
    self.n477 = 0L
    self.n515 = 0L
    self.n514 = 0L
    self.n512 = 0L
    self.n483 = 0L
    self.n482 = 0L
    self.n481 = 0L
    self.n485 = 0L
    self.n484 = 0L
    self.n500 = 0L
    self.n487 = 0L
    self.n486 = 0L
    self.n489 = 0L
    self.n488 = 0L
    self.n501 = 0L
    self.n491 = 0L
    self.n490 = 0L
    self.n504 = 0L
    self.n493 = 0L
    self.n492 = 0L
    self.n502 = 0L
    self.n495 = 0L
    self.n494 = 0L
    self.n497 = 0L
    self.n496 = 0L
    self.n503 = 0L
    self.n498 = 0L
    self.n505 = 0L
    self.n506 = 0L
    self.n507 = 0L
    self.n508 = 0L
    self.n509 = 0L
    self.n510 = 0L
    self.n516 = 0L
    self.n513 = 0L
    self.n551 = 0L
    self.n550 = 0L
    self.n548 = 0L
    self.n519 = 0L
    self.n518 = 0L
    self.n517 = 0L
    self.n521 = 0L
    self.n520 = 0L
    self.n536 = 0L
    self.n523 = 0L
    self.n522 = 0L
    self.n525 = 0L
    self.n524 = 0L
    self.n537 = 0L
    self.n527 = 0L
    self.n526 = 0L
    self.n540 = 0L
    self.n529 = 0L
    self.n528 = 0L
    self.n538 = 0L
    self.n531 = 0L
    self.n530 = 0L
    self.n533 = 0L
    self.n532 = 0L
    self.n539 = 0L
    self.n534 = 0L
    self.n541 = 0L
    self.n542 = 0L
    self.n543 = 0L
    self.n544 = 0L
    self.n545 = 0L
    self.n546 = 0L
    self.n552 = 0L
    self.n549 = 0L
    self.n587 = 0L
    self.n586 = 0L
    self.n584 = 0L
    self.n555 = 0L
    self.n554 = 0L
    self.n553 = 0L
    self.n557 = 0L
    self.n556 = 0L
    self.n572 = 0L
    self.n559 = 0L
    self.n558 = 0L
    self.n561 = 0L
    self.n560 = 0L
    self.n573 = 0L
    self.n563 = 0L
    self.n562 = 0L
    self.n576 = 0L
    self.n565 = 0L
    self.n564 = 0L
    self.n574 = 0L
    self.n567 = 0L
    self.n566 = 0L
    self.n569 = 0L
    self.n568 = 0L
    self.n575 = 0L
    self.n570 = 0L
    self.n577 = 0L
    self.n578 = 0L
    self.n579 = 0L
    self.n580 = 0L
    self.n581 = 0L
    self.n582 = 0L
    self.n588 = 0L
    self.n585 = 0L
    self.n623 = 0L
    self.n622 = 0L
    self.n620 = 0L
    self.n591 = 0L
    self.n590 = 0L
    self.n589 = 0L
    self.n593 = 0L
    self.n592 = 0L
    self.n608 = 0L
    self.n595 = 0L
    self.n594 = 0L
    self.n597 = 0L
    self.n596 = 0L
    self.n609 = 0L
    self.n599 = 0L
    self.n598 = 0L
    self.n612 = 0L
    self.n601 = 0L
    self.n600 = 0L
    self.n610 = 0L
    self.n603 = 0L
    self.n602 = 0L
    self.n605 = 0L
    self.n604 = 0L
    self.n611 = 0L
    self.n606 = 0L
    self.n613 = 0L
    self.n614 = 0L
    self.n615 = 0L
    self.n616 = 0L
    self.n617 = 0L
    self.n618 = 0L
    self.n624 = 0L
    self.n621 = 0L
    self.n659 = 0L
    self.n658 = 0L
    self.n656 = 0L
    self.n627 = 0L
    self.n626 = 0L
    self.n625 = 0L
    self.n629 = 0L
    self.n628 = 0L
    self.n644 = 0L
    self.n631 = 0L
    self.n630 = 0L
    self.n633 = 0L
    self.n632 = 0L
    self.n645 = 0L
    self.n635 = 0L
    self.n634 = 0L
    self.n648 = 0L
    self.n637 = 0L
    self.n636 = 0L
    self.n646 = 0L
    self.n639 = 0L
    self.n638 = 0L
    self.n641 = 0L
    self.n640 = 0L
    self.n647 = 0L
    self.n642 = 0L
    self.n649 = 0L
    self.n650 = 0L
    self.n651 = 0L
    self.n652 = 0L
    self.n653 = 0L
    self.n654 = 0L
    self.n660 = 0L
    self.n657 = 0L
    self.n695 = 0L
    self.n694 = 0L
    self.n692 = 0L
    self.n663 = 0L
    self.n662 = 0L
    self.n661 = 0L
    self.n665 = 0L
    self.n664 = 0L
    self.n680 = 0L
    self.n667 = 0L
    self.n666 = 0L
    self.n669 = 0L
    self.n668 = 0L
    self.n681 = 0L
    self.n671 = 0L
    self.n670 = 0L
    self.n684 = 0L
    self.n673 = 0L
    self.n672 = 0L
    self.n682 = 0L
    self.n675 = 0L
    self.n674 = 0L
    self.n677 = 0L
    self.n676 = 0L
    self.n683 = 0L
    self.n678 = 0L
    self.n685 = 0L
    self.n686 = 0L
    self.n687 = 0L
    self.n688 = 0L
    self.n689 = 0L
    self.n690 = 0L
    self.n696 = 0L
    self.n693 = 0L
    self.n731 = 0L
    self.n730 = 0L
    self.n728 = 0L
    self.n699 = 0L
    self.n698 = 0L
    self.n697 = 0L
    self.n701 = 0L
    self.n700 = 0L
    self.n716 = 0L
    self.n703 = 0L
    self.n702 = 0L
    self.n705 = 0L
    self.n704 = 0L
    self.n717 = 0L
    self.n707 = 0L
    self.n706 = 0L
    self.n720 = 0L
    self.n709 = 0L
    self.n708 = 0L
    self.n718 = 0L
    self.n711 = 0L
    self.n710 = 0L
    self.n713 = 0L
    self.n712 = 0L
    self.n719 = 0L
    self.n714 = 0L
    self.n721 = 0L
    self.n722 = 0L
    self.n723 = 0L
    self.n724 = 0L
    self.n725 = 0L
    self.n726 = 0L
    self.n732 = 0L
    self.n729 = 0L
    self.n767 = 0L
    self.n766 = 0L
    self.n764 = 0L
    self.n735 = 0L
    self.n734 = 0L
    self.n733 = 0L
    self.n737 = 0L
    self.n736 = 0L
    self.n752 = 0L
    self.n739 = 0L
    self.n738 = 0L
    self.n741 = 0L
    self.n740 = 0L
    self.n753 = 0L
    self.n743 = 0L
    self.n742 = 0L
    self.n756 = 0L
    self.n745 = 0L
    self.n744 = 0L
    self.n754 = 0L
    self.n747 = 0L
    self.n746 = 0L
    self.n749 = 0L
    self.n748 = 0L
    self.n755 = 0L
    self.n750 = 0L
    self.n757 = 0L
    self.n758 = 0L
    self.n759 = 0L
    self.n760 = 0L
    self.n761 = 0L
    self.n762 = 0L
    self.n768 = 0L
    self.n765 = 0L
    self.n803 = 0L
    self.n802 = 0L
    self.n800 = 0L
    self.n771 = 0L
    self.n770 = 0L
    self.n769 = 0L
    self.n773 = 0L
    self.n772 = 0L
    self.n788 = 0L
    self.n775 = 0L
    self.n774 = 0L
    self.n777 = 0L
    self.n776 = 0L
    self.n789 = 0L
    self.n779 = 0L
    self.n778 = 0L
    self.n792 = 0L
    self.n781 = 0L
    self.n780 = 0L
    self.n790 = 0L
    self.n783 = 0L
    self.n782 = 0L
    self.n785 = 0L
    self.n784 = 0L
    self.n791 = 0L
    self.n786 = 0L
    self.n793 = 0L
    self.n794 = 0L
    self.n795 = 0L
    self.n796 = 0L
    self.n797 = 0L
    self.n798 = 0L
    self.n804 = 0L
    self.n801 = 0L
    self.n839 = 0L
    self.n838 = 0L
    self.n836 = 0L
    self.n807 = 0L
    self.n806 = 0L
    self.n805 = 0L
    self.n809 = 0L
    self.n808 = 0L
    self.n824 = 0L
    self.n811 = 0L
    self.n810 = 0L
    self.n813 = 0L
    self.n812 = 0L
    self.n825 = 0L
    self.n815 = 0L
    self.n814 = 0L
    self.n828 = 0L
    self.n817 = 0L
    self.n816 = 0L
    self.n826 = 0L
    self.n819 = 0L
    self.n818 = 0L
    self.n821 = 0L
    self.n820 = 0L
    self.n827 = 0L
    self.n822 = 0L
    self.n829 = 0L
    self.n830 = 0L
    self.n831 = 0L
    self.n832 = 0L
    self.n833 = 0L
    self.n834 = 0L
    self.n840 = 0L
    self.n837 = 0L
    self.n875 = 0L
    self.n874 = 0L
    self.n872 = 0L
    self.n843 = 0L
    self.n842 = 0L
    self.n841 = 0L
    self.n845 = 0L
    self.n844 = 0L
    self.n860 = 0L
    self.n847 = 0L
    self.n846 = 0L
    self.n849 = 0L
    self.n848 = 0L
    self.n861 = 0L
    self.n851 = 0L
    self.n850 = 0L
    self.n864 = 0L
    self.n853 = 0L
    self.n852 = 0L
    self.n862 = 0L
    self.n855 = 0L
    self.n854 = 0L
    self.n857 = 0L
    self.n856 = 0L
    self.n863 = 0L
    self.n858 = 0L
    self.n865 = 0L
    self.n866 = 0L
    self.n867 = 0L
    self.n868 = 0L
    self.n869 = 0L
    self.n870 = 0L
    self.n876 = 0L
    self.n873 = 0L
    self.n911 = 0L
    self.n910 = 0L
    self.n908 = 0L
    self.n879 = 0L
    self.n878 = 0L
    self.n877 = 0L
    self.n881 = 0L
    self.n880 = 0L
    self.n896 = 0L
    self.n883 = 0L
    self.n882 = 0L
    self.n885 = 0L
    self.n884 = 0L
    self.n897 = 0L
    self.n887 = 0L
    self.n886 = 0L
    self.n900 = 0L
    self.n889 = 0L
    self.n888 = 0L
    self.n898 = 0L
    self.n891 = 0L
    self.n890 = 0L
    self.n893 = 0L
    self.n892 = 0L
    self.n899 = 0L
    self.n894 = 0L
    self.n901 = 0L
    self.n902 = 0L
    self.n903 = 0L
    self.n904 = 0L
    self.n905 = 0L
    self.n906 = 0L
    self.n912 = 0L
    self.n909 = 0L
    self.n947 = 0L
    self.n946 = 0L
    self.n944 = 0L
    self.n915 = 0L
    self.n914 = 0L
    self.n913 = 0L
    self.n917 = 0L
    self.n916 = 0L
    self.n932 = 0L
    self.n919 = 0L
    self.n918 = 0L
    self.n921 = 0L
    self.n920 = 0L
    self.n933 = 0L
    self.n923 = 0L
    self.n922 = 0L
    self.n936 = 0L
    self.n925 = 0L
    self.n924 = 0L
    self.n934 = 0L
    self.n927 = 0L
    self.n926 = 0L
    self.n929 = 0L
    self.n928 = 0L
    self.n935 = 0L
    self.n930 = 0L
    self.n937 = 0L
    self.n938 = 0L
    self.n939 = 0L
    self.n940 = 0L
    self.n941 = 0L
    self.n942 = 0L
    self.n948 = 0L
    self.n945 = 0L
    self.n983 = 0L
    self.n982 = 0L
    self.n980 = 0L
    self.n951 = 0L
    self.n950 = 0L
    self.n949 = 0L
    self.n953 = 0L
    self.n952 = 0L
    self.n968 = 0L
    self.n955 = 0L
    self.n954 = 0L
    self.n957 = 0L
    self.n956 = 0L
    self.n969 = 0L
    self.n959 = 0L
    self.n958 = 0L
    self.n972 = 0L
    self.n961 = 0L
    self.n960 = 0L
    self.n970 = 0L
    self.n963 = 0L
    self.n962 = 0L
    self.n965 = 0L
    self.n964 = 0L
    self.n971 = 0L
    self.n966 = 0L
    self.n973 = 0L
    self.n974 = 0L
    self.n975 = 0L
    self.n976 = 0L
    self.n977 = 0L
    self.n978 = 0L
    self.n984 = 0L
    self.n981 = 0L
    self.n1019 = 0L
    self.n1018 = 0L
    self.n1016 = 0L
    self.n987 = 0L
    self.n986 = 0L
    self.n985 = 0L
    self.n989 = 0L
    self.n988 = 0L
    self.n1004 = 0L
    self.n991 = 0L
    self.n990 = 0L
    self.n993 = 0L
    self.n992 = 0L
    self.n1005 = 0L
    self.n995 = 0L
    self.n994 = 0L
    self.n1008 = 0L
    self.n997 = 0L
    self.n996 = 0L
    self.n1006 = 0L
    self.n999 = 0L
    self.n998 = 0L
    self.n1001 = 0L
    self.n1000 = 0L
    self.n1007 = 0L
    self.n1002 = 0L
    self.n1009 = 0L
    self.n1010 = 0L
    self.n1011 = 0L
    self.n1012 = 0L
    self.n1013 = 0L
    self.n1014 = 0L
    self.n1020 = 0L
    self.n1017 = 0L
    self.n1055 = 0L
    self.n1054 = 0L
    self.n1052 = 0L
    self.n1023 = 0L
    self.n1022 = 0L
    self.n1021 = 0L
    self.n1025 = 0L
    self.n1024 = 0L
    self.n1040 = 0L
    self.n1027 = 0L
    self.n1026 = 0L
    self.n1029 = 0L
    self.n1028 = 0L
    self.n1041 = 0L
    self.n1031 = 0L
    self.n1030 = 0L
    self.n1044 = 0L
    self.n1033 = 0L
    self.n1032 = 0L
    self.n1042 = 0L
    self.n1035 = 0L
    self.n1034 = 0L
    self.n1037 = 0L
    self.n1036 = 0L
    self.n1043 = 0L
    self.n1038 = 0L
    self.n1045 = 0L
    self.n1046 = 0L
    self.n1047 = 0L
    self.n1048 = 0L
    self.n1049 = 0L
    self.n1050 = 0L
    self.n1056 = 0L
    self.n1053 = 0L
    self.n1091 = 0L
    self.n1090 = 0L
    self.n1088 = 0L
    self.n1059 = 0L
    self.n1058 = 0L
    self.n1057 = 0L
    self.n1061 = 0L
    self.n1060 = 0L
    self.n1076 = 0L
    self.n1063 = 0L
    self.n1062 = 0L
    self.n1065 = 0L
    self.n1064 = 0L
    self.n1077 = 0L
    self.n1067 = 0L
    self.n1066 = 0L
    self.n1080 = 0L
    self.n1069 = 0L
    self.n1068 = 0L
    self.n1078 = 0L
    self.n1071 = 0L
    self.n1070 = 0L
    self.n1073 = 0L
    self.n1072 = 0L
    self.n1079 = 0L
    self.n1074 = 0L
    self.n1081 = 0L
    self.n1082 = 0L
    self.n1083 = 0L
    self.n1084 = 0L
    self.n1085 = 0L
    self.n1086 = 0L
    self.n1092 = 0L
    self.n1089 = 0L
    self.n1127 = 0L
    self.n1126 = 0L
    self.n1124 = 0L
    self.n1095 = 0L
    self.n1094 = 0L
    self.n1093 = 0L
    self.n1097 = 0L
    self.n1096 = 0L
    self.n1112 = 0L
    self.n1099 = 0L
    self.n1098 = 0L
    self.n1101 = 0L
    self.n1100 = 0L
    self.n1113 = 0L
    self.n1103 = 0L
    self.n1102 = 0L
    self.n1116 = 0L
    self.n1105 = 0L
    self.n1104 = 0L
    self.n1114 = 0L
    self.n1107 = 0L
    self.n1106 = 0L
    self.n1109 = 0L
    self.n1108 = 0L
    self.n1115 = 0L
    self.n1110 = 0L
    self.n1117 = 0L
    self.n1118 = 0L
    self.n1119 = 0L
    self.n1120 = 0L
    self.n1121 = 0L
    self.n1122 = 0L
    self.n1128 = 0L
    self.n1125 = 0L
    self.n1130 = 0L
    self.n1129 = 0L
    self.n1131 = 0L
    self.n1197 = 0L
    self.n1201 = 0L
    self.n1204 = 0L
    self.n1205 = 0L
    self.n1206 = 0L
    self.calc(0L, 0L, )

  def calc(self, a_i, b_i, ):
    self.n1213 = 0x7FBFFFFFL
    self.n1211 = 0x7FFFFFFFL
    self.n1209 = 0x7F800000L
    self.n1207 = 0x07FL
    self.n1178 = 0x1L
    self.n1176 = 0x3L
    self.n1174 = 0x2L
    self.n1172 = 0x7L
    self.n1170 = 0x6L
    self.n1168 = 0x5L
    self.n1166 = 0x4L
    self.n1164 = 0xFL
    self.n1162 = 0xEL
    self.n1160 = 0xDL
    self.n1158 = 0xCL
    self.n1156 = 0xBL
    self.n1154 = 0xAL
    self.n1152 = 0x9L
    self.n1150 = 0x8L
    self.n1149 = 0x4L
    self.n1148 = 0x3L
    self.n1147 = 0x2L
    self.n1146 = 0x1L
    self.n1145 = 0x0L
    self.n1132 = 0x00000000L
    self.n1123 = 0x001L
    self.n1087 = 0x001L
    self.n1051 = 0x001L
    self.n1015 = 0x001L
    self.n979 = 0x001L
    self.n943 = 0x001L
    self.n907 = 0x001L
    self.n871 = 0x001L
    self.n835 = 0x001L
    self.n799 = 0x001L
    self.n763 = 0x001L
    self.n727 = 0x001L
    self.n691 = 0x001L
    self.n655 = 0x001L
    self.n619 = 0x001L
    self.n583 = 0x001L
    self.n547 = 0x001L
    self.n511 = 0x001L
    self.n475 = 0x001L
    self.n439 = 0x001L
    self.n403 = 0x001L
    self.n367 = 0x001L
    self.n331 = 0x001L
    self.n295 = 0x001L
    self.n282 = 0x0L
    self.n280 = 0x0L
    self.n4 = b_i
    self.n3 = a_i
    self.n143 = (self.n4 & 0x400000L) | (self.n4 & 0x200000L) | (self.n4 & 0x100000L) | (self.n4 & 0x80000L) | (self.n4 & 0x40000L) | (self.n4 & 0x20000L) | (self.n4 & 0x10000L) | (self.n4 & 0x8000L) | (self.n4 & 0x4000L) | (self.n4 & 0x2000L) | (self.n4 & 0x1000L) | (self.n4 & 0x800L) | (self.n4 & 0x400L) | (self.n4 & 0x200L) | (self.n4 & 0x100L) | (self.n4 & 0x80L) | (self.n4 & 0x40L) | (self.n4 & 0x20L) | (self.n4 & 0x10L) | (self.n4 & 0x8L) | (self.n4 & 0x4L) | (self.n4 & 0x2L) | (self.n4 & 0x1L)
    self.n142 = ((self.n4 & 0x40000000L) >> 23) | ((self.n4 & 0x20000000L) >> 23) | ((self.n4 & 0x10000000L) >> 23) | ((self.n4 & 0x8000000L) >> 23) | ((self.n4 & 0x4000000L) >> 23) | ((self.n4 & 0x2000000L) >> 23) | ((self.n4 & 0x1000000L) >> 23) | ((self.n4 & 0x800000L) >> 23)
    self.n13 = (self.n3 & 0x400000L) | (self.n3 & 0x200000L) | (self.n3 & 0x100000L) | (self.n3 & 0x80000L) | (self.n3 & 0x40000L) | (self.n3 & 0x20000L) | (self.n3 & 0x10000L) | (self.n3 & 0x8000L) | (self.n3 & 0x4000L) | (self.n3 & 0x2000L) | (self.n3 & 0x1000L) | (self.n3 & 0x800L) | (self.n3 & 0x400L) | (self.n3 & 0x200L) | (self.n3 & 0x100L) | (self.n3 & 0x80L) | (self.n3 & 0x40L) | (self.n3 & 0x20L) | (self.n3 & 0x10L) | (self.n3 & 0x8L) | (self.n3 & 0x4L) | (self.n3 & 0x2L) | (self.n3 & 0x1L)
    self.n12 = ((self.n3 & 0x40000000L) >> 23) | ((self.n3 & 0x20000000L) >> 23) | ((self.n3 & 0x10000000L) >> 23) | ((self.n3 & 0x8000000L) >> 23) | ((self.n3 & 0x4000000L) >> 23) | ((self.n3 & 0x2000000L) >> 23) | ((self.n3 & 0x1000000L) >> 23) | ((self.n3 & 0x800000L) >> 23)
    self.n10 = (self.n4 & 0x400000L) | (self.n4 & 0x200000L) | (self.n4 & 0x100000L) | (self.n4 & 0x80000L) | (self.n4 & 0x40000L) | (self.n4 & 0x20000L) | (self.n4 & 0x10000L) | (self.n4 & 0x8000L) | (self.n4 & 0x4000L) | (self.n4 & 0x2000L) | (self.n4 & 0x1000L) | (self.n4 & 0x800L) | (self.n4 & 0x400L) | (self.n4 & 0x200L) | (self.n4 & 0x100L) | (self.n4 & 0x80L) | (self.n4 & 0x40L) | (self.n4 & 0x20L) | (self.n4 & 0x10L) | (self.n4 & 0x8L) | (self.n4 & 0x4L) | (self.n4 & 0x2L) | (self.n4 & 0x1L)
    self.n9 = ((self.n4 & 0x40000000L) >> 23) | ((self.n4 & 0x20000000L) >> 23) | ((self.n4 & 0x10000000L) >> 23) | ((self.n4 & 0x8000000L) >> 23) | ((self.n4 & 0x4000000L) >> 23) | ((self.n4 & 0x2000000L) >> 23) | ((self.n4 & 0x1000000L) >> 23) | ((self.n4 & 0x800000L) >> 23)
    self.n8 = ((self.n4 & 0x80000000L) >> 31)
    self.n7 = (self.n3 & 0x400000L) | (self.n3 & 0x200000L) | (self.n3 & 0x100000L) | (self.n3 & 0x80000L) | (self.n3 & 0x40000L) | (self.n3 & 0x20000L) | (self.n3 & 0x10000L) | (self.n3 & 0x8000L) | (self.n3 & 0x4000L) | (self.n3 & 0x2000L) | (self.n3 & 0x1000L) | (self.n3 & 0x800L) | (self.n3 & 0x400L) | (self.n3 & 0x200L) | (self.n3 & 0x100L) | (self.n3 & 0x80L) | (self.n3 & 0x40L) | (self.n3 & 0x20L) | (self.n3 & 0x10L) | (self.n3 & 0x8L) | (self.n3 & 0x4L) | (self.n3 & 0x2L) | (self.n3 & 0x1L)
    self.n6 = ((self.n3 & 0x40000000L) >> 23) | ((self.n3 & 0x20000000L) >> 23) | ((self.n3 & 0x10000000L) >> 23) | ((self.n3 & 0x8000000L) >> 23) | ((self.n3 & 0x4000000L) >> 23) | ((self.n3 & 0x2000000L) >> 23) | ((self.n3 & 0x1000000L) >> 23) | ((self.n3 & 0x800000L) >> 23)
    self.n5 = ((self.n3 & 0x80000000L) >> 31)
    self.n283 = self.n282 << 8 | self.n9
    self.n281 = self.n280 << 8 | self.n6
    self.n279 = self.n5 ^ self.n8
    self.n262 = ((self.n143 & 0x400000L) >> 22)
    self.n260 = ((self.n143 & 0x400000L) >> 22)
    self.n192 = (self.n143 & 0x200000L) | (self.n143 & 0x100000L) | (self.n143 & 0x80000L) | (self.n143 & 0x40000L) | (self.n143 & 0x20000L) | (self.n143 & 0x10000L) | (self.n143 & 0x8000L) | (self.n143 & 0x4000L) | (self.n143 & 0x2000L) | (self.n143 & 0x1000L) | (self.n143 & 0x800L) | (self.n143 & 0x400L) | (self.n143 & 0x200L) | (self.n143 & 0x100L) | (self.n143 & 0x80L) | (self.n143 & 0x40L) | (self.n143 & 0x20L) | (self.n143 & 0x10L) | (self.n143 & 0x8L) | (self.n143 & 0x4L) | (self.n143 & 0x2L) | (self.n143 & 0x1L)
    self.n191 = ((self.n143 & 0x400000L) >> 22)
    self.n168 = (self.n142 & 0x40L) | (self.n142 & 0x20L) | (self.n142 & 0x10L) | (self.n142 & 0x8L) | (self.n142 & 0x4L) | (self.n142 & 0x2L) | (self.n142 & 0x1L)
    self.n167 = ((self.n142 & 0x80L) >> 7)
    self.n145 = (self.n142 & 0x40L) | (self.n142 & 0x20L) | (self.n142 & 0x10L) | (self.n142 & 0x8L) | (self.n142 & 0x4L) | (self.n142 & 0x2L) | (self.n142 & 0x1L)
    self.n144 = ((self.n142 & 0x80L) >> 7)
    self.n132 = ((self.n13 & 0x400000L) >> 22)
    self.n130 = ((self.n13 & 0x400000L) >> 22)
    self.n62 = (self.n13 & 0x200000L) | (self.n13 & 0x100000L) | (self.n13 & 0x80000L) | (self.n13 & 0x40000L) | (self.n13 & 0x20000L) | (self.n13 & 0x10000L) | (self.n13 & 0x8000L) | (self.n13 & 0x4000L) | (self.n13 & 0x2000L) | (self.n13 & 0x1000L) | (self.n13 & 0x800L) | (self.n13 & 0x400L) | (self.n13 & 0x200L) | (self.n13 & 0x100L) | (self.n13 & 0x80L) | (self.n13 & 0x40L) | (self.n13 & 0x20L) | (self.n13 & 0x10L) | (self.n13 & 0x8L) | (self.n13 & 0x4L) | (self.n13 & 0x2L) | (self.n13 & 0x1L)
    self.n61 = ((self.n13 & 0x400000L) >> 22)
    self.n38 = (self.n12 & 0x40L) | (self.n12 & 0x20L) | (self.n12 & 0x10L) | (self.n12 & 0x8L) | (self.n12 & 0x4L) | (self.n12 & 0x2L) | (self.n12 & 0x1L)
    self.n37 = ((self.n12 & 0x80L) >> 7)
    self.n15 = (self.n12 & 0x40L) | (self.n12 & 0x20L) | (self.n12 & 0x10L) | (self.n12 & 0x8L) | (self.n12 & 0x4L) | (self.n12 & 0x2L) | (self.n12 & 0x1L)
    self.n14 = ((self.n12 & 0x80L) >> 7)
    self.n284 = (self.n281 + self.n283) & 0x1FFL
    self.n263 = ~self.n262 & 0x1L
    self.n194 = (self.n192 & 0x100000L) | (self.n192 & 0x80000L) | (self.n192 & 0x40000L) | (self.n192 & 0x20000L) | (self.n192 & 0x10000L) | (self.n192 & 0x8000L) | (self.n192 & 0x4000L) | (self.n192 & 0x2000L) | (self.n192 & 0x1000L) | (self.n192 & 0x800L) | (self.n192 & 0x400L) | (self.n192 & 0x200L) | (self.n192 & 0x100L) | (self.n192 & 0x80L) | (self.n192 & 0x40L) | (self.n192 & 0x20L) | (self.n192 & 0x10L) | (self.n192 & 0x8L) | (self.n192 & 0x4L) | (self.n192 & 0x2L) | (self.n192 & 0x1L)
    self.n193 = ((self.n192 & 0x200000L) >> 21)
    self.n170 = (self.n168 & 0x20L) | (self.n168 & 0x10L) | (self.n168 & 0x8L) | (self.n168 & 0x4L) | (self.n168 & 0x2L) | (self.n168 & 0x1L)
    self.n169 = ((self.n168 & 0x40L) >> 6)
    self.n147 = (self.n145 & 0x20L) | (self.n145 & 0x10L) | (self.n145 & 0x8L) | (self.n145 & 0x4L) | (self.n145 & 0x2L) | (self.n145 & 0x1L)
    self.n146 = ((self.n145 & 0x40L) >> 6)
    self.n133 = ~self.n132 & 0x1L
    self.n64 = (self.n62 & 0x100000L) | (self.n62 & 0x80000L) | (self.n62 & 0x40000L) | (self.n62 & 0x20000L) | (self.n62 & 0x10000L) | (self.n62 & 0x8000L) | (self.n62 & 0x4000L) | (self.n62 & 0x2000L) | (self.n62 & 0x1000L) | (self.n62 & 0x800L) | (self.n62 & 0x400L) | (self.n62 & 0x200L) | (self.n62 & 0x100L) | (self.n62 & 0x80L) | (self.n62 & 0x40L) | (self.n62 & 0x20L) | (self.n62 & 0x10L) | (self.n62 & 0x8L) | (self.n62 & 0x4L) | (self.n62 & 0x2L) | (self.n62 & 0x1L)
    self.n63 = ((self.n62 & 0x200000L) >> 21)
    self.n40 = (self.n38 & 0x20L) | (self.n38 & 0x10L) | (self.n38 & 0x8L) | (self.n38 & 0x4L) | (self.n38 & 0x2L) | (self.n38 & 0x1L)
    self.n39 = ((self.n38 & 0x40L) >> 6)
    self.n17 = (self.n15 & 0x20L) | (self.n15 & 0x10L) | (self.n15 & 0x8L) | (self.n15 & 0x4L) | (self.n15 & 0x2L) | (self.n15 & 0x1L)
    self.n16 = ((self.n15 & 0x40L) >> 6)
    self.n288 = (self.n284 - self.n1207) & 0x1FFL
    self.n237 = self.n191 | self.n193
    self.n196 = (self.n194 & 0x80000L) | (self.n194 & 0x40000L) | (self.n194 & 0x20000L) | (self.n194 & 0x10000L) | (self.n194 & 0x8000L) | (self.n194 & 0x4000L) | (self.n194 & 0x2000L) | (self.n194 & 0x1000L) | (self.n194 & 0x800L) | (self.n194 & 0x400L) | (self.n194 & 0x200L) | (self.n194 & 0x100L) | (self.n194 & 0x80L) | (self.n194 & 0x40L) | (self.n194 & 0x20L) | (self.n194 & 0x10L) | (self.n194 & 0x8L) | (self.n194 & 0x4L) | (self.n194 & 0x2L) | (self.n194 & 0x1L)
    self.n195 = ((self.n194 & 0x100000L) >> 20)
    self.n183 = self.n167 | self.n169
    self.n172 = (self.n170 & 0x10L) | (self.n170 & 0x8L) | (self.n170 & 0x4L) | (self.n170 & 0x2L) | (self.n170 & 0x1L)
    self.n171 = ((self.n170 & 0x20L) >> 5)
    self.n160 = self.n144 & self.n146
    self.n149 = (self.n147 & 0x10L) | (self.n147 & 0x8L) | (self.n147 & 0x4L) | (self.n147 & 0x2L) | (self.n147 & 0x1L)
    self.n148 = ((self.n147 & 0x20L) >> 5)
    self.n107 = self.n61 | self.n63
    self.n66 = (self.n64 & 0x80000L) | (self.n64 & 0x40000L) | (self.n64 & 0x20000L) | (self.n64 & 0x10000L) | (self.n64 & 0x8000L) | (self.n64 & 0x4000L) | (self.n64 & 0x2000L) | (self.n64 & 0x1000L) | (self.n64 & 0x800L) | (self.n64 & 0x400L) | (self.n64 & 0x200L) | (self.n64 & 0x100L) | (self.n64 & 0x80L) | (self.n64 & 0x40L) | (self.n64 & 0x20L) | (self.n64 & 0x10L) | (self.n64 & 0x8L) | (self.n64 & 0x4L) | (self.n64 & 0x2L) | (self.n64 & 0x1L)
    self.n65 = ((self.n64 & 0x100000L) >> 20)
    self.n53 = self.n37 | self.n39
    self.n42 = (self.n40 & 0x10L) | (self.n40 & 0x8L) | (self.n40 & 0x4L) | (self.n40 & 0x2L) | (self.n40 & 0x1L)
    self.n41 = ((self.n40 & 0x20L) >> 5)
    self.n30 = self.n14 & self.n16
    self.n19 = (self.n17 & 0x10L) | (self.n17 & 0x8L) | (self.n17 & 0x4L) | (self.n17 & 0x2L) | (self.n17 & 0x1L)
    self.n18 = ((self.n17 & 0x20L) >> 5)
    self.n296 = (self.n288 + self.n295) & 0x1FFL
    self.n198 = (self.n196 & 0x40000L) | (self.n196 & 0x20000L) | (self.n196 & 0x10000L) | (self.n196 & 0x8000L) | (self.n196 & 0x4000L) | (self.n196 & 0x2000L) | (self.n196 & 0x1000L) | (self.n196 & 0x800L) | (self.n196 & 0x400L) | (self.n196 & 0x200L) | (self.n196 & 0x100L) | (self.n196 & 0x80L) | (self.n196 & 0x40L) | (self.n196 & 0x20L) | (self.n196 & 0x10L) | (self.n196 & 0x8L) | (self.n196 & 0x4L) | (self.n196 & 0x2L) | (self.n196 & 0x1L)
    self.n197 = ((self.n196 & 0x80000L) >> 19)
    self.n174 = (self.n172 & 0x8L) | (self.n172 & 0x4L) | (self.n172 & 0x2L) | (self.n172 & 0x1L)
    self.n173 = ((self.n172 & 0x10L) >> 4)
    self.n151 = (self.n149 & 0x8L) | (self.n149 & 0x4L) | (self.n149 & 0x2L) | (self.n149 & 0x1L)
    self.n150 = ((self.n149 & 0x10L) >> 4)
    self.n68 = (self.n66 & 0x40000L) | (self.n66 & 0x20000L) | (self.n66 & 0x10000L) | (self.n66 & 0x8000L) | (self.n66 & 0x4000L) | (self.n66 & 0x2000L) | (self.n66 & 0x1000L) | (self.n66 & 0x800L) | (self.n66 & 0x400L) | (self.n66 & 0x200L) | (self.n66 & 0x100L) | (self.n66 & 0x80L) | (self.n66 & 0x40L) | (self.n66 & 0x20L) | (self.n66 & 0x10L) | (self.n66 & 0x8L) | (self.n66 & 0x4L) | (self.n66 & 0x2L) | (self.n66 & 0x1L)
    self.n67 = ((self.n66 & 0x80000L) >> 19)
    self.n44 = (self.n42 & 0x8L) | (self.n42 & 0x4L) | (self.n42 & 0x2L) | (self.n42 & 0x1L)
    self.n43 = ((self.n42 & 0x10L) >> 4)
    self.n21 = (self.n19 & 0x8L) | (self.n19 & 0x4L) | (self.n19 & 0x2L) | (self.n19 & 0x1L)
    self.n20 = ((self.n19 & 0x10L) >> 4)
    self.n238 = self.n195 | self.n197
    self.n200 = (self.n198 & 0x20000L) | (self.n198 & 0x10000L) | (self.n198 & 0x8000L) | (self.n198 & 0x4000L) | (self.n198 & 0x2000L) | (self.n198 & 0x1000L) | (self.n198 & 0x800L) | (self.n198 & 0x400L) | (self.n198 & 0x200L) | (self.n198 & 0x100L) | (self.n198 & 0x80L) | (self.n198 & 0x40L) | (self.n198 & 0x20L) | (self.n198 & 0x10L) | (self.n198 & 0x8L) | (self.n198 & 0x4L) | (self.n198 & 0x2L) | (self.n198 & 0x1L)
    self.n199 = ((self.n198 & 0x40000L) >> 18)
    self.n184 = self.n171 | self.n173
    self.n176 = (self.n174 & 0x4L) | (self.n174 & 0x2L) | (self.n174 & 0x1L)
    self.n175 = ((self.n174 & 0x8L) >> 3)
    self.n161 = self.n148 & self.n150
    self.n153 = (self.n151 & 0x4L) | (self.n151 & 0x2L) | (self.n151 & 0x1L)
    self.n152 = ((self.n151 & 0x8L) >> 3)
    self.n108 = self.n65 | self.n67
    self.n70 = (self.n68 & 0x20000L) | (self.n68 & 0x10000L) | (self.n68 & 0x8000L) | (self.n68 & 0x4000L) | (self.n68 & 0x2000L) | (self.n68 & 0x1000L) | (self.n68 & 0x800L) | (self.n68 & 0x400L) | (self.n68 & 0x200L) | (self.n68 & 0x100L) | (self.n68 & 0x80L) | (self.n68 & 0x40L) | (self.n68 & 0x20L) | (self.n68 & 0x10L) | (self.n68 & 0x8L) | (self.n68 & 0x4L) | (self.n68 & 0x2L) | (self.n68 & 0x1L)
    self.n69 = ((self.n68 & 0x40000L) >> 18)
    self.n54 = self.n41 | self.n43
    self.n46 = (self.n44 & 0x4L) | (self.n44 & 0x2L) | (self.n44 & 0x1L)
    self.n45 = ((self.n44 & 0x8L) >> 3)
    self.n31 = self.n18 & self.n20
    self.n23 = (self.n21 & 0x4L) | (self.n21 & 0x2L) | (self.n21 & 0x1L)
    self.n22 = ((self.n21 & 0x8L) >> 3)
    self.n248 = self.n237 | self.n238
    self.n202 = (self.n200 & 0x10000L) | (self.n200 & 0x8000L) | (self.n200 & 0x4000L) | (self.n200 & 0x2000L) | (self.n200 & 0x1000L) | (self.n200 & 0x800L) | (self.n200 & 0x400L) | (self.n200 & 0x200L) | (self.n200 & 0x100L) | (self.n200 & 0x80L) | (self.n200 & 0x40L) | (self.n200 & 0x20L) | (self.n200 & 0x10L) | (self.n200 & 0x8L) | (self.n200 & 0x4L) | (self.n200 & 0x2L) | (self.n200 & 0x1L)
    self.n201 = ((self.n200 & 0x20000L) >> 17)
    self.n187 = self.n183 | self.n184
    self.n178 = (self.n176 & 0x2L) | (self.n176 & 0x1L)
    self.n177 = ((self.n176 & 0x4L) >> 2)
    self.n164 = self.n160 & self.n161
    self.n155 = (self.n153 & 0x2L) | (self.n153 & 0x1L)
    self.n154 = ((self.n153 & 0x4L) >> 2)
    self.n118 = self.n107 | self.n108
    self.n72 = (self.n70 & 0x10000L) | (self.n70 & 0x8000L) | (self.n70 & 0x4000L) | (self.n70 & 0x2000L) | (self.n70 & 0x1000L) | (self.n70 & 0x800L) | (self.n70 & 0x400L) | (self.n70 & 0x200L) | (self.n70 & 0x100L) | (self.n70 & 0x80L) | (self.n70 & 0x40L) | (self.n70 & 0x20L) | (self.n70 & 0x10L) | (self.n70 & 0x8L) | (self.n70 & 0x4L) | (self.n70 & 0x2L) | (self.n70 & 0x1L)
    self.n71 = ((self.n70 & 0x20000L) >> 17)
    self.n57 = self.n53 | self.n54
    self.n48 = (self.n46 & 0x2L) | (self.n46 & 0x1L)
    self.n47 = ((self.n46 & 0x4L) >> 2)
    self.n34 = self.n30 & self.n31
    self.n25 = (self.n23 & 0x2L) | (self.n23 & 0x1L)
    self.n24 = ((self.n23 & 0x4L) >> 2)
    self.n239 = self.n199 | self.n201
    self.n204 = (self.n202 & 0x8000L) | (self.n202 & 0x4000L) | (self.n202 & 0x2000L) | (self.n202 & 0x1000L) | (self.n202 & 0x800L) | (self.n202 & 0x400L) | (self.n202 & 0x200L) | (self.n202 & 0x100L) | (self.n202 & 0x80L) | (self.n202 & 0x40L) | (self.n202 & 0x20L) | (self.n202 & 0x10L) | (self.n202 & 0x8L) | (self.n202 & 0x4L) | (self.n202 & 0x2L) | (self.n202 & 0x1L)
    self.n203 = ((self.n202 & 0x10000L) >> 16)
    self.n185 = self.n175 | self.n177
    self.n180 = (self.n178 & 0x1L)
    self.n179 = ((self.n178 & 0x2L) >> 1)
    self.n162 = self.n152 & self.n154
    self.n157 = (self.n155 & 0x1L)
    self.n156 = ((self.n155 & 0x2L) >> 1)
    self.n109 = self.n69 | self.n71
    self.n74 = (self.n72 & 0x8000L) | (self.n72 & 0x4000L) | (self.n72 & 0x2000L) | (self.n72 & 0x1000L) | (self.n72 & 0x800L) | (self.n72 & 0x400L) | (self.n72 & 0x200L) | (self.n72 & 0x100L) | (self.n72 & 0x80L) | (self.n72 & 0x40L) | (self.n72 & 0x20L) | (self.n72 & 0x10L) | (self.n72 & 0x8L) | (self.n72 & 0x4L) | (self.n72 & 0x2L) | (self.n72 & 0x1L)
    self.n73 = ((self.n72 & 0x10000L) >> 16)
    self.n55 = self.n45 | self.n47
    self.n50 = (self.n48 & 0x1L)
    self.n49 = ((self.n48 & 0x2L) >> 1)
    self.n32 = self.n22 & self.n24
    self.n27 = (self.n25 & 0x1L)
    self.n26 = ((self.n25 & 0x2L) >> 1)
    self.n206 = (self.n204 & 0x4000L) | (self.n204 & 0x2000L) | (self.n204 & 0x1000L) | (self.n204 & 0x800L) | (self.n204 & 0x400L) | (self.n204 & 0x200L) | (self.n204 & 0x100L) | (self.n204 & 0x80L) | (self.n204 & 0x40L) | (self.n204 & 0x20L) | (self.n204 & 0x10L) | (self.n204 & 0x8L) | (self.n204 & 0x4L) | (self.n204 & 0x2L) | (self.n204 & 0x1L)
    self.n205 = ((self.n204 & 0x8000L) >> 15)
    self.n181 = (self.n180 & 0x1L)
    self.n158 = (self.n157 & 0x1L)
    self.n76 = (self.n74 & 0x4000L) | (self.n74 & 0x2000L) | (self.n74 & 0x1000L) | (self.n74 & 0x800L) | (self.n74 & 0x400L) | (self.n74 & 0x200L) | (self.n74 & 0x100L) | (self.n74 & 0x80L) | (self.n74 & 0x40L) | (self.n74 & 0x20L) | (self.n74 & 0x10L) | (self.n74 & 0x8L) | (self.n74 & 0x4L) | (self.n74 & 0x2L) | (self.n74 & 0x1L)
    self.n75 = ((self.n74 & 0x8000L) >> 15)
    self.n51 = (self.n50 & 0x1L)
    self.n28 = (self.n27 & 0x1L)
    self.n240 = self.n203 | self.n205
    self.n208 = (self.n206 & 0x2000L) | (self.n206 & 0x1000L) | (self.n206 & 0x800L) | (self.n206 & 0x400L) | (self.n206 & 0x200L) | (self.n206 & 0x100L) | (self.n206 & 0x80L) | (self.n206 & 0x40L) | (self.n206 & 0x20L) | (self.n206 & 0x10L) | (self.n206 & 0x8L) | (self.n206 & 0x4L) | (self.n206 & 0x2L) | (self.n206 & 0x1L)
    self.n207 = ((self.n206 & 0x4000L) >> 14)
    self.n186 = self.n179 | self.n181
    self.n163 = self.n156 & self.n158
    self.n110 = self.n73 | self.n75
    self.n78 = (self.n76 & 0x2000L) | (self.n76 & 0x1000L) | (self.n76 & 0x800L) | (self.n76 & 0x400L) | (self.n76 & 0x200L) | (self.n76 & 0x100L) | (self.n76 & 0x80L) | (self.n76 & 0x40L) | (self.n76 & 0x20L) | (self.n76 & 0x10L) | (self.n76 & 0x8L) | (self.n76 & 0x4L) | (self.n76 & 0x2L) | (self.n76 & 0x1L)
    self.n77 = ((self.n76 & 0x4000L) >> 14)
    self.n56 = self.n49 | self.n51
    self.n33 = self.n26 & self.n28
    self.n249 = self.n239 | self.n240
    self.n210 = (self.n208 & 0x1000L) | (self.n208 & 0x800L) | (self.n208 & 0x400L) | (self.n208 & 0x200L) | (self.n208 & 0x100L) | (self.n208 & 0x80L) | (self.n208 & 0x40L) | (self.n208 & 0x20L) | (self.n208 & 0x10L) | (self.n208 & 0x8L) | (self.n208 & 0x4L) | (self.n208 & 0x2L) | (self.n208 & 0x1L)
    self.n209 = ((self.n208 & 0x2000L) >> 13)
    self.n188 = self.n185 | self.n186
    self.n165 = self.n162 & self.n163
    self.n119 = self.n109 | self.n110
    self.n80 = (self.n78 & 0x1000L) | (self.n78 & 0x800L) | (self.n78 & 0x400L) | (self.n78 & 0x200L) | (self.n78 & 0x100L) | (self.n78 & 0x80L) | (self.n78 & 0x40L) | (self.n78 & 0x20L) | (self.n78 & 0x10L) | (self.n78 & 0x8L) | (self.n78 & 0x4L) | (self.n78 & 0x2L) | (self.n78 & 0x1L)
    self.n79 = ((self.n78 & 0x2000L) >> 13)
    self.n58 = self.n55 | self.n56
    self.n35 = self.n32 & self.n33
    self.n254 = self.n248 | self.n249
    self.n241 = self.n207 | self.n209
    self.n212 = (self.n210 & 0x800L) | (self.n210 & 0x400L) | (self.n210 & 0x200L) | (self.n210 & 0x100L) | (self.n210 & 0x80L) | (self.n210 & 0x40L) | (self.n210 & 0x20L) | (self.n210 & 0x10L) | (self.n210 & 0x8L) | (self.n210 & 0x4L) | (self.n210 & 0x2L) | (self.n210 & 0x1L)
    self.n211 = ((self.n210 & 0x1000L) >> 12)
    self.n189 = self.n187 | self.n188
    self.n166 = self.n164 & self.n165
    self.n124 = self.n118 | self.n119
    self.n111 = self.n77 | self.n79
    self.n82 = (self.n80 & 0x800L) | (self.n80 & 0x400L) | (self.n80 & 0x200L) | (self.n80 & 0x100L) | (self.n80 & 0x80L) | (self.n80 & 0x40L) | (self.n80 & 0x20L) | (self.n80 & 0x10L) | (self.n80 & 0x8L) | (self.n80 & 0x4L) | (self.n80 & 0x2L) | (self.n80 & 0x1L)
    self.n81 = ((self.n80 & 0x1000L) >> 12)
    self.n59 = self.n57 | self.n58
    self.n36 = self.n34 & self.n35
    self.n264 = self.n166 & self.n263
    self.n261 = self.n166 & self.n260
    self.n214 = (self.n212 & 0x400L) | (self.n212 & 0x200L) | (self.n212 & 0x100L) | (self.n212 & 0x80L) | (self.n212 & 0x40L) | (self.n212 & 0x20L) | (self.n212 & 0x10L) | (self.n212 & 0x8L) | (self.n212 & 0x4L) | (self.n212 & 0x2L) | (self.n212 & 0x1L)
    self.n213 = ((self.n212 & 0x800L) >> 11)
    self.n190 = ~self.n189 & 0x1L
    self.n134 = self.n36 & self.n133
    self.n131 = self.n36 & self.n130
    self.n84 = (self.n82 & 0x400L) | (self.n82 & 0x200L) | (self.n82 & 0x100L) | (self.n82 & 0x80L) | (self.n82 & 0x40L) | (self.n82 & 0x20L) | (self.n82 & 0x10L) | (self.n82 & 0x8L) | (self.n82 & 0x4L) | (self.n82 & 0x2L) | (self.n82 & 0x1L)
    self.n83 = ((self.n82 & 0x800L) >> 11)
    self.n60 = ~self.n59 & 0x1L
    self.n242 = self.n211 | self.n213
    self.n216 = (self.n214 & 0x200L) | (self.n214 & 0x100L) | (self.n214 & 0x80L) | (self.n214 & 0x40L) | (self.n214 & 0x20L) | (self.n214 & 0x10L) | (self.n214 & 0x8L) | (self.n214 & 0x4L) | (self.n214 & 0x2L) | (self.n214 & 0x1L)
    self.n215 = ((self.n214 & 0x400L) >> 10)
    self.n112 = self.n81 | self.n83
    self.n86 = (self.n84 & 0x200L) | (self.n84 & 0x100L) | (self.n84 & 0x80L) | (self.n84 & 0x40L) | (self.n84 & 0x20L) | (self.n84 & 0x10L) | (self.n84 & 0x8L) | (self.n84 & 0x4L) | (self.n84 & 0x2L) | (self.n84 & 0x1L)
    self.n85 = ((self.n84 & 0x400L) >> 10)
    self.n250 = self.n241 | self.n242
    self.n218 = (self.n216 & 0x100L) | (self.n216 & 0x80L) | (self.n216 & 0x40L) | (self.n216 & 0x20L) | (self.n216 & 0x10L) | (self.n216 & 0x8L) | (self.n216 & 0x4L) | (self.n216 & 0x2L) | (self.n216 & 0x1L)
    self.n217 = ((self.n216 & 0x200L) >> 9)
    self.n120 = self.n111 | self.n112
    self.n88 = (self.n86 & 0x100L) | (self.n86 & 0x80L) | (self.n86 & 0x40L) | (self.n86 & 0x20L) | (self.n86 & 0x10L) | (self.n86 & 0x8L) | (self.n86 & 0x4L) | (self.n86 & 0x2L) | (self.n86 & 0x1L)
    self.n87 = ((self.n86 & 0x200L) >> 9)
    self.n243 = self.n215 | self.n217
    self.n220 = (self.n218 & 0x80L) | (self.n218 & 0x40L) | (self.n218 & 0x20L) | (self.n218 & 0x10L) | (self.n218 & 0x8L) | (self.n218 & 0x4L) | (self.n218 & 0x2L) | (self.n218 & 0x1L)
    self.n219 = ((self.n218 & 0x100L) >> 8)
    self.n113 = self.n85 | self.n87
    self.n90 = (self.n88 & 0x80L) | (self.n88 & 0x40L) | (self.n88 & 0x20L) | (self.n88 & 0x10L) | (self.n88 & 0x8L) | (self.n88 & 0x4L) | (self.n88 & 0x2L) | (self.n88 & 0x1L)
    self.n89 = ((self.n88 & 0x100L) >> 8)
    self.n222 = (self.n220 & 0x40L) | (self.n220 & 0x20L) | (self.n220 & 0x10L) | (self.n220 & 0x8L) | (self.n220 & 0x4L) | (self.n220 & 0x2L) | (self.n220 & 0x1L)
    self.n221 = ((self.n220 & 0x80L) >> 7)
    self.n92 = (self.n90 & 0x40L) | (self.n90 & 0x20L) | (self.n90 & 0x10L) | (self.n90 & 0x8L) | (self.n90 & 0x4L) | (self.n90 & 0x2L) | (self.n90 & 0x1L)
    self.n91 = ((self.n90 & 0x80L) >> 7)
    self.n244 = self.n219 | self.n221
    self.n224 = (self.n222 & 0x20L) | (self.n222 & 0x10L) | (self.n222 & 0x8L) | (self.n222 & 0x4L) | (self.n222 & 0x2L) | (self.n222 & 0x1L)
    self.n223 = ((self.n222 & 0x40L) >> 6)
    self.n114 = self.n89 | self.n91
    self.n94 = (self.n92 & 0x20L) | (self.n92 & 0x10L) | (self.n92 & 0x8L) | (self.n92 & 0x4L) | (self.n92 & 0x2L) | (self.n92 & 0x1L)
    self.n93 = ((self.n92 & 0x40L) >> 6)
    self.n251 = self.n243 | self.n244
    self.n226 = (self.n224 & 0x10L) | (self.n224 & 0x8L) | (self.n224 & 0x4L) | (self.n224 & 0x2L) | (self.n224 & 0x1L)
    self.n225 = ((self.n224 & 0x20L) >> 5)
    self.n121 = self.n113 | self.n114
    self.n96 = (self.n94 & 0x10L) | (self.n94 & 0x8L) | (self.n94 & 0x4L) | (self.n94 & 0x2L) | (self.n94 & 0x1L)
    self.n95 = ((self.n94 & 0x20L) >> 5)
    self.n255 = self.n250 | self.n251
    self.n245 = self.n223 | self.n225
    self.n228 = (self.n226 & 0x8L) | (self.n226 & 0x4L) | (self.n226 & 0x2L) | (self.n226 & 0x1L)
    self.n227 = ((self.n226 & 0x10L) >> 4)
    self.n125 = self.n120 | self.n121
    self.n115 = self.n93 | self.n95
    self.n98 = (self.n96 & 0x8L) | (self.n96 & 0x4L) | (self.n96 & 0x2L) | (self.n96 & 0x1L)
    self.n97 = ((self.n96 & 0x10L) >> 4)
    self.n257 = self.n254 | self.n255
    self.n230 = (self.n228 & 0x4L) | (self.n228 & 0x2L) | (self.n228 & 0x1L)
    self.n229 = ((self.n228 & 0x8L) >> 3)
    self.n127 = self.n124 | self.n125
    self.n100 = (self.n98 & 0x4L) | (self.n98 & 0x2L) | (self.n98 & 0x1L)
    self.n99 = ((self.n98 & 0x8L) >> 3)
    self.n246 = self.n227 | self.n229
    self.n232 = (self.n230 & 0x2L) | (self.n230 & 0x1L)
    self.n231 = ((self.n230 & 0x4L) >> 2)
    self.n116 = self.n97 | self.n99
    self.n102 = (self.n100 & 0x2L) | (self.n100 & 0x1L)
    self.n101 = ((self.n100 & 0x4L) >> 2)
    self.n252 = self.n245 | self.n246
    self.n234 = (self.n232 & 0x1L)
    self.n233 = ((self.n232 & 0x2L) >> 1)
    self.n122 = self.n115 | self.n116
    self.n104 = (self.n102 & 0x1L)
    self.n103 = ((self.n102 & 0x2L) >> 1)
    self.n247 = self.n231 | self.n233
    self.n235 = (self.n234 & 0x1L)
    self.n117 = self.n101 | self.n103
    self.n105 = (self.n104 & 0x1L)
    self.n253 = self.n247 | self.n235
    self.n123 = self.n117 | self.n105
    self.n256 = self.n252 | self.n253
    self.n126 = self.n122 | self.n123
    self.n258 = self.n257 | self.n256
    self.n128 = self.n127 | self.n126
    self.n259 = ~self.n258 & 0x1L
    self.n129 = ~self.n128 & 0x1L
    self.n269 = ~self.n259 & 0x1L
    self.n268 = self.n190 & self.n259
    self.n267 = self.n166 & self.n259
    self.n265 = ~self.n259 & 0x1L
    self.n139 = ~self.n129 & 0x1L
    self.n138 = self.n60 & self.n129
    self.n137 = self.n36 & self.n129
    self.n135 = ~self.n129 & 0x1L
    self.n278 = self.n138 | self.n268
    self.n277 = self.n137 | self.n267
    self.n275 = self.n138 & self.n267
    self.n274 = self.n137 & self.n268
    self.n270 = self.n190 & self.n269
    self.n266 = self.n264 & self.n265
    self.n140 = self.n60 & self.n139
    self.n136 = self.n134 & self.n135
    self.n1142 = self.n277 << 1 | self.n278
    self.n291 = ~self.n270 & 0x1L
    self.n289 = ~self.n140 & 0x1L
    self.n276 = self.n274 | self.n275
    self.n272 = self.n266 | self.n261
    self.n271 = self.n136 | self.n131
    self.n1143 = self.n276 << 2 | self.n1142
    self.n292 = self.n291 << 23 | self.n10
    self.n290 = self.n289 << 23 | self.n7
    self.n273 = self.n271 | self.n272
    self.n1144 = self.n273 << 3 | self.n1143
    self.n293 = (self.n290 * self.n292) & 0xFFFFFFFFFFFFL
    if self.n1144 == self.n1178:
      self.n1179 = 1L
    else:
      self.n1179 = 0L
    if self.n1144 == self.n1176:
      self.n1177 = 1L
    else:
      self.n1177 = 0L
    if self.n1144 == self.n1174:
      self.n1175 = 1L
    else:
      self.n1175 = 0L
    if self.n1144 == self.n1172:
      self.n1173 = 1L
    else:
      self.n1173 = 0L
    if self.n1144 == self.n1170:
      self.n1171 = 1L
    else:
      self.n1171 = 0L
    if self.n1144 == self.n1168:
      self.n1169 = 1L
    else:
      self.n1169 = 0L
    if self.n1144 == self.n1166:
      self.n1167 = 1L
    else:
      self.n1167 = 0L
    if self.n1144 == self.n1164:
      self.n1165 = 1L
    else:
      self.n1165 = 0L
    if self.n1144 == self.n1162:
      self.n1163 = 1L
    else:
      self.n1163 = 0L
    if self.n1144 == self.n1160:
      self.n1161 = 1L
    else:
      self.n1161 = 0L
    if self.n1144 == self.n1158:
      self.n1159 = 1L
    else:
      self.n1159 = 0L
    if self.n1144 == self.n1156:
      self.n1157 = 1L
    else:
      self.n1157 = 0L
    if self.n1144 == self.n1154:
      self.n1155 = 1L
    else:
      self.n1155 = 0L
    if self.n1144 == self.n1152:
      self.n1153 = 1L
    else:
      self.n1153 = 0L
    if self.n1144 == self.n1150:
      self.n1151 = 1L
    else:
      self.n1151 = 0L
    self.n299 = (self.n293 & 0x400000000000L) | (self.n293 & 0x200000000000L) | (self.n293 & 0x100000000000L) | (self.n293 & 0x80000000000L) | (self.n293 & 0x40000000000L) | (self.n293 & 0x20000000000L) | (self.n293 & 0x10000000000L) | (self.n293 & 0x8000000000L) | (self.n293 & 0x4000000000L) | (self.n293 & 0x2000000000L) | (self.n293 & 0x1000000000L) | (self.n293 & 0x800000000L) | (self.n293 & 0x400000000L) | (self.n293 & 0x200000000L) | (self.n293 & 0x100000000L) | (self.n293 & 0x80000000L) | (self.n293 & 0x40000000L) | (self.n293 & 0x20000000L) | (self.n293 & 0x10000000L) | (self.n293 & 0x8000000L) | (self.n293 & 0x4000000L) | (self.n293 & 0x2000000L) | (self.n293 & 0x1000000L) | (self.n293 & 0x800000L) | (self.n293 & 0x400000L) | (self.n293 & 0x200000L) | (self.n293 & 0x100000L) | (self.n293 & 0x80000L) | (self.n293 & 0x40000L) | (self.n293 & 0x20000L) | (self.n293 & 0x10000L) | (self.n293 & 0x8000L) | (self.n293 & 0x4000L) | (self.n293 & 0x2000L) | (self.n293 & 0x1000L) | (self.n293 & 0x800L) | (self.n293 & 0x400L) | (self.n293 & 0x200L) | (self.n293 & 0x100L) | (self.n293 & 0x80L) | (self.n293 & 0x40L) | (self.n293 & 0x20L) | (self.n293 & 0x10L) | (self.n293 & 0x8L) | (self.n293 & 0x4L) | (self.n293 & 0x2L) | (self.n293 & 0x1L)
    self.n298 = ((self.n293 & 0x800000000000L) >> 1) | ((self.n293 & 0x400000000000L) >> 1) | ((self.n293 & 0x200000000000L) >> 1) | ((self.n293 & 0x100000000000L) >> 1) | ((self.n293 & 0x80000000000L) >> 1) | ((self.n293 & 0x40000000000L) >> 1) | ((self.n293 & 0x20000000000L) >> 1) | ((self.n293 & 0x10000000000L) >> 1) | ((self.n293 & 0x8000000000L) >> 1) | ((self.n293 & 0x4000000000L) >> 1) | ((self.n293 & 0x2000000000L) >> 1) | ((self.n293 & 0x1000000000L) >> 1) | ((self.n293 & 0x800000000L) >> 1) | ((self.n293 & 0x400000000L) >> 1) | ((self.n293 & 0x200000000L) >> 1) | ((self.n293 & 0x100000000L) >> 1) | ((self.n293 & 0x80000000L) >> 1) | ((self.n293 & 0x40000000L) >> 1) | ((self.n293 & 0x20000000L) >> 1) | ((self.n293 & 0x10000000L) >> 1) | ((self.n293 & 0x8000000L) >> 1) | ((self.n293 & 0x4000000L) >> 1) | ((self.n293 & 0x2000000L) >> 1) | ((self.n293 & 0x1000000L) >> 1) | ((self.n293 & 0x800000L) >> 1) | ((self.n293 & 0x400000L) >> 1) | ((self.n293 & 0x200000L) >> 1) | ((self.n293 & 0x100000L) >> 1) | ((self.n293 & 0x80000L) >> 1) | ((self.n293 & 0x40000L) >> 1) | ((self.n293 & 0x20000L) >> 1) | ((self.n293 & 0x10000L) >> 1) | ((self.n293 & 0x8000L) >> 1) | ((self.n293 & 0x4000L) >> 1) | ((self.n293 & 0x2000L) >> 1) | ((self.n293 & 0x1000L) >> 1) | ((self.n293 & 0x800L) >> 1) | ((self.n293 & 0x400L) >> 1) | ((self.n293 & 0x200L) >> 1) | ((self.n293 & 0x100L) >> 1) | ((self.n293 & 0x80L) >> 1) | ((self.n293 & 0x40L) >> 1) | ((self.n293 & 0x20L) >> 1) | ((self.n293 & 0x10L) >> 1) | ((self.n293 & 0x8L) >> 1) | ((self.n293 & 0x4L) >> 1) | ((self.n293 & 0x2L) >> 1)
    self.n294 = ((self.n293 & 0x800000000000L) >> 47)
    if self.n1179:
      self.n1180 = self.n1146
    else:
      self.n1180 = self.n1145
    if self.n294:
      self.n300 = self.n298
    else:
      self.n300 = self.n299
    if self.n294:
      self.n297 = self.n296
    else:
      self.n297 = self.n288
    if self.n1177:
      self.n1181 = self.n1147
    else:
      self.n1181 = self.n1180
    self.n335 = ((self.n300 & 0x400000000000L) >> 1) | ((self.n300 & 0x200000000000L) >> 1) | ((self.n300 & 0x100000000000L) >> 1) | ((self.n300 & 0x80000000000L) >> 1) | ((self.n300 & 0x40000000000L) >> 1) | ((self.n300 & 0x20000000000L) >> 1) | ((self.n300 & 0x10000000000L) >> 1) | ((self.n300 & 0x8000000000L) >> 1) | ((self.n300 & 0x4000000000L) >> 1) | ((self.n300 & 0x2000000000L) >> 1) | ((self.n300 & 0x1000000000L) >> 1) | ((self.n300 & 0x800000000L) >> 1) | ((self.n300 & 0x400000000L) >> 1) | ((self.n300 & 0x200000000L) >> 1) | ((self.n300 & 0x100000000L) >> 1) | ((self.n300 & 0x80000000L) >> 1) | ((self.n300 & 0x40000000L) >> 1) | ((self.n300 & 0x20000000L) >> 1) | ((self.n300 & 0x10000000L) >> 1) | ((self.n300 & 0x8000000L) >> 1) | ((self.n300 & 0x4000000L) >> 1) | ((self.n300 & 0x2000000L) >> 1) | ((self.n300 & 0x1000000L) >> 1) | ((self.n300 & 0x800000L) >> 1) | ((self.n300 & 0x400000L) >> 1) | ((self.n300 & 0x200000L) >> 1) | ((self.n300 & 0x100000L) >> 1) | ((self.n300 & 0x80000L) >> 1) | ((self.n300 & 0x40000L) >> 1) | ((self.n300 & 0x20000L) >> 1) | ((self.n300 & 0x10000L) >> 1) | ((self.n300 & 0x8000L) >> 1) | ((self.n300 & 0x4000L) >> 1) | ((self.n300 & 0x2000L) >> 1) | ((self.n300 & 0x1000L) >> 1) | ((self.n300 & 0x800L) >> 1) | ((self.n300 & 0x400L) >> 1) | ((self.n300 & 0x200L) >> 1) | ((self.n300 & 0x100L) >> 1) | ((self.n300 & 0x80L) >> 1) | ((self.n300 & 0x40L) >> 1) | ((self.n300 & 0x20L) >> 1) | ((self.n300 & 0x10L) >> 1) | ((self.n300 & 0x8L) >> 1) | ((self.n300 & 0x4L) >> 1) | ((self.n300 & 0x2L) >> 1)
    self.n334 = (self.n300 & 0x200000000000L) | (self.n300 & 0x100000000000L) | (self.n300 & 0x80000000000L) | (self.n300 & 0x40000000000L) | (self.n300 & 0x20000000000L) | (self.n300 & 0x10000000000L) | (self.n300 & 0x8000000000L) | (self.n300 & 0x4000000000L) | (self.n300 & 0x2000000000L) | (self.n300 & 0x1000000000L) | (self.n300 & 0x800000000L) | (self.n300 & 0x400000000L) | (self.n300 & 0x200000000L) | (self.n300 & 0x100000000L) | (self.n300 & 0x80000000L) | (self.n300 & 0x40000000L) | (self.n300 & 0x20000000L) | (self.n300 & 0x10000000L) | (self.n300 & 0x8000000L) | (self.n300 & 0x4000000L) | (self.n300 & 0x2000000L) | (self.n300 & 0x1000000L) | (self.n300 & 0x800000L) | (self.n300 & 0x400000L) | (self.n300 & 0x200000L) | (self.n300 & 0x100000L) | (self.n300 & 0x80000L) | (self.n300 & 0x40000L) | (self.n300 & 0x20000L) | (self.n300 & 0x10000L) | (self.n300 & 0x8000L) | (self.n300 & 0x4000L) | (self.n300 & 0x2000L) | (self.n300 & 0x1000L) | (self.n300 & 0x800L) | (self.n300 & 0x400L) | (self.n300 & 0x200L) | (self.n300 & 0x100L) | (self.n300 & 0x80L) | (self.n300 & 0x40L) | (self.n300 & 0x20L) | (self.n300 & 0x10L) | (self.n300 & 0x8L) | (self.n300 & 0x4L) | (self.n300 & 0x2L) | (self.n300 & 0x1L)
    self.n332 = (self.n297 - self.n331) & 0x1FFL
    self.n303 = (self.n297 & 0x80L) | (self.n297 & 0x40L) | (self.n297 & 0x20L) | (self.n297 & 0x10L) | (self.n297 & 0x8L) | (self.n297 & 0x4L) | (self.n297 & 0x2L) | (self.n297 & 0x1L)
    self.n302 = ((self.n297 & 0x100L) >> 8)
    self.n301 = ((self.n300 & 0x400000000000L) >> 46)
    if self.n1175:
      self.n1182 = self.n1147
    else:
      self.n1182 = self.n1181
    self.n305 = (self.n303 & 0x40L) | (self.n303 & 0x20L) | (self.n303 & 0x10L) | (self.n303 & 0x8L) | (self.n303 & 0x4L) | (self.n303 & 0x2L) | (self.n303 & 0x1L)
    self.n304 = ((self.n303 & 0x80L) >> 7)
    if self.n1173:
      self.n1183 = self.n1148
    else:
      self.n1183 = self.n1182
    self.n320 = self.n302 | self.n304
    self.n307 = (self.n305 & 0x20L) | (self.n305 & 0x10L) | (self.n305 & 0x8L) | (self.n305 & 0x4L) | (self.n305 & 0x2L) | (self.n305 & 0x1L)
    self.n306 = ((self.n305 & 0x40L) >> 6)
    if self.n1171:
      self.n1184 = self.n1148
    else:
      self.n1184 = self.n1183
    self.n309 = (self.n307 & 0x10L) | (self.n307 & 0x8L) | (self.n307 & 0x4L) | (self.n307 & 0x2L) | (self.n307 & 0x1L)
    self.n308 = ((self.n307 & 0x20L) >> 5)
    if self.n1169:
      self.n1185 = self.n1148
    else:
      self.n1185 = self.n1184
    self.n321 = self.n306 | self.n308
    self.n311 = (self.n309 & 0x8L) | (self.n309 & 0x4L) | (self.n309 & 0x2L) | (self.n309 & 0x1L)
    self.n310 = ((self.n309 & 0x10L) >> 4)
    if self.n1167:
      self.n1186 = self.n1148
    else:
      self.n1186 = self.n1185
    self.n324 = self.n320 | self.n321
    self.n313 = (self.n311 & 0x4L) | (self.n311 & 0x2L) | (self.n311 & 0x1L)
    self.n312 = ((self.n311 & 0x8L) >> 3)
    if self.n1165:
      self.n1187 = self.n1149
    else:
      self.n1187 = self.n1186
    self.n322 = self.n310 | self.n312
    self.n315 = (self.n313 & 0x2L) | (self.n313 & 0x1L)
    self.n314 = ((self.n313 & 0x4L) >> 2)
    if self.n1163:
      self.n1188 = self.n1149
    else:
      self.n1188 = self.n1187
    self.n317 = (self.n315 & 0x1L)
    self.n316 = ((self.n315 & 0x2L) >> 1)
    if self.n1161:
      self.n1189 = self.n1149
    else:
      self.n1189 = self.n1188
    self.n323 = self.n314 | self.n316
    self.n318 = (self.n317 & 0x1L)
    if self.n1159:
      self.n1190 = self.n1149
    else:
      self.n1190 = self.n1189
    self.n325 = self.n322 | self.n323
    if self.n1157:
      self.n1191 = self.n1149
    else:
      self.n1191 = self.n1190
    self.n326 = self.n324 | self.n325
    if self.n1155:
      self.n1192 = self.n1149
    else:
      self.n1192 = self.n1191
    self.n327 = self.n326 | self.n318
    if self.n1153:
      self.n1193 = self.n1149
    else:
      self.n1193 = self.n1192
    self.n328 = ~self.n327 & 0x1L
    if self.n1151:
      self.n1194 = self.n1149
    else:
      self.n1194 = self.n1193
    self.n329 = self.n301 | self.n328
    self.n1196 = (self.n1194 & 0x1L)
    self.n1195 = ((self.n1194 & 0x4L) >> 1) | ((self.n1194 & 0x2L) >> 1)
    self.n330 = ~self.n329 & 0x1L
    self.n1200 = (self.n1195 & 0x1L)
    self.n1199 = ((self.n1195 & 0x2L) >> 1)
    if self.n1196:
      self.n1198 = self.n1211
    else:
      self.n1198 = self.n1209
    if self.n330:
      self.n336 = self.n334
    else:
      self.n336 = self.n335
    if self.n330:
      self.n333 = self.n332
    else:
      self.n333 = self.n297
    self.n1203 = (self.n1199 & 0x1L)
    self.n371 = ((self.n336 & 0x200000000000L) >> 1) | ((self.n336 & 0x100000000000L) >> 1) | ((self.n336 & 0x80000000000L) >> 1) | ((self.n336 & 0x40000000000L) >> 1) | ((self.n336 & 0x20000000000L) >> 1) | ((self.n336 & 0x10000000000L) >> 1) | ((self.n336 & 0x8000000000L) >> 1) | ((self.n336 & 0x4000000000L) >> 1) | ((self.n336 & 0x2000000000L) >> 1) | ((self.n336 & 0x1000000000L) >> 1) | ((self.n336 & 0x800000000L) >> 1) | ((self.n336 & 0x400000000L) >> 1) | ((self.n336 & 0x200000000L) >> 1) | ((self.n336 & 0x100000000L) >> 1) | ((self.n336 & 0x80000000L) >> 1) | ((self.n336 & 0x40000000L) >> 1) | ((self.n336 & 0x20000000L) >> 1) | ((self.n336 & 0x10000000L) >> 1) | ((self.n336 & 0x8000000L) >> 1) | ((self.n336 & 0x4000000L) >> 1) | ((self.n336 & 0x2000000L) >> 1) | ((self.n336 & 0x1000000L) >> 1) | ((self.n336 & 0x800000L) >> 1) | ((self.n336 & 0x400000L) >> 1) | ((self.n336 & 0x200000L) >> 1) | ((self.n336 & 0x100000L) >> 1) | ((self.n336 & 0x80000L) >> 1) | ((self.n336 & 0x40000L) >> 1) | ((self.n336 & 0x20000L) >> 1) | ((self.n336 & 0x10000L) >> 1) | ((self.n336 & 0x8000L) >> 1) | ((self.n336 & 0x4000L) >> 1) | ((self.n336 & 0x2000L) >> 1) | ((self.n336 & 0x1000L) >> 1) | ((self.n336 & 0x800L) >> 1) | ((self.n336 & 0x400L) >> 1) | ((self.n336 & 0x200L) >> 1) | ((self.n336 & 0x100L) >> 1) | ((self.n336 & 0x80L) >> 1) | ((self.n336 & 0x40L) >> 1) | ((self.n336 & 0x20L) >> 1) | ((self.n336 & 0x10L) >> 1) | ((self.n336 & 0x8L) >> 1) | ((self.n336 & 0x4L) >> 1) | ((self.n336 & 0x2L) >> 1)
    self.n370 = (self.n336 & 0x100000000000L) | (self.n336 & 0x80000000000L) | (self.n336 & 0x40000000000L) | (self.n336 & 0x20000000000L) | (self.n336 & 0x10000000000L) | (self.n336 & 0x8000000000L) | (self.n336 & 0x4000000000L) | (self.n336 & 0x2000000000L) | (self.n336 & 0x1000000000L) | (self.n336 & 0x800000000L) | (self.n336 & 0x400000000L) | (self.n336 & 0x200000000L) | (self.n336 & 0x100000000L) | (self.n336 & 0x80000000L) | (self.n336 & 0x40000000L) | (self.n336 & 0x20000000L) | (self.n336 & 0x10000000L) | (self.n336 & 0x8000000L) | (self.n336 & 0x4000000L) | (self.n336 & 0x2000000L) | (self.n336 & 0x1000000L) | (self.n336 & 0x800000L) | (self.n336 & 0x400000L) | (self.n336 & 0x200000L) | (self.n336 & 0x100000L) | (self.n336 & 0x80000L) | (self.n336 & 0x40000L) | (self.n336 & 0x20000L) | (self.n336 & 0x10000L) | (self.n336 & 0x8000L) | (self.n336 & 0x4000L) | (self.n336 & 0x2000L) | (self.n336 & 0x1000L) | (self.n336 & 0x800L) | (self.n336 & 0x400L) | (self.n336 & 0x200L) | (self.n336 & 0x100L) | (self.n336 & 0x80L) | (self.n336 & 0x40L) | (self.n336 & 0x20L) | (self.n336 & 0x10L) | (self.n336 & 0x8L) | (self.n336 & 0x4L) | (self.n336 & 0x2L) | (self.n336 & 0x1L)
    self.n368 = (self.n333 - self.n367) & 0x1FFL
    self.n339 = (self.n333 & 0x80L) | (self.n333 & 0x40L) | (self.n333 & 0x20L) | (self.n333 & 0x10L) | (self.n333 & 0x8L) | (self.n333 & 0x4L) | (self.n333 & 0x2L) | (self.n333 & 0x1L)
    self.n338 = ((self.n333 & 0x100L) >> 8)
    self.n337 = ((self.n336 & 0x200000000000L) >> 45)
    self.n341 = (self.n339 & 0x40L) | (self.n339 & 0x20L) | (self.n339 & 0x10L) | (self.n339 & 0x8L) | (self.n339 & 0x4L) | (self.n339 & 0x2L) | (self.n339 & 0x1L)
    self.n340 = ((self.n339 & 0x80L) >> 7)
    self.n356 = self.n338 | self.n340
    self.n343 = (self.n341 & 0x20L) | (self.n341 & 0x10L) | (self.n341 & 0x8L) | (self.n341 & 0x4L) | (self.n341 & 0x2L) | (self.n341 & 0x1L)
    self.n342 = ((self.n341 & 0x40L) >> 6)
    self.n345 = (self.n343 & 0x10L) | (self.n343 & 0x8L) | (self.n343 & 0x4L) | (self.n343 & 0x2L) | (self.n343 & 0x1L)
    self.n344 = ((self.n343 & 0x20L) >> 5)
    self.n357 = self.n342 | self.n344
    self.n347 = (self.n345 & 0x8L) | (self.n345 & 0x4L) | (self.n345 & 0x2L) | (self.n345 & 0x1L)
    self.n346 = ((self.n345 & 0x10L) >> 4)
    self.n360 = self.n356 | self.n357
    self.n349 = (self.n347 & 0x4L) | (self.n347 & 0x2L) | (self.n347 & 0x1L)
    self.n348 = ((self.n347 & 0x8L) >> 3)
    self.n358 = self.n346 | self.n348
    self.n351 = (self.n349 & 0x2L) | (self.n349 & 0x1L)
    self.n350 = ((self.n349 & 0x4L) >> 2)
    self.n353 = (self.n351 & 0x1L)
    self.n352 = ((self.n351 & 0x2L) >> 1)
    self.n359 = self.n350 | self.n352
    self.n354 = (self.n353 & 0x1L)
    self.n361 = self.n358 | self.n359
    self.n362 = self.n360 | self.n361
    self.n363 = self.n362 | self.n354
    self.n364 = ~self.n363 & 0x1L
    self.n365 = self.n337 | self.n364
    self.n366 = ~self.n365 & 0x1L
    if self.n366:
      self.n372 = self.n370
    else:
      self.n372 = self.n371
    if self.n366:
      self.n369 = self.n368
    else:
      self.n369 = self.n333
    self.n407 = ((self.n372 & 0x100000000000L) >> 1) | ((self.n372 & 0x80000000000L) >> 1) | ((self.n372 & 0x40000000000L) >> 1) | ((self.n372 & 0x20000000000L) >> 1) | ((self.n372 & 0x10000000000L) >> 1) | ((self.n372 & 0x8000000000L) >> 1) | ((self.n372 & 0x4000000000L) >> 1) | ((self.n372 & 0x2000000000L) >> 1) | ((self.n372 & 0x1000000000L) >> 1) | ((self.n372 & 0x800000000L) >> 1) | ((self.n372 & 0x400000000L) >> 1) | ((self.n372 & 0x200000000L) >> 1) | ((self.n372 & 0x100000000L) >> 1) | ((self.n372 & 0x80000000L) >> 1) | ((self.n372 & 0x40000000L) >> 1) | ((self.n372 & 0x20000000L) >> 1) | ((self.n372 & 0x10000000L) >> 1) | ((self.n372 & 0x8000000L) >> 1) | ((self.n372 & 0x4000000L) >> 1) | ((self.n372 & 0x2000000L) >> 1) | ((self.n372 & 0x1000000L) >> 1) | ((self.n372 & 0x800000L) >> 1) | ((self.n372 & 0x400000L) >> 1) | ((self.n372 & 0x200000L) >> 1) | ((self.n372 & 0x100000L) >> 1) | ((self.n372 & 0x80000L) >> 1) | ((self.n372 & 0x40000L) >> 1) | ((self.n372 & 0x20000L) >> 1) | ((self.n372 & 0x10000L) >> 1) | ((self.n372 & 0x8000L) >> 1) | ((self.n372 & 0x4000L) >> 1) | ((self.n372 & 0x2000L) >> 1) | ((self.n372 & 0x1000L) >> 1) | ((self.n372 & 0x800L) >> 1) | ((self.n372 & 0x400L) >> 1) | ((self.n372 & 0x200L) >> 1) | ((self.n372 & 0x100L) >> 1) | ((self.n372 & 0x80L) >> 1) | ((self.n372 & 0x40L) >> 1) | ((self.n372 & 0x20L) >> 1) | ((self.n372 & 0x10L) >> 1) | ((self.n372 & 0x8L) >> 1) | ((self.n372 & 0x4L) >> 1) | ((self.n372 & 0x2L) >> 1)
    self.n406 = (self.n372 & 0x80000000000L) | (self.n372 & 0x40000000000L) | (self.n372 & 0x20000000000L) | (self.n372 & 0x10000000000L) | (self.n372 & 0x8000000000L) | (self.n372 & 0x4000000000L) | (self.n372 & 0x2000000000L) | (self.n372 & 0x1000000000L) | (self.n372 & 0x800000000L) | (self.n372 & 0x400000000L) | (self.n372 & 0x200000000L) | (self.n372 & 0x100000000L) | (self.n372 & 0x80000000L) | (self.n372 & 0x40000000L) | (self.n372 & 0x20000000L) | (self.n372 & 0x10000000L) | (self.n372 & 0x8000000L) | (self.n372 & 0x4000000L) | (self.n372 & 0x2000000L) | (self.n372 & 0x1000000L) | (self.n372 & 0x800000L) | (self.n372 & 0x400000L) | (self.n372 & 0x200000L) | (self.n372 & 0x100000L) | (self.n372 & 0x80000L) | (self.n372 & 0x40000L) | (self.n372 & 0x20000L) | (self.n372 & 0x10000L) | (self.n372 & 0x8000L) | (self.n372 & 0x4000L) | (self.n372 & 0x2000L) | (self.n372 & 0x1000L) | (self.n372 & 0x800L) | (self.n372 & 0x400L) | (self.n372 & 0x200L) | (self.n372 & 0x100L) | (self.n372 & 0x80L) | (self.n372 & 0x40L) | (self.n372 & 0x20L) | (self.n372 & 0x10L) | (self.n372 & 0x8L) | (self.n372 & 0x4L) | (self.n372 & 0x2L) | (self.n372 & 0x1L)
    self.n404 = (self.n369 - self.n403) & 0x1FFL
    self.n375 = (self.n369 & 0x80L) | (self.n369 & 0x40L) | (self.n369 & 0x20L) | (self.n369 & 0x10L) | (self.n369 & 0x8L) | (self.n369 & 0x4L) | (self.n369 & 0x2L) | (self.n369 & 0x1L)
    self.n374 = ((self.n369 & 0x100L) >> 8)
    self.n373 = ((self.n372 & 0x100000000000L) >> 44)
    self.n377 = (self.n375 & 0x40L) | (self.n375 & 0x20L) | (self.n375 & 0x10L) | (self.n375 & 0x8L) | (self.n375 & 0x4L) | (self.n375 & 0x2L) | (self.n375 & 0x1L)
    self.n376 = ((self.n375 & 0x80L) >> 7)
    self.n392 = self.n374 | self.n376
    self.n379 = (self.n377 & 0x20L) | (self.n377 & 0x10L) | (self.n377 & 0x8L) | (self.n377 & 0x4L) | (self.n377 & 0x2L) | (self.n377 & 0x1L)
    self.n378 = ((self.n377 & 0x40L) >> 6)
    self.n381 = (self.n379 & 0x10L) | (self.n379 & 0x8L) | (self.n379 & 0x4L) | (self.n379 & 0x2L) | (self.n379 & 0x1L)
    self.n380 = ((self.n379 & 0x20L) >> 5)
    self.n393 = self.n378 | self.n380
    self.n383 = (self.n381 & 0x8L) | (self.n381 & 0x4L) | (self.n381 & 0x2L) | (self.n381 & 0x1L)
    self.n382 = ((self.n381 & 0x10L) >> 4)
    self.n396 = self.n392 | self.n393
    self.n385 = (self.n383 & 0x4L) | (self.n383 & 0x2L) | (self.n383 & 0x1L)
    self.n384 = ((self.n383 & 0x8L) >> 3)
    self.n394 = self.n382 | self.n384
    self.n387 = (self.n385 & 0x2L) | (self.n385 & 0x1L)
    self.n386 = ((self.n385 & 0x4L) >> 2)
    self.n389 = (self.n387 & 0x1L)
    self.n388 = ((self.n387 & 0x2L) >> 1)
    self.n395 = self.n386 | self.n388
    self.n390 = (self.n389 & 0x1L)
    self.n397 = self.n394 | self.n395
    self.n398 = self.n396 | self.n397
    self.n399 = self.n398 | self.n390
    self.n400 = ~self.n399 & 0x1L
    self.n401 = self.n373 | self.n400
    self.n402 = ~self.n401 & 0x1L
    if self.n402:
      self.n408 = self.n406
    else:
      self.n408 = self.n407
    if self.n402:
      self.n405 = self.n404
    else:
      self.n405 = self.n369
    self.n443 = ((self.n408 & 0x80000000000L) >> 1) | ((self.n408 & 0x40000000000L) >> 1) | ((self.n408 & 0x20000000000L) >> 1) | ((self.n408 & 0x10000000000L) >> 1) | ((self.n408 & 0x8000000000L) >> 1) | ((self.n408 & 0x4000000000L) >> 1) | ((self.n408 & 0x2000000000L) >> 1) | ((self.n408 & 0x1000000000L) >> 1) | ((self.n408 & 0x800000000L) >> 1) | ((self.n408 & 0x400000000L) >> 1) | ((self.n408 & 0x200000000L) >> 1) | ((self.n408 & 0x100000000L) >> 1) | ((self.n408 & 0x80000000L) >> 1) | ((self.n408 & 0x40000000L) >> 1) | ((self.n408 & 0x20000000L) >> 1) | ((self.n408 & 0x10000000L) >> 1) | ((self.n408 & 0x8000000L) >> 1) | ((self.n408 & 0x4000000L) >> 1) | ((self.n408 & 0x2000000L) >> 1) | ((self.n408 & 0x1000000L) >> 1) | ((self.n408 & 0x800000L) >> 1) | ((self.n408 & 0x400000L) >> 1) | ((self.n408 & 0x200000L) >> 1) | ((self.n408 & 0x100000L) >> 1) | ((self.n408 & 0x80000L) >> 1) | ((self.n408 & 0x40000L) >> 1) | ((self.n408 & 0x20000L) >> 1) | ((self.n408 & 0x10000L) >> 1) | ((self.n408 & 0x8000L) >> 1) | ((self.n408 & 0x4000L) >> 1) | ((self.n408 & 0x2000L) >> 1) | ((self.n408 & 0x1000L) >> 1) | ((self.n408 & 0x800L) >> 1) | ((self.n408 & 0x400L) >> 1) | ((self.n408 & 0x200L) >> 1) | ((self.n408 & 0x100L) >> 1) | ((self.n408 & 0x80L) >> 1) | ((self.n408 & 0x40L) >> 1) | ((self.n408 & 0x20L) >> 1) | ((self.n408 & 0x10L) >> 1) | ((self.n408 & 0x8L) >> 1) | ((self.n408 & 0x4L) >> 1) | ((self.n408 & 0x2L) >> 1)
    self.n442 = (self.n408 & 0x40000000000L) | (self.n408 & 0x20000000000L) | (self.n408 & 0x10000000000L) | (self.n408 & 0x8000000000L) | (self.n408 & 0x4000000000L) | (self.n408 & 0x2000000000L) | (self.n408 & 0x1000000000L) | (self.n408 & 0x800000000L) | (self.n408 & 0x400000000L) | (self.n408 & 0x200000000L) | (self.n408 & 0x100000000L) | (self.n408 & 0x80000000L) | (self.n408 & 0x40000000L) | (self.n408 & 0x20000000L) | (self.n408 & 0x10000000L) | (self.n408 & 0x8000000L) | (self.n408 & 0x4000000L) | (self.n408 & 0x2000000L) | (self.n408 & 0x1000000L) | (self.n408 & 0x800000L) | (self.n408 & 0x400000L) | (self.n408 & 0x200000L) | (self.n408 & 0x100000L) | (self.n408 & 0x80000L) | (self.n408 & 0x40000L) | (self.n408 & 0x20000L) | (self.n408 & 0x10000L) | (self.n408 & 0x8000L) | (self.n408 & 0x4000L) | (self.n408 & 0x2000L) | (self.n408 & 0x1000L) | (self.n408 & 0x800L) | (self.n408 & 0x400L) | (self.n408 & 0x200L) | (self.n408 & 0x100L) | (self.n408 & 0x80L) | (self.n408 & 0x40L) | (self.n408 & 0x20L) | (self.n408 & 0x10L) | (self.n408 & 0x8L) | (self.n408 & 0x4L) | (self.n408 & 0x2L) | (self.n408 & 0x1L)
    self.n440 = (self.n405 - self.n439) & 0x1FFL
    self.n411 = (self.n405 & 0x80L) | (self.n405 & 0x40L) | (self.n405 & 0x20L) | (self.n405 & 0x10L) | (self.n405 & 0x8L) | (self.n405 & 0x4L) | (self.n405 & 0x2L) | (self.n405 & 0x1L)
    self.n410 = ((self.n405 & 0x100L) >> 8)
    self.n409 = ((self.n408 & 0x80000000000L) >> 43)
    self.n413 = (self.n411 & 0x40L) | (self.n411 & 0x20L) | (self.n411 & 0x10L) | (self.n411 & 0x8L) | (self.n411 & 0x4L) | (self.n411 & 0x2L) | (self.n411 & 0x1L)
    self.n412 = ((self.n411 & 0x80L) >> 7)
    self.n428 = self.n410 | self.n412
    self.n415 = (self.n413 & 0x20L) | (self.n413 & 0x10L) | (self.n413 & 0x8L) | (self.n413 & 0x4L) | (self.n413 & 0x2L) | (self.n413 & 0x1L)
    self.n414 = ((self.n413 & 0x40L) >> 6)
    self.n417 = (self.n415 & 0x10L) | (self.n415 & 0x8L) | (self.n415 & 0x4L) | (self.n415 & 0x2L) | (self.n415 & 0x1L)
    self.n416 = ((self.n415 & 0x20L) >> 5)
    self.n429 = self.n414 | self.n416
    self.n419 = (self.n417 & 0x8L) | (self.n417 & 0x4L) | (self.n417 & 0x2L) | (self.n417 & 0x1L)
    self.n418 = ((self.n417 & 0x10L) >> 4)
    self.n432 = self.n428 | self.n429
    self.n421 = (self.n419 & 0x4L) | (self.n419 & 0x2L) | (self.n419 & 0x1L)
    self.n420 = ((self.n419 & 0x8L) >> 3)
    self.n430 = self.n418 | self.n420
    self.n423 = (self.n421 & 0x2L) | (self.n421 & 0x1L)
    self.n422 = ((self.n421 & 0x4L) >> 2)
    self.n425 = (self.n423 & 0x1L)
    self.n424 = ((self.n423 & 0x2L) >> 1)
    self.n431 = self.n422 | self.n424
    self.n426 = (self.n425 & 0x1L)
    self.n433 = self.n430 | self.n431
    self.n434 = self.n432 | self.n433
    self.n435 = self.n434 | self.n426
    self.n436 = ~self.n435 & 0x1L
    self.n437 = self.n409 | self.n436
    self.n438 = ~self.n437 & 0x1L
    if self.n438:
      self.n444 = self.n442
    else:
      self.n444 = self.n443
    if self.n438:
      self.n441 = self.n440
    else:
      self.n441 = self.n405
    self.n479 = ((self.n444 & 0x40000000000L) >> 1) | ((self.n444 & 0x20000000000L) >> 1) | ((self.n444 & 0x10000000000L) >> 1) | ((self.n444 & 0x8000000000L) >> 1) | ((self.n444 & 0x4000000000L) >> 1) | ((self.n444 & 0x2000000000L) >> 1) | ((self.n444 & 0x1000000000L) >> 1) | ((self.n444 & 0x800000000L) >> 1) | ((self.n444 & 0x400000000L) >> 1) | ((self.n444 & 0x200000000L) >> 1) | ((self.n444 & 0x100000000L) >> 1) | ((self.n444 & 0x80000000L) >> 1) | ((self.n444 & 0x40000000L) >> 1) | ((self.n444 & 0x20000000L) >> 1) | ((self.n444 & 0x10000000L) >> 1) | ((self.n444 & 0x8000000L) >> 1) | ((self.n444 & 0x4000000L) >> 1) | ((self.n444 & 0x2000000L) >> 1) | ((self.n444 & 0x1000000L) >> 1) | ((self.n444 & 0x800000L) >> 1) | ((self.n444 & 0x400000L) >> 1) | ((self.n444 & 0x200000L) >> 1) | ((self.n444 & 0x100000L) >> 1) | ((self.n444 & 0x80000L) >> 1) | ((self.n444 & 0x40000L) >> 1) | ((self.n444 & 0x20000L) >> 1) | ((self.n444 & 0x10000L) >> 1) | ((self.n444 & 0x8000L) >> 1) | ((self.n444 & 0x4000L) >> 1) | ((self.n444 & 0x2000L) >> 1) | ((self.n444 & 0x1000L) >> 1) | ((self.n444 & 0x800L) >> 1) | ((self.n444 & 0x400L) >> 1) | ((self.n444 & 0x200L) >> 1) | ((self.n444 & 0x100L) >> 1) | ((self.n444 & 0x80L) >> 1) | ((self.n444 & 0x40L) >> 1) | ((self.n444 & 0x20L) >> 1) | ((self.n444 & 0x10L) >> 1) | ((self.n444 & 0x8L) >> 1) | ((self.n444 & 0x4L) >> 1) | ((self.n444 & 0x2L) >> 1)
    self.n478 = (self.n444 & 0x20000000000L) | (self.n444 & 0x10000000000L) | (self.n444 & 0x8000000000L) | (self.n444 & 0x4000000000L) | (self.n444 & 0x2000000000L) | (self.n444 & 0x1000000000L) | (self.n444 & 0x800000000L) | (self.n444 & 0x400000000L) | (self.n444 & 0x200000000L) | (self.n444 & 0x100000000L) | (self.n444 & 0x80000000L) | (self.n444 & 0x40000000L) | (self.n444 & 0x20000000L) | (self.n444 & 0x10000000L) | (self.n444 & 0x8000000L) | (self.n444 & 0x4000000L) | (self.n444 & 0x2000000L) | (self.n444 & 0x1000000L) | (self.n444 & 0x800000L) | (self.n444 & 0x400000L) | (self.n444 & 0x200000L) | (self.n444 & 0x100000L) | (self.n444 & 0x80000L) | (self.n444 & 0x40000L) | (self.n444 & 0x20000L) | (self.n444 & 0x10000L) | (self.n444 & 0x8000L) | (self.n444 & 0x4000L) | (self.n444 & 0x2000L) | (self.n444 & 0x1000L) | (self.n444 & 0x800L) | (self.n444 & 0x400L) | (self.n444 & 0x200L) | (self.n444 & 0x100L) | (self.n444 & 0x80L) | (self.n444 & 0x40L) | (self.n444 & 0x20L) | (self.n444 & 0x10L) | (self.n444 & 0x8L) | (self.n444 & 0x4L) | (self.n444 & 0x2L) | (self.n444 & 0x1L)
    self.n476 = (self.n441 - self.n475) & 0x1FFL
    self.n447 = (self.n441 & 0x80L) | (self.n441 & 0x40L) | (self.n441 & 0x20L) | (self.n441 & 0x10L) | (self.n441 & 0x8L) | (self.n441 & 0x4L) | (self.n441 & 0x2L) | (self.n441 & 0x1L)
    self.n446 = ((self.n441 & 0x100L) >> 8)
    self.n445 = ((self.n444 & 0x40000000000L) >> 42)
    self.n449 = (self.n447 & 0x40L) | (self.n447 & 0x20L) | (self.n447 & 0x10L) | (self.n447 & 0x8L) | (self.n447 & 0x4L) | (self.n447 & 0x2L) | (self.n447 & 0x1L)
    self.n448 = ((self.n447 & 0x80L) >> 7)
    self.n464 = self.n446 | self.n448
    self.n451 = (self.n449 & 0x20L) | (self.n449 & 0x10L) | (self.n449 & 0x8L) | (self.n449 & 0x4L) | (self.n449 & 0x2L) | (self.n449 & 0x1L)
    self.n450 = ((self.n449 & 0x40L) >> 6)
    self.n453 = (self.n451 & 0x10L) | (self.n451 & 0x8L) | (self.n451 & 0x4L) | (self.n451 & 0x2L) | (self.n451 & 0x1L)
    self.n452 = ((self.n451 & 0x20L) >> 5)
    self.n465 = self.n450 | self.n452
    self.n455 = (self.n453 & 0x8L) | (self.n453 & 0x4L) | (self.n453 & 0x2L) | (self.n453 & 0x1L)
    self.n454 = ((self.n453 & 0x10L) >> 4)
    self.n468 = self.n464 | self.n465
    self.n457 = (self.n455 & 0x4L) | (self.n455 & 0x2L) | (self.n455 & 0x1L)
    self.n456 = ((self.n455 & 0x8L) >> 3)
    self.n466 = self.n454 | self.n456
    self.n459 = (self.n457 & 0x2L) | (self.n457 & 0x1L)
    self.n458 = ((self.n457 & 0x4L) >> 2)
    self.n461 = (self.n459 & 0x1L)
    self.n460 = ((self.n459 & 0x2L) >> 1)
    self.n467 = self.n458 | self.n460
    self.n462 = (self.n461 & 0x1L)
    self.n469 = self.n466 | self.n467
    self.n470 = self.n468 | self.n469
    self.n471 = self.n470 | self.n462
    self.n472 = ~self.n471 & 0x1L
    self.n473 = self.n445 | self.n472
    self.n474 = ~self.n473 & 0x1L
    if self.n474:
      self.n480 = self.n478
    else:
      self.n480 = self.n479
    if self.n474:
      self.n477 = self.n476
    else:
      self.n477 = self.n441
    self.n515 = ((self.n480 & 0x20000000000L) >> 1) | ((self.n480 & 0x10000000000L) >> 1) | ((self.n480 & 0x8000000000L) >> 1) | ((self.n480 & 0x4000000000L) >> 1) | ((self.n480 & 0x2000000000L) >> 1) | ((self.n480 & 0x1000000000L) >> 1) | ((self.n480 & 0x800000000L) >> 1) | ((self.n480 & 0x400000000L) >> 1) | ((self.n480 & 0x200000000L) >> 1) | ((self.n480 & 0x100000000L) >> 1) | ((self.n480 & 0x80000000L) >> 1) | ((self.n480 & 0x40000000L) >> 1) | ((self.n480 & 0x20000000L) >> 1) | ((self.n480 & 0x10000000L) >> 1) | ((self.n480 & 0x8000000L) >> 1) | ((self.n480 & 0x4000000L) >> 1) | ((self.n480 & 0x2000000L) >> 1) | ((self.n480 & 0x1000000L) >> 1) | ((self.n480 & 0x800000L) >> 1) | ((self.n480 & 0x400000L) >> 1) | ((self.n480 & 0x200000L) >> 1) | ((self.n480 & 0x100000L) >> 1) | ((self.n480 & 0x80000L) >> 1) | ((self.n480 & 0x40000L) >> 1) | ((self.n480 & 0x20000L) >> 1) | ((self.n480 & 0x10000L) >> 1) | ((self.n480 & 0x8000L) >> 1) | ((self.n480 & 0x4000L) >> 1) | ((self.n480 & 0x2000L) >> 1) | ((self.n480 & 0x1000L) >> 1) | ((self.n480 & 0x800L) >> 1) | ((self.n480 & 0x400L) >> 1) | ((self.n480 & 0x200L) >> 1) | ((self.n480 & 0x100L) >> 1) | ((self.n480 & 0x80L) >> 1) | ((self.n480 & 0x40L) >> 1) | ((self.n480 & 0x20L) >> 1) | ((self.n480 & 0x10L) >> 1) | ((self.n480 & 0x8L) >> 1) | ((self.n480 & 0x4L) >> 1) | ((self.n480 & 0x2L) >> 1)
    self.n514 = (self.n480 & 0x10000000000L) | (self.n480 & 0x8000000000L) | (self.n480 & 0x4000000000L) | (self.n480 & 0x2000000000L) | (self.n480 & 0x1000000000L) | (self.n480 & 0x800000000L) | (self.n480 & 0x400000000L) | (self.n480 & 0x200000000L) | (self.n480 & 0x100000000L) | (self.n480 & 0x80000000L) | (self.n480 & 0x40000000L) | (self.n480 & 0x20000000L) | (self.n480 & 0x10000000L) | (self.n480 & 0x8000000L) | (self.n480 & 0x4000000L) | (self.n480 & 0x2000000L) | (self.n480 & 0x1000000L) | (self.n480 & 0x800000L) | (self.n480 & 0x400000L) | (self.n480 & 0x200000L) | (self.n480 & 0x100000L) | (self.n480 & 0x80000L) | (self.n480 & 0x40000L) | (self.n480 & 0x20000L) | (self.n480 & 0x10000L) | (self.n480 & 0x8000L) | (self.n480 & 0x4000L) | (self.n480 & 0x2000L) | (self.n480 & 0x1000L) | (self.n480 & 0x800L) | (self.n480 & 0x400L) | (self.n480 & 0x200L) | (self.n480 & 0x100L) | (self.n480 & 0x80L) | (self.n480 & 0x40L) | (self.n480 & 0x20L) | (self.n480 & 0x10L) | (self.n480 & 0x8L) | (self.n480 & 0x4L) | (self.n480 & 0x2L) | (self.n480 & 0x1L)
    self.n512 = (self.n477 - self.n511) & 0x1FFL
    self.n483 = (self.n477 & 0x80L) | (self.n477 & 0x40L) | (self.n477 & 0x20L) | (self.n477 & 0x10L) | (self.n477 & 0x8L) | (self.n477 & 0x4L) | (self.n477 & 0x2L) | (self.n477 & 0x1L)
    self.n482 = ((self.n477 & 0x100L) >> 8)
    self.n481 = ((self.n480 & 0x20000000000L) >> 41)
    self.n485 = (self.n483 & 0x40L) | (self.n483 & 0x20L) | (self.n483 & 0x10L) | (self.n483 & 0x8L) | (self.n483 & 0x4L) | (self.n483 & 0x2L) | (self.n483 & 0x1L)
    self.n484 = ((self.n483 & 0x80L) >> 7)
    self.n500 = self.n482 | self.n484
    self.n487 = (self.n485 & 0x20L) | (self.n485 & 0x10L) | (self.n485 & 0x8L) | (self.n485 & 0x4L) | (self.n485 & 0x2L) | (self.n485 & 0x1L)
    self.n486 = ((self.n485 & 0x40L) >> 6)
    self.n489 = (self.n487 & 0x10L) | (self.n487 & 0x8L) | (self.n487 & 0x4L) | (self.n487 & 0x2L) | (self.n487 & 0x1L)
    self.n488 = ((self.n487 & 0x20L) >> 5)
    self.n501 = self.n486 | self.n488
    self.n491 = (self.n489 & 0x8L) | (self.n489 & 0x4L) | (self.n489 & 0x2L) | (self.n489 & 0x1L)
    self.n490 = ((self.n489 & 0x10L) >> 4)
    self.n504 = self.n500 | self.n501
    self.n493 = (self.n491 & 0x4L) | (self.n491 & 0x2L) | (self.n491 & 0x1L)
    self.n492 = ((self.n491 & 0x8L) >> 3)
    self.n502 = self.n490 | self.n492
    self.n495 = (self.n493 & 0x2L) | (self.n493 & 0x1L)
    self.n494 = ((self.n493 & 0x4L) >> 2)
    self.n497 = (self.n495 & 0x1L)
    self.n496 = ((self.n495 & 0x2L) >> 1)
    self.n503 = self.n494 | self.n496
    self.n498 = (self.n497 & 0x1L)
    self.n505 = self.n502 | self.n503
    self.n506 = self.n504 | self.n505
    self.n507 = self.n506 | self.n498
    self.n508 = ~self.n507 & 0x1L
    self.n509 = self.n481 | self.n508
    self.n510 = ~self.n509 & 0x1L
    if self.n510:
      self.n516 = self.n514
    else:
      self.n516 = self.n515
    if self.n510:
      self.n513 = self.n512
    else:
      self.n513 = self.n477
    self.n551 = ((self.n516 & 0x10000000000L) >> 1) | ((self.n516 & 0x8000000000L) >> 1) | ((self.n516 & 0x4000000000L) >> 1) | ((self.n516 & 0x2000000000L) >> 1) | ((self.n516 & 0x1000000000L) >> 1) | ((self.n516 & 0x800000000L) >> 1) | ((self.n516 & 0x400000000L) >> 1) | ((self.n516 & 0x200000000L) >> 1) | ((self.n516 & 0x100000000L) >> 1) | ((self.n516 & 0x80000000L) >> 1) | ((self.n516 & 0x40000000L) >> 1) | ((self.n516 & 0x20000000L) >> 1) | ((self.n516 & 0x10000000L) >> 1) | ((self.n516 & 0x8000000L) >> 1) | ((self.n516 & 0x4000000L) >> 1) | ((self.n516 & 0x2000000L) >> 1) | ((self.n516 & 0x1000000L) >> 1) | ((self.n516 & 0x800000L) >> 1) | ((self.n516 & 0x400000L) >> 1) | ((self.n516 & 0x200000L) >> 1) | ((self.n516 & 0x100000L) >> 1) | ((self.n516 & 0x80000L) >> 1) | ((self.n516 & 0x40000L) >> 1) | ((self.n516 & 0x20000L) >> 1) | ((self.n516 & 0x10000L) >> 1) | ((self.n516 & 0x8000L) >> 1) | ((self.n516 & 0x4000L) >> 1) | ((self.n516 & 0x2000L) >> 1) | ((self.n516 & 0x1000L) >> 1) | ((self.n516 & 0x800L) >> 1) | ((self.n516 & 0x400L) >> 1) | ((self.n516 & 0x200L) >> 1) | ((self.n516 & 0x100L) >> 1) | ((self.n516 & 0x80L) >> 1) | ((self.n516 & 0x40L) >> 1) | ((self.n516 & 0x20L) >> 1) | ((self.n516 & 0x10L) >> 1) | ((self.n516 & 0x8L) >> 1) | ((self.n516 & 0x4L) >> 1) | ((self.n516 & 0x2L) >> 1)
    self.n550 = (self.n516 & 0x8000000000L) | (self.n516 & 0x4000000000L) | (self.n516 & 0x2000000000L) | (self.n516 & 0x1000000000L) | (self.n516 & 0x800000000L) | (self.n516 & 0x400000000L) | (self.n516 & 0x200000000L) | (self.n516 & 0x100000000L) | (self.n516 & 0x80000000L) | (self.n516 & 0x40000000L) | (self.n516 & 0x20000000L) | (self.n516 & 0x10000000L) | (self.n516 & 0x8000000L) | (self.n516 & 0x4000000L) | (self.n516 & 0x2000000L) | (self.n516 & 0x1000000L) | (self.n516 & 0x800000L) | (self.n516 & 0x400000L) | (self.n516 & 0x200000L) | (self.n516 & 0x100000L) | (self.n516 & 0x80000L) | (self.n516 & 0x40000L) | (self.n516 & 0x20000L) | (self.n516 & 0x10000L) | (self.n516 & 0x8000L) | (self.n516 & 0x4000L) | (self.n516 & 0x2000L) | (self.n516 & 0x1000L) | (self.n516 & 0x800L) | (self.n516 & 0x400L) | (self.n516 & 0x200L) | (self.n516 & 0x100L) | (self.n516 & 0x80L) | (self.n516 & 0x40L) | (self.n516 & 0x20L) | (self.n516 & 0x10L) | (self.n516 & 0x8L) | (self.n516 & 0x4L) | (self.n516 & 0x2L) | (self.n516 & 0x1L)
    self.n548 = (self.n513 - self.n547) & 0x1FFL
    self.n519 = (self.n513 & 0x80L) | (self.n513 & 0x40L) | (self.n513 & 0x20L) | (self.n513 & 0x10L) | (self.n513 & 0x8L) | (self.n513 & 0x4L) | (self.n513 & 0x2L) | (self.n513 & 0x1L)
    self.n518 = ((self.n513 & 0x100L) >> 8)
    self.n517 = ((self.n516 & 0x10000000000L) >> 40)
    self.n521 = (self.n519 & 0x40L) | (self.n519 & 0x20L) | (self.n519 & 0x10L) | (self.n519 & 0x8L) | (self.n519 & 0x4L) | (self.n519 & 0x2L) | (self.n519 & 0x1L)
    self.n520 = ((self.n519 & 0x80L) >> 7)
    self.n536 = self.n518 | self.n520
    self.n523 = (self.n521 & 0x20L) | (self.n521 & 0x10L) | (self.n521 & 0x8L) | (self.n521 & 0x4L) | (self.n521 & 0x2L) | (self.n521 & 0x1L)
    self.n522 = ((self.n521 & 0x40L) >> 6)
    self.n525 = (self.n523 & 0x10L) | (self.n523 & 0x8L) | (self.n523 & 0x4L) | (self.n523 & 0x2L) | (self.n523 & 0x1L)
    self.n524 = ((self.n523 & 0x20L) >> 5)
    self.n537 = self.n522 | self.n524
    self.n527 = (self.n525 & 0x8L) | (self.n525 & 0x4L) | (self.n525 & 0x2L) | (self.n525 & 0x1L)
    self.n526 = ((self.n525 & 0x10L) >> 4)
    self.n540 = self.n536 | self.n537
    self.n529 = (self.n527 & 0x4L) | (self.n527 & 0x2L) | (self.n527 & 0x1L)
    self.n528 = ((self.n527 & 0x8L) >> 3)
    self.n538 = self.n526 | self.n528
    self.n531 = (self.n529 & 0x2L) | (self.n529 & 0x1L)
    self.n530 = ((self.n529 & 0x4L) >> 2)
    self.n533 = (self.n531 & 0x1L)
    self.n532 = ((self.n531 & 0x2L) >> 1)
    self.n539 = self.n530 | self.n532
    self.n534 = (self.n533 & 0x1L)
    self.n541 = self.n538 | self.n539
    self.n542 = self.n540 | self.n541
    self.n543 = self.n542 | self.n534
    self.n544 = ~self.n543 & 0x1L
    self.n545 = self.n517 | self.n544
    self.n546 = ~self.n545 & 0x1L
    if self.n546:
      self.n552 = self.n550
    else:
      self.n552 = self.n551
    if self.n546:
      self.n549 = self.n548
    else:
      self.n549 = self.n513
    self.n587 = ((self.n552 & 0x8000000000L) >> 1) | ((self.n552 & 0x4000000000L) >> 1) | ((self.n552 & 0x2000000000L) >> 1) | ((self.n552 & 0x1000000000L) >> 1) | ((self.n552 & 0x800000000L) >> 1) | ((self.n552 & 0x400000000L) >> 1) | ((self.n552 & 0x200000000L) >> 1) | ((self.n552 & 0x100000000L) >> 1) | ((self.n552 & 0x80000000L) >> 1) | ((self.n552 & 0x40000000L) >> 1) | ((self.n552 & 0x20000000L) >> 1) | ((self.n552 & 0x10000000L) >> 1) | ((self.n552 & 0x8000000L) >> 1) | ((self.n552 & 0x4000000L) >> 1) | ((self.n552 & 0x2000000L) >> 1) | ((self.n552 & 0x1000000L) >> 1) | ((self.n552 & 0x800000L) >> 1) | ((self.n552 & 0x400000L) >> 1) | ((self.n552 & 0x200000L) >> 1) | ((self.n552 & 0x100000L) >> 1) | ((self.n552 & 0x80000L) >> 1) | ((self.n552 & 0x40000L) >> 1) | ((self.n552 & 0x20000L) >> 1) | ((self.n552 & 0x10000L) >> 1) | ((self.n552 & 0x8000L) >> 1) | ((self.n552 & 0x4000L) >> 1) | ((self.n552 & 0x2000L) >> 1) | ((self.n552 & 0x1000L) >> 1) | ((self.n552 & 0x800L) >> 1) | ((self.n552 & 0x400L) >> 1) | ((self.n552 & 0x200L) >> 1) | ((self.n552 & 0x100L) >> 1) | ((self.n552 & 0x80L) >> 1) | ((self.n552 & 0x40L) >> 1) | ((self.n552 & 0x20L) >> 1) | ((self.n552 & 0x10L) >> 1) | ((self.n552 & 0x8L) >> 1) | ((self.n552 & 0x4L) >> 1) | ((self.n552 & 0x2L) >> 1)
    self.n586 = (self.n552 & 0x4000000000L) | (self.n552 & 0x2000000000L) | (self.n552 & 0x1000000000L) | (self.n552 & 0x800000000L) | (self.n552 & 0x400000000L) | (self.n552 & 0x200000000L) | (self.n552 & 0x100000000L) | (self.n552 & 0x80000000L) | (self.n552 & 0x40000000L) | (self.n552 & 0x20000000L) | (self.n552 & 0x10000000L) | (self.n552 & 0x8000000L) | (self.n552 & 0x4000000L) | (self.n552 & 0x2000000L) | (self.n552 & 0x1000000L) | (self.n552 & 0x800000L) | (self.n552 & 0x400000L) | (self.n552 & 0x200000L) | (self.n552 & 0x100000L) | (self.n552 & 0x80000L) | (self.n552 & 0x40000L) | (self.n552 & 0x20000L) | (self.n552 & 0x10000L) | (self.n552 & 0x8000L) | (self.n552 & 0x4000L) | (self.n552 & 0x2000L) | (self.n552 & 0x1000L) | (self.n552 & 0x800L) | (self.n552 & 0x400L) | (self.n552 & 0x200L) | (self.n552 & 0x100L) | (self.n552 & 0x80L) | (self.n552 & 0x40L) | (self.n552 & 0x20L) | (self.n552 & 0x10L) | (self.n552 & 0x8L) | (self.n552 & 0x4L) | (self.n552 & 0x2L) | (self.n552 & 0x1L)
    self.n584 = (self.n549 - self.n583) & 0x1FFL
    self.n555 = (self.n549 & 0x80L) | (self.n549 & 0x40L) | (self.n549 & 0x20L) | (self.n549 & 0x10L) | (self.n549 & 0x8L) | (self.n549 & 0x4L) | (self.n549 & 0x2L) | (self.n549 & 0x1L)
    self.n554 = ((self.n549 & 0x100L) >> 8)
    self.n553 = ((self.n552 & 0x8000000000L) >> 39)
    self.n557 = (self.n555 & 0x40L) | (self.n555 & 0x20L) | (self.n555 & 0x10L) | (self.n555 & 0x8L) | (self.n555 & 0x4L) | (self.n555 & 0x2L) | (self.n555 & 0x1L)
    self.n556 = ((self.n555 & 0x80L) >> 7)
    self.n572 = self.n554 | self.n556
    self.n559 = (self.n557 & 0x20L) | (self.n557 & 0x10L) | (self.n557 & 0x8L) | (self.n557 & 0x4L) | (self.n557 & 0x2L) | (self.n557 & 0x1L)
    self.n558 = ((self.n557 & 0x40L) >> 6)
    self.n561 = (self.n559 & 0x10L) | (self.n559 & 0x8L) | (self.n559 & 0x4L) | (self.n559 & 0x2L) | (self.n559 & 0x1L)
    self.n560 = ((self.n559 & 0x20L) >> 5)
    self.n573 = self.n558 | self.n560
    self.n563 = (self.n561 & 0x8L) | (self.n561 & 0x4L) | (self.n561 & 0x2L) | (self.n561 & 0x1L)
    self.n562 = ((self.n561 & 0x10L) >> 4)
    self.n576 = self.n572 | self.n573
    self.n565 = (self.n563 & 0x4L) | (self.n563 & 0x2L) | (self.n563 & 0x1L)
    self.n564 = ((self.n563 & 0x8L) >> 3)
    self.n574 = self.n562 | self.n564
    self.n567 = (self.n565 & 0x2L) | (self.n565 & 0x1L)
    self.n566 = ((self.n565 & 0x4L) >> 2)
    self.n569 = (self.n567 & 0x1L)
    self.n568 = ((self.n567 & 0x2L) >> 1)
    self.n575 = self.n566 | self.n568
    self.n570 = (self.n569 & 0x1L)
    self.n577 = self.n574 | self.n575
    self.n578 = self.n576 | self.n577
    self.n579 = self.n578 | self.n570
    self.n580 = ~self.n579 & 0x1L
    self.n581 = self.n553 | self.n580
    self.n582 = ~self.n581 & 0x1L
    if self.n582:
      self.n588 = self.n586
    else:
      self.n588 = self.n587
    if self.n582:
      self.n585 = self.n584
    else:
      self.n585 = self.n549
    self.n623 = ((self.n588 & 0x4000000000L) >> 1) | ((self.n588 & 0x2000000000L) >> 1) | ((self.n588 & 0x1000000000L) >> 1) | ((self.n588 & 0x800000000L) >> 1) | ((self.n588 & 0x400000000L) >> 1) | ((self.n588 & 0x200000000L) >> 1) | ((self.n588 & 0x100000000L) >> 1) | ((self.n588 & 0x80000000L) >> 1) | ((self.n588 & 0x40000000L) >> 1) | ((self.n588 & 0x20000000L) >> 1) | ((self.n588 & 0x10000000L) >> 1) | ((self.n588 & 0x8000000L) >> 1) | ((self.n588 & 0x4000000L) >> 1) | ((self.n588 & 0x2000000L) >> 1) | ((self.n588 & 0x1000000L) >> 1) | ((self.n588 & 0x800000L) >> 1) | ((self.n588 & 0x400000L) >> 1) | ((self.n588 & 0x200000L) >> 1) | ((self.n588 & 0x100000L) >> 1) | ((self.n588 & 0x80000L) >> 1) | ((self.n588 & 0x40000L) >> 1) | ((self.n588 & 0x20000L) >> 1) | ((self.n588 & 0x10000L) >> 1) | ((self.n588 & 0x8000L) >> 1) | ((self.n588 & 0x4000L) >> 1) | ((self.n588 & 0x2000L) >> 1) | ((self.n588 & 0x1000L) >> 1) | ((self.n588 & 0x800L) >> 1) | ((self.n588 & 0x400L) >> 1) | ((self.n588 & 0x200L) >> 1) | ((self.n588 & 0x100L) >> 1) | ((self.n588 & 0x80L) >> 1) | ((self.n588 & 0x40L) >> 1) | ((self.n588 & 0x20L) >> 1) | ((self.n588 & 0x10L) >> 1) | ((self.n588 & 0x8L) >> 1) | ((self.n588 & 0x4L) >> 1) | ((self.n588 & 0x2L) >> 1)
    self.n622 = (self.n588 & 0x2000000000L) | (self.n588 & 0x1000000000L) | (self.n588 & 0x800000000L) | (self.n588 & 0x400000000L) | (self.n588 & 0x200000000L) | (self.n588 & 0x100000000L) | (self.n588 & 0x80000000L) | (self.n588 & 0x40000000L) | (self.n588 & 0x20000000L) | (self.n588 & 0x10000000L) | (self.n588 & 0x8000000L) | (self.n588 & 0x4000000L) | (self.n588 & 0x2000000L) | (self.n588 & 0x1000000L) | (self.n588 & 0x800000L) | (self.n588 & 0x400000L) | (self.n588 & 0x200000L) | (self.n588 & 0x100000L) | (self.n588 & 0x80000L) | (self.n588 & 0x40000L) | (self.n588 & 0x20000L) | (self.n588 & 0x10000L) | (self.n588 & 0x8000L) | (self.n588 & 0x4000L) | (self.n588 & 0x2000L) | (self.n588 & 0x1000L) | (self.n588 & 0x800L) | (self.n588 & 0x400L) | (self.n588 & 0x200L) | (self.n588 & 0x100L) | (self.n588 & 0x80L) | (self.n588 & 0x40L) | (self.n588 & 0x20L) | (self.n588 & 0x10L) | (self.n588 & 0x8L) | (self.n588 & 0x4L) | (self.n588 & 0x2L) | (self.n588 & 0x1L)
    self.n620 = (self.n585 - self.n619) & 0x1FFL
    self.n591 = (self.n585 & 0x80L) | (self.n585 & 0x40L) | (self.n585 & 0x20L) | (self.n585 & 0x10L) | (self.n585 & 0x8L) | (self.n585 & 0x4L) | (self.n585 & 0x2L) | (self.n585 & 0x1L)
    self.n590 = ((self.n585 & 0x100L) >> 8)
    self.n589 = ((self.n588 & 0x4000000000L) >> 38)
    self.n593 = (self.n591 & 0x40L) | (self.n591 & 0x20L) | (self.n591 & 0x10L) | (self.n591 & 0x8L) | (self.n591 & 0x4L) | (self.n591 & 0x2L) | (self.n591 & 0x1L)
    self.n592 = ((self.n591 & 0x80L) >> 7)
    self.n608 = self.n590 | self.n592
    self.n595 = (self.n593 & 0x20L) | (self.n593 & 0x10L) | (self.n593 & 0x8L) | (self.n593 & 0x4L) | (self.n593 & 0x2L) | (self.n593 & 0x1L)
    self.n594 = ((self.n593 & 0x40L) >> 6)
    self.n597 = (self.n595 & 0x10L) | (self.n595 & 0x8L) | (self.n595 & 0x4L) | (self.n595 & 0x2L) | (self.n595 & 0x1L)
    self.n596 = ((self.n595 & 0x20L) >> 5)
    self.n609 = self.n594 | self.n596
    self.n599 = (self.n597 & 0x8L) | (self.n597 & 0x4L) | (self.n597 & 0x2L) | (self.n597 & 0x1L)
    self.n598 = ((self.n597 & 0x10L) >> 4)
    self.n612 = self.n608 | self.n609
    self.n601 = (self.n599 & 0x4L) | (self.n599 & 0x2L) | (self.n599 & 0x1L)
    self.n600 = ((self.n599 & 0x8L) >> 3)
    self.n610 = self.n598 | self.n600
    self.n603 = (self.n601 & 0x2L) | (self.n601 & 0x1L)
    self.n602 = ((self.n601 & 0x4L) >> 2)
    self.n605 = (self.n603 & 0x1L)
    self.n604 = ((self.n603 & 0x2L) >> 1)
    self.n611 = self.n602 | self.n604
    self.n606 = (self.n605 & 0x1L)
    self.n613 = self.n610 | self.n611
    self.n614 = self.n612 | self.n613
    self.n615 = self.n614 | self.n606
    self.n616 = ~self.n615 & 0x1L
    self.n617 = self.n589 | self.n616
    self.n618 = ~self.n617 & 0x1L
    if self.n618:
      self.n624 = self.n622
    else:
      self.n624 = self.n623
    if self.n618:
      self.n621 = self.n620
    else:
      self.n621 = self.n585
    self.n659 = ((self.n624 & 0x2000000000L) >> 1) | ((self.n624 & 0x1000000000L) >> 1) | ((self.n624 & 0x800000000L) >> 1) | ((self.n624 & 0x400000000L) >> 1) | ((self.n624 & 0x200000000L) >> 1) | ((self.n624 & 0x100000000L) >> 1) | ((self.n624 & 0x80000000L) >> 1) | ((self.n624 & 0x40000000L) >> 1) | ((self.n624 & 0x20000000L) >> 1) | ((self.n624 & 0x10000000L) >> 1) | ((self.n624 & 0x8000000L) >> 1) | ((self.n624 & 0x4000000L) >> 1) | ((self.n624 & 0x2000000L) >> 1) | ((self.n624 & 0x1000000L) >> 1) | ((self.n624 & 0x800000L) >> 1) | ((self.n624 & 0x400000L) >> 1) | ((self.n624 & 0x200000L) >> 1) | ((self.n624 & 0x100000L) >> 1) | ((self.n624 & 0x80000L) >> 1) | ((self.n624 & 0x40000L) >> 1) | ((self.n624 & 0x20000L) >> 1) | ((self.n624 & 0x10000L) >> 1) | ((self.n624 & 0x8000L) >> 1) | ((self.n624 & 0x4000L) >> 1) | ((self.n624 & 0x2000L) >> 1) | ((self.n624 & 0x1000L) >> 1) | ((self.n624 & 0x800L) >> 1) | ((self.n624 & 0x400L) >> 1) | ((self.n624 & 0x200L) >> 1) | ((self.n624 & 0x100L) >> 1) | ((self.n624 & 0x80L) >> 1) | ((self.n624 & 0x40L) >> 1) | ((self.n624 & 0x20L) >> 1) | ((self.n624 & 0x10L) >> 1) | ((self.n624 & 0x8L) >> 1) | ((self.n624 & 0x4L) >> 1) | ((self.n624 & 0x2L) >> 1)
    self.n658 = (self.n624 & 0x1000000000L) | (self.n624 & 0x800000000L) | (self.n624 & 0x400000000L) | (self.n624 & 0x200000000L) | (self.n624 & 0x100000000L) | (self.n624 & 0x80000000L) | (self.n624 & 0x40000000L) | (self.n624 & 0x20000000L) | (self.n624 & 0x10000000L) | (self.n624 & 0x8000000L) | (self.n624 & 0x4000000L) | (self.n624 & 0x2000000L) | (self.n624 & 0x1000000L) | (self.n624 & 0x800000L) | (self.n624 & 0x400000L) | (self.n624 & 0x200000L) | (self.n624 & 0x100000L) | (self.n624 & 0x80000L) | (self.n624 & 0x40000L) | (self.n624 & 0x20000L) | (self.n624 & 0x10000L) | (self.n624 & 0x8000L) | (self.n624 & 0x4000L) | (self.n624 & 0x2000L) | (self.n624 & 0x1000L) | (self.n624 & 0x800L) | (self.n624 & 0x400L) | (self.n624 & 0x200L) | (self.n624 & 0x100L) | (self.n624 & 0x80L) | (self.n624 & 0x40L) | (self.n624 & 0x20L) | (self.n624 & 0x10L) | (self.n624 & 0x8L) | (self.n624 & 0x4L) | (self.n624 & 0x2L) | (self.n624 & 0x1L)
    self.n656 = (self.n621 - self.n655) & 0x1FFL
    self.n627 = (self.n621 & 0x80L) | (self.n621 & 0x40L) | (self.n621 & 0x20L) | (self.n621 & 0x10L) | (self.n621 & 0x8L) | (self.n621 & 0x4L) | (self.n621 & 0x2L) | (self.n621 & 0x1L)
    self.n626 = ((self.n621 & 0x100L) >> 8)
    self.n625 = ((self.n624 & 0x2000000000L) >> 37)
    self.n629 = (self.n627 & 0x40L) | (self.n627 & 0x20L) | (self.n627 & 0x10L) | (self.n627 & 0x8L) | (self.n627 & 0x4L) | (self.n627 & 0x2L) | (self.n627 & 0x1L)
    self.n628 = ((self.n627 & 0x80L) >> 7)
    self.n644 = self.n626 | self.n628
    self.n631 = (self.n629 & 0x20L) | (self.n629 & 0x10L) | (self.n629 & 0x8L) | (self.n629 & 0x4L) | (self.n629 & 0x2L) | (self.n629 & 0x1L)
    self.n630 = ((self.n629 & 0x40L) >> 6)
    self.n633 = (self.n631 & 0x10L) | (self.n631 & 0x8L) | (self.n631 & 0x4L) | (self.n631 & 0x2L) | (self.n631 & 0x1L)
    self.n632 = ((self.n631 & 0x20L) >> 5)
    self.n645 = self.n630 | self.n632
    self.n635 = (self.n633 & 0x8L) | (self.n633 & 0x4L) | (self.n633 & 0x2L) | (self.n633 & 0x1L)
    self.n634 = ((self.n633 & 0x10L) >> 4)
    self.n648 = self.n644 | self.n645
    self.n637 = (self.n635 & 0x4L) | (self.n635 & 0x2L) | (self.n635 & 0x1L)
    self.n636 = ((self.n635 & 0x8L) >> 3)
    self.n646 = self.n634 | self.n636
    self.n639 = (self.n637 & 0x2L) | (self.n637 & 0x1L)
    self.n638 = ((self.n637 & 0x4L) >> 2)
    self.n641 = (self.n639 & 0x1L)
    self.n640 = ((self.n639 & 0x2L) >> 1)
    self.n647 = self.n638 | self.n640
    self.n642 = (self.n641 & 0x1L)
    self.n649 = self.n646 | self.n647
    self.n650 = self.n648 | self.n649
    self.n651 = self.n650 | self.n642
    self.n652 = ~self.n651 & 0x1L
    self.n653 = self.n625 | self.n652
    self.n654 = ~self.n653 & 0x1L
    if self.n654:
      self.n660 = self.n658
    else:
      self.n660 = self.n659
    if self.n654:
      self.n657 = self.n656
    else:
      self.n657 = self.n621
    self.n695 = ((self.n660 & 0x1000000000L) >> 1) | ((self.n660 & 0x800000000L) >> 1) | ((self.n660 & 0x400000000L) >> 1) | ((self.n660 & 0x200000000L) >> 1) | ((self.n660 & 0x100000000L) >> 1) | ((self.n660 & 0x80000000L) >> 1) | ((self.n660 & 0x40000000L) >> 1) | ((self.n660 & 0x20000000L) >> 1) | ((self.n660 & 0x10000000L) >> 1) | ((self.n660 & 0x8000000L) >> 1) | ((self.n660 & 0x4000000L) >> 1) | ((self.n660 & 0x2000000L) >> 1) | ((self.n660 & 0x1000000L) >> 1) | ((self.n660 & 0x800000L) >> 1) | ((self.n660 & 0x400000L) >> 1) | ((self.n660 & 0x200000L) >> 1) | ((self.n660 & 0x100000L) >> 1) | ((self.n660 & 0x80000L) >> 1) | ((self.n660 & 0x40000L) >> 1) | ((self.n660 & 0x20000L) >> 1) | ((self.n660 & 0x10000L) >> 1) | ((self.n660 & 0x8000L) >> 1) | ((self.n660 & 0x4000L) >> 1) | ((self.n660 & 0x2000L) >> 1) | ((self.n660 & 0x1000L) >> 1) | ((self.n660 & 0x800L) >> 1) | ((self.n660 & 0x400L) >> 1) | ((self.n660 & 0x200L) >> 1) | ((self.n660 & 0x100L) >> 1) | ((self.n660 & 0x80L) >> 1) | ((self.n660 & 0x40L) >> 1) | ((self.n660 & 0x20L) >> 1) | ((self.n660 & 0x10L) >> 1) | ((self.n660 & 0x8L) >> 1) | ((self.n660 & 0x4L) >> 1) | ((self.n660 & 0x2L) >> 1)
    self.n694 = (self.n660 & 0x800000000L) | (self.n660 & 0x400000000L) | (self.n660 & 0x200000000L) | (self.n660 & 0x100000000L) | (self.n660 & 0x80000000L) | (self.n660 & 0x40000000L) | (self.n660 & 0x20000000L) | (self.n660 & 0x10000000L) | (self.n660 & 0x8000000L) | (self.n660 & 0x4000000L) | (self.n660 & 0x2000000L) | (self.n660 & 0x1000000L) | (self.n660 & 0x800000L) | (self.n660 & 0x400000L) | (self.n660 & 0x200000L) | (self.n660 & 0x100000L) | (self.n660 & 0x80000L) | (self.n660 & 0x40000L) | (self.n660 & 0x20000L) | (self.n660 & 0x10000L) | (self.n660 & 0x8000L) | (self.n660 & 0x4000L) | (self.n660 & 0x2000L) | (self.n660 & 0x1000L) | (self.n660 & 0x800L) | (self.n660 & 0x400L) | (self.n660 & 0x200L) | (self.n660 & 0x100L) | (self.n660 & 0x80L) | (self.n660 & 0x40L) | (self.n660 & 0x20L) | (self.n660 & 0x10L) | (self.n660 & 0x8L) | (self.n660 & 0x4L) | (self.n660 & 0x2L) | (self.n660 & 0x1L)
    self.n692 = (self.n657 - self.n691) & 0x1FFL
    self.n663 = (self.n657 & 0x80L) | (self.n657 & 0x40L) | (self.n657 & 0x20L) | (self.n657 & 0x10L) | (self.n657 & 0x8L) | (self.n657 & 0x4L) | (self.n657 & 0x2L) | (self.n657 & 0x1L)
    self.n662 = ((self.n657 & 0x100L) >> 8)
    self.n661 = ((self.n660 & 0x1000000000L) >> 36)
    self.n665 = (self.n663 & 0x40L) | (self.n663 & 0x20L) | (self.n663 & 0x10L) | (self.n663 & 0x8L) | (self.n663 & 0x4L) | (self.n663 & 0x2L) | (self.n663 & 0x1L)
    self.n664 = ((self.n663 & 0x80L) >> 7)
    self.n680 = self.n662 | self.n664
    self.n667 = (self.n665 & 0x20L) | (self.n665 & 0x10L) | (self.n665 & 0x8L) | (self.n665 & 0x4L) | (self.n665 & 0x2L) | (self.n665 & 0x1L)
    self.n666 = ((self.n665 & 0x40L) >> 6)
    self.n669 = (self.n667 & 0x10L) | (self.n667 & 0x8L) | (self.n667 & 0x4L) | (self.n667 & 0x2L) | (self.n667 & 0x1L)
    self.n668 = ((self.n667 & 0x20L) >> 5)
    self.n681 = self.n666 | self.n668
    self.n671 = (self.n669 & 0x8L) | (self.n669 & 0x4L) | (self.n669 & 0x2L) | (self.n669 & 0x1L)
    self.n670 = ((self.n669 & 0x10L) >> 4)
    self.n684 = self.n680 | self.n681
    self.n673 = (self.n671 & 0x4L) | (self.n671 & 0x2L) | (self.n671 & 0x1L)
    self.n672 = ((self.n671 & 0x8L) >> 3)
    self.n682 = self.n670 | self.n672
    self.n675 = (self.n673 & 0x2L) | (self.n673 & 0x1L)
    self.n674 = ((self.n673 & 0x4L) >> 2)
    self.n677 = (self.n675 & 0x1L)
    self.n676 = ((self.n675 & 0x2L) >> 1)
    self.n683 = self.n674 | self.n676
    self.n678 = (self.n677 & 0x1L)
    self.n685 = self.n682 | self.n683
    self.n686 = self.n684 | self.n685
    self.n687 = self.n686 | self.n678
    self.n688 = ~self.n687 & 0x1L
    self.n689 = self.n661 | self.n688
    self.n690 = ~self.n689 & 0x1L
    if self.n690:
      self.n696 = self.n694
    else:
      self.n696 = self.n695
    if self.n690:
      self.n693 = self.n692
    else:
      self.n693 = self.n657
    self.n731 = ((self.n696 & 0x800000000L) >> 1) | ((self.n696 & 0x400000000L) >> 1) | ((self.n696 & 0x200000000L) >> 1) | ((self.n696 & 0x100000000L) >> 1) | ((self.n696 & 0x80000000L) >> 1) | ((self.n696 & 0x40000000L) >> 1) | ((self.n696 & 0x20000000L) >> 1) | ((self.n696 & 0x10000000L) >> 1) | ((self.n696 & 0x8000000L) >> 1) | ((self.n696 & 0x4000000L) >> 1) | ((self.n696 & 0x2000000L) >> 1) | ((self.n696 & 0x1000000L) >> 1) | ((self.n696 & 0x800000L) >> 1) | ((self.n696 & 0x400000L) >> 1) | ((self.n696 & 0x200000L) >> 1) | ((self.n696 & 0x100000L) >> 1) | ((self.n696 & 0x80000L) >> 1) | ((self.n696 & 0x40000L) >> 1) | ((self.n696 & 0x20000L) >> 1) | ((self.n696 & 0x10000L) >> 1) | ((self.n696 & 0x8000L) >> 1) | ((self.n696 & 0x4000L) >> 1) | ((self.n696 & 0x2000L) >> 1) | ((self.n696 & 0x1000L) >> 1) | ((self.n696 & 0x800L) >> 1) | ((self.n696 & 0x400L) >> 1) | ((self.n696 & 0x200L) >> 1) | ((self.n696 & 0x100L) >> 1) | ((self.n696 & 0x80L) >> 1) | ((self.n696 & 0x40L) >> 1) | ((self.n696 & 0x20L) >> 1) | ((self.n696 & 0x10L) >> 1) | ((self.n696 & 0x8L) >> 1) | ((self.n696 & 0x4L) >> 1) | ((self.n696 & 0x2L) >> 1)
    self.n730 = (self.n696 & 0x400000000L) | (self.n696 & 0x200000000L) | (self.n696 & 0x100000000L) | (self.n696 & 0x80000000L) | (self.n696 & 0x40000000L) | (self.n696 & 0x20000000L) | (self.n696 & 0x10000000L) | (self.n696 & 0x8000000L) | (self.n696 & 0x4000000L) | (self.n696 & 0x2000000L) | (self.n696 & 0x1000000L) | (self.n696 & 0x800000L) | (self.n696 & 0x400000L) | (self.n696 & 0x200000L) | (self.n696 & 0x100000L) | (self.n696 & 0x80000L) | (self.n696 & 0x40000L) | (self.n696 & 0x20000L) | (self.n696 & 0x10000L) | (self.n696 & 0x8000L) | (self.n696 & 0x4000L) | (self.n696 & 0x2000L) | (self.n696 & 0x1000L) | (self.n696 & 0x800L) | (self.n696 & 0x400L) | (self.n696 & 0x200L) | (self.n696 & 0x100L) | (self.n696 & 0x80L) | (self.n696 & 0x40L) | (self.n696 & 0x20L) | (self.n696 & 0x10L) | (self.n696 & 0x8L) | (self.n696 & 0x4L) | (self.n696 & 0x2L) | (self.n696 & 0x1L)
    self.n728 = (self.n693 - self.n727) & 0x1FFL
    self.n699 = (self.n693 & 0x80L) | (self.n693 & 0x40L) | (self.n693 & 0x20L) | (self.n693 & 0x10L) | (self.n693 & 0x8L) | (self.n693 & 0x4L) | (self.n693 & 0x2L) | (self.n693 & 0x1L)
    self.n698 = ((self.n693 & 0x100L) >> 8)
    self.n697 = ((self.n696 & 0x800000000L) >> 35)
    self.n701 = (self.n699 & 0x40L) | (self.n699 & 0x20L) | (self.n699 & 0x10L) | (self.n699 & 0x8L) | (self.n699 & 0x4L) | (self.n699 & 0x2L) | (self.n699 & 0x1L)
    self.n700 = ((self.n699 & 0x80L) >> 7)
    self.n716 = self.n698 | self.n700
    self.n703 = (self.n701 & 0x20L) | (self.n701 & 0x10L) | (self.n701 & 0x8L) | (self.n701 & 0x4L) | (self.n701 & 0x2L) | (self.n701 & 0x1L)
    self.n702 = ((self.n701 & 0x40L) >> 6)
    self.n705 = (self.n703 & 0x10L) | (self.n703 & 0x8L) | (self.n703 & 0x4L) | (self.n703 & 0x2L) | (self.n703 & 0x1L)
    self.n704 = ((self.n703 & 0x20L) >> 5)
    self.n717 = self.n702 | self.n704
    self.n707 = (self.n705 & 0x8L) | (self.n705 & 0x4L) | (self.n705 & 0x2L) | (self.n705 & 0x1L)
    self.n706 = ((self.n705 & 0x10L) >> 4)
    self.n720 = self.n716 | self.n717
    self.n709 = (self.n707 & 0x4L) | (self.n707 & 0x2L) | (self.n707 & 0x1L)
    self.n708 = ((self.n707 & 0x8L) >> 3)
    self.n718 = self.n706 | self.n708
    self.n711 = (self.n709 & 0x2L) | (self.n709 & 0x1L)
    self.n710 = ((self.n709 & 0x4L) >> 2)
    self.n713 = (self.n711 & 0x1L)
    self.n712 = ((self.n711 & 0x2L) >> 1)
    self.n719 = self.n710 | self.n712
    self.n714 = (self.n713 & 0x1L)
    self.n721 = self.n718 | self.n719
    self.n722 = self.n720 | self.n721
    self.n723 = self.n722 | self.n714
    self.n724 = ~self.n723 & 0x1L
    self.n725 = self.n697 | self.n724
    self.n726 = ~self.n725 & 0x1L
    if self.n726:
      self.n732 = self.n730
    else:
      self.n732 = self.n731
    if self.n726:
      self.n729 = self.n728
    else:
      self.n729 = self.n693
    self.n767 = ((self.n732 & 0x400000000L) >> 1) | ((self.n732 & 0x200000000L) >> 1) | ((self.n732 & 0x100000000L) >> 1) | ((self.n732 & 0x80000000L) >> 1) | ((self.n732 & 0x40000000L) >> 1) | ((self.n732 & 0x20000000L) >> 1) | ((self.n732 & 0x10000000L) >> 1) | ((self.n732 & 0x8000000L) >> 1) | ((self.n732 & 0x4000000L) >> 1) | ((self.n732 & 0x2000000L) >> 1) | ((self.n732 & 0x1000000L) >> 1) | ((self.n732 & 0x800000L) >> 1) | ((self.n732 & 0x400000L) >> 1) | ((self.n732 & 0x200000L) >> 1) | ((self.n732 & 0x100000L) >> 1) | ((self.n732 & 0x80000L) >> 1) | ((self.n732 & 0x40000L) >> 1) | ((self.n732 & 0x20000L) >> 1) | ((self.n732 & 0x10000L) >> 1) | ((self.n732 & 0x8000L) >> 1) | ((self.n732 & 0x4000L) >> 1) | ((self.n732 & 0x2000L) >> 1) | ((self.n732 & 0x1000L) >> 1) | ((self.n732 & 0x800L) >> 1) | ((self.n732 & 0x400L) >> 1) | ((self.n732 & 0x200L) >> 1) | ((self.n732 & 0x100L) >> 1) | ((self.n732 & 0x80L) >> 1) | ((self.n732 & 0x40L) >> 1) | ((self.n732 & 0x20L) >> 1) | ((self.n732 & 0x10L) >> 1) | ((self.n732 & 0x8L) >> 1) | ((self.n732 & 0x4L) >> 1) | ((self.n732 & 0x2L) >> 1)
    self.n766 = (self.n732 & 0x200000000L) | (self.n732 & 0x100000000L) | (self.n732 & 0x80000000L) | (self.n732 & 0x40000000L) | (self.n732 & 0x20000000L) | (self.n732 & 0x10000000L) | (self.n732 & 0x8000000L) | (self.n732 & 0x4000000L) | (self.n732 & 0x2000000L) | (self.n732 & 0x1000000L) | (self.n732 & 0x800000L) | (self.n732 & 0x400000L) | (self.n732 & 0x200000L) | (self.n732 & 0x100000L) | (self.n732 & 0x80000L) | (self.n732 & 0x40000L) | (self.n732 & 0x20000L) | (self.n732 & 0x10000L) | (self.n732 & 0x8000L) | (self.n732 & 0x4000L) | (self.n732 & 0x2000L) | (self.n732 & 0x1000L) | (self.n732 & 0x800L) | (self.n732 & 0x400L) | (self.n732 & 0x200L) | (self.n732 & 0x100L) | (self.n732 & 0x80L) | (self.n732 & 0x40L) | (self.n732 & 0x20L) | (self.n732 & 0x10L) | (self.n732 & 0x8L) | (self.n732 & 0x4L) | (self.n732 & 0x2L) | (self.n732 & 0x1L)
    self.n764 = (self.n729 - self.n763) & 0x1FFL
    self.n735 = (self.n729 & 0x80L) | (self.n729 & 0x40L) | (self.n729 & 0x20L) | (self.n729 & 0x10L) | (self.n729 & 0x8L) | (self.n729 & 0x4L) | (self.n729 & 0x2L) | (self.n729 & 0x1L)
    self.n734 = ((self.n729 & 0x100L) >> 8)
    self.n733 = ((self.n732 & 0x400000000L) >> 34)
    self.n737 = (self.n735 & 0x40L) | (self.n735 & 0x20L) | (self.n735 & 0x10L) | (self.n735 & 0x8L) | (self.n735 & 0x4L) | (self.n735 & 0x2L) | (self.n735 & 0x1L)
    self.n736 = ((self.n735 & 0x80L) >> 7)
    self.n752 = self.n734 | self.n736
    self.n739 = (self.n737 & 0x20L) | (self.n737 & 0x10L) | (self.n737 & 0x8L) | (self.n737 & 0x4L) | (self.n737 & 0x2L) | (self.n737 & 0x1L)
    self.n738 = ((self.n737 & 0x40L) >> 6)
    self.n741 = (self.n739 & 0x10L) | (self.n739 & 0x8L) | (self.n739 & 0x4L) | (self.n739 & 0x2L) | (self.n739 & 0x1L)
    self.n740 = ((self.n739 & 0x20L) >> 5)
    self.n753 = self.n738 | self.n740
    self.n743 = (self.n741 & 0x8L) | (self.n741 & 0x4L) | (self.n741 & 0x2L) | (self.n741 & 0x1L)
    self.n742 = ((self.n741 & 0x10L) >> 4)
    self.n756 = self.n752 | self.n753
    self.n745 = (self.n743 & 0x4L) | (self.n743 & 0x2L) | (self.n743 & 0x1L)
    self.n744 = ((self.n743 & 0x8L) >> 3)
    self.n754 = self.n742 | self.n744
    self.n747 = (self.n745 & 0x2L) | (self.n745 & 0x1L)
    self.n746 = ((self.n745 & 0x4L) >> 2)
    self.n749 = (self.n747 & 0x1L)
    self.n748 = ((self.n747 & 0x2L) >> 1)
    self.n755 = self.n746 | self.n748
    self.n750 = (self.n749 & 0x1L)
    self.n757 = self.n754 | self.n755
    self.n758 = self.n756 | self.n757
    self.n759 = self.n758 | self.n750
    self.n760 = ~self.n759 & 0x1L
    self.n761 = self.n733 | self.n760
    self.n762 = ~self.n761 & 0x1L
    if self.n762:
      self.n768 = self.n766
    else:
      self.n768 = self.n767
    if self.n762:
      self.n765 = self.n764
    else:
      self.n765 = self.n729
    self.n803 = ((self.n768 & 0x200000000L) >> 1) | ((self.n768 & 0x100000000L) >> 1) | ((self.n768 & 0x80000000L) >> 1) | ((self.n768 & 0x40000000L) >> 1) | ((self.n768 & 0x20000000L) >> 1) | ((self.n768 & 0x10000000L) >> 1) | ((self.n768 & 0x8000000L) >> 1) | ((self.n768 & 0x4000000L) >> 1) | ((self.n768 & 0x2000000L) >> 1) | ((self.n768 & 0x1000000L) >> 1) | ((self.n768 & 0x800000L) >> 1) | ((self.n768 & 0x400000L) >> 1) | ((self.n768 & 0x200000L) >> 1) | ((self.n768 & 0x100000L) >> 1) | ((self.n768 & 0x80000L) >> 1) | ((self.n768 & 0x40000L) >> 1) | ((self.n768 & 0x20000L) >> 1) | ((self.n768 & 0x10000L) >> 1) | ((self.n768 & 0x8000L) >> 1) | ((self.n768 & 0x4000L) >> 1) | ((self.n768 & 0x2000L) >> 1) | ((self.n768 & 0x1000L) >> 1) | ((self.n768 & 0x800L) >> 1) | ((self.n768 & 0x400L) >> 1) | ((self.n768 & 0x200L) >> 1) | ((self.n768 & 0x100L) >> 1) | ((self.n768 & 0x80L) >> 1) | ((self.n768 & 0x40L) >> 1) | ((self.n768 & 0x20L) >> 1) | ((self.n768 & 0x10L) >> 1) | ((self.n768 & 0x8L) >> 1) | ((self.n768 & 0x4L) >> 1) | ((self.n768 & 0x2L) >> 1)
    self.n802 = (self.n768 & 0x100000000L) | (self.n768 & 0x80000000L) | (self.n768 & 0x40000000L) | (self.n768 & 0x20000000L) | (self.n768 & 0x10000000L) | (self.n768 & 0x8000000L) | (self.n768 & 0x4000000L) | (self.n768 & 0x2000000L) | (self.n768 & 0x1000000L) | (self.n768 & 0x800000L) | (self.n768 & 0x400000L) | (self.n768 & 0x200000L) | (self.n768 & 0x100000L) | (self.n768 & 0x80000L) | (self.n768 & 0x40000L) | (self.n768 & 0x20000L) | (self.n768 & 0x10000L) | (self.n768 & 0x8000L) | (self.n768 & 0x4000L) | (self.n768 & 0x2000L) | (self.n768 & 0x1000L) | (self.n768 & 0x800L) | (self.n768 & 0x400L) | (self.n768 & 0x200L) | (self.n768 & 0x100L) | (self.n768 & 0x80L) | (self.n768 & 0x40L) | (self.n768 & 0x20L) | (self.n768 & 0x10L) | (self.n768 & 0x8L) | (self.n768 & 0x4L) | (self.n768 & 0x2L) | (self.n768 & 0x1L)
    self.n800 = (self.n765 - self.n799) & 0x1FFL
    self.n771 = (self.n765 & 0x80L) | (self.n765 & 0x40L) | (self.n765 & 0x20L) | (self.n765 & 0x10L) | (self.n765 & 0x8L) | (self.n765 & 0x4L) | (self.n765 & 0x2L) | (self.n765 & 0x1L)
    self.n770 = ((self.n765 & 0x100L) >> 8)
    self.n769 = ((self.n768 & 0x200000000L) >> 33)
    self.n773 = (self.n771 & 0x40L) | (self.n771 & 0x20L) | (self.n771 & 0x10L) | (self.n771 & 0x8L) | (self.n771 & 0x4L) | (self.n771 & 0x2L) | (self.n771 & 0x1L)
    self.n772 = ((self.n771 & 0x80L) >> 7)
    self.n788 = self.n770 | self.n772
    self.n775 = (self.n773 & 0x20L) | (self.n773 & 0x10L) | (self.n773 & 0x8L) | (self.n773 & 0x4L) | (self.n773 & 0x2L) | (self.n773 & 0x1L)
    self.n774 = ((self.n773 & 0x40L) >> 6)
    self.n777 = (self.n775 & 0x10L) | (self.n775 & 0x8L) | (self.n775 & 0x4L) | (self.n775 & 0x2L) | (self.n775 & 0x1L)
    self.n776 = ((self.n775 & 0x20L) >> 5)
    self.n789 = self.n774 | self.n776
    self.n779 = (self.n777 & 0x8L) | (self.n777 & 0x4L) | (self.n777 & 0x2L) | (self.n777 & 0x1L)
    self.n778 = ((self.n777 & 0x10L) >> 4)
    self.n792 = self.n788 | self.n789
    self.n781 = (self.n779 & 0x4L) | (self.n779 & 0x2L) | (self.n779 & 0x1L)
    self.n780 = ((self.n779 & 0x8L) >> 3)
    self.n790 = self.n778 | self.n780
    self.n783 = (self.n781 & 0x2L) | (self.n781 & 0x1L)
    self.n782 = ((self.n781 & 0x4L) >> 2)
    self.n785 = (self.n783 & 0x1L)
    self.n784 = ((self.n783 & 0x2L) >> 1)
    self.n791 = self.n782 | self.n784
    self.n786 = (self.n785 & 0x1L)
    self.n793 = self.n790 | self.n791
    self.n794 = self.n792 | self.n793
    self.n795 = self.n794 | self.n786
    self.n796 = ~self.n795 & 0x1L
    self.n797 = self.n769 | self.n796
    self.n798 = ~self.n797 & 0x1L
    if self.n798:
      self.n804 = self.n802
    else:
      self.n804 = self.n803
    if self.n798:
      self.n801 = self.n800
    else:
      self.n801 = self.n765
    self.n839 = ((self.n804 & 0x100000000L) >> 1) | ((self.n804 & 0x80000000L) >> 1) | ((self.n804 & 0x40000000L) >> 1) | ((self.n804 & 0x20000000L) >> 1) | ((self.n804 & 0x10000000L) >> 1) | ((self.n804 & 0x8000000L) >> 1) | ((self.n804 & 0x4000000L) >> 1) | ((self.n804 & 0x2000000L) >> 1) | ((self.n804 & 0x1000000L) >> 1) | ((self.n804 & 0x800000L) >> 1) | ((self.n804 & 0x400000L) >> 1) | ((self.n804 & 0x200000L) >> 1) | ((self.n804 & 0x100000L) >> 1) | ((self.n804 & 0x80000L) >> 1) | ((self.n804 & 0x40000L) >> 1) | ((self.n804 & 0x20000L) >> 1) | ((self.n804 & 0x10000L) >> 1) | ((self.n804 & 0x8000L) >> 1) | ((self.n804 & 0x4000L) >> 1) | ((self.n804 & 0x2000L) >> 1) | ((self.n804 & 0x1000L) >> 1) | ((self.n804 & 0x800L) >> 1) | ((self.n804 & 0x400L) >> 1) | ((self.n804 & 0x200L) >> 1) | ((self.n804 & 0x100L) >> 1) | ((self.n804 & 0x80L) >> 1) | ((self.n804 & 0x40L) >> 1) | ((self.n804 & 0x20L) >> 1) | ((self.n804 & 0x10L) >> 1) | ((self.n804 & 0x8L) >> 1) | ((self.n804 & 0x4L) >> 1) | ((self.n804 & 0x2L) >> 1)
    self.n838 = (self.n804 & 0x80000000L) | (self.n804 & 0x40000000L) | (self.n804 & 0x20000000L) | (self.n804 & 0x10000000L) | (self.n804 & 0x8000000L) | (self.n804 & 0x4000000L) | (self.n804 & 0x2000000L) | (self.n804 & 0x1000000L) | (self.n804 & 0x800000L) | (self.n804 & 0x400000L) | (self.n804 & 0x200000L) | (self.n804 & 0x100000L) | (self.n804 & 0x80000L) | (self.n804 & 0x40000L) | (self.n804 & 0x20000L) | (self.n804 & 0x10000L) | (self.n804 & 0x8000L) | (self.n804 & 0x4000L) | (self.n804 & 0x2000L) | (self.n804 & 0x1000L) | (self.n804 & 0x800L) | (self.n804 & 0x400L) | (self.n804 & 0x200L) | (self.n804 & 0x100L) | (self.n804 & 0x80L) | (self.n804 & 0x40L) | (self.n804 & 0x20L) | (self.n804 & 0x10L) | (self.n804 & 0x8L) | (self.n804 & 0x4L) | (self.n804 & 0x2L) | (self.n804 & 0x1L)
    self.n836 = (self.n801 - self.n835) & 0x1FFL
    self.n807 = (self.n801 & 0x80L) | (self.n801 & 0x40L) | (self.n801 & 0x20L) | (self.n801 & 0x10L) | (self.n801 & 0x8L) | (self.n801 & 0x4L) | (self.n801 & 0x2L) | (self.n801 & 0x1L)
    self.n806 = ((self.n801 & 0x100L) >> 8)
    self.n805 = ((self.n804 & 0x100000000L) >> 32)
    self.n809 = (self.n807 & 0x40L) | (self.n807 & 0x20L) | (self.n807 & 0x10L) | (self.n807 & 0x8L) | (self.n807 & 0x4L) | (self.n807 & 0x2L) | (self.n807 & 0x1L)
    self.n808 = ((self.n807 & 0x80L) >> 7)
    self.n824 = self.n806 | self.n808
    self.n811 = (self.n809 & 0x20L) | (self.n809 & 0x10L) | (self.n809 & 0x8L) | (self.n809 & 0x4L) | (self.n809 & 0x2L) | (self.n809 & 0x1L)
    self.n810 = ((self.n809 & 0x40L) >> 6)
    self.n813 = (self.n811 & 0x10L) | (self.n811 & 0x8L) | (self.n811 & 0x4L) | (self.n811 & 0x2L) | (self.n811 & 0x1L)
    self.n812 = ((self.n811 & 0x20L) >> 5)
    self.n825 = self.n810 | self.n812
    self.n815 = (self.n813 & 0x8L) | (self.n813 & 0x4L) | (self.n813 & 0x2L) | (self.n813 & 0x1L)
    self.n814 = ((self.n813 & 0x10L) >> 4)
    self.n828 = self.n824 | self.n825
    self.n817 = (self.n815 & 0x4L) | (self.n815 & 0x2L) | (self.n815 & 0x1L)
    self.n816 = ((self.n815 & 0x8L) >> 3)
    self.n826 = self.n814 | self.n816
    self.n819 = (self.n817 & 0x2L) | (self.n817 & 0x1L)
    self.n818 = ((self.n817 & 0x4L) >> 2)
    self.n821 = (self.n819 & 0x1L)
    self.n820 = ((self.n819 & 0x2L) >> 1)
    self.n827 = self.n818 | self.n820
    self.n822 = (self.n821 & 0x1L)
    self.n829 = self.n826 | self.n827
    self.n830 = self.n828 | self.n829
    self.n831 = self.n830 | self.n822
    self.n832 = ~self.n831 & 0x1L
    self.n833 = self.n805 | self.n832
    self.n834 = ~self.n833 & 0x1L
    if self.n834:
      self.n840 = self.n838
    else:
      self.n840 = self.n839
    if self.n834:
      self.n837 = self.n836
    else:
      self.n837 = self.n801
    self.n875 = ((self.n840 & 0x80000000L) >> 1) | ((self.n840 & 0x40000000L) >> 1) | ((self.n840 & 0x20000000L) >> 1) | ((self.n840 & 0x10000000L) >> 1) | ((self.n840 & 0x8000000L) >> 1) | ((self.n840 & 0x4000000L) >> 1) | ((self.n840 & 0x2000000L) >> 1) | ((self.n840 & 0x1000000L) >> 1) | ((self.n840 & 0x800000L) >> 1) | ((self.n840 & 0x400000L) >> 1) | ((self.n840 & 0x200000L) >> 1) | ((self.n840 & 0x100000L) >> 1) | ((self.n840 & 0x80000L) >> 1) | ((self.n840 & 0x40000L) >> 1) | ((self.n840 & 0x20000L) >> 1) | ((self.n840 & 0x10000L) >> 1) | ((self.n840 & 0x8000L) >> 1) | ((self.n840 & 0x4000L) >> 1) | ((self.n840 & 0x2000L) >> 1) | ((self.n840 & 0x1000L) >> 1) | ((self.n840 & 0x800L) >> 1) | ((self.n840 & 0x400L) >> 1) | ((self.n840 & 0x200L) >> 1) | ((self.n840 & 0x100L) >> 1) | ((self.n840 & 0x80L) >> 1) | ((self.n840 & 0x40L) >> 1) | ((self.n840 & 0x20L) >> 1) | ((self.n840 & 0x10L) >> 1) | ((self.n840 & 0x8L) >> 1) | ((self.n840 & 0x4L) >> 1) | ((self.n840 & 0x2L) >> 1)
    self.n874 = (self.n840 & 0x40000000L) | (self.n840 & 0x20000000L) | (self.n840 & 0x10000000L) | (self.n840 & 0x8000000L) | (self.n840 & 0x4000000L) | (self.n840 & 0x2000000L) | (self.n840 & 0x1000000L) | (self.n840 & 0x800000L) | (self.n840 & 0x400000L) | (self.n840 & 0x200000L) | (self.n840 & 0x100000L) | (self.n840 & 0x80000L) | (self.n840 & 0x40000L) | (self.n840 & 0x20000L) | (self.n840 & 0x10000L) | (self.n840 & 0x8000L) | (self.n840 & 0x4000L) | (self.n840 & 0x2000L) | (self.n840 & 0x1000L) | (self.n840 & 0x800L) | (self.n840 & 0x400L) | (self.n840 & 0x200L) | (self.n840 & 0x100L) | (self.n840 & 0x80L) | (self.n840 & 0x40L) | (self.n840 & 0x20L) | (self.n840 & 0x10L) | (self.n840 & 0x8L) | (self.n840 & 0x4L) | (self.n840 & 0x2L) | (self.n840 & 0x1L)
    self.n872 = (self.n837 - self.n871) & 0x1FFL
    self.n843 = (self.n837 & 0x80L) | (self.n837 & 0x40L) | (self.n837 & 0x20L) | (self.n837 & 0x10L) | (self.n837 & 0x8L) | (self.n837 & 0x4L) | (self.n837 & 0x2L) | (self.n837 & 0x1L)
    self.n842 = ((self.n837 & 0x100L) >> 8)
    self.n841 = ((self.n840 & 0x80000000L) >> 31)
    self.n845 = (self.n843 & 0x40L) | (self.n843 & 0x20L) | (self.n843 & 0x10L) | (self.n843 & 0x8L) | (self.n843 & 0x4L) | (self.n843 & 0x2L) | (self.n843 & 0x1L)
    self.n844 = ((self.n843 & 0x80L) >> 7)
    self.n860 = self.n842 | self.n844
    self.n847 = (self.n845 & 0x20L) | (self.n845 & 0x10L) | (self.n845 & 0x8L) | (self.n845 & 0x4L) | (self.n845 & 0x2L) | (self.n845 & 0x1L)
    self.n846 = ((self.n845 & 0x40L) >> 6)
    self.n849 = (self.n847 & 0x10L) | (self.n847 & 0x8L) | (self.n847 & 0x4L) | (self.n847 & 0x2L) | (self.n847 & 0x1L)
    self.n848 = ((self.n847 & 0x20L) >> 5)
    self.n861 = self.n846 | self.n848
    self.n851 = (self.n849 & 0x8L) | (self.n849 & 0x4L) | (self.n849 & 0x2L) | (self.n849 & 0x1L)
    self.n850 = ((self.n849 & 0x10L) >> 4)
    self.n864 = self.n860 | self.n861
    self.n853 = (self.n851 & 0x4L) | (self.n851 & 0x2L) | (self.n851 & 0x1L)
    self.n852 = ((self.n851 & 0x8L) >> 3)
    self.n862 = self.n850 | self.n852
    self.n855 = (self.n853 & 0x2L) | (self.n853 & 0x1L)
    self.n854 = ((self.n853 & 0x4L) >> 2)
    self.n857 = (self.n855 & 0x1L)
    self.n856 = ((self.n855 & 0x2L) >> 1)
    self.n863 = self.n854 | self.n856
    self.n858 = (self.n857 & 0x1L)
    self.n865 = self.n862 | self.n863
    self.n866 = self.n864 | self.n865
    self.n867 = self.n866 | self.n858
    self.n868 = ~self.n867 & 0x1L
    self.n869 = self.n841 | self.n868
    self.n870 = ~self.n869 & 0x1L
    if self.n870:
      self.n876 = self.n874
    else:
      self.n876 = self.n875
    if self.n870:
      self.n873 = self.n872
    else:
      self.n873 = self.n837
    self.n911 = ((self.n876 & 0x40000000L) >> 1) | ((self.n876 & 0x20000000L) >> 1) | ((self.n876 & 0x10000000L) >> 1) | ((self.n876 & 0x8000000L) >> 1) | ((self.n876 & 0x4000000L) >> 1) | ((self.n876 & 0x2000000L) >> 1) | ((self.n876 & 0x1000000L) >> 1) | ((self.n876 & 0x800000L) >> 1) | ((self.n876 & 0x400000L) >> 1) | ((self.n876 & 0x200000L) >> 1) | ((self.n876 & 0x100000L) >> 1) | ((self.n876 & 0x80000L) >> 1) | ((self.n876 & 0x40000L) >> 1) | ((self.n876 & 0x20000L) >> 1) | ((self.n876 & 0x10000L) >> 1) | ((self.n876 & 0x8000L) >> 1) | ((self.n876 & 0x4000L) >> 1) | ((self.n876 & 0x2000L) >> 1) | ((self.n876 & 0x1000L) >> 1) | ((self.n876 & 0x800L) >> 1) | ((self.n876 & 0x400L) >> 1) | ((self.n876 & 0x200L) >> 1) | ((self.n876 & 0x100L) >> 1) | ((self.n876 & 0x80L) >> 1) | ((self.n876 & 0x40L) >> 1) | ((self.n876 & 0x20L) >> 1) | ((self.n876 & 0x10L) >> 1) | ((self.n876 & 0x8L) >> 1) | ((self.n876 & 0x4L) >> 1) | ((self.n876 & 0x2L) >> 1)
    self.n910 = (self.n876 & 0x20000000L) | (self.n876 & 0x10000000L) | (self.n876 & 0x8000000L) | (self.n876 & 0x4000000L) | (self.n876 & 0x2000000L) | (self.n876 & 0x1000000L) | (self.n876 & 0x800000L) | (self.n876 & 0x400000L) | (self.n876 & 0x200000L) | (self.n876 & 0x100000L) | (self.n876 & 0x80000L) | (self.n876 & 0x40000L) | (self.n876 & 0x20000L) | (self.n876 & 0x10000L) | (self.n876 & 0x8000L) | (self.n876 & 0x4000L) | (self.n876 & 0x2000L) | (self.n876 & 0x1000L) | (self.n876 & 0x800L) | (self.n876 & 0x400L) | (self.n876 & 0x200L) | (self.n876 & 0x100L) | (self.n876 & 0x80L) | (self.n876 & 0x40L) | (self.n876 & 0x20L) | (self.n876 & 0x10L) | (self.n876 & 0x8L) | (self.n876 & 0x4L) | (self.n876 & 0x2L) | (self.n876 & 0x1L)
    self.n908 = (self.n873 - self.n907) & 0x1FFL
    self.n879 = (self.n873 & 0x80L) | (self.n873 & 0x40L) | (self.n873 & 0x20L) | (self.n873 & 0x10L) | (self.n873 & 0x8L) | (self.n873 & 0x4L) | (self.n873 & 0x2L) | (self.n873 & 0x1L)
    self.n878 = ((self.n873 & 0x100L) >> 8)
    self.n877 = ((self.n876 & 0x40000000L) >> 30)
    self.n881 = (self.n879 & 0x40L) | (self.n879 & 0x20L) | (self.n879 & 0x10L) | (self.n879 & 0x8L) | (self.n879 & 0x4L) | (self.n879 & 0x2L) | (self.n879 & 0x1L)
    self.n880 = ((self.n879 & 0x80L) >> 7)
    self.n896 = self.n878 | self.n880
    self.n883 = (self.n881 & 0x20L) | (self.n881 & 0x10L) | (self.n881 & 0x8L) | (self.n881 & 0x4L) | (self.n881 & 0x2L) | (self.n881 & 0x1L)
    self.n882 = ((self.n881 & 0x40L) >> 6)
    self.n885 = (self.n883 & 0x10L) | (self.n883 & 0x8L) | (self.n883 & 0x4L) | (self.n883 & 0x2L) | (self.n883 & 0x1L)
    self.n884 = ((self.n883 & 0x20L) >> 5)
    self.n897 = self.n882 | self.n884
    self.n887 = (self.n885 & 0x8L) | (self.n885 & 0x4L) | (self.n885 & 0x2L) | (self.n885 & 0x1L)
    self.n886 = ((self.n885 & 0x10L) >> 4)
    self.n900 = self.n896 | self.n897
    self.n889 = (self.n887 & 0x4L) | (self.n887 & 0x2L) | (self.n887 & 0x1L)
    self.n888 = ((self.n887 & 0x8L) >> 3)
    self.n898 = self.n886 | self.n888
    self.n891 = (self.n889 & 0x2L) | (self.n889 & 0x1L)
    self.n890 = ((self.n889 & 0x4L) >> 2)
    self.n893 = (self.n891 & 0x1L)
    self.n892 = ((self.n891 & 0x2L) >> 1)
    self.n899 = self.n890 | self.n892
    self.n894 = (self.n893 & 0x1L)
    self.n901 = self.n898 | self.n899
    self.n902 = self.n900 | self.n901
    self.n903 = self.n902 | self.n894
    self.n904 = ~self.n903 & 0x1L
    self.n905 = self.n877 | self.n904
    self.n906 = ~self.n905 & 0x1L
    if self.n906:
      self.n912 = self.n910
    else:
      self.n912 = self.n911
    if self.n906:
      self.n909 = self.n908
    else:
      self.n909 = self.n873
    self.n947 = ((self.n912 & 0x20000000L) >> 1) | ((self.n912 & 0x10000000L) >> 1) | ((self.n912 & 0x8000000L) >> 1) | ((self.n912 & 0x4000000L) >> 1) | ((self.n912 & 0x2000000L) >> 1) | ((self.n912 & 0x1000000L) >> 1) | ((self.n912 & 0x800000L) >> 1) | ((self.n912 & 0x400000L) >> 1) | ((self.n912 & 0x200000L) >> 1) | ((self.n912 & 0x100000L) >> 1) | ((self.n912 & 0x80000L) >> 1) | ((self.n912 & 0x40000L) >> 1) | ((self.n912 & 0x20000L) >> 1) | ((self.n912 & 0x10000L) >> 1) | ((self.n912 & 0x8000L) >> 1) | ((self.n912 & 0x4000L) >> 1) | ((self.n912 & 0x2000L) >> 1) | ((self.n912 & 0x1000L) >> 1) | ((self.n912 & 0x800L) >> 1) | ((self.n912 & 0x400L) >> 1) | ((self.n912 & 0x200L) >> 1) | ((self.n912 & 0x100L) >> 1) | ((self.n912 & 0x80L) >> 1) | ((self.n912 & 0x40L) >> 1) | ((self.n912 & 0x20L) >> 1) | ((self.n912 & 0x10L) >> 1) | ((self.n912 & 0x8L) >> 1) | ((self.n912 & 0x4L) >> 1) | ((self.n912 & 0x2L) >> 1)
    self.n946 = (self.n912 & 0x10000000L) | (self.n912 & 0x8000000L) | (self.n912 & 0x4000000L) | (self.n912 & 0x2000000L) | (self.n912 & 0x1000000L) | (self.n912 & 0x800000L) | (self.n912 & 0x400000L) | (self.n912 & 0x200000L) | (self.n912 & 0x100000L) | (self.n912 & 0x80000L) | (self.n912 & 0x40000L) | (self.n912 & 0x20000L) | (self.n912 & 0x10000L) | (self.n912 & 0x8000L) | (self.n912 & 0x4000L) | (self.n912 & 0x2000L) | (self.n912 & 0x1000L) | (self.n912 & 0x800L) | (self.n912 & 0x400L) | (self.n912 & 0x200L) | (self.n912 & 0x100L) | (self.n912 & 0x80L) | (self.n912 & 0x40L) | (self.n912 & 0x20L) | (self.n912 & 0x10L) | (self.n912 & 0x8L) | (self.n912 & 0x4L) | (self.n912 & 0x2L) | (self.n912 & 0x1L)
    self.n944 = (self.n909 - self.n943) & 0x1FFL
    self.n915 = (self.n909 & 0x80L) | (self.n909 & 0x40L) | (self.n909 & 0x20L) | (self.n909 & 0x10L) | (self.n909 & 0x8L) | (self.n909 & 0x4L) | (self.n909 & 0x2L) | (self.n909 & 0x1L)
    self.n914 = ((self.n909 & 0x100L) >> 8)
    self.n913 = ((self.n912 & 0x20000000L) >> 29)
    self.n917 = (self.n915 & 0x40L) | (self.n915 & 0x20L) | (self.n915 & 0x10L) | (self.n915 & 0x8L) | (self.n915 & 0x4L) | (self.n915 & 0x2L) | (self.n915 & 0x1L)
    self.n916 = ((self.n915 & 0x80L) >> 7)
    self.n932 = self.n914 | self.n916
    self.n919 = (self.n917 & 0x20L) | (self.n917 & 0x10L) | (self.n917 & 0x8L) | (self.n917 & 0x4L) | (self.n917 & 0x2L) | (self.n917 & 0x1L)
    self.n918 = ((self.n917 & 0x40L) >> 6)
    self.n921 = (self.n919 & 0x10L) | (self.n919 & 0x8L) | (self.n919 & 0x4L) | (self.n919 & 0x2L) | (self.n919 & 0x1L)
    self.n920 = ((self.n919 & 0x20L) >> 5)
    self.n933 = self.n918 | self.n920
    self.n923 = (self.n921 & 0x8L) | (self.n921 & 0x4L) | (self.n921 & 0x2L) | (self.n921 & 0x1L)
    self.n922 = ((self.n921 & 0x10L) >> 4)
    self.n936 = self.n932 | self.n933
    self.n925 = (self.n923 & 0x4L) | (self.n923 & 0x2L) | (self.n923 & 0x1L)
    self.n924 = ((self.n923 & 0x8L) >> 3)
    self.n934 = self.n922 | self.n924
    self.n927 = (self.n925 & 0x2L) | (self.n925 & 0x1L)
    self.n926 = ((self.n925 & 0x4L) >> 2)
    self.n929 = (self.n927 & 0x1L)
    self.n928 = ((self.n927 & 0x2L) >> 1)
    self.n935 = self.n926 | self.n928
    self.n930 = (self.n929 & 0x1L)
    self.n937 = self.n934 | self.n935
    self.n938 = self.n936 | self.n937
    self.n939 = self.n938 | self.n930
    self.n940 = ~self.n939 & 0x1L
    self.n941 = self.n913 | self.n940
    self.n942 = ~self.n941 & 0x1L
    if self.n942:
      self.n948 = self.n946
    else:
      self.n948 = self.n947
    if self.n942:
      self.n945 = self.n944
    else:
      self.n945 = self.n909
    self.n983 = ((self.n948 & 0x10000000L) >> 1) | ((self.n948 & 0x8000000L) >> 1) | ((self.n948 & 0x4000000L) >> 1) | ((self.n948 & 0x2000000L) >> 1) | ((self.n948 & 0x1000000L) >> 1) | ((self.n948 & 0x800000L) >> 1) | ((self.n948 & 0x400000L) >> 1) | ((self.n948 & 0x200000L) >> 1) | ((self.n948 & 0x100000L) >> 1) | ((self.n948 & 0x80000L) >> 1) | ((self.n948 & 0x40000L) >> 1) | ((self.n948 & 0x20000L) >> 1) | ((self.n948 & 0x10000L) >> 1) | ((self.n948 & 0x8000L) >> 1) | ((self.n948 & 0x4000L) >> 1) | ((self.n948 & 0x2000L) >> 1) | ((self.n948 & 0x1000L) >> 1) | ((self.n948 & 0x800L) >> 1) | ((self.n948 & 0x400L) >> 1) | ((self.n948 & 0x200L) >> 1) | ((self.n948 & 0x100L) >> 1) | ((self.n948 & 0x80L) >> 1) | ((self.n948 & 0x40L) >> 1) | ((self.n948 & 0x20L) >> 1) | ((self.n948 & 0x10L) >> 1) | ((self.n948 & 0x8L) >> 1) | ((self.n948 & 0x4L) >> 1) | ((self.n948 & 0x2L) >> 1)
    self.n982 = (self.n948 & 0x8000000L) | (self.n948 & 0x4000000L) | (self.n948 & 0x2000000L) | (self.n948 & 0x1000000L) | (self.n948 & 0x800000L) | (self.n948 & 0x400000L) | (self.n948 & 0x200000L) | (self.n948 & 0x100000L) | (self.n948 & 0x80000L) | (self.n948 & 0x40000L) | (self.n948 & 0x20000L) | (self.n948 & 0x10000L) | (self.n948 & 0x8000L) | (self.n948 & 0x4000L) | (self.n948 & 0x2000L) | (self.n948 & 0x1000L) | (self.n948 & 0x800L) | (self.n948 & 0x400L) | (self.n948 & 0x200L) | (self.n948 & 0x100L) | (self.n948 & 0x80L) | (self.n948 & 0x40L) | (self.n948 & 0x20L) | (self.n948 & 0x10L) | (self.n948 & 0x8L) | (self.n948 & 0x4L) | (self.n948 & 0x2L) | (self.n948 & 0x1L)
    self.n980 = (self.n945 - self.n979) & 0x1FFL
    self.n951 = (self.n945 & 0x80L) | (self.n945 & 0x40L) | (self.n945 & 0x20L) | (self.n945 & 0x10L) | (self.n945 & 0x8L) | (self.n945 & 0x4L) | (self.n945 & 0x2L) | (self.n945 & 0x1L)
    self.n950 = ((self.n945 & 0x100L) >> 8)
    self.n949 = ((self.n948 & 0x10000000L) >> 28)
    self.n953 = (self.n951 & 0x40L) | (self.n951 & 0x20L) | (self.n951 & 0x10L) | (self.n951 & 0x8L) | (self.n951 & 0x4L) | (self.n951 & 0x2L) | (self.n951 & 0x1L)
    self.n952 = ((self.n951 & 0x80L) >> 7)
    self.n968 = self.n950 | self.n952
    self.n955 = (self.n953 & 0x20L) | (self.n953 & 0x10L) | (self.n953 & 0x8L) | (self.n953 & 0x4L) | (self.n953 & 0x2L) | (self.n953 & 0x1L)
    self.n954 = ((self.n953 & 0x40L) >> 6)
    self.n957 = (self.n955 & 0x10L) | (self.n955 & 0x8L) | (self.n955 & 0x4L) | (self.n955 & 0x2L) | (self.n955 & 0x1L)
    self.n956 = ((self.n955 & 0x20L) >> 5)
    self.n969 = self.n954 | self.n956
    self.n959 = (self.n957 & 0x8L) | (self.n957 & 0x4L) | (self.n957 & 0x2L) | (self.n957 & 0x1L)
    self.n958 = ((self.n957 & 0x10L) >> 4)
    self.n972 = self.n968 | self.n969
    self.n961 = (self.n959 & 0x4L) | (self.n959 & 0x2L) | (self.n959 & 0x1L)
    self.n960 = ((self.n959 & 0x8L) >> 3)
    self.n970 = self.n958 | self.n960
    self.n963 = (self.n961 & 0x2L) | (self.n961 & 0x1L)
    self.n962 = ((self.n961 & 0x4L) >> 2)
    self.n965 = (self.n963 & 0x1L)
    self.n964 = ((self.n963 & 0x2L) >> 1)
    self.n971 = self.n962 | self.n964
    self.n966 = (self.n965 & 0x1L)
    self.n973 = self.n970 | self.n971
    self.n974 = self.n972 | self.n973
    self.n975 = self.n974 | self.n966
    self.n976 = ~self.n975 & 0x1L
    self.n977 = self.n949 | self.n976
    self.n978 = ~self.n977 & 0x1L
    if self.n978:
      self.n984 = self.n982
    else:
      self.n984 = self.n983
    if self.n978:
      self.n981 = self.n980
    else:
      self.n981 = self.n945
    self.n1019 = ((self.n984 & 0x8000000L) >> 1) | ((self.n984 & 0x4000000L) >> 1) | ((self.n984 & 0x2000000L) >> 1) | ((self.n984 & 0x1000000L) >> 1) | ((self.n984 & 0x800000L) >> 1) | ((self.n984 & 0x400000L) >> 1) | ((self.n984 & 0x200000L) >> 1) | ((self.n984 & 0x100000L) >> 1) | ((self.n984 & 0x80000L) >> 1) | ((self.n984 & 0x40000L) >> 1) | ((self.n984 & 0x20000L) >> 1) | ((self.n984 & 0x10000L) >> 1) | ((self.n984 & 0x8000L) >> 1) | ((self.n984 & 0x4000L) >> 1) | ((self.n984 & 0x2000L) >> 1) | ((self.n984 & 0x1000L) >> 1) | ((self.n984 & 0x800L) >> 1) | ((self.n984 & 0x400L) >> 1) | ((self.n984 & 0x200L) >> 1) | ((self.n984 & 0x100L) >> 1) | ((self.n984 & 0x80L) >> 1) | ((self.n984 & 0x40L) >> 1) | ((self.n984 & 0x20L) >> 1) | ((self.n984 & 0x10L) >> 1) | ((self.n984 & 0x8L) >> 1) | ((self.n984 & 0x4L) >> 1) | ((self.n984 & 0x2L) >> 1)
    self.n1018 = (self.n984 & 0x4000000L) | (self.n984 & 0x2000000L) | (self.n984 & 0x1000000L) | (self.n984 & 0x800000L) | (self.n984 & 0x400000L) | (self.n984 & 0x200000L) | (self.n984 & 0x100000L) | (self.n984 & 0x80000L) | (self.n984 & 0x40000L) | (self.n984 & 0x20000L) | (self.n984 & 0x10000L) | (self.n984 & 0x8000L) | (self.n984 & 0x4000L) | (self.n984 & 0x2000L) | (self.n984 & 0x1000L) | (self.n984 & 0x800L) | (self.n984 & 0x400L) | (self.n984 & 0x200L) | (self.n984 & 0x100L) | (self.n984 & 0x80L) | (self.n984 & 0x40L) | (self.n984 & 0x20L) | (self.n984 & 0x10L) | (self.n984 & 0x8L) | (self.n984 & 0x4L) | (self.n984 & 0x2L) | (self.n984 & 0x1L)
    self.n1016 = (self.n981 - self.n1015) & 0x1FFL
    self.n987 = (self.n981 & 0x80L) | (self.n981 & 0x40L) | (self.n981 & 0x20L) | (self.n981 & 0x10L) | (self.n981 & 0x8L) | (self.n981 & 0x4L) | (self.n981 & 0x2L) | (self.n981 & 0x1L)
    self.n986 = ((self.n981 & 0x100L) >> 8)
    self.n985 = ((self.n984 & 0x8000000L) >> 27)
    self.n989 = (self.n987 & 0x40L) | (self.n987 & 0x20L) | (self.n987 & 0x10L) | (self.n987 & 0x8L) | (self.n987 & 0x4L) | (self.n987 & 0x2L) | (self.n987 & 0x1L)
    self.n988 = ((self.n987 & 0x80L) >> 7)
    self.n1004 = self.n986 | self.n988
    self.n991 = (self.n989 & 0x20L) | (self.n989 & 0x10L) | (self.n989 & 0x8L) | (self.n989 & 0x4L) | (self.n989 & 0x2L) | (self.n989 & 0x1L)
    self.n990 = ((self.n989 & 0x40L) >> 6)
    self.n993 = (self.n991 & 0x10L) | (self.n991 & 0x8L) | (self.n991 & 0x4L) | (self.n991 & 0x2L) | (self.n991 & 0x1L)
    self.n992 = ((self.n991 & 0x20L) >> 5)
    self.n1005 = self.n990 | self.n992
    self.n995 = (self.n993 & 0x8L) | (self.n993 & 0x4L) | (self.n993 & 0x2L) | (self.n993 & 0x1L)
    self.n994 = ((self.n993 & 0x10L) >> 4)
    self.n1008 = self.n1004 | self.n1005
    self.n997 = (self.n995 & 0x4L) | (self.n995 & 0x2L) | (self.n995 & 0x1L)
    self.n996 = ((self.n995 & 0x8L) >> 3)
    self.n1006 = self.n994 | self.n996
    self.n999 = (self.n997 & 0x2L) | (self.n997 & 0x1L)
    self.n998 = ((self.n997 & 0x4L) >> 2)
    self.n1001 = (self.n999 & 0x1L)
    self.n1000 = ((self.n999 & 0x2L) >> 1)
    self.n1007 = self.n998 | self.n1000
    self.n1002 = (self.n1001 & 0x1L)
    self.n1009 = self.n1006 | self.n1007
    self.n1010 = self.n1008 | self.n1009
    self.n1011 = self.n1010 | self.n1002
    self.n1012 = ~self.n1011 & 0x1L
    self.n1013 = self.n985 | self.n1012
    self.n1014 = ~self.n1013 & 0x1L
    if self.n1014:
      self.n1020 = self.n1018
    else:
      self.n1020 = self.n1019
    if self.n1014:
      self.n1017 = self.n1016
    else:
      self.n1017 = self.n981
    self.n1055 = ((self.n1020 & 0x4000000L) >> 1) | ((self.n1020 & 0x2000000L) >> 1) | ((self.n1020 & 0x1000000L) >> 1) | ((self.n1020 & 0x800000L) >> 1) | ((self.n1020 & 0x400000L) >> 1) | ((self.n1020 & 0x200000L) >> 1) | ((self.n1020 & 0x100000L) >> 1) | ((self.n1020 & 0x80000L) >> 1) | ((self.n1020 & 0x40000L) >> 1) | ((self.n1020 & 0x20000L) >> 1) | ((self.n1020 & 0x10000L) >> 1) | ((self.n1020 & 0x8000L) >> 1) | ((self.n1020 & 0x4000L) >> 1) | ((self.n1020 & 0x2000L) >> 1) | ((self.n1020 & 0x1000L) >> 1) | ((self.n1020 & 0x800L) >> 1) | ((self.n1020 & 0x400L) >> 1) | ((self.n1020 & 0x200L) >> 1) | ((self.n1020 & 0x100L) >> 1) | ((self.n1020 & 0x80L) >> 1) | ((self.n1020 & 0x40L) >> 1) | ((self.n1020 & 0x20L) >> 1) | ((self.n1020 & 0x10L) >> 1) | ((self.n1020 & 0x8L) >> 1) | ((self.n1020 & 0x4L) >> 1) | ((self.n1020 & 0x2L) >> 1)
    self.n1054 = (self.n1020 & 0x2000000L) | (self.n1020 & 0x1000000L) | (self.n1020 & 0x800000L) | (self.n1020 & 0x400000L) | (self.n1020 & 0x200000L) | (self.n1020 & 0x100000L) | (self.n1020 & 0x80000L) | (self.n1020 & 0x40000L) | (self.n1020 & 0x20000L) | (self.n1020 & 0x10000L) | (self.n1020 & 0x8000L) | (self.n1020 & 0x4000L) | (self.n1020 & 0x2000L) | (self.n1020 & 0x1000L) | (self.n1020 & 0x800L) | (self.n1020 & 0x400L) | (self.n1020 & 0x200L) | (self.n1020 & 0x100L) | (self.n1020 & 0x80L) | (self.n1020 & 0x40L) | (self.n1020 & 0x20L) | (self.n1020 & 0x10L) | (self.n1020 & 0x8L) | (self.n1020 & 0x4L) | (self.n1020 & 0x2L) | (self.n1020 & 0x1L)
    self.n1052 = (self.n1017 - self.n1051) & 0x1FFL
    self.n1023 = (self.n1017 & 0x80L) | (self.n1017 & 0x40L) | (self.n1017 & 0x20L) | (self.n1017 & 0x10L) | (self.n1017 & 0x8L) | (self.n1017 & 0x4L) | (self.n1017 & 0x2L) | (self.n1017 & 0x1L)
    self.n1022 = ((self.n1017 & 0x100L) >> 8)
    self.n1021 = ((self.n1020 & 0x4000000L) >> 26)
    self.n1025 = (self.n1023 & 0x40L) | (self.n1023 & 0x20L) | (self.n1023 & 0x10L) | (self.n1023 & 0x8L) | (self.n1023 & 0x4L) | (self.n1023 & 0x2L) | (self.n1023 & 0x1L)
    self.n1024 = ((self.n1023 & 0x80L) >> 7)
    self.n1040 = self.n1022 | self.n1024
    self.n1027 = (self.n1025 & 0x20L) | (self.n1025 & 0x10L) | (self.n1025 & 0x8L) | (self.n1025 & 0x4L) | (self.n1025 & 0x2L) | (self.n1025 & 0x1L)
    self.n1026 = ((self.n1025 & 0x40L) >> 6)
    self.n1029 = (self.n1027 & 0x10L) | (self.n1027 & 0x8L) | (self.n1027 & 0x4L) | (self.n1027 & 0x2L) | (self.n1027 & 0x1L)
    self.n1028 = ((self.n1027 & 0x20L) >> 5)
    self.n1041 = self.n1026 | self.n1028
    self.n1031 = (self.n1029 & 0x8L) | (self.n1029 & 0x4L) | (self.n1029 & 0x2L) | (self.n1029 & 0x1L)
    self.n1030 = ((self.n1029 & 0x10L) >> 4)
    self.n1044 = self.n1040 | self.n1041
    self.n1033 = (self.n1031 & 0x4L) | (self.n1031 & 0x2L) | (self.n1031 & 0x1L)
    self.n1032 = ((self.n1031 & 0x8L) >> 3)
    self.n1042 = self.n1030 | self.n1032
    self.n1035 = (self.n1033 & 0x2L) | (self.n1033 & 0x1L)
    self.n1034 = ((self.n1033 & 0x4L) >> 2)
    self.n1037 = (self.n1035 & 0x1L)
    self.n1036 = ((self.n1035 & 0x2L) >> 1)
    self.n1043 = self.n1034 | self.n1036
    self.n1038 = (self.n1037 & 0x1L)
    self.n1045 = self.n1042 | self.n1043
    self.n1046 = self.n1044 | self.n1045
    self.n1047 = self.n1046 | self.n1038
    self.n1048 = ~self.n1047 & 0x1L
    self.n1049 = self.n1021 | self.n1048
    self.n1050 = ~self.n1049 & 0x1L
    if self.n1050:
      self.n1056 = self.n1054
    else:
      self.n1056 = self.n1055
    if self.n1050:
      self.n1053 = self.n1052
    else:
      self.n1053 = self.n1017
    self.n1091 = ((self.n1056 & 0x2000000L) >> 1) | ((self.n1056 & 0x1000000L) >> 1) | ((self.n1056 & 0x800000L) >> 1) | ((self.n1056 & 0x400000L) >> 1) | ((self.n1056 & 0x200000L) >> 1) | ((self.n1056 & 0x100000L) >> 1) | ((self.n1056 & 0x80000L) >> 1) | ((self.n1056 & 0x40000L) >> 1) | ((self.n1056 & 0x20000L) >> 1) | ((self.n1056 & 0x10000L) >> 1) | ((self.n1056 & 0x8000L) >> 1) | ((self.n1056 & 0x4000L) >> 1) | ((self.n1056 & 0x2000L) >> 1) | ((self.n1056 & 0x1000L) >> 1) | ((self.n1056 & 0x800L) >> 1) | ((self.n1056 & 0x400L) >> 1) | ((self.n1056 & 0x200L) >> 1) | ((self.n1056 & 0x100L) >> 1) | ((self.n1056 & 0x80L) >> 1) | ((self.n1056 & 0x40L) >> 1) | ((self.n1056 & 0x20L) >> 1) | ((self.n1056 & 0x10L) >> 1) | ((self.n1056 & 0x8L) >> 1) | ((self.n1056 & 0x4L) >> 1) | ((self.n1056 & 0x2L) >> 1)
    self.n1090 = (self.n1056 & 0x1000000L) | (self.n1056 & 0x800000L) | (self.n1056 & 0x400000L) | (self.n1056 & 0x200000L) | (self.n1056 & 0x100000L) | (self.n1056 & 0x80000L) | (self.n1056 & 0x40000L) | (self.n1056 & 0x20000L) | (self.n1056 & 0x10000L) | (self.n1056 & 0x8000L) | (self.n1056 & 0x4000L) | (self.n1056 & 0x2000L) | (self.n1056 & 0x1000L) | (self.n1056 & 0x800L) | (self.n1056 & 0x400L) | (self.n1056 & 0x200L) | (self.n1056 & 0x100L) | (self.n1056 & 0x80L) | (self.n1056 & 0x40L) | (self.n1056 & 0x20L) | (self.n1056 & 0x10L) | (self.n1056 & 0x8L) | (self.n1056 & 0x4L) | (self.n1056 & 0x2L) | (self.n1056 & 0x1L)
    self.n1088 = (self.n1053 - self.n1087) & 0x1FFL
    self.n1059 = (self.n1053 & 0x80L) | (self.n1053 & 0x40L) | (self.n1053 & 0x20L) | (self.n1053 & 0x10L) | (self.n1053 & 0x8L) | (self.n1053 & 0x4L) | (self.n1053 & 0x2L) | (self.n1053 & 0x1L)
    self.n1058 = ((self.n1053 & 0x100L) >> 8)
    self.n1057 = ((self.n1056 & 0x2000000L) >> 25)
    self.n1061 = (self.n1059 & 0x40L) | (self.n1059 & 0x20L) | (self.n1059 & 0x10L) | (self.n1059 & 0x8L) | (self.n1059 & 0x4L) | (self.n1059 & 0x2L) | (self.n1059 & 0x1L)
    self.n1060 = ((self.n1059 & 0x80L) >> 7)
    self.n1076 = self.n1058 | self.n1060
    self.n1063 = (self.n1061 & 0x20L) | (self.n1061 & 0x10L) | (self.n1061 & 0x8L) | (self.n1061 & 0x4L) | (self.n1061 & 0x2L) | (self.n1061 & 0x1L)
    self.n1062 = ((self.n1061 & 0x40L) >> 6)
    self.n1065 = (self.n1063 & 0x10L) | (self.n1063 & 0x8L) | (self.n1063 & 0x4L) | (self.n1063 & 0x2L) | (self.n1063 & 0x1L)
    self.n1064 = ((self.n1063 & 0x20L) >> 5)
    self.n1077 = self.n1062 | self.n1064
    self.n1067 = (self.n1065 & 0x8L) | (self.n1065 & 0x4L) | (self.n1065 & 0x2L) | (self.n1065 & 0x1L)
    self.n1066 = ((self.n1065 & 0x10L) >> 4)
    self.n1080 = self.n1076 | self.n1077
    self.n1069 = (self.n1067 & 0x4L) | (self.n1067 & 0x2L) | (self.n1067 & 0x1L)
    self.n1068 = ((self.n1067 & 0x8L) >> 3)
    self.n1078 = self.n1066 | self.n1068
    self.n1071 = (self.n1069 & 0x2L) | (self.n1069 & 0x1L)
    self.n1070 = ((self.n1069 & 0x4L) >> 2)
    self.n1073 = (self.n1071 & 0x1L)
    self.n1072 = ((self.n1071 & 0x2L) >> 1)
    self.n1079 = self.n1070 | self.n1072
    self.n1074 = (self.n1073 & 0x1L)
    self.n1081 = self.n1078 | self.n1079
    self.n1082 = self.n1080 | self.n1081
    self.n1083 = self.n1082 | self.n1074
    self.n1084 = ~self.n1083 & 0x1L
    self.n1085 = self.n1057 | self.n1084
    self.n1086 = ~self.n1085 & 0x1L
    if self.n1086:
      self.n1092 = self.n1090
    else:
      self.n1092 = self.n1091
    if self.n1086:
      self.n1089 = self.n1088
    else:
      self.n1089 = self.n1053
    self.n1127 = ((self.n1092 & 0x1000000L) >> 1) | ((self.n1092 & 0x800000L) >> 1) | ((self.n1092 & 0x400000L) >> 1) | ((self.n1092 & 0x200000L) >> 1) | ((self.n1092 & 0x100000L) >> 1) | ((self.n1092 & 0x80000L) >> 1) | ((self.n1092 & 0x40000L) >> 1) | ((self.n1092 & 0x20000L) >> 1) | ((self.n1092 & 0x10000L) >> 1) | ((self.n1092 & 0x8000L) >> 1) | ((self.n1092 & 0x4000L) >> 1) | ((self.n1092 & 0x2000L) >> 1) | ((self.n1092 & 0x1000L) >> 1) | ((self.n1092 & 0x800L) >> 1) | ((self.n1092 & 0x400L) >> 1) | ((self.n1092 & 0x200L) >> 1) | ((self.n1092 & 0x100L) >> 1) | ((self.n1092 & 0x80L) >> 1) | ((self.n1092 & 0x40L) >> 1) | ((self.n1092 & 0x20L) >> 1) | ((self.n1092 & 0x10L) >> 1) | ((self.n1092 & 0x8L) >> 1) | ((self.n1092 & 0x4L) >> 1) | ((self.n1092 & 0x2L) >> 1)
    self.n1126 = (self.n1092 & 0x800000L) | (self.n1092 & 0x400000L) | (self.n1092 & 0x200000L) | (self.n1092 & 0x100000L) | (self.n1092 & 0x80000L) | (self.n1092 & 0x40000L) | (self.n1092 & 0x20000L) | (self.n1092 & 0x10000L) | (self.n1092 & 0x8000L) | (self.n1092 & 0x4000L) | (self.n1092 & 0x2000L) | (self.n1092 & 0x1000L) | (self.n1092 & 0x800L) | (self.n1092 & 0x400L) | (self.n1092 & 0x200L) | (self.n1092 & 0x100L) | (self.n1092 & 0x80L) | (self.n1092 & 0x40L) | (self.n1092 & 0x20L) | (self.n1092 & 0x10L) | (self.n1092 & 0x8L) | (self.n1092 & 0x4L) | (self.n1092 & 0x2L) | (self.n1092 & 0x1L)
    self.n1124 = (self.n1089 - self.n1123) & 0x1FFL
    self.n1095 = (self.n1089 & 0x80L) | (self.n1089 & 0x40L) | (self.n1089 & 0x20L) | (self.n1089 & 0x10L) | (self.n1089 & 0x8L) | (self.n1089 & 0x4L) | (self.n1089 & 0x2L) | (self.n1089 & 0x1L)
    self.n1094 = ((self.n1089 & 0x100L) >> 8)
    self.n1093 = ((self.n1092 & 0x1000000L) >> 24)
    self.n1097 = (self.n1095 & 0x40L) | (self.n1095 & 0x20L) | (self.n1095 & 0x10L) | (self.n1095 & 0x8L) | (self.n1095 & 0x4L) | (self.n1095 & 0x2L) | (self.n1095 & 0x1L)
    self.n1096 = ((self.n1095 & 0x80L) >> 7)
    self.n1112 = self.n1094 | self.n1096
    self.n1099 = (self.n1097 & 0x20L) | (self.n1097 & 0x10L) | (self.n1097 & 0x8L) | (self.n1097 & 0x4L) | (self.n1097 & 0x2L) | (self.n1097 & 0x1L)
    self.n1098 = ((self.n1097 & 0x40L) >> 6)
    self.n1101 = (self.n1099 & 0x10L) | (self.n1099 & 0x8L) | (self.n1099 & 0x4L) | (self.n1099 & 0x2L) | (self.n1099 & 0x1L)
    self.n1100 = ((self.n1099 & 0x20L) >> 5)
    self.n1113 = self.n1098 | self.n1100
    self.n1103 = (self.n1101 & 0x8L) | (self.n1101 & 0x4L) | (self.n1101 & 0x2L) | (self.n1101 & 0x1L)
    self.n1102 = ((self.n1101 & 0x10L) >> 4)
    self.n1116 = self.n1112 | self.n1113
    self.n1105 = (self.n1103 & 0x4L) | (self.n1103 & 0x2L) | (self.n1103 & 0x1L)
    self.n1104 = ((self.n1103 & 0x8L) >> 3)
    self.n1114 = self.n1102 | self.n1104
    self.n1107 = (self.n1105 & 0x2L) | (self.n1105 & 0x1L)
    self.n1106 = ((self.n1105 & 0x4L) >> 2)
    self.n1109 = (self.n1107 & 0x1L)
    self.n1108 = ((self.n1107 & 0x2L) >> 1)
    self.n1115 = self.n1106 | self.n1108
    self.n1110 = (self.n1109 & 0x1L)
    self.n1117 = self.n1114 | self.n1115
    self.n1118 = self.n1116 | self.n1117
    self.n1119 = self.n1118 | self.n1110
    self.n1120 = ~self.n1119 & 0x1L
    self.n1121 = self.n1093 | self.n1120
    self.n1122 = ~self.n1121 & 0x1L
    if self.n1122:
      self.n1128 = self.n1126
    else:
      self.n1128 = self.n1127
    if self.n1122:
      self.n1125 = self.n1124
    else:
      self.n1125 = self.n1089
    self.n1130 = (self.n1128 & 0x400000L) | (self.n1128 & 0x200000L) | (self.n1128 & 0x100000L) | (self.n1128 & 0x80000L) | (self.n1128 & 0x40000L) | (self.n1128 & 0x20000L) | (self.n1128 & 0x10000L) | (self.n1128 & 0x8000L) | (self.n1128 & 0x4000L) | (self.n1128 & 0x2000L) | (self.n1128 & 0x1000L) | (self.n1128 & 0x800L) | (self.n1128 & 0x400L) | (self.n1128 & 0x200L) | (self.n1128 & 0x100L) | (self.n1128 & 0x80L) | (self.n1128 & 0x40L) | (self.n1128 & 0x20L) | (self.n1128 & 0x10L) | (self.n1128 & 0x8L) | (self.n1128 & 0x4L) | (self.n1128 & 0x2L) | (self.n1128 & 0x1L)
    self.n1129 = (self.n1125 & 0x80L) | (self.n1125 & 0x40L) | (self.n1125 & 0x20L) | (self.n1125 & 0x10L) | (self.n1125 & 0x8L) | (self.n1125 & 0x4L) | (self.n1125 & 0x2L) | (self.n1125 & 0x1L)
    self.n1131 = self.n1129 << 23 | self.n1130
    if self.n1196:
      self.n1197 = self.n1132
    else:
      self.n1197 = self.n1131
    if self.n1200:
      self.n1201 = self.n1198
    else:
      self.n1201 = self.n1197
    if self.n1203:
      self.n1204 = self.n1213
    else:
      self.n1204 = self.n1201
    self.n1205 = self.n279 << 31 | self.n1204
    x_o = self.n1205
    self.n1206 = self.n1205
    return (x_o, )

  def sim_init(self, vcdFile):
    self.sim_file = open(vcdFile, 'w')
    self.sim_count = 1
    self.init()
    self.sim_n3 = self.n3
    self.sim_n4 = self.n4
    self.sim_n1206 = self.n1206
    self.sim_file.write("$date\n")
    self.sim_file.write("  " + time.strftime("%a %b %d %H:%M:%S %Y", time.localtime()) + "\n")
    self.sim_file.write("$end\n")
    self.sim_file.write("$version\n  Confluence 0.6.3 -- Launchbird Design Systems, Inc.\n$end\n")
    self.sim_file.write("$timescale\n  1 ns\n$end\n")
    self.sim_file.write("$scope module cf_fp_mul_c_8_23 $end\n")
    self.sim_file.write("$var wire 32 ! a_i $end\n")
    self.sim_file.write("$var wire 32 \" b_i $end\n")
    self.sim_file.write("$var wire 32 # x_o $end\n")
    self.sim_file.write("$upscope $end\n")
    self.sim_file.write("$enddefinitions $end\n")
    self.sim_file.write("#0\n")
    self.sim_file.write("$dumpvars\n")
    found = 0
    for bit in range(31, -1, -1):
      if found:
        if self.n3 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n3 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" !\n")
    found = 0
    for bit in range(31, -1, -1):
      if found:
        if self.n4 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n4 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" \"\n")
    found = 0
    for bit in range(31, -1, -1):
      if found:
        if self.n1206 & (2L ** bit):
          self.sim_file.write("1")
        else:
          self.sim_file.write("0")
      else:
        if self.n1206 & (2L ** bit):
          self.sim_file.write("b1")
          found = 1
    if not found:
      self.sim_file.write("b0")
    self.sim_file.write(" #\n")
    self.sim_file.write("$end\n")

  def sim_end(self):
    self.sim_file.write("#%d\n" % self.sim_count)
    self.sim_file.close()

  def sim_sample(self):
    changed = 0
    if self.sim_n3 != self.n3:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(31, -1, -1):
        if found:
          if self.n3 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n3 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" !\n")
      self.sim_n3 = self.n3
    if self.sim_n4 != self.n4:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(31, -1, -1):
        if found:
          if self.n4 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n4 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" \"\n")
      self.sim_n4 = self.n4
    if self.sim_n1206 != self.n1206:
      if not changed:
        changed = 1
        self.sim_file.write("#%d\n" % self.sim_count)
      found = 0
      for bit in range(31, -1, -1):
        if found:
          if self.n1206 & (2L ** bit):
            self.sim_file.write("1")
          else:
            self.sim_file.write("0")
        else:
          if self.n1206 & (2L ** bit):
            self.sim_file.write("b1")
            found = 1
      if not found:
        self.sim_file.write("b0")
      self.sim_file.write(" #\n")
      self.sim_n1206 = self.n1206
    self.sim_count = self.sim_count + 1

