--
--  Copyright (c) 2003 Launchbird Design Systems, Inc.
--  All rights reserved.
--  
--  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
--    Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
--    Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
--  
--  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
--  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
--  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
--  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
--  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
--  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--  
--  
--  Overview:
--  
--    Performs floating point multiply.
--  
--  Interface:
--  
--  
--  
--    Inputs:
--      a_i : Left operand.
--      b_i : Right operand.
--  
--    Outputs:
--      x_o : Result.
--  
--  Built In Parameters:
--  
--    Exponent Precision = 8
--    Mantissa Precision = 23
--    Total    Precision = 32
--  
--  
--  
--  
--  
--  Generated by Confluence 0.6.3  --  Launchbird Design Systems, Inc.  --  www.launchbird.com
--  
--  Build Date : Fri Aug 22 09:47:06 CDT 2003
--  
--  Interface
--  
--    Build Name    : cf_fp_mul_c_8_23
--    Clock Domains : 
--    Vector Input  : a_i(32)
--    Vector Input  : b_i(32)
--    Vector Output : x_o(32)
--  
--  
--  

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_47;
architecture rtl of cf_fp_mul_c_8_23_47 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
begin
n1 <= i1 or i2;
n2 <= i3 or i4;
n3 <= i5 or i6;
n4 <= i7 or i8;
n5 <= n1 or n2;
n6 <= n3 or n4;
n7 <= n5 or n6;
n8 <= n7 or i9;
o1 <= n8;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_46 is
port (
i1 : in  unsigned(4 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_46;
architecture rtl of cf_fp_mul_c_8_23_46 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(3 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(2 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(1 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
begin
n1 <= i1(4 downto 4);
n2 <= i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(3 downto 3);
n4 <= n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(2 downto 2);
n6 <= n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n6(1 downto 1);
n8 <= n6(0 downto 0);
n9 <= n8(0 downto 0);
o5 <= n9;
o4 <= n7;
o3 <= n5;
o2 <= n3;
o1 <= n1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_45;
architecture rtl of cf_fp_mul_c_8_23_45 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(7 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(6 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(5 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(4 downto 0);
signal s9_1 : unsigned(0 downto 0);
signal s9_2 : unsigned(0 downto 0);
signal s9_3 : unsigned(0 downto 0);
signal s9_4 : unsigned(0 downto 0);
signal s9_5 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_46 is
port (
i1 : in  unsigned(4 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_46;
begin
n1 <= i1(8 downto 8);
n2 <= i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(7 downto 7);
n4 <= n2(6 downto 6) &
  n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(6 downto 6);
n6 <= n4(5 downto 5) &
  n4(4 downto 4) &
  n4(3 downto 3) &
  n4(2 downto 2) &
  n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n6(5 downto 5);
n8 <= n6(4 downto 4) &
  n6(3 downto 3) &
  n6(2 downto 2) &
  n6(1 downto 1) &
  n6(0 downto 0);
s9 : cf_fp_mul_c_8_23_46 port map (n8, s9_1, s9_2, s9_3, s9_4, s9_5);
o9 <= s9_5;
o8 <= s9_4;
o7 <= s9_3;
o6 <= s9_2;
o5 <= s9_1;
o4 <= n7;
o3 <= n5;
o2 <= n3;
o1 <= n1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_44 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(46 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(45 downto 0));
end entity cf_fp_mul_c_8_23_44;
architecture rtl of cf_fp_mul_c_8_23_44 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(45 downto 0);
signal n9 : unsigned(45 downto 0);
signal n10 : unsigned(45 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(46 downto 46);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(45 downto 45) &
  i2(44 downto 44) &
  i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(46 downto 46) &
  i2(45 downto 45) &
  i2(44 downto 44) &
  i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_43 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(39 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(38 downto 0));
end entity cf_fp_mul_c_8_23_43;
architecture rtl of cf_fp_mul_c_8_23_43 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(38 downto 0);
signal n9 : unsigned(38 downto 0);
signal n10 : unsigned(38 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(39 downto 39);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_42 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(32 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(31 downto 0));
end entity cf_fp_mul_c_8_23_42;
architecture rtl of cf_fp_mul_c_8_23_42 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(31 downto 0);
signal n9 : unsigned(31 downto 0);
signal n10 : unsigned(31 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(32 downto 32);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_41 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(24 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end entity cf_fp_mul_c_8_23_41;
architecture rtl of cf_fp_mul_c_8_23_41 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(23 downto 0);
signal n9 : unsigned(23 downto 0);
signal n10 : unsigned(23 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(24 downto 24);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_40 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(25 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(24 downto 0));
end entity cf_fp_mul_c_8_23_40;
architecture rtl of cf_fp_mul_c_8_23_40 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(24 downto 0);
signal n9 : unsigned(24 downto 0);
signal n10 : unsigned(24 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(25 downto 25);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_39 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(26 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(25 downto 0));
end entity cf_fp_mul_c_8_23_39;
architecture rtl of cf_fp_mul_c_8_23_39 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(25 downto 0);
signal n9 : unsigned(25 downto 0);
signal n10 : unsigned(25 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(26 downto 26);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_38 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(27 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(26 downto 0));
end entity cf_fp_mul_c_8_23_38;
architecture rtl of cf_fp_mul_c_8_23_38 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(26 downto 0);
signal n9 : unsigned(26 downto 0);
signal n10 : unsigned(26 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(27 downto 27);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_37 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(28 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(27 downto 0));
end entity cf_fp_mul_c_8_23_37;
architecture rtl of cf_fp_mul_c_8_23_37 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(27 downto 0);
signal n9 : unsigned(27 downto 0);
signal n10 : unsigned(27 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(28 downto 28);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_36 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(29 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(28 downto 0));
end entity cf_fp_mul_c_8_23_36;
architecture rtl of cf_fp_mul_c_8_23_36 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(28 downto 0);
signal n9 : unsigned(28 downto 0);
signal n10 : unsigned(28 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(29 downto 29);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_35 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(30 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(29 downto 0));
end entity cf_fp_mul_c_8_23_35;
architecture rtl of cf_fp_mul_c_8_23_35 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(29 downto 0);
signal n9 : unsigned(29 downto 0);
signal n10 : unsigned(29 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(30 downto 30);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_34 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(30 downto 0));
end entity cf_fp_mul_c_8_23_34;
architecture rtl of cf_fp_mul_c_8_23_34 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(30 downto 0);
signal n9 : unsigned(30 downto 0);
signal n10 : unsigned(30 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(31 downto 31);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_33 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end entity cf_fp_mul_c_8_23_33;
architecture rtl of cf_fp_mul_c_8_23_33 is
signal s1_1 : unsigned(8 downto 0);
signal s1_2 : unsigned(23 downto 0);
signal s2_1 : unsigned(8 downto 0);
signal s2_2 : unsigned(24 downto 0);
signal s3_1 : unsigned(8 downto 0);
signal s3_2 : unsigned(25 downto 0);
signal s4_1 : unsigned(8 downto 0);
signal s4_2 : unsigned(26 downto 0);
signal s5_1 : unsigned(8 downto 0);
signal s5_2 : unsigned(27 downto 0);
signal s6_1 : unsigned(8 downto 0);
signal s6_2 : unsigned(28 downto 0);
signal s7_1 : unsigned(8 downto 0);
signal s7_2 : unsigned(29 downto 0);
signal s8_1 : unsigned(8 downto 0);
signal s8_2 : unsigned(30 downto 0);
component cf_fp_mul_c_8_23_41 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(24 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end component cf_fp_mul_c_8_23_41;
component cf_fp_mul_c_8_23_40 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(25 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(24 downto 0));
end component cf_fp_mul_c_8_23_40;
component cf_fp_mul_c_8_23_39 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(26 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(25 downto 0));
end component cf_fp_mul_c_8_23_39;
component cf_fp_mul_c_8_23_38 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(27 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(26 downto 0));
end component cf_fp_mul_c_8_23_38;
component cf_fp_mul_c_8_23_37 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(28 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(27 downto 0));
end component cf_fp_mul_c_8_23_37;
component cf_fp_mul_c_8_23_36 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(29 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(28 downto 0));
end component cf_fp_mul_c_8_23_36;
component cf_fp_mul_c_8_23_35 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(30 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(29 downto 0));
end component cf_fp_mul_c_8_23_35;
component cf_fp_mul_c_8_23_34 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(30 downto 0));
end component cf_fp_mul_c_8_23_34;
begin
s1 : cf_fp_mul_c_8_23_41 port map (s2_1, s2_2, s1_1, s1_2);
s2 : cf_fp_mul_c_8_23_40 port map (s3_1, s3_2, s2_1, s2_2);
s3 : cf_fp_mul_c_8_23_39 port map (s4_1, s4_2, s3_1, s3_2);
s4 : cf_fp_mul_c_8_23_38 port map (s5_1, s5_2, s4_1, s4_2);
s5 : cf_fp_mul_c_8_23_37 port map (s6_1, s6_2, s5_1, s5_2);
s6 : cf_fp_mul_c_8_23_36 port map (s7_1, s7_2, s6_1, s6_2);
s7 : cf_fp_mul_c_8_23_35 port map (s8_1, s8_2, s7_1, s7_2);
s8 : cf_fp_mul_c_8_23_34 port map (i1, i2, s8_1, s8_2);
o2 <= s1_2;
o1 <= s1_1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_32 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(33 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(32 downto 0));
end entity cf_fp_mul_c_8_23_32;
architecture rtl of cf_fp_mul_c_8_23_32 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(32 downto 0);
signal n9 : unsigned(32 downto 0);
signal n10 : unsigned(32 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(33 downto 33);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_31 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(34 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(33 downto 0));
end entity cf_fp_mul_c_8_23_31;
architecture rtl of cf_fp_mul_c_8_23_31 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(33 downto 0);
signal n9 : unsigned(33 downto 0);
signal n10 : unsigned(33 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(34 downto 34);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_30 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(35 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(34 downto 0));
end entity cf_fp_mul_c_8_23_30;
architecture rtl of cf_fp_mul_c_8_23_30 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(34 downto 0);
signal n9 : unsigned(34 downto 0);
signal n10 : unsigned(34 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(35 downto 35);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_29 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(36 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(35 downto 0));
end entity cf_fp_mul_c_8_23_29;
architecture rtl of cf_fp_mul_c_8_23_29 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(35 downto 0);
signal n9 : unsigned(35 downto 0);
signal n10 : unsigned(35 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(36 downto 36);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_28 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(37 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(36 downto 0));
end entity cf_fp_mul_c_8_23_28;
architecture rtl of cf_fp_mul_c_8_23_28 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(36 downto 0);
signal n9 : unsigned(36 downto 0);
signal n10 : unsigned(36 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(37 downto 37);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_27 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(38 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(37 downto 0));
end entity cf_fp_mul_c_8_23_27;
architecture rtl of cf_fp_mul_c_8_23_27 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(37 downto 0);
signal n9 : unsigned(37 downto 0);
signal n10 : unsigned(37 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(38 downto 38);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_26 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(38 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end entity cf_fp_mul_c_8_23_26;
architecture rtl of cf_fp_mul_c_8_23_26 is
signal s1_1 : unsigned(8 downto 0);
signal s1_2 : unsigned(31 downto 0);
signal s2_1 : unsigned(8 downto 0);
signal s2_2 : unsigned(23 downto 0);
signal s3_1 : unsigned(8 downto 0);
signal s3_2 : unsigned(32 downto 0);
signal s4_1 : unsigned(8 downto 0);
signal s4_2 : unsigned(33 downto 0);
signal s5_1 : unsigned(8 downto 0);
signal s5_2 : unsigned(34 downto 0);
signal s6_1 : unsigned(8 downto 0);
signal s6_2 : unsigned(35 downto 0);
signal s7_1 : unsigned(8 downto 0);
signal s7_2 : unsigned(36 downto 0);
signal s8_1 : unsigned(8 downto 0);
signal s8_2 : unsigned(37 downto 0);
component cf_fp_mul_c_8_23_42 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(32 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(31 downto 0));
end component cf_fp_mul_c_8_23_42;
component cf_fp_mul_c_8_23_33 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end component cf_fp_mul_c_8_23_33;
component cf_fp_mul_c_8_23_32 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(33 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(32 downto 0));
end component cf_fp_mul_c_8_23_32;
component cf_fp_mul_c_8_23_31 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(34 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(33 downto 0));
end component cf_fp_mul_c_8_23_31;
component cf_fp_mul_c_8_23_30 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(35 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(34 downto 0));
end component cf_fp_mul_c_8_23_30;
component cf_fp_mul_c_8_23_29 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(36 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(35 downto 0));
end component cf_fp_mul_c_8_23_29;
component cf_fp_mul_c_8_23_28 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(37 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(36 downto 0));
end component cf_fp_mul_c_8_23_28;
component cf_fp_mul_c_8_23_27 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(38 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(37 downto 0));
end component cf_fp_mul_c_8_23_27;
begin
s1 : cf_fp_mul_c_8_23_42 port map (s3_1, s3_2, s1_1, s1_2);
s2 : cf_fp_mul_c_8_23_33 port map (s1_1, s1_2, s2_1, s2_2);
s3 : cf_fp_mul_c_8_23_32 port map (s4_1, s4_2, s3_1, s3_2);
s4 : cf_fp_mul_c_8_23_31 port map (s5_1, s5_2, s4_1, s4_2);
s5 : cf_fp_mul_c_8_23_30 port map (s6_1, s6_2, s5_1, s5_2);
s6 : cf_fp_mul_c_8_23_29 port map (s7_1, s7_2, s6_1, s6_2);
s7 : cf_fp_mul_c_8_23_28 port map (s8_1, s8_2, s7_1, s7_2);
s8 : cf_fp_mul_c_8_23_27 port map (i1, i2, s8_1, s8_2);
o2 <= s2_2;
o1 <= s2_1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_25 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(40 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(39 downto 0));
end entity cf_fp_mul_c_8_23_25;
architecture rtl of cf_fp_mul_c_8_23_25 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(39 downto 0);
signal n9 : unsigned(39 downto 0);
signal n10 : unsigned(39 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(40 downto 40);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_24 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(41 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(40 downto 0));
end entity cf_fp_mul_c_8_23_24;
architecture rtl of cf_fp_mul_c_8_23_24 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(40 downto 0);
signal n9 : unsigned(40 downto 0);
signal n10 : unsigned(40 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(41 downto 41);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_23 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(42 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(41 downto 0));
end entity cf_fp_mul_c_8_23_23;
architecture rtl of cf_fp_mul_c_8_23_23 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(41 downto 0);
signal n9 : unsigned(41 downto 0);
signal n10 : unsigned(41 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(42 downto 42);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_22 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(43 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(42 downto 0));
end entity cf_fp_mul_c_8_23_22;
architecture rtl of cf_fp_mul_c_8_23_22 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(42 downto 0);
signal n9 : unsigned(42 downto 0);
signal n10 : unsigned(42 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(43 downto 43);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_21 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(44 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(43 downto 0));
end entity cf_fp_mul_c_8_23_21;
architecture rtl of cf_fp_mul_c_8_23_21 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(43 downto 0);
signal n9 : unsigned(43 downto 0);
signal n10 : unsigned(43 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(44 downto 44);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(44 downto 44) &
  i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_20 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(45 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(44 downto 0));
end entity cf_fp_mul_c_8_23_20;
architecture rtl of cf_fp_mul_c_8_23_20 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(8 downto 0);
signal n6 : unsigned(8 downto 0);
signal n7 : unsigned(8 downto 0);
signal n8 : unsigned(44 downto 0);
signal n9 : unsigned(44 downto 0);
signal n10 : unsigned(44 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s12_1 : unsigned(0 downto 0);
signal s12_2 : unsigned(0 downto 0);
signal s12_3 : unsigned(0 downto 0);
signal s12_4 : unsigned(0 downto 0);
signal s12_5 : unsigned(0 downto 0);
signal s12_6 : unsigned(0 downto 0);
signal s12_7 : unsigned(0 downto 0);
signal s12_8 : unsigned(0 downto 0);
signal s12_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_47 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_47;
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i2(45 downto 45);
n2 <= not s11_1;
n3 <= n1 or n2;
n4 <= not n3;
n5 <= "000000001";
n6 <= i1 - n5;
n7 <= n6 when n4 = "1" else i1;
n8 <= i2(44 downto 44) &
  i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n9 <= i2(45 downto 45) &
  i2(44 downto 44) &
  i2(43 downto 43) &
  i2(42 downto 42) &
  i2(41 downto 41) &
  i2(40 downto 40) &
  i2(39 downto 39) &
  i2(38 downto 38) &
  i2(37 downto 37) &
  i2(36 downto 36) &
  i2(35 downto 35) &
  i2(34 downto 34) &
  i2(33 downto 33) &
  i2(32 downto 32) &
  i2(31 downto 31) &
  i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23) &
  i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1);
n10 <= n8 when n4 = "1" else n9;
s11 : cf_fp_mul_c_8_23_47 port map (s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9, s11_1);
s12 : cf_fp_mul_c_8_23_45 port map (i1, s12_1, s12_2, s12_3, s12_4, s12_5, s12_6, s12_7, s12_8, s12_9);
o2 <= n10;
o1 <= n7;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_19 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(45 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end entity cf_fp_mul_c_8_23_19;
architecture rtl of cf_fp_mul_c_8_23_19 is
signal s1_1 : unsigned(8 downto 0);
signal s1_2 : unsigned(38 downto 0);
signal s2_1 : unsigned(8 downto 0);
signal s2_2 : unsigned(23 downto 0);
signal s3_1 : unsigned(8 downto 0);
signal s3_2 : unsigned(39 downto 0);
signal s4_1 : unsigned(8 downto 0);
signal s4_2 : unsigned(40 downto 0);
signal s5_1 : unsigned(8 downto 0);
signal s5_2 : unsigned(41 downto 0);
signal s6_1 : unsigned(8 downto 0);
signal s6_2 : unsigned(42 downto 0);
signal s7_1 : unsigned(8 downto 0);
signal s7_2 : unsigned(43 downto 0);
signal s8_1 : unsigned(8 downto 0);
signal s8_2 : unsigned(44 downto 0);
component cf_fp_mul_c_8_23_43 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(39 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(38 downto 0));
end component cf_fp_mul_c_8_23_43;
component cf_fp_mul_c_8_23_26 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(38 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end component cf_fp_mul_c_8_23_26;
component cf_fp_mul_c_8_23_25 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(40 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(39 downto 0));
end component cf_fp_mul_c_8_23_25;
component cf_fp_mul_c_8_23_24 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(41 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(40 downto 0));
end component cf_fp_mul_c_8_23_24;
component cf_fp_mul_c_8_23_23 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(42 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(41 downto 0));
end component cf_fp_mul_c_8_23_23;
component cf_fp_mul_c_8_23_22 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(43 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(42 downto 0));
end component cf_fp_mul_c_8_23_22;
component cf_fp_mul_c_8_23_21 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(44 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(43 downto 0));
end component cf_fp_mul_c_8_23_21;
component cf_fp_mul_c_8_23_20 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(45 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(44 downto 0));
end component cf_fp_mul_c_8_23_20;
begin
s1 : cf_fp_mul_c_8_23_43 port map (s3_1, s3_2, s1_1, s1_2);
s2 : cf_fp_mul_c_8_23_26 port map (s1_1, s1_2, s2_1, s2_2);
s3 : cf_fp_mul_c_8_23_25 port map (s4_1, s4_2, s3_1, s3_2);
s4 : cf_fp_mul_c_8_23_24 port map (s5_1, s5_2, s4_1, s4_2);
s5 : cf_fp_mul_c_8_23_23 port map (s6_1, s6_2, s5_1, s5_2);
s6 : cf_fp_mul_c_8_23_22 port map (s7_1, s7_2, s6_1, s6_2);
s7 : cf_fp_mul_c_8_23_21 port map (s8_1, s8_2, s7_1, s7_2);
s8 : cf_fp_mul_c_8_23_20 port map (i1, i2, s8_1, s8_2);
o2 <= s2_2;
o1 <= s2_1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_18 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_8_23_18;
architecture rtl of cf_fp_mul_c_8_23_18 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
begin
n1 <= "0010";
n2 <= "1" when i1 = n1 else "0";
n3 <= "0011";
n4 <= "1" when i1 = n3 else "0";
n5 <= "0001";
n6 <= "1" when i1 = n5 else "0";
n7 <= i3 when n6 = "1" else i2;
n8 <= i4 when n4 = "1" else n7;
n9 <= i4 when n2 = "1" else n8;
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_17 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_8_23_17;
architecture rtl of cf_fp_mul_c_8_23_17 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_8_23_18 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_8_23_18;
begin
n1 <= "0101";
n2 <= "1" when i1 = n1 else "0";
n3 <= "0110";
n4 <= "1" when i1 = n3 else "0";
n5 <= "0111";
n6 <= "1" when i1 = n5 else "0";
n7 <= i5 when n6 = "1" else s10_1;
n8 <= i5 when n4 = "1" else n7;
n9 <= i5 when n2 = "1" else n8;
s10 : cf_fp_mul_c_8_23_18 port map (i1, i2, i3, i4, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_16 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_8_23_16;
architecture rtl of cf_fp_mul_c_8_23_16 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_8_23_17 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_8_23_17;
begin
n1 <= "1110";
n2 <= "1" when i1 = n1 else "0";
n3 <= "1111";
n4 <= "1" when i1 = n3 else "0";
n5 <= "0100";
n6 <= "1" when i1 = n5 else "0";
n7 <= i5 when n6 = "1" else s10_1;
n8 <= i6 when n4 = "1" else n7;
n9 <= i6 when n2 = "1" else n8;
s10 : cf_fp_mul_c_8_23_17 port map (i1, i2, i3, i4, i5, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_15 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_8_23_15;
architecture rtl of cf_fp_mul_c_8_23_15 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_8_23_16 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_8_23_16;
begin
n1 <= "1011";
n2 <= "1" when i1 = n1 else "0";
n3 <= "1100";
n4 <= "1" when i1 = n3 else "0";
n5 <= "1101";
n6 <= "1" when i1 = n5 else "0";
n7 <= i6 when n6 = "1" else s10_1;
n8 <= i6 when n4 = "1" else n7;
n9 <= i6 when n2 = "1" else n8;
s10 : cf_fp_mul_c_8_23_16 port map (i1, i2, i3, i4, i5, i6, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_14 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end entity cf_fp_mul_c_8_23_14;
architecture rtl of cf_fp_mul_c_8_23_14 is
signal n1 : unsigned(3 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(3 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(3 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(2 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal s10_1 : unsigned(2 downto 0);
component cf_fp_mul_c_8_23_15 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_8_23_15;
begin
n1 <= "1000";
n2 <= "1" when i1 = n1 else "0";
n3 <= "1001";
n4 <= "1" when i1 = n3 else "0";
n5 <= "1010";
n6 <= "1" when i1 = n5 else "0";
n7 <= i6 when n6 = "1" else s10_1;
n8 <= i6 when n4 = "1" else n7;
n9 <= i6 when n2 = "1" else n8;
s10 : cf_fp_mul_c_8_23_15 port map (i1, i2, i3, i4, i5, i6, s10_1);
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_13 is
port (
i1 : in  unsigned(30 downto 0);
i2 : in  unsigned(30 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(30 downto 0);
i5 : in  unsigned(30 downto 0);
i6 : in  unsigned(30 downto 0);
o1 : out unsigned(30 downto 0));
end entity cf_fp_mul_c_8_23_13;
architecture rtl of cf_fp_mul_c_8_23_13 is
signal n1 : unsigned(1 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(30 downto 0);
signal n4 : unsigned(30 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(30 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(30 downto 0);
begin
n1 <= i3(2 downto 2) &
  i3(1 downto 1);
n2 <= i3(0 downto 0);
n3 <= i2 when n2 = "1" else i1;
n4 <= i5 when n2 = "1" else i4;
n5 <= n1(1 downto 1);
n6 <= n1(0 downto 0);
n7 <= n4 when n6 = "1" else n3;
n8 <= n5(0 downto 0);
n9 <= i6 when n8 = "1" else n7;
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_12 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(8 downto 0);
i7 : in  unsigned(23 downto 0);
o1 : out unsigned(31 downto 0));
end entity cf_fp_mul_c_8_23_12;
architecture rtl of cf_fp_mul_c_8_23_12 is
signal n1 : unsigned(7 downto 0);
signal n2 : unsigned(22 downto 0);
signal n3 : unsigned(30 downto 0);
signal n4 : unsigned(30 downto 0);
signal n5 : unsigned(1 downto 0);
signal n6 : unsigned(2 downto 0);
signal n7 : unsigned(3 downto 0);
signal n8 : unsigned(2 downto 0);
signal n9 : unsigned(2 downto 0);
signal n10 : unsigned(2 downto 0);
signal n11 : unsigned(2 downto 0);
signal n12 : unsigned(2 downto 0);
signal n13 : unsigned(31 downto 0);
signal n14 : unsigned(30 downto 0);
signal n15 : unsigned(30 downto 0);
signal n16 : unsigned(30 downto 0);
signal s17_1 : unsigned(2 downto 0);
signal s18_1 : unsigned(30 downto 0);
component cf_fp_mul_c_8_23_14 is
port (
i1 : in  unsigned(3 downto 0);
i2 : in  unsigned(2 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(2 downto 0);
i5 : in  unsigned(2 downto 0);
i6 : in  unsigned(2 downto 0);
o1 : out unsigned(2 downto 0));
end component cf_fp_mul_c_8_23_14;
component cf_fp_mul_c_8_23_13 is
port (
i1 : in  unsigned(30 downto 0);
i2 : in  unsigned(30 downto 0);
i3 : in  unsigned(2 downto 0);
i4 : in  unsigned(30 downto 0);
i5 : in  unsigned(30 downto 0);
i6 : in  unsigned(30 downto 0);
o1 : out unsigned(30 downto 0));
end component cf_fp_mul_c_8_23_13;
begin
n1 <= i6(7 downto 7) &
  i6(6 downto 6) &
  i6(5 downto 5) &
  i6(4 downto 4) &
  i6(3 downto 3) &
  i6(2 downto 2) &
  i6(1 downto 1) &
  i6(0 downto 0);
n2 <= i7(22 downto 22) &
  i7(21 downto 21) &
  i7(20 downto 20) &
  i7(19 downto 19) &
  i7(18 downto 18) &
  i7(17 downto 17) &
  i7(16 downto 16) &
  i7(15 downto 15) &
  i7(14 downto 14) &
  i7(13 downto 13) &
  i7(12 downto 12) &
  i7(11 downto 11) &
  i7(10 downto 10) &
  i7(9 downto 9) &
  i7(8 downto 8) &
  i7(7 downto 7) &
  i7(6 downto 6) &
  i7(5 downto 5) &
  i7(4 downto 4) &
  i7(3 downto 3) &
  i7(2 downto 2) &
  i7(1 downto 1) &
  i7(0 downto 0);
n3 <= n1 & n2;
n4 <= "0000000000000000000000000000000";
n5 <= i3 & i4;
n6 <= i2 & n5;
n7 <= i1 & n6;
n8 <= "000";
n9 <= "001";
n10 <= "010";
n11 <= "011";
n12 <= "100";
n13 <= i5 & s18_1;
n14 <= "1111111100000000000000000000000";
n15 <= "1111111111111111111111111111111";
n16 <= "1111111101111111111111111111111";
s17 : cf_fp_mul_c_8_23_14 port map (n7, n8, n9, n10, n11, n12, s17_1);
s18 : cf_fp_mul_c_8_23_13 port map (n3, n4, s17_1, n14, n15, n16, s18_1);
o1 <= n13;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_11 is
port (
i1 : in  unsigned(12 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0);
o10 : out unsigned(0 downto 0);
o11 : out unsigned(0 downto 0);
o12 : out unsigned(0 downto 0);
o13 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_11;
architecture rtl of cf_fp_mul_c_8_23_11 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(11 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(10 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(9 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(8 downto 0);
signal s9_1 : unsigned(0 downto 0);
signal s9_2 : unsigned(0 downto 0);
signal s9_3 : unsigned(0 downto 0);
signal s9_4 : unsigned(0 downto 0);
signal s9_5 : unsigned(0 downto 0);
signal s9_6 : unsigned(0 downto 0);
signal s9_7 : unsigned(0 downto 0);
signal s9_8 : unsigned(0 downto 0);
signal s9_9 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_45 is
port (
i1 : in  unsigned(8 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_45;
begin
n1 <= i1(12 downto 12);
n2 <= i1(11 downto 11) &
  i1(10 downto 10) &
  i1(9 downto 9) &
  i1(8 downto 8) &
  i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(11 downto 11);
n4 <= n2(10 downto 10) &
  n2(9 downto 9) &
  n2(8 downto 8) &
  n2(7 downto 7) &
  n2(6 downto 6) &
  n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(10 downto 10);
n6 <= n4(9 downto 9) &
  n4(8 downto 8) &
  n4(7 downto 7) &
  n4(6 downto 6) &
  n4(5 downto 5) &
  n4(4 downto 4) &
  n4(3 downto 3) &
  n4(2 downto 2) &
  n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n6(9 downto 9);
n8 <= n6(8 downto 8) &
  n6(7 downto 7) &
  n6(6 downto 6) &
  n6(5 downto 5) &
  n6(4 downto 4) &
  n6(3 downto 3) &
  n6(2 downto 2) &
  n6(1 downto 1) &
  n6(0 downto 0);
s9 : cf_fp_mul_c_8_23_45 port map (n8, s9_1, s9_2, s9_3, s9_4, s9_5, s9_6, s9_7, s9_8, s9_9);
o13 <= s9_9;
o12 <= s9_8;
o11 <= s9_7;
o10 <= s9_6;
o9 <= s9_5;
o8 <= s9_4;
o7 <= s9_3;
o6 <= s9_2;
o5 <= s9_1;
o4 <= n7;
o3 <= n5;
o2 <= n3;
o1 <= n1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_10 is
port (
i1 : in  unsigned(16 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0);
o10 : out unsigned(0 downto 0);
o11 : out unsigned(0 downto 0);
o12 : out unsigned(0 downto 0);
o13 : out unsigned(0 downto 0);
o14 : out unsigned(0 downto 0);
o15 : out unsigned(0 downto 0);
o16 : out unsigned(0 downto 0);
o17 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_10;
architecture rtl of cf_fp_mul_c_8_23_10 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(15 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(14 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(13 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(12 downto 0);
signal s9_1 : unsigned(0 downto 0);
signal s9_2 : unsigned(0 downto 0);
signal s9_3 : unsigned(0 downto 0);
signal s9_4 : unsigned(0 downto 0);
signal s9_5 : unsigned(0 downto 0);
signal s9_6 : unsigned(0 downto 0);
signal s9_7 : unsigned(0 downto 0);
signal s9_8 : unsigned(0 downto 0);
signal s9_9 : unsigned(0 downto 0);
signal s9_10 : unsigned(0 downto 0);
signal s9_11 : unsigned(0 downto 0);
signal s9_12 : unsigned(0 downto 0);
signal s9_13 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_11 is
port (
i1 : in  unsigned(12 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0);
o10 : out unsigned(0 downto 0);
o11 : out unsigned(0 downto 0);
o12 : out unsigned(0 downto 0);
o13 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_11;
begin
n1 <= i1(16 downto 16);
n2 <= i1(15 downto 15) &
  i1(14 downto 14) &
  i1(13 downto 13) &
  i1(12 downto 12) &
  i1(11 downto 11) &
  i1(10 downto 10) &
  i1(9 downto 9) &
  i1(8 downto 8) &
  i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(15 downto 15);
n4 <= n2(14 downto 14) &
  n2(13 downto 13) &
  n2(12 downto 12) &
  n2(11 downto 11) &
  n2(10 downto 10) &
  n2(9 downto 9) &
  n2(8 downto 8) &
  n2(7 downto 7) &
  n2(6 downto 6) &
  n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(14 downto 14);
n6 <= n4(13 downto 13) &
  n4(12 downto 12) &
  n4(11 downto 11) &
  n4(10 downto 10) &
  n4(9 downto 9) &
  n4(8 downto 8) &
  n4(7 downto 7) &
  n4(6 downto 6) &
  n4(5 downto 5) &
  n4(4 downto 4) &
  n4(3 downto 3) &
  n4(2 downto 2) &
  n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n6(13 downto 13);
n8 <= n6(12 downto 12) &
  n6(11 downto 11) &
  n6(10 downto 10) &
  n6(9 downto 9) &
  n6(8 downto 8) &
  n6(7 downto 7) &
  n6(6 downto 6) &
  n6(5 downto 5) &
  n6(4 downto 4) &
  n6(3 downto 3) &
  n6(2 downto 2) &
  n6(1 downto 1) &
  n6(0 downto 0);
s9 : cf_fp_mul_c_8_23_11 port map (n8, s9_1, s9_2, s9_3, s9_4, s9_5, s9_6, s9_7, s9_8, s9_9, s9_10, s9_11, s9_12, s9_13);
o17 <= s9_13;
o16 <= s9_12;
o15 <= s9_11;
o14 <= s9_10;
o13 <= s9_9;
o12 <= s9_8;
o11 <= s9_7;
o10 <= s9_6;
o9 <= s9_5;
o8 <= s9_4;
o7 <= s9_3;
o6 <= s9_2;
o5 <= s9_1;
o4 <= n7;
o3 <= n5;
o2 <= n3;
o1 <= n1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_9 is
port (
i1 : in  unsigned(20 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0);
o10 : out unsigned(0 downto 0);
o11 : out unsigned(0 downto 0);
o12 : out unsigned(0 downto 0);
o13 : out unsigned(0 downto 0);
o14 : out unsigned(0 downto 0);
o15 : out unsigned(0 downto 0);
o16 : out unsigned(0 downto 0);
o17 : out unsigned(0 downto 0);
o18 : out unsigned(0 downto 0);
o19 : out unsigned(0 downto 0);
o20 : out unsigned(0 downto 0);
o21 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_9;
architecture rtl of cf_fp_mul_c_8_23_9 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(19 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(18 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(17 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(16 downto 0);
signal s9_1 : unsigned(0 downto 0);
signal s9_2 : unsigned(0 downto 0);
signal s9_3 : unsigned(0 downto 0);
signal s9_4 : unsigned(0 downto 0);
signal s9_5 : unsigned(0 downto 0);
signal s9_6 : unsigned(0 downto 0);
signal s9_7 : unsigned(0 downto 0);
signal s9_8 : unsigned(0 downto 0);
signal s9_9 : unsigned(0 downto 0);
signal s9_10 : unsigned(0 downto 0);
signal s9_11 : unsigned(0 downto 0);
signal s9_12 : unsigned(0 downto 0);
signal s9_13 : unsigned(0 downto 0);
signal s9_14 : unsigned(0 downto 0);
signal s9_15 : unsigned(0 downto 0);
signal s9_16 : unsigned(0 downto 0);
signal s9_17 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_10 is
port (
i1 : in  unsigned(16 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0);
o10 : out unsigned(0 downto 0);
o11 : out unsigned(0 downto 0);
o12 : out unsigned(0 downto 0);
o13 : out unsigned(0 downto 0);
o14 : out unsigned(0 downto 0);
o15 : out unsigned(0 downto 0);
o16 : out unsigned(0 downto 0);
o17 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_10;
begin
n1 <= i1(20 downto 20);
n2 <= i1(19 downto 19) &
  i1(18 downto 18) &
  i1(17 downto 17) &
  i1(16 downto 16) &
  i1(15 downto 15) &
  i1(14 downto 14) &
  i1(13 downto 13) &
  i1(12 downto 12) &
  i1(11 downto 11) &
  i1(10 downto 10) &
  i1(9 downto 9) &
  i1(8 downto 8) &
  i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(19 downto 19);
n4 <= n2(18 downto 18) &
  n2(17 downto 17) &
  n2(16 downto 16) &
  n2(15 downto 15) &
  n2(14 downto 14) &
  n2(13 downto 13) &
  n2(12 downto 12) &
  n2(11 downto 11) &
  n2(10 downto 10) &
  n2(9 downto 9) &
  n2(8 downto 8) &
  n2(7 downto 7) &
  n2(6 downto 6) &
  n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(18 downto 18);
n6 <= n4(17 downto 17) &
  n4(16 downto 16) &
  n4(15 downto 15) &
  n4(14 downto 14) &
  n4(13 downto 13) &
  n4(12 downto 12) &
  n4(11 downto 11) &
  n4(10 downto 10) &
  n4(9 downto 9) &
  n4(8 downto 8) &
  n4(7 downto 7) &
  n4(6 downto 6) &
  n4(5 downto 5) &
  n4(4 downto 4) &
  n4(3 downto 3) &
  n4(2 downto 2) &
  n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n6(17 downto 17);
n8 <= n6(16 downto 16) &
  n6(15 downto 15) &
  n6(14 downto 14) &
  n6(13 downto 13) &
  n6(12 downto 12) &
  n6(11 downto 11) &
  n6(10 downto 10) &
  n6(9 downto 9) &
  n6(8 downto 8) &
  n6(7 downto 7) &
  n6(6 downto 6) &
  n6(5 downto 5) &
  n6(4 downto 4) &
  n6(3 downto 3) &
  n6(2 downto 2) &
  n6(1 downto 1) &
  n6(0 downto 0);
s9 : cf_fp_mul_c_8_23_10 port map (n8, s9_1, s9_2, s9_3, s9_4, s9_5, s9_6, s9_7, s9_8, s9_9, s9_10, s9_11, s9_12, s9_13, s9_14, s9_15, s9_16, s9_17);
o21 <= s9_17;
o20 <= s9_16;
o19 <= s9_15;
o18 <= s9_14;
o17 <= s9_13;
o16 <= s9_12;
o15 <= s9_11;
o14 <= s9_10;
o13 <= s9_9;
o12 <= s9_8;
o11 <= s9_7;
o10 <= s9_6;
o9 <= s9_5;
o8 <= s9_4;
o7 <= s9_3;
o6 <= s9_2;
o5 <= s9_1;
o4 <= n7;
o3 <= n5;
o2 <= n3;
o1 <= n1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_8 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
i10 : in  unsigned(0 downto 0);
i11 : in  unsigned(0 downto 0);
i12 : in  unsigned(0 downto 0);
i13 : in  unsigned(0 downto 0);
i14 : in  unsigned(0 downto 0);
i15 : in  unsigned(0 downto 0);
i16 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_8;
architecture rtl of cf_fp_mul_c_8_23_8 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
begin
n1 <= i1 or i2;
n2 <= i3 or i4;
n3 <= i5 or i6;
n4 <= i7 or i8;
n5 <= i9 or i10;
n6 <= i11 or i12;
n7 <= i13 or i14;
n8 <= i15 or i16;
o8 <= n8;
o7 <= n7;
o6 <= n6;
o5 <= n5;
o4 <= n4;
o3 <= n3;
o2 <= n2;
o1 <= n1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_7 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
i10 : in  unsigned(0 downto 0);
i11 : in  unsigned(0 downto 0);
i12 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_7;
architecture rtl of cf_fp_mul_c_8_23_7 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(0 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
begin
n1 <= i2 or i3;
n2 <= i4 or i5;
n3 <= i6 or i7;
n4 <= i8 or i9;
n5 <= i10 or i11;
n6 <= i12 or i1;
n7 <= n1 or n2;
n8 <= n3 or n4;
n9 <= n5 or n6;
n10 <= n7 or n8;
n11 <= n10 or n9;
o1 <= n11;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_6 is
port (
i1 : in  unsigned(22 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_6;
architecture rtl of cf_fp_mul_c_8_23_6 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(21 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(20 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal s9_1 : unsigned(0 downto 0);
signal s9_2 : unsigned(0 downto 0);
signal s9_3 : unsigned(0 downto 0);
signal s9_4 : unsigned(0 downto 0);
signal s9_5 : unsigned(0 downto 0);
signal s9_6 : unsigned(0 downto 0);
signal s9_7 : unsigned(0 downto 0);
signal s9_8 : unsigned(0 downto 0);
signal s9_9 : unsigned(0 downto 0);
signal s9_10 : unsigned(0 downto 0);
signal s9_11 : unsigned(0 downto 0);
signal s9_12 : unsigned(0 downto 0);
signal s9_13 : unsigned(0 downto 0);
signal s9_14 : unsigned(0 downto 0);
signal s9_15 : unsigned(0 downto 0);
signal s9_16 : unsigned(0 downto 0);
signal s9_17 : unsigned(0 downto 0);
signal s9_18 : unsigned(0 downto 0);
signal s9_19 : unsigned(0 downto 0);
signal s9_20 : unsigned(0 downto 0);
signal s9_21 : unsigned(0 downto 0);
signal s10_1 : unsigned(0 downto 0);
signal s10_2 : unsigned(0 downto 0);
signal s10_3 : unsigned(0 downto 0);
signal s10_4 : unsigned(0 downto 0);
signal s10_5 : unsigned(0 downto 0);
signal s10_6 : unsigned(0 downto 0);
signal s10_7 : unsigned(0 downto 0);
signal s10_8 : unsigned(0 downto 0);
signal s11_1 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_9 is
port (
i1 : in  unsigned(20 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0);
o9 : out unsigned(0 downto 0);
o10 : out unsigned(0 downto 0);
o11 : out unsigned(0 downto 0);
o12 : out unsigned(0 downto 0);
o13 : out unsigned(0 downto 0);
o14 : out unsigned(0 downto 0);
o15 : out unsigned(0 downto 0);
o16 : out unsigned(0 downto 0);
o17 : out unsigned(0 downto 0);
o18 : out unsigned(0 downto 0);
o19 : out unsigned(0 downto 0);
o20 : out unsigned(0 downto 0);
o21 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_9;
component cf_fp_mul_c_8_23_8 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
i10 : in  unsigned(0 downto 0);
i11 : in  unsigned(0 downto 0);
i12 : in  unsigned(0 downto 0);
i13 : in  unsigned(0 downto 0);
i14 : in  unsigned(0 downto 0);
i15 : in  unsigned(0 downto 0);
i16 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(0 downto 0);
o7 : out unsigned(0 downto 0);
o8 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_8;
component cf_fp_mul_c_8_23_7 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(0 downto 0);
i7 : in  unsigned(0 downto 0);
i8 : in  unsigned(0 downto 0);
i9 : in  unsigned(0 downto 0);
i10 : in  unsigned(0 downto 0);
i11 : in  unsigned(0 downto 0);
i12 : in  unsigned(0 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_7;
begin
n1 <= i1(22 downto 22);
n2 <= i1(21 downto 21) &
  i1(20 downto 20) &
  i1(19 downto 19) &
  i1(18 downto 18) &
  i1(17 downto 17) &
  i1(16 downto 16) &
  i1(15 downto 15) &
  i1(14 downto 14) &
  i1(13 downto 13) &
  i1(12 downto 12) &
  i1(11 downto 11) &
  i1(10 downto 10) &
  i1(9 downto 9) &
  i1(8 downto 8) &
  i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(21 downto 21);
n4 <= n2(20 downto 20) &
  n2(19 downto 19) &
  n2(18 downto 18) &
  n2(17 downto 17) &
  n2(16 downto 16) &
  n2(15 downto 15) &
  n2(14 downto 14) &
  n2(13 downto 13) &
  n2(12 downto 12) &
  n2(11 downto 11) &
  n2(10 downto 10) &
  n2(9 downto 9) &
  n2(8 downto 8) &
  n2(7 downto 7) &
  n2(6 downto 6) &
  n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n1 or n3;
n6 <= s9_1 or s9_2;
n7 <= s9_3 or s9_4;
n8 <= not s11_1;
s9 : cf_fp_mul_c_8_23_9 port map (n4, s9_1, s9_2, s9_3, s9_4, s9_5, s9_6, s9_7, s9_8, s9_9, s9_10, s9_11, s9_12, s9_13, s9_14, s9_15, s9_16, s9_17, s9_18, s9_19, s9_20, s9_21);
s10 : cf_fp_mul_c_8_23_8 port map (s9_5, s9_6, s9_7, s9_8, s9_9, s9_10, s9_11, s9_12, s9_13, s9_14, s9_15, s9_16, s9_17, s9_18, s9_19, s9_20, s10_1, s10_2, s10_3, s10_4, s10_5, s10_6, s10_7, s10_8);
s11 : cf_fp_mul_c_8_23_7 port map (s9_21, n5, n6, n7, s10_1, s10_2, s10_3, s10_4, s10_5, s10_6, s10_7, s10_8, s11_1);
o1 <= n8;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_5 is
port (
i1 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_5;
architecture rtl of cf_fp_mul_c_8_23_5 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(6 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(5 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(4 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
signal n12 : unsigned(0 downto 0);
signal n13 : unsigned(0 downto 0);
signal n14 : unsigned(0 downto 0);
signal s15_1 : unsigned(0 downto 0);
signal s15_2 : unsigned(0 downto 0);
signal s15_3 : unsigned(0 downto 0);
signal s15_4 : unsigned(0 downto 0);
signal s15_5 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_46 is
port (
i1 : in  unsigned(4 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_46;
begin
n1 <= i1(7 downto 7);
n2 <= i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(6 downto 6);
n4 <= n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(5 downto 5);
n6 <= n4(4 downto 4) &
  n4(3 downto 3) &
  n4(2 downto 2) &
  n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n1 or n3;
n8 <= n5 or s15_1;
n9 <= s15_2 or s15_3;
n10 <= s15_4 or s15_5;
n11 <= n7 or n8;
n12 <= n9 or n10;
n13 <= n11 or n12;
n14 <= not n13;
s15 : cf_fp_mul_c_8_23_46 port map (n6, s15_1, s15_2, s15_3, s15_4, s15_5);
o1 <= n14;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_4 is
port (
i1 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_4;
architecture rtl of cf_fp_mul_c_8_23_4 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(6 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(5 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(4 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
signal n12 : unsigned(0 downto 0);
signal n13 : unsigned(0 downto 0);
signal s14_1 : unsigned(0 downto 0);
signal s14_2 : unsigned(0 downto 0);
signal s14_3 : unsigned(0 downto 0);
signal s14_4 : unsigned(0 downto 0);
signal s14_5 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_46 is
port (
i1 : in  unsigned(4 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_46;
begin
n1 <= i1(7 downto 7);
n2 <= i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(6 downto 6);
n4 <= n2(5 downto 5) &
  n2(4 downto 4) &
  n2(3 downto 3) &
  n2(2 downto 2) &
  n2(1 downto 1) &
  n2(0 downto 0);
n5 <= n4(5 downto 5);
n6 <= n4(4 downto 4) &
  n4(3 downto 3) &
  n4(2 downto 2) &
  n4(1 downto 1) &
  n4(0 downto 0);
n7 <= n1 and n3;
n8 <= n5 and s14_1;
n9 <= s14_2 and s14_3;
n10 <= s14_4 and s14_5;
n11 <= n7 and n8;
n12 <= n9 and n10;
n13 <= n11 and n12;
s14 : cf_fp_mul_c_8_23_46 port map (n6, s14_1, s14_2, s14_3, s14_4, s14_5);
o1 <= n13;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_3 is
port (
i1 : in  unsigned(31 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end entity cf_fp_mul_c_8_23_3;
architecture rtl of cf_fp_mul_c_8_23_3 is
signal n1 : unsigned(7 downto 0);
signal n2 : unsigned(22 downto 0);
signal n3 : unsigned(0 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(0 downto 0);
signal n6 : unsigned(0 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
signal n12 : unsigned(0 downto 0);
signal n13 : unsigned(0 downto 0);
signal s14_1 : unsigned(0 downto 0);
signal s15_1 : unsigned(0 downto 0);
signal s16_1 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_6 is
port (
i1 : in  unsigned(22 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_6;
component cf_fp_mul_c_8_23_5 is
port (
i1 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_5;
component cf_fp_mul_c_8_23_4 is
port (
i1 : in  unsigned(7 downto 0);
o1 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_4;
begin
n1 <= i1(30 downto 30) &
  i1(29 downto 29) &
  i1(28 downto 28) &
  i1(27 downto 27) &
  i1(26 downto 26) &
  i1(25 downto 25) &
  i1(24 downto 24) &
  i1(23 downto 23);
n2 <= i1(22 downto 22) &
  i1(21 downto 21) &
  i1(20 downto 20) &
  i1(19 downto 19) &
  i1(18 downto 18) &
  i1(17 downto 17) &
  i1(16 downto 16) &
  i1(15 downto 15) &
  i1(14 downto 14) &
  i1(13 downto 13) &
  i1(12 downto 12) &
  i1(11 downto 11) &
  i1(10 downto 10) &
  i1(9 downto 9) &
  i1(8 downto 8) &
  i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n3 <= n2(22 downto 22);
n4 <= s16_1 and n3;
n5 <= n2(22 downto 22);
n6 <= not n5;
n7 <= s16_1 and n6;
n8 <= not s14_1;
n9 <= n7 and n8;
n10 <= s16_1 and s14_1;
n11 <= s15_1 and s14_1;
n12 <= not s14_1;
n13 <= s15_1 and n12;
s14 : cf_fp_mul_c_8_23_6 port map (n2, s14_1);
s15 : cf_fp_mul_c_8_23_5 port map (n1, s15_1);
s16 : cf_fp_mul_c_8_23_4 port map (n1, s16_1);
o5 <= n13;
o4 <= n11;
o3 <= n10;
o2 <= n9;
o1 <= n4;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_2 is
port (
i1 : in  unsigned(31 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(8 downto 0);
o7 : out unsigned(47 downto 0));
end entity cf_fp_mul_c_8_23_2;
architecture rtl of cf_fp_mul_c_8_23_2 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(7 downto 0);
signal n3 : unsigned(22 downto 0);
signal n4 : unsigned(0 downto 0);
signal n5 : unsigned(7 downto 0);
signal n6 : unsigned(22 downto 0);
signal n7 : unsigned(0 downto 0);
signal n8 : unsigned(0 downto 0);
signal n9 : unsigned(0 downto 0);
signal n10 : unsigned(0 downto 0);
signal n11 : unsigned(0 downto 0);
signal n12 : unsigned(0 downto 0);
signal n13 : unsigned(0 downto 0);
signal n14 : unsigned(0 downto 0);
signal n15 : unsigned(0 downto 0);
signal n16 : unsigned(0 downto 0);
signal n17 : unsigned(8 downto 0);
signal n18 : unsigned(0 downto 0);
signal n19 : unsigned(8 downto 0);
signal n20 : unsigned(8 downto 0);
signal n21 : unsigned(8 downto 0);
signal n22 : unsigned(0 downto 0);
signal n23 : unsigned(23 downto 0);
signal n24 : unsigned(0 downto 0);
signal n25 : unsigned(23 downto 0);
signal n26 : unsigned(47 downto 0);
signal n27 : unsigned(8 downto 0);
signal s28_1 : unsigned(0 downto 0);
signal s28_2 : unsigned(0 downto 0);
signal s28_3 : unsigned(0 downto 0);
signal s28_4 : unsigned(0 downto 0);
signal s28_5 : unsigned(0 downto 0);
signal s29_1 : unsigned(0 downto 0);
signal s29_2 : unsigned(0 downto 0);
signal s29_3 : unsigned(0 downto 0);
signal s29_4 : unsigned(0 downto 0);
signal s29_5 : unsigned(0 downto 0);
component cf_fp_mul_c_8_23_3 is
port (
i1 : in  unsigned(31 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0));
end component cf_fp_mul_c_8_23_3;
begin
n1 <= i1(31 downto 31);
n2 <= i1(30 downto 30) &
  i1(29 downto 29) &
  i1(28 downto 28) &
  i1(27 downto 27) &
  i1(26 downto 26) &
  i1(25 downto 25) &
  i1(24 downto 24) &
  i1(23 downto 23);
n3 <= i1(22 downto 22) &
  i1(21 downto 21) &
  i1(20 downto 20) &
  i1(19 downto 19) &
  i1(18 downto 18) &
  i1(17 downto 17) &
  i1(16 downto 16) &
  i1(15 downto 15) &
  i1(14 downto 14) &
  i1(13 downto 13) &
  i1(12 downto 12) &
  i1(11 downto 11) &
  i1(10 downto 10) &
  i1(9 downto 9) &
  i1(8 downto 8) &
  i1(7 downto 7) &
  i1(6 downto 6) &
  i1(5 downto 5) &
  i1(4 downto 4) &
  i1(3 downto 3) &
  i1(2 downto 2) &
  i1(1 downto 1) &
  i1(0 downto 0);
n4 <= i2(31 downto 31);
n5 <= i2(30 downto 30) &
  i2(29 downto 29) &
  i2(28 downto 28) &
  i2(27 downto 27) &
  i2(26 downto 26) &
  i2(25 downto 25) &
  i2(24 downto 24) &
  i2(23 downto 23);
n6 <= i2(22 downto 22) &
  i2(21 downto 21) &
  i2(20 downto 20) &
  i2(19 downto 19) &
  i2(18 downto 18) &
  i2(17 downto 17) &
  i2(16 downto 16) &
  i2(15 downto 15) &
  i2(14 downto 14) &
  i2(13 downto 13) &
  i2(12 downto 12) &
  i2(11 downto 11) &
  i2(10 downto 10) &
  i2(9 downto 9) &
  i2(8 downto 8) &
  i2(7 downto 7) &
  i2(6 downto 6) &
  i2(5 downto 5) &
  i2(4 downto 4) &
  i2(3 downto 3) &
  i2(2 downto 2) &
  i2(1 downto 1) &
  i2(0 downto 0);
n7 <= s29_2 or s29_1;
n8 <= s28_2 or s28_1;
n9 <= n7 or n8;
n10 <= s29_3 and s28_4;
n11 <= s29_4 and s28_3;
n12 <= n10 or n11;
n13 <= s29_3 or s28_3;
n14 <= s29_4 or s28_4;
n15 <= n1 xor n4;
n16 <= "0";
n17 <= n16 & n2;
n18 <= "0";
n19 <= n18 & n5;
n20 <= n17 + n19;
n21 <= n20 - n27;
n22 <= not s29_5;
n23 <= n22 & n3;
n24 <= not s28_5;
n25 <= n24 & n6;
n26 <= n23 * n25;
n27 <= "001111111";
s28 : cf_fp_mul_c_8_23_3 port map (i2, s28_1, s28_2, s28_3, s28_4, s28_5);
s29 : cf_fp_mul_c_8_23_3 port map (i1, s29_1, s29_2, s29_3, s29_4, s29_5);
o7 <= n26;
o6 <= n21;
o5 <= n15;
o4 <= n14;
o3 <= n13;
o2 <= n12;
o1 <= n9;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23_1 is
port (
i1 : in  unsigned(31 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(31 downto 0));
end entity cf_fp_mul_c_8_23_1;
architecture rtl of cf_fp_mul_c_8_23_1 is
signal n1 : unsigned(0 downto 0);
signal n2 : unsigned(8 downto 0);
signal n3 : unsigned(8 downto 0);
signal n4 : unsigned(8 downto 0);
signal n5 : unsigned(46 downto 0);
signal n6 : unsigned(46 downto 0);
signal n7 : unsigned(46 downto 0);
signal s8_1 : unsigned(8 downto 0);
signal s8_2 : unsigned(45 downto 0);
signal s9_1 : unsigned(8 downto 0);
signal s9_2 : unsigned(23 downto 0);
signal s10_1 : unsigned(31 downto 0);
signal s11_1 : unsigned(0 downto 0);
signal s11_2 : unsigned(0 downto 0);
signal s11_3 : unsigned(0 downto 0);
signal s11_4 : unsigned(0 downto 0);
signal s11_5 : unsigned(0 downto 0);
signal s11_6 : unsigned(8 downto 0);
signal s11_7 : unsigned(47 downto 0);
component cf_fp_mul_c_8_23_44 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(46 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(45 downto 0));
end component cf_fp_mul_c_8_23_44;
component cf_fp_mul_c_8_23_19 is
port (
i1 : in  unsigned(8 downto 0);
i2 : in  unsigned(45 downto 0);
o1 : out unsigned(8 downto 0);
o2 : out unsigned(23 downto 0));
end component cf_fp_mul_c_8_23_19;
component cf_fp_mul_c_8_23_12 is
port (
i1 : in  unsigned(0 downto 0);
i2 : in  unsigned(0 downto 0);
i3 : in  unsigned(0 downto 0);
i4 : in  unsigned(0 downto 0);
i5 : in  unsigned(0 downto 0);
i6 : in  unsigned(8 downto 0);
i7 : in  unsigned(23 downto 0);
o1 : out unsigned(31 downto 0));
end component cf_fp_mul_c_8_23_12;
component cf_fp_mul_c_8_23_2 is
port (
i1 : in  unsigned(31 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(0 downto 0);
o2 : out unsigned(0 downto 0);
o3 : out unsigned(0 downto 0);
o4 : out unsigned(0 downto 0);
o5 : out unsigned(0 downto 0);
o6 : out unsigned(8 downto 0);
o7 : out unsigned(47 downto 0));
end component cf_fp_mul_c_8_23_2;
begin
n1 <= s11_7(47 downto 47);
n2 <= "000000001";
n3 <= s11_6 + n2;
n4 <= n3 when n1 = "1" else s11_6;
n5 <= s11_7(47 downto 47) &
  s11_7(46 downto 46) &
  s11_7(45 downto 45) &
  s11_7(44 downto 44) &
  s11_7(43 downto 43) &
  s11_7(42 downto 42) &
  s11_7(41 downto 41) &
  s11_7(40 downto 40) &
  s11_7(39 downto 39) &
  s11_7(38 downto 38) &
  s11_7(37 downto 37) &
  s11_7(36 downto 36) &
  s11_7(35 downto 35) &
  s11_7(34 downto 34) &
  s11_7(33 downto 33) &
  s11_7(32 downto 32) &
  s11_7(31 downto 31) &
  s11_7(30 downto 30) &
  s11_7(29 downto 29) &
  s11_7(28 downto 28) &
  s11_7(27 downto 27) &
  s11_7(26 downto 26) &
  s11_7(25 downto 25) &
  s11_7(24 downto 24) &
  s11_7(23 downto 23) &
  s11_7(22 downto 22) &
  s11_7(21 downto 21) &
  s11_7(20 downto 20) &
  s11_7(19 downto 19) &
  s11_7(18 downto 18) &
  s11_7(17 downto 17) &
  s11_7(16 downto 16) &
  s11_7(15 downto 15) &
  s11_7(14 downto 14) &
  s11_7(13 downto 13) &
  s11_7(12 downto 12) &
  s11_7(11 downto 11) &
  s11_7(10 downto 10) &
  s11_7(9 downto 9) &
  s11_7(8 downto 8) &
  s11_7(7 downto 7) &
  s11_7(6 downto 6) &
  s11_7(5 downto 5) &
  s11_7(4 downto 4) &
  s11_7(3 downto 3) &
  s11_7(2 downto 2) &
  s11_7(1 downto 1);
n6 <= s11_7(46 downto 46) &
  s11_7(45 downto 45) &
  s11_7(44 downto 44) &
  s11_7(43 downto 43) &
  s11_7(42 downto 42) &
  s11_7(41 downto 41) &
  s11_7(40 downto 40) &
  s11_7(39 downto 39) &
  s11_7(38 downto 38) &
  s11_7(37 downto 37) &
  s11_7(36 downto 36) &
  s11_7(35 downto 35) &
  s11_7(34 downto 34) &
  s11_7(33 downto 33) &
  s11_7(32 downto 32) &
  s11_7(31 downto 31) &
  s11_7(30 downto 30) &
  s11_7(29 downto 29) &
  s11_7(28 downto 28) &
  s11_7(27 downto 27) &
  s11_7(26 downto 26) &
  s11_7(25 downto 25) &
  s11_7(24 downto 24) &
  s11_7(23 downto 23) &
  s11_7(22 downto 22) &
  s11_7(21 downto 21) &
  s11_7(20 downto 20) &
  s11_7(19 downto 19) &
  s11_7(18 downto 18) &
  s11_7(17 downto 17) &
  s11_7(16 downto 16) &
  s11_7(15 downto 15) &
  s11_7(14 downto 14) &
  s11_7(13 downto 13) &
  s11_7(12 downto 12) &
  s11_7(11 downto 11) &
  s11_7(10 downto 10) &
  s11_7(9 downto 9) &
  s11_7(8 downto 8) &
  s11_7(7 downto 7) &
  s11_7(6 downto 6) &
  s11_7(5 downto 5) &
  s11_7(4 downto 4) &
  s11_7(3 downto 3) &
  s11_7(2 downto 2) &
  s11_7(1 downto 1) &
  s11_7(0 downto 0);
n7 <= n5 when n1 = "1" else n6;
s8 : cf_fp_mul_c_8_23_44 port map (n4, n7, s8_1, s8_2);
s9 : cf_fp_mul_c_8_23_19 port map (s8_1, s8_2, s9_1, s9_2);
s10 : cf_fp_mul_c_8_23_12 port map (s11_1, s11_2, s11_3, s11_4, s11_5, s9_1, s9_2, s10_1);
s11 : cf_fp_mul_c_8_23_2 port map (i1, i2, s11_1, s11_2, s11_3, s11_4, s11_5, s11_6, s11_7);
o1 <= s10_1;
end architecture rtl;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity cf_fp_mul_c_8_23 is
port(
signal a_i : in unsigned(31 downto 0);
signal b_i : in unsigned(31 downto 0);
signal x_o : out unsigned(31 downto 0));
end entity cf_fp_mul_c_8_23;
architecture rtl of cf_fp_mul_c_8_23 is
component cf_fp_mul_c_8_23_1 is
port (
i1 : in  unsigned(31 downto 0);
i2 : in  unsigned(31 downto 0);
o1 : out unsigned(31 downto 0));
end component cf_fp_mul_c_8_23_1;
signal n1 : unsigned(31 downto 0);
begin
s1 : cf_fp_mul_c_8_23_1 port map (a_i, b_i, n1);
x_o <= n1;
end architecture rtl;


